// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, request_header::RequestHeader,
    service_types::impls::MessageInfo, service_types::AddNodesItem,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct AddNodesRequest {
    pub request_header: RequestHeader,
    pub nodes_to_add: Option<Vec<AddNodesItem>>,
}

impl MessageInfo for AddNodesRequest {
    fn object_id(&self) -> ObjectId {
        ObjectId::AddNodesRequest_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<AddNodesRequest> for AddNodesRequest {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.request_header.byte_len();
        size += byte_len_array(&self.nodes_to_add);
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.request_header.encode(stream)?;
        size += write_array(stream, &self.nodes_to_add)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let request_header = RequestHeader::decode(stream, decoding_options)?;
        let nodes_to_add: Option<Vec<AddNodesItem>> = read_array(stream, decoding_options)?;
        Ok(AddNodesRequest {
            request_header,
            nodes_to_add,
        })
    }
}
