// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, request_header::RequestHeader,
    service_types::impls::MessageInfo, service_types::AddReferencesItem,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct AddReferencesRequest {
    pub request_header: RequestHeader,
    pub references_to_add: Option<Vec<AddReferencesItem>>,
}

impl MessageInfo for AddReferencesRequest {
    fn object_id(&self) -> ObjectId {
        ObjectId::AddReferencesRequest_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<AddReferencesRequest> for AddReferencesRequest {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.request_header.byte_len();
        size += byte_len_array(&self.references_to_add);
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.request_header.encode(stream)?;
        size += write_array(stream, &self.references_to_add)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let request_header = RequestHeader::decode(stream, decoding_options)?;
        let references_to_add: Option<Vec<AddReferencesItem>> =
            read_array(stream, decoding_options)?;
        Ok(AddReferencesRequest {
            request_header,
            references_to_add,
        })
    }
}
