// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, service_types::impls::MessageInfo,
    service_types::ContentFilterElement,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq, Serialize, Deserialize)]
#[serde(rename_all = "PascalCase")]
pub struct ContentFilter {
    pub elements: Option<Vec<ContentFilterElement>>,
}

impl MessageInfo for ContentFilter {
    fn object_id(&self) -> ObjectId {
        ObjectId::ContentFilter_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<ContentFilter> for ContentFilter {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += byte_len_array(&self.elements);
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += write_array(stream, &self.elements)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let elements: Option<Vec<ContentFilterElement>> = read_array(stream, decoding_options)?;
        Ok(ContentFilter { elements })
    }
}
