// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, date_time::DateTime, encoding::*, node_ids::ObjectId,
    response_header::ResponseHeader, service_types::impls::MessageInfo,
    service_types::ServerOnNetwork,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct FindServersOnNetworkResponse {
    pub response_header: ResponseHeader,
    pub last_counter_reset_time: DateTime,
    pub servers: Option<Vec<ServerOnNetwork>>,
}

impl MessageInfo for FindServersOnNetworkResponse {
    fn object_id(&self) -> ObjectId {
        ObjectId::FindServersOnNetworkResponse_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<FindServersOnNetworkResponse> for FindServersOnNetworkResponse {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.response_header.byte_len();
        size += self.last_counter_reset_time.byte_len();
        size += byte_len_array(&self.servers);
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.response_header.encode(stream)?;
        size += self.last_counter_reset_time.encode(stream)?;
        size += write_array(stream, &self.servers)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let response_header = ResponseHeader::decode(stream, decoding_options)?;
        let last_counter_reset_time = DateTime::decode(stream, decoding_options)?;
        let servers: Option<Vec<ServerOnNetwork>> = read_array(stream, decoding_options)?;
        Ok(FindServersOnNetworkResponse {
            response_header,
            last_counter_reset_time,
            servers,
        })
    }
}
