// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, service_types::impls::MessageInfo,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct RationalNumber {
    pub numerator: i32,
    pub denominator: u32,
}

impl MessageInfo for RationalNumber {
    fn object_id(&self) -> ObjectId {
        ObjectId::RationalNumber_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<RationalNumber> for RationalNumber {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.numerator.byte_len();
        size += self.denominator.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.numerator.encode(stream)?;
        size += self.denominator.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let numerator = i32::decode(stream, decoding_options)?;
        let denominator = u32::decode(stream, decoding_options)?;
        Ok(RationalNumber {
            numerator,
            denominator,
        })
    }
}
