// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{basic_types::*, date_time::DateTime, encoding::*};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct ReadAtTimeDetails {
    pub req_times: Option<Vec<DateTime>>,
    pub use_simple_bounds: bool,
}

impl BinaryEncoder<ReadAtTimeDetails> for ReadAtTimeDetails {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += byte_len_array(&self.req_times);
        size += self.use_simple_bounds.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += write_array(stream, &self.req_times)?;
        size += self.use_simple_bounds.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let req_times: Option<Vec<DateTime>> = read_array(stream, decoding_options)?;
        let use_simple_bounds = bool::decode(stream, decoding_options)?;
        Ok(ReadAtTimeDetails {
            req_times,
            use_simple_bounds,
        })
    }
}
