// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, date_time::DateTime, encoding::*, node_id::NodeId,
    service_types::AggregateConfiguration,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct ReadProcessedDetails {
    pub start_time: DateTime,
    pub end_time: DateTime,
    pub processing_interval: f64,
    pub aggregate_type: Option<Vec<NodeId>>,
    pub aggregate_configuration: AggregateConfiguration,
}

impl BinaryEncoder<ReadProcessedDetails> for ReadProcessedDetails {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.start_time.byte_len();
        size += self.end_time.byte_len();
        size += self.processing_interval.byte_len();
        size += byte_len_array(&self.aggregate_type);
        size += self.aggregate_configuration.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.start_time.encode(stream)?;
        size += self.end_time.encode(stream)?;
        size += self.processing_interval.encode(stream)?;
        size += write_array(stream, &self.aggregate_type)?;
        size += self.aggregate_configuration.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let start_time = DateTime::decode(stream, decoding_options)?;
        let end_time = DateTime::decode(stream, decoding_options)?;
        let processing_interval = f64::decode(stream, decoding_options)?;
        let aggregate_type: Option<Vec<NodeId>> = read_array(stream, decoding_options)?;
        let aggregate_configuration = AggregateConfiguration::decode(stream, decoding_options)?;
        Ok(ReadProcessedDetails {
            start_time,
            end_time,
            processing_interval,
            aggregate_type,
            aggregate_configuration,
        })
    }
}
