// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, response_header::ResponseHeader,
    service_types::impls::MessageInfo, service_types::NotificationMessage,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct RepublishResponse {
    pub response_header: ResponseHeader,
    pub notification_message: NotificationMessage,
}

impl MessageInfo for RepublishResponse {
    fn object_id(&self) -> ObjectId {
        ObjectId::RepublishResponse_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<RepublishResponse> for RepublishResponse {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.response_header.byte_len();
        size += self.notification_message.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.response_header.encode(stream)?;
        size += self.notification_message.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let response_header = ResponseHeader::decode(stream, decoding_options)?;
        let notification_message = NotificationMessage::decode(stream, decoding_options)?;
        Ok(RepublishResponse {
            response_header,
            notification_message,
        })
    }
}
