// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, service_types::impls::MessageInfo,
    string::UAString,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct SessionlessInvokeRequestType {
    pub uris_version: u32,
    pub namespace_uris: Option<Vec<UAString>>,
    pub server_uris: Option<Vec<UAString>>,
    pub locale_ids: Option<Vec<UAString>>,
    pub service_id: u32,
}

impl MessageInfo for SessionlessInvokeRequestType {
    fn object_id(&self) -> ObjectId {
        ObjectId::SessionlessInvokeRequestType_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<SessionlessInvokeRequestType> for SessionlessInvokeRequestType {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.uris_version.byte_len();
        size += byte_len_array(&self.namespace_uris);
        size += byte_len_array(&self.server_uris);
        size += byte_len_array(&self.locale_ids);
        size += self.service_id.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.uris_version.encode(stream)?;
        size += write_array(stream, &self.namespace_uris)?;
        size += write_array(stream, &self.server_uris)?;
        size += write_array(stream, &self.locale_ids)?;
        size += self.service_id.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let uris_version = u32::decode(stream, decoding_options)?;
        let namespace_uris: Option<Vec<UAString>> = read_array(stream, decoding_options)?;
        let server_uris: Option<Vec<UAString>> = read_array(stream, decoding_options)?;
        let locale_ids: Option<Vec<UAString>> = read_array(stream, decoding_options)?;
        let service_id = u32::decode(stream, decoding_options)?;
        Ok(SessionlessInvokeRequestType {
            uris_version,
            namespace_uris,
            server_uris,
            locale_ids,
            service_id,
        })
    }
}
