// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, byte_string::ByteString, encoding::*, node_ids::ObjectId,
    service_types::impls::MessageInfo,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct SignedSoftwareCertificate {
    pub certificate_data: ByteString,
    pub signature: ByteString,
}

impl MessageInfo for SignedSoftwareCertificate {
    fn object_id(&self) -> ObjectId {
        ObjectId::SignedSoftwareCertificate_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<SignedSoftwareCertificate> for SignedSoftwareCertificate {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.certificate_data.byte_len();
        size += self.signature.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.certificate_data.encode(stream)?;
        size += self.signature.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let certificate_data = ByteString::decode(stream, decoding_options)?;
        let signature = ByteString::decode(stream, decoding_options)?;
        Ok(SignedSoftwareCertificate {
            certificate_data,
            signature,
        })
    }
}
