// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, node_ids::ObjectId, service_types::impls::MessageInfo,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct TimeZoneDataType {
    pub offset: i16,
    pub daylight_saving_in_offset: bool,
}

impl MessageInfo for TimeZoneDataType {
    fn object_id(&self) -> ObjectId {
        ObjectId::TimeZoneDataType_Encoding_DefaultBinary
    }
}

impl BinaryEncoder<TimeZoneDataType> for TimeZoneDataType {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.offset.byte_len();
        size += self.daylight_saving_in_offset.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.offset.encode(stream)?;
        size += self.daylight_saving_in_offset.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let offset = i16::decode(stream, decoding_options)?;
        let daylight_saving_in_offset = bool::decode(stream, decoding_options)?;
        Ok(TimeZoneDataType {
            offset,
            daylight_saving_in_offset,
        })
    }
}
