// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock
//
// This file was autogenerated from Opc.Ua.Types.bsd by tools/schema/gen_types.js
//
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]
#[allow(unused_imports)]
use crate::types::{
    basic_types::*, encoding::*, service_types::enums::UadpDataSetMessageContentMask,
};
use std::io::{Read, Write};

#[derive(Debug, Clone, PartialEq)]
pub struct UadpDataSetWriterMessageDataType {
    pub data_set_message_content_mask: UadpDataSetMessageContentMask,
    pub configured_size: u16,
    pub network_message_number: u16,
    pub data_set_offset: u16,
}

impl BinaryEncoder<UadpDataSetWriterMessageDataType> for UadpDataSetWriterMessageDataType {
    fn byte_len(&self) -> usize {
        let mut size = 0;
        size += self.data_set_message_content_mask.byte_len();
        size += self.configured_size.byte_len();
        size += self.network_message_number.byte_len();
        size += self.data_set_offset.byte_len();
        size
    }

    #[allow(unused_variables)]
    fn encode<S: Write>(&self, stream: &mut S) -> EncodingResult<usize> {
        let mut size = 0;
        size += self.data_set_message_content_mask.encode(stream)?;
        size += self.configured_size.encode(stream)?;
        size += self.network_message_number.encode(stream)?;
        size += self.data_set_offset.encode(stream)?;
        Ok(size)
    }

    #[allow(unused_variables)]
    fn decode<S: Read>(stream: &mut S, decoding_options: &DecodingOptions) -> EncodingResult<Self> {
        let data_set_message_content_mask =
            UadpDataSetMessageContentMask::decode(stream, decoding_options)?;
        let configured_size = u16::decode(stream, decoding_options)?;
        let network_message_number = u16::decode(stream, decoding_options)?;
        let data_set_offset = u16::decode(stream, decoding_options)?;
        Ok(UadpDataSetWriterMessageDataType {
            data_set_message_content_mask,
            configured_size,
            network_message_number,
            data_set_offset,
        })
    }
}
