// OPCUA for Rust
// SPDX-License-Identifier: MPL-2.0
// Copyright (C) 2017-2024 Adam Lock

// This file was autogenerated from NodeIds.csv by tools/schema/gen_node_ids.js
// DO NOT EDIT THIS FILE
#![allow(unused_attributes)]

use std::convert::TryFrom;

use crate::types::{expanded_node_id::ExpandedNodeId, node_id::NodeId, string::UAString};

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum DataTypeId {
    Boolean = 1,
    SByte = 2,
    Byte = 3,
    Int16 = 4,
    UInt16 = 5,
    Int32 = 6,
    UInt32 = 7,
    Int64 = 8,
    UInt64 = 9,
    Float = 10,
    Double = 11,
    String = 12,
    DateTime = 13,
    Guid = 14,
    ByteString = 15,
    XmlElement = 16,
    NodeId = 17,
    ExpandedNodeId = 18,
    StatusCode = 19,
    QualifiedName = 20,
    LocalizedText = 21,
    Structure = 22,
    DataValue = 23,
    BaseDataType = 24,
    DiagnosticInfo = 25,
    Number = 26,
    Integer = 27,
    UInteger = 28,
    Enumeration = 29,
    Image = 30,
    Decimal = 50,
    PermissionType = 94,
    AccessRestrictionType = 95,
    RolePermissionType = 96,
    DataTypeDefinition = 97,
    StructureType = 98,
    StructureDefinition = 99,
    EnumDefinition = 100,
    StructureField = 101,
    EnumField = 102,
    NamingRuleType = 120,
    IdType = 256,
    NodeClass = 257,
    Node = 258,
    ObjectNode = 261,
    ObjectTypeNode = 264,
    VariableNode = 267,
    VariableTypeNode = 270,
    ReferenceTypeNode = 273,
    MethodNode = 276,
    ViewNode = 279,
    DataTypeNode = 282,
    ReferenceNode = 285,
    IntegerId = 288,
    Counter = 289,
    Duration = 290,
    NumericRange = 291,
    UtcTime = 294,
    LocaleId = 295,
    Argument = 296,
    StatusResult = 299,
    MessageSecurityMode = 302,
    UserTokenType = 303,
    UserTokenPolicy = 304,
    ApplicationType = 307,
    ApplicationDescription = 308,
    ApplicationInstanceCertificate = 311,
    EndpointDescription = 312,
    SecurityTokenRequestType = 315,
    UserIdentityToken = 316,
    AnonymousIdentityToken = 319,
    UserNameIdentityToken = 322,
    X509IdentityToken = 325,
    EndpointConfiguration = 331,
    BuildInfo = 338,
    SignedSoftwareCertificate = 344,
    AttributeWriteMask = 347,
    NodeAttributesMask = 348,
    NodeAttributes = 349,
    ObjectAttributes = 352,
    VariableAttributes = 355,
    MethodAttributes = 358,
    ObjectTypeAttributes = 361,
    VariableTypeAttributes = 364,
    ReferenceTypeAttributes = 367,
    DataTypeAttributes = 370,
    ViewAttributes = 373,
    AddNodesItem = 376,
    AddReferencesItem = 379,
    DeleteNodesItem = 382,
    DeleteReferencesItem = 385,
    SessionAuthenticationToken = 388,
    RequestHeader = 389,
    ResponseHeader = 392,
    ServiceFault = 395,
    FindServersRequest = 420,
    FindServersResponse = 423,
    GetEndpointsRequest = 426,
    GetEndpointsResponse = 429,
    RegisteredServer = 432,
    RegisterServerRequest = 435,
    RegisterServerResponse = 438,
    ChannelSecurityToken = 441,
    OpenSecureChannelRequest = 444,
    OpenSecureChannelResponse = 447,
    CloseSecureChannelRequest = 450,
    CloseSecureChannelResponse = 453,
    SignatureData = 456,
    CreateSessionRequest = 459,
    CreateSessionResponse = 462,
    ActivateSessionRequest = 465,
    ActivateSessionResponse = 468,
    CloseSessionRequest = 471,
    CloseSessionResponse = 474,
    CancelRequest = 477,
    CancelResponse = 480,
    AddNodesResult = 483,
    AddNodesRequest = 486,
    AddNodesResponse = 489,
    AddReferencesRequest = 492,
    AddReferencesResponse = 495,
    DeleteNodesRequest = 498,
    DeleteNodesResponse = 501,
    DeleteReferencesRequest = 504,
    DeleteReferencesResponse = 507,
    BrowseDirection = 510,
    ViewDescription = 511,
    BrowseDescription = 514,
    BrowseResultMask = 517,
    ReferenceDescription = 518,
    ContinuationPoint = 521,
    BrowseResult = 522,
    BrowseRequest = 525,
    BrowseResponse = 528,
    BrowseNextRequest = 531,
    BrowseNextResponse = 534,
    RelativePathElement = 537,
    RelativePath = 540,
    BrowsePath = 543,
    BrowsePathTarget = 546,
    BrowsePathResult = 549,
    TranslateBrowsePathsToNodeIdsRequest = 552,
    TranslateBrowsePathsToNodeIdsResponse = 555,
    RegisterNodesRequest = 558,
    RegisterNodesResponse = 561,
    UnregisterNodesRequest = 564,
    UnregisterNodesResponse = 567,
    QueryDataDescription = 570,
    NodeTypeDescription = 573,
    FilterOperator = 576,
    QueryDataSet = 577,
    NodeReference = 580,
    ContentFilterElement = 583,
    ContentFilter = 586,
    FilterOperand = 589,
    ElementOperand = 592,
    LiteralOperand = 595,
    AttributeOperand = 598,
    SimpleAttributeOperand = 601,
    ContentFilterElementResult = 604,
    ContentFilterResult = 607,
    ParsingResult = 610,
    QueryFirstRequest = 613,
    QueryFirstResponse = 616,
    QueryNextRequest = 619,
    QueryNextResponse = 622,
    TimestampsToReturn = 625,
    ReadValueId = 626,
    ReadRequest = 629,
    ReadResponse = 632,
    HistoryReadValueId = 635,
    HistoryReadResult = 638,
    HistoryReadDetails = 641,
    ReadEventDetails = 644,
    ReadRawModifiedDetails = 647,
    ReadProcessedDetails = 650,
    ReadAtTimeDetails = 653,
    HistoryData = 656,
    HistoryEvent = 659,
    HistoryReadRequest = 662,
    HistoryReadResponse = 665,
    WriteValue = 668,
    WriteRequest = 671,
    WriteResponse = 674,
    HistoryUpdateDetails = 677,
    UpdateDataDetails = 680,
    UpdateEventDetails = 683,
    DeleteRawModifiedDetails = 686,
    DeleteAtTimeDetails = 689,
    DeleteEventDetails = 692,
    HistoryUpdateResult = 695,
    HistoryUpdateRequest = 698,
    HistoryUpdateResponse = 701,
    CallMethodRequest = 704,
    CallMethodResult = 707,
    CallRequest = 710,
    CallResponse = 713,
    MonitoringMode = 716,
    DataChangeTrigger = 717,
    DeadbandType = 718,
    MonitoringFilter = 719,
    DataChangeFilter = 722,
    EventFilter = 725,
    AggregateFilter = 728,
    MonitoringFilterResult = 731,
    EventFilterResult = 734,
    AggregateFilterResult = 737,
    MonitoringParameters = 740,
    MonitoredItemCreateRequest = 743,
    MonitoredItemCreateResult = 746,
    CreateMonitoredItemsRequest = 749,
    CreateMonitoredItemsResponse = 752,
    MonitoredItemModifyRequest = 755,
    MonitoredItemModifyResult = 758,
    ModifyMonitoredItemsRequest = 761,
    ModifyMonitoredItemsResponse = 764,
    SetMonitoringModeRequest = 767,
    SetMonitoringModeResponse = 770,
    SetTriggeringRequest = 773,
    SetTriggeringResponse = 776,
    DeleteMonitoredItemsRequest = 779,
    DeleteMonitoredItemsResponse = 782,
    CreateSubscriptionRequest = 785,
    CreateSubscriptionResponse = 788,
    ModifySubscriptionRequest = 791,
    ModifySubscriptionResponse = 794,
    SetPublishingModeRequest = 797,
    SetPublishingModeResponse = 800,
    NotificationMessage = 803,
    MonitoredItemNotification = 806,
    DataChangeNotification = 809,
    StatusChangeNotification = 818,
    SubscriptionAcknowledgement = 821,
    PublishRequest = 824,
    PublishResponse = 827,
    RepublishRequest = 830,
    RepublishResponse = 833,
    TransferResult = 836,
    TransferSubscriptionsRequest = 839,
    TransferSubscriptionsResponse = 842,
    DeleteSubscriptionsRequest = 845,
    DeleteSubscriptionsResponse = 848,
    RedundancySupport = 851,
    ServerState = 852,
    RedundantServerDataType = 853,
    SamplingIntervalDiagnosticsDataType = 856,
    ServerDiagnosticsSummaryDataType = 859,
    ServerStatusDataType = 862,
    SessionDiagnosticsDataType = 865,
    SessionSecurityDiagnosticsDataType = 868,
    ServiceCounterDataType = 871,
    SubscriptionDiagnosticsDataType = 874,
    ModelChangeStructureDataType = 877,
    Range = 884,
    EUInformation = 887,
    ExceptionDeviationFormat = 890,
    Annotation = 891,
    ProgramDiagnosticDataType = 894,
    SemanticChangeStructureDataType = 897,
    EventNotificationList = 914,
    EventFieldList = 917,
    HistoryEventFieldList = 920,
    IssuedIdentityToken = 938,
    NotificationData = 945,
    AggregateConfiguration = 948,
    ImageBMP = 2000,
    ImageGIF = 2001,
    ImageJPG = 2002,
    ImagePNG = 2003,
    EnumValueType = 7594,
    TimeZoneDataType = 8912,
    ModificationInfo = 11216,
    HistoryModifiedData = 11217,
    HistoryUpdateType = 11234,
    PerformUpdateType = 11293,
    UpdateStructureDataDetails = 11295,
    BitFieldMaskDataType = 11737,
    InstanceNode = 11879,
    TypeNode = 11880,
    OpenFileMode = 11939,
    ModelChangeStructureVerbMask = 11941,
    EndpointUrlListDataType = 11943,
    NetworkGroupDataType = 11944,
    AxisScaleEnumeration = 12077,
    AxisInformation = 12079,
    XVType = 12080,
    ComplexNumberType = 12171,
    DoubleComplexNumberType = 12172,
    ServerOnNetwork = 12189,
    FindServersOnNetworkRequest = 12190,
    FindServersOnNetworkResponse = 12191,
    RegisterServer2Request = 12193,
    RegisterServer2Response = 12194,
    TrustListMasks = 12552,
    TrustListDataType = 12554,
    OptionSet = 12755,
    Union = 12756,
    NormalizedString = 12877,
    DecimalString = 12878,
    DurationString = 12879,
    TimeString = 12880,
    DateString = 12881,
    DiscoveryConfiguration = 12890,
    MdnsDiscoveryConfiguration = 12891,
    PublishedVariableDataType = 14273,
    DataSetMetaDataType = 14523,
    FieldMetaData = 14524,
    DataTypeDescription = 14525,
    KeyValuePair = 14533,
    ConfigurationVersionDataType = 14593,
    PubSubState = 14647,
    FieldTargetDataType = 14744,
    SimpleTypeDescription = 15005,
    UABinaryFileDataType = 15006,
    BrokerConnectionTransportDataType = 15007,
    BrokerTransportQualityOfService = 15008,
    AccessLevelType = 15031,
    EventNotifierType = 15033,
    ProgramDiagnostic2DataType = 15396,
    AccessLevelExType = 15406,
    WriterGroupDataType = 15480,
    StructureDescription = 15487,
    EnumDescription = 15488,
    NetworkAddressDataType = 15502,
    NetworkAddressUrlDataType = 15510,
    ReaderGroupDataType = 15520,
    EndpointType = 15528,
    PubSubConfigurationDataType = 15530,
    DatagramWriterGroupTransportDataType = 15532,
    DataTypeSchemaHeader = 15534,
    PublishedDataSetDataType = 15578,
    PublishedDataSetSourceDataType = 15580,
    PublishedDataItemsDataType = 15581,
    PublishedEventsDataType = 15582,
    DataSetFieldContentMask = 15583,
    DataSetWriterDataType = 15597,
    DataSetWriterTransportDataType = 15598,
    DataSetWriterMessageDataType = 15605,
    PubSubGroupDataType = 15609,
    WriterGroupTransportDataType = 15611,
    WriterGroupMessageDataType = 15616,
    PubSubConnectionDataType = 15617,
    ConnectionTransportDataType = 15618,
    ReaderGroupTransportDataType = 15621,
    ReaderGroupMessageDataType = 15622,
    DataSetReaderDataType = 15623,
    DataSetReaderTransportDataType = 15628,
    DataSetReaderMessageDataType = 15629,
    SubscribedDataSetDataType = 15630,
    TargetVariablesDataType = 15631,
    IdentityCriteriaType = 15632,
    IdentityMappingRuleType = 15634,
    SubscribedDataSetMirrorDataType = 15635,
    UadpNetworkMessageContentMask = 15642,
    UadpWriterGroupMessageDataType = 15645,
    UadpDataSetMessageContentMask = 15646,
    UadpDataSetWriterMessageDataType = 15652,
    UadpDataSetReaderMessageDataType = 15653,
    JsonNetworkMessageContentMask = 15654,
    JsonWriterGroupMessageDataType = 15657,
    JsonDataSetMessageContentMask = 15658,
    JsonDataSetWriterMessageDataType = 15664,
    JsonDataSetReaderMessageDataType = 15665,
    BrokerWriterGroupTransportDataType = 15667,
    BrokerDataSetWriterTransportDataType = 15669,
    BrokerDataSetReaderTransportDataType = 15670,
    OverrideValueHandling = 15874,
    SessionlessInvokeRequestType = 15901,
    DataSetFieldFlags = 15904,
    AudioDataType = 16307,
    AdditionalParametersType = 16313,
    DatagramConnectionTransportDataType = 17467,
    RsaEncryptedSecret = 17545,
    EccEncryptedSecret = 17546,
    EphemeralKeyType = 17548,
    Index = 17588,
    GenericAttributeValue = 17606,
    GenericAttributes = 17607,
    DecimalDataType = 17861,
    RationalNumber = 18806,
    Vector = 18807,
    ThreeDVector = 18808,
    CartesianCoordinates = 18809,
    ThreeDCartesianCoordinates = 18810,
    Orientation = 18811,
    ThreeDOrientation = 18812,
    Frame = 18813,
    ThreeDFrame = 18814,
    DiagnosticsLevel = 19723,
    PubSubDiagnosticsCounterClassification = 19730,
    DataSetOrderingType = 20408,
    VersionTime = 20998,
    SessionlessInvokeResponseType = 20999,
    AliasNameDataType = 23468,
    ReadAnnotationDataDetails = 23497,
    CurrencyUnitType = 23498,
}

impl<'a> From<&'a DataTypeId> for NodeId {
    fn from(r: &'a DataTypeId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for DataTypeId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for DataTypeId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for DataTypeId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            1 => Ok(DataTypeId::Boolean),
            2 => Ok(DataTypeId::SByte),
            3 => Ok(DataTypeId::Byte),
            4 => Ok(DataTypeId::Int16),
            5 => Ok(DataTypeId::UInt16),
            6 => Ok(DataTypeId::Int32),
            7 => Ok(DataTypeId::UInt32),
            8 => Ok(DataTypeId::Int64),
            9 => Ok(DataTypeId::UInt64),
            10 => Ok(DataTypeId::Float),
            11 => Ok(DataTypeId::Double),
            12 => Ok(DataTypeId::String),
            13 => Ok(DataTypeId::DateTime),
            14 => Ok(DataTypeId::Guid),
            15 => Ok(DataTypeId::ByteString),
            16 => Ok(DataTypeId::XmlElement),
            17 => Ok(DataTypeId::NodeId),
            18 => Ok(DataTypeId::ExpandedNodeId),
            19 => Ok(DataTypeId::StatusCode),
            20 => Ok(DataTypeId::QualifiedName),
            21 => Ok(DataTypeId::LocalizedText),
            22 => Ok(DataTypeId::Structure),
            23 => Ok(DataTypeId::DataValue),
            24 => Ok(DataTypeId::BaseDataType),
            25 => Ok(DataTypeId::DiagnosticInfo),
            26 => Ok(DataTypeId::Number),
            27 => Ok(DataTypeId::Integer),
            28 => Ok(DataTypeId::UInteger),
            29 => Ok(DataTypeId::Enumeration),
            30 => Ok(DataTypeId::Image),
            50 => Ok(DataTypeId::Decimal),
            94 => Ok(DataTypeId::PermissionType),
            95 => Ok(DataTypeId::AccessRestrictionType),
            96 => Ok(DataTypeId::RolePermissionType),
            97 => Ok(DataTypeId::DataTypeDefinition),
            98 => Ok(DataTypeId::StructureType),
            99 => Ok(DataTypeId::StructureDefinition),
            100 => Ok(DataTypeId::EnumDefinition),
            101 => Ok(DataTypeId::StructureField),
            102 => Ok(DataTypeId::EnumField),
            120 => Ok(DataTypeId::NamingRuleType),
            256 => Ok(DataTypeId::IdType),
            257 => Ok(DataTypeId::NodeClass),
            258 => Ok(DataTypeId::Node),
            261 => Ok(DataTypeId::ObjectNode),
            264 => Ok(DataTypeId::ObjectTypeNode),
            267 => Ok(DataTypeId::VariableNode),
            270 => Ok(DataTypeId::VariableTypeNode),
            273 => Ok(DataTypeId::ReferenceTypeNode),
            276 => Ok(DataTypeId::MethodNode),
            279 => Ok(DataTypeId::ViewNode),
            282 => Ok(DataTypeId::DataTypeNode),
            285 => Ok(DataTypeId::ReferenceNode),
            288 => Ok(DataTypeId::IntegerId),
            289 => Ok(DataTypeId::Counter),
            290 => Ok(DataTypeId::Duration),
            291 => Ok(DataTypeId::NumericRange),
            294 => Ok(DataTypeId::UtcTime),
            295 => Ok(DataTypeId::LocaleId),
            296 => Ok(DataTypeId::Argument),
            299 => Ok(DataTypeId::StatusResult),
            302 => Ok(DataTypeId::MessageSecurityMode),
            303 => Ok(DataTypeId::UserTokenType),
            304 => Ok(DataTypeId::UserTokenPolicy),
            307 => Ok(DataTypeId::ApplicationType),
            308 => Ok(DataTypeId::ApplicationDescription),
            311 => Ok(DataTypeId::ApplicationInstanceCertificate),
            312 => Ok(DataTypeId::EndpointDescription),
            315 => Ok(DataTypeId::SecurityTokenRequestType),
            316 => Ok(DataTypeId::UserIdentityToken),
            319 => Ok(DataTypeId::AnonymousIdentityToken),
            322 => Ok(DataTypeId::UserNameIdentityToken),
            325 => Ok(DataTypeId::X509IdentityToken),
            331 => Ok(DataTypeId::EndpointConfiguration),
            338 => Ok(DataTypeId::BuildInfo),
            344 => Ok(DataTypeId::SignedSoftwareCertificate),
            347 => Ok(DataTypeId::AttributeWriteMask),
            348 => Ok(DataTypeId::NodeAttributesMask),
            349 => Ok(DataTypeId::NodeAttributes),
            352 => Ok(DataTypeId::ObjectAttributes),
            355 => Ok(DataTypeId::VariableAttributes),
            358 => Ok(DataTypeId::MethodAttributes),
            361 => Ok(DataTypeId::ObjectTypeAttributes),
            364 => Ok(DataTypeId::VariableTypeAttributes),
            367 => Ok(DataTypeId::ReferenceTypeAttributes),
            370 => Ok(DataTypeId::DataTypeAttributes),
            373 => Ok(DataTypeId::ViewAttributes),
            376 => Ok(DataTypeId::AddNodesItem),
            379 => Ok(DataTypeId::AddReferencesItem),
            382 => Ok(DataTypeId::DeleteNodesItem),
            385 => Ok(DataTypeId::DeleteReferencesItem),
            388 => Ok(DataTypeId::SessionAuthenticationToken),
            389 => Ok(DataTypeId::RequestHeader),
            392 => Ok(DataTypeId::ResponseHeader),
            395 => Ok(DataTypeId::ServiceFault),
            420 => Ok(DataTypeId::FindServersRequest),
            423 => Ok(DataTypeId::FindServersResponse),
            426 => Ok(DataTypeId::GetEndpointsRequest),
            429 => Ok(DataTypeId::GetEndpointsResponse),
            432 => Ok(DataTypeId::RegisteredServer),
            435 => Ok(DataTypeId::RegisterServerRequest),
            438 => Ok(DataTypeId::RegisterServerResponse),
            441 => Ok(DataTypeId::ChannelSecurityToken),
            444 => Ok(DataTypeId::OpenSecureChannelRequest),
            447 => Ok(DataTypeId::OpenSecureChannelResponse),
            450 => Ok(DataTypeId::CloseSecureChannelRequest),
            453 => Ok(DataTypeId::CloseSecureChannelResponse),
            456 => Ok(DataTypeId::SignatureData),
            459 => Ok(DataTypeId::CreateSessionRequest),
            462 => Ok(DataTypeId::CreateSessionResponse),
            465 => Ok(DataTypeId::ActivateSessionRequest),
            468 => Ok(DataTypeId::ActivateSessionResponse),
            471 => Ok(DataTypeId::CloseSessionRequest),
            474 => Ok(DataTypeId::CloseSessionResponse),
            477 => Ok(DataTypeId::CancelRequest),
            480 => Ok(DataTypeId::CancelResponse),
            483 => Ok(DataTypeId::AddNodesResult),
            486 => Ok(DataTypeId::AddNodesRequest),
            489 => Ok(DataTypeId::AddNodesResponse),
            492 => Ok(DataTypeId::AddReferencesRequest),
            495 => Ok(DataTypeId::AddReferencesResponse),
            498 => Ok(DataTypeId::DeleteNodesRequest),
            501 => Ok(DataTypeId::DeleteNodesResponse),
            504 => Ok(DataTypeId::DeleteReferencesRequest),
            507 => Ok(DataTypeId::DeleteReferencesResponse),
            510 => Ok(DataTypeId::BrowseDirection),
            511 => Ok(DataTypeId::ViewDescription),
            514 => Ok(DataTypeId::BrowseDescription),
            517 => Ok(DataTypeId::BrowseResultMask),
            518 => Ok(DataTypeId::ReferenceDescription),
            521 => Ok(DataTypeId::ContinuationPoint),
            522 => Ok(DataTypeId::BrowseResult),
            525 => Ok(DataTypeId::BrowseRequest),
            528 => Ok(DataTypeId::BrowseResponse),
            531 => Ok(DataTypeId::BrowseNextRequest),
            534 => Ok(DataTypeId::BrowseNextResponse),
            537 => Ok(DataTypeId::RelativePathElement),
            540 => Ok(DataTypeId::RelativePath),
            543 => Ok(DataTypeId::BrowsePath),
            546 => Ok(DataTypeId::BrowsePathTarget),
            549 => Ok(DataTypeId::BrowsePathResult),
            552 => Ok(DataTypeId::TranslateBrowsePathsToNodeIdsRequest),
            555 => Ok(DataTypeId::TranslateBrowsePathsToNodeIdsResponse),
            558 => Ok(DataTypeId::RegisterNodesRequest),
            561 => Ok(DataTypeId::RegisterNodesResponse),
            564 => Ok(DataTypeId::UnregisterNodesRequest),
            567 => Ok(DataTypeId::UnregisterNodesResponse),
            570 => Ok(DataTypeId::QueryDataDescription),
            573 => Ok(DataTypeId::NodeTypeDescription),
            576 => Ok(DataTypeId::FilterOperator),
            577 => Ok(DataTypeId::QueryDataSet),
            580 => Ok(DataTypeId::NodeReference),
            583 => Ok(DataTypeId::ContentFilterElement),
            586 => Ok(DataTypeId::ContentFilter),
            589 => Ok(DataTypeId::FilterOperand),
            592 => Ok(DataTypeId::ElementOperand),
            595 => Ok(DataTypeId::LiteralOperand),
            598 => Ok(DataTypeId::AttributeOperand),
            601 => Ok(DataTypeId::SimpleAttributeOperand),
            604 => Ok(DataTypeId::ContentFilterElementResult),
            607 => Ok(DataTypeId::ContentFilterResult),
            610 => Ok(DataTypeId::ParsingResult),
            613 => Ok(DataTypeId::QueryFirstRequest),
            616 => Ok(DataTypeId::QueryFirstResponse),
            619 => Ok(DataTypeId::QueryNextRequest),
            622 => Ok(DataTypeId::QueryNextResponse),
            625 => Ok(DataTypeId::TimestampsToReturn),
            626 => Ok(DataTypeId::ReadValueId),
            629 => Ok(DataTypeId::ReadRequest),
            632 => Ok(DataTypeId::ReadResponse),
            635 => Ok(DataTypeId::HistoryReadValueId),
            638 => Ok(DataTypeId::HistoryReadResult),
            641 => Ok(DataTypeId::HistoryReadDetails),
            644 => Ok(DataTypeId::ReadEventDetails),
            647 => Ok(DataTypeId::ReadRawModifiedDetails),
            650 => Ok(DataTypeId::ReadProcessedDetails),
            653 => Ok(DataTypeId::ReadAtTimeDetails),
            656 => Ok(DataTypeId::HistoryData),
            659 => Ok(DataTypeId::HistoryEvent),
            662 => Ok(DataTypeId::HistoryReadRequest),
            665 => Ok(DataTypeId::HistoryReadResponse),
            668 => Ok(DataTypeId::WriteValue),
            671 => Ok(DataTypeId::WriteRequest),
            674 => Ok(DataTypeId::WriteResponse),
            677 => Ok(DataTypeId::HistoryUpdateDetails),
            680 => Ok(DataTypeId::UpdateDataDetails),
            683 => Ok(DataTypeId::UpdateEventDetails),
            686 => Ok(DataTypeId::DeleteRawModifiedDetails),
            689 => Ok(DataTypeId::DeleteAtTimeDetails),
            692 => Ok(DataTypeId::DeleteEventDetails),
            695 => Ok(DataTypeId::HistoryUpdateResult),
            698 => Ok(DataTypeId::HistoryUpdateRequest),
            701 => Ok(DataTypeId::HistoryUpdateResponse),
            704 => Ok(DataTypeId::CallMethodRequest),
            707 => Ok(DataTypeId::CallMethodResult),
            710 => Ok(DataTypeId::CallRequest),
            713 => Ok(DataTypeId::CallResponse),
            716 => Ok(DataTypeId::MonitoringMode),
            717 => Ok(DataTypeId::DataChangeTrigger),
            718 => Ok(DataTypeId::DeadbandType),
            719 => Ok(DataTypeId::MonitoringFilter),
            722 => Ok(DataTypeId::DataChangeFilter),
            725 => Ok(DataTypeId::EventFilter),
            728 => Ok(DataTypeId::AggregateFilter),
            731 => Ok(DataTypeId::MonitoringFilterResult),
            734 => Ok(DataTypeId::EventFilterResult),
            737 => Ok(DataTypeId::AggregateFilterResult),
            740 => Ok(DataTypeId::MonitoringParameters),
            743 => Ok(DataTypeId::MonitoredItemCreateRequest),
            746 => Ok(DataTypeId::MonitoredItemCreateResult),
            749 => Ok(DataTypeId::CreateMonitoredItemsRequest),
            752 => Ok(DataTypeId::CreateMonitoredItemsResponse),
            755 => Ok(DataTypeId::MonitoredItemModifyRequest),
            758 => Ok(DataTypeId::MonitoredItemModifyResult),
            761 => Ok(DataTypeId::ModifyMonitoredItemsRequest),
            764 => Ok(DataTypeId::ModifyMonitoredItemsResponse),
            767 => Ok(DataTypeId::SetMonitoringModeRequest),
            770 => Ok(DataTypeId::SetMonitoringModeResponse),
            773 => Ok(DataTypeId::SetTriggeringRequest),
            776 => Ok(DataTypeId::SetTriggeringResponse),
            779 => Ok(DataTypeId::DeleteMonitoredItemsRequest),
            782 => Ok(DataTypeId::DeleteMonitoredItemsResponse),
            785 => Ok(DataTypeId::CreateSubscriptionRequest),
            788 => Ok(DataTypeId::CreateSubscriptionResponse),
            791 => Ok(DataTypeId::ModifySubscriptionRequest),
            794 => Ok(DataTypeId::ModifySubscriptionResponse),
            797 => Ok(DataTypeId::SetPublishingModeRequest),
            800 => Ok(DataTypeId::SetPublishingModeResponse),
            803 => Ok(DataTypeId::NotificationMessage),
            806 => Ok(DataTypeId::MonitoredItemNotification),
            809 => Ok(DataTypeId::DataChangeNotification),
            818 => Ok(DataTypeId::StatusChangeNotification),
            821 => Ok(DataTypeId::SubscriptionAcknowledgement),
            824 => Ok(DataTypeId::PublishRequest),
            827 => Ok(DataTypeId::PublishResponse),
            830 => Ok(DataTypeId::RepublishRequest),
            833 => Ok(DataTypeId::RepublishResponse),
            836 => Ok(DataTypeId::TransferResult),
            839 => Ok(DataTypeId::TransferSubscriptionsRequest),
            842 => Ok(DataTypeId::TransferSubscriptionsResponse),
            845 => Ok(DataTypeId::DeleteSubscriptionsRequest),
            848 => Ok(DataTypeId::DeleteSubscriptionsResponse),
            851 => Ok(DataTypeId::RedundancySupport),
            852 => Ok(DataTypeId::ServerState),
            853 => Ok(DataTypeId::RedundantServerDataType),
            856 => Ok(DataTypeId::SamplingIntervalDiagnosticsDataType),
            859 => Ok(DataTypeId::ServerDiagnosticsSummaryDataType),
            862 => Ok(DataTypeId::ServerStatusDataType),
            865 => Ok(DataTypeId::SessionDiagnosticsDataType),
            868 => Ok(DataTypeId::SessionSecurityDiagnosticsDataType),
            871 => Ok(DataTypeId::ServiceCounterDataType),
            874 => Ok(DataTypeId::SubscriptionDiagnosticsDataType),
            877 => Ok(DataTypeId::ModelChangeStructureDataType),
            884 => Ok(DataTypeId::Range),
            887 => Ok(DataTypeId::EUInformation),
            890 => Ok(DataTypeId::ExceptionDeviationFormat),
            891 => Ok(DataTypeId::Annotation),
            894 => Ok(DataTypeId::ProgramDiagnosticDataType),
            897 => Ok(DataTypeId::SemanticChangeStructureDataType),
            914 => Ok(DataTypeId::EventNotificationList),
            917 => Ok(DataTypeId::EventFieldList),
            920 => Ok(DataTypeId::HistoryEventFieldList),
            938 => Ok(DataTypeId::IssuedIdentityToken),
            945 => Ok(DataTypeId::NotificationData),
            948 => Ok(DataTypeId::AggregateConfiguration),
            2000 => Ok(DataTypeId::ImageBMP),
            2001 => Ok(DataTypeId::ImageGIF),
            2002 => Ok(DataTypeId::ImageJPG),
            2003 => Ok(DataTypeId::ImagePNG),
            7594 => Ok(DataTypeId::EnumValueType),
            8912 => Ok(DataTypeId::TimeZoneDataType),
            11216 => Ok(DataTypeId::ModificationInfo),
            11217 => Ok(DataTypeId::HistoryModifiedData),
            11234 => Ok(DataTypeId::HistoryUpdateType),
            11293 => Ok(DataTypeId::PerformUpdateType),
            11295 => Ok(DataTypeId::UpdateStructureDataDetails),
            11737 => Ok(DataTypeId::BitFieldMaskDataType),
            11879 => Ok(DataTypeId::InstanceNode),
            11880 => Ok(DataTypeId::TypeNode),
            11939 => Ok(DataTypeId::OpenFileMode),
            11941 => Ok(DataTypeId::ModelChangeStructureVerbMask),
            11943 => Ok(DataTypeId::EndpointUrlListDataType),
            11944 => Ok(DataTypeId::NetworkGroupDataType),
            12077 => Ok(DataTypeId::AxisScaleEnumeration),
            12079 => Ok(DataTypeId::AxisInformation),
            12080 => Ok(DataTypeId::XVType),
            12171 => Ok(DataTypeId::ComplexNumberType),
            12172 => Ok(DataTypeId::DoubleComplexNumberType),
            12189 => Ok(DataTypeId::ServerOnNetwork),
            12190 => Ok(DataTypeId::FindServersOnNetworkRequest),
            12191 => Ok(DataTypeId::FindServersOnNetworkResponse),
            12193 => Ok(DataTypeId::RegisterServer2Request),
            12194 => Ok(DataTypeId::RegisterServer2Response),
            12552 => Ok(DataTypeId::TrustListMasks),
            12554 => Ok(DataTypeId::TrustListDataType),
            12755 => Ok(DataTypeId::OptionSet),
            12756 => Ok(DataTypeId::Union),
            12877 => Ok(DataTypeId::NormalizedString),
            12878 => Ok(DataTypeId::DecimalString),
            12879 => Ok(DataTypeId::DurationString),
            12880 => Ok(DataTypeId::TimeString),
            12881 => Ok(DataTypeId::DateString),
            12890 => Ok(DataTypeId::DiscoveryConfiguration),
            12891 => Ok(DataTypeId::MdnsDiscoveryConfiguration),
            14273 => Ok(DataTypeId::PublishedVariableDataType),
            14523 => Ok(DataTypeId::DataSetMetaDataType),
            14524 => Ok(DataTypeId::FieldMetaData),
            14525 => Ok(DataTypeId::DataTypeDescription),
            14533 => Ok(DataTypeId::KeyValuePair),
            14593 => Ok(DataTypeId::ConfigurationVersionDataType),
            14647 => Ok(DataTypeId::PubSubState),
            14744 => Ok(DataTypeId::FieldTargetDataType),
            15005 => Ok(DataTypeId::SimpleTypeDescription),
            15006 => Ok(DataTypeId::UABinaryFileDataType),
            15007 => Ok(DataTypeId::BrokerConnectionTransportDataType),
            15008 => Ok(DataTypeId::BrokerTransportQualityOfService),
            15031 => Ok(DataTypeId::AccessLevelType),
            15033 => Ok(DataTypeId::EventNotifierType),
            15396 => Ok(DataTypeId::ProgramDiagnostic2DataType),
            15406 => Ok(DataTypeId::AccessLevelExType),
            15480 => Ok(DataTypeId::WriterGroupDataType),
            15487 => Ok(DataTypeId::StructureDescription),
            15488 => Ok(DataTypeId::EnumDescription),
            15502 => Ok(DataTypeId::NetworkAddressDataType),
            15510 => Ok(DataTypeId::NetworkAddressUrlDataType),
            15520 => Ok(DataTypeId::ReaderGroupDataType),
            15528 => Ok(DataTypeId::EndpointType),
            15530 => Ok(DataTypeId::PubSubConfigurationDataType),
            15532 => Ok(DataTypeId::DatagramWriterGroupTransportDataType),
            15534 => Ok(DataTypeId::DataTypeSchemaHeader),
            15578 => Ok(DataTypeId::PublishedDataSetDataType),
            15580 => Ok(DataTypeId::PublishedDataSetSourceDataType),
            15581 => Ok(DataTypeId::PublishedDataItemsDataType),
            15582 => Ok(DataTypeId::PublishedEventsDataType),
            15583 => Ok(DataTypeId::DataSetFieldContentMask),
            15597 => Ok(DataTypeId::DataSetWriterDataType),
            15598 => Ok(DataTypeId::DataSetWriterTransportDataType),
            15605 => Ok(DataTypeId::DataSetWriterMessageDataType),
            15609 => Ok(DataTypeId::PubSubGroupDataType),
            15611 => Ok(DataTypeId::WriterGroupTransportDataType),
            15616 => Ok(DataTypeId::WriterGroupMessageDataType),
            15617 => Ok(DataTypeId::PubSubConnectionDataType),
            15618 => Ok(DataTypeId::ConnectionTransportDataType),
            15621 => Ok(DataTypeId::ReaderGroupTransportDataType),
            15622 => Ok(DataTypeId::ReaderGroupMessageDataType),
            15623 => Ok(DataTypeId::DataSetReaderDataType),
            15628 => Ok(DataTypeId::DataSetReaderTransportDataType),
            15629 => Ok(DataTypeId::DataSetReaderMessageDataType),
            15630 => Ok(DataTypeId::SubscribedDataSetDataType),
            15631 => Ok(DataTypeId::TargetVariablesDataType),
            15632 => Ok(DataTypeId::IdentityCriteriaType),
            15634 => Ok(DataTypeId::IdentityMappingRuleType),
            15635 => Ok(DataTypeId::SubscribedDataSetMirrorDataType),
            15642 => Ok(DataTypeId::UadpNetworkMessageContentMask),
            15645 => Ok(DataTypeId::UadpWriterGroupMessageDataType),
            15646 => Ok(DataTypeId::UadpDataSetMessageContentMask),
            15652 => Ok(DataTypeId::UadpDataSetWriterMessageDataType),
            15653 => Ok(DataTypeId::UadpDataSetReaderMessageDataType),
            15654 => Ok(DataTypeId::JsonNetworkMessageContentMask),
            15657 => Ok(DataTypeId::JsonWriterGroupMessageDataType),
            15658 => Ok(DataTypeId::JsonDataSetMessageContentMask),
            15664 => Ok(DataTypeId::JsonDataSetWriterMessageDataType),
            15665 => Ok(DataTypeId::JsonDataSetReaderMessageDataType),
            15667 => Ok(DataTypeId::BrokerWriterGroupTransportDataType),
            15669 => Ok(DataTypeId::BrokerDataSetWriterTransportDataType),
            15670 => Ok(DataTypeId::BrokerDataSetReaderTransportDataType),
            15874 => Ok(DataTypeId::OverrideValueHandling),
            15901 => Ok(DataTypeId::SessionlessInvokeRequestType),
            15904 => Ok(DataTypeId::DataSetFieldFlags),
            16307 => Ok(DataTypeId::AudioDataType),
            16313 => Ok(DataTypeId::AdditionalParametersType),
            17467 => Ok(DataTypeId::DatagramConnectionTransportDataType),
            17545 => Ok(DataTypeId::RsaEncryptedSecret),
            17546 => Ok(DataTypeId::EccEncryptedSecret),
            17548 => Ok(DataTypeId::EphemeralKeyType),
            17588 => Ok(DataTypeId::Index),
            17606 => Ok(DataTypeId::GenericAttributeValue),
            17607 => Ok(DataTypeId::GenericAttributes),
            17861 => Ok(DataTypeId::DecimalDataType),
            18806 => Ok(DataTypeId::RationalNumber),
            18807 => Ok(DataTypeId::Vector),
            18808 => Ok(DataTypeId::ThreeDVector),
            18809 => Ok(DataTypeId::CartesianCoordinates),
            18810 => Ok(DataTypeId::ThreeDCartesianCoordinates),
            18811 => Ok(DataTypeId::Orientation),
            18812 => Ok(DataTypeId::ThreeDOrientation),
            18813 => Ok(DataTypeId::Frame),
            18814 => Ok(DataTypeId::ThreeDFrame),
            19723 => Ok(DataTypeId::DiagnosticsLevel),
            19730 => Ok(DataTypeId::PubSubDiagnosticsCounterClassification),
            20408 => Ok(DataTypeId::DataSetOrderingType),
            20998 => Ok(DataTypeId::VersionTime),
            20999 => Ok(DataTypeId::SessionlessInvokeResponseType),
            23468 => Ok(DataTypeId::AliasNameDataType),
            23497 => Ok(DataTypeId::ReadAnnotationDataDetails),
            23498 => Ok(DataTypeId::CurrencyUnitType),
            _ => Err(()),
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum ReferenceTypeId {
    References = 31,
    NonHierarchicalReferences = 32,
    HierarchicalReferences = 33,
    HasChild = 34,
    Organizes = 35,
    HasEventSource = 36,
    HasModellingRule = 37,
    HasEncoding = 38,
    HasDescription = 39,
    HasTypeDefinition = 40,
    GeneratesEvent = 41,
    Aggregates = 44,
    HasSubtype = 45,
    HasProperty = 46,
    HasComponent = 47,
    HasNotifier = 48,
    HasOrderedComponent = 49,
    FromState = 51,
    ToState = 52,
    HasCause = 53,
    HasEffect = 54,
    HasHistoricalConfiguration = 56,
    HasSubStateMachine = 117,
    HasArgumentDescription = 129,
    HasOptionalInputArgumentDescription = 131,
    AlwaysGeneratesEvent = 3065,
    HasTrueSubState = 9004,
    HasFalseSubState = 9005,
    HasCondition = 9006,
    HasPubSubConnection = 14476,
    DataSetToWriter = 14936,
    HasGuard = 15112,
    HasDataSetWriter = 15296,
    HasDataSetReader = 15297,
    HasAlarmSuppressionGroup = 16361,
    AlarmGroupMember = 16362,
    HasEffectDisable = 17276,
    HasDictionaryEntry = 17597,
    HasInterface = 17603,
    HasAddIn = 17604,
    HasEffectEnable = 17983,
    HasEffectSuppressed = 17984,
    HasEffectUnsuppressed = 17985,
    HasWriterGroup = 18804,
    HasReaderGroup = 18805,
    AliasFor = 23469,
}

impl<'a> From<&'a ReferenceTypeId> for NodeId {
    fn from(r: &'a ReferenceTypeId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for ReferenceTypeId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for ReferenceTypeId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for ReferenceTypeId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            31 => Ok(ReferenceTypeId::References),
            32 => Ok(ReferenceTypeId::NonHierarchicalReferences),
            33 => Ok(ReferenceTypeId::HierarchicalReferences),
            34 => Ok(ReferenceTypeId::HasChild),
            35 => Ok(ReferenceTypeId::Organizes),
            36 => Ok(ReferenceTypeId::HasEventSource),
            37 => Ok(ReferenceTypeId::HasModellingRule),
            38 => Ok(ReferenceTypeId::HasEncoding),
            39 => Ok(ReferenceTypeId::HasDescription),
            40 => Ok(ReferenceTypeId::HasTypeDefinition),
            41 => Ok(ReferenceTypeId::GeneratesEvent),
            44 => Ok(ReferenceTypeId::Aggregates),
            45 => Ok(ReferenceTypeId::HasSubtype),
            46 => Ok(ReferenceTypeId::HasProperty),
            47 => Ok(ReferenceTypeId::HasComponent),
            48 => Ok(ReferenceTypeId::HasNotifier),
            49 => Ok(ReferenceTypeId::HasOrderedComponent),
            51 => Ok(ReferenceTypeId::FromState),
            52 => Ok(ReferenceTypeId::ToState),
            53 => Ok(ReferenceTypeId::HasCause),
            54 => Ok(ReferenceTypeId::HasEffect),
            56 => Ok(ReferenceTypeId::HasHistoricalConfiguration),
            117 => Ok(ReferenceTypeId::HasSubStateMachine),
            129 => Ok(ReferenceTypeId::HasArgumentDescription),
            131 => Ok(ReferenceTypeId::HasOptionalInputArgumentDescription),
            3065 => Ok(ReferenceTypeId::AlwaysGeneratesEvent),
            9004 => Ok(ReferenceTypeId::HasTrueSubState),
            9005 => Ok(ReferenceTypeId::HasFalseSubState),
            9006 => Ok(ReferenceTypeId::HasCondition),
            14476 => Ok(ReferenceTypeId::HasPubSubConnection),
            14936 => Ok(ReferenceTypeId::DataSetToWriter),
            15112 => Ok(ReferenceTypeId::HasGuard),
            15296 => Ok(ReferenceTypeId::HasDataSetWriter),
            15297 => Ok(ReferenceTypeId::HasDataSetReader),
            16361 => Ok(ReferenceTypeId::HasAlarmSuppressionGroup),
            16362 => Ok(ReferenceTypeId::AlarmGroupMember),
            17276 => Ok(ReferenceTypeId::HasEffectDisable),
            17597 => Ok(ReferenceTypeId::HasDictionaryEntry),
            17603 => Ok(ReferenceTypeId::HasInterface),
            17604 => Ok(ReferenceTypeId::HasAddIn),
            17983 => Ok(ReferenceTypeId::HasEffectEnable),
            17984 => Ok(ReferenceTypeId::HasEffectSuppressed),
            17985 => Ok(ReferenceTypeId::HasEffectUnsuppressed),
            18804 => Ok(ReferenceTypeId::HasWriterGroup),
            18805 => Ok(ReferenceTypeId::HasReaderGroup),
            23469 => Ok(ReferenceTypeId::AliasFor),
            _ => Err(()),
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum ObjectTypeId {
    BaseObjectType = 58,
    FolderType = 61,
    DataTypeSystemType = 75,
    DataTypeEncodingType = 76,
    ModellingRuleType = 77,
    ServerType = 2004,
    ServerCapabilitiesType = 2013,
    ServerDiagnosticsType = 2020,
    SessionsDiagnosticsSummaryType = 2026,
    SessionDiagnosticsObjectType = 2029,
    VendorServerInfoType = 2033,
    ServerRedundancyType = 2034,
    TransparentRedundancyType = 2036,
    NonTransparentRedundancyType = 2039,
    BaseEventType = 2041,
    AuditEventType = 2052,
    AuditSecurityEventType = 2058,
    AuditChannelEventType = 2059,
    AuditOpenSecureChannelEventType = 2060,
    AuditSessionEventType = 2069,
    AuditCreateSessionEventType = 2071,
    AuditActivateSessionEventType = 2075,
    AuditCancelEventType = 2078,
    AuditCertificateEventType = 2080,
    AuditCertificateDataMismatchEventType = 2082,
    AuditCertificateExpiredEventType = 2085,
    AuditCertificateInvalidEventType = 2086,
    AuditCertificateUntrustedEventType = 2087,
    AuditCertificateRevokedEventType = 2088,
    AuditCertificateMismatchEventType = 2089,
    AuditNodeManagementEventType = 2090,
    AuditAddNodesEventType = 2091,
    AuditDeleteNodesEventType = 2093,
    AuditAddReferencesEventType = 2095,
    AuditDeleteReferencesEventType = 2097,
    AuditUpdateEventType = 2099,
    AuditWriteUpdateEventType = 2100,
    AuditHistoryUpdateEventType = 2104,
    AuditUpdateMethodEventType = 2127,
    SystemEventType = 2130,
    DeviceFailureEventType = 2131,
    BaseModelChangeEventType = 2132,
    GeneralModelChangeEventType = 2133,
    StateMachineType = 2299,
    StateType = 2307,
    InitialStateType = 2309,
    TransitionType = 2310,
    TransitionEventType = 2311,
    AuditUpdateStateEventType = 2315,
    HistoricalDataConfigurationType = 2318,
    HistoryServerCapabilitiesType = 2330,
    AggregateFunctionType = 2340,
    ProgramTransitionEventType = 2378,
    ProgramStateMachineType = 2391,
    SemanticChangeEventType = 2738,
    AuditUrlMismatchEventType = 2748,
    FiniteStateMachineType = 2771,
    ConditionType = 2782,
    RefreshStartEventType = 2787,
    RefreshEndEventType = 2788,
    RefreshRequiredEventType = 2789,
    AuditConditionEventType = 2790,
    AuditConditionEnableEventType = 2803,
    AuditConditionCommentEventType = 2829,
    DialogConditionType = 2830,
    AcknowledgeableConditionType = 2881,
    AlarmConditionType = 2915,
    ShelvedStateMachineType = 2929,
    LimitAlarmType = 2955,
    AuditHistoryEventUpdateEventType = 2999,
    AuditHistoryValueUpdateEventType = 3006,
    AuditHistoryDeleteEventType = 3012,
    AuditHistoryRawModifyDeleteEventType = 3014,
    AuditHistoryAtTimeDeleteEventType = 3019,
    AuditHistoryEventDeleteEventType = 3022,
    EventQueueOverflowEventType = 3035,
    ProgramTransitionAuditEventType = 3806,
    AuditConditionRespondEventType = 8927,
    AuditConditionAcknowledgeEventType = 8944,
    AuditConditionConfirmEventType = 8961,
    ExclusiveLimitStateMachineType = 9318,
    ExclusiveLimitAlarmType = 9341,
    ExclusiveLevelAlarmType = 9482,
    ExclusiveRateOfChangeAlarmType = 9623,
    ExclusiveDeviationAlarmType = 9764,
    NonExclusiveLimitAlarmType = 9906,
    NonExclusiveLevelAlarmType = 10060,
    NonExclusiveRateOfChangeAlarmType = 10214,
    NonExclusiveDeviationAlarmType = 10368,
    DiscreteAlarmType = 10523,
    OffNormalAlarmType = 10637,
    TripAlarmType = 10751,
    AuditConditionShelvingEventType = 11093,
    BaseConditionClassType = 11163,
    ProcessConditionClassType = 11164,
    MaintenanceConditionClassType = 11165,
    SystemConditionClassType = 11166,
    AggregateConfigurationType = 11187,
    ProgressEventType = 11436,
    SystemStatusChangeEventType = 11446,
    OperationLimitsType = 11564,
    FileType = 11575,
    AddressSpaceFileType = 11595,
    NamespaceMetadataType = 11616,
    NamespacesType = 11645,
    SystemOffNormalAlarmType = 11753,
    AuditProgramTransitionEventType = 11856,
    NonTransparentNetworkRedundancyType = 11945,
    TrustListType = 12522,
    CertificateGroupType = 12555,
    CertificateType = 12556,
    ApplicationCertificateType = 12557,
    HttpsCertificateType = 12558,
    RsaMinApplicationCertificateType = 12559,
    RsaSha256ApplicationCertificateType = 12560,
    TrustListUpdatedAuditEventType = 12561,
    ServerConfigurationType = 12581,
    CertificateUpdatedAuditEventType = 12620,
    CertificateExpirationAlarmType = 13225,
    FileDirectoryType = 13353,
    CertificateGroupFolderType = 13813,
    PubSubConnectionType = 14209,
    PubSubGroupType = 14232,
    PublishSubscribeType = 14416,
    DataSetFolderType = 14477,
    PublishedDataSetType = 14509,
    PublishedDataItemsType = 14534,
    PublishedEventsType = 14572,
    PubSubStatusType = 14643,
    AuditConditionResetEventType = 15013,
    DatagramConnectionTransportType = 15064,
    SubscribedDataSetType = 15108,
    ChoiceStateType = 15109,
    TargetVariablesType = 15111,
    SubscribedDataSetMirrorType = 15127,
    BrokerConnectionTransportType = 15155,
    UserCredentialCertificateType = 15181,
    DataSetWriterType = 15298,
    DataSetWriterTransportType = 15305,
    DataSetReaderType = 15306,
    DataSetReaderTransportType = 15319,
    SecurityGroupFolderType = 15452,
    SecurityGroupType = 15471,
    ExtensionFieldsType = 15489,
    PubSubStatusEventType = 15535,
    PubSubTransportLimitsExceedEventType = 15548,
    PubSubCommunicationFailureEventType = 15563,
    RoleSetType = 15607,
    RoleType = 15620,
    TemporaryFileTransferType = 15744,
    FileTransferStateMachineType = 15803,
    PubSubKeyServiceType = 15906,
    AlarmGroupType = 16405,
    DiscrepancyAlarmType = 17080,
    SafetyConditionClassType = 17218,
    HighlyManagedAlarmConditionClassType = 17219,
    TrainingConditionClassType = 17220,
    TestingConditionSubClassType = 17221,
    AuditConditionSuppressionEventType = 17225,
    AuditConditionSilenceEventType = 17242,
    AuditConditionOutOfServiceEventType = 17259,
    AlarmMetricsType = 17279,
    KeyCredentialConfigurationFolderType = 17496,
    DictionaryEntryType = 17589,
    DictionaryFolderType = 17591,
    IrdiDictionaryEntryType = 17598,
    UriDictionaryEntryType = 17600,
    BaseInterfaceType = 17602,
    RoleMappingRuleChangedAuditEventType = 17641,
    ConnectionTransportType = 17721,
    WriterGroupType = 17725,
    AuthorizationServiceConfigurationType = 17852,
    WriterGroupTransportType = 17997,
    WriterGroupMessageType = 17998,
    ReaderGroupType = 17999,
    KeyCredentialConfigurationType = 18001,
    KeyCredentialAuditEventType = 18011,
    KeyCredentialUpdatedAuditEventType = 18029,
    KeyCredentialDeletedAuditEventType = 18047,
    InstrumentDiagnosticAlarmType = 18347,
    SystemDiagnosticAlarmType = 18496,
    StatisticalConditionClassType = 18665,
    AuditHistoryAnnotationUpdateEventType = 19095,
    TrustListOutOfDateAlarmType = 19297,
    PubSubDiagnosticsType = 19677,
    PubSubDiagnosticsRootType = 19732,
    PubSubDiagnosticsConnectionType = 19786,
    PubSubDiagnosticsWriterGroupType = 19834,
    PubSubDiagnosticsReaderGroupType = 19903,
    PubSubDiagnosticsDataSetWriterType = 19968,
    PubSubDiagnosticsDataSetReaderType = 20027,
    ReaderGroupTransportType = 21090,
    ReaderGroupMessageType = 21091,
    DataSetWriterMessageType = 21096,
    DataSetReaderMessageType = 21104,
    UadpWriterGroupMessageType = 21105,
    UadpDataSetWriterMessageType = 21111,
    UadpDataSetReaderMessageType = 21116,
    JsonWriterGroupMessageType = 21126,
    JsonDataSetWriterMessageType = 21128,
    JsonDataSetReaderMessageType = 21130,
    DatagramWriterGroupTransportType = 21133,
    BrokerWriterGroupTransportType = 21136,
    BrokerDataSetWriterTransportType = 21138,
    BrokerDataSetReaderTransportType = 21142,
    NetworkAddressType = 21145,
    NetworkAddressUrlType = 21147,
    AliasNameType = 23455,
    AliasNameCategoryType = 23456,
    IOrderedObjectType = 23513,
    OrderedListType = 23518,
    EccApplicationCertificateType = 23537,
    EccNistP256ApplicationCertificateType = 23538,
    EccNistP384ApplicationCertificateType = 23539,
    EccBrainpoolP256r1ApplicationCertificateType = 23540,
    EccBrainpoolP384r1ApplicationCertificateType = 23541,
    EccCurve25519ApplicationCertificateType = 23542,
    EccCurve448ApplicationCertificateType = 23543,
    AuthorizationServicesConfigurationFolderType = 23556,
}

impl<'a> From<&'a ObjectTypeId> for NodeId {
    fn from(r: &'a ObjectTypeId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for ObjectTypeId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for ObjectTypeId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for ObjectTypeId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            58 => Ok(ObjectTypeId::BaseObjectType),
            61 => Ok(ObjectTypeId::FolderType),
            75 => Ok(ObjectTypeId::DataTypeSystemType),
            76 => Ok(ObjectTypeId::DataTypeEncodingType),
            77 => Ok(ObjectTypeId::ModellingRuleType),
            2004 => Ok(ObjectTypeId::ServerType),
            2013 => Ok(ObjectTypeId::ServerCapabilitiesType),
            2020 => Ok(ObjectTypeId::ServerDiagnosticsType),
            2026 => Ok(ObjectTypeId::SessionsDiagnosticsSummaryType),
            2029 => Ok(ObjectTypeId::SessionDiagnosticsObjectType),
            2033 => Ok(ObjectTypeId::VendorServerInfoType),
            2034 => Ok(ObjectTypeId::ServerRedundancyType),
            2036 => Ok(ObjectTypeId::TransparentRedundancyType),
            2039 => Ok(ObjectTypeId::NonTransparentRedundancyType),
            2041 => Ok(ObjectTypeId::BaseEventType),
            2052 => Ok(ObjectTypeId::AuditEventType),
            2058 => Ok(ObjectTypeId::AuditSecurityEventType),
            2059 => Ok(ObjectTypeId::AuditChannelEventType),
            2060 => Ok(ObjectTypeId::AuditOpenSecureChannelEventType),
            2069 => Ok(ObjectTypeId::AuditSessionEventType),
            2071 => Ok(ObjectTypeId::AuditCreateSessionEventType),
            2075 => Ok(ObjectTypeId::AuditActivateSessionEventType),
            2078 => Ok(ObjectTypeId::AuditCancelEventType),
            2080 => Ok(ObjectTypeId::AuditCertificateEventType),
            2082 => Ok(ObjectTypeId::AuditCertificateDataMismatchEventType),
            2085 => Ok(ObjectTypeId::AuditCertificateExpiredEventType),
            2086 => Ok(ObjectTypeId::AuditCertificateInvalidEventType),
            2087 => Ok(ObjectTypeId::AuditCertificateUntrustedEventType),
            2088 => Ok(ObjectTypeId::AuditCertificateRevokedEventType),
            2089 => Ok(ObjectTypeId::AuditCertificateMismatchEventType),
            2090 => Ok(ObjectTypeId::AuditNodeManagementEventType),
            2091 => Ok(ObjectTypeId::AuditAddNodesEventType),
            2093 => Ok(ObjectTypeId::AuditDeleteNodesEventType),
            2095 => Ok(ObjectTypeId::AuditAddReferencesEventType),
            2097 => Ok(ObjectTypeId::AuditDeleteReferencesEventType),
            2099 => Ok(ObjectTypeId::AuditUpdateEventType),
            2100 => Ok(ObjectTypeId::AuditWriteUpdateEventType),
            2104 => Ok(ObjectTypeId::AuditHistoryUpdateEventType),
            2127 => Ok(ObjectTypeId::AuditUpdateMethodEventType),
            2130 => Ok(ObjectTypeId::SystemEventType),
            2131 => Ok(ObjectTypeId::DeviceFailureEventType),
            2132 => Ok(ObjectTypeId::BaseModelChangeEventType),
            2133 => Ok(ObjectTypeId::GeneralModelChangeEventType),
            2299 => Ok(ObjectTypeId::StateMachineType),
            2307 => Ok(ObjectTypeId::StateType),
            2309 => Ok(ObjectTypeId::InitialStateType),
            2310 => Ok(ObjectTypeId::TransitionType),
            2311 => Ok(ObjectTypeId::TransitionEventType),
            2315 => Ok(ObjectTypeId::AuditUpdateStateEventType),
            2318 => Ok(ObjectTypeId::HistoricalDataConfigurationType),
            2330 => Ok(ObjectTypeId::HistoryServerCapabilitiesType),
            2340 => Ok(ObjectTypeId::AggregateFunctionType),
            2378 => Ok(ObjectTypeId::ProgramTransitionEventType),
            2391 => Ok(ObjectTypeId::ProgramStateMachineType),
            2738 => Ok(ObjectTypeId::SemanticChangeEventType),
            2748 => Ok(ObjectTypeId::AuditUrlMismatchEventType),
            2771 => Ok(ObjectTypeId::FiniteStateMachineType),
            2782 => Ok(ObjectTypeId::ConditionType),
            2787 => Ok(ObjectTypeId::RefreshStartEventType),
            2788 => Ok(ObjectTypeId::RefreshEndEventType),
            2789 => Ok(ObjectTypeId::RefreshRequiredEventType),
            2790 => Ok(ObjectTypeId::AuditConditionEventType),
            2803 => Ok(ObjectTypeId::AuditConditionEnableEventType),
            2829 => Ok(ObjectTypeId::AuditConditionCommentEventType),
            2830 => Ok(ObjectTypeId::DialogConditionType),
            2881 => Ok(ObjectTypeId::AcknowledgeableConditionType),
            2915 => Ok(ObjectTypeId::AlarmConditionType),
            2929 => Ok(ObjectTypeId::ShelvedStateMachineType),
            2955 => Ok(ObjectTypeId::LimitAlarmType),
            2999 => Ok(ObjectTypeId::AuditHistoryEventUpdateEventType),
            3006 => Ok(ObjectTypeId::AuditHistoryValueUpdateEventType),
            3012 => Ok(ObjectTypeId::AuditHistoryDeleteEventType),
            3014 => Ok(ObjectTypeId::AuditHistoryRawModifyDeleteEventType),
            3019 => Ok(ObjectTypeId::AuditHistoryAtTimeDeleteEventType),
            3022 => Ok(ObjectTypeId::AuditHistoryEventDeleteEventType),
            3035 => Ok(ObjectTypeId::EventQueueOverflowEventType),
            3806 => Ok(ObjectTypeId::ProgramTransitionAuditEventType),
            8927 => Ok(ObjectTypeId::AuditConditionRespondEventType),
            8944 => Ok(ObjectTypeId::AuditConditionAcknowledgeEventType),
            8961 => Ok(ObjectTypeId::AuditConditionConfirmEventType),
            9318 => Ok(ObjectTypeId::ExclusiveLimitStateMachineType),
            9341 => Ok(ObjectTypeId::ExclusiveLimitAlarmType),
            9482 => Ok(ObjectTypeId::ExclusiveLevelAlarmType),
            9623 => Ok(ObjectTypeId::ExclusiveRateOfChangeAlarmType),
            9764 => Ok(ObjectTypeId::ExclusiveDeviationAlarmType),
            9906 => Ok(ObjectTypeId::NonExclusiveLimitAlarmType),
            10060 => Ok(ObjectTypeId::NonExclusiveLevelAlarmType),
            10214 => Ok(ObjectTypeId::NonExclusiveRateOfChangeAlarmType),
            10368 => Ok(ObjectTypeId::NonExclusiveDeviationAlarmType),
            10523 => Ok(ObjectTypeId::DiscreteAlarmType),
            10637 => Ok(ObjectTypeId::OffNormalAlarmType),
            10751 => Ok(ObjectTypeId::TripAlarmType),
            11093 => Ok(ObjectTypeId::AuditConditionShelvingEventType),
            11163 => Ok(ObjectTypeId::BaseConditionClassType),
            11164 => Ok(ObjectTypeId::ProcessConditionClassType),
            11165 => Ok(ObjectTypeId::MaintenanceConditionClassType),
            11166 => Ok(ObjectTypeId::SystemConditionClassType),
            11187 => Ok(ObjectTypeId::AggregateConfigurationType),
            11436 => Ok(ObjectTypeId::ProgressEventType),
            11446 => Ok(ObjectTypeId::SystemStatusChangeEventType),
            11564 => Ok(ObjectTypeId::OperationLimitsType),
            11575 => Ok(ObjectTypeId::FileType),
            11595 => Ok(ObjectTypeId::AddressSpaceFileType),
            11616 => Ok(ObjectTypeId::NamespaceMetadataType),
            11645 => Ok(ObjectTypeId::NamespacesType),
            11753 => Ok(ObjectTypeId::SystemOffNormalAlarmType),
            11856 => Ok(ObjectTypeId::AuditProgramTransitionEventType),
            11945 => Ok(ObjectTypeId::NonTransparentNetworkRedundancyType),
            12522 => Ok(ObjectTypeId::TrustListType),
            12555 => Ok(ObjectTypeId::CertificateGroupType),
            12556 => Ok(ObjectTypeId::CertificateType),
            12557 => Ok(ObjectTypeId::ApplicationCertificateType),
            12558 => Ok(ObjectTypeId::HttpsCertificateType),
            12559 => Ok(ObjectTypeId::RsaMinApplicationCertificateType),
            12560 => Ok(ObjectTypeId::RsaSha256ApplicationCertificateType),
            12561 => Ok(ObjectTypeId::TrustListUpdatedAuditEventType),
            12581 => Ok(ObjectTypeId::ServerConfigurationType),
            12620 => Ok(ObjectTypeId::CertificateUpdatedAuditEventType),
            13225 => Ok(ObjectTypeId::CertificateExpirationAlarmType),
            13353 => Ok(ObjectTypeId::FileDirectoryType),
            13813 => Ok(ObjectTypeId::CertificateGroupFolderType),
            14209 => Ok(ObjectTypeId::PubSubConnectionType),
            14232 => Ok(ObjectTypeId::PubSubGroupType),
            14416 => Ok(ObjectTypeId::PublishSubscribeType),
            14477 => Ok(ObjectTypeId::DataSetFolderType),
            14509 => Ok(ObjectTypeId::PublishedDataSetType),
            14534 => Ok(ObjectTypeId::PublishedDataItemsType),
            14572 => Ok(ObjectTypeId::PublishedEventsType),
            14643 => Ok(ObjectTypeId::PubSubStatusType),
            15013 => Ok(ObjectTypeId::AuditConditionResetEventType),
            15064 => Ok(ObjectTypeId::DatagramConnectionTransportType),
            15108 => Ok(ObjectTypeId::SubscribedDataSetType),
            15109 => Ok(ObjectTypeId::ChoiceStateType),
            15111 => Ok(ObjectTypeId::TargetVariablesType),
            15127 => Ok(ObjectTypeId::SubscribedDataSetMirrorType),
            15155 => Ok(ObjectTypeId::BrokerConnectionTransportType),
            15181 => Ok(ObjectTypeId::UserCredentialCertificateType),
            15298 => Ok(ObjectTypeId::DataSetWriterType),
            15305 => Ok(ObjectTypeId::DataSetWriterTransportType),
            15306 => Ok(ObjectTypeId::DataSetReaderType),
            15319 => Ok(ObjectTypeId::DataSetReaderTransportType),
            15452 => Ok(ObjectTypeId::SecurityGroupFolderType),
            15471 => Ok(ObjectTypeId::SecurityGroupType),
            15489 => Ok(ObjectTypeId::ExtensionFieldsType),
            15535 => Ok(ObjectTypeId::PubSubStatusEventType),
            15548 => Ok(ObjectTypeId::PubSubTransportLimitsExceedEventType),
            15563 => Ok(ObjectTypeId::PubSubCommunicationFailureEventType),
            15607 => Ok(ObjectTypeId::RoleSetType),
            15620 => Ok(ObjectTypeId::RoleType),
            15744 => Ok(ObjectTypeId::TemporaryFileTransferType),
            15803 => Ok(ObjectTypeId::FileTransferStateMachineType),
            15906 => Ok(ObjectTypeId::PubSubKeyServiceType),
            16405 => Ok(ObjectTypeId::AlarmGroupType),
            17080 => Ok(ObjectTypeId::DiscrepancyAlarmType),
            17218 => Ok(ObjectTypeId::SafetyConditionClassType),
            17219 => Ok(ObjectTypeId::HighlyManagedAlarmConditionClassType),
            17220 => Ok(ObjectTypeId::TrainingConditionClassType),
            17221 => Ok(ObjectTypeId::TestingConditionSubClassType),
            17225 => Ok(ObjectTypeId::AuditConditionSuppressionEventType),
            17242 => Ok(ObjectTypeId::AuditConditionSilenceEventType),
            17259 => Ok(ObjectTypeId::AuditConditionOutOfServiceEventType),
            17279 => Ok(ObjectTypeId::AlarmMetricsType),
            17496 => Ok(ObjectTypeId::KeyCredentialConfigurationFolderType),
            17589 => Ok(ObjectTypeId::DictionaryEntryType),
            17591 => Ok(ObjectTypeId::DictionaryFolderType),
            17598 => Ok(ObjectTypeId::IrdiDictionaryEntryType),
            17600 => Ok(ObjectTypeId::UriDictionaryEntryType),
            17602 => Ok(ObjectTypeId::BaseInterfaceType),
            17641 => Ok(ObjectTypeId::RoleMappingRuleChangedAuditEventType),
            17721 => Ok(ObjectTypeId::ConnectionTransportType),
            17725 => Ok(ObjectTypeId::WriterGroupType),
            17852 => Ok(ObjectTypeId::AuthorizationServiceConfigurationType),
            17997 => Ok(ObjectTypeId::WriterGroupTransportType),
            17998 => Ok(ObjectTypeId::WriterGroupMessageType),
            17999 => Ok(ObjectTypeId::ReaderGroupType),
            18001 => Ok(ObjectTypeId::KeyCredentialConfigurationType),
            18011 => Ok(ObjectTypeId::KeyCredentialAuditEventType),
            18029 => Ok(ObjectTypeId::KeyCredentialUpdatedAuditEventType),
            18047 => Ok(ObjectTypeId::KeyCredentialDeletedAuditEventType),
            18347 => Ok(ObjectTypeId::InstrumentDiagnosticAlarmType),
            18496 => Ok(ObjectTypeId::SystemDiagnosticAlarmType),
            18665 => Ok(ObjectTypeId::StatisticalConditionClassType),
            19095 => Ok(ObjectTypeId::AuditHistoryAnnotationUpdateEventType),
            19297 => Ok(ObjectTypeId::TrustListOutOfDateAlarmType),
            19677 => Ok(ObjectTypeId::PubSubDiagnosticsType),
            19732 => Ok(ObjectTypeId::PubSubDiagnosticsRootType),
            19786 => Ok(ObjectTypeId::PubSubDiagnosticsConnectionType),
            19834 => Ok(ObjectTypeId::PubSubDiagnosticsWriterGroupType),
            19903 => Ok(ObjectTypeId::PubSubDiagnosticsReaderGroupType),
            19968 => Ok(ObjectTypeId::PubSubDiagnosticsDataSetWriterType),
            20027 => Ok(ObjectTypeId::PubSubDiagnosticsDataSetReaderType),
            21090 => Ok(ObjectTypeId::ReaderGroupTransportType),
            21091 => Ok(ObjectTypeId::ReaderGroupMessageType),
            21096 => Ok(ObjectTypeId::DataSetWriterMessageType),
            21104 => Ok(ObjectTypeId::DataSetReaderMessageType),
            21105 => Ok(ObjectTypeId::UadpWriterGroupMessageType),
            21111 => Ok(ObjectTypeId::UadpDataSetWriterMessageType),
            21116 => Ok(ObjectTypeId::UadpDataSetReaderMessageType),
            21126 => Ok(ObjectTypeId::JsonWriterGroupMessageType),
            21128 => Ok(ObjectTypeId::JsonDataSetWriterMessageType),
            21130 => Ok(ObjectTypeId::JsonDataSetReaderMessageType),
            21133 => Ok(ObjectTypeId::DatagramWriterGroupTransportType),
            21136 => Ok(ObjectTypeId::BrokerWriterGroupTransportType),
            21138 => Ok(ObjectTypeId::BrokerDataSetWriterTransportType),
            21142 => Ok(ObjectTypeId::BrokerDataSetReaderTransportType),
            21145 => Ok(ObjectTypeId::NetworkAddressType),
            21147 => Ok(ObjectTypeId::NetworkAddressUrlType),
            23455 => Ok(ObjectTypeId::AliasNameType),
            23456 => Ok(ObjectTypeId::AliasNameCategoryType),
            23513 => Ok(ObjectTypeId::IOrderedObjectType),
            23518 => Ok(ObjectTypeId::OrderedListType),
            23537 => Ok(ObjectTypeId::EccApplicationCertificateType),
            23538 => Ok(ObjectTypeId::EccNistP256ApplicationCertificateType),
            23539 => Ok(ObjectTypeId::EccNistP384ApplicationCertificateType),
            23540 => Ok(ObjectTypeId::EccBrainpoolP256r1ApplicationCertificateType),
            23541 => Ok(ObjectTypeId::EccBrainpoolP384r1ApplicationCertificateType),
            23542 => Ok(ObjectTypeId::EccCurve25519ApplicationCertificateType),
            23543 => Ok(ObjectTypeId::EccCurve448ApplicationCertificateType),
            23556 => Ok(ObjectTypeId::AuthorizationServicesConfigurationFolderType),
            _ => Err(()),
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum VariableTypeId {
    BaseVariableType = 62,
    BaseDataVariableType = 63,
    PropertyType = 68,
    DataTypeDescriptionType = 69,
    DataTypeDictionaryType = 72,
    ServerVendorCapabilityType = 2137,
    ServerStatusType = 2138,
    ServerDiagnosticsSummaryType = 2150,
    SamplingIntervalDiagnosticsArrayType = 2164,
    SamplingIntervalDiagnosticsType = 2165,
    SubscriptionDiagnosticsArrayType = 2171,
    SubscriptionDiagnosticsType = 2172,
    SessionDiagnosticsArrayType = 2196,
    SessionDiagnosticsVariableType = 2197,
    SessionSecurityDiagnosticsArrayType = 2243,
    SessionSecurityDiagnosticsType = 2244,
    DataItemType = 2365,
    AnalogItemType = 2368,
    DiscreteItemType = 2372,
    TwoStateDiscreteType = 2373,
    MultiStateDiscreteType = 2376,
    ProgramDiagnosticType = 2380,
    StateVariableType = 2755,
    FiniteStateVariableType = 2760,
    TransitionVariableType = 2762,
    FiniteTransitionVariableType = 2767,
    BuildInfoType = 3051,
    TwoStateVariableType = 8995,
    ConditionVariableType = 9002,
    MultiStateValueDiscreteType = 11238,
    OptionSetType = 11487,
    ArrayItemType = 12021,
    YArrayItemType = 12029,
    XYArrayItemType = 12038,
    ImageItemType = 12047,
    CubeItemType = 12057,
    NDimensionArrayItemType = 12068,
    GuardVariableType = 15113,
    ExpressionGuardVariableType = 15128,
    ElseGuardVariableType = 15317,
    BaseAnalogType = 15318,
    ProgramDiagnostic2Type = 15383,
    SelectionListType = 16309,
    AlarmRateVariableType = 17277,
    AnalogUnitType = 17497,
    AnalogUnitRangeType = 17570,
    RationalNumberType = 17709,
    VectorType = 17714,
    ThreeDVectorType = 17716,
    AudioVariableType = 17986,
    CartesianCoordinatesType = 18772,
    ThreeDCartesianCoordinatesType = 18774,
    OrientationType = 18779,
    ThreeDOrientationType = 18781,
    FrameType = 18786,
    ThreeDFrameType = 18791,
    MultiStateDictionaryEntryDiscreteBaseType = 19077,
    MultiStateDictionaryEntryDiscreteType = 19084,
    PubSubDiagnosticsCounterType = 19725,
}

impl<'a> From<&'a VariableTypeId> for NodeId {
    fn from(r: &'a VariableTypeId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for VariableTypeId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for VariableTypeId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for VariableTypeId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            62 => Ok(VariableTypeId::BaseVariableType),
            63 => Ok(VariableTypeId::BaseDataVariableType),
            68 => Ok(VariableTypeId::PropertyType),
            69 => Ok(VariableTypeId::DataTypeDescriptionType),
            72 => Ok(VariableTypeId::DataTypeDictionaryType),
            2137 => Ok(VariableTypeId::ServerVendorCapabilityType),
            2138 => Ok(VariableTypeId::ServerStatusType),
            2150 => Ok(VariableTypeId::ServerDiagnosticsSummaryType),
            2164 => Ok(VariableTypeId::SamplingIntervalDiagnosticsArrayType),
            2165 => Ok(VariableTypeId::SamplingIntervalDiagnosticsType),
            2171 => Ok(VariableTypeId::SubscriptionDiagnosticsArrayType),
            2172 => Ok(VariableTypeId::SubscriptionDiagnosticsType),
            2196 => Ok(VariableTypeId::SessionDiagnosticsArrayType),
            2197 => Ok(VariableTypeId::SessionDiagnosticsVariableType),
            2243 => Ok(VariableTypeId::SessionSecurityDiagnosticsArrayType),
            2244 => Ok(VariableTypeId::SessionSecurityDiagnosticsType),
            2365 => Ok(VariableTypeId::DataItemType),
            2368 => Ok(VariableTypeId::AnalogItemType),
            2372 => Ok(VariableTypeId::DiscreteItemType),
            2373 => Ok(VariableTypeId::TwoStateDiscreteType),
            2376 => Ok(VariableTypeId::MultiStateDiscreteType),
            2380 => Ok(VariableTypeId::ProgramDiagnosticType),
            2755 => Ok(VariableTypeId::StateVariableType),
            2760 => Ok(VariableTypeId::FiniteStateVariableType),
            2762 => Ok(VariableTypeId::TransitionVariableType),
            2767 => Ok(VariableTypeId::FiniteTransitionVariableType),
            3051 => Ok(VariableTypeId::BuildInfoType),
            8995 => Ok(VariableTypeId::TwoStateVariableType),
            9002 => Ok(VariableTypeId::ConditionVariableType),
            11238 => Ok(VariableTypeId::MultiStateValueDiscreteType),
            11487 => Ok(VariableTypeId::OptionSetType),
            12021 => Ok(VariableTypeId::ArrayItemType),
            12029 => Ok(VariableTypeId::YArrayItemType),
            12038 => Ok(VariableTypeId::XYArrayItemType),
            12047 => Ok(VariableTypeId::ImageItemType),
            12057 => Ok(VariableTypeId::CubeItemType),
            12068 => Ok(VariableTypeId::NDimensionArrayItemType),
            15113 => Ok(VariableTypeId::GuardVariableType),
            15128 => Ok(VariableTypeId::ExpressionGuardVariableType),
            15317 => Ok(VariableTypeId::ElseGuardVariableType),
            15318 => Ok(VariableTypeId::BaseAnalogType),
            15383 => Ok(VariableTypeId::ProgramDiagnostic2Type),
            16309 => Ok(VariableTypeId::SelectionListType),
            17277 => Ok(VariableTypeId::AlarmRateVariableType),
            17497 => Ok(VariableTypeId::AnalogUnitType),
            17570 => Ok(VariableTypeId::AnalogUnitRangeType),
            17709 => Ok(VariableTypeId::RationalNumberType),
            17714 => Ok(VariableTypeId::VectorType),
            17716 => Ok(VariableTypeId::ThreeDVectorType),
            17986 => Ok(VariableTypeId::AudioVariableType),
            18772 => Ok(VariableTypeId::CartesianCoordinatesType),
            18774 => Ok(VariableTypeId::ThreeDCartesianCoordinatesType),
            18779 => Ok(VariableTypeId::OrientationType),
            18781 => Ok(VariableTypeId::ThreeDOrientationType),
            18786 => Ok(VariableTypeId::FrameType),
            18791 => Ok(VariableTypeId::ThreeDFrameType),
            19077 => Ok(VariableTypeId::MultiStateDictionaryEntryDiscreteBaseType),
            19084 => Ok(VariableTypeId::MultiStateDictionaryEntryDiscreteType),
            19725 => Ok(VariableTypeId::PubSubDiagnosticsCounterType),
            _ => Err(()),
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum ObjectId {
    ModellingRule_Mandatory = 78,
    ModellingRule_Optional = 80,
    ModellingRule_ExposesItsArray = 83,
    RootFolder = 84,
    ObjectsFolder = 85,
    TypesFolder = 86,
    ViewsFolder = 87,
    ObjectTypesFolder = 88,
    VariableTypesFolder = 89,
    DataTypesFolder = 90,
    ReferenceTypesFolder = 91,
    XmlSchema_TypeSystem = 92,
    OPCBinarySchema_TypeSystem = 93,
    DataTypeDefinition_Encoding_DefaultBinary = 121,
    StructureDefinition_Encoding_DefaultBinary = 122,
    EnumDefinition_Encoding_DefaultBinary = 123,
    DataSetMetaDataType_Encoding_DefaultBinary = 124,
    DataTypeDescription_Encoding_DefaultBinary = 125,
    StructureDescription_Encoding_DefaultBinary = 126,
    EnumDescription_Encoding_DefaultBinary = 127,
    RolePermissionType_Encoding_DefaultBinary = 128,
    Node_Encoding_DefaultBinary = 260,
    ObjectNode_Encoding_DefaultBinary = 263,
    ObjectTypeNode_Encoding_DefaultBinary = 266,
    VariableNode_Encoding_DefaultBinary = 269,
    VariableTypeNode_Encoding_DefaultBinary = 272,
    ReferenceTypeNode_Encoding_DefaultBinary = 275,
    MethodNode_Encoding_DefaultBinary = 278,
    ViewNode_Encoding_DefaultBinary = 281,
    DataTypeNode_Encoding_DefaultBinary = 284,
    ReferenceNode_Encoding_DefaultBinary = 287,
    Argument_Encoding_DefaultBinary = 298,
    StatusResult_Encoding_DefaultBinary = 301,
    UserTokenPolicy_Encoding_DefaultBinary = 306,
    ApplicationDescription_Encoding_DefaultBinary = 310,
    EndpointDescription_Encoding_DefaultBinary = 314,
    UserIdentityToken_Encoding_DefaultBinary = 318,
    AnonymousIdentityToken_Encoding_DefaultBinary = 321,
    UserNameIdentityToken_Encoding_DefaultBinary = 324,
    X509IdentityToken_Encoding_DefaultBinary = 327,
    EndpointConfiguration_Encoding_DefaultBinary = 333,
    BuildInfo_Encoding_DefaultBinary = 340,
    SignedSoftwareCertificate_Encoding_DefaultBinary = 346,
    NodeAttributes_Encoding_DefaultBinary = 351,
    ObjectAttributes_Encoding_DefaultBinary = 354,
    VariableAttributes_Encoding_DefaultBinary = 357,
    MethodAttributes_Encoding_DefaultBinary = 360,
    ObjectTypeAttributes_Encoding_DefaultBinary = 363,
    VariableTypeAttributes_Encoding_DefaultBinary = 366,
    ReferenceTypeAttributes_Encoding_DefaultBinary = 369,
    DataTypeAttributes_Encoding_DefaultBinary = 372,
    ViewAttributes_Encoding_DefaultBinary = 375,
    AddNodesItem_Encoding_DefaultBinary = 378,
    AddReferencesItem_Encoding_DefaultBinary = 381,
    DeleteNodesItem_Encoding_DefaultBinary = 384,
    DeleteReferencesItem_Encoding_DefaultBinary = 387,
    RequestHeader_Encoding_DefaultBinary = 391,
    ResponseHeader_Encoding_DefaultBinary = 394,
    ServiceFault_Encoding_DefaultBinary = 397,
    FindServersRequest_Encoding_DefaultBinary = 422,
    FindServersResponse_Encoding_DefaultBinary = 425,
    GetEndpointsRequest_Encoding_DefaultBinary = 428,
    GetEndpointsResponse_Encoding_DefaultBinary = 431,
    RegisteredServer_Encoding_DefaultBinary = 434,
    RegisterServerRequest_Encoding_DefaultBinary = 437,
    RegisterServerResponse_Encoding_DefaultBinary = 440,
    ChannelSecurityToken_Encoding_DefaultBinary = 443,
    OpenSecureChannelRequest_Encoding_DefaultBinary = 446,
    OpenSecureChannelResponse_Encoding_DefaultBinary = 449,
    CloseSecureChannelRequest_Encoding_DefaultBinary = 452,
    CloseSecureChannelResponse_Encoding_DefaultBinary = 455,
    SignatureData_Encoding_DefaultBinary = 458,
    CreateSessionRequest_Encoding_DefaultBinary = 461,
    CreateSessionResponse_Encoding_DefaultBinary = 464,
    ActivateSessionRequest_Encoding_DefaultBinary = 467,
    ActivateSessionResponse_Encoding_DefaultBinary = 470,
    CloseSessionRequest_Encoding_DefaultBinary = 473,
    CloseSessionResponse_Encoding_DefaultBinary = 476,
    CancelRequest_Encoding_DefaultBinary = 479,
    CancelResponse_Encoding_DefaultBinary = 482,
    AddNodesResult_Encoding_DefaultBinary = 485,
    AddNodesRequest_Encoding_DefaultBinary = 488,
    AddNodesResponse_Encoding_DefaultBinary = 491,
    AddReferencesRequest_Encoding_DefaultBinary = 494,
    AddReferencesResponse_Encoding_DefaultBinary = 497,
    DeleteNodesRequest_Encoding_DefaultBinary = 500,
    DeleteNodesResponse_Encoding_DefaultBinary = 503,
    DeleteReferencesRequest_Encoding_DefaultBinary = 506,
    DeleteReferencesResponse_Encoding_DefaultBinary = 509,
    ViewDescription_Encoding_DefaultBinary = 513,
    BrowseDescription_Encoding_DefaultBinary = 516,
    ReferenceDescription_Encoding_DefaultBinary = 520,
    BrowseResult_Encoding_DefaultBinary = 524,
    BrowseRequest_Encoding_DefaultBinary = 527,
    BrowseResponse_Encoding_DefaultBinary = 530,
    BrowseNextRequest_Encoding_DefaultBinary = 533,
    BrowseNextResponse_Encoding_DefaultBinary = 536,
    RelativePathElement_Encoding_DefaultBinary = 539,
    RelativePath_Encoding_DefaultBinary = 542,
    BrowsePath_Encoding_DefaultBinary = 545,
    BrowsePathTarget_Encoding_DefaultBinary = 548,
    BrowsePathResult_Encoding_DefaultBinary = 551,
    TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultBinary = 554,
    TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultBinary = 557,
    RegisterNodesRequest_Encoding_DefaultBinary = 560,
    RegisterNodesResponse_Encoding_DefaultBinary = 563,
    UnregisterNodesRequest_Encoding_DefaultBinary = 566,
    UnregisterNodesResponse_Encoding_DefaultBinary = 569,
    QueryDataDescription_Encoding_DefaultBinary = 572,
    NodeTypeDescription_Encoding_DefaultBinary = 575,
    QueryDataSet_Encoding_DefaultBinary = 579,
    NodeReference_Encoding_DefaultBinary = 582,
    ContentFilterElement_Encoding_DefaultBinary = 585,
    ContentFilter_Encoding_DefaultBinary = 588,
    FilterOperand_Encoding_DefaultBinary = 591,
    ElementOperand_Encoding_DefaultBinary = 594,
    LiteralOperand_Encoding_DefaultBinary = 597,
    AttributeOperand_Encoding_DefaultBinary = 600,
    SimpleAttributeOperand_Encoding_DefaultBinary = 603,
    ContentFilterElementResult_Encoding_DefaultBinary = 606,
    ContentFilterResult_Encoding_DefaultBinary = 609,
    ParsingResult_Encoding_DefaultBinary = 612,
    QueryFirstRequest_Encoding_DefaultBinary = 615,
    QueryFirstResponse_Encoding_DefaultBinary = 618,
    QueryNextRequest_Encoding_DefaultBinary = 621,
    QueryNextResponse_Encoding_DefaultBinary = 624,
    ReadValueId_Encoding_DefaultBinary = 628,
    ReadRequest_Encoding_DefaultBinary = 631,
    ReadResponse_Encoding_DefaultBinary = 634,
    HistoryReadValueId_Encoding_DefaultBinary = 637,
    HistoryReadResult_Encoding_DefaultBinary = 640,
    HistoryReadDetails_Encoding_DefaultBinary = 643,
    ReadEventDetails_Encoding_DefaultBinary = 646,
    ReadRawModifiedDetails_Encoding_DefaultBinary = 649,
    ReadProcessedDetails_Encoding_DefaultBinary = 652,
    ReadAtTimeDetails_Encoding_DefaultBinary = 655,
    HistoryData_Encoding_DefaultBinary = 658,
    HistoryEvent_Encoding_DefaultBinary = 661,
    HistoryReadRequest_Encoding_DefaultBinary = 664,
    HistoryReadResponse_Encoding_DefaultBinary = 667,
    WriteValue_Encoding_DefaultBinary = 670,
    WriteRequest_Encoding_DefaultBinary = 673,
    WriteResponse_Encoding_DefaultBinary = 676,
    HistoryUpdateDetails_Encoding_DefaultBinary = 679,
    UpdateDataDetails_Encoding_DefaultBinary = 682,
    UpdateEventDetails_Encoding_DefaultBinary = 685,
    DeleteRawModifiedDetails_Encoding_DefaultBinary = 688,
    DeleteAtTimeDetails_Encoding_DefaultBinary = 691,
    DeleteEventDetails_Encoding_DefaultBinary = 694,
    HistoryUpdateResult_Encoding_DefaultBinary = 697,
    HistoryUpdateRequest_Encoding_DefaultBinary = 700,
    HistoryUpdateResponse_Encoding_DefaultBinary = 703,
    CallMethodRequest_Encoding_DefaultBinary = 706,
    CallMethodResult_Encoding_DefaultBinary = 709,
    CallRequest_Encoding_DefaultBinary = 712,
    CallResponse_Encoding_DefaultBinary = 715,
    MonitoringFilter_Encoding_DefaultBinary = 721,
    DataChangeFilter_Encoding_DefaultBinary = 724,
    EventFilter_Encoding_DefaultBinary = 727,
    AggregateFilter_Encoding_DefaultBinary = 730,
    MonitoringFilterResult_Encoding_DefaultBinary = 733,
    EventFilterResult_Encoding_DefaultBinary = 736,
    AggregateFilterResult_Encoding_DefaultBinary = 739,
    MonitoringParameters_Encoding_DefaultBinary = 742,
    MonitoredItemCreateRequest_Encoding_DefaultBinary = 745,
    MonitoredItemCreateResult_Encoding_DefaultBinary = 748,
    CreateMonitoredItemsRequest_Encoding_DefaultBinary = 751,
    CreateMonitoredItemsResponse_Encoding_DefaultBinary = 754,
    MonitoredItemModifyRequest_Encoding_DefaultBinary = 757,
    MonitoredItemModifyResult_Encoding_DefaultBinary = 760,
    ModifyMonitoredItemsRequest_Encoding_DefaultBinary = 763,
    ModifyMonitoredItemsResponse_Encoding_DefaultBinary = 766,
    SetMonitoringModeRequest_Encoding_DefaultBinary = 769,
    SetMonitoringModeResponse_Encoding_DefaultBinary = 772,
    SetTriggeringRequest_Encoding_DefaultBinary = 775,
    SetTriggeringResponse_Encoding_DefaultBinary = 778,
    DeleteMonitoredItemsRequest_Encoding_DefaultBinary = 781,
    DeleteMonitoredItemsResponse_Encoding_DefaultBinary = 784,
    CreateSubscriptionRequest_Encoding_DefaultBinary = 787,
    CreateSubscriptionResponse_Encoding_DefaultBinary = 790,
    ModifySubscriptionRequest_Encoding_DefaultBinary = 793,
    ModifySubscriptionResponse_Encoding_DefaultBinary = 796,
    SetPublishingModeRequest_Encoding_DefaultBinary = 799,
    SetPublishingModeResponse_Encoding_DefaultBinary = 802,
    NotificationMessage_Encoding_DefaultBinary = 805,
    MonitoredItemNotification_Encoding_DefaultBinary = 808,
    DataChangeNotification_Encoding_DefaultBinary = 811,
    StatusChangeNotification_Encoding_DefaultBinary = 820,
    SubscriptionAcknowledgement_Encoding_DefaultBinary = 823,
    PublishRequest_Encoding_DefaultBinary = 826,
    PublishResponse_Encoding_DefaultBinary = 829,
    RepublishRequest_Encoding_DefaultBinary = 832,
    RepublishResponse_Encoding_DefaultBinary = 835,
    TransferResult_Encoding_DefaultBinary = 838,
    TransferSubscriptionsRequest_Encoding_DefaultBinary = 841,
    TransferSubscriptionsResponse_Encoding_DefaultBinary = 844,
    DeleteSubscriptionsRequest_Encoding_DefaultBinary = 847,
    DeleteSubscriptionsResponse_Encoding_DefaultBinary = 850,
    RedundantServerDataType_Encoding_DefaultBinary = 855,
    SamplingIntervalDiagnosticsDataType_Encoding_DefaultBinary = 858,
    ServerDiagnosticsSummaryDataType_Encoding_DefaultBinary = 861,
    ServerStatusDataType_Encoding_DefaultBinary = 864,
    SessionDiagnosticsDataType_Encoding_DefaultBinary = 867,
    SessionSecurityDiagnosticsDataType_Encoding_DefaultBinary = 870,
    ServiceCounterDataType_Encoding_DefaultBinary = 873,
    SubscriptionDiagnosticsDataType_Encoding_DefaultBinary = 876,
    ModelChangeStructureDataType_Encoding_DefaultBinary = 879,
    Range_Encoding_DefaultBinary = 886,
    EUInformation_Encoding_DefaultBinary = 889,
    Annotation_Encoding_DefaultBinary = 893,
    ProgramDiagnosticDataType_Encoding_DefaultBinary = 896,
    SemanticChangeStructureDataType_Encoding_DefaultBinary = 899,
    EventNotificationList_Encoding_DefaultBinary = 916,
    EventFieldList_Encoding_DefaultBinary = 919,
    HistoryEventFieldList_Encoding_DefaultBinary = 922,
    IssuedIdentityToken_Encoding_DefaultBinary = 940,
    NotificationData_Encoding_DefaultBinary = 947,
    AggregateConfiguration_Encoding_DefaultBinary = 950,
    ServerType_ServerCapabilities = 2009,
    ServerType_ServerDiagnostics = 2010,
    ServerType_VendorServerInfo = 2011,
    ServerType_ServerRedundancy = 2012,
    ServerCapabilitiesType_ModellingRules = 2019,
    Server = 2253,
    Server_ServerCapabilities = 2268,
    Server_ServerDiagnostics = 2274,
    Server_VendorServerInfo = 2295,
    Server_ServerRedundancy = 2296,
    AggregateFunction_Interpolative = 2341,
    AggregateFunction_Average = 2342,
    AggregateFunction_TimeAverage = 2343,
    AggregateFunction_Total = 2344,
    AggregateFunction_Minimum = 2346,
    AggregateFunction_Maximum = 2347,
    AggregateFunction_MinimumActualTime = 2348,
    AggregateFunction_MaximumActualTime = 2349,
    AggregateFunction_Range = 2350,
    AggregateFunction_AnnotationCount = 2351,
    AggregateFunction_Count = 2352,
    AggregateFunction_NumberOfTransitions = 2355,
    AggregateFunction_Start = 2357,
    AggregateFunction_End = 2358,
    AggregateFunction_Delta = 2359,
    AggregateFunction_DurationGood = 2360,
    AggregateFunction_DurationBad = 2361,
    AggregateFunction_PercentGood = 2362,
    AggregateFunction_PercentBad = 2363,
    AggregateFunction_WorstQuality = 2364,
    ProgramStateMachineType_Ready = 2400,
    ProgramStateMachineType_Running = 2402,
    ProgramStateMachineType_Suspended = 2404,
    ProgramStateMachineType_Halted = 2406,
    ProgramStateMachineType_HaltedToReady = 2408,
    ProgramStateMachineType_ReadyToRunning = 2410,
    ProgramStateMachineType_RunningToHalted = 2412,
    ProgramStateMachineType_RunningToReady = 2414,
    ProgramStateMachineType_RunningToSuspended = 2416,
    ProgramStateMachineType_SuspendedToRunning = 2418,
    ProgramStateMachineType_SuspendedToHalted = 2420,
    ProgramStateMachineType_SuspendedToReady = 2422,
    ProgramStateMachineType_ReadyToHalted = 2424,
    ServerDiagnosticsType_SessionsDiagnosticsSummary = 2744,
    ServerCapabilitiesType_AggregateFunctions = 2754,
    ShelvedStateMachineType_Unshelved = 2930,
    ShelvedStateMachineType_TimedShelved = 2932,
    ShelvedStateMachineType_OneShotShelved = 2933,
    ShelvedStateMachineType_UnshelvedToTimedShelved = 2935,
    ShelvedStateMachineType_UnshelvedToOneShotShelved = 2936,
    ShelvedStateMachineType_TimedShelvedToUnshelved = 2940,
    ShelvedStateMachineType_TimedShelvedToOneShotShelved = 2942,
    ShelvedStateMachineType_OneShotShelvedToUnshelved = 2943,
    ShelvedStateMachineType_OneShotShelvedToTimedShelved = 2945,
    Server_ServerCapabilities_ModellingRules = 2996,
    Server_ServerCapabilities_AggregateFunctions = 2997,
    EventTypesFolder = 3048,
    HistoricalDataConfigurationType_AggregateConfiguration = 3059,
    DefaultBinary = 3062,
    DefaultXml = 3063,
    ServerType_ServerCapabilities_ModellingRules = 3093,
    ServerType_ServerCapabilities_AggregateFunctions = 3094,
    ServerType_ServerDiagnostics_SessionsDiagnosticsSummary = 3111,
    Server_ServerDiagnostics_SessionsDiagnosticsSummary = 3706,
    ProgramStateMachineType_FinalResultData = 3850,
    EnumValueType_Encoding_DefaultBinary = 8251,
    TimeZoneDataType_Encoding_DefaultBinary = 8917,
    AlarmConditionType_ShelvingState = 9178,
    LimitAlarmType_ShelvingState = 9279,
    ExclusiveLimitStateMachineType_HighHigh = 9329,
    ExclusiveLimitStateMachineType_High = 9331,
    ExclusiveLimitStateMachineType_Low = 9333,
    ExclusiveLimitStateMachineType_LowLow = 9335,
    ExclusiveLimitStateMachineType_LowLowToLow = 9337,
    ExclusiveLimitStateMachineType_LowToLowLow = 9338,
    ExclusiveLimitStateMachineType_HighHighToHigh = 9339,
    ExclusiveLimitStateMachineType_HighToHighHigh = 9340,
    ExclusiveLimitAlarmType_ShelvingState = 9416,
    ExclusiveLimitAlarmType_LimitState = 9455,
    ExclusiveLevelAlarmType_ShelvingState = 9557,
    ExclusiveLevelAlarmType_LimitState = 9596,
    ExclusiveRateOfChangeAlarmType_ShelvingState = 9698,
    ExclusiveRateOfChangeAlarmType_LimitState = 9737,
    ExclusiveDeviationAlarmType_ShelvingState = 9839,
    ExclusiveDeviationAlarmType_LimitState = 9878,
    NonExclusiveLimitAlarmType_ShelvingState = 9981,
    NonExclusiveLevelAlarmType_ShelvingState = 10135,
    NonExclusiveRateOfChangeAlarmType_ShelvingState = 10289,
    NonExclusiveDeviationAlarmType_ShelvingState = 10443,
    DiscreteAlarmType_ShelvingState = 10598,
    OffNormalAlarmType_ShelvingState = 10712,
    TripAlarmType_ShelvingState = 10826,
    HistoryServerCapabilitiesType_AggregateFunctions = 11172,
    HistoryServerCapabilities = 11192,
    HistoryServerCapabilities_AggregateFunctions = 11201,
    HAConfiguration = 11202,
    HAConfiguration_AggregateConfiguration = 11203,
    ModificationInfo_Encoding_DefaultBinary = 11226,
    HistoryModifiedData_Encoding_DefaultBinary = 11227,
    AggregateFunction_TimeAverage2 = 11285,
    AggregateFunction_Minimum2 = 11286,
    AggregateFunction_Maximum2 = 11287,
    AggregateFunction_Range2 = 11288,
    AggregateFunction_WorstQuality2 = 11292,
    UpdateStructureDataDetails_Encoding_DefaultBinary = 11300,
    AggregateFunction_Total2 = 11304,
    AggregateFunction_MinimumActualTime2 = 11305,
    AggregateFunction_MaximumActualTime2 = 11306,
    AggregateFunction_DurationInStateZero = 11307,
    AggregateFunction_DurationInStateNonZero = 11308,
    AggregateFunction_StandardDeviationSample = 11426,
    AggregateFunction_StandardDeviationPopulation = 11427,
    AggregateFunction_VarianceSample = 11428,
    AggregateFunction_VariancePopulation = 11429,
    AggregateFunction_StartBound = 11505,
    AggregateFunction_EndBound = 11506,
    AggregateFunction_DeltaBounds = 11507,
    ModellingRule_OptionalPlaceholder = 11508,
    ModellingRule_MandatoryPlaceholder = 11510,
    ServerType_ServerCapabilities_OperationLimits = 11516,
    ServerType_Namespaces = 11527,
    ServerCapabilitiesType_OperationLimits = 11551,
    NamespaceMetadataType_NamespaceFile = 11624,
    NamespacesType_NamespaceIdentifier_Placeholder = 11646,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile = 11654,
    Server_ServerCapabilities_OperationLimits = 11704,
    Server_Namespaces = 11715,
    SystemOffNormalAlarmType_ShelvingState = 11831,
    HistoricalDataConfigurationType_AggregateFunctions = 11876,
    HAConfiguration_AggregateFunctions = 11877,
    InstanceNode_Encoding_DefaultBinary = 11889,
    TypeNode_Encoding_DefaultBinary = 11890,
    EndpointUrlListDataType_Encoding_DefaultBinary = 11957,
    NetworkGroupDataType_Encoding_DefaultBinary = 11958,
    AxisInformation_Encoding_DefaultBinary = 12089,
    XVType_Encoding_DefaultBinary = 12090,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder = 12097,
    ComplexNumberType_Encoding_DefaultBinary = 12181,
    DoubleComplexNumberType_Encoding_DefaultBinary = 12182,
    ServerOnNetwork_Encoding_DefaultBinary = 12207,
    FindServersOnNetworkRequest_Encoding_DefaultBinary = 12208,
    FindServersOnNetworkResponse_Encoding_DefaultBinary = 12209,
    RegisterServer2Request_Encoding_DefaultBinary = 12211,
    RegisterServer2Response_Encoding_DefaultBinary = 12212,
    ServerConfiguration = 12637,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList = 12642,
    TrustListDataType_Encoding_DefaultBinary = 12680,
    OptionSet_Encoding_DefaultBinary = 12765,
    Union_Encoding_DefaultBinary = 12766,
    DiscoveryConfiguration_Encoding_DefaultBinary = 12900,
    MdnsDiscoveryConfiguration_Encoding_DefaultBinary = 12901,
    CertificateExpirationAlarmType_ShelvingState = 13305,
    FileDirectoryType_FileDirectoryName_Placeholder = 13354,
    FileDirectoryType_FileName_Placeholder = 13366,
    CertificateGroupType_TrustList = 13599,
    CertificateGroupFolderType_DefaultApplicationGroup = 13814,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList = 13815,
    CertificateGroupFolderType_DefaultHttpsGroup = 13848,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList = 13849,
    CertificateGroupFolderType_DefaultUserTokenGroup = 13882,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList = 13883,
    CertificateGroupFolderType_AdditionalGroup_Placeholder = 13916,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList = 13917,
    ServerConfigurationType_CertificateGroups = 13950,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup = 13951,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList = 13952,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup = 13985,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList = 13986,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup = 14019,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList = 14020,
    ServerConfiguration_CertificateGroups = 14053,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup = 14088,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList = 14089,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup = 14122,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList = 14123,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup = 14156,
    PubSubConnectionType_Address = 14221,
    PublishedVariableDataType_Encoding_DefaultBinary = 14323,
    PublishSubscribeType_ConnectionName_Placeholder = 14417,
    PublishSubscribeType_ConnectionName_Placeholder_Status = 14419,
    PublishSubscribeType_ConnectionName_Placeholder_Address = 14423,
    PublishSubscribeType_PublishedDataSets = 14434,
    PublishSubscribe = 14443,
    DataSetFolderType_DataSetFolderName_Placeholder = 14478,
    DataSetFolderType_PublishedDataSetName_Placeholder = 14487,
    PubSubConnectionType_Status = 14600,
    FieldMetaData_Encoding_DefaultBinary = 14839,
    StructureField_Encoding_DefaultBinary = 14844,
    EnumField_Encoding_DefaultBinary = 14845,
    KeyValuePair_Encoding_DefaultBinary = 14846,
    ConfigurationVersionDataType_Encoding_DefaultBinary = 14847,
    FieldTargetDataType_Encoding_DefaultBinary = 14848,
    KeyValuePair_Encoding_DefaultJson = 15041,
    IdentityMappingRuleType_Encoding_DefaultJson = 15042,
    TrustListDataType_Encoding_DefaultJson = 15044,
    DecimalDataType_Encoding_DefaultJson = 15045,
    ConfigurationVersionDataType_Encoding_DefaultJson = 15049,
    DataSetMetaDataType_Encoding_DefaultJson = 15050,
    FieldMetaData_Encoding_DefaultJson = 15051,
    DataTypeDescription_Encoding_DefaultJson = 15057,
    StructureDescription_Encoding_DefaultJson = 15058,
    EnumDescription_Encoding_DefaultJson = 15059,
    PublishedVariableDataType_Encoding_DefaultJson = 15060,
    FieldTargetDataType_Encoding_DefaultJson = 15061,
    RolePermissionType_Encoding_DefaultJson = 15062,
    DataTypeDefinition_Encoding_DefaultJson = 15063,
    StructureField_Encoding_DefaultJson = 15065,
    StructureDefinition_Encoding_DefaultJson = 15066,
    EnumDefinition_Encoding_DefaultJson = 15067,
    Node_Encoding_DefaultJson = 15068,
    InstanceNode_Encoding_DefaultJson = 15069,
    TypeNode_Encoding_DefaultJson = 15070,
    ObjectNode_Encoding_DefaultJson = 15071,
    DatagramConnectionTransportType_DiscoveryAddress = 15072,
    ObjectTypeNode_Encoding_DefaultJson = 15073,
    VariableNode_Encoding_DefaultJson = 15074,
    VariableTypeNode_Encoding_DefaultJson = 15075,
    ReferenceTypeNode_Encoding_DefaultJson = 15076,
    MethodNode_Encoding_DefaultJson = 15077,
    ViewNode_Encoding_DefaultJson = 15078,
    DataTypeNode_Encoding_DefaultJson = 15079,
    ReferenceNode_Encoding_DefaultJson = 15080,
    Argument_Encoding_DefaultJson = 15081,
    EnumValueType_Encoding_DefaultJson = 15082,
    EnumField_Encoding_DefaultJson = 15083,
    OptionSet_Encoding_DefaultJson = 15084,
    Union_Encoding_DefaultJson = 15085,
    TimeZoneDataType_Encoding_DefaultJson = 15086,
    ApplicationDescription_Encoding_DefaultJson = 15087,
    RequestHeader_Encoding_DefaultJson = 15088,
    ResponseHeader_Encoding_DefaultJson = 15089,
    ServiceFault_Encoding_DefaultJson = 15090,
    SessionlessInvokeRequestType_Encoding_DefaultJson = 15091,
    SessionlessInvokeResponseType_Encoding_DefaultJson = 15092,
    FindServersRequest_Encoding_DefaultJson = 15093,
    FindServersResponse_Encoding_DefaultJson = 15094,
    ServerOnNetwork_Encoding_DefaultJson = 15095,
    FindServersOnNetworkRequest_Encoding_DefaultJson = 15096,
    FindServersOnNetworkResponse_Encoding_DefaultJson = 15097,
    UserTokenPolicy_Encoding_DefaultJson = 15098,
    EndpointDescription_Encoding_DefaultJson = 15099,
    GetEndpointsRequest_Encoding_DefaultJson = 15100,
    GetEndpointsResponse_Encoding_DefaultJson = 15101,
    RegisteredServer_Encoding_DefaultJson = 15102,
    RegisterServerRequest_Encoding_DefaultJson = 15103,
    RegisterServerResponse_Encoding_DefaultJson = 15104,
    DiscoveryConfiguration_Encoding_DefaultJson = 15105,
    MdnsDiscoveryConfiguration_Encoding_DefaultJson = 15106,
    RegisterServer2Request_Encoding_DefaultJson = 15107,
    RegisterServer2Response_Encoding_DefaultJson = 15130,
    ChannelSecurityToken_Encoding_DefaultJson = 15131,
    OpenSecureChannelRequest_Encoding_DefaultJson = 15132,
    OpenSecureChannelResponse_Encoding_DefaultJson = 15133,
    CloseSecureChannelRequest_Encoding_DefaultJson = 15134,
    CloseSecureChannelResponse_Encoding_DefaultJson = 15135,
    SignedSoftwareCertificate_Encoding_DefaultJson = 15136,
    SignatureData_Encoding_DefaultJson = 15137,
    CreateSessionRequest_Encoding_DefaultJson = 15138,
    CreateSessionResponse_Encoding_DefaultJson = 15139,
    UserIdentityToken_Encoding_DefaultJson = 15140,
    AnonymousIdentityToken_Encoding_DefaultJson = 15141,
    UserNameIdentityToken_Encoding_DefaultJson = 15142,
    X509IdentityToken_Encoding_DefaultJson = 15143,
    IssuedIdentityToken_Encoding_DefaultJson = 15144,
    ActivateSessionRequest_Encoding_DefaultJson = 15145,
    ActivateSessionResponse_Encoding_DefaultJson = 15146,
    CloseSessionRequest_Encoding_DefaultJson = 15147,
    CloseSessionResponse_Encoding_DefaultJson = 15148,
    CancelRequest_Encoding_DefaultJson = 15149,
    CancelResponse_Encoding_DefaultJson = 15150,
    NodeAttributes_Encoding_DefaultJson = 15151,
    ObjectAttributes_Encoding_DefaultJson = 15152,
    VariableAttributes_Encoding_DefaultJson = 15153,
    MethodAttributes_Encoding_DefaultJson = 15157,
    ObjectTypeAttributes_Encoding_DefaultJson = 15158,
    VariableTypeAttributes_Encoding_DefaultJson = 15159,
    ReferenceTypeAttributes_Encoding_DefaultJson = 15160,
    DataTypeAttributes_Encoding_DefaultJson = 15161,
    ViewAttributes_Encoding_DefaultJson = 15162,
    GenericAttributeValue_Encoding_DefaultJson = 15163,
    GenericAttributes_Encoding_DefaultJson = 15164,
    AddNodesItem_Encoding_DefaultJson = 15165,
    AddNodesResult_Encoding_DefaultJson = 15166,
    AddNodesRequest_Encoding_DefaultJson = 15167,
    AddNodesResponse_Encoding_DefaultJson = 15168,
    AddReferencesItem_Encoding_DefaultJson = 15169,
    AddReferencesRequest_Encoding_DefaultJson = 15170,
    AddReferencesResponse_Encoding_DefaultJson = 15171,
    DeleteNodesItem_Encoding_DefaultJson = 15172,
    DeleteNodesRequest_Encoding_DefaultJson = 15173,
    DeleteNodesResponse_Encoding_DefaultJson = 15174,
    DeleteReferencesItem_Encoding_DefaultJson = 15175,
    DeleteReferencesRequest_Encoding_DefaultJson = 15176,
    DeleteReferencesResponse_Encoding_DefaultJson = 15177,
    ViewDescription_Encoding_DefaultJson = 15179,
    BrowseDescription_Encoding_DefaultJson = 15180,
    ReferenceDescription_Encoding_DefaultJson = 15182,
    BrowseResult_Encoding_DefaultJson = 15183,
    BrowseRequest_Encoding_DefaultJson = 15184,
    BrowseResponse_Encoding_DefaultJson = 15185,
    BrowseNextRequest_Encoding_DefaultJson = 15186,
    BrowseNextResponse_Encoding_DefaultJson = 15187,
    RelativePathElement_Encoding_DefaultJson = 15188,
    RelativePath_Encoding_DefaultJson = 15189,
    BrowsePath_Encoding_DefaultJson = 15190,
    BrowsePathTarget_Encoding_DefaultJson = 15191,
    BrowsePathResult_Encoding_DefaultJson = 15192,
    TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultJson = 15193,
    TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultJson = 15194,
    RegisterNodesRequest_Encoding_DefaultJson = 15195,
    RegisterNodesResponse_Encoding_DefaultJson = 15196,
    UnregisterNodesRequest_Encoding_DefaultJson = 15197,
    UnregisterNodesResponse_Encoding_DefaultJson = 15198,
    EndpointConfiguration_Encoding_DefaultJson = 15199,
    QueryDataDescription_Encoding_DefaultJson = 15200,
    NodeTypeDescription_Encoding_DefaultJson = 15201,
    QueryDataSet_Encoding_DefaultJson = 15202,
    NodeReference_Encoding_DefaultJson = 15203,
    ContentFilterElement_Encoding_DefaultJson = 15204,
    ContentFilter_Encoding_DefaultJson = 15205,
    FilterOperand_Encoding_DefaultJson = 15206,
    ElementOperand_Encoding_DefaultJson = 15207,
    LiteralOperand_Encoding_DefaultJson = 15208,
    AttributeOperand_Encoding_DefaultJson = 15209,
    SimpleAttributeOperand_Encoding_DefaultJson = 15210,
    ContentFilterElementResult_Encoding_DefaultJson = 15211,
    PublishedDataSetType_DataSetWriterName_Placeholder = 15222,
    PublishedDataSetType_DataSetWriterName_Placeholder_Status = 15223,
    PublishedDataSetType_DataSetWriterName_Placeholder_TransportSettings = 15227,
    ContentFilterResult_Encoding_DefaultJson = 15228,
    PublishedDataItemsType_DataSetWriterName_Placeholder = 15230,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Status = 15231,
    PublishedDataItemsType_DataSetWriterName_Placeholder_TransportSettings = 15235,
    ParsingResult_Encoding_DefaultJson = 15236,
    PublishedEventsType_DataSetWriterName_Placeholder = 15238,
    PublishedEventsType_DataSetWriterName_Placeholder_Status = 15239,
    PublishedEventsType_DataSetWriterName_Placeholder_TransportSettings = 15243,
    QueryFirstRequest_Encoding_DefaultJson = 15244,
    QueryFirstResponse_Encoding_DefaultJson = 15252,
    QueryNextRequest_Encoding_DefaultJson = 15254,
    QueryNextResponse_Encoding_DefaultJson = 15255,
    ReadValueId_Encoding_DefaultJson = 15256,
    ReadRequest_Encoding_DefaultJson = 15257,
    ReadResponse_Encoding_DefaultJson = 15258,
    HistoryReadValueId_Encoding_DefaultJson = 15259,
    HistoryReadResult_Encoding_DefaultJson = 15260,
    HistoryReadDetails_Encoding_DefaultJson = 15261,
    ReadEventDetails_Encoding_DefaultJson = 15262,
    ReadRawModifiedDetails_Encoding_DefaultJson = 15263,
    ReadProcessedDetails_Encoding_DefaultJson = 15264,
    PubSubGroupType_Status = 15265,
    ReadAtTimeDetails_Encoding_DefaultJson = 15269,
    HistoryData_Encoding_DefaultJson = 15270,
    ModificationInfo_Encoding_DefaultJson = 15271,
    HistoryModifiedData_Encoding_DefaultJson = 15272,
    HistoryEvent_Encoding_DefaultJson = 15273,
    HistoryReadRequest_Encoding_DefaultJson = 15274,
    HistoryReadResponse_Encoding_DefaultJson = 15275,
    WriteValue_Encoding_DefaultJson = 15276,
    WriteRequest_Encoding_DefaultJson = 15277,
    WriteResponse_Encoding_DefaultJson = 15278,
    HistoryUpdateDetails_Encoding_DefaultJson = 15279,
    UpdateDataDetails_Encoding_DefaultJson = 15280,
    UpdateStructureDataDetails_Encoding_DefaultJson = 15281,
    UpdateEventDetails_Encoding_DefaultJson = 15282,
    DeleteRawModifiedDetails_Encoding_DefaultJson = 15283,
    DeleteAtTimeDetails_Encoding_DefaultJson = 15284,
    DeleteEventDetails_Encoding_DefaultJson = 15285,
    HistoryUpdateResult_Encoding_DefaultJson = 15286,
    HistoryUpdateRequest_Encoding_DefaultJson = 15287,
    HistoryUpdateResponse_Encoding_DefaultJson = 15288,
    CallMethodRequest_Encoding_DefaultJson = 15289,
    CallMethodResult_Encoding_DefaultJson = 15290,
    CallRequest_Encoding_DefaultJson = 15291,
    CallResponse_Encoding_DefaultJson = 15292,
    MonitoringFilter_Encoding_DefaultJson = 15293,
    DataChangeFilter_Encoding_DefaultJson = 15294,
    EventFilter_Encoding_DefaultJson = 15295,
    DataSetWriterType_Status = 15299,
    DataSetWriterType_TransportSettings = 15303,
    AggregateConfiguration_Encoding_DefaultJson = 15304,
    DataSetReaderType_Status = 15307,
    DataSetReaderType_TransportSettings = 15311,
    AggregateFilter_Encoding_DefaultJson = 15312,
    MonitoringFilterResult_Encoding_DefaultJson = 15313,
    EventFilterResult_Encoding_DefaultJson = 15314,
    AggregateFilterResult_Encoding_DefaultJson = 15315,
    DataSetReaderType_SubscribedDataSet = 15316,
    MonitoringParameters_Encoding_DefaultJson = 15320,
    MonitoredItemCreateRequest_Encoding_DefaultJson = 15321,
    MonitoredItemCreateResult_Encoding_DefaultJson = 15322,
    CreateMonitoredItemsRequest_Encoding_DefaultJson = 15323,
    CreateMonitoredItemsResponse_Encoding_DefaultJson = 15324,
    MonitoredItemModifyRequest_Encoding_DefaultJson = 15325,
    MonitoredItemModifyResult_Encoding_DefaultJson = 15326,
    ModifyMonitoredItemsRequest_Encoding_DefaultJson = 15327,
    ModifyMonitoredItemsResponse_Encoding_DefaultJson = 15328,
    SetMonitoringModeRequest_Encoding_DefaultJson = 15329,
    SetMonitoringModeResponse_Encoding_DefaultJson = 15331,
    SetTriggeringRequest_Encoding_DefaultJson = 15332,
    SetTriggeringResponse_Encoding_DefaultJson = 15333,
    DeleteMonitoredItemsRequest_Encoding_DefaultJson = 15335,
    DeleteMonitoredItemsResponse_Encoding_DefaultJson = 15336,
    CreateSubscriptionRequest_Encoding_DefaultJson = 15337,
    CreateSubscriptionResponse_Encoding_DefaultJson = 15338,
    ModifySubscriptionRequest_Encoding_DefaultJson = 15339,
    ModifySubscriptionResponse_Encoding_DefaultJson = 15340,
    SetPublishingModeRequest_Encoding_DefaultJson = 15341,
    SetPublishingModeResponse_Encoding_DefaultJson = 15342,
    NotificationMessage_Encoding_DefaultJson = 15343,
    NotificationData_Encoding_DefaultJson = 15344,
    DataChangeNotification_Encoding_DefaultJson = 15345,
    MonitoredItemNotification_Encoding_DefaultJson = 15346,
    EventNotificationList_Encoding_DefaultJson = 15347,
    EventFieldList_Encoding_DefaultJson = 15348,
    HistoryEventFieldList_Encoding_DefaultJson = 15349,
    StatusChangeNotification_Encoding_DefaultJson = 15350,
    SubscriptionAcknowledgement_Encoding_DefaultJson = 15351,
    PublishRequest_Encoding_DefaultJson = 15352,
    PublishResponse_Encoding_DefaultJson = 15353,
    RepublishRequest_Encoding_DefaultJson = 15354,
    RepublishResponse_Encoding_DefaultJson = 15355,
    TransferResult_Encoding_DefaultJson = 15356,
    TransferSubscriptionsRequest_Encoding_DefaultJson = 15357,
    TransferSubscriptionsResponse_Encoding_DefaultJson = 15358,
    DeleteSubscriptionsRequest_Encoding_DefaultJson = 15359,
    DeleteSubscriptionsResponse_Encoding_DefaultJson = 15360,
    BuildInfo_Encoding_DefaultJson = 15361,
    RedundantServerDataType_Encoding_DefaultJson = 15362,
    EndpointUrlListDataType_Encoding_DefaultJson = 15363,
    NetworkGroupDataType_Encoding_DefaultJson = 15364,
    SamplingIntervalDiagnosticsDataType_Encoding_DefaultJson = 15365,
    ServerDiagnosticsSummaryDataType_Encoding_DefaultJson = 15366,
    ServerStatusDataType_Encoding_DefaultJson = 15367,
    SessionDiagnosticsDataType_Encoding_DefaultJson = 15368,
    SessionSecurityDiagnosticsDataType_Encoding_DefaultJson = 15369,
    ServiceCounterDataType_Encoding_DefaultJson = 15370,
    StatusResult_Encoding_DefaultJson = 15371,
    SubscriptionDiagnosticsDataType_Encoding_DefaultJson = 15372,
    ModelChangeStructureDataType_Encoding_DefaultJson = 15373,
    SemanticChangeStructureDataType_Encoding_DefaultJson = 15374,
    Range_Encoding_DefaultJson = 15375,
    EUInformation_Encoding_DefaultJson = 15376,
    ComplexNumberType_Encoding_DefaultJson = 15377,
    DoubleComplexNumberType_Encoding_DefaultJson = 15378,
    AxisInformation_Encoding_DefaultJson = 15379,
    XVType_Encoding_DefaultJson = 15380,
    ProgramDiagnosticDataType_Encoding_DefaultJson = 15381,
    Annotation_Encoding_DefaultJson = 15382,
    ProgramDiagnostic2DataType_Encoding_DefaultBinary = 15397,
    ProgramDiagnostic2DataType_Encoding_DefaultJson = 15405,
    SimpleTypeDescription_Encoding_DefaultBinary = 15421,
    UABinaryFileDataType_Encoding_DefaultBinary = 15422,
    PublishSubscribeType_SecurityGroups = 15434,
    PublishSubscribe_SecurityGroups = 15443,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder = 15453,
    SecurityGroupFolderType_SecurityGroupName_Placeholder = 15459,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields = 15473,
    BrokerConnectionTransportDataType_Encoding_DefaultBinary = 15479,
    PublishedDataSetType_ExtensionFields = 15481,
    PublishedDataItemsType_ExtensionFields = 15503,
    PublishedEventsType_ExtensionFields = 15511,
    Server_ServerCapabilities_RoleSet = 15606,
    RoleSetType_RoleName_Placeholder = 15608,
    WellKnownRole_Anonymous = 15644,
    WellKnownRole_AuthenticatedUser = 15656,
    WellKnownRole_Observer = 15668,
    EndpointType_Encoding_DefaultBinary = 15671,
    DataTypeSchemaHeader_Encoding_DefaultBinary = 15676,
    PublishedDataSetDataType_Encoding_DefaultBinary = 15677,
    PublishedDataSetSourceDataType_Encoding_DefaultBinary = 15678,
    PublishedDataItemsDataType_Encoding_DefaultBinary = 15679,
    WellKnownRole_Operator = 15680,
    PublishedEventsDataType_Encoding_DefaultBinary = 15681,
    DataSetWriterDataType_Encoding_DefaultBinary = 15682,
    DataSetWriterTransportDataType_Encoding_DefaultBinary = 15683,
    DataSetWriterMessageDataType_Encoding_DefaultBinary = 15688,
    PubSubGroupDataType_Encoding_DefaultBinary = 15689,
    WriterGroupTransportDataType_Encoding_DefaultBinary = 15691,
    WellKnownRole_Supervisor = 15692,
    WriterGroupMessageDataType_Encoding_DefaultBinary = 15693,
    PubSubConnectionDataType_Encoding_DefaultBinary = 15694,
    ConnectionTransportDataType_Encoding_DefaultBinary = 15695,
    SimpleTypeDescription_Encoding_DefaultJson = 15700,
    ReaderGroupTransportDataType_Encoding_DefaultBinary = 15701,
    ReaderGroupMessageDataType_Encoding_DefaultBinary = 15702,
    DataSetReaderDataType_Encoding_DefaultBinary = 15703,
    WellKnownRole_SecurityAdmin = 15704,
    DataSetReaderTransportDataType_Encoding_DefaultBinary = 15705,
    DataSetReaderMessageDataType_Encoding_DefaultBinary = 15706,
    SubscribedDataSetDataType_Encoding_DefaultBinary = 15707,
    TargetVariablesDataType_Encoding_DefaultBinary = 15712,
    SubscribedDataSetMirrorDataType_Encoding_DefaultBinary = 15713,
    UABinaryFileDataType_Encoding_DefaultJson = 15714,
    UadpWriterGroupMessageDataType_Encoding_DefaultBinary = 15715,
    WellKnownRole_ConfigureAdmin = 15716,
    UadpDataSetWriterMessageDataType_Encoding_DefaultBinary = 15717,
    UadpDataSetReaderMessageDataType_Encoding_DefaultBinary = 15718,
    JsonWriterGroupMessageDataType_Encoding_DefaultBinary = 15719,
    JsonDataSetWriterMessageDataType_Encoding_DefaultBinary = 15724,
    JsonDataSetReaderMessageDataType_Encoding_DefaultBinary = 15725,
    BrokerConnectionTransportDataType_Encoding_DefaultJson = 15726,
    BrokerWriterGroupTransportDataType_Encoding_DefaultBinary = 15727,
    BrokerDataSetWriterTransportDataType_Encoding_DefaultBinary = 15729,
    BrokerDataSetReaderTransportDataType_Encoding_DefaultBinary = 15733,
    IdentityMappingRuleType_Encoding_DefaultBinary = 15736,
    TemporaryFileTransferType_TransferState_Placeholder = 15754,
    PublishSubscribe_ConnectionName_Placeholder = 15790,
    FileTransferStateMachineType_Idle = 15815,
    FileTransferStateMachineType_ReadPrepare = 15817,
    FileTransferStateMachineType_ReadTransfer = 15819,
    FileTransferStateMachineType_ApplyWrite = 15821,
    FileTransferStateMachineType_Error = 15823,
    FileTransferStateMachineType_IdleToReadPrepare = 15825,
    FileTransferStateMachineType_ReadPrepareToReadTransfer = 15827,
    FileTransferStateMachineType_ReadTransferToIdle = 15829,
    FileTransferStateMachineType_IdleToApplyWrite = 15831,
    FileTransferStateMachineType_ApplyWriteToIdle = 15833,
    FileTransferStateMachineType_ReadPrepareToError = 15835,
    FileTransferStateMachineType_ReadTransferToError = 15837,
    FileTransferStateMachineType_ApplyWriteToError = 15839,
    FileTransferStateMachineType_ErrorToIdle = 15841,
    PublishSubscribeType_Status = 15844,
    PublishSubscribe_ConnectionName_Placeholder_Address = 15851,
    PublishSubscribe_ConnectionName_Placeholder_TransportSettings = 15864,
    PublishSubscribe_ConnectionName_Placeholder_Status = 15865,
    SessionlessInvokeRequestType_Encoding_DefaultBinary = 15903,
    PublishSubscribeType_ConnectionName_Placeholder_TransportSettings = 15905,
    PubSubKeyServiceType_SecurityGroups = 15913,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics = 15937,
    OPCUANamespaceMetadata = 15957,
    OPCUANamespaceMetadata_NamespaceFile = 15965,
    WellKnownRole_Engineer = 16036,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters = 16102,
    EndpointType_Encoding_DefaultJson = 16150,
    DataTypeSchemaHeader_Encoding_DefaultJson = 16151,
    PublishedDataSetDataType_Encoding_DefaultJson = 16152,
    PublishedDataSetSourceDataType_Encoding_DefaultJson = 16153,
    PublishedDataItemsDataType_Encoding_DefaultJson = 16154,
    PublishedEventsDataType_Encoding_DefaultJson = 16155,
    DataSetWriterDataType_Encoding_DefaultJson = 16156,
    DataSetWriterTransportDataType_Encoding_DefaultJson = 16157,
    DataSetWriterMessageDataType_Encoding_DefaultJson = 16158,
    PubSubGroupDataType_Encoding_DefaultJson = 16159,
    WriterGroupTransportDataType_Encoding_DefaultJson = 16161,
    WriterGroupMessageDataType_Encoding_DefaultJson = 16280,
    PubSubConnectionDataType_Encoding_DefaultJson = 16281,
    ConnectionTransportDataType_Encoding_DefaultJson = 16282,
    ReaderGroupTransportDataType_Encoding_DefaultJson = 16284,
    ReaderGroupMessageDataType_Encoding_DefaultJson = 16285,
    DataSetReaderDataType_Encoding_DefaultJson = 16286,
    DataSetReaderTransportDataType_Encoding_DefaultJson = 16287,
    DataSetReaderMessageDataType_Encoding_DefaultJson = 16288,
    ServerType_ServerCapabilities_RoleSet = 16289,
    ServerCapabilitiesType_RoleSet = 16295,
    SubscribedDataSetDataType_Encoding_DefaultJson = 16308,
    TargetVariablesDataType_Encoding_DefaultJson = 16310,
    SubscribedDataSetMirrorDataType_Encoding_DefaultJson = 16311,
    FileSystem = 16314,
    FileSystem_FileDirectoryName_Placeholder = 16315,
    UadpWriterGroupMessageDataType_Encoding_DefaultJson = 16323,
    FileSystem_FileName_Placeholder = 16327,
    UadpDataSetWriterMessageDataType_Encoding_DefaultJson = 16391,
    UadpDataSetReaderMessageDataType_Encoding_DefaultJson = 16392,
    JsonWriterGroupMessageDataType_Encoding_DefaultJson = 16393,
    JsonDataSetWriterMessageDataType_Encoding_DefaultJson = 16394,
    AlarmConditionType_FirstInGroup = 16398,
    AlarmConditionType_AlarmGroup_Placeholder = 16399,
    JsonDataSetReaderMessageDataType_Encoding_DefaultJson = 16404,
    AlarmGroupType_AlarmConditionInstance_Placeholder = 16406,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState = 16502,
    BrokerWriterGroupTransportDataType_Encoding_DefaultJson = 16524,
    BrokerDataSetWriterTransportDataType_Encoding_DefaultJson = 16525,
    BrokerDataSetReaderTransportDataType_Encoding_DefaultJson = 16526,
    AlarmGroupType_AlarmConditionInstance_Placeholder_FirstInGroup = 16530,
    LimitAlarmType_FirstInGroup = 16565,
    LimitAlarmType_AlarmGroup_Placeholder = 16566,
    ExclusiveLimitAlarmType_FirstInGroup = 16605,
    ExclusiveLimitAlarmType_AlarmGroup_Placeholder = 16606,
    NonExclusiveLimitAlarmType_FirstInGroup = 16645,
    NonExclusiveLimitAlarmType_AlarmGroup_Placeholder = 16646,
    NonExclusiveLevelAlarmType_FirstInGroup = 16685,
    NonExclusiveLevelAlarmType_AlarmGroup_Placeholder = 16686,
    ExclusiveLevelAlarmType_FirstInGroup = 16725,
    ExclusiveLevelAlarmType_AlarmGroup_Placeholder = 16726,
    PublishedDataSetType_DataSetWriterName_Placeholder_MessageSettings = 16758,
    NonExclusiveDeviationAlarmType_FirstInGroup = 16765,
    NonExclusiveDeviationAlarmType_AlarmGroup_Placeholder = 16766,
    PublishedDataItemsType_DataSetWriterName_Placeholder_MessageSettings = 16799,
    ExclusiveDeviationAlarmType_FirstInGroup = 16806,
    ExclusiveDeviationAlarmType_AlarmGroup_Placeholder = 16807,
    PublishedEventsType_DataSetWriterName_Placeholder_MessageSettings = 16840,
    NonExclusiveRateOfChangeAlarmType_FirstInGroup = 16847,
    NonExclusiveRateOfChangeAlarmType_AlarmGroup_Placeholder = 16848,
    ExclusiveRateOfChangeAlarmType_FirstInGroup = 16888,
    ExclusiveRateOfChangeAlarmType_AlarmGroup_Placeholder = 16889,
    DiscreteAlarmType_FirstInGroup = 16929,
    DiscreteAlarmType_AlarmGroup_Placeholder = 16930,
    OffNormalAlarmType_FirstInGroup = 16965,
    OffNormalAlarmType_AlarmGroup_Placeholder = 16966,
    SystemOffNormalAlarmType_FirstInGroup = 17001,
    SystemOffNormalAlarmType_AlarmGroup_Placeholder = 17002,
    TripAlarmType_FirstInGroup = 17037,
    TripAlarmType_AlarmGroup_Placeholder = 17038,
    CertificateExpirationAlarmType_FirstInGroup = 17073,
    CertificateExpirationAlarmType_AlarmGroup_Placeholder = 17074,
    DiscrepancyAlarmType_ShelvingState = 17180,
    PubSubConnectionType_TransportSettings = 17203,
    DiscrepancyAlarmType_FirstInGroup = 17208,
    DiscrepancyAlarmType_AlarmGroup_Placeholder = 17209,
    PubSubConnectionType_WriterGroupName_Placeholder_TransportSettings = 17290,
    PubSubConnectionType_WriterGroupName_Placeholder_MessageSettings = 17291,
    PubSubConnectionType_ReaderGroupName_Placeholder_TransportSettings = 17307,
    PubSubConnectionType_ReaderGroupName_Placeholder_MessageSettings = 17308,
    PubSubConnectionType_WriterGroupName_Placeholder = 17310,
    PubSubConnectionType_WriterGroupName_Placeholder_Status = 17314,
    PubSubConnectionType_ReaderGroupName_Placeholder = 17325,
    PubSubConnectionType_ReaderGroupName_Placeholder_Status = 17329,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues = 17352,
    PublishSubscribe_PublishedDataSets = 17371,
    PublishSubscribe_Status = 17405,
    PublishSubscribe_Diagnostics = 17409,
    PublishSubscribe_Diagnostics_Counters = 17423,
    PublishSubscribe_Diagnostics_LiveValues = 17457,
    DatagramConnectionTransportDataType_Encoding_DefaultBinary = 17468,
    DatagramConnectionTransportDataType_Encoding_DefaultJson = 17476,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder = 17511,
    AdditionalParametersType_Encoding_DefaultBinary = 17537,
    AdditionalParametersType_Encoding_DefaultJson = 17547,
    EphemeralKeyType_Encoding_DefaultBinary = 17549,
    EphemeralKeyType_Encoding_DefaultJson = 17557,
    DictionaryEntryType_DictionaryEntryName_Placeholder = 17590,
    DictionaryFolderType_DictionaryFolderName_Placeholder = 17592,
    DictionaryFolderType_DictionaryEntryName_Placeholder = 17593,
    Dictionaries = 17594,
    Dictionaries_DictionaryFolderName_Placeholder = 17595,
    Dictionaries_DictionaryEntryName_Placeholder = 17596,
    IrdiDictionaryEntryType_DictionaryEntryName_Placeholder = 17599,
    UriDictionaryEntryType_DictionaryEntryName_Placeholder = 17601,
    GenericAttributeValue_Encoding_DefaultBinary = 17610,
    GenericAttributes_Encoding_DefaultBinary = 17611,
    InterfaceTypes = 17708,
    WriterGroupType_Status = 17730,
    AuthorizationServices = 17732,
    WriterGroupType_TransportSettings = 17741,
    WriterGroupType_MessageSettings = 17742,
    WriterGroupType_DataSetWriterName_Placeholder = 17743,
    WriterGroupType_DataSetWriterName_Placeholder_TransportSettings = 17747,
    WriterGroupType_DataSetWriterName_Placeholder_MessageSettings = 17748,
    WriterGroupType_DataSetWriterName_Placeholder_Status = 17749,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics = 17753,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters = 17767,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues = 17798,
    WriterGroupType_Diagnostics = 17812,
    WriterGroupType_Diagnostics_Counters = 17826,
    WriterGroupType_Diagnostics_LiveValues = 17858,
    DecimalDataType_Encoding_DefaultBinary = 17863,
    ReaderGroupType_Status = 18067,
    ReaderGroupType_DataSetReaderName_Placeholder = 18076,
    ReaderGroupType_DataSetReaderName_Placeholder_TransportSettings = 18086,
    ReaderGroupType_DataSetReaderName_Placeholder_MessageSettings = 18087,
    ReaderGroupType_DataSetReaderName_Placeholder_Status = 18088,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics = 18092,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters = 18106,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues = 18137,
    KeyCredentialConfiguration = 18155,
    KeyCredentialConfiguration_ServiceName_Placeholder = 18156,
    InstrumentDiagnosticAlarmType_ShelvingState = 18438,
    InstrumentDiagnosticAlarmType_FirstInGroup = 18476,
    InstrumentDiagnosticAlarmType_AlarmGroup_Placeholder = 18486,
    SystemDiagnosticAlarmType_ShelvingState = 18587,
    SystemDiagnosticAlarmType_FirstInGroup = 18625,
    SystemDiagnosticAlarmType_AlarmGroup_Placeholder = 18635,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics = 18667,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters = 18681,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues = 18712,
    PublishSubscribeType_Diagnostics = 18715,
    PublishSubscribeType_Diagnostics_Counters = 18729,
    PublishSubscribeType_Diagnostics_LiveValues = 18760,
    RationalNumber_Encoding_DefaultBinary = 18815,
    Vector_Encoding_DefaultBinary = 18816,
    ThreeDVector_Encoding_DefaultBinary = 18817,
    CartesianCoordinates_Encoding_DefaultBinary = 18818,
    ThreeDCartesianCoordinates_Encoding_DefaultBinary = 18819,
    Orientation_Encoding_DefaultBinary = 18820,
    ThreeDOrientation_Encoding_DefaultBinary = 18821,
    Frame_Encoding_DefaultBinary = 18822,
    ThreeDFrame_Encoding_DefaultBinary = 18823,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics = 18871,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters = 18885,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues = 18916,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics = 18930,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters = 18944,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues = 18975,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics = 18989,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters = 19003,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues = 19034,
    RationalNumber_Encoding_DefaultJson = 19064,
    Vector_Encoding_DefaultJson = 19065,
    ThreeDVector_Encoding_DefaultJson = 19066,
    CartesianCoordinates_Encoding_DefaultJson = 19067,
    ThreeDCartesianCoordinates_Encoding_DefaultJson = 19068,
    Orientation_Encoding_DefaultJson = 19069,
    ThreeDOrientation_Encoding_DefaultJson = 19070,
    Frame_Encoding_DefaultJson = 19071,
    ThreeDFrame_Encoding_DefaultJson = 19072,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics = 19107,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters = 19121,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues = 19152,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics = 19176,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters = 19190,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues = 19221,
    PubSubConnectionType_Diagnostics = 19241,
    PubSubConnectionType_Diagnostics_Counters = 19255,
    PubSubConnectionType_Diagnostics_LiveValues = 19286,
    TrustListOutOfDateAlarmType_ShelvingState = 19388,
    TrustListOutOfDateAlarmType_FirstInGroup = 19426,
    TrustListOutOfDateAlarmType_AlarmGroup_Placeholder = 19436,
    CertificateGroupType_CertificateExpired = 19450,
    CertificateGroupType_CertificateExpired_ShelvingState = 19537,
    DataSetWriterType_Diagnostics = 19550,
    DataSetWriterType_Diagnostics_Counters = 19564,
    DataSetWriterType_Diagnostics_LiveValues = 19595,
    DataSetReaderType_Diagnostics = 19609,
    DataSetReaderType_Diagnostics_Counters = 19623,
    DataSetReaderType_Diagnostics_LiveValues = 19654,
    PubSubDiagnosticsType_Counters = 19691,
    PubSubDiagnosticsType_LiveValues = 19722,
    PubSubDiagnosticsRootType_Counters = 19746,
    PubSubDiagnosticsRootType_LiveValues = 19777,
    PubSubDiagnosticsConnectionType_Counters = 19800,
    PubSubDiagnosticsConnectionType_LiveValues = 19831,
    PubSubDiagnosticsWriterGroupType_Counters = 19848,
    PubSubDiagnosticsWriterGroupType_LiveValues = 19879,
    PubSubDiagnosticsReaderGroupType_Counters = 19917,
    PubSubDiagnosticsReaderGroupType_LiveValues = 19948,
    PubSubDiagnosticsDataSetWriterType_Counters = 19982,
    PubSubDiagnosticsDataSetWriterType_LiveValues = 20013,
    PubSubDiagnosticsDataSetReaderType_Counters = 20041,
    PubSubDiagnosticsDataSetReaderType_LiveValues = 20072,
    CertificateGroupType_CertificateExpired_FirstInGroup = 20120,
    CertificateGroupType_TrustListOutOfDate = 20143,
    CertificateGroupType_TrustListOutOfDate_ShelvingState = 20230,
    CertificateGroupType_TrustListOutOfDate_FirstInGroup = 20268,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired = 20291,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState = 20378,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_FirstInGroup = 20418,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate = 20441,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState = 20528,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup = 20566,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired = 20589,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState = 20676,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_FirstInGroup = 20714,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate = 20737,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState = 20824,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup = 20862,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired = 20885,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState = 20972,
    SessionlessInvokeResponseType_Encoding_DefaultBinary = 21001,
    ReaderGroupType_DataSetReaderName_Placeholder_SubscribedDataSet = 21006,
    ReaderGroupType_Diagnostics = 21015,
    ReaderGroupType_Diagnostics_Counters = 21029,
    ReaderGroupType_Diagnostics_LiveValues = 21060,
    ReaderGroupType_TransportSettings = 21080,
    ReaderGroupType_MessageSettings = 21081,
    DataSetWriterType_MessageSettings = 21095,
    DataSetReaderType_MessageSettings = 21103,
    WriterGroupDataType_Encoding_DefaultBinary = 21150,
    NetworkAddressDataType_Encoding_DefaultBinary = 21151,
    NetworkAddressUrlDataType_Encoding_DefaultBinary = 21152,
    ReaderGroupDataType_Encoding_DefaultBinary = 21153,
    PubSubConfigurationDataType_Encoding_DefaultBinary = 21154,
    DatagramWriterGroupTransportDataType_Encoding_DefaultBinary = 21155,
    WriterGroupDataType_Encoding_DefaultJson = 21198,
    NetworkAddressDataType_Encoding_DefaultJson = 21199,
    NetworkAddressUrlDataType_Encoding_DefaultJson = 21200,
    ReaderGroupDataType_Encoding_DefaultJson = 21201,
    PubSubConfigurationDataType_Encoding_DefaultJson = 21202,
    DatagramWriterGroupTransportDataType_Encoding_DefaultJson = 21203,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_FirstInGroup = 21213,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate = 21236,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState = 21323,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup = 21361,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired = 21384,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState = 21471,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_FirstInGroup = 21509,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate = 21532,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState = 21619,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_FirstInGroup = 21657,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired = 21680,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState =
        21767,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup =
        21805,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate = 21828,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState =
        21915,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup =
        21953,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired = 21976,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState =
        22063,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup =
        22101,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate = 22124,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState =
        22211,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup =
        22249,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired = 22272,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState =
        22359,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup =
        22397,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate = 22420,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState =
        22507,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup =
        22545,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired = 22568,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState =
        22655,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup =
        22693,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate = 22716,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState =
        22803,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup =
        22841,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired = 22864,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState =
        22951,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup = 22989,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate = 23012,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState =
        23099,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup = 23137,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired = 23160,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState =
        23247,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup =
        23285,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate = 23308,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState =
        23395,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup =
        23433,
    AliasNameCategoryType_Alias_Placeholder = 23457,
    AliasNameCategoryType_SubAliasNameCategories_Placeholder = 23458,
    Aliases = 23470,
    Aliases_Alias_Placeholder = 23471,
    Aliases_SubAliasNameCategories_Placeholder = 23472,
    TagVariables = 23479,
    TagVariables_Alias_Placeholder = 23480,
    TagVariables_SubAliasNameCategories_Placeholder = 23481,
    Topics = 23488,
    Topics_Alias_Placeholder = 23489,
    Topics_SubAliasNameCategories_Placeholder = 23490,
    AliasNameDataType_Encoding_DefaultBinary = 23499,
    ReadAnnotationDataDetails_Encoding_DefaultBinary = 23500,
    CurrencyUnitType_Encoding_DefaultBinary = 23507,
    AliasNameDataType_Encoding_DefaultJson = 23511,
    ReadAnnotationDataDetails_Encoding_DefaultJson = 23512,
    OrderedListType_OrderedObject_Placeholder = 23519,
    CurrencyUnitType_Encoding_DefaultJson = 23528,
    AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder = 23557,
}

impl<'a> From<&'a ObjectId> for NodeId {
    fn from(r: &'a ObjectId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for ObjectId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for ObjectId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for ObjectId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            78 => Ok(ObjectId::ModellingRule_Mandatory),
            80 => Ok(ObjectId::ModellingRule_Optional),
            83 => Ok(ObjectId::ModellingRule_ExposesItsArray),
            84 => Ok(ObjectId::RootFolder),
            85 => Ok(ObjectId::ObjectsFolder),
            86 => Ok(ObjectId::TypesFolder),
            87 => Ok(ObjectId::ViewsFolder),
            88 => Ok(ObjectId::ObjectTypesFolder),
            89 => Ok(ObjectId::VariableTypesFolder),
            90 => Ok(ObjectId::DataTypesFolder),
            91 => Ok(ObjectId::ReferenceTypesFolder),
            92 => Ok(ObjectId::XmlSchema_TypeSystem),
            93 => Ok(ObjectId::OPCBinarySchema_TypeSystem),
            121 => Ok(ObjectId::DataTypeDefinition_Encoding_DefaultBinary),
            122 => Ok(ObjectId::StructureDefinition_Encoding_DefaultBinary),
            123 => Ok(ObjectId::EnumDefinition_Encoding_DefaultBinary),
            124 => Ok(ObjectId::DataSetMetaDataType_Encoding_DefaultBinary),
            125 => Ok(ObjectId::DataTypeDescription_Encoding_DefaultBinary),
            126 => Ok(ObjectId::StructureDescription_Encoding_DefaultBinary),
            127 => Ok(ObjectId::EnumDescription_Encoding_DefaultBinary),
            128 => Ok(ObjectId::RolePermissionType_Encoding_DefaultBinary),
            260 => Ok(ObjectId::Node_Encoding_DefaultBinary),
            263 => Ok(ObjectId::ObjectNode_Encoding_DefaultBinary),
            266 => Ok(ObjectId::ObjectTypeNode_Encoding_DefaultBinary),
            269 => Ok(ObjectId::VariableNode_Encoding_DefaultBinary),
            272 => Ok(ObjectId::VariableTypeNode_Encoding_DefaultBinary),
            275 => Ok(ObjectId::ReferenceTypeNode_Encoding_DefaultBinary),
            278 => Ok(ObjectId::MethodNode_Encoding_DefaultBinary),
            281 => Ok(ObjectId::ViewNode_Encoding_DefaultBinary),
            284 => Ok(ObjectId::DataTypeNode_Encoding_DefaultBinary),
            287 => Ok(ObjectId::ReferenceNode_Encoding_DefaultBinary),
            298 => Ok(ObjectId::Argument_Encoding_DefaultBinary),
            301 => Ok(ObjectId::StatusResult_Encoding_DefaultBinary),
            306 => Ok(ObjectId::UserTokenPolicy_Encoding_DefaultBinary),
            310 => Ok(ObjectId::ApplicationDescription_Encoding_DefaultBinary),
            314 => Ok(ObjectId::EndpointDescription_Encoding_DefaultBinary),
            318 => Ok(ObjectId::UserIdentityToken_Encoding_DefaultBinary),
            321 => Ok(ObjectId::AnonymousIdentityToken_Encoding_DefaultBinary),
            324 => Ok(ObjectId::UserNameIdentityToken_Encoding_DefaultBinary),
            327 => Ok(ObjectId::X509IdentityToken_Encoding_DefaultBinary),
            333 => Ok(ObjectId::EndpointConfiguration_Encoding_DefaultBinary),
            340 => Ok(ObjectId::BuildInfo_Encoding_DefaultBinary),
            346 => Ok(ObjectId::SignedSoftwareCertificate_Encoding_DefaultBinary),
            351 => Ok(ObjectId::NodeAttributes_Encoding_DefaultBinary),
            354 => Ok(ObjectId::ObjectAttributes_Encoding_DefaultBinary),
            357 => Ok(ObjectId::VariableAttributes_Encoding_DefaultBinary),
            360 => Ok(ObjectId::MethodAttributes_Encoding_DefaultBinary),
            363 => Ok(ObjectId::ObjectTypeAttributes_Encoding_DefaultBinary),
            366 => Ok(ObjectId::VariableTypeAttributes_Encoding_DefaultBinary),
            369 => Ok(ObjectId::ReferenceTypeAttributes_Encoding_DefaultBinary),
            372 => Ok(ObjectId::DataTypeAttributes_Encoding_DefaultBinary),
            375 => Ok(ObjectId::ViewAttributes_Encoding_DefaultBinary),
            378 => Ok(ObjectId::AddNodesItem_Encoding_DefaultBinary),
            381 => Ok(ObjectId::AddReferencesItem_Encoding_DefaultBinary),
            384 => Ok(ObjectId::DeleteNodesItem_Encoding_DefaultBinary),
            387 => Ok(ObjectId::DeleteReferencesItem_Encoding_DefaultBinary),
            391 => Ok(ObjectId::RequestHeader_Encoding_DefaultBinary),
            394 => Ok(ObjectId::ResponseHeader_Encoding_DefaultBinary),
            397 => Ok(ObjectId::ServiceFault_Encoding_DefaultBinary),
            422 => Ok(ObjectId::FindServersRequest_Encoding_DefaultBinary),
            425 => Ok(ObjectId::FindServersResponse_Encoding_DefaultBinary),
            428 => Ok(ObjectId::GetEndpointsRequest_Encoding_DefaultBinary),
            431 => Ok(ObjectId::GetEndpointsResponse_Encoding_DefaultBinary),
            434 => Ok(ObjectId::RegisteredServer_Encoding_DefaultBinary),
            437 => Ok(ObjectId::RegisterServerRequest_Encoding_DefaultBinary),
            440 => Ok(ObjectId::RegisterServerResponse_Encoding_DefaultBinary),
            443 => Ok(ObjectId::ChannelSecurityToken_Encoding_DefaultBinary),
            446 => Ok(ObjectId::OpenSecureChannelRequest_Encoding_DefaultBinary),
            449 => Ok(ObjectId::OpenSecureChannelResponse_Encoding_DefaultBinary),
            452 => Ok(ObjectId::CloseSecureChannelRequest_Encoding_DefaultBinary),
            455 => Ok(ObjectId::CloseSecureChannelResponse_Encoding_DefaultBinary),
            458 => Ok(ObjectId::SignatureData_Encoding_DefaultBinary),
            461 => Ok(ObjectId::CreateSessionRequest_Encoding_DefaultBinary),
            464 => Ok(ObjectId::CreateSessionResponse_Encoding_DefaultBinary),
            467 => Ok(ObjectId::ActivateSessionRequest_Encoding_DefaultBinary),
            470 => Ok(ObjectId::ActivateSessionResponse_Encoding_DefaultBinary),
            473 => Ok(ObjectId::CloseSessionRequest_Encoding_DefaultBinary),
            476 => Ok(ObjectId::CloseSessionResponse_Encoding_DefaultBinary),
            479 => Ok(ObjectId::CancelRequest_Encoding_DefaultBinary),
            482 => Ok(ObjectId::CancelResponse_Encoding_DefaultBinary),
            485 => Ok(ObjectId::AddNodesResult_Encoding_DefaultBinary),
            488 => Ok(ObjectId::AddNodesRequest_Encoding_DefaultBinary),
            491 => Ok(ObjectId::AddNodesResponse_Encoding_DefaultBinary),
            494 => Ok(ObjectId::AddReferencesRequest_Encoding_DefaultBinary),
            497 => Ok(ObjectId::AddReferencesResponse_Encoding_DefaultBinary),
            500 => Ok(ObjectId::DeleteNodesRequest_Encoding_DefaultBinary),
            503 => Ok(ObjectId::DeleteNodesResponse_Encoding_DefaultBinary),
            506 => Ok(ObjectId::DeleteReferencesRequest_Encoding_DefaultBinary),
            509 => Ok(ObjectId::DeleteReferencesResponse_Encoding_DefaultBinary),
            513 => Ok(ObjectId::ViewDescription_Encoding_DefaultBinary),
            516 => Ok(ObjectId::BrowseDescription_Encoding_DefaultBinary),
            520 => Ok(ObjectId::ReferenceDescription_Encoding_DefaultBinary),
            524 => Ok(ObjectId::BrowseResult_Encoding_DefaultBinary),
            527 => Ok(ObjectId::BrowseRequest_Encoding_DefaultBinary),
            530 => Ok(ObjectId::BrowseResponse_Encoding_DefaultBinary),
            533 => Ok(ObjectId::BrowseNextRequest_Encoding_DefaultBinary),
            536 => Ok(ObjectId::BrowseNextResponse_Encoding_DefaultBinary),
            539 => Ok(ObjectId::RelativePathElement_Encoding_DefaultBinary),
            542 => Ok(ObjectId::RelativePath_Encoding_DefaultBinary),
            545 => Ok(ObjectId::BrowsePath_Encoding_DefaultBinary),
            548 => Ok(ObjectId::BrowsePathTarget_Encoding_DefaultBinary),
            551 => Ok(ObjectId::BrowsePathResult_Encoding_DefaultBinary),
            554 => Ok(ObjectId::TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultBinary),
            557 => Ok(ObjectId::TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultBinary),
            560 => Ok(ObjectId::RegisterNodesRequest_Encoding_DefaultBinary),
            563 => Ok(ObjectId::RegisterNodesResponse_Encoding_DefaultBinary),
            566 => Ok(ObjectId::UnregisterNodesRequest_Encoding_DefaultBinary),
            569 => Ok(ObjectId::UnregisterNodesResponse_Encoding_DefaultBinary),
            572 => Ok(ObjectId::QueryDataDescription_Encoding_DefaultBinary),
            575 => Ok(ObjectId::NodeTypeDescription_Encoding_DefaultBinary),
            579 => Ok(ObjectId::QueryDataSet_Encoding_DefaultBinary),
            582 => Ok(ObjectId::NodeReference_Encoding_DefaultBinary),
            585 => Ok(ObjectId::ContentFilterElement_Encoding_DefaultBinary),
            588 => Ok(ObjectId::ContentFilter_Encoding_DefaultBinary),
            591 => Ok(ObjectId::FilterOperand_Encoding_DefaultBinary),
            594 => Ok(ObjectId::ElementOperand_Encoding_DefaultBinary),
            597 => Ok(ObjectId::LiteralOperand_Encoding_DefaultBinary),
            600 => Ok(ObjectId::AttributeOperand_Encoding_DefaultBinary),
            603 => Ok(ObjectId::SimpleAttributeOperand_Encoding_DefaultBinary),
            606 => Ok(ObjectId::ContentFilterElementResult_Encoding_DefaultBinary),
            609 => Ok(ObjectId::ContentFilterResult_Encoding_DefaultBinary),
            612 => Ok(ObjectId::ParsingResult_Encoding_DefaultBinary),
            615 => Ok(ObjectId::QueryFirstRequest_Encoding_DefaultBinary),
            618 => Ok(ObjectId::QueryFirstResponse_Encoding_DefaultBinary),
            621 => Ok(ObjectId::QueryNextRequest_Encoding_DefaultBinary),
            624 => Ok(ObjectId::QueryNextResponse_Encoding_DefaultBinary),
            628 => Ok(ObjectId::ReadValueId_Encoding_DefaultBinary),
            631 => Ok(ObjectId::ReadRequest_Encoding_DefaultBinary),
            634 => Ok(ObjectId::ReadResponse_Encoding_DefaultBinary),
            637 => Ok(ObjectId::HistoryReadValueId_Encoding_DefaultBinary),
            640 => Ok(ObjectId::HistoryReadResult_Encoding_DefaultBinary),
            643 => Ok(ObjectId::HistoryReadDetails_Encoding_DefaultBinary),
            646 => Ok(ObjectId::ReadEventDetails_Encoding_DefaultBinary),
            649 => Ok(ObjectId::ReadRawModifiedDetails_Encoding_DefaultBinary),
            652 => Ok(ObjectId::ReadProcessedDetails_Encoding_DefaultBinary),
            655 => Ok(ObjectId::ReadAtTimeDetails_Encoding_DefaultBinary),
            658 => Ok(ObjectId::HistoryData_Encoding_DefaultBinary),
            661 => Ok(ObjectId::HistoryEvent_Encoding_DefaultBinary),
            664 => Ok(ObjectId::HistoryReadRequest_Encoding_DefaultBinary),
            667 => Ok(ObjectId::HistoryReadResponse_Encoding_DefaultBinary),
            670 => Ok(ObjectId::WriteValue_Encoding_DefaultBinary),
            673 => Ok(ObjectId::WriteRequest_Encoding_DefaultBinary),
            676 => Ok(ObjectId::WriteResponse_Encoding_DefaultBinary),
            679 => Ok(ObjectId::HistoryUpdateDetails_Encoding_DefaultBinary),
            682 => Ok(ObjectId::UpdateDataDetails_Encoding_DefaultBinary),
            685 => Ok(ObjectId::UpdateEventDetails_Encoding_DefaultBinary),
            688 => Ok(ObjectId::DeleteRawModifiedDetails_Encoding_DefaultBinary),
            691 => Ok(ObjectId::DeleteAtTimeDetails_Encoding_DefaultBinary),
            694 => Ok(ObjectId::DeleteEventDetails_Encoding_DefaultBinary),
            697 => Ok(ObjectId::HistoryUpdateResult_Encoding_DefaultBinary),
            700 => Ok(ObjectId::HistoryUpdateRequest_Encoding_DefaultBinary),
            703 => Ok(ObjectId::HistoryUpdateResponse_Encoding_DefaultBinary),
            706 => Ok(ObjectId::CallMethodRequest_Encoding_DefaultBinary),
            709 => Ok(ObjectId::CallMethodResult_Encoding_DefaultBinary),
            712 => Ok(ObjectId::CallRequest_Encoding_DefaultBinary),
            715 => Ok(ObjectId::CallResponse_Encoding_DefaultBinary),
            721 => Ok(ObjectId::MonitoringFilter_Encoding_DefaultBinary),
            724 => Ok(ObjectId::DataChangeFilter_Encoding_DefaultBinary),
            727 => Ok(ObjectId::EventFilter_Encoding_DefaultBinary),
            730 => Ok(ObjectId::AggregateFilter_Encoding_DefaultBinary),
            733 => Ok(ObjectId::MonitoringFilterResult_Encoding_DefaultBinary),
            736 => Ok(ObjectId::EventFilterResult_Encoding_DefaultBinary),
            739 => Ok(ObjectId::AggregateFilterResult_Encoding_DefaultBinary),
            742 => Ok(ObjectId::MonitoringParameters_Encoding_DefaultBinary),
            745 => Ok(ObjectId::MonitoredItemCreateRequest_Encoding_DefaultBinary),
            748 => Ok(ObjectId::MonitoredItemCreateResult_Encoding_DefaultBinary),
            751 => Ok(ObjectId::CreateMonitoredItemsRequest_Encoding_DefaultBinary),
            754 => Ok(ObjectId::CreateMonitoredItemsResponse_Encoding_DefaultBinary),
            757 => Ok(ObjectId::MonitoredItemModifyRequest_Encoding_DefaultBinary),
            760 => Ok(ObjectId::MonitoredItemModifyResult_Encoding_DefaultBinary),
            763 => Ok(ObjectId::ModifyMonitoredItemsRequest_Encoding_DefaultBinary),
            766 => Ok(ObjectId::ModifyMonitoredItemsResponse_Encoding_DefaultBinary),
            769 => Ok(ObjectId::SetMonitoringModeRequest_Encoding_DefaultBinary),
            772 => Ok(ObjectId::SetMonitoringModeResponse_Encoding_DefaultBinary),
            775 => Ok(ObjectId::SetTriggeringRequest_Encoding_DefaultBinary),
            778 => Ok(ObjectId::SetTriggeringResponse_Encoding_DefaultBinary),
            781 => Ok(ObjectId::DeleteMonitoredItemsRequest_Encoding_DefaultBinary),
            784 => Ok(ObjectId::DeleteMonitoredItemsResponse_Encoding_DefaultBinary),
            787 => Ok(ObjectId::CreateSubscriptionRequest_Encoding_DefaultBinary),
            790 => Ok(ObjectId::CreateSubscriptionResponse_Encoding_DefaultBinary),
            793 => Ok(ObjectId::ModifySubscriptionRequest_Encoding_DefaultBinary),
            796 => Ok(ObjectId::ModifySubscriptionResponse_Encoding_DefaultBinary),
            799 => Ok(ObjectId::SetPublishingModeRequest_Encoding_DefaultBinary),
            802 => Ok(ObjectId::SetPublishingModeResponse_Encoding_DefaultBinary),
            805 => Ok(ObjectId::NotificationMessage_Encoding_DefaultBinary),
            808 => Ok(ObjectId::MonitoredItemNotification_Encoding_DefaultBinary),
            811 => Ok(ObjectId::DataChangeNotification_Encoding_DefaultBinary),
            820 => Ok(ObjectId::StatusChangeNotification_Encoding_DefaultBinary),
            823 => Ok(ObjectId::SubscriptionAcknowledgement_Encoding_DefaultBinary),
            826 => Ok(ObjectId::PublishRequest_Encoding_DefaultBinary),
            829 => Ok(ObjectId::PublishResponse_Encoding_DefaultBinary),
            832 => Ok(ObjectId::RepublishRequest_Encoding_DefaultBinary),
            835 => Ok(ObjectId::RepublishResponse_Encoding_DefaultBinary),
            838 => Ok(ObjectId::TransferResult_Encoding_DefaultBinary),
            841 => Ok(ObjectId::TransferSubscriptionsRequest_Encoding_DefaultBinary),
            844 => Ok(ObjectId::TransferSubscriptionsResponse_Encoding_DefaultBinary),
            847 => Ok(ObjectId::DeleteSubscriptionsRequest_Encoding_DefaultBinary),
            850 => Ok(ObjectId::DeleteSubscriptionsResponse_Encoding_DefaultBinary),
            855 => Ok(ObjectId::RedundantServerDataType_Encoding_DefaultBinary),
            858 => Ok(ObjectId::SamplingIntervalDiagnosticsDataType_Encoding_DefaultBinary),
            861 => Ok(ObjectId::ServerDiagnosticsSummaryDataType_Encoding_DefaultBinary),
            864 => Ok(ObjectId::ServerStatusDataType_Encoding_DefaultBinary),
            867 => Ok(ObjectId::SessionDiagnosticsDataType_Encoding_DefaultBinary),
            870 => Ok(ObjectId::SessionSecurityDiagnosticsDataType_Encoding_DefaultBinary),
            873 => Ok(ObjectId::ServiceCounterDataType_Encoding_DefaultBinary),
            876 => Ok(ObjectId::SubscriptionDiagnosticsDataType_Encoding_DefaultBinary),
            879 => Ok(ObjectId::ModelChangeStructureDataType_Encoding_DefaultBinary),
            886 => Ok(ObjectId::Range_Encoding_DefaultBinary),
            889 => Ok(ObjectId::EUInformation_Encoding_DefaultBinary),
            893 => Ok(ObjectId::Annotation_Encoding_DefaultBinary),
            896 => Ok(ObjectId::ProgramDiagnosticDataType_Encoding_DefaultBinary),
            899 => Ok(ObjectId::SemanticChangeStructureDataType_Encoding_DefaultBinary),
            916 => Ok(ObjectId::EventNotificationList_Encoding_DefaultBinary),
            919 => Ok(ObjectId::EventFieldList_Encoding_DefaultBinary),
            922 => Ok(ObjectId::HistoryEventFieldList_Encoding_DefaultBinary),
            940 => Ok(ObjectId::IssuedIdentityToken_Encoding_DefaultBinary),
            947 => Ok(ObjectId::NotificationData_Encoding_DefaultBinary),
            950 => Ok(ObjectId::AggregateConfiguration_Encoding_DefaultBinary),
            2009 => Ok(ObjectId::ServerType_ServerCapabilities),
            2010 => Ok(ObjectId::ServerType_ServerDiagnostics),
            2011 => Ok(ObjectId::ServerType_VendorServerInfo),
            2012 => Ok(ObjectId::ServerType_ServerRedundancy),
            2019 => Ok(ObjectId::ServerCapabilitiesType_ModellingRules),
            2253 => Ok(ObjectId::Server),
            2268 => Ok(ObjectId::Server_ServerCapabilities),
            2274 => Ok(ObjectId::Server_ServerDiagnostics),
            2295 => Ok(ObjectId::Server_VendorServerInfo),
            2296 => Ok(ObjectId::Server_ServerRedundancy),
            2341 => Ok(ObjectId::AggregateFunction_Interpolative),
            2342 => Ok(ObjectId::AggregateFunction_Average),
            2343 => Ok(ObjectId::AggregateFunction_TimeAverage),
            2344 => Ok(ObjectId::AggregateFunction_Total),
            2346 => Ok(ObjectId::AggregateFunction_Minimum),
            2347 => Ok(ObjectId::AggregateFunction_Maximum),
            2348 => Ok(ObjectId::AggregateFunction_MinimumActualTime),
            2349 => Ok(ObjectId::AggregateFunction_MaximumActualTime),
            2350 => Ok(ObjectId::AggregateFunction_Range),
            2351 => Ok(ObjectId::AggregateFunction_AnnotationCount),
            2352 => Ok(ObjectId::AggregateFunction_Count),
            2355 => Ok(ObjectId::AggregateFunction_NumberOfTransitions),
            2357 => Ok(ObjectId::AggregateFunction_Start),
            2358 => Ok(ObjectId::AggregateFunction_End),
            2359 => Ok(ObjectId::AggregateFunction_Delta),
            2360 => Ok(ObjectId::AggregateFunction_DurationGood),
            2361 => Ok(ObjectId::AggregateFunction_DurationBad),
            2362 => Ok(ObjectId::AggregateFunction_PercentGood),
            2363 => Ok(ObjectId::AggregateFunction_PercentBad),
            2364 => Ok(ObjectId::AggregateFunction_WorstQuality),
            2400 => Ok(ObjectId::ProgramStateMachineType_Ready),
            2402 => Ok(ObjectId::ProgramStateMachineType_Running),
            2404 => Ok(ObjectId::ProgramStateMachineType_Suspended),
            2406 => Ok(ObjectId::ProgramStateMachineType_Halted),
            2408 => Ok(ObjectId::ProgramStateMachineType_HaltedToReady),
            2410 => Ok(ObjectId::ProgramStateMachineType_ReadyToRunning),
            2412 => Ok(ObjectId::ProgramStateMachineType_RunningToHalted),
            2414 => Ok(ObjectId::ProgramStateMachineType_RunningToReady),
            2416 => Ok(ObjectId::ProgramStateMachineType_RunningToSuspended),
            2418 => Ok(ObjectId::ProgramStateMachineType_SuspendedToRunning),
            2420 => Ok(ObjectId::ProgramStateMachineType_SuspendedToHalted),
            2422 => Ok(ObjectId::ProgramStateMachineType_SuspendedToReady),
            2424 => Ok(ObjectId::ProgramStateMachineType_ReadyToHalted),
            2744 => Ok(ObjectId::ServerDiagnosticsType_SessionsDiagnosticsSummary),
            2754 => Ok(ObjectId::ServerCapabilitiesType_AggregateFunctions),
            2930 => Ok(ObjectId::ShelvedStateMachineType_Unshelved),
            2932 => Ok(ObjectId::ShelvedStateMachineType_TimedShelved),
            2933 => Ok(ObjectId::ShelvedStateMachineType_OneShotShelved),
            2935 => Ok(ObjectId::ShelvedStateMachineType_UnshelvedToTimedShelved),
            2936 => Ok(ObjectId::ShelvedStateMachineType_UnshelvedToOneShotShelved),
            2940 => Ok(ObjectId::ShelvedStateMachineType_TimedShelvedToUnshelved),
            2942 => Ok(ObjectId::ShelvedStateMachineType_TimedShelvedToOneShotShelved),
            2943 => Ok(ObjectId::ShelvedStateMachineType_OneShotShelvedToUnshelved),
            2945 => Ok(ObjectId::ShelvedStateMachineType_OneShotShelvedToTimedShelved),
            2996 => Ok(ObjectId::Server_ServerCapabilities_ModellingRules),
            2997 => Ok(ObjectId::Server_ServerCapabilities_AggregateFunctions),
            3048 => Ok(ObjectId::EventTypesFolder),
            3059 => Ok(ObjectId::HistoricalDataConfigurationType_AggregateConfiguration),
            3062 => Ok(ObjectId::DefaultBinary),
            3063 => Ok(ObjectId::DefaultXml),
            3093 => Ok(ObjectId::ServerType_ServerCapabilities_ModellingRules),
            3094 => Ok(ObjectId::ServerType_ServerCapabilities_AggregateFunctions),
            3111 => Ok(ObjectId::ServerType_ServerDiagnostics_SessionsDiagnosticsSummary),
            3706 => Ok(ObjectId::Server_ServerDiagnostics_SessionsDiagnosticsSummary),
            3850 => Ok(ObjectId::ProgramStateMachineType_FinalResultData),
            8251 => Ok(ObjectId::EnumValueType_Encoding_DefaultBinary),
            8917 => Ok(ObjectId::TimeZoneDataType_Encoding_DefaultBinary),
            9178 => Ok(ObjectId::AlarmConditionType_ShelvingState),
            9279 => Ok(ObjectId::LimitAlarmType_ShelvingState),
            9329 => Ok(ObjectId::ExclusiveLimitStateMachineType_HighHigh),
            9331 => Ok(ObjectId::ExclusiveLimitStateMachineType_High),
            9333 => Ok(ObjectId::ExclusiveLimitStateMachineType_Low),
            9335 => Ok(ObjectId::ExclusiveLimitStateMachineType_LowLow),
            9337 => Ok(ObjectId::ExclusiveLimitStateMachineType_LowLowToLow),
            9338 => Ok(ObjectId::ExclusiveLimitStateMachineType_LowToLowLow),
            9339 => Ok(ObjectId::ExclusiveLimitStateMachineType_HighHighToHigh),
            9340 => Ok(ObjectId::ExclusiveLimitStateMachineType_HighToHighHigh),
            9416 => Ok(ObjectId::ExclusiveLimitAlarmType_ShelvingState),
            9455 => Ok(ObjectId::ExclusiveLimitAlarmType_LimitState),
            9557 => Ok(ObjectId::ExclusiveLevelAlarmType_ShelvingState),
            9596 => Ok(ObjectId::ExclusiveLevelAlarmType_LimitState),
            9698 => Ok(ObjectId::ExclusiveRateOfChangeAlarmType_ShelvingState),
            9737 => Ok(ObjectId::ExclusiveRateOfChangeAlarmType_LimitState),
            9839 => Ok(ObjectId::ExclusiveDeviationAlarmType_ShelvingState),
            9878 => Ok(ObjectId::ExclusiveDeviationAlarmType_LimitState),
            9981 => Ok(ObjectId::NonExclusiveLimitAlarmType_ShelvingState),
            10135 => Ok(ObjectId::NonExclusiveLevelAlarmType_ShelvingState),
            10289 => Ok(ObjectId::NonExclusiveRateOfChangeAlarmType_ShelvingState),
            10443 => Ok(ObjectId::NonExclusiveDeviationAlarmType_ShelvingState),
            10598 => Ok(ObjectId::DiscreteAlarmType_ShelvingState),
            10712 => Ok(ObjectId::OffNormalAlarmType_ShelvingState),
            10826 => Ok(ObjectId::TripAlarmType_ShelvingState),
            11172 => Ok(ObjectId::HistoryServerCapabilitiesType_AggregateFunctions),
            11192 => Ok(ObjectId::HistoryServerCapabilities),
            11201 => Ok(ObjectId::HistoryServerCapabilities_AggregateFunctions),
            11202 => Ok(ObjectId::HAConfiguration),
            11203 => Ok(ObjectId::HAConfiguration_AggregateConfiguration),
            11226 => Ok(ObjectId::ModificationInfo_Encoding_DefaultBinary),
            11227 => Ok(ObjectId::HistoryModifiedData_Encoding_DefaultBinary),
            11285 => Ok(ObjectId::AggregateFunction_TimeAverage2),
            11286 => Ok(ObjectId::AggregateFunction_Minimum2),
            11287 => Ok(ObjectId::AggregateFunction_Maximum2),
            11288 => Ok(ObjectId::AggregateFunction_Range2),
            11292 => Ok(ObjectId::AggregateFunction_WorstQuality2),
            11300 => Ok(ObjectId::UpdateStructureDataDetails_Encoding_DefaultBinary),
            11304 => Ok(ObjectId::AggregateFunction_Total2),
            11305 => Ok(ObjectId::AggregateFunction_MinimumActualTime2),
            11306 => Ok(ObjectId::AggregateFunction_MaximumActualTime2),
            11307 => Ok(ObjectId::AggregateFunction_DurationInStateZero),
            11308 => Ok(ObjectId::AggregateFunction_DurationInStateNonZero),
            11426 => Ok(ObjectId::AggregateFunction_StandardDeviationSample),
            11427 => Ok(ObjectId::AggregateFunction_StandardDeviationPopulation),
            11428 => Ok(ObjectId::AggregateFunction_VarianceSample),
            11429 => Ok(ObjectId::AggregateFunction_VariancePopulation),
            11505 => Ok(ObjectId::AggregateFunction_StartBound),
            11506 => Ok(ObjectId::AggregateFunction_EndBound),
            11507 => Ok(ObjectId::AggregateFunction_DeltaBounds),
            11508 => Ok(ObjectId::ModellingRule_OptionalPlaceholder),
            11510 => Ok(ObjectId::ModellingRule_MandatoryPlaceholder),
            11516 => Ok(ObjectId::ServerType_ServerCapabilities_OperationLimits),
            11527 => Ok(ObjectId::ServerType_Namespaces),
            11551 => Ok(ObjectId::ServerCapabilitiesType_OperationLimits),
            11624 => Ok(ObjectId::NamespaceMetadataType_NamespaceFile),
            11646 => Ok(ObjectId::NamespacesType_NamespaceIdentifier_Placeholder),
            11654 => Ok(ObjectId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile),
            11704 => Ok(ObjectId::Server_ServerCapabilities_OperationLimits),
            11715 => Ok(ObjectId::Server_Namespaces),
            11831 => Ok(ObjectId::SystemOffNormalAlarmType_ShelvingState),
            11876 => Ok(ObjectId::HistoricalDataConfigurationType_AggregateFunctions),
            11877 => Ok(ObjectId::HAConfiguration_AggregateFunctions),
            11889 => Ok(ObjectId::InstanceNode_Encoding_DefaultBinary),
            11890 => Ok(ObjectId::TypeNode_Encoding_DefaultBinary),
            11957 => Ok(ObjectId::EndpointUrlListDataType_Encoding_DefaultBinary),
            11958 => Ok(ObjectId::NetworkGroupDataType_Encoding_DefaultBinary),
            12089 => Ok(ObjectId::AxisInformation_Encoding_DefaultBinary),
            12090 => Ok(ObjectId::XVType_Encoding_DefaultBinary),
            12097 => Ok(ObjectId::SessionsDiagnosticsSummaryType_ClientName_Placeholder),
            12181 => Ok(ObjectId::ComplexNumberType_Encoding_DefaultBinary),
            12182 => Ok(ObjectId::DoubleComplexNumberType_Encoding_DefaultBinary),
            12207 => Ok(ObjectId::ServerOnNetwork_Encoding_DefaultBinary),
            12208 => Ok(ObjectId::FindServersOnNetworkRequest_Encoding_DefaultBinary),
            12209 => Ok(ObjectId::FindServersOnNetworkResponse_Encoding_DefaultBinary),
            12211 => Ok(ObjectId::RegisterServer2Request_Encoding_DefaultBinary),
            12212 => Ok(ObjectId::RegisterServer2Response_Encoding_DefaultBinary),
            12637 => Ok(ObjectId::ServerConfiguration),
            12642 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList),
            12680 => Ok(ObjectId::TrustListDataType_Encoding_DefaultBinary),
            12765 => Ok(ObjectId::OptionSet_Encoding_DefaultBinary),
            12766 => Ok(ObjectId::Union_Encoding_DefaultBinary),
            12900 => Ok(ObjectId::DiscoveryConfiguration_Encoding_DefaultBinary),
            12901 => Ok(ObjectId::MdnsDiscoveryConfiguration_Encoding_DefaultBinary),
            13305 => Ok(ObjectId::CertificateExpirationAlarmType_ShelvingState),
            13354 => Ok(ObjectId::FileDirectoryType_FileDirectoryName_Placeholder),
            13366 => Ok(ObjectId::FileDirectoryType_FileName_Placeholder),
            13599 => Ok(ObjectId::CertificateGroupType_TrustList),
            13814 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup),
            13815 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList),
            13848 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup),
            13849 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList),
            13882 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup),
            13883 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList),
            13916 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder),
            13917 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList),
            13950 => Ok(ObjectId::ServerConfigurationType_CertificateGroups),
            13951 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup),
            13952 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList),
            13985 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup),
            13986 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList),
            14019 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup),
            14020 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList),
            14053 => Ok(ObjectId::ServerConfiguration_CertificateGroups),
            14088 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup),
            14089 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList),
            14122 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup),
            14123 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList),
            14156 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup),
            14221 => Ok(ObjectId::PubSubConnectionType_Address),
            14323 => Ok(ObjectId::PublishedVariableDataType_Encoding_DefaultBinary),
            14417 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder),
            14419 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_Status),
            14423 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_Address),
            14434 => Ok(ObjectId::PublishSubscribeType_PublishedDataSets),
            14443 => Ok(ObjectId::PublishSubscribe),
            14478 => Ok(ObjectId::DataSetFolderType_DataSetFolderName_Placeholder),
            14487 => Ok(ObjectId::DataSetFolderType_PublishedDataSetName_Placeholder),
            14600 => Ok(ObjectId::PubSubConnectionType_Status),
            14839 => Ok(ObjectId::FieldMetaData_Encoding_DefaultBinary),
            14844 => Ok(ObjectId::StructureField_Encoding_DefaultBinary),
            14845 => Ok(ObjectId::EnumField_Encoding_DefaultBinary),
            14846 => Ok(ObjectId::KeyValuePair_Encoding_DefaultBinary),
            14847 => Ok(ObjectId::ConfigurationVersionDataType_Encoding_DefaultBinary),
            14848 => Ok(ObjectId::FieldTargetDataType_Encoding_DefaultBinary),
            15041 => Ok(ObjectId::KeyValuePair_Encoding_DefaultJson),
            15042 => Ok(ObjectId::IdentityMappingRuleType_Encoding_DefaultJson),
            15044 => Ok(ObjectId::TrustListDataType_Encoding_DefaultJson),
            15045 => Ok(ObjectId::DecimalDataType_Encoding_DefaultJson),
            15049 => Ok(ObjectId::ConfigurationVersionDataType_Encoding_DefaultJson),
            15050 => Ok(ObjectId::DataSetMetaDataType_Encoding_DefaultJson),
            15051 => Ok(ObjectId::FieldMetaData_Encoding_DefaultJson),
            15057 => Ok(ObjectId::DataTypeDescription_Encoding_DefaultJson),
            15058 => Ok(ObjectId::StructureDescription_Encoding_DefaultJson),
            15059 => Ok(ObjectId::EnumDescription_Encoding_DefaultJson),
            15060 => Ok(ObjectId::PublishedVariableDataType_Encoding_DefaultJson),
            15061 => Ok(ObjectId::FieldTargetDataType_Encoding_DefaultJson),
            15062 => Ok(ObjectId::RolePermissionType_Encoding_DefaultJson),
            15063 => Ok(ObjectId::DataTypeDefinition_Encoding_DefaultJson),
            15065 => Ok(ObjectId::StructureField_Encoding_DefaultJson),
            15066 => Ok(ObjectId::StructureDefinition_Encoding_DefaultJson),
            15067 => Ok(ObjectId::EnumDefinition_Encoding_DefaultJson),
            15068 => Ok(ObjectId::Node_Encoding_DefaultJson),
            15069 => Ok(ObjectId::InstanceNode_Encoding_DefaultJson),
            15070 => Ok(ObjectId::TypeNode_Encoding_DefaultJson),
            15071 => Ok(ObjectId::ObjectNode_Encoding_DefaultJson),
            15072 => Ok(ObjectId::DatagramConnectionTransportType_DiscoveryAddress),
            15073 => Ok(ObjectId::ObjectTypeNode_Encoding_DefaultJson),
            15074 => Ok(ObjectId::VariableNode_Encoding_DefaultJson),
            15075 => Ok(ObjectId::VariableTypeNode_Encoding_DefaultJson),
            15076 => Ok(ObjectId::ReferenceTypeNode_Encoding_DefaultJson),
            15077 => Ok(ObjectId::MethodNode_Encoding_DefaultJson),
            15078 => Ok(ObjectId::ViewNode_Encoding_DefaultJson),
            15079 => Ok(ObjectId::DataTypeNode_Encoding_DefaultJson),
            15080 => Ok(ObjectId::ReferenceNode_Encoding_DefaultJson),
            15081 => Ok(ObjectId::Argument_Encoding_DefaultJson),
            15082 => Ok(ObjectId::EnumValueType_Encoding_DefaultJson),
            15083 => Ok(ObjectId::EnumField_Encoding_DefaultJson),
            15084 => Ok(ObjectId::OptionSet_Encoding_DefaultJson),
            15085 => Ok(ObjectId::Union_Encoding_DefaultJson),
            15086 => Ok(ObjectId::TimeZoneDataType_Encoding_DefaultJson),
            15087 => Ok(ObjectId::ApplicationDescription_Encoding_DefaultJson),
            15088 => Ok(ObjectId::RequestHeader_Encoding_DefaultJson),
            15089 => Ok(ObjectId::ResponseHeader_Encoding_DefaultJson),
            15090 => Ok(ObjectId::ServiceFault_Encoding_DefaultJson),
            15091 => Ok(ObjectId::SessionlessInvokeRequestType_Encoding_DefaultJson),
            15092 => Ok(ObjectId::SessionlessInvokeResponseType_Encoding_DefaultJson),
            15093 => Ok(ObjectId::FindServersRequest_Encoding_DefaultJson),
            15094 => Ok(ObjectId::FindServersResponse_Encoding_DefaultJson),
            15095 => Ok(ObjectId::ServerOnNetwork_Encoding_DefaultJson),
            15096 => Ok(ObjectId::FindServersOnNetworkRequest_Encoding_DefaultJson),
            15097 => Ok(ObjectId::FindServersOnNetworkResponse_Encoding_DefaultJson),
            15098 => Ok(ObjectId::UserTokenPolicy_Encoding_DefaultJson),
            15099 => Ok(ObjectId::EndpointDescription_Encoding_DefaultJson),
            15100 => Ok(ObjectId::GetEndpointsRequest_Encoding_DefaultJson),
            15101 => Ok(ObjectId::GetEndpointsResponse_Encoding_DefaultJson),
            15102 => Ok(ObjectId::RegisteredServer_Encoding_DefaultJson),
            15103 => Ok(ObjectId::RegisterServerRequest_Encoding_DefaultJson),
            15104 => Ok(ObjectId::RegisterServerResponse_Encoding_DefaultJson),
            15105 => Ok(ObjectId::DiscoveryConfiguration_Encoding_DefaultJson),
            15106 => Ok(ObjectId::MdnsDiscoveryConfiguration_Encoding_DefaultJson),
            15107 => Ok(ObjectId::RegisterServer2Request_Encoding_DefaultJson),
            15130 => Ok(ObjectId::RegisterServer2Response_Encoding_DefaultJson),
            15131 => Ok(ObjectId::ChannelSecurityToken_Encoding_DefaultJson),
            15132 => Ok(ObjectId::OpenSecureChannelRequest_Encoding_DefaultJson),
            15133 => Ok(ObjectId::OpenSecureChannelResponse_Encoding_DefaultJson),
            15134 => Ok(ObjectId::CloseSecureChannelRequest_Encoding_DefaultJson),
            15135 => Ok(ObjectId::CloseSecureChannelResponse_Encoding_DefaultJson),
            15136 => Ok(ObjectId::SignedSoftwareCertificate_Encoding_DefaultJson),
            15137 => Ok(ObjectId::SignatureData_Encoding_DefaultJson),
            15138 => Ok(ObjectId::CreateSessionRequest_Encoding_DefaultJson),
            15139 => Ok(ObjectId::CreateSessionResponse_Encoding_DefaultJson),
            15140 => Ok(ObjectId::UserIdentityToken_Encoding_DefaultJson),
            15141 => Ok(ObjectId::AnonymousIdentityToken_Encoding_DefaultJson),
            15142 => Ok(ObjectId::UserNameIdentityToken_Encoding_DefaultJson),
            15143 => Ok(ObjectId::X509IdentityToken_Encoding_DefaultJson),
            15144 => Ok(ObjectId::IssuedIdentityToken_Encoding_DefaultJson),
            15145 => Ok(ObjectId::ActivateSessionRequest_Encoding_DefaultJson),
            15146 => Ok(ObjectId::ActivateSessionResponse_Encoding_DefaultJson),
            15147 => Ok(ObjectId::CloseSessionRequest_Encoding_DefaultJson),
            15148 => Ok(ObjectId::CloseSessionResponse_Encoding_DefaultJson),
            15149 => Ok(ObjectId::CancelRequest_Encoding_DefaultJson),
            15150 => Ok(ObjectId::CancelResponse_Encoding_DefaultJson),
            15151 => Ok(ObjectId::NodeAttributes_Encoding_DefaultJson),
            15152 => Ok(ObjectId::ObjectAttributes_Encoding_DefaultJson),
            15153 => Ok(ObjectId::VariableAttributes_Encoding_DefaultJson),
            15157 => Ok(ObjectId::MethodAttributes_Encoding_DefaultJson),
            15158 => Ok(ObjectId::ObjectTypeAttributes_Encoding_DefaultJson),
            15159 => Ok(ObjectId::VariableTypeAttributes_Encoding_DefaultJson),
            15160 => Ok(ObjectId::ReferenceTypeAttributes_Encoding_DefaultJson),
            15161 => Ok(ObjectId::DataTypeAttributes_Encoding_DefaultJson),
            15162 => Ok(ObjectId::ViewAttributes_Encoding_DefaultJson),
            15163 => Ok(ObjectId::GenericAttributeValue_Encoding_DefaultJson),
            15164 => Ok(ObjectId::GenericAttributes_Encoding_DefaultJson),
            15165 => Ok(ObjectId::AddNodesItem_Encoding_DefaultJson),
            15166 => Ok(ObjectId::AddNodesResult_Encoding_DefaultJson),
            15167 => Ok(ObjectId::AddNodesRequest_Encoding_DefaultJson),
            15168 => Ok(ObjectId::AddNodesResponse_Encoding_DefaultJson),
            15169 => Ok(ObjectId::AddReferencesItem_Encoding_DefaultJson),
            15170 => Ok(ObjectId::AddReferencesRequest_Encoding_DefaultJson),
            15171 => Ok(ObjectId::AddReferencesResponse_Encoding_DefaultJson),
            15172 => Ok(ObjectId::DeleteNodesItem_Encoding_DefaultJson),
            15173 => Ok(ObjectId::DeleteNodesRequest_Encoding_DefaultJson),
            15174 => Ok(ObjectId::DeleteNodesResponse_Encoding_DefaultJson),
            15175 => Ok(ObjectId::DeleteReferencesItem_Encoding_DefaultJson),
            15176 => Ok(ObjectId::DeleteReferencesRequest_Encoding_DefaultJson),
            15177 => Ok(ObjectId::DeleteReferencesResponse_Encoding_DefaultJson),
            15179 => Ok(ObjectId::ViewDescription_Encoding_DefaultJson),
            15180 => Ok(ObjectId::BrowseDescription_Encoding_DefaultJson),
            15182 => Ok(ObjectId::ReferenceDescription_Encoding_DefaultJson),
            15183 => Ok(ObjectId::BrowseResult_Encoding_DefaultJson),
            15184 => Ok(ObjectId::BrowseRequest_Encoding_DefaultJson),
            15185 => Ok(ObjectId::BrowseResponse_Encoding_DefaultJson),
            15186 => Ok(ObjectId::BrowseNextRequest_Encoding_DefaultJson),
            15187 => Ok(ObjectId::BrowseNextResponse_Encoding_DefaultJson),
            15188 => Ok(ObjectId::RelativePathElement_Encoding_DefaultJson),
            15189 => Ok(ObjectId::RelativePath_Encoding_DefaultJson),
            15190 => Ok(ObjectId::BrowsePath_Encoding_DefaultJson),
            15191 => Ok(ObjectId::BrowsePathTarget_Encoding_DefaultJson),
            15192 => Ok(ObjectId::BrowsePathResult_Encoding_DefaultJson),
            15193 => Ok(ObjectId::TranslateBrowsePathsToNodeIdsRequest_Encoding_DefaultJson),
            15194 => Ok(ObjectId::TranslateBrowsePathsToNodeIdsResponse_Encoding_DefaultJson),
            15195 => Ok(ObjectId::RegisterNodesRequest_Encoding_DefaultJson),
            15196 => Ok(ObjectId::RegisterNodesResponse_Encoding_DefaultJson),
            15197 => Ok(ObjectId::UnregisterNodesRequest_Encoding_DefaultJson),
            15198 => Ok(ObjectId::UnregisterNodesResponse_Encoding_DefaultJson),
            15199 => Ok(ObjectId::EndpointConfiguration_Encoding_DefaultJson),
            15200 => Ok(ObjectId::QueryDataDescription_Encoding_DefaultJson),
            15201 => Ok(ObjectId::NodeTypeDescription_Encoding_DefaultJson),
            15202 => Ok(ObjectId::QueryDataSet_Encoding_DefaultJson),
            15203 => Ok(ObjectId::NodeReference_Encoding_DefaultJson),
            15204 => Ok(ObjectId::ContentFilterElement_Encoding_DefaultJson),
            15205 => Ok(ObjectId::ContentFilter_Encoding_DefaultJson),
            15206 => Ok(ObjectId::FilterOperand_Encoding_DefaultJson),
            15207 => Ok(ObjectId::ElementOperand_Encoding_DefaultJson),
            15208 => Ok(ObjectId::LiteralOperand_Encoding_DefaultJson),
            15209 => Ok(ObjectId::AttributeOperand_Encoding_DefaultJson),
            15210 => Ok(ObjectId::SimpleAttributeOperand_Encoding_DefaultJson),
            15211 => Ok(ObjectId::ContentFilterElementResult_Encoding_DefaultJson),
            15222 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder),
            15223 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_Status),
            15227 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_TransportSettings),
            15228 => Ok(ObjectId::ContentFilterResult_Encoding_DefaultJson),
            15230 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder),
            15231 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_Status),
            15235 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_TransportSettings),
            15236 => Ok(ObjectId::ParsingResult_Encoding_DefaultJson),
            15238 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder),
            15239 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_Status),
            15243 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_TransportSettings),
            15244 => Ok(ObjectId::QueryFirstRequest_Encoding_DefaultJson),
            15252 => Ok(ObjectId::QueryFirstResponse_Encoding_DefaultJson),
            15254 => Ok(ObjectId::QueryNextRequest_Encoding_DefaultJson),
            15255 => Ok(ObjectId::QueryNextResponse_Encoding_DefaultJson),
            15256 => Ok(ObjectId::ReadValueId_Encoding_DefaultJson),
            15257 => Ok(ObjectId::ReadRequest_Encoding_DefaultJson),
            15258 => Ok(ObjectId::ReadResponse_Encoding_DefaultJson),
            15259 => Ok(ObjectId::HistoryReadValueId_Encoding_DefaultJson),
            15260 => Ok(ObjectId::HistoryReadResult_Encoding_DefaultJson),
            15261 => Ok(ObjectId::HistoryReadDetails_Encoding_DefaultJson),
            15262 => Ok(ObjectId::ReadEventDetails_Encoding_DefaultJson),
            15263 => Ok(ObjectId::ReadRawModifiedDetails_Encoding_DefaultJson),
            15264 => Ok(ObjectId::ReadProcessedDetails_Encoding_DefaultJson),
            15265 => Ok(ObjectId::PubSubGroupType_Status),
            15269 => Ok(ObjectId::ReadAtTimeDetails_Encoding_DefaultJson),
            15270 => Ok(ObjectId::HistoryData_Encoding_DefaultJson),
            15271 => Ok(ObjectId::ModificationInfo_Encoding_DefaultJson),
            15272 => Ok(ObjectId::HistoryModifiedData_Encoding_DefaultJson),
            15273 => Ok(ObjectId::HistoryEvent_Encoding_DefaultJson),
            15274 => Ok(ObjectId::HistoryReadRequest_Encoding_DefaultJson),
            15275 => Ok(ObjectId::HistoryReadResponse_Encoding_DefaultJson),
            15276 => Ok(ObjectId::WriteValue_Encoding_DefaultJson),
            15277 => Ok(ObjectId::WriteRequest_Encoding_DefaultJson),
            15278 => Ok(ObjectId::WriteResponse_Encoding_DefaultJson),
            15279 => Ok(ObjectId::HistoryUpdateDetails_Encoding_DefaultJson),
            15280 => Ok(ObjectId::UpdateDataDetails_Encoding_DefaultJson),
            15281 => Ok(ObjectId::UpdateStructureDataDetails_Encoding_DefaultJson),
            15282 => Ok(ObjectId::UpdateEventDetails_Encoding_DefaultJson),
            15283 => Ok(ObjectId::DeleteRawModifiedDetails_Encoding_DefaultJson),
            15284 => Ok(ObjectId::DeleteAtTimeDetails_Encoding_DefaultJson),
            15285 => Ok(ObjectId::DeleteEventDetails_Encoding_DefaultJson),
            15286 => Ok(ObjectId::HistoryUpdateResult_Encoding_DefaultJson),
            15287 => Ok(ObjectId::HistoryUpdateRequest_Encoding_DefaultJson),
            15288 => Ok(ObjectId::HistoryUpdateResponse_Encoding_DefaultJson),
            15289 => Ok(ObjectId::CallMethodRequest_Encoding_DefaultJson),
            15290 => Ok(ObjectId::CallMethodResult_Encoding_DefaultJson),
            15291 => Ok(ObjectId::CallRequest_Encoding_DefaultJson),
            15292 => Ok(ObjectId::CallResponse_Encoding_DefaultJson),
            15293 => Ok(ObjectId::MonitoringFilter_Encoding_DefaultJson),
            15294 => Ok(ObjectId::DataChangeFilter_Encoding_DefaultJson),
            15295 => Ok(ObjectId::EventFilter_Encoding_DefaultJson),
            15299 => Ok(ObjectId::DataSetWriterType_Status),
            15303 => Ok(ObjectId::DataSetWriterType_TransportSettings),
            15304 => Ok(ObjectId::AggregateConfiguration_Encoding_DefaultJson),
            15307 => Ok(ObjectId::DataSetReaderType_Status),
            15311 => Ok(ObjectId::DataSetReaderType_TransportSettings),
            15312 => Ok(ObjectId::AggregateFilter_Encoding_DefaultJson),
            15313 => Ok(ObjectId::MonitoringFilterResult_Encoding_DefaultJson),
            15314 => Ok(ObjectId::EventFilterResult_Encoding_DefaultJson),
            15315 => Ok(ObjectId::AggregateFilterResult_Encoding_DefaultJson),
            15316 => Ok(ObjectId::DataSetReaderType_SubscribedDataSet),
            15320 => Ok(ObjectId::MonitoringParameters_Encoding_DefaultJson),
            15321 => Ok(ObjectId::MonitoredItemCreateRequest_Encoding_DefaultJson),
            15322 => Ok(ObjectId::MonitoredItemCreateResult_Encoding_DefaultJson),
            15323 => Ok(ObjectId::CreateMonitoredItemsRequest_Encoding_DefaultJson),
            15324 => Ok(ObjectId::CreateMonitoredItemsResponse_Encoding_DefaultJson),
            15325 => Ok(ObjectId::MonitoredItemModifyRequest_Encoding_DefaultJson),
            15326 => Ok(ObjectId::MonitoredItemModifyResult_Encoding_DefaultJson),
            15327 => Ok(ObjectId::ModifyMonitoredItemsRequest_Encoding_DefaultJson),
            15328 => Ok(ObjectId::ModifyMonitoredItemsResponse_Encoding_DefaultJson),
            15329 => Ok(ObjectId::SetMonitoringModeRequest_Encoding_DefaultJson),
            15331 => Ok(ObjectId::SetMonitoringModeResponse_Encoding_DefaultJson),
            15332 => Ok(ObjectId::SetTriggeringRequest_Encoding_DefaultJson),
            15333 => Ok(ObjectId::SetTriggeringResponse_Encoding_DefaultJson),
            15335 => Ok(ObjectId::DeleteMonitoredItemsRequest_Encoding_DefaultJson),
            15336 => Ok(ObjectId::DeleteMonitoredItemsResponse_Encoding_DefaultJson),
            15337 => Ok(ObjectId::CreateSubscriptionRequest_Encoding_DefaultJson),
            15338 => Ok(ObjectId::CreateSubscriptionResponse_Encoding_DefaultJson),
            15339 => Ok(ObjectId::ModifySubscriptionRequest_Encoding_DefaultJson),
            15340 => Ok(ObjectId::ModifySubscriptionResponse_Encoding_DefaultJson),
            15341 => Ok(ObjectId::SetPublishingModeRequest_Encoding_DefaultJson),
            15342 => Ok(ObjectId::SetPublishingModeResponse_Encoding_DefaultJson),
            15343 => Ok(ObjectId::NotificationMessage_Encoding_DefaultJson),
            15344 => Ok(ObjectId::NotificationData_Encoding_DefaultJson),
            15345 => Ok(ObjectId::DataChangeNotification_Encoding_DefaultJson),
            15346 => Ok(ObjectId::MonitoredItemNotification_Encoding_DefaultJson),
            15347 => Ok(ObjectId::EventNotificationList_Encoding_DefaultJson),
            15348 => Ok(ObjectId::EventFieldList_Encoding_DefaultJson),
            15349 => Ok(ObjectId::HistoryEventFieldList_Encoding_DefaultJson),
            15350 => Ok(ObjectId::StatusChangeNotification_Encoding_DefaultJson),
            15351 => Ok(ObjectId::SubscriptionAcknowledgement_Encoding_DefaultJson),
            15352 => Ok(ObjectId::PublishRequest_Encoding_DefaultJson),
            15353 => Ok(ObjectId::PublishResponse_Encoding_DefaultJson),
            15354 => Ok(ObjectId::RepublishRequest_Encoding_DefaultJson),
            15355 => Ok(ObjectId::RepublishResponse_Encoding_DefaultJson),
            15356 => Ok(ObjectId::TransferResult_Encoding_DefaultJson),
            15357 => Ok(ObjectId::TransferSubscriptionsRequest_Encoding_DefaultJson),
            15358 => Ok(ObjectId::TransferSubscriptionsResponse_Encoding_DefaultJson),
            15359 => Ok(ObjectId::DeleteSubscriptionsRequest_Encoding_DefaultJson),
            15360 => Ok(ObjectId::DeleteSubscriptionsResponse_Encoding_DefaultJson),
            15361 => Ok(ObjectId::BuildInfo_Encoding_DefaultJson),
            15362 => Ok(ObjectId::RedundantServerDataType_Encoding_DefaultJson),
            15363 => Ok(ObjectId::EndpointUrlListDataType_Encoding_DefaultJson),
            15364 => Ok(ObjectId::NetworkGroupDataType_Encoding_DefaultJson),
            15365 => Ok(ObjectId::SamplingIntervalDiagnosticsDataType_Encoding_DefaultJson),
            15366 => Ok(ObjectId::ServerDiagnosticsSummaryDataType_Encoding_DefaultJson),
            15367 => Ok(ObjectId::ServerStatusDataType_Encoding_DefaultJson),
            15368 => Ok(ObjectId::SessionDiagnosticsDataType_Encoding_DefaultJson),
            15369 => Ok(ObjectId::SessionSecurityDiagnosticsDataType_Encoding_DefaultJson),
            15370 => Ok(ObjectId::ServiceCounterDataType_Encoding_DefaultJson),
            15371 => Ok(ObjectId::StatusResult_Encoding_DefaultJson),
            15372 => Ok(ObjectId::SubscriptionDiagnosticsDataType_Encoding_DefaultJson),
            15373 => Ok(ObjectId::ModelChangeStructureDataType_Encoding_DefaultJson),
            15374 => Ok(ObjectId::SemanticChangeStructureDataType_Encoding_DefaultJson),
            15375 => Ok(ObjectId::Range_Encoding_DefaultJson),
            15376 => Ok(ObjectId::EUInformation_Encoding_DefaultJson),
            15377 => Ok(ObjectId::ComplexNumberType_Encoding_DefaultJson),
            15378 => Ok(ObjectId::DoubleComplexNumberType_Encoding_DefaultJson),
            15379 => Ok(ObjectId::AxisInformation_Encoding_DefaultJson),
            15380 => Ok(ObjectId::XVType_Encoding_DefaultJson),
            15381 => Ok(ObjectId::ProgramDiagnosticDataType_Encoding_DefaultJson),
            15382 => Ok(ObjectId::Annotation_Encoding_DefaultJson),
            15397 => Ok(ObjectId::ProgramDiagnostic2DataType_Encoding_DefaultBinary),
            15405 => Ok(ObjectId::ProgramDiagnostic2DataType_Encoding_DefaultJson),
            15421 => Ok(ObjectId::SimpleTypeDescription_Encoding_DefaultBinary),
            15422 => Ok(ObjectId::UABinaryFileDataType_Encoding_DefaultBinary),
            15434 => Ok(ObjectId::PublishSubscribeType_SecurityGroups),
            15443 => Ok(ObjectId::PublishSubscribe_SecurityGroups),
            15453 => Ok(ObjectId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder),
            15459 => Ok(ObjectId::SecurityGroupFolderType_SecurityGroupName_Placeholder),
            15473 => Ok(ObjectId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields),
            15479 => Ok(ObjectId::BrokerConnectionTransportDataType_Encoding_DefaultBinary),
            15481 => Ok(ObjectId::PublishedDataSetType_ExtensionFields),
            15503 => Ok(ObjectId::PublishedDataItemsType_ExtensionFields),
            15511 => Ok(ObjectId::PublishedEventsType_ExtensionFields),
            15606 => Ok(ObjectId::Server_ServerCapabilities_RoleSet),
            15608 => Ok(ObjectId::RoleSetType_RoleName_Placeholder),
            15644 => Ok(ObjectId::WellKnownRole_Anonymous),
            15656 => Ok(ObjectId::WellKnownRole_AuthenticatedUser),
            15668 => Ok(ObjectId::WellKnownRole_Observer),
            15671 => Ok(ObjectId::EndpointType_Encoding_DefaultBinary),
            15676 => Ok(ObjectId::DataTypeSchemaHeader_Encoding_DefaultBinary),
            15677 => Ok(ObjectId::PublishedDataSetDataType_Encoding_DefaultBinary),
            15678 => Ok(ObjectId::PublishedDataSetSourceDataType_Encoding_DefaultBinary),
            15679 => Ok(ObjectId::PublishedDataItemsDataType_Encoding_DefaultBinary),
            15680 => Ok(ObjectId::WellKnownRole_Operator),
            15681 => Ok(ObjectId::PublishedEventsDataType_Encoding_DefaultBinary),
            15682 => Ok(ObjectId::DataSetWriterDataType_Encoding_DefaultBinary),
            15683 => Ok(ObjectId::DataSetWriterTransportDataType_Encoding_DefaultBinary),
            15688 => Ok(ObjectId::DataSetWriterMessageDataType_Encoding_DefaultBinary),
            15689 => Ok(ObjectId::PubSubGroupDataType_Encoding_DefaultBinary),
            15691 => Ok(ObjectId::WriterGroupTransportDataType_Encoding_DefaultBinary),
            15692 => Ok(ObjectId::WellKnownRole_Supervisor),
            15693 => Ok(ObjectId::WriterGroupMessageDataType_Encoding_DefaultBinary),
            15694 => Ok(ObjectId::PubSubConnectionDataType_Encoding_DefaultBinary),
            15695 => Ok(ObjectId::ConnectionTransportDataType_Encoding_DefaultBinary),
            15700 => Ok(ObjectId::SimpleTypeDescription_Encoding_DefaultJson),
            15701 => Ok(ObjectId::ReaderGroupTransportDataType_Encoding_DefaultBinary),
            15702 => Ok(ObjectId::ReaderGroupMessageDataType_Encoding_DefaultBinary),
            15703 => Ok(ObjectId::DataSetReaderDataType_Encoding_DefaultBinary),
            15704 => Ok(ObjectId::WellKnownRole_SecurityAdmin),
            15705 => Ok(ObjectId::DataSetReaderTransportDataType_Encoding_DefaultBinary),
            15706 => Ok(ObjectId::DataSetReaderMessageDataType_Encoding_DefaultBinary),
            15707 => Ok(ObjectId::SubscribedDataSetDataType_Encoding_DefaultBinary),
            15712 => Ok(ObjectId::TargetVariablesDataType_Encoding_DefaultBinary),
            15713 => Ok(ObjectId::SubscribedDataSetMirrorDataType_Encoding_DefaultBinary),
            15714 => Ok(ObjectId::UABinaryFileDataType_Encoding_DefaultJson),
            15715 => Ok(ObjectId::UadpWriterGroupMessageDataType_Encoding_DefaultBinary),
            15716 => Ok(ObjectId::WellKnownRole_ConfigureAdmin),
            15717 => Ok(ObjectId::UadpDataSetWriterMessageDataType_Encoding_DefaultBinary),
            15718 => Ok(ObjectId::UadpDataSetReaderMessageDataType_Encoding_DefaultBinary),
            15719 => Ok(ObjectId::JsonWriterGroupMessageDataType_Encoding_DefaultBinary),
            15724 => Ok(ObjectId::JsonDataSetWriterMessageDataType_Encoding_DefaultBinary),
            15725 => Ok(ObjectId::JsonDataSetReaderMessageDataType_Encoding_DefaultBinary),
            15726 => Ok(ObjectId::BrokerConnectionTransportDataType_Encoding_DefaultJson),
            15727 => Ok(ObjectId::BrokerWriterGroupTransportDataType_Encoding_DefaultBinary),
            15729 => Ok(ObjectId::BrokerDataSetWriterTransportDataType_Encoding_DefaultBinary),
            15733 => Ok(ObjectId::BrokerDataSetReaderTransportDataType_Encoding_DefaultBinary),
            15736 => Ok(ObjectId::IdentityMappingRuleType_Encoding_DefaultBinary),
            15754 => Ok(ObjectId::TemporaryFileTransferType_TransferState_Placeholder),
            15790 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder),
            15815 => Ok(ObjectId::FileTransferStateMachineType_Idle),
            15817 => Ok(ObjectId::FileTransferStateMachineType_ReadPrepare),
            15819 => Ok(ObjectId::FileTransferStateMachineType_ReadTransfer),
            15821 => Ok(ObjectId::FileTransferStateMachineType_ApplyWrite),
            15823 => Ok(ObjectId::FileTransferStateMachineType_Error),
            15825 => Ok(ObjectId::FileTransferStateMachineType_IdleToReadPrepare),
            15827 => Ok(ObjectId::FileTransferStateMachineType_ReadPrepareToReadTransfer),
            15829 => Ok(ObjectId::FileTransferStateMachineType_ReadTransferToIdle),
            15831 => Ok(ObjectId::FileTransferStateMachineType_IdleToApplyWrite),
            15833 => Ok(ObjectId::FileTransferStateMachineType_ApplyWriteToIdle),
            15835 => Ok(ObjectId::FileTransferStateMachineType_ReadPrepareToError),
            15837 => Ok(ObjectId::FileTransferStateMachineType_ReadTransferToError),
            15839 => Ok(ObjectId::FileTransferStateMachineType_ApplyWriteToError),
            15841 => Ok(ObjectId::FileTransferStateMachineType_ErrorToIdle),
            15844 => Ok(ObjectId::PublishSubscribeType_Status),
            15851 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_Address),
            15864 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_TransportSettings),
            15865 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_Status),
            15903 => Ok(ObjectId::SessionlessInvokeRequestType_Encoding_DefaultBinary),
            15905 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_TransportSettings),
            15913 => Ok(ObjectId::PubSubKeyServiceType_SecurityGroups),
            15937 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics),
            15957 => Ok(ObjectId::OPCUANamespaceMetadata),
            15965 => Ok(ObjectId::OPCUANamespaceMetadata_NamespaceFile),
            16036 => Ok(ObjectId::WellKnownRole_Engineer),
            16102 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters),
            16150 => Ok(ObjectId::EndpointType_Encoding_DefaultJson),
            16151 => Ok(ObjectId::DataTypeSchemaHeader_Encoding_DefaultJson),
            16152 => Ok(ObjectId::PublishedDataSetDataType_Encoding_DefaultJson),
            16153 => Ok(ObjectId::PublishedDataSetSourceDataType_Encoding_DefaultJson),
            16154 => Ok(ObjectId::PublishedDataItemsDataType_Encoding_DefaultJson),
            16155 => Ok(ObjectId::PublishedEventsDataType_Encoding_DefaultJson),
            16156 => Ok(ObjectId::DataSetWriterDataType_Encoding_DefaultJson),
            16157 => Ok(ObjectId::DataSetWriterTransportDataType_Encoding_DefaultJson),
            16158 => Ok(ObjectId::DataSetWriterMessageDataType_Encoding_DefaultJson),
            16159 => Ok(ObjectId::PubSubGroupDataType_Encoding_DefaultJson),
            16161 => Ok(ObjectId::WriterGroupTransportDataType_Encoding_DefaultJson),
            16280 => Ok(ObjectId::WriterGroupMessageDataType_Encoding_DefaultJson),
            16281 => Ok(ObjectId::PubSubConnectionDataType_Encoding_DefaultJson),
            16282 => Ok(ObjectId::ConnectionTransportDataType_Encoding_DefaultJson),
            16284 => Ok(ObjectId::ReaderGroupTransportDataType_Encoding_DefaultJson),
            16285 => Ok(ObjectId::ReaderGroupMessageDataType_Encoding_DefaultJson),
            16286 => Ok(ObjectId::DataSetReaderDataType_Encoding_DefaultJson),
            16287 => Ok(ObjectId::DataSetReaderTransportDataType_Encoding_DefaultJson),
            16288 => Ok(ObjectId::DataSetReaderMessageDataType_Encoding_DefaultJson),
            16289 => Ok(ObjectId::ServerType_ServerCapabilities_RoleSet),
            16295 => Ok(ObjectId::ServerCapabilitiesType_RoleSet),
            16308 => Ok(ObjectId::SubscribedDataSetDataType_Encoding_DefaultJson),
            16310 => Ok(ObjectId::TargetVariablesDataType_Encoding_DefaultJson),
            16311 => Ok(ObjectId::SubscribedDataSetMirrorDataType_Encoding_DefaultJson),
            16314 => Ok(ObjectId::FileSystem),
            16315 => Ok(ObjectId::FileSystem_FileDirectoryName_Placeholder),
            16323 => Ok(ObjectId::UadpWriterGroupMessageDataType_Encoding_DefaultJson),
            16327 => Ok(ObjectId::FileSystem_FileName_Placeholder),
            16391 => Ok(ObjectId::UadpDataSetWriterMessageDataType_Encoding_DefaultJson),
            16392 => Ok(ObjectId::UadpDataSetReaderMessageDataType_Encoding_DefaultJson),
            16393 => Ok(ObjectId::JsonWriterGroupMessageDataType_Encoding_DefaultJson),
            16394 => Ok(ObjectId::JsonDataSetWriterMessageDataType_Encoding_DefaultJson),
            16398 => Ok(ObjectId::AlarmConditionType_FirstInGroup),
            16399 => Ok(ObjectId::AlarmConditionType_AlarmGroup_Placeholder),
            16404 => Ok(ObjectId::JsonDataSetReaderMessageDataType_Encoding_DefaultJson),
            16406 => Ok(ObjectId::AlarmGroupType_AlarmConditionInstance_Placeholder),
            16502 => Ok(ObjectId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState),
            16524 => Ok(ObjectId::BrokerWriterGroupTransportDataType_Encoding_DefaultJson),
            16525 => Ok(ObjectId::BrokerDataSetWriterTransportDataType_Encoding_DefaultJson),
            16526 => Ok(ObjectId::BrokerDataSetReaderTransportDataType_Encoding_DefaultJson),
            16530 => Ok(ObjectId::AlarmGroupType_AlarmConditionInstance_Placeholder_FirstInGroup),
            16565 => Ok(ObjectId::LimitAlarmType_FirstInGroup),
            16566 => Ok(ObjectId::LimitAlarmType_AlarmGroup_Placeholder),
            16605 => Ok(ObjectId::ExclusiveLimitAlarmType_FirstInGroup),
            16606 => Ok(ObjectId::ExclusiveLimitAlarmType_AlarmGroup_Placeholder),
            16645 => Ok(ObjectId::NonExclusiveLimitAlarmType_FirstInGroup),
            16646 => Ok(ObjectId::NonExclusiveLimitAlarmType_AlarmGroup_Placeholder),
            16685 => Ok(ObjectId::NonExclusiveLevelAlarmType_FirstInGroup),
            16686 => Ok(ObjectId::NonExclusiveLevelAlarmType_AlarmGroup_Placeholder),
            16725 => Ok(ObjectId::ExclusiveLevelAlarmType_FirstInGroup),
            16726 => Ok(ObjectId::ExclusiveLevelAlarmType_AlarmGroup_Placeholder),
            16758 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_MessageSettings),
            16765 => Ok(ObjectId::NonExclusiveDeviationAlarmType_FirstInGroup),
            16766 => Ok(ObjectId::NonExclusiveDeviationAlarmType_AlarmGroup_Placeholder),
            16799 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_MessageSettings),
            16806 => Ok(ObjectId::ExclusiveDeviationAlarmType_FirstInGroup),
            16807 => Ok(ObjectId::ExclusiveDeviationAlarmType_AlarmGroup_Placeholder),
            16840 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_MessageSettings),
            16847 => Ok(ObjectId::NonExclusiveRateOfChangeAlarmType_FirstInGroup),
            16848 => Ok(ObjectId::NonExclusiveRateOfChangeAlarmType_AlarmGroup_Placeholder),
            16888 => Ok(ObjectId::ExclusiveRateOfChangeAlarmType_FirstInGroup),
            16889 => Ok(ObjectId::ExclusiveRateOfChangeAlarmType_AlarmGroup_Placeholder),
            16929 => Ok(ObjectId::DiscreteAlarmType_FirstInGroup),
            16930 => Ok(ObjectId::DiscreteAlarmType_AlarmGroup_Placeholder),
            16965 => Ok(ObjectId::OffNormalAlarmType_FirstInGroup),
            16966 => Ok(ObjectId::OffNormalAlarmType_AlarmGroup_Placeholder),
            17001 => Ok(ObjectId::SystemOffNormalAlarmType_FirstInGroup),
            17002 => Ok(ObjectId::SystemOffNormalAlarmType_AlarmGroup_Placeholder),
            17037 => Ok(ObjectId::TripAlarmType_FirstInGroup),
            17038 => Ok(ObjectId::TripAlarmType_AlarmGroup_Placeholder),
            17073 => Ok(ObjectId::CertificateExpirationAlarmType_FirstInGroup),
            17074 => Ok(ObjectId::CertificateExpirationAlarmType_AlarmGroup_Placeholder),
            17180 => Ok(ObjectId::DiscrepancyAlarmType_ShelvingState),
            17203 => Ok(ObjectId::PubSubConnectionType_TransportSettings),
            17208 => Ok(ObjectId::DiscrepancyAlarmType_FirstInGroup),
            17209 => Ok(ObjectId::DiscrepancyAlarmType_AlarmGroup_Placeholder),
            17290 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_TransportSettings),
            17291 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_MessageSettings),
            17307 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_TransportSettings),
            17308 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_MessageSettings),
            17310 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder),
            17314 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_Status),
            17325 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder),
            17329 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_Status),
            17352 => Ok(ObjectId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues),
            17371 => Ok(ObjectId::PublishSubscribe_PublishedDataSets),
            17405 => Ok(ObjectId::PublishSubscribe_Status),
            17409 => Ok(ObjectId::PublishSubscribe_Diagnostics),
            17423 => Ok(ObjectId::PublishSubscribe_Diagnostics_Counters),
            17457 => Ok(ObjectId::PublishSubscribe_Diagnostics_LiveValues),
            17468 => Ok(ObjectId::DatagramConnectionTransportDataType_Encoding_DefaultBinary),
            17476 => Ok(ObjectId::DatagramConnectionTransportDataType_Encoding_DefaultJson),
            17511 => Ok(ObjectId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder),
            17537 => Ok(ObjectId::AdditionalParametersType_Encoding_DefaultBinary),
            17547 => Ok(ObjectId::AdditionalParametersType_Encoding_DefaultJson),
            17549 => Ok(ObjectId::EphemeralKeyType_Encoding_DefaultBinary),
            17557 => Ok(ObjectId::EphemeralKeyType_Encoding_DefaultJson),
            17590 => Ok(ObjectId::DictionaryEntryType_DictionaryEntryName_Placeholder),
            17592 => Ok(ObjectId::DictionaryFolderType_DictionaryFolderName_Placeholder),
            17593 => Ok(ObjectId::DictionaryFolderType_DictionaryEntryName_Placeholder),
            17594 => Ok(ObjectId::Dictionaries),
            17595 => Ok(ObjectId::Dictionaries_DictionaryFolderName_Placeholder),
            17596 => Ok(ObjectId::Dictionaries_DictionaryEntryName_Placeholder),
            17599 => Ok(ObjectId::IrdiDictionaryEntryType_DictionaryEntryName_Placeholder),
            17601 => Ok(ObjectId::UriDictionaryEntryType_DictionaryEntryName_Placeholder),
            17610 => Ok(ObjectId::GenericAttributeValue_Encoding_DefaultBinary),
            17611 => Ok(ObjectId::GenericAttributes_Encoding_DefaultBinary),
            17708 => Ok(ObjectId::InterfaceTypes),
            17730 => Ok(ObjectId::WriterGroupType_Status),
            17732 => Ok(ObjectId::AuthorizationServices),
            17741 => Ok(ObjectId::WriterGroupType_TransportSettings),
            17742 => Ok(ObjectId::WriterGroupType_MessageSettings),
            17743 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder),
            17747 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_TransportSettings),
            17748 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_MessageSettings),
            17749 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_Status),
            17753 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics),
            17767 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters),
            17798 => Ok(ObjectId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues),
            17812 => Ok(ObjectId::WriterGroupType_Diagnostics),
            17826 => Ok(ObjectId::WriterGroupType_Diagnostics_Counters),
            17858 => Ok(ObjectId::WriterGroupType_Diagnostics_LiveValues),
            17863 => Ok(ObjectId::DecimalDataType_Encoding_DefaultBinary),
            18067 => Ok(ObjectId::ReaderGroupType_Status),
            18076 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder),
            18086 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_TransportSettings),
            18087 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_MessageSettings),
            18088 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_Status),
            18092 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics),
            18106 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters),
            18137 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues),
            18155 => Ok(ObjectId::KeyCredentialConfiguration),
            18156 => Ok(ObjectId::KeyCredentialConfiguration_ServiceName_Placeholder),
            18438 => Ok(ObjectId::InstrumentDiagnosticAlarmType_ShelvingState),
            18476 => Ok(ObjectId::InstrumentDiagnosticAlarmType_FirstInGroup),
            18486 => Ok(ObjectId::InstrumentDiagnosticAlarmType_AlarmGroup_Placeholder),
            18587 => Ok(ObjectId::SystemDiagnosticAlarmType_ShelvingState),
            18625 => Ok(ObjectId::SystemDiagnosticAlarmType_FirstInGroup),
            18635 => Ok(ObjectId::SystemDiagnosticAlarmType_AlarmGroup_Placeholder),
            18667 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics),
            18681 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters),
            18712 => Ok(ObjectId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues),
            18715 => Ok(ObjectId::PublishSubscribeType_Diagnostics),
            18729 => Ok(ObjectId::PublishSubscribeType_Diagnostics_Counters),
            18760 => Ok(ObjectId::PublishSubscribeType_Diagnostics_LiveValues),
            18815 => Ok(ObjectId::RationalNumber_Encoding_DefaultBinary),
            18816 => Ok(ObjectId::Vector_Encoding_DefaultBinary),
            18817 => Ok(ObjectId::ThreeDVector_Encoding_DefaultBinary),
            18818 => Ok(ObjectId::CartesianCoordinates_Encoding_DefaultBinary),
            18819 => Ok(ObjectId::ThreeDCartesianCoordinates_Encoding_DefaultBinary),
            18820 => Ok(ObjectId::Orientation_Encoding_DefaultBinary),
            18821 => Ok(ObjectId::ThreeDOrientation_Encoding_DefaultBinary),
            18822 => Ok(ObjectId::Frame_Encoding_DefaultBinary),
            18823 => Ok(ObjectId::ThreeDFrame_Encoding_DefaultBinary),
            18871 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics),
            18885 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters),
            18916 => Ok(ObjectId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues),
            18930 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics),
            18944 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters),
            18975 => Ok(ObjectId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues),
            18989 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics),
            19003 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters),
            19034 => Ok(ObjectId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues),
            19064 => Ok(ObjectId::RationalNumber_Encoding_DefaultJson),
            19065 => Ok(ObjectId::Vector_Encoding_DefaultJson),
            19066 => Ok(ObjectId::ThreeDVector_Encoding_DefaultJson),
            19067 => Ok(ObjectId::CartesianCoordinates_Encoding_DefaultJson),
            19068 => Ok(ObjectId::ThreeDCartesianCoordinates_Encoding_DefaultJson),
            19069 => Ok(ObjectId::Orientation_Encoding_DefaultJson),
            19070 => Ok(ObjectId::ThreeDOrientation_Encoding_DefaultJson),
            19071 => Ok(ObjectId::Frame_Encoding_DefaultJson),
            19072 => Ok(ObjectId::ThreeDFrame_Encoding_DefaultJson),
            19107 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics),
            19121 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters),
            19152 => Ok(ObjectId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues),
            19176 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics),
            19190 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters),
            19221 => Ok(ObjectId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues),
            19241 => Ok(ObjectId::PubSubConnectionType_Diagnostics),
            19255 => Ok(ObjectId::PubSubConnectionType_Diagnostics_Counters),
            19286 => Ok(ObjectId::PubSubConnectionType_Diagnostics_LiveValues),
            19388 => Ok(ObjectId::TrustListOutOfDateAlarmType_ShelvingState),
            19426 => Ok(ObjectId::TrustListOutOfDateAlarmType_FirstInGroup),
            19436 => Ok(ObjectId::TrustListOutOfDateAlarmType_AlarmGroup_Placeholder),
            19450 => Ok(ObjectId::CertificateGroupType_CertificateExpired),
            19537 => Ok(ObjectId::CertificateGroupType_CertificateExpired_ShelvingState),
            19550 => Ok(ObjectId::DataSetWriterType_Diagnostics),
            19564 => Ok(ObjectId::DataSetWriterType_Diagnostics_Counters),
            19595 => Ok(ObjectId::DataSetWriterType_Diagnostics_LiveValues),
            19609 => Ok(ObjectId::DataSetReaderType_Diagnostics),
            19623 => Ok(ObjectId::DataSetReaderType_Diagnostics_Counters),
            19654 => Ok(ObjectId::DataSetReaderType_Diagnostics_LiveValues),
            19691 => Ok(ObjectId::PubSubDiagnosticsType_Counters),
            19722 => Ok(ObjectId::PubSubDiagnosticsType_LiveValues),
            19746 => Ok(ObjectId::PubSubDiagnosticsRootType_Counters),
            19777 => Ok(ObjectId::PubSubDiagnosticsRootType_LiveValues),
            19800 => Ok(ObjectId::PubSubDiagnosticsConnectionType_Counters),
            19831 => Ok(ObjectId::PubSubDiagnosticsConnectionType_LiveValues),
            19848 => Ok(ObjectId::PubSubDiagnosticsWriterGroupType_Counters),
            19879 => Ok(ObjectId::PubSubDiagnosticsWriterGroupType_LiveValues),
            19917 => Ok(ObjectId::PubSubDiagnosticsReaderGroupType_Counters),
            19948 => Ok(ObjectId::PubSubDiagnosticsReaderGroupType_LiveValues),
            19982 => Ok(ObjectId::PubSubDiagnosticsDataSetWriterType_Counters),
            20013 => Ok(ObjectId::PubSubDiagnosticsDataSetWriterType_LiveValues),
            20041 => Ok(ObjectId::PubSubDiagnosticsDataSetReaderType_Counters),
            20072 => Ok(ObjectId::PubSubDiagnosticsDataSetReaderType_LiveValues),
            20120 => Ok(ObjectId::CertificateGroupType_CertificateExpired_FirstInGroup),
            20143 => Ok(ObjectId::CertificateGroupType_TrustListOutOfDate),
            20230 => Ok(ObjectId::CertificateGroupType_TrustListOutOfDate_ShelvingState),
            20268 => Ok(ObjectId::CertificateGroupType_TrustListOutOfDate_FirstInGroup),
            20291 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired),
            20378 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState),
            20418 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_FirstInGroup),
            20441 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate),
            20528 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState),
            20566 => Ok(ObjectId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup),
            20589 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired),
            20676 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState),
            20714 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_FirstInGroup),
            20737 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate),
            20824 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState),
            20862 => Ok(ObjectId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup),
            20885 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired),
            20972 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState),
            21001 => Ok(ObjectId::SessionlessInvokeResponseType_Encoding_DefaultBinary),
            21006 => Ok(ObjectId::ReaderGroupType_DataSetReaderName_Placeholder_SubscribedDataSet),
            21015 => Ok(ObjectId::ReaderGroupType_Diagnostics),
            21029 => Ok(ObjectId::ReaderGroupType_Diagnostics_Counters),
            21060 => Ok(ObjectId::ReaderGroupType_Diagnostics_LiveValues),
            21080 => Ok(ObjectId::ReaderGroupType_TransportSettings),
            21081 => Ok(ObjectId::ReaderGroupType_MessageSettings),
            21095 => Ok(ObjectId::DataSetWriterType_MessageSettings),
            21103 => Ok(ObjectId::DataSetReaderType_MessageSettings),
            21150 => Ok(ObjectId::WriterGroupDataType_Encoding_DefaultBinary),
            21151 => Ok(ObjectId::NetworkAddressDataType_Encoding_DefaultBinary),
            21152 => Ok(ObjectId::NetworkAddressUrlDataType_Encoding_DefaultBinary),
            21153 => Ok(ObjectId::ReaderGroupDataType_Encoding_DefaultBinary),
            21154 => Ok(ObjectId::PubSubConfigurationDataType_Encoding_DefaultBinary),
            21155 => Ok(ObjectId::DatagramWriterGroupTransportDataType_Encoding_DefaultBinary),
            21198 => Ok(ObjectId::WriterGroupDataType_Encoding_DefaultJson),
            21199 => Ok(ObjectId::NetworkAddressDataType_Encoding_DefaultJson),
            21200 => Ok(ObjectId::NetworkAddressUrlDataType_Encoding_DefaultJson),
            21201 => Ok(ObjectId::ReaderGroupDataType_Encoding_DefaultJson),
            21202 => Ok(ObjectId::PubSubConfigurationDataType_Encoding_DefaultJson),
            21203 => Ok(ObjectId::DatagramWriterGroupTransportDataType_Encoding_DefaultJson),
            21213 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_FirstInGroup),
            21236 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate),
            21323 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState),
            21361 => Ok(ObjectId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup),
            21384 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired),
            21471 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState),
            21509 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_FirstInGroup),
            21532 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate),
            21619 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState),
            21657 => Ok(ObjectId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_FirstInGroup),
            21680 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired),
            21767 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState),
            21805 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup),
            21828 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate),
            21915 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState),
            21953 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup),
            21976 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired),
            22063 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState),
            22101 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup),
            22124 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate),
            22211 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState),
            22249 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup),
            22272 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired),
            22359 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState),
            22397 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup),
            22420 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate),
            22507 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState),
            22545 => Ok(ObjectId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup),
            22568 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired),
            22655 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState),
            22693 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroup),
            22716 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate),
            22803 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState),
            22841 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroup),
            22864 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired),
            22951 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState),
            22989 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroup),
            23012 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate),
            23099 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState),
            23137 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroup),
            23160 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired),
            23247 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState),
            23285 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroup),
            23308 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate),
            23395 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState),
            23433 => Ok(ObjectId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroup),
            23457 => Ok(ObjectId::AliasNameCategoryType_Alias_Placeholder),
            23458 => Ok(ObjectId::AliasNameCategoryType_SubAliasNameCategories_Placeholder),
            23470 => Ok(ObjectId::Aliases),
            23471 => Ok(ObjectId::Aliases_Alias_Placeholder),
            23472 => Ok(ObjectId::Aliases_SubAliasNameCategories_Placeholder),
            23479 => Ok(ObjectId::TagVariables),
            23480 => Ok(ObjectId::TagVariables_Alias_Placeholder),
            23481 => Ok(ObjectId::TagVariables_SubAliasNameCategories_Placeholder),
            23488 => Ok(ObjectId::Topics),
            23489 => Ok(ObjectId::Topics_Alias_Placeholder),
            23490 => Ok(ObjectId::Topics_SubAliasNameCategories_Placeholder),
            23499 => Ok(ObjectId::AliasNameDataType_Encoding_DefaultBinary),
            23500 => Ok(ObjectId::ReadAnnotationDataDetails_Encoding_DefaultBinary),
            23507 => Ok(ObjectId::CurrencyUnitType_Encoding_DefaultBinary),
            23511 => Ok(ObjectId::AliasNameDataType_Encoding_DefaultJson),
            23512 => Ok(ObjectId::ReadAnnotationDataDetails_Encoding_DefaultJson),
            23519 => Ok(ObjectId::OrderedListType_OrderedObject_Placeholder),
            23528 => Ok(ObjectId::CurrencyUnitType_Encoding_DefaultJson),
            23557 => Ok(ObjectId::AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder),
            _ => Err(())
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum VariableId {
    DataTypeDescriptionType_DataTypeVersion = 104,
    DataTypeDescriptionType_DictionaryFragment = 105,
    DataTypeDictionaryType_DataTypeVersion = 106,
    DataTypeDictionaryType_NamespaceUri = 107,
    ModellingRuleType_NamingRule = 111,
    ModellingRule_Mandatory_NamingRule = 112,
    ModellingRule_Optional_NamingRule = 113,
    ModellingRule_ExposesItsArray_NamingRule = 114,
    ServerType_ServerArray = 2005,
    ServerType_NamespaceArray = 2006,
    ServerType_ServerStatus = 2007,
    ServerType_ServiceLevel = 2008,
    ServerCapabilitiesType_ServerProfileArray = 2014,
    ServerCapabilitiesType_LocaleIdArray = 2016,
    ServerCapabilitiesType_MinSupportedSampleRate = 2017,
    ServerDiagnosticsType_ServerDiagnosticsSummary = 2021,
    ServerDiagnosticsType_SamplingIntervalDiagnosticsArray = 2022,
    ServerDiagnosticsType_SubscriptionDiagnosticsArray = 2023,
    ServerDiagnosticsType_EnabledFlag = 2025,
    SessionsDiagnosticsSummaryType_SessionDiagnosticsArray = 2027,
    SessionsDiagnosticsSummaryType_SessionSecurityDiagnosticsArray = 2028,
    SessionDiagnosticsObjectType_SessionDiagnostics = 2030,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics = 2031,
    SessionDiagnosticsObjectType_SubscriptionDiagnosticsArray = 2032,
    ServerRedundancyType_RedundancySupport = 2035,
    TransparentRedundancyType_CurrentServerId = 2037,
    TransparentRedundancyType_RedundantServerArray = 2038,
    NonTransparentRedundancyType_ServerUriArray = 2040,
    BaseEventType_EventId = 2042,
    BaseEventType_EventType = 2043,
    BaseEventType_SourceNode = 2044,
    BaseEventType_SourceName = 2045,
    BaseEventType_Time = 2046,
    BaseEventType_ReceiveTime = 2047,
    BaseEventType_Message = 2050,
    BaseEventType_Severity = 2051,
    AuditEventType_ActionTimeStamp = 2053,
    AuditEventType_Status = 2054,
    AuditEventType_ServerId = 2055,
    AuditEventType_ClientAuditEntryId = 2056,
    AuditEventType_ClientUserId = 2057,
    AuditOpenSecureChannelEventType_ClientCertificate = 2061,
    AuditOpenSecureChannelEventType_RequestType = 2062,
    AuditOpenSecureChannelEventType_SecurityPolicyUri = 2063,
    AuditOpenSecureChannelEventType_SecurityMode = 2065,
    AuditOpenSecureChannelEventType_RequestedLifetime = 2066,
    AuditSessionEventType_SessionId = 2070,
    AuditCreateSessionEventType_SecureChannelId = 2072,
    AuditCreateSessionEventType_ClientCertificate = 2073,
    AuditCreateSessionEventType_RevisedSessionTimeout = 2074,
    AuditActivateSessionEventType_ClientSoftwareCertificates = 2076,
    AuditActivateSessionEventType_UserIdentityToken = 2077,
    AuditCancelEventType_RequestHandle = 2079,
    AuditCertificateEventType_Certificate = 2081,
    AuditCertificateDataMismatchEventType_InvalidHostname = 2083,
    AuditCertificateDataMismatchEventType_InvalidUri = 2084,
    AuditAddNodesEventType_NodesToAdd = 2092,
    AuditDeleteNodesEventType_NodesToDelete = 2094,
    AuditAddReferencesEventType_ReferencesToAdd = 2096,
    AuditDeleteReferencesEventType_ReferencesToDelete = 2098,
    AuditWriteUpdateEventType_IndexRange = 2101,
    AuditWriteUpdateEventType_OldValue = 2102,
    AuditWriteUpdateEventType_NewValue = 2103,
    AuditUpdateMethodEventType_MethodId = 2128,
    AuditUpdateMethodEventType_InputArguments = 2129,
    GeneralModelChangeEventType_Changes = 2134,
    ServerStatusType_StartTime = 2139,
    ServerStatusType_CurrentTime = 2140,
    ServerStatusType_State = 2141,
    ServerStatusType_BuildInfo = 2142,
    ServerDiagnosticsSummaryType_ServerViewCount = 2151,
    ServerDiagnosticsSummaryType_CurrentSessionCount = 2152,
    ServerDiagnosticsSummaryType_CumulatedSessionCount = 2153,
    ServerDiagnosticsSummaryType_SecurityRejectedSessionCount = 2154,
    ServerDiagnosticsSummaryType_RejectedSessionCount = 2155,
    ServerDiagnosticsSummaryType_SessionTimeoutCount = 2156,
    ServerDiagnosticsSummaryType_SessionAbortCount = 2157,
    ServerDiagnosticsSummaryType_PublishingIntervalCount = 2159,
    ServerDiagnosticsSummaryType_CurrentSubscriptionCount = 2160,
    ServerDiagnosticsSummaryType_CumulatedSubscriptionCount = 2161,
    ServerDiagnosticsSummaryType_SecurityRejectedRequestsCount = 2162,
    ServerDiagnosticsSummaryType_RejectedRequestsCount = 2163,
    SamplingIntervalDiagnosticsType_SamplingInterval = 2166,
    SubscriptionDiagnosticsType_SessionId = 2173,
    SubscriptionDiagnosticsType_SubscriptionId = 2174,
    SubscriptionDiagnosticsType_Priority = 2175,
    SubscriptionDiagnosticsType_PublishingInterval = 2176,
    SubscriptionDiagnosticsType_MaxKeepAliveCount = 2177,
    SubscriptionDiagnosticsType_MaxNotificationsPerPublish = 2179,
    SubscriptionDiagnosticsType_PublishingEnabled = 2180,
    SubscriptionDiagnosticsType_ModifyCount = 2181,
    SubscriptionDiagnosticsType_EnableCount = 2182,
    SubscriptionDiagnosticsType_DisableCount = 2183,
    SubscriptionDiagnosticsType_RepublishRequestCount = 2184,
    SubscriptionDiagnosticsType_RepublishMessageRequestCount = 2185,
    SubscriptionDiagnosticsType_RepublishMessageCount = 2186,
    SubscriptionDiagnosticsType_TransferRequestCount = 2187,
    SubscriptionDiagnosticsType_TransferredToAltClientCount = 2188,
    SubscriptionDiagnosticsType_TransferredToSameClientCount = 2189,
    SubscriptionDiagnosticsType_PublishRequestCount = 2190,
    SubscriptionDiagnosticsType_DataChangeNotificationsCount = 2191,
    SubscriptionDiagnosticsType_NotificationsCount = 2193,
    SessionDiagnosticsVariableType_SessionId = 2198,
    SessionDiagnosticsVariableType_SessionName = 2199,
    SessionDiagnosticsVariableType_ClientDescription = 2200,
    SessionDiagnosticsVariableType_ServerUri = 2201,
    SessionDiagnosticsVariableType_EndpointUrl = 2202,
    SessionDiagnosticsVariableType_LocaleIds = 2203,
    SessionDiagnosticsVariableType_ActualSessionTimeout = 2204,
    SessionDiagnosticsVariableType_ClientConnectionTime = 2205,
    SessionDiagnosticsVariableType_ClientLastContactTime = 2206,
    SessionDiagnosticsVariableType_CurrentSubscriptionsCount = 2207,
    SessionDiagnosticsVariableType_CurrentMonitoredItemsCount = 2208,
    SessionDiagnosticsVariableType_CurrentPublishRequestsInQueue = 2209,
    SessionDiagnosticsVariableType_ReadCount = 2217,
    SessionDiagnosticsVariableType_HistoryReadCount = 2218,
    SessionDiagnosticsVariableType_WriteCount = 2219,
    SessionDiagnosticsVariableType_HistoryUpdateCount = 2220,
    SessionDiagnosticsVariableType_CallCount = 2221,
    SessionDiagnosticsVariableType_CreateMonitoredItemsCount = 2222,
    SessionDiagnosticsVariableType_ModifyMonitoredItemsCount = 2223,
    SessionDiagnosticsVariableType_SetMonitoringModeCount = 2224,
    SessionDiagnosticsVariableType_SetTriggeringCount = 2225,
    SessionDiagnosticsVariableType_DeleteMonitoredItemsCount = 2226,
    SessionDiagnosticsVariableType_CreateSubscriptionCount = 2227,
    SessionDiagnosticsVariableType_ModifySubscriptionCount = 2228,
    SessionDiagnosticsVariableType_SetPublishingModeCount = 2229,
    SessionDiagnosticsVariableType_PublishCount = 2230,
    SessionDiagnosticsVariableType_RepublishCount = 2231,
    SessionDiagnosticsVariableType_TransferSubscriptionsCount = 2232,
    SessionDiagnosticsVariableType_DeleteSubscriptionsCount = 2233,
    SessionDiagnosticsVariableType_AddNodesCount = 2234,
    SessionDiagnosticsVariableType_AddReferencesCount = 2235,
    SessionDiagnosticsVariableType_DeleteNodesCount = 2236,
    SessionDiagnosticsVariableType_DeleteReferencesCount = 2237,
    SessionDiagnosticsVariableType_BrowseCount = 2238,
    SessionDiagnosticsVariableType_BrowseNextCount = 2239,
    SessionDiagnosticsVariableType_TranslateBrowsePathsToNodeIdsCount = 2240,
    SessionDiagnosticsVariableType_QueryFirstCount = 2241,
    SessionDiagnosticsVariableType_QueryNextCount = 2242,
    SessionSecurityDiagnosticsType_SessionId = 2245,
    SessionSecurityDiagnosticsType_ClientUserIdOfSession = 2246,
    SessionSecurityDiagnosticsType_ClientUserIdHistory = 2247,
    SessionSecurityDiagnosticsType_AuthenticationMechanism = 2248,
    SessionSecurityDiagnosticsType_Encoding = 2249,
    SessionSecurityDiagnosticsType_TransportProtocol = 2250,
    SessionSecurityDiagnosticsType_SecurityMode = 2251,
    SessionSecurityDiagnosticsType_SecurityPolicyUri = 2252,
    Server_ServerArray = 2254,
    Server_NamespaceArray = 2255,
    Server_ServerStatus = 2256,
    Server_ServerStatus_StartTime = 2257,
    Server_ServerStatus_CurrentTime = 2258,
    Server_ServerStatus_State = 2259,
    Server_ServerStatus_BuildInfo = 2260,
    Server_ServerStatus_BuildInfo_ProductName = 2261,
    Server_ServerStatus_BuildInfo_ProductUri = 2262,
    Server_ServerStatus_BuildInfo_ManufacturerName = 2263,
    Server_ServerStatus_BuildInfo_SoftwareVersion = 2264,
    Server_ServerStatus_BuildInfo_BuildNumber = 2265,
    Server_ServerStatus_BuildInfo_BuildDate = 2266,
    Server_ServiceLevel = 2267,
    Server_ServerCapabilities_ServerProfileArray = 2269,
    Server_ServerCapabilities_LocaleIdArray = 2271,
    Server_ServerCapabilities_MinSupportedSampleRate = 2272,
    Server_ServerDiagnostics_ServerDiagnosticsSummary = 2275,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount = 2276,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount = 2277,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount = 2278,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount = 2279,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount = 2281,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount = 2282,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount = 2284,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount = 2285,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount = 2286,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount = 2287,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount = 2288,
    Server_ServerDiagnostics_SamplingIntervalDiagnosticsArray = 2289,
    Server_ServerDiagnostics_SubscriptionDiagnosticsArray = 2290,
    Server_ServerDiagnostics_EnabledFlag = 2294,
    StateType_StateNumber = 2308,
    TransitionType_TransitionNumber = 2312,
    HistoricalDataConfigurationType_Stepped = 2323,
    HistoricalDataConfigurationType_Definition = 2324,
    HistoricalDataConfigurationType_MaxTimeInterval = 2325,
    HistoricalDataConfigurationType_MinTimeInterval = 2326,
    HistoricalDataConfigurationType_ExceptionDeviation = 2327,
    HistoricalDataConfigurationType_ExceptionDeviationFormat = 2328,
    HistoryServerCapabilitiesType_AccessHistoryDataCapability = 2331,
    HistoryServerCapabilitiesType_AccessHistoryEventsCapability = 2332,
    HistoryServerCapabilitiesType_InsertDataCapability = 2334,
    HistoryServerCapabilitiesType_ReplaceDataCapability = 2335,
    HistoryServerCapabilitiesType_UpdateDataCapability = 2336,
    HistoryServerCapabilitiesType_DeleteRawCapability = 2337,
    HistoryServerCapabilitiesType_DeleteAtTimeCapability = 2338,
    DataItemType_Definition = 2366,
    DataItemType_ValuePrecision = 2367,
    AnalogItemType_EURange = 2369,
    AnalogItemType_InstrumentRange = 2370,
    AnalogItemType_EngineeringUnits = 2371,
    TwoStateDiscreteType_FalseState = 2374,
    TwoStateDiscreteType_TrueState = 2375,
    MultiStateDiscreteType_EnumStrings = 2377,
    ProgramTransitionEventType_IntermediateResult = 2379,
    ProgramDiagnosticType_CreateSessionId = 2381,
    ProgramDiagnosticType_CreateClientName = 2382,
    ProgramDiagnosticType_InvocationCreationTime = 2383,
    ProgramDiagnosticType_LastTransitionTime = 2384,
    ProgramDiagnosticType_LastMethodCall = 2385,
    ProgramDiagnosticType_LastMethodSessionId = 2386,
    ProgramDiagnosticType_LastMethodInputArguments = 2387,
    ProgramDiagnosticType_LastMethodOutputArguments = 2388,
    ProgramDiagnosticType_LastMethodCallTime = 2389,
    ProgramDiagnosticType_LastMethodReturnStatus = 2390,
    ProgramStateMachineType_Creatable = 2392,
    ProgramStateMachineType_Deletable = 2393,
    ProgramStateMachineType_AutoDelete = 2394,
    ProgramStateMachineType_RecycleCount = 2395,
    ProgramStateMachineType_InstanceCount = 2396,
    ProgramStateMachineType_MaxInstanceCount = 2397,
    ProgramStateMachineType_MaxRecycleCount = 2398,
    ProgramStateMachineType_ProgramDiagnostic = 2399,
    ProgramStateMachineType_Ready_StateNumber = 2401,
    ProgramStateMachineType_Running_StateNumber = 2403,
    ProgramStateMachineType_Suspended_StateNumber = 2405,
    ProgramStateMachineType_Halted_StateNumber = 2407,
    ProgramStateMachineType_HaltedToReady_TransitionNumber = 2409,
    ProgramStateMachineType_ReadyToRunning_TransitionNumber = 2411,
    ProgramStateMachineType_RunningToHalted_TransitionNumber = 2413,
    ProgramStateMachineType_RunningToReady_TransitionNumber = 2415,
    ProgramStateMachineType_RunningToSuspended_TransitionNumber = 2417,
    ProgramStateMachineType_SuspendedToRunning_TransitionNumber = 2419,
    ProgramStateMachineType_SuspendedToHalted_TransitionNumber = 2421,
    ProgramStateMachineType_SuspendedToReady_TransitionNumber = 2423,
    ProgramStateMachineType_ReadyToHalted_TransitionNumber = 2425,
    SessionDiagnosticsVariableType_RegisterNodesCount = 2730,
    SessionDiagnosticsVariableType_UnregisterNodesCount = 2731,
    ServerCapabilitiesType_MaxBrowseContinuationPoints = 2732,
    ServerCapabilitiesType_MaxQueryContinuationPoints = 2733,
    ServerCapabilitiesType_MaxHistoryContinuationPoints = 2734,
    Server_ServerCapabilities_MaxBrowseContinuationPoints = 2735,
    Server_ServerCapabilities_MaxQueryContinuationPoints = 2736,
    Server_ServerCapabilities_MaxHistoryContinuationPoints = 2737,
    SemanticChangeEventType_Changes = 2739,
    ServerType_Auditing = 2742,
    AuditChannelEventType_SecureChannelId = 2745,
    AuditOpenSecureChannelEventType_ClientCertificateThumbprint = 2746,
    AuditCreateSessionEventType_ClientCertificateThumbprint = 2747,
    AuditUrlMismatchEventType_EndpointUrl = 2749,
    AuditWriteUpdateEventType_AttributeId = 2750,
    AuditHistoryUpdateEventType_ParameterDataTypeId = 2751,
    ServerStatusType_SecondsTillShutdown = 2752,
    ServerStatusType_ShutdownReason = 2753,
    StateVariableType_Id = 2756,
    StateVariableType_Name = 2757,
    StateVariableType_Number = 2758,
    StateVariableType_EffectiveDisplayName = 2759,
    FiniteStateVariableType_Id = 2761,
    TransitionVariableType_Id = 2763,
    TransitionVariableType_Name = 2764,
    TransitionVariableType_Number = 2765,
    TransitionVariableType_TransitionTime = 2766,
    FiniteTransitionVariableType_Id = 2768,
    StateMachineType_CurrentState = 2769,
    StateMachineType_LastTransition = 2770,
    FiniteStateMachineType_CurrentState = 2772,
    FiniteStateMachineType_LastTransition = 2773,
    TransitionEventType_Transition = 2774,
    TransitionEventType_FromState = 2775,
    TransitionEventType_ToState = 2776,
    AuditUpdateStateEventType_OldStateId = 2777,
    AuditUpdateStateEventType_NewStateId = 2778,
    DialogConditionType_Prompt = 2831,
    ShelvedStateMachineType_TimedShelve_InputArguments = 2991,
    Server_ServerStatus_SecondsTillShutdown = 2992,
    Server_ServerStatus_ShutdownReason = 2993,
    Server_Auditing = 2994,
    SubscriptionDiagnosticsType_EventNotificationsCount = 2998,
    AuditHistoryEventUpdateEventType_Filter = 3003,
    AuditHistoryRawModifyDeleteEventType_IsDeleteModified = 3015,
    AuditHistoryRawModifyDeleteEventType_StartTime = 3016,
    AuditHistoryRawModifyDeleteEventType_EndTime = 3017,
    AuditHistoryAtTimeDeleteEventType_ReqTimes = 3020,
    AuditHistoryAtTimeDeleteEventType_OldValues = 3021,
    AuditHistoryEventDeleteEventType_EventIds = 3023,
    AuditHistoryEventDeleteEventType_OldValues = 3024,
    AuditHistoryEventUpdateEventType_UpdatedNode = 3025,
    AuditHistoryValueUpdateEventType_UpdatedNode = 3026,
    AuditHistoryDeleteEventType_UpdatedNode = 3027,
    AuditHistoryEventUpdateEventType_PerformInsertReplace = 3028,
    AuditHistoryEventUpdateEventType_NewValues = 3029,
    AuditHistoryEventUpdateEventType_OldValues = 3030,
    AuditHistoryValueUpdateEventType_PerformInsertReplace = 3031,
    AuditHistoryValueUpdateEventType_NewValues = 3032,
    AuditHistoryValueUpdateEventType_OldValues = 3033,
    AuditHistoryRawModifyDeleteEventType_OldValues = 3034,
    ServerCapabilitiesType_SoftwareCertificates = 3049,
    SessionDiagnosticsVariableType_MaxResponseMessageSize = 3050,
    BuildInfoType_ProductUri = 3052,
    BuildInfoType_ManufacturerName = 3053,
    BuildInfoType_ProductName = 3054,
    BuildInfoType_SoftwareVersion = 3055,
    BuildInfoType_BuildNumber = 3056,
    BuildInfoType_BuildDate = 3057,
    SessionSecurityDiagnosticsType_ClientCertificate = 3058,
    Icon = 3067,
    NodeVersion = 3068,
    LocalTime = 3069,
    AllowNulls = 3070,
    EnumValues = 3071,
    InputArguments = 3072,
    OutputArguments = 3073,
    ServerType_ServerStatus_StartTime = 3074,
    ServerType_ServerStatus_CurrentTime = 3075,
    ServerType_ServerStatus_State = 3076,
    ServerType_ServerStatus_BuildInfo = 3077,
    ServerType_ServerStatus_BuildInfo_ProductUri = 3078,
    ServerType_ServerStatus_BuildInfo_ManufacturerName = 3079,
    ServerType_ServerStatus_BuildInfo_ProductName = 3080,
    ServerType_ServerStatus_BuildInfo_SoftwareVersion = 3081,
    ServerType_ServerStatus_BuildInfo_BuildNumber = 3082,
    ServerType_ServerStatus_BuildInfo_BuildDate = 3083,
    ServerType_ServerStatus_SecondsTillShutdown = 3084,
    ServerType_ServerStatus_ShutdownReason = 3085,
    ServerType_ServerCapabilities_ServerProfileArray = 3086,
    ServerType_ServerCapabilities_LocaleIdArray = 3087,
    ServerType_ServerCapabilities_MinSupportedSampleRate = 3088,
    ServerType_ServerCapabilities_MaxBrowseContinuationPoints = 3089,
    ServerType_ServerCapabilities_MaxQueryContinuationPoints = 3090,
    ServerType_ServerCapabilities_MaxHistoryContinuationPoints = 3091,
    ServerType_ServerCapabilities_SoftwareCertificates = 3092,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary = 3095,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount = 3096,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount = 3097,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount = 3098,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount = 3099,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount = 3100,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount = 3101,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount = 3102,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount = 3104,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount = 3105,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount = 3106,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount = 3107,
    ServerType_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount = 3108,
    ServerType_ServerDiagnostics_SamplingIntervalDiagnosticsArray = 3109,
    ServerType_ServerDiagnostics_SubscriptionDiagnosticsArray = 3110,
    ServerType_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray = 3112,
    ServerType_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray = 3113,
    ServerType_ServerDiagnostics_EnabledFlag = 3114,
    ServerType_ServerRedundancy_RedundancySupport = 3115,
    ServerDiagnosticsType_ServerDiagnosticsSummary_ServerViewCount = 3116,
    ServerDiagnosticsType_ServerDiagnosticsSummary_CurrentSessionCount = 3117,
    ServerDiagnosticsType_ServerDiagnosticsSummary_CumulatedSessionCount = 3118,
    ServerDiagnosticsType_ServerDiagnosticsSummary_SecurityRejectedSessionCount = 3119,
    ServerDiagnosticsType_ServerDiagnosticsSummary_RejectedSessionCount = 3120,
    ServerDiagnosticsType_ServerDiagnosticsSummary_SessionTimeoutCount = 3121,
    ServerDiagnosticsType_ServerDiagnosticsSummary_SessionAbortCount = 3122,
    ServerDiagnosticsType_ServerDiagnosticsSummary_PublishingIntervalCount = 3124,
    ServerDiagnosticsType_ServerDiagnosticsSummary_CurrentSubscriptionCount = 3125,
    ServerDiagnosticsType_ServerDiagnosticsSummary_CumulatedSubscriptionCount = 3126,
    ServerDiagnosticsType_ServerDiagnosticsSummary_SecurityRejectedRequestsCount = 3127,
    ServerDiagnosticsType_ServerDiagnosticsSummary_RejectedRequestsCount = 3128,
    ServerDiagnosticsType_SessionsDiagnosticsSummary_SessionDiagnosticsArray = 3129,
    ServerDiagnosticsType_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray = 3130,
    SessionDiagnosticsObjectType_SessionDiagnostics_SessionId = 3131,
    SessionDiagnosticsObjectType_SessionDiagnostics_SessionName = 3132,
    SessionDiagnosticsObjectType_SessionDiagnostics_ClientDescription = 3133,
    SessionDiagnosticsObjectType_SessionDiagnostics_ServerUri = 3134,
    SessionDiagnosticsObjectType_SessionDiagnostics_EndpointUrl = 3135,
    SessionDiagnosticsObjectType_SessionDiagnostics_LocaleIds = 3136,
    SessionDiagnosticsObjectType_SessionDiagnostics_ActualSessionTimeout = 3137,
    SessionDiagnosticsObjectType_SessionDiagnostics_MaxResponseMessageSize = 3138,
    SessionDiagnosticsObjectType_SessionDiagnostics_ClientConnectionTime = 3139,
    SessionDiagnosticsObjectType_SessionDiagnostics_ClientLastContactTime = 3140,
    SessionDiagnosticsObjectType_SessionDiagnostics_CurrentSubscriptionsCount = 3141,
    SessionDiagnosticsObjectType_SessionDiagnostics_CurrentMonitoredItemsCount = 3142,
    SessionDiagnosticsObjectType_SessionDiagnostics_CurrentPublishRequestsInQueue = 3143,
    SessionDiagnosticsObjectType_SessionDiagnostics_ReadCount = 3151,
    SessionDiagnosticsObjectType_SessionDiagnostics_HistoryReadCount = 3152,
    SessionDiagnosticsObjectType_SessionDiagnostics_WriteCount = 3153,
    SessionDiagnosticsObjectType_SessionDiagnostics_HistoryUpdateCount = 3154,
    SessionDiagnosticsObjectType_SessionDiagnostics_CallCount = 3155,
    SessionDiagnosticsObjectType_SessionDiagnostics_CreateMonitoredItemsCount = 3156,
    SessionDiagnosticsObjectType_SessionDiagnostics_ModifyMonitoredItemsCount = 3157,
    SessionDiagnosticsObjectType_SessionDiagnostics_SetMonitoringModeCount = 3158,
    SessionDiagnosticsObjectType_SessionDiagnostics_SetTriggeringCount = 3159,
    SessionDiagnosticsObjectType_SessionDiagnostics_DeleteMonitoredItemsCount = 3160,
    SessionDiagnosticsObjectType_SessionDiagnostics_CreateSubscriptionCount = 3161,
    SessionDiagnosticsObjectType_SessionDiagnostics_ModifySubscriptionCount = 3162,
    SessionDiagnosticsObjectType_SessionDiagnostics_SetPublishingModeCount = 3163,
    SessionDiagnosticsObjectType_SessionDiagnostics_PublishCount = 3164,
    SessionDiagnosticsObjectType_SessionDiagnostics_RepublishCount = 3165,
    SessionDiagnosticsObjectType_SessionDiagnostics_TransferSubscriptionsCount = 3166,
    SessionDiagnosticsObjectType_SessionDiagnostics_DeleteSubscriptionsCount = 3167,
    SessionDiagnosticsObjectType_SessionDiagnostics_AddNodesCount = 3168,
    SessionDiagnosticsObjectType_SessionDiagnostics_AddReferencesCount = 3169,
    SessionDiagnosticsObjectType_SessionDiagnostics_DeleteNodesCount = 3170,
    SessionDiagnosticsObjectType_SessionDiagnostics_DeleteReferencesCount = 3171,
    SessionDiagnosticsObjectType_SessionDiagnostics_BrowseCount = 3172,
    SessionDiagnosticsObjectType_SessionDiagnostics_BrowseNextCount = 3173,
    SessionDiagnosticsObjectType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount = 3174,
    SessionDiagnosticsObjectType_SessionDiagnostics_QueryFirstCount = 3175,
    SessionDiagnosticsObjectType_SessionDiagnostics_QueryNextCount = 3176,
    SessionDiagnosticsObjectType_SessionDiagnostics_RegisterNodesCount = 3177,
    SessionDiagnosticsObjectType_SessionDiagnostics_UnregisterNodesCount = 3178,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SessionId = 3179,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdOfSession = 3180,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdHistory = 3181,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_AuthenticationMechanism = 3182,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_Encoding = 3183,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_TransportProtocol = 3184,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityMode = 3185,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityPolicyUri = 3186,
    SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientCertificate = 3187,
    TransparentRedundancyType_RedundancySupport = 3188,
    NonTransparentRedundancyType_RedundancySupport = 3189,
    BaseEventType_LocalTime = 3190,
    EventQueueOverflowEventType_EventId = 3191,
    EventQueueOverflowEventType_EventType = 3192,
    EventQueueOverflowEventType_SourceNode = 3193,
    EventQueueOverflowEventType_SourceName = 3194,
    EventQueueOverflowEventType_Time = 3195,
    EventQueueOverflowEventType_ReceiveTime = 3196,
    EventQueueOverflowEventType_LocalTime = 3197,
    EventQueueOverflowEventType_Message = 3198,
    EventQueueOverflowEventType_Severity = 3199,
    AuditEventType_EventId = 3200,
    AuditEventType_EventType = 3201,
    AuditEventType_SourceNode = 3202,
    AuditEventType_SourceName = 3203,
    AuditEventType_Time = 3204,
    AuditEventType_ReceiveTime = 3205,
    AuditEventType_LocalTime = 3206,
    AuditEventType_Message = 3207,
    AuditEventType_Severity = 3208,
    AuditSecurityEventType_EventId = 3209,
    AuditSecurityEventType_EventType = 3210,
    AuditSecurityEventType_SourceNode = 3211,
    AuditSecurityEventType_SourceName = 3212,
    AuditSecurityEventType_Time = 3213,
    AuditSecurityEventType_ReceiveTime = 3214,
    AuditSecurityEventType_LocalTime = 3215,
    AuditSecurityEventType_Message = 3216,
    AuditSecurityEventType_Severity = 3217,
    AuditSecurityEventType_ActionTimeStamp = 3218,
    AuditSecurityEventType_Status = 3219,
    AuditSecurityEventType_ServerId = 3220,
    AuditSecurityEventType_ClientAuditEntryId = 3221,
    AuditSecurityEventType_ClientUserId = 3222,
    AuditChannelEventType_EventId = 3223,
    AuditChannelEventType_EventType = 3224,
    AuditChannelEventType_SourceNode = 3225,
    AuditChannelEventType_SourceName = 3226,
    AuditChannelEventType_Time = 3227,
    AuditChannelEventType_ReceiveTime = 3228,
    AuditChannelEventType_LocalTime = 3229,
    AuditChannelEventType_Message = 3230,
    AuditChannelEventType_Severity = 3231,
    AuditChannelEventType_ActionTimeStamp = 3232,
    AuditChannelEventType_Status = 3233,
    AuditChannelEventType_ServerId = 3234,
    AuditChannelEventType_ClientAuditEntryId = 3235,
    AuditChannelEventType_ClientUserId = 3236,
    AuditOpenSecureChannelEventType_EventId = 3237,
    AuditOpenSecureChannelEventType_EventType = 3238,
    AuditOpenSecureChannelEventType_SourceNode = 3239,
    AuditOpenSecureChannelEventType_SourceName = 3240,
    AuditOpenSecureChannelEventType_Time = 3241,
    AuditOpenSecureChannelEventType_ReceiveTime = 3242,
    AuditOpenSecureChannelEventType_LocalTime = 3243,
    AuditOpenSecureChannelEventType_Message = 3244,
    AuditOpenSecureChannelEventType_Severity = 3245,
    AuditOpenSecureChannelEventType_ActionTimeStamp = 3246,
    AuditOpenSecureChannelEventType_Status = 3247,
    AuditOpenSecureChannelEventType_ServerId = 3248,
    AuditOpenSecureChannelEventType_ClientAuditEntryId = 3249,
    AuditOpenSecureChannelEventType_ClientUserId = 3250,
    AuditOpenSecureChannelEventType_SecureChannelId = 3251,
    AuditSessionEventType_EventId = 3252,
    AuditSessionEventType_EventType = 3253,
    AuditSessionEventType_SourceNode = 3254,
    AuditSessionEventType_SourceName = 3255,
    AuditSessionEventType_Time = 3256,
    AuditSessionEventType_ReceiveTime = 3257,
    AuditSessionEventType_LocalTime = 3258,
    AuditSessionEventType_Message = 3259,
    AuditSessionEventType_Severity = 3260,
    AuditSessionEventType_ActionTimeStamp = 3261,
    AuditSessionEventType_Status = 3262,
    AuditSessionEventType_ServerId = 3263,
    AuditSessionEventType_ClientAuditEntryId = 3264,
    AuditSessionEventType_ClientUserId = 3265,
    AuditCreateSessionEventType_EventId = 3266,
    AuditCreateSessionEventType_EventType = 3267,
    AuditCreateSessionEventType_SourceNode = 3268,
    AuditCreateSessionEventType_SourceName = 3269,
    AuditCreateSessionEventType_Time = 3270,
    AuditCreateSessionEventType_ReceiveTime = 3271,
    AuditCreateSessionEventType_LocalTime = 3272,
    AuditCreateSessionEventType_Message = 3273,
    AuditCreateSessionEventType_Severity = 3274,
    AuditCreateSessionEventType_ActionTimeStamp = 3275,
    AuditCreateSessionEventType_Status = 3276,
    AuditCreateSessionEventType_ServerId = 3277,
    AuditCreateSessionEventType_ClientAuditEntryId = 3278,
    AuditCreateSessionEventType_ClientUserId = 3279,
    AuditUrlMismatchEventType_EventId = 3281,
    AuditUrlMismatchEventType_EventType = 3282,
    AuditUrlMismatchEventType_SourceNode = 3283,
    AuditUrlMismatchEventType_SourceName = 3284,
    AuditUrlMismatchEventType_Time = 3285,
    AuditUrlMismatchEventType_ReceiveTime = 3286,
    AuditUrlMismatchEventType_LocalTime = 3287,
    AuditUrlMismatchEventType_Message = 3288,
    AuditUrlMismatchEventType_Severity = 3289,
    AuditUrlMismatchEventType_ActionTimeStamp = 3290,
    AuditUrlMismatchEventType_Status = 3291,
    AuditUrlMismatchEventType_ServerId = 3292,
    AuditUrlMismatchEventType_ClientAuditEntryId = 3293,
    AuditUrlMismatchEventType_ClientUserId = 3294,
    AuditUrlMismatchEventType_SecureChannelId = 3296,
    AuditUrlMismatchEventType_ClientCertificate = 3297,
    AuditUrlMismatchEventType_ClientCertificateThumbprint = 3298,
    AuditUrlMismatchEventType_RevisedSessionTimeout = 3299,
    AuditActivateSessionEventType_EventId = 3300,
    AuditActivateSessionEventType_EventType = 3301,
    AuditActivateSessionEventType_SourceNode = 3302,
    AuditActivateSessionEventType_SourceName = 3303,
    AuditActivateSessionEventType_Time = 3304,
    AuditActivateSessionEventType_ReceiveTime = 3305,
    AuditActivateSessionEventType_LocalTime = 3306,
    AuditActivateSessionEventType_Message = 3307,
    AuditActivateSessionEventType_Severity = 3308,
    AuditActivateSessionEventType_ActionTimeStamp = 3309,
    AuditActivateSessionEventType_Status = 3310,
    AuditActivateSessionEventType_ServerId = 3311,
    AuditActivateSessionEventType_ClientAuditEntryId = 3312,
    AuditActivateSessionEventType_ClientUserId = 3313,
    AuditActivateSessionEventType_SessionId = 3314,
    AuditCancelEventType_EventId = 3315,
    AuditCancelEventType_EventType = 3316,
    AuditCancelEventType_SourceNode = 3317,
    AuditCancelEventType_SourceName = 3318,
    AuditCancelEventType_Time = 3319,
    AuditCancelEventType_ReceiveTime = 3320,
    AuditCancelEventType_LocalTime = 3321,
    AuditCancelEventType_Message = 3322,
    AuditCancelEventType_Severity = 3323,
    AuditCancelEventType_ActionTimeStamp = 3324,
    AuditCancelEventType_Status = 3325,
    AuditCancelEventType_ServerId = 3326,
    AuditCancelEventType_ClientAuditEntryId = 3327,
    AuditCancelEventType_ClientUserId = 3328,
    AuditCancelEventType_SessionId = 3329,
    AuditCertificateEventType_EventId = 3330,
    AuditCertificateEventType_EventType = 3331,
    AuditCertificateEventType_SourceNode = 3332,
    AuditCertificateEventType_SourceName = 3333,
    AuditCertificateEventType_Time = 3334,
    AuditCertificateEventType_ReceiveTime = 3335,
    AuditCertificateEventType_LocalTime = 3336,
    AuditCertificateEventType_Message = 3337,
    AuditCertificateEventType_Severity = 3338,
    AuditCertificateEventType_ActionTimeStamp = 3339,
    AuditCertificateEventType_Status = 3340,
    AuditCertificateEventType_ServerId = 3341,
    AuditCertificateEventType_ClientAuditEntryId = 3342,
    AuditCertificateEventType_ClientUserId = 3343,
    AuditCertificateDataMismatchEventType_EventId = 3344,
    AuditCertificateDataMismatchEventType_EventType = 3345,
    AuditCertificateDataMismatchEventType_SourceNode = 3346,
    AuditCertificateDataMismatchEventType_SourceName = 3347,
    AuditCertificateDataMismatchEventType_Time = 3348,
    AuditCertificateDataMismatchEventType_ReceiveTime = 3349,
    AuditCertificateDataMismatchEventType_LocalTime = 3350,
    AuditCertificateDataMismatchEventType_Message = 3351,
    AuditCertificateDataMismatchEventType_Severity = 3352,
    AuditCertificateDataMismatchEventType_ActionTimeStamp = 3353,
    AuditCertificateDataMismatchEventType_Status = 3354,
    AuditCertificateDataMismatchEventType_ServerId = 3355,
    AuditCertificateDataMismatchEventType_ClientAuditEntryId = 3356,
    AuditCertificateDataMismatchEventType_ClientUserId = 3357,
    AuditCertificateDataMismatchEventType_Certificate = 3358,
    AuditCertificateExpiredEventType_EventId = 3359,
    AuditCertificateExpiredEventType_EventType = 3360,
    AuditCertificateExpiredEventType_SourceNode = 3361,
    AuditCertificateExpiredEventType_SourceName = 3362,
    AuditCertificateExpiredEventType_Time = 3363,
    AuditCertificateExpiredEventType_ReceiveTime = 3364,
    AuditCertificateExpiredEventType_LocalTime = 3365,
    AuditCertificateExpiredEventType_Message = 3366,
    AuditCertificateExpiredEventType_Severity = 3367,
    AuditCertificateExpiredEventType_ActionTimeStamp = 3368,
    AuditCertificateExpiredEventType_Status = 3369,
    AuditCertificateExpiredEventType_ServerId = 3370,
    AuditCertificateExpiredEventType_ClientAuditEntryId = 3371,
    AuditCertificateExpiredEventType_ClientUserId = 3372,
    AuditCertificateExpiredEventType_Certificate = 3373,
    AuditCertificateInvalidEventType_EventId = 3374,
    AuditCertificateInvalidEventType_EventType = 3375,
    AuditCertificateInvalidEventType_SourceNode = 3376,
    AuditCertificateInvalidEventType_SourceName = 3377,
    AuditCertificateInvalidEventType_Time = 3378,
    AuditCertificateInvalidEventType_ReceiveTime = 3379,
    AuditCertificateInvalidEventType_LocalTime = 3380,
    AuditCertificateInvalidEventType_Message = 3381,
    AuditCertificateInvalidEventType_Severity = 3382,
    AuditCertificateInvalidEventType_ActionTimeStamp = 3383,
    AuditCertificateInvalidEventType_Status = 3384,
    AuditCertificateInvalidEventType_ServerId = 3385,
    AuditCertificateInvalidEventType_ClientAuditEntryId = 3386,
    AuditCertificateInvalidEventType_ClientUserId = 3387,
    AuditCertificateInvalidEventType_Certificate = 3388,
    AuditCertificateUntrustedEventType_EventId = 3389,
    AuditCertificateUntrustedEventType_EventType = 3390,
    AuditCertificateUntrustedEventType_SourceNode = 3391,
    AuditCertificateUntrustedEventType_SourceName = 3392,
    AuditCertificateUntrustedEventType_Time = 3393,
    AuditCertificateUntrustedEventType_ReceiveTime = 3394,
    AuditCertificateUntrustedEventType_LocalTime = 3395,
    AuditCertificateUntrustedEventType_Message = 3396,
    AuditCertificateUntrustedEventType_Severity = 3397,
    AuditCertificateUntrustedEventType_ActionTimeStamp = 3398,
    AuditCertificateUntrustedEventType_Status = 3399,
    AuditCertificateUntrustedEventType_ServerId = 3400,
    AuditCertificateUntrustedEventType_ClientAuditEntryId = 3401,
    AuditCertificateUntrustedEventType_ClientUserId = 3402,
    AuditCertificateUntrustedEventType_Certificate = 3403,
    AuditCertificateRevokedEventType_EventId = 3404,
    AuditCertificateRevokedEventType_EventType = 3405,
    AuditCertificateRevokedEventType_SourceNode = 3406,
    AuditCertificateRevokedEventType_SourceName = 3407,
    AuditCertificateRevokedEventType_Time = 3408,
    AuditCertificateRevokedEventType_ReceiveTime = 3409,
    AuditCertificateRevokedEventType_LocalTime = 3410,
    AuditCertificateRevokedEventType_Message = 3411,
    AuditCertificateRevokedEventType_Severity = 3412,
    AuditCertificateRevokedEventType_ActionTimeStamp = 3413,
    AuditCertificateRevokedEventType_Status = 3414,
    AuditCertificateRevokedEventType_ServerId = 3415,
    AuditCertificateRevokedEventType_ClientAuditEntryId = 3416,
    AuditCertificateRevokedEventType_ClientUserId = 3417,
    AuditCertificateRevokedEventType_Certificate = 3418,
    AuditCertificateMismatchEventType_EventId = 3419,
    AuditCertificateMismatchEventType_EventType = 3420,
    AuditCertificateMismatchEventType_SourceNode = 3421,
    AuditCertificateMismatchEventType_SourceName = 3422,
    AuditCertificateMismatchEventType_Time = 3423,
    AuditCertificateMismatchEventType_ReceiveTime = 3424,
    AuditCertificateMismatchEventType_LocalTime = 3425,
    AuditCertificateMismatchEventType_Message = 3426,
    AuditCertificateMismatchEventType_Severity = 3427,
    AuditCertificateMismatchEventType_ActionTimeStamp = 3428,
    AuditCertificateMismatchEventType_Status = 3429,
    AuditCertificateMismatchEventType_ServerId = 3430,
    AuditCertificateMismatchEventType_ClientAuditEntryId = 3431,
    AuditCertificateMismatchEventType_ClientUserId = 3432,
    AuditCertificateMismatchEventType_Certificate = 3433,
    AuditNodeManagementEventType_EventId = 3434,
    AuditNodeManagementEventType_EventType = 3435,
    AuditNodeManagementEventType_SourceNode = 3436,
    AuditNodeManagementEventType_SourceName = 3437,
    AuditNodeManagementEventType_Time = 3438,
    AuditNodeManagementEventType_ReceiveTime = 3439,
    AuditNodeManagementEventType_LocalTime = 3440,
    AuditNodeManagementEventType_Message = 3441,
    AuditNodeManagementEventType_Severity = 3442,
    AuditNodeManagementEventType_ActionTimeStamp = 3443,
    AuditNodeManagementEventType_Status = 3444,
    AuditNodeManagementEventType_ServerId = 3445,
    AuditNodeManagementEventType_ClientAuditEntryId = 3446,
    AuditNodeManagementEventType_ClientUserId = 3447,
    AuditAddNodesEventType_EventId = 3448,
    AuditAddNodesEventType_EventType = 3449,
    AuditAddNodesEventType_SourceNode = 3450,
    AuditAddNodesEventType_SourceName = 3451,
    AuditAddNodesEventType_Time = 3452,
    AuditAddNodesEventType_ReceiveTime = 3453,
    AuditAddNodesEventType_LocalTime = 3454,
    AuditAddNodesEventType_Message = 3455,
    AuditAddNodesEventType_Severity = 3456,
    AuditAddNodesEventType_ActionTimeStamp = 3457,
    AuditAddNodesEventType_Status = 3458,
    AuditAddNodesEventType_ServerId = 3459,
    AuditAddNodesEventType_ClientAuditEntryId = 3460,
    AuditAddNodesEventType_ClientUserId = 3461,
    AuditDeleteNodesEventType_EventId = 3462,
    AuditDeleteNodesEventType_EventType = 3463,
    AuditDeleteNodesEventType_SourceNode = 3464,
    AuditDeleteNodesEventType_SourceName = 3465,
    AuditDeleteNodesEventType_Time = 3466,
    AuditDeleteNodesEventType_ReceiveTime = 3467,
    AuditDeleteNodesEventType_LocalTime = 3468,
    AuditDeleteNodesEventType_Message = 3469,
    AuditDeleteNodesEventType_Severity = 3470,
    AuditDeleteNodesEventType_ActionTimeStamp = 3471,
    AuditDeleteNodesEventType_Status = 3472,
    AuditDeleteNodesEventType_ServerId = 3473,
    AuditDeleteNodesEventType_ClientAuditEntryId = 3474,
    AuditDeleteNodesEventType_ClientUserId = 3475,
    AuditAddReferencesEventType_EventId = 3476,
    AuditAddReferencesEventType_EventType = 3477,
    AuditAddReferencesEventType_SourceNode = 3478,
    AuditAddReferencesEventType_SourceName = 3479,
    AuditAddReferencesEventType_Time = 3480,
    AuditAddReferencesEventType_ReceiveTime = 3481,
    AuditAddReferencesEventType_LocalTime = 3482,
    AuditAddReferencesEventType_Message = 3483,
    AuditAddReferencesEventType_Severity = 3484,
    AuditAddReferencesEventType_ActionTimeStamp = 3485,
    AuditAddReferencesEventType_Status = 3486,
    AuditAddReferencesEventType_ServerId = 3487,
    AuditAddReferencesEventType_ClientAuditEntryId = 3488,
    AuditAddReferencesEventType_ClientUserId = 3489,
    AuditDeleteReferencesEventType_EventId = 3490,
    AuditDeleteReferencesEventType_EventType = 3491,
    AuditDeleteReferencesEventType_SourceNode = 3492,
    AuditDeleteReferencesEventType_SourceName = 3493,
    AuditDeleteReferencesEventType_Time = 3494,
    AuditDeleteReferencesEventType_ReceiveTime = 3495,
    AuditDeleteReferencesEventType_LocalTime = 3496,
    AuditDeleteReferencesEventType_Message = 3497,
    AuditDeleteReferencesEventType_Severity = 3498,
    AuditDeleteReferencesEventType_ActionTimeStamp = 3499,
    AuditDeleteReferencesEventType_Status = 3500,
    AuditDeleteReferencesEventType_ServerId = 3501,
    AuditDeleteReferencesEventType_ClientAuditEntryId = 3502,
    AuditDeleteReferencesEventType_ClientUserId = 3503,
    AuditUpdateEventType_EventId = 3504,
    AuditUpdateEventType_EventType = 3505,
    AuditUpdateEventType_SourceNode = 3506,
    AuditUpdateEventType_SourceName = 3507,
    AuditUpdateEventType_Time = 3508,
    AuditUpdateEventType_ReceiveTime = 3509,
    AuditUpdateEventType_LocalTime = 3510,
    AuditUpdateEventType_Message = 3511,
    AuditUpdateEventType_Severity = 3512,
    AuditUpdateEventType_ActionTimeStamp = 3513,
    AuditUpdateEventType_Status = 3514,
    AuditUpdateEventType_ServerId = 3515,
    AuditUpdateEventType_ClientAuditEntryId = 3516,
    AuditUpdateEventType_ClientUserId = 3517,
    AuditWriteUpdateEventType_EventId = 3518,
    AuditWriteUpdateEventType_EventType = 3519,
    AuditWriteUpdateEventType_SourceNode = 3520,
    AuditWriteUpdateEventType_SourceName = 3521,
    AuditWriteUpdateEventType_Time = 3522,
    AuditWriteUpdateEventType_ReceiveTime = 3523,
    AuditWriteUpdateEventType_LocalTime = 3524,
    AuditWriteUpdateEventType_Message = 3525,
    AuditWriteUpdateEventType_Severity = 3526,
    AuditWriteUpdateEventType_ActionTimeStamp = 3527,
    AuditWriteUpdateEventType_Status = 3528,
    AuditWriteUpdateEventType_ServerId = 3529,
    AuditWriteUpdateEventType_ClientAuditEntryId = 3530,
    AuditWriteUpdateEventType_ClientUserId = 3531,
    AuditHistoryUpdateEventType_EventId = 3532,
    AuditHistoryUpdateEventType_EventType = 3533,
    AuditHistoryUpdateEventType_SourceNode = 3534,
    AuditHistoryUpdateEventType_SourceName = 3535,
    AuditHistoryUpdateEventType_Time = 3536,
    AuditHistoryUpdateEventType_ReceiveTime = 3537,
    AuditHistoryUpdateEventType_LocalTime = 3538,
    AuditHistoryUpdateEventType_Message = 3539,
    AuditHistoryUpdateEventType_Severity = 3540,
    AuditHistoryUpdateEventType_ActionTimeStamp = 3541,
    AuditHistoryUpdateEventType_Status = 3542,
    AuditHistoryUpdateEventType_ServerId = 3543,
    AuditHistoryUpdateEventType_ClientAuditEntryId = 3544,
    AuditHistoryUpdateEventType_ClientUserId = 3545,
    AuditHistoryEventUpdateEventType_EventId = 3546,
    AuditHistoryEventUpdateEventType_EventType = 3547,
    AuditHistoryEventUpdateEventType_SourceNode = 3548,
    AuditHistoryEventUpdateEventType_SourceName = 3549,
    AuditHistoryEventUpdateEventType_Time = 3550,
    AuditHistoryEventUpdateEventType_ReceiveTime = 3551,
    AuditHistoryEventUpdateEventType_LocalTime = 3552,
    AuditHistoryEventUpdateEventType_Message = 3553,
    AuditHistoryEventUpdateEventType_Severity = 3554,
    AuditHistoryEventUpdateEventType_ActionTimeStamp = 3555,
    AuditHistoryEventUpdateEventType_Status = 3556,
    AuditHistoryEventUpdateEventType_ServerId = 3557,
    AuditHistoryEventUpdateEventType_ClientAuditEntryId = 3558,
    AuditHistoryEventUpdateEventType_ClientUserId = 3559,
    AuditHistoryEventUpdateEventType_ParameterDataTypeId = 3560,
    AuditHistoryValueUpdateEventType_EventId = 3561,
    AuditHistoryValueUpdateEventType_EventType = 3562,
    AuditHistoryValueUpdateEventType_SourceNode = 3563,
    AuditHistoryValueUpdateEventType_SourceName = 3564,
    AuditHistoryValueUpdateEventType_Time = 3565,
    AuditHistoryValueUpdateEventType_ReceiveTime = 3566,
    AuditHistoryValueUpdateEventType_LocalTime = 3567,
    AuditHistoryValueUpdateEventType_Message = 3568,
    AuditHistoryValueUpdateEventType_Severity = 3569,
    AuditHistoryValueUpdateEventType_ActionTimeStamp = 3570,
    AuditHistoryValueUpdateEventType_Status = 3571,
    AuditHistoryValueUpdateEventType_ServerId = 3572,
    AuditHistoryValueUpdateEventType_ClientAuditEntryId = 3573,
    AuditHistoryValueUpdateEventType_ClientUserId = 3574,
    AuditHistoryValueUpdateEventType_ParameterDataTypeId = 3575,
    AuditHistoryDeleteEventType_EventId = 3576,
    AuditHistoryDeleteEventType_EventType = 3577,
    AuditHistoryDeleteEventType_SourceNode = 3578,
    AuditHistoryDeleteEventType_SourceName = 3579,
    AuditHistoryDeleteEventType_Time = 3580,
    AuditHistoryDeleteEventType_ReceiveTime = 3581,
    AuditHistoryDeleteEventType_LocalTime = 3582,
    AuditHistoryDeleteEventType_Message = 3583,
    AuditHistoryDeleteEventType_Severity = 3584,
    AuditHistoryDeleteEventType_ActionTimeStamp = 3585,
    AuditHistoryDeleteEventType_Status = 3586,
    AuditHistoryDeleteEventType_ServerId = 3587,
    AuditHistoryDeleteEventType_ClientAuditEntryId = 3588,
    AuditHistoryDeleteEventType_ClientUserId = 3589,
    AuditHistoryDeleteEventType_ParameterDataTypeId = 3590,
    AuditHistoryRawModifyDeleteEventType_EventId = 3591,
    AuditHistoryRawModifyDeleteEventType_EventType = 3592,
    AuditHistoryRawModifyDeleteEventType_SourceNode = 3593,
    AuditHistoryRawModifyDeleteEventType_SourceName = 3594,
    AuditHistoryRawModifyDeleteEventType_Time = 3595,
    AuditHistoryRawModifyDeleteEventType_ReceiveTime = 3596,
    AuditHistoryRawModifyDeleteEventType_LocalTime = 3597,
    AuditHistoryRawModifyDeleteEventType_Message = 3598,
    AuditHistoryRawModifyDeleteEventType_Severity = 3599,
    AuditHistoryRawModifyDeleteEventType_ActionTimeStamp = 3600,
    AuditHistoryRawModifyDeleteEventType_Status = 3601,
    AuditHistoryRawModifyDeleteEventType_ServerId = 3602,
    AuditHistoryRawModifyDeleteEventType_ClientAuditEntryId = 3603,
    AuditHistoryRawModifyDeleteEventType_ClientUserId = 3604,
    AuditHistoryRawModifyDeleteEventType_ParameterDataTypeId = 3605,
    AuditHistoryRawModifyDeleteEventType_UpdatedNode = 3606,
    AuditHistoryAtTimeDeleteEventType_EventId = 3607,
    AuditHistoryAtTimeDeleteEventType_EventType = 3608,
    AuditHistoryAtTimeDeleteEventType_SourceNode = 3609,
    AuditHistoryAtTimeDeleteEventType_SourceName = 3610,
    AuditHistoryAtTimeDeleteEventType_Time = 3611,
    AuditHistoryAtTimeDeleteEventType_ReceiveTime = 3612,
    AuditHistoryAtTimeDeleteEventType_LocalTime = 3613,
    AuditHistoryAtTimeDeleteEventType_Message = 3614,
    AuditHistoryAtTimeDeleteEventType_Severity = 3615,
    AuditHistoryAtTimeDeleteEventType_ActionTimeStamp = 3616,
    AuditHistoryAtTimeDeleteEventType_Status = 3617,
    AuditHistoryAtTimeDeleteEventType_ServerId = 3618,
    AuditHistoryAtTimeDeleteEventType_ClientAuditEntryId = 3619,
    AuditHistoryAtTimeDeleteEventType_ClientUserId = 3620,
    AuditHistoryAtTimeDeleteEventType_ParameterDataTypeId = 3621,
    AuditHistoryAtTimeDeleteEventType_UpdatedNode = 3622,
    AuditHistoryEventDeleteEventType_EventId = 3623,
    AuditHistoryEventDeleteEventType_EventType = 3624,
    AuditHistoryEventDeleteEventType_SourceNode = 3625,
    AuditHistoryEventDeleteEventType_SourceName = 3626,
    AuditHistoryEventDeleteEventType_Time = 3627,
    AuditHistoryEventDeleteEventType_ReceiveTime = 3628,
    AuditHistoryEventDeleteEventType_LocalTime = 3629,
    AuditHistoryEventDeleteEventType_Message = 3630,
    AuditHistoryEventDeleteEventType_Severity = 3631,
    AuditHistoryEventDeleteEventType_ActionTimeStamp = 3632,
    AuditHistoryEventDeleteEventType_Status = 3633,
    AuditHistoryEventDeleteEventType_ServerId = 3634,
    AuditHistoryEventDeleteEventType_ClientAuditEntryId = 3635,
    AuditHistoryEventDeleteEventType_ClientUserId = 3636,
    AuditHistoryEventDeleteEventType_ParameterDataTypeId = 3637,
    AuditHistoryEventDeleteEventType_UpdatedNode = 3638,
    AuditUpdateMethodEventType_EventId = 3639,
    AuditUpdateMethodEventType_EventType = 3640,
    AuditUpdateMethodEventType_SourceNode = 3641,
    AuditUpdateMethodEventType_SourceName = 3642,
    AuditUpdateMethodEventType_Time = 3643,
    AuditUpdateMethodEventType_ReceiveTime = 3644,
    AuditUpdateMethodEventType_LocalTime = 3645,
    AuditUpdateMethodEventType_Message = 3646,
    AuditUpdateMethodEventType_Severity = 3647,
    AuditUpdateMethodEventType_ActionTimeStamp = 3648,
    AuditUpdateMethodEventType_Status = 3649,
    AuditUpdateMethodEventType_ServerId = 3650,
    AuditUpdateMethodEventType_ClientAuditEntryId = 3651,
    AuditUpdateMethodEventType_ClientUserId = 3652,
    SystemEventType_EventId = 3653,
    SystemEventType_EventType = 3654,
    SystemEventType_SourceNode = 3655,
    SystemEventType_SourceName = 3656,
    SystemEventType_Time = 3657,
    SystemEventType_ReceiveTime = 3658,
    SystemEventType_LocalTime = 3659,
    SystemEventType_Message = 3660,
    SystemEventType_Severity = 3661,
    DeviceFailureEventType_EventId = 3662,
    DeviceFailureEventType_EventType = 3663,
    DeviceFailureEventType_SourceNode = 3664,
    DeviceFailureEventType_SourceName = 3665,
    DeviceFailureEventType_Time = 3666,
    DeviceFailureEventType_ReceiveTime = 3667,
    DeviceFailureEventType_LocalTime = 3668,
    DeviceFailureEventType_Message = 3669,
    DeviceFailureEventType_Severity = 3670,
    BaseModelChangeEventType_EventId = 3671,
    BaseModelChangeEventType_EventType = 3672,
    BaseModelChangeEventType_SourceNode = 3673,
    BaseModelChangeEventType_SourceName = 3674,
    BaseModelChangeEventType_Time = 3675,
    BaseModelChangeEventType_ReceiveTime = 3676,
    BaseModelChangeEventType_LocalTime = 3677,
    BaseModelChangeEventType_Message = 3678,
    BaseModelChangeEventType_Severity = 3679,
    GeneralModelChangeEventType_EventId = 3680,
    GeneralModelChangeEventType_EventType = 3681,
    GeneralModelChangeEventType_SourceNode = 3682,
    GeneralModelChangeEventType_SourceName = 3683,
    GeneralModelChangeEventType_Time = 3684,
    GeneralModelChangeEventType_ReceiveTime = 3685,
    GeneralModelChangeEventType_LocalTime = 3686,
    GeneralModelChangeEventType_Message = 3687,
    GeneralModelChangeEventType_Severity = 3688,
    SemanticChangeEventType_EventId = 3689,
    SemanticChangeEventType_EventType = 3690,
    SemanticChangeEventType_SourceNode = 3691,
    SemanticChangeEventType_SourceName = 3692,
    SemanticChangeEventType_Time = 3693,
    SemanticChangeEventType_ReceiveTime = 3694,
    SemanticChangeEventType_LocalTime = 3695,
    SemanticChangeEventType_Message = 3696,
    SemanticChangeEventType_Severity = 3697,
    ServerStatusType_BuildInfo_ProductUri = 3698,
    ServerStatusType_BuildInfo_ManufacturerName = 3699,
    ServerStatusType_BuildInfo_ProductName = 3700,
    ServerStatusType_BuildInfo_SoftwareVersion = 3701,
    ServerStatusType_BuildInfo_BuildNumber = 3702,
    ServerStatusType_BuildInfo_BuildDate = 3703,
    Server_ServerCapabilities_SoftwareCertificates = 3704,
    Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount = 3705,
    Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray = 3707,
    Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray = 3708,
    Server_ServerRedundancy_RedundancySupport = 3709,
    FiniteStateVariableType_Name = 3714,
    FiniteStateVariableType_Number = 3715,
    FiniteStateVariableType_EffectiveDisplayName = 3716,
    FiniteTransitionVariableType_Name = 3717,
    FiniteTransitionVariableType_Number = 3718,
    FiniteTransitionVariableType_TransitionTime = 3719,
    StateMachineType_CurrentState_Id = 3720,
    StateMachineType_CurrentState_Name = 3721,
    StateMachineType_CurrentState_Number = 3722,
    StateMachineType_CurrentState_EffectiveDisplayName = 3723,
    StateMachineType_LastTransition_Id = 3724,
    StateMachineType_LastTransition_Name = 3725,
    StateMachineType_LastTransition_Number = 3726,
    StateMachineType_LastTransition_TransitionTime = 3727,
    FiniteStateMachineType_CurrentState_Id = 3728,
    FiniteStateMachineType_CurrentState_Name = 3729,
    FiniteStateMachineType_CurrentState_Number = 3730,
    FiniteStateMachineType_CurrentState_EffectiveDisplayName = 3731,
    FiniteStateMachineType_LastTransition_Id = 3732,
    FiniteStateMachineType_LastTransition_Name = 3733,
    FiniteStateMachineType_LastTransition_Number = 3734,
    FiniteStateMachineType_LastTransition_TransitionTime = 3735,
    InitialStateType_StateNumber = 3736,
    TransitionEventType_EventId = 3737,
    TransitionEventType_EventType = 3738,
    TransitionEventType_SourceNode = 3739,
    TransitionEventType_SourceName = 3740,
    TransitionEventType_Time = 3741,
    TransitionEventType_ReceiveTime = 3742,
    TransitionEventType_LocalTime = 3743,
    TransitionEventType_Message = 3744,
    TransitionEventType_Severity = 3745,
    TransitionEventType_FromState_Id = 3746,
    TransitionEventType_FromState_Name = 3747,
    TransitionEventType_FromState_Number = 3748,
    TransitionEventType_FromState_EffectiveDisplayName = 3749,
    TransitionEventType_ToState_Id = 3750,
    TransitionEventType_ToState_Name = 3751,
    TransitionEventType_ToState_Number = 3752,
    TransitionEventType_ToState_EffectiveDisplayName = 3753,
    TransitionEventType_Transition_Id = 3754,
    TransitionEventType_Transition_Name = 3755,
    TransitionEventType_Transition_Number = 3756,
    TransitionEventType_Transition_TransitionTime = 3757,
    AuditUpdateStateEventType_EventId = 3758,
    AuditUpdateStateEventType_EventType = 3759,
    AuditUpdateStateEventType_SourceNode = 3760,
    AuditUpdateStateEventType_SourceName = 3761,
    AuditUpdateStateEventType_Time = 3762,
    AuditUpdateStateEventType_ReceiveTime = 3763,
    AuditUpdateStateEventType_LocalTime = 3764,
    AuditUpdateStateEventType_Message = 3765,
    AuditUpdateStateEventType_Severity = 3766,
    AuditUpdateStateEventType_ActionTimeStamp = 3767,
    AuditUpdateStateEventType_Status = 3768,
    AuditUpdateStateEventType_ServerId = 3769,
    AuditUpdateStateEventType_ClientAuditEntryId = 3770,
    AuditUpdateStateEventType_ClientUserId = 3771,
    AuditUpdateStateEventType_MethodId = 3772,
    AuditUpdateStateEventType_InputArguments = 3773,
    AnalogItemType_Definition = 3774,
    AnalogItemType_ValuePrecision = 3775,
    DiscreteItemType_Definition = 3776,
    DiscreteItemType_ValuePrecision = 3777,
    TwoStateDiscreteType_Definition = 3778,
    TwoStateDiscreteType_ValuePrecision = 3779,
    MultiStateDiscreteType_Definition = 3780,
    MultiStateDiscreteType_ValuePrecision = 3781,
    ProgramTransitionEventType_EventId = 3782,
    ProgramTransitionEventType_EventType = 3783,
    ProgramTransitionEventType_SourceNode = 3784,
    ProgramTransitionEventType_SourceName = 3785,
    ProgramTransitionEventType_Time = 3786,
    ProgramTransitionEventType_ReceiveTime = 3787,
    ProgramTransitionEventType_LocalTime = 3788,
    ProgramTransitionEventType_Message = 3789,
    ProgramTransitionEventType_Severity = 3790,
    ProgramTransitionEventType_FromState = 3791,
    ProgramTransitionEventType_FromState_Id = 3792,
    ProgramTransitionEventType_FromState_Name = 3793,
    ProgramTransitionEventType_FromState_Number = 3794,
    ProgramTransitionEventType_FromState_EffectiveDisplayName = 3795,
    ProgramTransitionEventType_ToState = 3796,
    ProgramTransitionEventType_ToState_Id = 3797,
    ProgramTransitionEventType_ToState_Name = 3798,
    ProgramTransitionEventType_ToState_Number = 3799,
    ProgramTransitionEventType_ToState_EffectiveDisplayName = 3800,
    ProgramTransitionEventType_Transition = 3801,
    ProgramTransitionEventType_Transition_Id = 3802,
    ProgramTransitionEventType_Transition_Name = 3803,
    ProgramTransitionEventType_Transition_Number = 3804,
    ProgramTransitionEventType_Transition_TransitionTime = 3805,
    ProgramTransitionAuditEventType_EventId = 3807,
    ProgramTransitionAuditEventType_EventType = 3808,
    ProgramTransitionAuditEventType_SourceNode = 3809,
    ProgramTransitionAuditEventType_SourceName = 3810,
    ProgramTransitionAuditEventType_Time = 3811,
    ProgramTransitionAuditEventType_ReceiveTime = 3812,
    ProgramTransitionAuditEventType_LocalTime = 3813,
    ProgramTransitionAuditEventType_Message = 3814,
    ProgramTransitionAuditEventType_Severity = 3815,
    ProgramTransitionAuditEventType_ActionTimeStamp = 3816,
    ProgramTransitionAuditEventType_Status = 3817,
    ProgramTransitionAuditEventType_ServerId = 3818,
    ProgramTransitionAuditEventType_ClientAuditEntryId = 3819,
    ProgramTransitionAuditEventType_ClientUserId = 3820,
    ProgramTransitionAuditEventType_MethodId = 3821,
    ProgramTransitionAuditEventType_InputArguments = 3822,
    ProgramTransitionAuditEventType_OldStateId = 3823,
    ProgramTransitionAuditEventType_NewStateId = 3824,
    ProgramTransitionAuditEventType_Transition = 3825,
    ProgramTransitionAuditEventType_Transition_Id = 3826,
    ProgramTransitionAuditEventType_Transition_Name = 3827,
    ProgramTransitionAuditEventType_Transition_Number = 3828,
    ProgramTransitionAuditEventType_Transition_TransitionTime = 3829,
    ProgramStateMachineType_CurrentState = 3830,
    ProgramStateMachineType_CurrentState_Id = 3831,
    ProgramStateMachineType_CurrentState_Name = 3832,
    ProgramStateMachineType_CurrentState_Number = 3833,
    ProgramStateMachineType_CurrentState_EffectiveDisplayName = 3834,
    ProgramStateMachineType_LastTransition = 3835,
    ProgramStateMachineType_LastTransition_Id = 3836,
    ProgramStateMachineType_LastTransition_Name = 3837,
    ProgramStateMachineType_LastTransition_Number = 3838,
    ProgramStateMachineType_LastTransition_TransitionTime = 3839,
    ProgramStateMachineType_ProgramDiagnostic_CreateSessionId = 3840,
    ProgramStateMachineType_ProgramDiagnostic_CreateClientName = 3841,
    ProgramStateMachineType_ProgramDiagnostic_InvocationCreationTime = 3842,
    ProgramStateMachineType_ProgramDiagnostic_LastTransitionTime = 3843,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodCall = 3844,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodSessionId = 3845,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodInputArguments = 3846,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodOutputArguments = 3847,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodCallTime = 3848,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodReturnStatus = 3849,
    AddCommentMethodType_InputArguments = 3864,
    ConditionType_EventId = 3865,
    ConditionType_EventType = 3866,
    ConditionType_SourceNode = 3867,
    ConditionType_SourceName = 3868,
    ConditionType_Time = 3869,
    ConditionType_ReceiveTime = 3870,
    ConditionType_LocalTime = 3871,
    ConditionType_Message = 3872,
    ConditionType_Severity = 3873,
    ConditionType_Retain = 3874,
    ConditionType_ConditionRefresh_InputArguments = 3876,
    RefreshStartEventType_EventId = 3969,
    RefreshStartEventType_EventType = 3970,
    RefreshStartEventType_SourceNode = 3971,
    RefreshStartEventType_SourceName = 3972,
    RefreshStartEventType_Time = 3973,
    RefreshStartEventType_ReceiveTime = 3974,
    RefreshStartEventType_LocalTime = 3975,
    RefreshStartEventType_Message = 3976,
    RefreshStartEventType_Severity = 3977,
    RefreshEndEventType_EventId = 3978,
    RefreshEndEventType_EventType = 3979,
    RefreshEndEventType_SourceNode = 3980,
    RefreshEndEventType_SourceName = 3981,
    RefreshEndEventType_Time = 3982,
    RefreshEndEventType_ReceiveTime = 3983,
    RefreshEndEventType_LocalTime = 3984,
    RefreshEndEventType_Message = 3985,
    RefreshEndEventType_Severity = 3986,
    RefreshRequiredEventType_EventId = 3987,
    RefreshRequiredEventType_EventType = 3988,
    RefreshRequiredEventType_SourceNode = 3989,
    RefreshRequiredEventType_SourceName = 3990,
    RefreshRequiredEventType_Time = 3991,
    RefreshRequiredEventType_ReceiveTime = 3992,
    RefreshRequiredEventType_LocalTime = 3993,
    RefreshRequiredEventType_Message = 3994,
    RefreshRequiredEventType_Severity = 3995,
    AuditConditionEventType_EventId = 3996,
    AuditConditionEventType_EventType = 3997,
    AuditConditionEventType_SourceNode = 3998,
    AuditConditionEventType_SourceName = 3999,
    AuditConditionEventType_Time = 4000,
    AuditConditionEventType_ReceiveTime = 4001,
    AuditConditionEventType_LocalTime = 4002,
    AuditConditionEventType_Message = 4003,
    AuditConditionEventType_Severity = 4004,
    AuditConditionEventType_ActionTimeStamp = 4005,
    AuditConditionEventType_Status = 4006,
    AuditConditionEventType_ServerId = 4007,
    AuditConditionEventType_ClientAuditEntryId = 4008,
    AuditConditionEventType_ClientUserId = 4009,
    AuditConditionEventType_MethodId = 4010,
    AuditConditionEventType_InputArguments = 4011,
    AuditConditionEnableEventType_EventId = 4106,
    AuditConditionEnableEventType_EventType = 4107,
    AuditConditionEnableEventType_SourceNode = 4108,
    AuditConditionEnableEventType_SourceName = 4109,
    AuditConditionEnableEventType_Time = 4110,
    AuditConditionEnableEventType_ReceiveTime = 4111,
    AuditConditionEnableEventType_LocalTime = 4112,
    AuditConditionEnableEventType_Message = 4113,
    AuditConditionEnableEventType_Severity = 4114,
    AuditConditionEnableEventType_ActionTimeStamp = 4115,
    AuditConditionEnableEventType_Status = 4116,
    AuditConditionEnableEventType_ServerId = 4117,
    AuditConditionEnableEventType_ClientAuditEntryId = 4118,
    AuditConditionEnableEventType_ClientUserId = 4119,
    AuditConditionEnableEventType_MethodId = 4120,
    AuditConditionEnableEventType_InputArguments = 4121,
    AuditConditionCommentEventType_EventId = 4170,
    AuditConditionCommentEventType_EventType = 4171,
    AuditConditionCommentEventType_SourceNode = 4172,
    AuditConditionCommentEventType_SourceName = 4173,
    AuditConditionCommentEventType_Time = 4174,
    AuditConditionCommentEventType_ReceiveTime = 4175,
    AuditConditionCommentEventType_LocalTime = 4176,
    AuditConditionCommentEventType_Message = 4177,
    AuditConditionCommentEventType_Severity = 4178,
    AuditConditionCommentEventType_ActionTimeStamp = 4179,
    AuditConditionCommentEventType_Status = 4180,
    AuditConditionCommentEventType_ServerId = 4181,
    AuditConditionCommentEventType_ClientAuditEntryId = 4182,
    AuditConditionCommentEventType_ClientUserId = 4183,
    AuditConditionCommentEventType_MethodId = 4184,
    AuditConditionCommentEventType_InputArguments = 4185,
    DialogConditionType_EventId = 4188,
    DialogConditionType_EventType = 4189,
    DialogConditionType_SourceNode = 4190,
    DialogConditionType_SourceName = 4191,
    DialogConditionType_Time = 4192,
    DialogConditionType_ReceiveTime = 4193,
    DialogConditionType_LocalTime = 4194,
    DialogConditionType_Message = 4195,
    DialogConditionType_Severity = 4196,
    DialogConditionType_Retain = 4197,
    DialogConditionType_ConditionRefresh_InputArguments = 4199,
    AcknowledgeableConditionType_EventId = 5113,
    AcknowledgeableConditionType_EventType = 5114,
    AcknowledgeableConditionType_SourceNode = 5115,
    AcknowledgeableConditionType_SourceName = 5116,
    AcknowledgeableConditionType_Time = 5117,
    AcknowledgeableConditionType_ReceiveTime = 5118,
    AcknowledgeableConditionType_LocalTime = 5119,
    AcknowledgeableConditionType_Message = 5120,
    AcknowledgeableConditionType_Severity = 5121,
    AcknowledgeableConditionType_Retain = 5122,
    AcknowledgeableConditionType_ConditionRefresh_InputArguments = 5124,
    AlarmConditionType_EventId = 5540,
    AlarmConditionType_EventType = 5541,
    AlarmConditionType_SourceNode = 5542,
    AlarmConditionType_SourceName = 5543,
    AlarmConditionType_Time = 5544,
    AlarmConditionType_ReceiveTime = 5545,
    AlarmConditionType_LocalTime = 5546,
    AlarmConditionType_Message = 5547,
    AlarmConditionType_Severity = 5548,
    AlarmConditionType_Retain = 5549,
    AlarmConditionType_ConditionRefresh_InputArguments = 5551,
    ShelvedStateMachineType_CurrentState = 6088,
    ShelvedStateMachineType_CurrentState_Id = 6089,
    ShelvedStateMachineType_CurrentState_Name = 6090,
    ShelvedStateMachineType_CurrentState_Number = 6091,
    ShelvedStateMachineType_CurrentState_EffectiveDisplayName = 6092,
    ShelvedStateMachineType_LastTransition = 6093,
    ShelvedStateMachineType_LastTransition_Id = 6094,
    ShelvedStateMachineType_LastTransition_Name = 6095,
    ShelvedStateMachineType_LastTransition_Number = 6096,
    ShelvedStateMachineType_LastTransition_TransitionTime = 6097,
    ShelvedStateMachineType_Unshelved_StateNumber = 6098,
    ShelvedStateMachineType_TimedShelved_StateNumber = 6100,
    ShelvedStateMachineType_OneShotShelved_StateNumber = 6101,
    TimedShelveMethodType_InputArguments = 6103,
    LimitAlarmType_EventId = 6116,
    LimitAlarmType_EventType = 6117,
    LimitAlarmType_SourceNode = 6118,
    LimitAlarmType_SourceName = 6119,
    LimitAlarmType_Time = 6120,
    LimitAlarmType_ReceiveTime = 6121,
    LimitAlarmType_LocalTime = 6122,
    LimitAlarmType_Message = 6123,
    LimitAlarmType_Severity = 6124,
    LimitAlarmType_Retain = 6125,
    LimitAlarmType_ConditionRefresh_InputArguments = 6127,
    IdType_EnumStrings = 7591,
    MessageSecurityMode_EnumStrings = 7595,
    UserTokenType_EnumStrings = 7596,
    ApplicationType_EnumStrings = 7597,
    SecurityTokenRequestType_EnumStrings = 7598,
    BrowseDirection_EnumStrings = 7603,
    FilterOperator_EnumStrings = 7605,
    TimestampsToReturn_EnumStrings = 7606,
    MonitoringMode_EnumStrings = 7608,
    DataChangeTrigger_EnumStrings = 7609,
    DeadbandType_EnumStrings = 7610,
    RedundancySupport_EnumStrings = 7611,
    ServerState_EnumStrings = 7612,
    ExceptionDeviationFormat_EnumStrings = 7614,
    OpcUa_BinarySchema = 7617,
    OpcUa_BinarySchema_DataTypeVersion = 7618,
    OpcUa_BinarySchema_NamespaceUri = 7619,
    OpcUa_BinarySchema_Argument = 7650,
    OpcUa_BinarySchema_Argument_DataTypeVersion = 7651,
    OpcUa_BinarySchema_Argument_DictionaryFragment = 7652,
    OpcUa_BinarySchema_EnumValueType = 7656,
    OpcUa_BinarySchema_EnumValueType_DataTypeVersion = 7657,
    OpcUa_BinarySchema_EnumValueType_DictionaryFragment = 7658,
    OpcUa_BinarySchema_StatusResult = 7659,
    OpcUa_BinarySchema_StatusResult_DataTypeVersion = 7660,
    OpcUa_BinarySchema_StatusResult_DictionaryFragment = 7661,
    OpcUa_BinarySchema_UserTokenPolicy = 7662,
    OpcUa_BinarySchema_UserTokenPolicy_DataTypeVersion = 7663,
    OpcUa_BinarySchema_UserTokenPolicy_DictionaryFragment = 7664,
    OpcUa_BinarySchema_ApplicationDescription = 7665,
    OpcUa_BinarySchema_ApplicationDescription_DataTypeVersion = 7666,
    OpcUa_BinarySchema_ApplicationDescription_DictionaryFragment = 7667,
    OpcUa_BinarySchema_EndpointDescription = 7668,
    OpcUa_BinarySchema_EndpointDescription_DataTypeVersion = 7669,
    OpcUa_BinarySchema_EndpointDescription_DictionaryFragment = 7670,
    OpcUa_BinarySchema_UserIdentityToken = 7671,
    OpcUa_BinarySchema_UserIdentityToken_DataTypeVersion = 7672,
    OpcUa_BinarySchema_UserIdentityToken_DictionaryFragment = 7673,
    OpcUa_BinarySchema_AnonymousIdentityToken = 7674,
    OpcUa_BinarySchema_AnonymousIdentityToken_DataTypeVersion = 7675,
    OpcUa_BinarySchema_AnonymousIdentityToken_DictionaryFragment = 7676,
    OpcUa_BinarySchema_UserNameIdentityToken = 7677,
    OpcUa_BinarySchema_UserNameIdentityToken_DataTypeVersion = 7678,
    OpcUa_BinarySchema_UserNameIdentityToken_DictionaryFragment = 7679,
    OpcUa_BinarySchema_X509IdentityToken = 7680,
    OpcUa_BinarySchema_X509IdentityToken_DataTypeVersion = 7681,
    OpcUa_BinarySchema_X509IdentityToken_DictionaryFragment = 7682,
    OpcUa_BinarySchema_IssuedIdentityToken = 7683,
    OpcUa_BinarySchema_IssuedIdentityToken_DataTypeVersion = 7684,
    OpcUa_BinarySchema_IssuedIdentityToken_DictionaryFragment = 7685,
    OpcUa_BinarySchema_EndpointConfiguration = 7686,
    OpcUa_BinarySchema_EndpointConfiguration_DataTypeVersion = 7687,
    OpcUa_BinarySchema_EndpointConfiguration_DictionaryFragment = 7688,
    OpcUa_BinarySchema_BuildInfo = 7692,
    OpcUa_BinarySchema_BuildInfo_DataTypeVersion = 7693,
    OpcUa_BinarySchema_BuildInfo_DictionaryFragment = 7694,
    OpcUa_BinarySchema_SignedSoftwareCertificate = 7698,
    OpcUa_BinarySchema_SignedSoftwareCertificate_DataTypeVersion = 7699,
    OpcUa_BinarySchema_SignedSoftwareCertificate_DictionaryFragment = 7700,
    OpcUa_BinarySchema_AddNodesItem = 7728,
    OpcUa_BinarySchema_AddNodesItem_DataTypeVersion = 7729,
    OpcUa_BinarySchema_AddNodesItem_DictionaryFragment = 7730,
    OpcUa_BinarySchema_AddReferencesItem = 7731,
    OpcUa_BinarySchema_AddReferencesItem_DataTypeVersion = 7732,
    OpcUa_BinarySchema_AddReferencesItem_DictionaryFragment = 7733,
    OpcUa_BinarySchema_DeleteNodesItem = 7734,
    OpcUa_BinarySchema_DeleteNodesItem_DataTypeVersion = 7735,
    OpcUa_BinarySchema_DeleteNodesItem_DictionaryFragment = 7736,
    OpcUa_BinarySchema_DeleteReferencesItem = 7737,
    OpcUa_BinarySchema_DeleteReferencesItem_DataTypeVersion = 7738,
    OpcUa_BinarySchema_DeleteReferencesItem_DictionaryFragment = 7739,
    OpcUa_BinarySchema_RegisteredServer = 7782,
    OpcUa_BinarySchema_RegisteredServer_DataTypeVersion = 7783,
    OpcUa_BinarySchema_RegisteredServer_DictionaryFragment = 7784,
    OpcUa_BinarySchema_ContentFilterElement = 7929,
    OpcUa_BinarySchema_ContentFilterElement_DataTypeVersion = 7930,
    OpcUa_BinarySchema_ContentFilterElement_DictionaryFragment = 7931,
    OpcUa_BinarySchema_ContentFilter = 7932,
    OpcUa_BinarySchema_ContentFilter_DataTypeVersion = 7933,
    OpcUa_BinarySchema_ContentFilter_DictionaryFragment = 7934,
    OpcUa_BinarySchema_FilterOperand = 7935,
    OpcUa_BinarySchema_FilterOperand_DataTypeVersion = 7936,
    OpcUa_BinarySchema_FilterOperand_DictionaryFragment = 7937,
    OpcUa_BinarySchema_ElementOperand = 7938,
    OpcUa_BinarySchema_ElementOperand_DataTypeVersion = 7939,
    OpcUa_BinarySchema_ElementOperand_DictionaryFragment = 7940,
    OpcUa_BinarySchema_LiteralOperand = 7941,
    OpcUa_BinarySchema_LiteralOperand_DataTypeVersion = 7942,
    OpcUa_BinarySchema_LiteralOperand_DictionaryFragment = 7943,
    OpcUa_BinarySchema_AttributeOperand = 7944,
    OpcUa_BinarySchema_AttributeOperand_DataTypeVersion = 7945,
    OpcUa_BinarySchema_AttributeOperand_DictionaryFragment = 7946,
    OpcUa_BinarySchema_SimpleAttributeOperand = 7947,
    OpcUa_BinarySchema_SimpleAttributeOperand_DataTypeVersion = 7948,
    OpcUa_BinarySchema_SimpleAttributeOperand_DictionaryFragment = 7949,
    OpcUa_BinarySchema_HistoryEvent = 8004,
    OpcUa_BinarySchema_HistoryEvent_DataTypeVersion = 8005,
    OpcUa_BinarySchema_HistoryEvent_DictionaryFragment = 8006,
    OpcUa_BinarySchema_MonitoringFilter = 8067,
    OpcUa_BinarySchema_MonitoringFilter_DataTypeVersion = 8068,
    OpcUa_BinarySchema_MonitoringFilter_DictionaryFragment = 8069,
    OpcUa_BinarySchema_EventFilter = 8073,
    OpcUa_BinarySchema_EventFilter_DataTypeVersion = 8074,
    OpcUa_BinarySchema_EventFilter_DictionaryFragment = 8075,
    OpcUa_BinarySchema_AggregateConfiguration = 8076,
    OpcUa_BinarySchema_AggregateConfiguration_DataTypeVersion = 8077,
    OpcUa_BinarySchema_AggregateConfiguration_DictionaryFragment = 8078,
    OpcUa_BinarySchema_HistoryEventFieldList = 8172,
    OpcUa_BinarySchema_HistoryEventFieldList_DataTypeVersion = 8173,
    OpcUa_BinarySchema_HistoryEventFieldList_DictionaryFragment = 8174,
    OpcUa_BinarySchema_RedundantServerDataType = 8208,
    OpcUa_BinarySchema_RedundantServerDataType_DataTypeVersion = 8209,
    OpcUa_BinarySchema_RedundantServerDataType_DictionaryFragment = 8210,
    OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType = 8211,
    OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion = 8212,
    OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment = 8213,
    OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType = 8214,
    OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DataTypeVersion = 8215,
    OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DictionaryFragment = 8216,
    OpcUa_BinarySchema_ServerStatusDataType = 8217,
    OpcUa_BinarySchema_ServerStatusDataType_DataTypeVersion = 8218,
    OpcUa_BinarySchema_ServerStatusDataType_DictionaryFragment = 8219,
    OpcUa_BinarySchema_SessionDiagnosticsDataType = 8220,
    OpcUa_BinarySchema_SessionDiagnosticsDataType_DataTypeVersion = 8221,
    OpcUa_BinarySchema_SessionDiagnosticsDataType_DictionaryFragment = 8222,
    OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType = 8223,
    OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DataTypeVersion = 8224,
    OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DictionaryFragment = 8225,
    OpcUa_BinarySchema_ServiceCounterDataType = 8226,
    OpcUa_BinarySchema_ServiceCounterDataType_DataTypeVersion = 8227,
    OpcUa_BinarySchema_ServiceCounterDataType_DictionaryFragment = 8228,
    OpcUa_BinarySchema_SubscriptionDiagnosticsDataType = 8229,
    OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DataTypeVersion = 8230,
    OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DictionaryFragment = 8231,
    OpcUa_BinarySchema_ModelChangeStructureDataType = 8232,
    OpcUa_BinarySchema_ModelChangeStructureDataType_DataTypeVersion = 8233,
    OpcUa_BinarySchema_ModelChangeStructureDataType_DictionaryFragment = 8234,
    OpcUa_BinarySchema_SemanticChangeStructureDataType = 8235,
    OpcUa_BinarySchema_SemanticChangeStructureDataType_DataTypeVersion = 8236,
    OpcUa_BinarySchema_SemanticChangeStructureDataType_DictionaryFragment = 8237,
    OpcUa_BinarySchema_Range = 8238,
    OpcUa_BinarySchema_Range_DataTypeVersion = 8239,
    OpcUa_BinarySchema_Range_DictionaryFragment = 8240,
    OpcUa_BinarySchema_EUInformation = 8241,
    OpcUa_BinarySchema_EUInformation_DataTypeVersion = 8242,
    OpcUa_BinarySchema_EUInformation_DictionaryFragment = 8243,
    OpcUa_BinarySchema_Annotation = 8244,
    OpcUa_BinarySchema_Annotation_DataTypeVersion = 8245,
    OpcUa_BinarySchema_Annotation_DictionaryFragment = 8246,
    OpcUa_BinarySchema_ProgramDiagnosticDataType = 8247,
    OpcUa_BinarySchema_ProgramDiagnosticDataType_DataTypeVersion = 8248,
    OpcUa_BinarySchema_ProgramDiagnosticDataType_DictionaryFragment = 8249,
    OpcUa_XmlSchema = 8252,
    SubscriptionDiagnosticsType_MaxLifetimeCount = 8888,
    SubscriptionDiagnosticsType_LatePublishRequestCount = 8889,
    SubscriptionDiagnosticsType_CurrentKeepAliveCount = 8890,
    SubscriptionDiagnosticsType_CurrentLifetimeCount = 8891,
    SubscriptionDiagnosticsType_UnacknowledgedMessageCount = 8892,
    SubscriptionDiagnosticsType_DiscardedMessageCount = 8893,
    SubscriptionDiagnosticsType_MonitoredItemCount = 8894,
    SubscriptionDiagnosticsType_DisabledMonitoredItemCount = 8895,
    SubscriptionDiagnosticsType_MonitoringQueueOverflowCount = 8896,
    SubscriptionDiagnosticsType_NextSequenceNumber = 8897,
    SessionDiagnosticsObjectType_SessionDiagnostics_TotalRequestCount = 8898,
    SessionDiagnosticsVariableType_TotalRequestCount = 8900,
    SubscriptionDiagnosticsType_EventQueueOverflowCount = 8902,
    OpcUa_BinarySchema_TimeZoneDataType = 8914,
    OpcUa_BinarySchema_TimeZoneDataType_DataTypeVersion = 8915,
    OpcUa_BinarySchema_TimeZoneDataType_DictionaryFragment = 8916,
    AuditConditionRespondEventType_EventId = 8928,
    AuditConditionRespondEventType_EventType = 8929,
    AuditConditionRespondEventType_SourceNode = 8930,
    AuditConditionRespondEventType_SourceName = 8931,
    AuditConditionRespondEventType_Time = 8932,
    AuditConditionRespondEventType_ReceiveTime = 8933,
    AuditConditionRespondEventType_LocalTime = 8934,
    AuditConditionRespondEventType_Message = 8935,
    AuditConditionRespondEventType_Severity = 8936,
    AuditConditionRespondEventType_ActionTimeStamp = 8937,
    AuditConditionRespondEventType_Status = 8938,
    AuditConditionRespondEventType_ServerId = 8939,
    AuditConditionRespondEventType_ClientAuditEntryId = 8940,
    AuditConditionRespondEventType_ClientUserId = 8941,
    AuditConditionRespondEventType_MethodId = 8942,
    AuditConditionRespondEventType_InputArguments = 8943,
    AuditConditionAcknowledgeEventType_EventId = 8945,
    AuditConditionAcknowledgeEventType_EventType = 8946,
    AuditConditionAcknowledgeEventType_SourceNode = 8947,
    AuditConditionAcknowledgeEventType_SourceName = 8948,
    AuditConditionAcknowledgeEventType_Time = 8949,
    AuditConditionAcknowledgeEventType_ReceiveTime = 8950,
    AuditConditionAcknowledgeEventType_LocalTime = 8951,
    AuditConditionAcknowledgeEventType_Message = 8952,
    AuditConditionAcknowledgeEventType_Severity = 8953,
    AuditConditionAcknowledgeEventType_ActionTimeStamp = 8954,
    AuditConditionAcknowledgeEventType_Status = 8955,
    AuditConditionAcknowledgeEventType_ServerId = 8956,
    AuditConditionAcknowledgeEventType_ClientAuditEntryId = 8957,
    AuditConditionAcknowledgeEventType_ClientUserId = 8958,
    AuditConditionAcknowledgeEventType_MethodId = 8959,
    AuditConditionAcknowledgeEventType_InputArguments = 8960,
    AuditConditionConfirmEventType_EventId = 8962,
    AuditConditionConfirmEventType_EventType = 8963,
    AuditConditionConfirmEventType_SourceNode = 8964,
    AuditConditionConfirmEventType_SourceName = 8965,
    AuditConditionConfirmEventType_Time = 8966,
    AuditConditionConfirmEventType_ReceiveTime = 8967,
    AuditConditionConfirmEventType_LocalTime = 8968,
    AuditConditionConfirmEventType_Message = 8969,
    AuditConditionConfirmEventType_Severity = 8970,
    AuditConditionConfirmEventType_ActionTimeStamp = 8971,
    AuditConditionConfirmEventType_Status = 8972,
    AuditConditionConfirmEventType_ServerId = 8973,
    AuditConditionConfirmEventType_ClientAuditEntryId = 8974,
    AuditConditionConfirmEventType_ClientUserId = 8975,
    AuditConditionConfirmEventType_MethodId = 8976,
    AuditConditionConfirmEventType_InputArguments = 8977,
    TwoStateVariableType_Id = 8996,
    TwoStateVariableType_Name = 8997,
    TwoStateVariableType_Number = 8998,
    TwoStateVariableType_EffectiveDisplayName = 8999,
    TwoStateVariableType_TransitionTime = 9000,
    TwoStateVariableType_EffectiveTransitionTime = 9001,
    ConditionVariableType_SourceTimestamp = 9003,
    ConditionRefreshMethodType_InputArguments = 9008,
    ConditionType_ConditionName = 9009,
    ConditionType_BranchId = 9010,
    ConditionType_EnabledState = 9011,
    ConditionType_EnabledState_Id = 9012,
    ConditionType_EnabledState_Name = 9013,
    ConditionType_EnabledState_Number = 9014,
    ConditionType_EnabledState_EffectiveDisplayName = 9015,
    ConditionType_EnabledState_TransitionTime = 9016,
    ConditionType_EnabledState_EffectiveTransitionTime = 9017,
    ConditionType_EnabledState_TrueState = 9018,
    ConditionType_EnabledState_FalseState = 9019,
    ConditionType_Quality = 9020,
    ConditionType_Quality_SourceTimestamp = 9021,
    ConditionType_LastSeverity = 9022,
    ConditionType_LastSeverity_SourceTimestamp = 9023,
    ConditionType_Comment = 9024,
    ConditionType_Comment_SourceTimestamp = 9025,
    ConditionType_ClientUserId = 9026,
    ConditionType_AddComment_InputArguments = 9030,
    DialogResponseMethodType_InputArguments = 9032,
    DialogConditionType_ConditionName = 9033,
    DialogConditionType_BranchId = 9034,
    DialogConditionType_EnabledState = 9035,
    DialogConditionType_EnabledState_Id = 9036,
    DialogConditionType_EnabledState_Name = 9037,
    DialogConditionType_EnabledState_Number = 9038,
    DialogConditionType_EnabledState_EffectiveDisplayName = 9039,
    DialogConditionType_EnabledState_TransitionTime = 9040,
    DialogConditionType_EnabledState_EffectiveTransitionTime = 9041,
    DialogConditionType_EnabledState_TrueState = 9042,
    DialogConditionType_EnabledState_FalseState = 9043,
    DialogConditionType_Quality = 9044,
    DialogConditionType_Quality_SourceTimestamp = 9045,
    DialogConditionType_LastSeverity = 9046,
    DialogConditionType_LastSeverity_SourceTimestamp = 9047,
    DialogConditionType_Comment = 9048,
    DialogConditionType_Comment_SourceTimestamp = 9049,
    DialogConditionType_ClientUserId = 9050,
    DialogConditionType_AddComment_InputArguments = 9054,
    DialogConditionType_DialogState = 9055,
    DialogConditionType_DialogState_Id = 9056,
    DialogConditionType_DialogState_Name = 9057,
    DialogConditionType_DialogState_Number = 9058,
    DialogConditionType_DialogState_EffectiveDisplayName = 9059,
    DialogConditionType_DialogState_TransitionTime = 9060,
    DialogConditionType_DialogState_EffectiveTransitionTime = 9061,
    DialogConditionType_DialogState_TrueState = 9062,
    DialogConditionType_DialogState_FalseState = 9063,
    DialogConditionType_ResponseOptionSet = 9064,
    DialogConditionType_DefaultResponse = 9065,
    DialogConditionType_OkResponse = 9066,
    DialogConditionType_CancelResponse = 9067,
    DialogConditionType_LastResponse = 9068,
    DialogConditionType_Respond_InputArguments = 9070,
    AcknowledgeableConditionType_ConditionName = 9071,
    AcknowledgeableConditionType_BranchId = 9072,
    AcknowledgeableConditionType_EnabledState = 9073,
    AcknowledgeableConditionType_EnabledState_Id = 9074,
    AcknowledgeableConditionType_EnabledState_Name = 9075,
    AcknowledgeableConditionType_EnabledState_Number = 9076,
    AcknowledgeableConditionType_EnabledState_EffectiveDisplayName = 9077,
    AcknowledgeableConditionType_EnabledState_TransitionTime = 9078,
    AcknowledgeableConditionType_EnabledState_EffectiveTransitionTime = 9079,
    AcknowledgeableConditionType_EnabledState_TrueState = 9080,
    AcknowledgeableConditionType_EnabledState_FalseState = 9081,
    AcknowledgeableConditionType_Quality = 9082,
    AcknowledgeableConditionType_Quality_SourceTimestamp = 9083,
    AcknowledgeableConditionType_LastSeverity = 9084,
    AcknowledgeableConditionType_LastSeverity_SourceTimestamp = 9085,
    AcknowledgeableConditionType_Comment = 9086,
    AcknowledgeableConditionType_Comment_SourceTimestamp = 9087,
    AcknowledgeableConditionType_ClientUserId = 9088,
    AcknowledgeableConditionType_AddComment_InputArguments = 9092,
    AcknowledgeableConditionType_AckedState = 9093,
    AcknowledgeableConditionType_AckedState_Id = 9094,
    AcknowledgeableConditionType_AckedState_Name = 9095,
    AcknowledgeableConditionType_AckedState_Number = 9096,
    AcknowledgeableConditionType_AckedState_EffectiveDisplayName = 9097,
    AcknowledgeableConditionType_AckedState_TransitionTime = 9098,
    AcknowledgeableConditionType_AckedState_EffectiveTransitionTime = 9099,
    AcknowledgeableConditionType_AckedState_TrueState = 9100,
    AcknowledgeableConditionType_AckedState_FalseState = 9101,
    AcknowledgeableConditionType_ConfirmedState = 9102,
    AcknowledgeableConditionType_ConfirmedState_Id = 9103,
    AcknowledgeableConditionType_ConfirmedState_Name = 9104,
    AcknowledgeableConditionType_ConfirmedState_Number = 9105,
    AcknowledgeableConditionType_ConfirmedState_EffectiveDisplayName = 9106,
    AcknowledgeableConditionType_ConfirmedState_TransitionTime = 9107,
    AcknowledgeableConditionType_ConfirmedState_EffectiveTransitionTime = 9108,
    AcknowledgeableConditionType_ConfirmedState_TrueState = 9109,
    AcknowledgeableConditionType_ConfirmedState_FalseState = 9110,
    AcknowledgeableConditionType_Acknowledge_InputArguments = 9112,
    AcknowledgeableConditionType_Confirm_InputArguments = 9114,
    ShelvedStateMachineType_UnshelveTime = 9115,
    AlarmConditionType_ConditionName = 9116,
    AlarmConditionType_BranchId = 9117,
    AlarmConditionType_EnabledState = 9118,
    AlarmConditionType_EnabledState_Id = 9119,
    AlarmConditionType_EnabledState_Name = 9120,
    AlarmConditionType_EnabledState_Number = 9121,
    AlarmConditionType_EnabledState_EffectiveDisplayName = 9122,
    AlarmConditionType_EnabledState_TransitionTime = 9123,
    AlarmConditionType_EnabledState_EffectiveTransitionTime = 9124,
    AlarmConditionType_EnabledState_TrueState = 9125,
    AlarmConditionType_EnabledState_FalseState = 9126,
    AlarmConditionType_Quality = 9127,
    AlarmConditionType_Quality_SourceTimestamp = 9128,
    AlarmConditionType_LastSeverity = 9129,
    AlarmConditionType_LastSeverity_SourceTimestamp = 9130,
    AlarmConditionType_Comment = 9131,
    AlarmConditionType_Comment_SourceTimestamp = 9132,
    AlarmConditionType_ClientUserId = 9133,
    AlarmConditionType_AddComment_InputArguments = 9137,
    AlarmConditionType_AckedState = 9138,
    AlarmConditionType_AckedState_Id = 9139,
    AlarmConditionType_AckedState_Name = 9140,
    AlarmConditionType_AckedState_Number = 9141,
    AlarmConditionType_AckedState_EffectiveDisplayName = 9142,
    AlarmConditionType_AckedState_TransitionTime = 9143,
    AlarmConditionType_AckedState_EffectiveTransitionTime = 9144,
    AlarmConditionType_AckedState_TrueState = 9145,
    AlarmConditionType_AckedState_FalseState = 9146,
    AlarmConditionType_ConfirmedState = 9147,
    AlarmConditionType_ConfirmedState_Id = 9148,
    AlarmConditionType_ConfirmedState_Name = 9149,
    AlarmConditionType_ConfirmedState_Number = 9150,
    AlarmConditionType_ConfirmedState_EffectiveDisplayName = 9151,
    AlarmConditionType_ConfirmedState_TransitionTime = 9152,
    AlarmConditionType_ConfirmedState_EffectiveTransitionTime = 9153,
    AlarmConditionType_ConfirmedState_TrueState = 9154,
    AlarmConditionType_ConfirmedState_FalseState = 9155,
    AlarmConditionType_Acknowledge_InputArguments = 9157,
    AlarmConditionType_Confirm_InputArguments = 9159,
    AlarmConditionType_ActiveState = 9160,
    AlarmConditionType_ActiveState_Id = 9161,
    AlarmConditionType_ActiveState_Name = 9162,
    AlarmConditionType_ActiveState_Number = 9163,
    AlarmConditionType_ActiveState_EffectiveDisplayName = 9164,
    AlarmConditionType_ActiveState_TransitionTime = 9165,
    AlarmConditionType_ActiveState_EffectiveTransitionTime = 9166,
    AlarmConditionType_ActiveState_TrueState = 9167,
    AlarmConditionType_ActiveState_FalseState = 9168,
    AlarmConditionType_SuppressedState = 9169,
    AlarmConditionType_SuppressedState_Id = 9170,
    AlarmConditionType_SuppressedState_Name = 9171,
    AlarmConditionType_SuppressedState_Number = 9172,
    AlarmConditionType_SuppressedState_EffectiveDisplayName = 9173,
    AlarmConditionType_SuppressedState_TransitionTime = 9174,
    AlarmConditionType_SuppressedState_EffectiveTransitionTime = 9175,
    AlarmConditionType_SuppressedState_TrueState = 9176,
    AlarmConditionType_SuppressedState_FalseState = 9177,
    AlarmConditionType_ShelvingState_CurrentState = 9179,
    AlarmConditionType_ShelvingState_CurrentState_Id = 9180,
    AlarmConditionType_ShelvingState_CurrentState_Name = 9181,
    AlarmConditionType_ShelvingState_CurrentState_Number = 9182,
    AlarmConditionType_ShelvingState_CurrentState_EffectiveDisplayName = 9183,
    AlarmConditionType_ShelvingState_LastTransition = 9184,
    AlarmConditionType_ShelvingState_LastTransition_Id = 9185,
    AlarmConditionType_ShelvingState_LastTransition_Name = 9186,
    AlarmConditionType_ShelvingState_LastTransition_Number = 9187,
    AlarmConditionType_ShelvingState_LastTransition_TransitionTime = 9188,
    AlarmConditionType_ShelvingState_UnshelveTime = 9189,
    AlarmConditionType_ShelvingState_TimedShelve_InputArguments = 9214,
    AlarmConditionType_SuppressedOrShelved = 9215,
    AlarmConditionType_MaxTimeShelved = 9216,
    LimitAlarmType_ConditionName = 9217,
    LimitAlarmType_BranchId = 9218,
    LimitAlarmType_EnabledState = 9219,
    LimitAlarmType_EnabledState_Id = 9220,
    LimitAlarmType_EnabledState_Name = 9221,
    LimitAlarmType_EnabledState_Number = 9222,
    LimitAlarmType_EnabledState_EffectiveDisplayName = 9223,
    LimitAlarmType_EnabledState_TransitionTime = 9224,
    LimitAlarmType_EnabledState_EffectiveTransitionTime = 9225,
    LimitAlarmType_EnabledState_TrueState = 9226,
    LimitAlarmType_EnabledState_FalseState = 9227,
    LimitAlarmType_Quality = 9228,
    LimitAlarmType_Quality_SourceTimestamp = 9229,
    LimitAlarmType_LastSeverity = 9230,
    LimitAlarmType_LastSeverity_SourceTimestamp = 9231,
    LimitAlarmType_Comment = 9232,
    LimitAlarmType_Comment_SourceTimestamp = 9233,
    LimitAlarmType_ClientUserId = 9234,
    LimitAlarmType_AddComment_InputArguments = 9238,
    LimitAlarmType_AckedState = 9239,
    LimitAlarmType_AckedState_Id = 9240,
    LimitAlarmType_AckedState_Name = 9241,
    LimitAlarmType_AckedState_Number = 9242,
    LimitAlarmType_AckedState_EffectiveDisplayName = 9243,
    LimitAlarmType_AckedState_TransitionTime = 9244,
    LimitAlarmType_AckedState_EffectiveTransitionTime = 9245,
    LimitAlarmType_AckedState_TrueState = 9246,
    LimitAlarmType_AckedState_FalseState = 9247,
    LimitAlarmType_ConfirmedState = 9248,
    LimitAlarmType_ConfirmedState_Id = 9249,
    LimitAlarmType_ConfirmedState_Name = 9250,
    LimitAlarmType_ConfirmedState_Number = 9251,
    LimitAlarmType_ConfirmedState_EffectiveDisplayName = 9252,
    LimitAlarmType_ConfirmedState_TransitionTime = 9253,
    LimitAlarmType_ConfirmedState_EffectiveTransitionTime = 9254,
    LimitAlarmType_ConfirmedState_TrueState = 9255,
    LimitAlarmType_ConfirmedState_FalseState = 9256,
    LimitAlarmType_Acknowledge_InputArguments = 9258,
    LimitAlarmType_Confirm_InputArguments = 9260,
    LimitAlarmType_ActiveState = 9261,
    LimitAlarmType_ActiveState_Id = 9262,
    LimitAlarmType_ActiveState_Name = 9263,
    LimitAlarmType_ActiveState_Number = 9264,
    LimitAlarmType_ActiveState_EffectiveDisplayName = 9265,
    LimitAlarmType_ActiveState_TransitionTime = 9266,
    LimitAlarmType_ActiveState_EffectiveTransitionTime = 9267,
    LimitAlarmType_ActiveState_TrueState = 9268,
    LimitAlarmType_ActiveState_FalseState = 9269,
    LimitAlarmType_SuppressedState = 9270,
    LimitAlarmType_SuppressedState_Id = 9271,
    LimitAlarmType_SuppressedState_Name = 9272,
    LimitAlarmType_SuppressedState_Number = 9273,
    LimitAlarmType_SuppressedState_EffectiveDisplayName = 9274,
    LimitAlarmType_SuppressedState_TransitionTime = 9275,
    LimitAlarmType_SuppressedState_EffectiveTransitionTime = 9276,
    LimitAlarmType_SuppressedState_TrueState = 9277,
    LimitAlarmType_SuppressedState_FalseState = 9278,
    LimitAlarmType_ShelvingState_CurrentState = 9280,
    LimitAlarmType_ShelvingState_CurrentState_Id = 9281,
    LimitAlarmType_ShelvingState_CurrentState_Name = 9282,
    LimitAlarmType_ShelvingState_CurrentState_Number = 9283,
    LimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9284,
    LimitAlarmType_ShelvingState_LastTransition = 9285,
    LimitAlarmType_ShelvingState_LastTransition_Id = 9286,
    LimitAlarmType_ShelvingState_LastTransition_Name = 9287,
    LimitAlarmType_ShelvingState_LastTransition_Number = 9288,
    LimitAlarmType_ShelvingState_LastTransition_TransitionTime = 9289,
    LimitAlarmType_ShelvingState_UnshelveTime = 9290,
    LimitAlarmType_ShelvingState_TimedShelve_InputArguments = 9315,
    LimitAlarmType_SuppressedOrShelved = 9316,
    LimitAlarmType_MaxTimeShelved = 9317,
    ExclusiveLimitStateMachineType_CurrentState = 9319,
    ExclusiveLimitStateMachineType_CurrentState_Id = 9320,
    ExclusiveLimitStateMachineType_CurrentState_Name = 9321,
    ExclusiveLimitStateMachineType_CurrentState_Number = 9322,
    ExclusiveLimitStateMachineType_CurrentState_EffectiveDisplayName = 9323,
    ExclusiveLimitStateMachineType_LastTransition = 9324,
    ExclusiveLimitStateMachineType_LastTransition_Id = 9325,
    ExclusiveLimitStateMachineType_LastTransition_Name = 9326,
    ExclusiveLimitStateMachineType_LastTransition_Number = 9327,
    ExclusiveLimitStateMachineType_LastTransition_TransitionTime = 9328,
    ExclusiveLimitStateMachineType_HighHigh_StateNumber = 9330,
    ExclusiveLimitStateMachineType_High_StateNumber = 9332,
    ExclusiveLimitStateMachineType_Low_StateNumber = 9334,
    ExclusiveLimitStateMachineType_LowLow_StateNumber = 9336,
    ExclusiveLimitAlarmType_EventId = 9342,
    ExclusiveLimitAlarmType_EventType = 9343,
    ExclusiveLimitAlarmType_SourceNode = 9344,
    ExclusiveLimitAlarmType_SourceName = 9345,
    ExclusiveLimitAlarmType_Time = 9346,
    ExclusiveLimitAlarmType_ReceiveTime = 9347,
    ExclusiveLimitAlarmType_LocalTime = 9348,
    ExclusiveLimitAlarmType_Message = 9349,
    ExclusiveLimitAlarmType_Severity = 9350,
    ExclusiveLimitAlarmType_ConditionName = 9351,
    ExclusiveLimitAlarmType_BranchId = 9352,
    ExclusiveLimitAlarmType_Retain = 9353,
    ExclusiveLimitAlarmType_EnabledState = 9354,
    ExclusiveLimitAlarmType_EnabledState_Id = 9355,
    ExclusiveLimitAlarmType_EnabledState_Name = 9356,
    ExclusiveLimitAlarmType_EnabledState_Number = 9357,
    ExclusiveLimitAlarmType_EnabledState_EffectiveDisplayName = 9358,
    ExclusiveLimitAlarmType_EnabledState_TransitionTime = 9359,
    ExclusiveLimitAlarmType_EnabledState_EffectiveTransitionTime = 9360,
    ExclusiveLimitAlarmType_EnabledState_TrueState = 9361,
    ExclusiveLimitAlarmType_EnabledState_FalseState = 9362,
    ExclusiveLimitAlarmType_Quality = 9363,
    ExclusiveLimitAlarmType_Quality_SourceTimestamp = 9364,
    ExclusiveLimitAlarmType_LastSeverity = 9365,
    ExclusiveLimitAlarmType_LastSeverity_SourceTimestamp = 9366,
    ExclusiveLimitAlarmType_Comment = 9367,
    ExclusiveLimitAlarmType_Comment_SourceTimestamp = 9368,
    ExclusiveLimitAlarmType_ClientUserId = 9369,
    ExclusiveLimitAlarmType_AddComment_InputArguments = 9373,
    ExclusiveLimitAlarmType_ConditionRefresh_InputArguments = 9375,
    ExclusiveLimitAlarmType_AckedState = 9376,
    ExclusiveLimitAlarmType_AckedState_Id = 9377,
    ExclusiveLimitAlarmType_AckedState_Name = 9378,
    ExclusiveLimitAlarmType_AckedState_Number = 9379,
    ExclusiveLimitAlarmType_AckedState_EffectiveDisplayName = 9380,
    ExclusiveLimitAlarmType_AckedState_TransitionTime = 9381,
    ExclusiveLimitAlarmType_AckedState_EffectiveTransitionTime = 9382,
    ExclusiveLimitAlarmType_AckedState_TrueState = 9383,
    ExclusiveLimitAlarmType_AckedState_FalseState = 9384,
    ExclusiveLimitAlarmType_ConfirmedState = 9385,
    ExclusiveLimitAlarmType_ConfirmedState_Id = 9386,
    ExclusiveLimitAlarmType_ConfirmedState_Name = 9387,
    ExclusiveLimitAlarmType_ConfirmedState_Number = 9388,
    ExclusiveLimitAlarmType_ConfirmedState_EffectiveDisplayName = 9389,
    ExclusiveLimitAlarmType_ConfirmedState_TransitionTime = 9390,
    ExclusiveLimitAlarmType_ConfirmedState_EffectiveTransitionTime = 9391,
    ExclusiveLimitAlarmType_ConfirmedState_TrueState = 9392,
    ExclusiveLimitAlarmType_ConfirmedState_FalseState = 9393,
    ExclusiveLimitAlarmType_Acknowledge_InputArguments = 9395,
    ExclusiveLimitAlarmType_Confirm_InputArguments = 9397,
    ExclusiveLimitAlarmType_ActiveState = 9398,
    ExclusiveLimitAlarmType_ActiveState_Id = 9399,
    ExclusiveLimitAlarmType_ActiveState_Name = 9400,
    ExclusiveLimitAlarmType_ActiveState_Number = 9401,
    ExclusiveLimitAlarmType_ActiveState_EffectiveDisplayName = 9402,
    ExclusiveLimitAlarmType_ActiveState_TransitionTime = 9403,
    ExclusiveLimitAlarmType_ActiveState_EffectiveTransitionTime = 9404,
    ExclusiveLimitAlarmType_ActiveState_TrueState = 9405,
    ExclusiveLimitAlarmType_ActiveState_FalseState = 9406,
    ExclusiveLimitAlarmType_SuppressedState = 9407,
    ExclusiveLimitAlarmType_SuppressedState_Id = 9408,
    ExclusiveLimitAlarmType_SuppressedState_Name = 9409,
    ExclusiveLimitAlarmType_SuppressedState_Number = 9410,
    ExclusiveLimitAlarmType_SuppressedState_EffectiveDisplayName = 9411,
    ExclusiveLimitAlarmType_SuppressedState_TransitionTime = 9412,
    ExclusiveLimitAlarmType_SuppressedState_EffectiveTransitionTime = 9413,
    ExclusiveLimitAlarmType_SuppressedState_TrueState = 9414,
    ExclusiveLimitAlarmType_SuppressedState_FalseState = 9415,
    ExclusiveLimitAlarmType_ShelvingState_CurrentState = 9417,
    ExclusiveLimitAlarmType_ShelvingState_CurrentState_Id = 9418,
    ExclusiveLimitAlarmType_ShelvingState_CurrentState_Name = 9419,
    ExclusiveLimitAlarmType_ShelvingState_CurrentState_Number = 9420,
    ExclusiveLimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9421,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition = 9422,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition_Id = 9423,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition_Name = 9424,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition_Number = 9425,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition_TransitionTime = 9426,
    ExclusiveLimitAlarmType_ShelvingState_UnshelveTime = 9427,
    ExclusiveLimitAlarmType_ShelvingState_TimedShelve_InputArguments = 9452,
    ExclusiveLimitAlarmType_SuppressedOrShelved = 9453,
    ExclusiveLimitAlarmType_MaxTimeShelved = 9454,
    ExclusiveLimitAlarmType_LimitState_CurrentState = 9456,
    ExclusiveLimitAlarmType_LimitState_CurrentState_Id = 9457,
    ExclusiveLimitAlarmType_LimitState_CurrentState_Name = 9458,
    ExclusiveLimitAlarmType_LimitState_CurrentState_Number = 9459,
    ExclusiveLimitAlarmType_LimitState_CurrentState_EffectiveDisplayName = 9460,
    ExclusiveLimitAlarmType_LimitState_LastTransition = 9461,
    ExclusiveLimitAlarmType_LimitState_LastTransition_Id = 9462,
    ExclusiveLimitAlarmType_LimitState_LastTransition_Name = 9463,
    ExclusiveLimitAlarmType_LimitState_LastTransition_Number = 9464,
    ExclusiveLimitAlarmType_LimitState_LastTransition_TransitionTime = 9465,
    ExclusiveLimitAlarmType_HighHighLimit = 9478,
    ExclusiveLimitAlarmType_HighLimit = 9479,
    ExclusiveLimitAlarmType_LowLimit = 9480,
    ExclusiveLimitAlarmType_LowLowLimit = 9481,
    ExclusiveLevelAlarmType_EventId = 9483,
    ExclusiveLevelAlarmType_EventType = 9484,
    ExclusiveLevelAlarmType_SourceNode = 9485,
    ExclusiveLevelAlarmType_SourceName = 9486,
    ExclusiveLevelAlarmType_Time = 9487,
    ExclusiveLevelAlarmType_ReceiveTime = 9488,
    ExclusiveLevelAlarmType_LocalTime = 9489,
    ExclusiveLevelAlarmType_Message = 9490,
    ExclusiveLevelAlarmType_Severity = 9491,
    ExclusiveLevelAlarmType_ConditionName = 9492,
    ExclusiveLevelAlarmType_BranchId = 9493,
    ExclusiveLevelAlarmType_Retain = 9494,
    ExclusiveLevelAlarmType_EnabledState = 9495,
    ExclusiveLevelAlarmType_EnabledState_Id = 9496,
    ExclusiveLevelAlarmType_EnabledState_Name = 9497,
    ExclusiveLevelAlarmType_EnabledState_Number = 9498,
    ExclusiveLevelAlarmType_EnabledState_EffectiveDisplayName = 9499,
    ExclusiveLevelAlarmType_EnabledState_TransitionTime = 9500,
    ExclusiveLevelAlarmType_EnabledState_EffectiveTransitionTime = 9501,
    ExclusiveLevelAlarmType_EnabledState_TrueState = 9502,
    ExclusiveLevelAlarmType_EnabledState_FalseState = 9503,
    ExclusiveLevelAlarmType_Quality = 9504,
    ExclusiveLevelAlarmType_Quality_SourceTimestamp = 9505,
    ExclusiveLevelAlarmType_LastSeverity = 9506,
    ExclusiveLevelAlarmType_LastSeverity_SourceTimestamp = 9507,
    ExclusiveLevelAlarmType_Comment = 9508,
    ExclusiveLevelAlarmType_Comment_SourceTimestamp = 9509,
    ExclusiveLevelAlarmType_ClientUserId = 9510,
    ExclusiveLevelAlarmType_AddComment_InputArguments = 9514,
    ExclusiveLevelAlarmType_ConditionRefresh_InputArguments = 9516,
    ExclusiveLevelAlarmType_AckedState = 9517,
    ExclusiveLevelAlarmType_AckedState_Id = 9518,
    ExclusiveLevelAlarmType_AckedState_Name = 9519,
    ExclusiveLevelAlarmType_AckedState_Number = 9520,
    ExclusiveLevelAlarmType_AckedState_EffectiveDisplayName = 9521,
    ExclusiveLevelAlarmType_AckedState_TransitionTime = 9522,
    ExclusiveLevelAlarmType_AckedState_EffectiveTransitionTime = 9523,
    ExclusiveLevelAlarmType_AckedState_TrueState = 9524,
    ExclusiveLevelAlarmType_AckedState_FalseState = 9525,
    ExclusiveLevelAlarmType_ConfirmedState = 9526,
    ExclusiveLevelAlarmType_ConfirmedState_Id = 9527,
    ExclusiveLevelAlarmType_ConfirmedState_Name = 9528,
    ExclusiveLevelAlarmType_ConfirmedState_Number = 9529,
    ExclusiveLevelAlarmType_ConfirmedState_EffectiveDisplayName = 9530,
    ExclusiveLevelAlarmType_ConfirmedState_TransitionTime = 9531,
    ExclusiveLevelAlarmType_ConfirmedState_EffectiveTransitionTime = 9532,
    ExclusiveLevelAlarmType_ConfirmedState_TrueState = 9533,
    ExclusiveLevelAlarmType_ConfirmedState_FalseState = 9534,
    ExclusiveLevelAlarmType_Acknowledge_InputArguments = 9536,
    ExclusiveLevelAlarmType_Confirm_InputArguments = 9538,
    ExclusiveLevelAlarmType_ActiveState = 9539,
    ExclusiveLevelAlarmType_ActiveState_Id = 9540,
    ExclusiveLevelAlarmType_ActiveState_Name = 9541,
    ExclusiveLevelAlarmType_ActiveState_Number = 9542,
    ExclusiveLevelAlarmType_ActiveState_EffectiveDisplayName = 9543,
    ExclusiveLevelAlarmType_ActiveState_TransitionTime = 9544,
    ExclusiveLevelAlarmType_ActiveState_EffectiveTransitionTime = 9545,
    ExclusiveLevelAlarmType_ActiveState_TrueState = 9546,
    ExclusiveLevelAlarmType_ActiveState_FalseState = 9547,
    ExclusiveLevelAlarmType_SuppressedState = 9548,
    ExclusiveLevelAlarmType_SuppressedState_Id = 9549,
    ExclusiveLevelAlarmType_SuppressedState_Name = 9550,
    ExclusiveLevelAlarmType_SuppressedState_Number = 9551,
    ExclusiveLevelAlarmType_SuppressedState_EffectiveDisplayName = 9552,
    ExclusiveLevelAlarmType_SuppressedState_TransitionTime = 9553,
    ExclusiveLevelAlarmType_SuppressedState_EffectiveTransitionTime = 9554,
    ExclusiveLevelAlarmType_SuppressedState_TrueState = 9555,
    ExclusiveLevelAlarmType_SuppressedState_FalseState = 9556,
    ExclusiveLevelAlarmType_ShelvingState_CurrentState = 9558,
    ExclusiveLevelAlarmType_ShelvingState_CurrentState_Id = 9559,
    ExclusiveLevelAlarmType_ShelvingState_CurrentState_Name = 9560,
    ExclusiveLevelAlarmType_ShelvingState_CurrentState_Number = 9561,
    ExclusiveLevelAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9562,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition = 9563,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition_Id = 9564,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition_Name = 9565,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition_Number = 9566,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition_TransitionTime = 9567,
    ExclusiveLevelAlarmType_ShelvingState_UnshelveTime = 9568,
    ExclusiveLevelAlarmType_ShelvingState_TimedShelve_InputArguments = 9593,
    ExclusiveLevelAlarmType_SuppressedOrShelved = 9594,
    ExclusiveLevelAlarmType_MaxTimeShelved = 9595,
    ExclusiveLevelAlarmType_LimitState_CurrentState = 9597,
    ExclusiveLevelAlarmType_LimitState_CurrentState_Id = 9598,
    ExclusiveLevelAlarmType_LimitState_CurrentState_Name = 9599,
    ExclusiveLevelAlarmType_LimitState_CurrentState_Number = 9600,
    ExclusiveLevelAlarmType_LimitState_CurrentState_EffectiveDisplayName = 9601,
    ExclusiveLevelAlarmType_LimitState_LastTransition = 9602,
    ExclusiveLevelAlarmType_LimitState_LastTransition_Id = 9603,
    ExclusiveLevelAlarmType_LimitState_LastTransition_Name = 9604,
    ExclusiveLevelAlarmType_LimitState_LastTransition_Number = 9605,
    ExclusiveLevelAlarmType_LimitState_LastTransition_TransitionTime = 9606,
    ExclusiveLevelAlarmType_HighHighLimit = 9619,
    ExclusiveLevelAlarmType_HighLimit = 9620,
    ExclusiveLevelAlarmType_LowLimit = 9621,
    ExclusiveLevelAlarmType_LowLowLimit = 9622,
    ExclusiveRateOfChangeAlarmType_EventId = 9624,
    ExclusiveRateOfChangeAlarmType_EventType = 9625,
    ExclusiveRateOfChangeAlarmType_SourceNode = 9626,
    ExclusiveRateOfChangeAlarmType_SourceName = 9627,
    ExclusiveRateOfChangeAlarmType_Time = 9628,
    ExclusiveRateOfChangeAlarmType_ReceiveTime = 9629,
    ExclusiveRateOfChangeAlarmType_LocalTime = 9630,
    ExclusiveRateOfChangeAlarmType_Message = 9631,
    ExclusiveRateOfChangeAlarmType_Severity = 9632,
    ExclusiveRateOfChangeAlarmType_ConditionName = 9633,
    ExclusiveRateOfChangeAlarmType_BranchId = 9634,
    ExclusiveRateOfChangeAlarmType_Retain = 9635,
    ExclusiveRateOfChangeAlarmType_EnabledState = 9636,
    ExclusiveRateOfChangeAlarmType_EnabledState_Id = 9637,
    ExclusiveRateOfChangeAlarmType_EnabledState_Name = 9638,
    ExclusiveRateOfChangeAlarmType_EnabledState_Number = 9639,
    ExclusiveRateOfChangeAlarmType_EnabledState_EffectiveDisplayName = 9640,
    ExclusiveRateOfChangeAlarmType_EnabledState_TransitionTime = 9641,
    ExclusiveRateOfChangeAlarmType_EnabledState_EffectiveTransitionTime = 9642,
    ExclusiveRateOfChangeAlarmType_EnabledState_TrueState = 9643,
    ExclusiveRateOfChangeAlarmType_EnabledState_FalseState = 9644,
    ExclusiveRateOfChangeAlarmType_Quality = 9645,
    ExclusiveRateOfChangeAlarmType_Quality_SourceTimestamp = 9646,
    ExclusiveRateOfChangeAlarmType_LastSeverity = 9647,
    ExclusiveRateOfChangeAlarmType_LastSeverity_SourceTimestamp = 9648,
    ExclusiveRateOfChangeAlarmType_Comment = 9649,
    ExclusiveRateOfChangeAlarmType_Comment_SourceTimestamp = 9650,
    ExclusiveRateOfChangeAlarmType_ClientUserId = 9651,
    ExclusiveRateOfChangeAlarmType_AddComment_InputArguments = 9655,
    ExclusiveRateOfChangeAlarmType_ConditionRefresh_InputArguments = 9657,
    ExclusiveRateOfChangeAlarmType_AckedState = 9658,
    ExclusiveRateOfChangeAlarmType_AckedState_Id = 9659,
    ExclusiveRateOfChangeAlarmType_AckedState_Name = 9660,
    ExclusiveRateOfChangeAlarmType_AckedState_Number = 9661,
    ExclusiveRateOfChangeAlarmType_AckedState_EffectiveDisplayName = 9662,
    ExclusiveRateOfChangeAlarmType_AckedState_TransitionTime = 9663,
    ExclusiveRateOfChangeAlarmType_AckedState_EffectiveTransitionTime = 9664,
    ExclusiveRateOfChangeAlarmType_AckedState_TrueState = 9665,
    ExclusiveRateOfChangeAlarmType_AckedState_FalseState = 9666,
    ExclusiveRateOfChangeAlarmType_ConfirmedState = 9667,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_Id = 9668,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_Name = 9669,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_Number = 9670,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveDisplayName = 9671,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_TransitionTime = 9672,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveTransitionTime = 9673,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_TrueState = 9674,
    ExclusiveRateOfChangeAlarmType_ConfirmedState_FalseState = 9675,
    ExclusiveRateOfChangeAlarmType_Acknowledge_InputArguments = 9677,
    ExclusiveRateOfChangeAlarmType_Confirm_InputArguments = 9679,
    ExclusiveRateOfChangeAlarmType_ActiveState = 9680,
    ExclusiveRateOfChangeAlarmType_ActiveState_Id = 9681,
    ExclusiveRateOfChangeAlarmType_ActiveState_Name = 9682,
    ExclusiveRateOfChangeAlarmType_ActiveState_Number = 9683,
    ExclusiveRateOfChangeAlarmType_ActiveState_EffectiveDisplayName = 9684,
    ExclusiveRateOfChangeAlarmType_ActiveState_TransitionTime = 9685,
    ExclusiveRateOfChangeAlarmType_ActiveState_EffectiveTransitionTime = 9686,
    ExclusiveRateOfChangeAlarmType_ActiveState_TrueState = 9687,
    ExclusiveRateOfChangeAlarmType_ActiveState_FalseState = 9688,
    ExclusiveRateOfChangeAlarmType_SuppressedState = 9689,
    ExclusiveRateOfChangeAlarmType_SuppressedState_Id = 9690,
    ExclusiveRateOfChangeAlarmType_SuppressedState_Name = 9691,
    ExclusiveRateOfChangeAlarmType_SuppressedState_Number = 9692,
    ExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveDisplayName = 9693,
    ExclusiveRateOfChangeAlarmType_SuppressedState_TransitionTime = 9694,
    ExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveTransitionTime = 9695,
    ExclusiveRateOfChangeAlarmType_SuppressedState_TrueState = 9696,
    ExclusiveRateOfChangeAlarmType_SuppressedState_FalseState = 9697,
    ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState = 9699,
    ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Id = 9700,
    ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Name = 9701,
    ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Number = 9702,
    ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9703,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition = 9704,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Id = 9705,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Name = 9706,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Number = 9707,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_TransitionTime = 9708,
    ExclusiveRateOfChangeAlarmType_ShelvingState_UnshelveTime = 9709,
    ExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve_InputArguments = 9734,
    ExclusiveRateOfChangeAlarmType_SuppressedOrShelved = 9735,
    ExclusiveRateOfChangeAlarmType_MaxTimeShelved = 9736,
    ExclusiveRateOfChangeAlarmType_LimitState_CurrentState = 9738,
    ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Id = 9739,
    ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Name = 9740,
    ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Number = 9741,
    ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_EffectiveDisplayName = 9742,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition = 9743,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Id = 9744,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Name = 9745,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Number = 9746,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_TransitionTime = 9747,
    ExclusiveRateOfChangeAlarmType_HighHighLimit = 9760,
    ExclusiveRateOfChangeAlarmType_HighLimit = 9761,
    ExclusiveRateOfChangeAlarmType_LowLimit = 9762,
    ExclusiveRateOfChangeAlarmType_LowLowLimit = 9763,
    ExclusiveDeviationAlarmType_EventId = 9765,
    ExclusiveDeviationAlarmType_EventType = 9766,
    ExclusiveDeviationAlarmType_SourceNode = 9767,
    ExclusiveDeviationAlarmType_SourceName = 9768,
    ExclusiveDeviationAlarmType_Time = 9769,
    ExclusiveDeviationAlarmType_ReceiveTime = 9770,
    ExclusiveDeviationAlarmType_LocalTime = 9771,
    ExclusiveDeviationAlarmType_Message = 9772,
    ExclusiveDeviationAlarmType_Severity = 9773,
    ExclusiveDeviationAlarmType_ConditionName = 9774,
    ExclusiveDeviationAlarmType_BranchId = 9775,
    ExclusiveDeviationAlarmType_Retain = 9776,
    ExclusiveDeviationAlarmType_EnabledState = 9777,
    ExclusiveDeviationAlarmType_EnabledState_Id = 9778,
    ExclusiveDeviationAlarmType_EnabledState_Name = 9779,
    ExclusiveDeviationAlarmType_EnabledState_Number = 9780,
    ExclusiveDeviationAlarmType_EnabledState_EffectiveDisplayName = 9781,
    ExclusiveDeviationAlarmType_EnabledState_TransitionTime = 9782,
    ExclusiveDeviationAlarmType_EnabledState_EffectiveTransitionTime = 9783,
    ExclusiveDeviationAlarmType_EnabledState_TrueState = 9784,
    ExclusiveDeviationAlarmType_EnabledState_FalseState = 9785,
    ExclusiveDeviationAlarmType_Quality = 9786,
    ExclusiveDeviationAlarmType_Quality_SourceTimestamp = 9787,
    ExclusiveDeviationAlarmType_LastSeverity = 9788,
    ExclusiveDeviationAlarmType_LastSeverity_SourceTimestamp = 9789,
    ExclusiveDeviationAlarmType_Comment = 9790,
    ExclusiveDeviationAlarmType_Comment_SourceTimestamp = 9791,
    ExclusiveDeviationAlarmType_ClientUserId = 9792,
    ExclusiveDeviationAlarmType_AddComment_InputArguments = 9796,
    ExclusiveDeviationAlarmType_ConditionRefresh_InputArguments = 9798,
    ExclusiveDeviationAlarmType_AckedState = 9799,
    ExclusiveDeviationAlarmType_AckedState_Id = 9800,
    ExclusiveDeviationAlarmType_AckedState_Name = 9801,
    ExclusiveDeviationAlarmType_AckedState_Number = 9802,
    ExclusiveDeviationAlarmType_AckedState_EffectiveDisplayName = 9803,
    ExclusiveDeviationAlarmType_AckedState_TransitionTime = 9804,
    ExclusiveDeviationAlarmType_AckedState_EffectiveTransitionTime = 9805,
    ExclusiveDeviationAlarmType_AckedState_TrueState = 9806,
    ExclusiveDeviationAlarmType_AckedState_FalseState = 9807,
    ExclusiveDeviationAlarmType_ConfirmedState = 9808,
    ExclusiveDeviationAlarmType_ConfirmedState_Id = 9809,
    ExclusiveDeviationAlarmType_ConfirmedState_Name = 9810,
    ExclusiveDeviationAlarmType_ConfirmedState_Number = 9811,
    ExclusiveDeviationAlarmType_ConfirmedState_EffectiveDisplayName = 9812,
    ExclusiveDeviationAlarmType_ConfirmedState_TransitionTime = 9813,
    ExclusiveDeviationAlarmType_ConfirmedState_EffectiveTransitionTime = 9814,
    ExclusiveDeviationAlarmType_ConfirmedState_TrueState = 9815,
    ExclusiveDeviationAlarmType_ConfirmedState_FalseState = 9816,
    ExclusiveDeviationAlarmType_Acknowledge_InputArguments = 9818,
    ExclusiveDeviationAlarmType_Confirm_InputArguments = 9820,
    ExclusiveDeviationAlarmType_ActiveState = 9821,
    ExclusiveDeviationAlarmType_ActiveState_Id = 9822,
    ExclusiveDeviationAlarmType_ActiveState_Name = 9823,
    ExclusiveDeviationAlarmType_ActiveState_Number = 9824,
    ExclusiveDeviationAlarmType_ActiveState_EffectiveDisplayName = 9825,
    ExclusiveDeviationAlarmType_ActiveState_TransitionTime = 9826,
    ExclusiveDeviationAlarmType_ActiveState_EffectiveTransitionTime = 9827,
    ExclusiveDeviationAlarmType_ActiveState_TrueState = 9828,
    ExclusiveDeviationAlarmType_ActiveState_FalseState = 9829,
    ExclusiveDeviationAlarmType_SuppressedState = 9830,
    ExclusiveDeviationAlarmType_SuppressedState_Id = 9831,
    ExclusiveDeviationAlarmType_SuppressedState_Name = 9832,
    ExclusiveDeviationAlarmType_SuppressedState_Number = 9833,
    ExclusiveDeviationAlarmType_SuppressedState_EffectiveDisplayName = 9834,
    ExclusiveDeviationAlarmType_SuppressedState_TransitionTime = 9835,
    ExclusiveDeviationAlarmType_SuppressedState_EffectiveTransitionTime = 9836,
    ExclusiveDeviationAlarmType_SuppressedState_TrueState = 9837,
    ExclusiveDeviationAlarmType_SuppressedState_FalseState = 9838,
    ExclusiveDeviationAlarmType_ShelvingState_CurrentState = 9840,
    ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Id = 9841,
    ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Name = 9842,
    ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Number = 9843,
    ExclusiveDeviationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9844,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition = 9845,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Id = 9846,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Name = 9847,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Number = 9848,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition_TransitionTime = 9849,
    ExclusiveDeviationAlarmType_ShelvingState_UnshelveTime = 9850,
    ExclusiveDeviationAlarmType_ShelvingState_TimedShelve_InputArguments = 9875,
    ExclusiveDeviationAlarmType_SuppressedOrShelved = 9876,
    ExclusiveDeviationAlarmType_MaxTimeShelved = 9877,
    ExclusiveDeviationAlarmType_LimitState_CurrentState = 9879,
    ExclusiveDeviationAlarmType_LimitState_CurrentState_Id = 9880,
    ExclusiveDeviationAlarmType_LimitState_CurrentState_Name = 9881,
    ExclusiveDeviationAlarmType_LimitState_CurrentState_Number = 9882,
    ExclusiveDeviationAlarmType_LimitState_CurrentState_EffectiveDisplayName = 9883,
    ExclusiveDeviationAlarmType_LimitState_LastTransition = 9884,
    ExclusiveDeviationAlarmType_LimitState_LastTransition_Id = 9885,
    ExclusiveDeviationAlarmType_LimitState_LastTransition_Name = 9886,
    ExclusiveDeviationAlarmType_LimitState_LastTransition_Number = 9887,
    ExclusiveDeviationAlarmType_LimitState_LastTransition_TransitionTime = 9888,
    ExclusiveDeviationAlarmType_HighHighLimit = 9901,
    ExclusiveDeviationAlarmType_HighLimit = 9902,
    ExclusiveDeviationAlarmType_LowLimit = 9903,
    ExclusiveDeviationAlarmType_LowLowLimit = 9904,
    ExclusiveDeviationAlarmType_SetpointNode = 9905,
    NonExclusiveLimitAlarmType_EventId = 9907,
    NonExclusiveLimitAlarmType_EventType = 9908,
    NonExclusiveLimitAlarmType_SourceNode = 9909,
    NonExclusiveLimitAlarmType_SourceName = 9910,
    NonExclusiveLimitAlarmType_Time = 9911,
    NonExclusiveLimitAlarmType_ReceiveTime = 9912,
    NonExclusiveLimitAlarmType_LocalTime = 9913,
    NonExclusiveLimitAlarmType_Message = 9914,
    NonExclusiveLimitAlarmType_Severity = 9915,
    NonExclusiveLimitAlarmType_ConditionName = 9916,
    NonExclusiveLimitAlarmType_BranchId = 9917,
    NonExclusiveLimitAlarmType_Retain = 9918,
    NonExclusiveLimitAlarmType_EnabledState = 9919,
    NonExclusiveLimitAlarmType_EnabledState_Id = 9920,
    NonExclusiveLimitAlarmType_EnabledState_Name = 9921,
    NonExclusiveLimitAlarmType_EnabledState_Number = 9922,
    NonExclusiveLimitAlarmType_EnabledState_EffectiveDisplayName = 9923,
    NonExclusiveLimitAlarmType_EnabledState_TransitionTime = 9924,
    NonExclusiveLimitAlarmType_EnabledState_EffectiveTransitionTime = 9925,
    NonExclusiveLimitAlarmType_EnabledState_TrueState = 9926,
    NonExclusiveLimitAlarmType_EnabledState_FalseState = 9927,
    NonExclusiveLimitAlarmType_Quality = 9928,
    NonExclusiveLimitAlarmType_Quality_SourceTimestamp = 9929,
    NonExclusiveLimitAlarmType_LastSeverity = 9930,
    NonExclusiveLimitAlarmType_LastSeverity_SourceTimestamp = 9931,
    NonExclusiveLimitAlarmType_Comment = 9932,
    NonExclusiveLimitAlarmType_Comment_SourceTimestamp = 9933,
    NonExclusiveLimitAlarmType_ClientUserId = 9934,
    NonExclusiveLimitAlarmType_AddComment_InputArguments = 9938,
    NonExclusiveLimitAlarmType_ConditionRefresh_InputArguments = 9940,
    NonExclusiveLimitAlarmType_AckedState = 9941,
    NonExclusiveLimitAlarmType_AckedState_Id = 9942,
    NonExclusiveLimitAlarmType_AckedState_Name = 9943,
    NonExclusiveLimitAlarmType_AckedState_Number = 9944,
    NonExclusiveLimitAlarmType_AckedState_EffectiveDisplayName = 9945,
    NonExclusiveLimitAlarmType_AckedState_TransitionTime = 9946,
    NonExclusiveLimitAlarmType_AckedState_EffectiveTransitionTime = 9947,
    NonExclusiveLimitAlarmType_AckedState_TrueState = 9948,
    NonExclusiveLimitAlarmType_AckedState_FalseState = 9949,
    NonExclusiveLimitAlarmType_ConfirmedState = 9950,
    NonExclusiveLimitAlarmType_ConfirmedState_Id = 9951,
    NonExclusiveLimitAlarmType_ConfirmedState_Name = 9952,
    NonExclusiveLimitAlarmType_ConfirmedState_Number = 9953,
    NonExclusiveLimitAlarmType_ConfirmedState_EffectiveDisplayName = 9954,
    NonExclusiveLimitAlarmType_ConfirmedState_TransitionTime = 9955,
    NonExclusiveLimitAlarmType_ConfirmedState_EffectiveTransitionTime = 9956,
    NonExclusiveLimitAlarmType_ConfirmedState_TrueState = 9957,
    NonExclusiveLimitAlarmType_ConfirmedState_FalseState = 9958,
    NonExclusiveLimitAlarmType_Acknowledge_InputArguments = 9960,
    NonExclusiveLimitAlarmType_Confirm_InputArguments = 9962,
    NonExclusiveLimitAlarmType_ActiveState = 9963,
    NonExclusiveLimitAlarmType_ActiveState_Id = 9964,
    NonExclusiveLimitAlarmType_ActiveState_Name = 9965,
    NonExclusiveLimitAlarmType_ActiveState_Number = 9966,
    NonExclusiveLimitAlarmType_ActiveState_EffectiveDisplayName = 9967,
    NonExclusiveLimitAlarmType_ActiveState_TransitionTime = 9968,
    NonExclusiveLimitAlarmType_ActiveState_EffectiveTransitionTime = 9969,
    NonExclusiveLimitAlarmType_ActiveState_TrueState = 9970,
    NonExclusiveLimitAlarmType_ActiveState_FalseState = 9971,
    NonExclusiveLimitAlarmType_SuppressedState = 9972,
    NonExclusiveLimitAlarmType_SuppressedState_Id = 9973,
    NonExclusiveLimitAlarmType_SuppressedState_Name = 9974,
    NonExclusiveLimitAlarmType_SuppressedState_Number = 9975,
    NonExclusiveLimitAlarmType_SuppressedState_EffectiveDisplayName = 9976,
    NonExclusiveLimitAlarmType_SuppressedState_TransitionTime = 9977,
    NonExclusiveLimitAlarmType_SuppressedState_EffectiveTransitionTime = 9978,
    NonExclusiveLimitAlarmType_SuppressedState_TrueState = 9979,
    NonExclusiveLimitAlarmType_SuppressedState_FalseState = 9980,
    NonExclusiveLimitAlarmType_ShelvingState_CurrentState = 9982,
    NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Id = 9983,
    NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Name = 9984,
    NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Number = 9985,
    NonExclusiveLimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 9986,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition = 9987,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Id = 9988,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Name = 9989,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Number = 9990,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition_TransitionTime = 9991,
    NonExclusiveLimitAlarmType_ShelvingState_UnshelveTime = 9992,
    NonExclusiveLimitAlarmType_ShelvingState_TimedShelve_InputArguments = 10017,
    NonExclusiveLimitAlarmType_SuppressedOrShelved = 10018,
    NonExclusiveLimitAlarmType_MaxTimeShelved = 10019,
    NonExclusiveLimitAlarmType_HighHighState = 10020,
    NonExclusiveLimitAlarmType_HighHighState_Id = 10021,
    NonExclusiveLimitAlarmType_HighHighState_Name = 10022,
    NonExclusiveLimitAlarmType_HighHighState_Number = 10023,
    NonExclusiveLimitAlarmType_HighHighState_EffectiveDisplayName = 10024,
    NonExclusiveLimitAlarmType_HighHighState_TransitionTime = 10025,
    NonExclusiveLimitAlarmType_HighHighState_EffectiveTransitionTime = 10026,
    NonExclusiveLimitAlarmType_HighHighState_TrueState = 10027,
    NonExclusiveLimitAlarmType_HighHighState_FalseState = 10028,
    NonExclusiveLimitAlarmType_HighState = 10029,
    NonExclusiveLimitAlarmType_HighState_Id = 10030,
    NonExclusiveLimitAlarmType_HighState_Name = 10031,
    NonExclusiveLimitAlarmType_HighState_Number = 10032,
    NonExclusiveLimitAlarmType_HighState_EffectiveDisplayName = 10033,
    NonExclusiveLimitAlarmType_HighState_TransitionTime = 10034,
    NonExclusiveLimitAlarmType_HighState_EffectiveTransitionTime = 10035,
    NonExclusiveLimitAlarmType_HighState_TrueState = 10036,
    NonExclusiveLimitAlarmType_HighState_FalseState = 10037,
    NonExclusiveLimitAlarmType_LowState = 10038,
    NonExclusiveLimitAlarmType_LowState_Id = 10039,
    NonExclusiveLimitAlarmType_LowState_Name = 10040,
    NonExclusiveLimitAlarmType_LowState_Number = 10041,
    NonExclusiveLimitAlarmType_LowState_EffectiveDisplayName = 10042,
    NonExclusiveLimitAlarmType_LowState_TransitionTime = 10043,
    NonExclusiveLimitAlarmType_LowState_EffectiveTransitionTime = 10044,
    NonExclusiveLimitAlarmType_LowState_TrueState = 10045,
    NonExclusiveLimitAlarmType_LowState_FalseState = 10046,
    NonExclusiveLimitAlarmType_LowLowState = 10047,
    NonExclusiveLimitAlarmType_LowLowState_Id = 10048,
    NonExclusiveLimitAlarmType_LowLowState_Name = 10049,
    NonExclusiveLimitAlarmType_LowLowState_Number = 10050,
    NonExclusiveLimitAlarmType_LowLowState_EffectiveDisplayName = 10051,
    NonExclusiveLimitAlarmType_LowLowState_TransitionTime = 10052,
    NonExclusiveLimitAlarmType_LowLowState_EffectiveTransitionTime = 10053,
    NonExclusiveLimitAlarmType_LowLowState_TrueState = 10054,
    NonExclusiveLimitAlarmType_LowLowState_FalseState = 10055,
    NonExclusiveLimitAlarmType_HighHighLimit = 10056,
    NonExclusiveLimitAlarmType_HighLimit = 10057,
    NonExclusiveLimitAlarmType_LowLimit = 10058,
    NonExclusiveLimitAlarmType_LowLowLimit = 10059,
    NonExclusiveLevelAlarmType_EventId = 10061,
    NonExclusiveLevelAlarmType_EventType = 10062,
    NonExclusiveLevelAlarmType_SourceNode = 10063,
    NonExclusiveLevelAlarmType_SourceName = 10064,
    NonExclusiveLevelAlarmType_Time = 10065,
    NonExclusiveLevelAlarmType_ReceiveTime = 10066,
    NonExclusiveLevelAlarmType_LocalTime = 10067,
    NonExclusiveLevelAlarmType_Message = 10068,
    NonExclusiveLevelAlarmType_Severity = 10069,
    NonExclusiveLevelAlarmType_ConditionName = 10070,
    NonExclusiveLevelAlarmType_BranchId = 10071,
    NonExclusiveLevelAlarmType_Retain = 10072,
    NonExclusiveLevelAlarmType_EnabledState = 10073,
    NonExclusiveLevelAlarmType_EnabledState_Id = 10074,
    NonExclusiveLevelAlarmType_EnabledState_Name = 10075,
    NonExclusiveLevelAlarmType_EnabledState_Number = 10076,
    NonExclusiveLevelAlarmType_EnabledState_EffectiveDisplayName = 10077,
    NonExclusiveLevelAlarmType_EnabledState_TransitionTime = 10078,
    NonExclusiveLevelAlarmType_EnabledState_EffectiveTransitionTime = 10079,
    NonExclusiveLevelAlarmType_EnabledState_TrueState = 10080,
    NonExclusiveLevelAlarmType_EnabledState_FalseState = 10081,
    NonExclusiveLevelAlarmType_Quality = 10082,
    NonExclusiveLevelAlarmType_Quality_SourceTimestamp = 10083,
    NonExclusiveLevelAlarmType_LastSeverity = 10084,
    NonExclusiveLevelAlarmType_LastSeverity_SourceTimestamp = 10085,
    NonExclusiveLevelAlarmType_Comment = 10086,
    NonExclusiveLevelAlarmType_Comment_SourceTimestamp = 10087,
    NonExclusiveLevelAlarmType_ClientUserId = 10088,
    NonExclusiveLevelAlarmType_AddComment_InputArguments = 10092,
    NonExclusiveLevelAlarmType_ConditionRefresh_InputArguments = 10094,
    NonExclusiveLevelAlarmType_AckedState = 10095,
    NonExclusiveLevelAlarmType_AckedState_Id = 10096,
    NonExclusiveLevelAlarmType_AckedState_Name = 10097,
    NonExclusiveLevelAlarmType_AckedState_Number = 10098,
    NonExclusiveLevelAlarmType_AckedState_EffectiveDisplayName = 10099,
    NonExclusiveLevelAlarmType_AckedState_TransitionTime = 10100,
    NonExclusiveLevelAlarmType_AckedState_EffectiveTransitionTime = 10101,
    NonExclusiveLevelAlarmType_AckedState_TrueState = 10102,
    NonExclusiveLevelAlarmType_AckedState_FalseState = 10103,
    NonExclusiveLevelAlarmType_ConfirmedState = 10104,
    NonExclusiveLevelAlarmType_ConfirmedState_Id = 10105,
    NonExclusiveLevelAlarmType_ConfirmedState_Name = 10106,
    NonExclusiveLevelAlarmType_ConfirmedState_Number = 10107,
    NonExclusiveLevelAlarmType_ConfirmedState_EffectiveDisplayName = 10108,
    NonExclusiveLevelAlarmType_ConfirmedState_TransitionTime = 10109,
    NonExclusiveLevelAlarmType_ConfirmedState_EffectiveTransitionTime = 10110,
    NonExclusiveLevelAlarmType_ConfirmedState_TrueState = 10111,
    NonExclusiveLevelAlarmType_ConfirmedState_FalseState = 10112,
    NonExclusiveLevelAlarmType_Acknowledge_InputArguments = 10114,
    NonExclusiveLevelAlarmType_Confirm_InputArguments = 10116,
    NonExclusiveLevelAlarmType_ActiveState = 10117,
    NonExclusiveLevelAlarmType_ActiveState_Id = 10118,
    NonExclusiveLevelAlarmType_ActiveState_Name = 10119,
    NonExclusiveLevelAlarmType_ActiveState_Number = 10120,
    NonExclusiveLevelAlarmType_ActiveState_EffectiveDisplayName = 10121,
    NonExclusiveLevelAlarmType_ActiveState_TransitionTime = 10122,
    NonExclusiveLevelAlarmType_ActiveState_EffectiveTransitionTime = 10123,
    NonExclusiveLevelAlarmType_ActiveState_TrueState = 10124,
    NonExclusiveLevelAlarmType_ActiveState_FalseState = 10125,
    NonExclusiveLevelAlarmType_SuppressedState = 10126,
    NonExclusiveLevelAlarmType_SuppressedState_Id = 10127,
    NonExclusiveLevelAlarmType_SuppressedState_Name = 10128,
    NonExclusiveLevelAlarmType_SuppressedState_Number = 10129,
    NonExclusiveLevelAlarmType_SuppressedState_EffectiveDisplayName = 10130,
    NonExclusiveLevelAlarmType_SuppressedState_TransitionTime = 10131,
    NonExclusiveLevelAlarmType_SuppressedState_EffectiveTransitionTime = 10132,
    NonExclusiveLevelAlarmType_SuppressedState_TrueState = 10133,
    NonExclusiveLevelAlarmType_SuppressedState_FalseState = 10134,
    NonExclusiveLevelAlarmType_ShelvingState_CurrentState = 10136,
    NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Id = 10137,
    NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Name = 10138,
    NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Number = 10139,
    NonExclusiveLevelAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10140,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition = 10141,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Id = 10142,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Name = 10143,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Number = 10144,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition_TransitionTime = 10145,
    NonExclusiveLevelAlarmType_ShelvingState_UnshelveTime = 10146,
    NonExclusiveLevelAlarmType_ShelvingState_TimedShelve_InputArguments = 10171,
    NonExclusiveLevelAlarmType_SuppressedOrShelved = 10172,
    NonExclusiveLevelAlarmType_MaxTimeShelved = 10173,
    NonExclusiveLevelAlarmType_HighHighState = 10174,
    NonExclusiveLevelAlarmType_HighHighState_Id = 10175,
    NonExclusiveLevelAlarmType_HighHighState_Name = 10176,
    NonExclusiveLevelAlarmType_HighHighState_Number = 10177,
    NonExclusiveLevelAlarmType_HighHighState_EffectiveDisplayName = 10178,
    NonExclusiveLevelAlarmType_HighHighState_TransitionTime = 10179,
    NonExclusiveLevelAlarmType_HighHighState_EffectiveTransitionTime = 10180,
    NonExclusiveLevelAlarmType_HighHighState_TrueState = 10181,
    NonExclusiveLevelAlarmType_HighHighState_FalseState = 10182,
    NonExclusiveLevelAlarmType_HighState = 10183,
    NonExclusiveLevelAlarmType_HighState_Id = 10184,
    NonExclusiveLevelAlarmType_HighState_Name = 10185,
    NonExclusiveLevelAlarmType_HighState_Number = 10186,
    NonExclusiveLevelAlarmType_HighState_EffectiveDisplayName = 10187,
    NonExclusiveLevelAlarmType_HighState_TransitionTime = 10188,
    NonExclusiveLevelAlarmType_HighState_EffectiveTransitionTime = 10189,
    NonExclusiveLevelAlarmType_HighState_TrueState = 10190,
    NonExclusiveLevelAlarmType_HighState_FalseState = 10191,
    NonExclusiveLevelAlarmType_LowState = 10192,
    NonExclusiveLevelAlarmType_LowState_Id = 10193,
    NonExclusiveLevelAlarmType_LowState_Name = 10194,
    NonExclusiveLevelAlarmType_LowState_Number = 10195,
    NonExclusiveLevelAlarmType_LowState_EffectiveDisplayName = 10196,
    NonExclusiveLevelAlarmType_LowState_TransitionTime = 10197,
    NonExclusiveLevelAlarmType_LowState_EffectiveTransitionTime = 10198,
    NonExclusiveLevelAlarmType_LowState_TrueState = 10199,
    NonExclusiveLevelAlarmType_LowState_FalseState = 10200,
    NonExclusiveLevelAlarmType_LowLowState = 10201,
    NonExclusiveLevelAlarmType_LowLowState_Id = 10202,
    NonExclusiveLevelAlarmType_LowLowState_Name = 10203,
    NonExclusiveLevelAlarmType_LowLowState_Number = 10204,
    NonExclusiveLevelAlarmType_LowLowState_EffectiveDisplayName = 10205,
    NonExclusiveLevelAlarmType_LowLowState_TransitionTime = 10206,
    NonExclusiveLevelAlarmType_LowLowState_EffectiveTransitionTime = 10207,
    NonExclusiveLevelAlarmType_LowLowState_TrueState = 10208,
    NonExclusiveLevelAlarmType_LowLowState_FalseState = 10209,
    NonExclusiveLevelAlarmType_HighHighLimit = 10210,
    NonExclusiveLevelAlarmType_HighLimit = 10211,
    NonExclusiveLevelAlarmType_LowLimit = 10212,
    NonExclusiveLevelAlarmType_LowLowLimit = 10213,
    NonExclusiveRateOfChangeAlarmType_EventId = 10215,
    NonExclusiveRateOfChangeAlarmType_EventType = 10216,
    NonExclusiveRateOfChangeAlarmType_SourceNode = 10217,
    NonExclusiveRateOfChangeAlarmType_SourceName = 10218,
    NonExclusiveRateOfChangeAlarmType_Time = 10219,
    NonExclusiveRateOfChangeAlarmType_ReceiveTime = 10220,
    NonExclusiveRateOfChangeAlarmType_LocalTime = 10221,
    NonExclusiveRateOfChangeAlarmType_Message = 10222,
    NonExclusiveRateOfChangeAlarmType_Severity = 10223,
    NonExclusiveRateOfChangeAlarmType_ConditionName = 10224,
    NonExclusiveRateOfChangeAlarmType_BranchId = 10225,
    NonExclusiveRateOfChangeAlarmType_Retain = 10226,
    NonExclusiveRateOfChangeAlarmType_EnabledState = 10227,
    NonExclusiveRateOfChangeAlarmType_EnabledState_Id = 10228,
    NonExclusiveRateOfChangeAlarmType_EnabledState_Name = 10229,
    NonExclusiveRateOfChangeAlarmType_EnabledState_Number = 10230,
    NonExclusiveRateOfChangeAlarmType_EnabledState_EffectiveDisplayName = 10231,
    NonExclusiveRateOfChangeAlarmType_EnabledState_TransitionTime = 10232,
    NonExclusiveRateOfChangeAlarmType_EnabledState_EffectiveTransitionTime = 10233,
    NonExclusiveRateOfChangeAlarmType_EnabledState_TrueState = 10234,
    NonExclusiveRateOfChangeAlarmType_EnabledState_FalseState = 10235,
    NonExclusiveRateOfChangeAlarmType_Quality = 10236,
    NonExclusiveRateOfChangeAlarmType_Quality_SourceTimestamp = 10237,
    NonExclusiveRateOfChangeAlarmType_LastSeverity = 10238,
    NonExclusiveRateOfChangeAlarmType_LastSeverity_SourceTimestamp = 10239,
    NonExclusiveRateOfChangeAlarmType_Comment = 10240,
    NonExclusiveRateOfChangeAlarmType_Comment_SourceTimestamp = 10241,
    NonExclusiveRateOfChangeAlarmType_ClientUserId = 10242,
    NonExclusiveRateOfChangeAlarmType_AddComment_InputArguments = 10246,
    NonExclusiveRateOfChangeAlarmType_ConditionRefresh_InputArguments = 10248,
    NonExclusiveRateOfChangeAlarmType_AckedState = 10249,
    NonExclusiveRateOfChangeAlarmType_AckedState_Id = 10250,
    NonExclusiveRateOfChangeAlarmType_AckedState_Name = 10251,
    NonExclusiveRateOfChangeAlarmType_AckedState_Number = 10252,
    NonExclusiveRateOfChangeAlarmType_AckedState_EffectiveDisplayName = 10253,
    NonExclusiveRateOfChangeAlarmType_AckedState_TransitionTime = 10254,
    NonExclusiveRateOfChangeAlarmType_AckedState_EffectiveTransitionTime = 10255,
    NonExclusiveRateOfChangeAlarmType_AckedState_TrueState = 10256,
    NonExclusiveRateOfChangeAlarmType_AckedState_FalseState = 10257,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState = 10258,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_Id = 10259,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_Name = 10260,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_Number = 10261,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveDisplayName = 10262,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_TransitionTime = 10263,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveTransitionTime = 10264,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_TrueState = 10265,
    NonExclusiveRateOfChangeAlarmType_ConfirmedState_FalseState = 10266,
    NonExclusiveRateOfChangeAlarmType_Acknowledge_InputArguments = 10268,
    NonExclusiveRateOfChangeAlarmType_Confirm_InputArguments = 10270,
    NonExclusiveRateOfChangeAlarmType_ActiveState = 10271,
    NonExclusiveRateOfChangeAlarmType_ActiveState_Id = 10272,
    NonExclusiveRateOfChangeAlarmType_ActiveState_Name = 10273,
    NonExclusiveRateOfChangeAlarmType_ActiveState_Number = 10274,
    NonExclusiveRateOfChangeAlarmType_ActiveState_EffectiveDisplayName = 10275,
    NonExclusiveRateOfChangeAlarmType_ActiveState_TransitionTime = 10276,
    NonExclusiveRateOfChangeAlarmType_ActiveState_EffectiveTransitionTime = 10277,
    NonExclusiveRateOfChangeAlarmType_ActiveState_TrueState = 10278,
    NonExclusiveRateOfChangeAlarmType_ActiveState_FalseState = 10279,
    NonExclusiveRateOfChangeAlarmType_SuppressedState = 10280,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_Id = 10281,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_Name = 10282,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_Number = 10283,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveDisplayName = 10284,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_TransitionTime = 10285,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveTransitionTime = 10286,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_TrueState = 10287,
    NonExclusiveRateOfChangeAlarmType_SuppressedState_FalseState = 10288,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState = 10290,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Id = 10291,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Name = 10292,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Number = 10293,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10294,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition = 10295,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Id = 10296,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Name = 10297,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Number = 10298,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_TransitionTime = 10299,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_UnshelveTime = 10300,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve_InputArguments = 10325,
    NonExclusiveRateOfChangeAlarmType_SuppressedOrShelved = 10326,
    NonExclusiveRateOfChangeAlarmType_MaxTimeShelved = 10327,
    NonExclusiveRateOfChangeAlarmType_HighHighState = 10328,
    NonExclusiveRateOfChangeAlarmType_HighHighState_Id = 10329,
    NonExclusiveRateOfChangeAlarmType_HighHighState_Name = 10330,
    NonExclusiveRateOfChangeAlarmType_HighHighState_Number = 10331,
    NonExclusiveRateOfChangeAlarmType_HighHighState_EffectiveDisplayName = 10332,
    NonExclusiveRateOfChangeAlarmType_HighHighState_TransitionTime = 10333,
    NonExclusiveRateOfChangeAlarmType_HighHighState_EffectiveTransitionTime = 10334,
    NonExclusiveRateOfChangeAlarmType_HighHighState_TrueState = 10335,
    NonExclusiveRateOfChangeAlarmType_HighHighState_FalseState = 10336,
    NonExclusiveRateOfChangeAlarmType_HighState = 10337,
    NonExclusiveRateOfChangeAlarmType_HighState_Id = 10338,
    NonExclusiveRateOfChangeAlarmType_HighState_Name = 10339,
    NonExclusiveRateOfChangeAlarmType_HighState_Number = 10340,
    NonExclusiveRateOfChangeAlarmType_HighState_EffectiveDisplayName = 10341,
    NonExclusiveRateOfChangeAlarmType_HighState_TransitionTime = 10342,
    NonExclusiveRateOfChangeAlarmType_HighState_EffectiveTransitionTime = 10343,
    NonExclusiveRateOfChangeAlarmType_HighState_TrueState = 10344,
    NonExclusiveRateOfChangeAlarmType_HighState_FalseState = 10345,
    NonExclusiveRateOfChangeAlarmType_LowState = 10346,
    NonExclusiveRateOfChangeAlarmType_LowState_Id = 10347,
    NonExclusiveRateOfChangeAlarmType_LowState_Name = 10348,
    NonExclusiveRateOfChangeAlarmType_LowState_Number = 10349,
    NonExclusiveRateOfChangeAlarmType_LowState_EffectiveDisplayName = 10350,
    NonExclusiveRateOfChangeAlarmType_LowState_TransitionTime = 10351,
    NonExclusiveRateOfChangeAlarmType_LowState_EffectiveTransitionTime = 10352,
    NonExclusiveRateOfChangeAlarmType_LowState_TrueState = 10353,
    NonExclusiveRateOfChangeAlarmType_LowState_FalseState = 10354,
    NonExclusiveRateOfChangeAlarmType_LowLowState = 10355,
    NonExclusiveRateOfChangeAlarmType_LowLowState_Id = 10356,
    NonExclusiveRateOfChangeAlarmType_LowLowState_Name = 10357,
    NonExclusiveRateOfChangeAlarmType_LowLowState_Number = 10358,
    NonExclusiveRateOfChangeAlarmType_LowLowState_EffectiveDisplayName = 10359,
    NonExclusiveRateOfChangeAlarmType_LowLowState_TransitionTime = 10360,
    NonExclusiveRateOfChangeAlarmType_LowLowState_EffectiveTransitionTime = 10361,
    NonExclusiveRateOfChangeAlarmType_LowLowState_TrueState = 10362,
    NonExclusiveRateOfChangeAlarmType_LowLowState_FalseState = 10363,
    NonExclusiveRateOfChangeAlarmType_HighHighLimit = 10364,
    NonExclusiveRateOfChangeAlarmType_HighLimit = 10365,
    NonExclusiveRateOfChangeAlarmType_LowLimit = 10366,
    NonExclusiveRateOfChangeAlarmType_LowLowLimit = 10367,
    NonExclusiveDeviationAlarmType_EventId = 10369,
    NonExclusiveDeviationAlarmType_EventType = 10370,
    NonExclusiveDeviationAlarmType_SourceNode = 10371,
    NonExclusiveDeviationAlarmType_SourceName = 10372,
    NonExclusiveDeviationAlarmType_Time = 10373,
    NonExclusiveDeviationAlarmType_ReceiveTime = 10374,
    NonExclusiveDeviationAlarmType_LocalTime = 10375,
    NonExclusiveDeviationAlarmType_Message = 10376,
    NonExclusiveDeviationAlarmType_Severity = 10377,
    NonExclusiveDeviationAlarmType_ConditionName = 10378,
    NonExclusiveDeviationAlarmType_BranchId = 10379,
    NonExclusiveDeviationAlarmType_Retain = 10380,
    NonExclusiveDeviationAlarmType_EnabledState = 10381,
    NonExclusiveDeviationAlarmType_EnabledState_Id = 10382,
    NonExclusiveDeviationAlarmType_EnabledState_Name = 10383,
    NonExclusiveDeviationAlarmType_EnabledState_Number = 10384,
    NonExclusiveDeviationAlarmType_EnabledState_EffectiveDisplayName = 10385,
    NonExclusiveDeviationAlarmType_EnabledState_TransitionTime = 10386,
    NonExclusiveDeviationAlarmType_EnabledState_EffectiveTransitionTime = 10387,
    NonExclusiveDeviationAlarmType_EnabledState_TrueState = 10388,
    NonExclusiveDeviationAlarmType_EnabledState_FalseState = 10389,
    NonExclusiveDeviationAlarmType_Quality = 10390,
    NonExclusiveDeviationAlarmType_Quality_SourceTimestamp = 10391,
    NonExclusiveDeviationAlarmType_LastSeverity = 10392,
    NonExclusiveDeviationAlarmType_LastSeverity_SourceTimestamp = 10393,
    NonExclusiveDeviationAlarmType_Comment = 10394,
    NonExclusiveDeviationAlarmType_Comment_SourceTimestamp = 10395,
    NonExclusiveDeviationAlarmType_ClientUserId = 10396,
    NonExclusiveDeviationAlarmType_AddComment_InputArguments = 10400,
    NonExclusiveDeviationAlarmType_ConditionRefresh_InputArguments = 10402,
    NonExclusiveDeviationAlarmType_AckedState = 10403,
    NonExclusiveDeviationAlarmType_AckedState_Id = 10404,
    NonExclusiveDeviationAlarmType_AckedState_Name = 10405,
    NonExclusiveDeviationAlarmType_AckedState_Number = 10406,
    NonExclusiveDeviationAlarmType_AckedState_EffectiveDisplayName = 10407,
    NonExclusiveDeviationAlarmType_AckedState_TransitionTime = 10408,
    NonExclusiveDeviationAlarmType_AckedState_EffectiveTransitionTime = 10409,
    NonExclusiveDeviationAlarmType_AckedState_TrueState = 10410,
    NonExclusiveDeviationAlarmType_AckedState_FalseState = 10411,
    NonExclusiveDeviationAlarmType_ConfirmedState = 10412,
    NonExclusiveDeviationAlarmType_ConfirmedState_Id = 10413,
    NonExclusiveDeviationAlarmType_ConfirmedState_Name = 10414,
    NonExclusiveDeviationAlarmType_ConfirmedState_Number = 10415,
    NonExclusiveDeviationAlarmType_ConfirmedState_EffectiveDisplayName = 10416,
    NonExclusiveDeviationAlarmType_ConfirmedState_TransitionTime = 10417,
    NonExclusiveDeviationAlarmType_ConfirmedState_EffectiveTransitionTime = 10418,
    NonExclusiveDeviationAlarmType_ConfirmedState_TrueState = 10419,
    NonExclusiveDeviationAlarmType_ConfirmedState_FalseState = 10420,
    NonExclusiveDeviationAlarmType_Acknowledge_InputArguments = 10422,
    NonExclusiveDeviationAlarmType_Confirm_InputArguments = 10424,
    NonExclusiveDeviationAlarmType_ActiveState = 10425,
    NonExclusiveDeviationAlarmType_ActiveState_Id = 10426,
    NonExclusiveDeviationAlarmType_ActiveState_Name = 10427,
    NonExclusiveDeviationAlarmType_ActiveState_Number = 10428,
    NonExclusiveDeviationAlarmType_ActiveState_EffectiveDisplayName = 10429,
    NonExclusiveDeviationAlarmType_ActiveState_TransitionTime = 10430,
    NonExclusiveDeviationAlarmType_ActiveState_EffectiveTransitionTime = 10431,
    NonExclusiveDeviationAlarmType_ActiveState_TrueState = 10432,
    NonExclusiveDeviationAlarmType_ActiveState_FalseState = 10433,
    NonExclusiveDeviationAlarmType_SuppressedState = 10434,
    NonExclusiveDeviationAlarmType_SuppressedState_Id = 10435,
    NonExclusiveDeviationAlarmType_SuppressedState_Name = 10436,
    NonExclusiveDeviationAlarmType_SuppressedState_Number = 10437,
    NonExclusiveDeviationAlarmType_SuppressedState_EffectiveDisplayName = 10438,
    NonExclusiveDeviationAlarmType_SuppressedState_TransitionTime = 10439,
    NonExclusiveDeviationAlarmType_SuppressedState_EffectiveTransitionTime = 10440,
    NonExclusiveDeviationAlarmType_SuppressedState_TrueState = 10441,
    NonExclusiveDeviationAlarmType_SuppressedState_FalseState = 10442,
    NonExclusiveDeviationAlarmType_ShelvingState_CurrentState = 10444,
    NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Id = 10445,
    NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Name = 10446,
    NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Number = 10447,
    NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10448,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition = 10449,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Id = 10450,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Name = 10451,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Number = 10452,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_TransitionTime = 10453,
    NonExclusiveDeviationAlarmType_ShelvingState_UnshelveTime = 10454,
    NonExclusiveDeviationAlarmType_ShelvingState_TimedShelve_InputArguments = 10479,
    NonExclusiveDeviationAlarmType_SuppressedOrShelved = 10480,
    NonExclusiveDeviationAlarmType_MaxTimeShelved = 10481,
    NonExclusiveDeviationAlarmType_HighHighState = 10482,
    NonExclusiveDeviationAlarmType_HighHighState_Id = 10483,
    NonExclusiveDeviationAlarmType_HighHighState_Name = 10484,
    NonExclusiveDeviationAlarmType_HighHighState_Number = 10485,
    NonExclusiveDeviationAlarmType_HighHighState_EffectiveDisplayName = 10486,
    NonExclusiveDeviationAlarmType_HighHighState_TransitionTime = 10487,
    NonExclusiveDeviationAlarmType_HighHighState_EffectiveTransitionTime = 10488,
    NonExclusiveDeviationAlarmType_HighHighState_TrueState = 10489,
    NonExclusiveDeviationAlarmType_HighHighState_FalseState = 10490,
    NonExclusiveDeviationAlarmType_HighState = 10491,
    NonExclusiveDeviationAlarmType_HighState_Id = 10492,
    NonExclusiveDeviationAlarmType_HighState_Name = 10493,
    NonExclusiveDeviationAlarmType_HighState_Number = 10494,
    NonExclusiveDeviationAlarmType_HighState_EffectiveDisplayName = 10495,
    NonExclusiveDeviationAlarmType_HighState_TransitionTime = 10496,
    NonExclusiveDeviationAlarmType_HighState_EffectiveTransitionTime = 10497,
    NonExclusiveDeviationAlarmType_HighState_TrueState = 10498,
    NonExclusiveDeviationAlarmType_HighState_FalseState = 10499,
    NonExclusiveDeviationAlarmType_LowState = 10500,
    NonExclusiveDeviationAlarmType_LowState_Id = 10501,
    NonExclusiveDeviationAlarmType_LowState_Name = 10502,
    NonExclusiveDeviationAlarmType_LowState_Number = 10503,
    NonExclusiveDeviationAlarmType_LowState_EffectiveDisplayName = 10504,
    NonExclusiveDeviationAlarmType_LowState_TransitionTime = 10505,
    NonExclusiveDeviationAlarmType_LowState_EffectiveTransitionTime = 10506,
    NonExclusiveDeviationAlarmType_LowState_TrueState = 10507,
    NonExclusiveDeviationAlarmType_LowState_FalseState = 10508,
    NonExclusiveDeviationAlarmType_LowLowState = 10509,
    NonExclusiveDeviationAlarmType_LowLowState_Id = 10510,
    NonExclusiveDeviationAlarmType_LowLowState_Name = 10511,
    NonExclusiveDeviationAlarmType_LowLowState_Number = 10512,
    NonExclusiveDeviationAlarmType_LowLowState_EffectiveDisplayName = 10513,
    NonExclusiveDeviationAlarmType_LowLowState_TransitionTime = 10514,
    NonExclusiveDeviationAlarmType_LowLowState_EffectiveTransitionTime = 10515,
    NonExclusiveDeviationAlarmType_LowLowState_TrueState = 10516,
    NonExclusiveDeviationAlarmType_LowLowState_FalseState = 10517,
    NonExclusiveDeviationAlarmType_HighHighLimit = 10518,
    NonExclusiveDeviationAlarmType_HighLimit = 10519,
    NonExclusiveDeviationAlarmType_LowLimit = 10520,
    NonExclusiveDeviationAlarmType_LowLowLimit = 10521,
    NonExclusiveDeviationAlarmType_SetpointNode = 10522,
    DiscreteAlarmType_EventId = 10524,
    DiscreteAlarmType_EventType = 10525,
    DiscreteAlarmType_SourceNode = 10526,
    DiscreteAlarmType_SourceName = 10527,
    DiscreteAlarmType_Time = 10528,
    DiscreteAlarmType_ReceiveTime = 10529,
    DiscreteAlarmType_LocalTime = 10530,
    DiscreteAlarmType_Message = 10531,
    DiscreteAlarmType_Severity = 10532,
    DiscreteAlarmType_ConditionName = 10533,
    DiscreteAlarmType_BranchId = 10534,
    DiscreteAlarmType_Retain = 10535,
    DiscreteAlarmType_EnabledState = 10536,
    DiscreteAlarmType_EnabledState_Id = 10537,
    DiscreteAlarmType_EnabledState_Name = 10538,
    DiscreteAlarmType_EnabledState_Number = 10539,
    DiscreteAlarmType_EnabledState_EffectiveDisplayName = 10540,
    DiscreteAlarmType_EnabledState_TransitionTime = 10541,
    DiscreteAlarmType_EnabledState_EffectiveTransitionTime = 10542,
    DiscreteAlarmType_EnabledState_TrueState = 10543,
    DiscreteAlarmType_EnabledState_FalseState = 10544,
    DiscreteAlarmType_Quality = 10545,
    DiscreteAlarmType_Quality_SourceTimestamp = 10546,
    DiscreteAlarmType_LastSeverity = 10547,
    DiscreteAlarmType_LastSeverity_SourceTimestamp = 10548,
    DiscreteAlarmType_Comment = 10549,
    DiscreteAlarmType_Comment_SourceTimestamp = 10550,
    DiscreteAlarmType_ClientUserId = 10551,
    DiscreteAlarmType_AddComment_InputArguments = 10555,
    DiscreteAlarmType_ConditionRefresh_InputArguments = 10557,
    DiscreteAlarmType_AckedState = 10558,
    DiscreteAlarmType_AckedState_Id = 10559,
    DiscreteAlarmType_AckedState_Name = 10560,
    DiscreteAlarmType_AckedState_Number = 10561,
    DiscreteAlarmType_AckedState_EffectiveDisplayName = 10562,
    DiscreteAlarmType_AckedState_TransitionTime = 10563,
    DiscreteAlarmType_AckedState_EffectiveTransitionTime = 10564,
    DiscreteAlarmType_AckedState_TrueState = 10565,
    DiscreteAlarmType_AckedState_FalseState = 10566,
    DiscreteAlarmType_ConfirmedState = 10567,
    DiscreteAlarmType_ConfirmedState_Id = 10568,
    DiscreteAlarmType_ConfirmedState_Name = 10569,
    DiscreteAlarmType_ConfirmedState_Number = 10570,
    DiscreteAlarmType_ConfirmedState_EffectiveDisplayName = 10571,
    DiscreteAlarmType_ConfirmedState_TransitionTime = 10572,
    DiscreteAlarmType_ConfirmedState_EffectiveTransitionTime = 10573,
    DiscreteAlarmType_ConfirmedState_TrueState = 10574,
    DiscreteAlarmType_ConfirmedState_FalseState = 10575,
    DiscreteAlarmType_Acknowledge_InputArguments = 10577,
    DiscreteAlarmType_Confirm_InputArguments = 10579,
    DiscreteAlarmType_ActiveState = 10580,
    DiscreteAlarmType_ActiveState_Id = 10581,
    DiscreteAlarmType_ActiveState_Name = 10582,
    DiscreteAlarmType_ActiveState_Number = 10583,
    DiscreteAlarmType_ActiveState_EffectiveDisplayName = 10584,
    DiscreteAlarmType_ActiveState_TransitionTime = 10585,
    DiscreteAlarmType_ActiveState_EffectiveTransitionTime = 10586,
    DiscreteAlarmType_ActiveState_TrueState = 10587,
    DiscreteAlarmType_ActiveState_FalseState = 10588,
    DiscreteAlarmType_SuppressedState = 10589,
    DiscreteAlarmType_SuppressedState_Id = 10590,
    DiscreteAlarmType_SuppressedState_Name = 10591,
    DiscreteAlarmType_SuppressedState_Number = 10592,
    DiscreteAlarmType_SuppressedState_EffectiveDisplayName = 10593,
    DiscreteAlarmType_SuppressedState_TransitionTime = 10594,
    DiscreteAlarmType_SuppressedState_EffectiveTransitionTime = 10595,
    DiscreteAlarmType_SuppressedState_TrueState = 10596,
    DiscreteAlarmType_SuppressedState_FalseState = 10597,
    DiscreteAlarmType_ShelvingState_CurrentState = 10599,
    DiscreteAlarmType_ShelvingState_CurrentState_Id = 10600,
    DiscreteAlarmType_ShelvingState_CurrentState_Name = 10601,
    DiscreteAlarmType_ShelvingState_CurrentState_Number = 10602,
    DiscreteAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10603,
    DiscreteAlarmType_ShelvingState_LastTransition = 10604,
    DiscreteAlarmType_ShelvingState_LastTransition_Id = 10605,
    DiscreteAlarmType_ShelvingState_LastTransition_Name = 10606,
    DiscreteAlarmType_ShelvingState_LastTransition_Number = 10607,
    DiscreteAlarmType_ShelvingState_LastTransition_TransitionTime = 10608,
    DiscreteAlarmType_ShelvingState_UnshelveTime = 10609,
    DiscreteAlarmType_ShelvingState_TimedShelve_InputArguments = 10634,
    DiscreteAlarmType_SuppressedOrShelved = 10635,
    DiscreteAlarmType_MaxTimeShelved = 10636,
    OffNormalAlarmType_EventId = 10638,
    OffNormalAlarmType_EventType = 10639,
    OffNormalAlarmType_SourceNode = 10640,
    OffNormalAlarmType_SourceName = 10641,
    OffNormalAlarmType_Time = 10642,
    OffNormalAlarmType_ReceiveTime = 10643,
    OffNormalAlarmType_LocalTime = 10644,
    OffNormalAlarmType_Message = 10645,
    OffNormalAlarmType_Severity = 10646,
    OffNormalAlarmType_ConditionName = 10647,
    OffNormalAlarmType_BranchId = 10648,
    OffNormalAlarmType_Retain = 10649,
    OffNormalAlarmType_EnabledState = 10650,
    OffNormalAlarmType_EnabledState_Id = 10651,
    OffNormalAlarmType_EnabledState_Name = 10652,
    OffNormalAlarmType_EnabledState_Number = 10653,
    OffNormalAlarmType_EnabledState_EffectiveDisplayName = 10654,
    OffNormalAlarmType_EnabledState_TransitionTime = 10655,
    OffNormalAlarmType_EnabledState_EffectiveTransitionTime = 10656,
    OffNormalAlarmType_EnabledState_TrueState = 10657,
    OffNormalAlarmType_EnabledState_FalseState = 10658,
    OffNormalAlarmType_Quality = 10659,
    OffNormalAlarmType_Quality_SourceTimestamp = 10660,
    OffNormalAlarmType_LastSeverity = 10661,
    OffNormalAlarmType_LastSeverity_SourceTimestamp = 10662,
    OffNormalAlarmType_Comment = 10663,
    OffNormalAlarmType_Comment_SourceTimestamp = 10664,
    OffNormalAlarmType_ClientUserId = 10665,
    OffNormalAlarmType_AddComment_InputArguments = 10669,
    OffNormalAlarmType_ConditionRefresh_InputArguments = 10671,
    OffNormalAlarmType_AckedState = 10672,
    OffNormalAlarmType_AckedState_Id = 10673,
    OffNormalAlarmType_AckedState_Name = 10674,
    OffNormalAlarmType_AckedState_Number = 10675,
    OffNormalAlarmType_AckedState_EffectiveDisplayName = 10676,
    OffNormalAlarmType_AckedState_TransitionTime = 10677,
    OffNormalAlarmType_AckedState_EffectiveTransitionTime = 10678,
    OffNormalAlarmType_AckedState_TrueState = 10679,
    OffNormalAlarmType_AckedState_FalseState = 10680,
    OffNormalAlarmType_ConfirmedState = 10681,
    OffNormalAlarmType_ConfirmedState_Id = 10682,
    OffNormalAlarmType_ConfirmedState_Name = 10683,
    OffNormalAlarmType_ConfirmedState_Number = 10684,
    OffNormalAlarmType_ConfirmedState_EffectiveDisplayName = 10685,
    OffNormalAlarmType_ConfirmedState_TransitionTime = 10686,
    OffNormalAlarmType_ConfirmedState_EffectiveTransitionTime = 10687,
    OffNormalAlarmType_ConfirmedState_TrueState = 10688,
    OffNormalAlarmType_ConfirmedState_FalseState = 10689,
    OffNormalAlarmType_Acknowledge_InputArguments = 10691,
    OffNormalAlarmType_Confirm_InputArguments = 10693,
    OffNormalAlarmType_ActiveState = 10694,
    OffNormalAlarmType_ActiveState_Id = 10695,
    OffNormalAlarmType_ActiveState_Name = 10696,
    OffNormalAlarmType_ActiveState_Number = 10697,
    OffNormalAlarmType_ActiveState_EffectiveDisplayName = 10698,
    OffNormalAlarmType_ActiveState_TransitionTime = 10699,
    OffNormalAlarmType_ActiveState_EffectiveTransitionTime = 10700,
    OffNormalAlarmType_ActiveState_TrueState = 10701,
    OffNormalAlarmType_ActiveState_FalseState = 10702,
    OffNormalAlarmType_SuppressedState = 10703,
    OffNormalAlarmType_SuppressedState_Id = 10704,
    OffNormalAlarmType_SuppressedState_Name = 10705,
    OffNormalAlarmType_SuppressedState_Number = 10706,
    OffNormalAlarmType_SuppressedState_EffectiveDisplayName = 10707,
    OffNormalAlarmType_SuppressedState_TransitionTime = 10708,
    OffNormalAlarmType_SuppressedState_EffectiveTransitionTime = 10709,
    OffNormalAlarmType_SuppressedState_TrueState = 10710,
    OffNormalAlarmType_SuppressedState_FalseState = 10711,
    OffNormalAlarmType_ShelvingState_CurrentState = 10713,
    OffNormalAlarmType_ShelvingState_CurrentState_Id = 10714,
    OffNormalAlarmType_ShelvingState_CurrentState_Name = 10715,
    OffNormalAlarmType_ShelvingState_CurrentState_Number = 10716,
    OffNormalAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10717,
    OffNormalAlarmType_ShelvingState_LastTransition = 10718,
    OffNormalAlarmType_ShelvingState_LastTransition_Id = 10719,
    OffNormalAlarmType_ShelvingState_LastTransition_Name = 10720,
    OffNormalAlarmType_ShelvingState_LastTransition_Number = 10721,
    OffNormalAlarmType_ShelvingState_LastTransition_TransitionTime = 10722,
    OffNormalAlarmType_ShelvingState_UnshelveTime = 10723,
    OffNormalAlarmType_ShelvingState_TimedShelve_InputArguments = 10748,
    OffNormalAlarmType_SuppressedOrShelved = 10749,
    OffNormalAlarmType_MaxTimeShelved = 10750,
    TripAlarmType_EventId = 10752,
    TripAlarmType_EventType = 10753,
    TripAlarmType_SourceNode = 10754,
    TripAlarmType_SourceName = 10755,
    TripAlarmType_Time = 10756,
    TripAlarmType_ReceiveTime = 10757,
    TripAlarmType_LocalTime = 10758,
    TripAlarmType_Message = 10759,
    TripAlarmType_Severity = 10760,
    TripAlarmType_ConditionName = 10761,
    TripAlarmType_BranchId = 10762,
    TripAlarmType_Retain = 10763,
    TripAlarmType_EnabledState = 10764,
    TripAlarmType_EnabledState_Id = 10765,
    TripAlarmType_EnabledState_Name = 10766,
    TripAlarmType_EnabledState_Number = 10767,
    TripAlarmType_EnabledState_EffectiveDisplayName = 10768,
    TripAlarmType_EnabledState_TransitionTime = 10769,
    TripAlarmType_EnabledState_EffectiveTransitionTime = 10770,
    TripAlarmType_EnabledState_TrueState = 10771,
    TripAlarmType_EnabledState_FalseState = 10772,
    TripAlarmType_Quality = 10773,
    TripAlarmType_Quality_SourceTimestamp = 10774,
    TripAlarmType_LastSeverity = 10775,
    TripAlarmType_LastSeverity_SourceTimestamp = 10776,
    TripAlarmType_Comment = 10777,
    TripAlarmType_Comment_SourceTimestamp = 10778,
    TripAlarmType_ClientUserId = 10779,
    TripAlarmType_AddComment_InputArguments = 10783,
    TripAlarmType_ConditionRefresh_InputArguments = 10785,
    TripAlarmType_AckedState = 10786,
    TripAlarmType_AckedState_Id = 10787,
    TripAlarmType_AckedState_Name = 10788,
    TripAlarmType_AckedState_Number = 10789,
    TripAlarmType_AckedState_EffectiveDisplayName = 10790,
    TripAlarmType_AckedState_TransitionTime = 10791,
    TripAlarmType_AckedState_EffectiveTransitionTime = 10792,
    TripAlarmType_AckedState_TrueState = 10793,
    TripAlarmType_AckedState_FalseState = 10794,
    TripAlarmType_ConfirmedState = 10795,
    TripAlarmType_ConfirmedState_Id = 10796,
    TripAlarmType_ConfirmedState_Name = 10797,
    TripAlarmType_ConfirmedState_Number = 10798,
    TripAlarmType_ConfirmedState_EffectiveDisplayName = 10799,
    TripAlarmType_ConfirmedState_TransitionTime = 10800,
    TripAlarmType_ConfirmedState_EffectiveTransitionTime = 10801,
    TripAlarmType_ConfirmedState_TrueState = 10802,
    TripAlarmType_ConfirmedState_FalseState = 10803,
    TripAlarmType_Acknowledge_InputArguments = 10805,
    TripAlarmType_Confirm_InputArguments = 10807,
    TripAlarmType_ActiveState = 10808,
    TripAlarmType_ActiveState_Id = 10809,
    TripAlarmType_ActiveState_Name = 10810,
    TripAlarmType_ActiveState_Number = 10811,
    TripAlarmType_ActiveState_EffectiveDisplayName = 10812,
    TripAlarmType_ActiveState_TransitionTime = 10813,
    TripAlarmType_ActiveState_EffectiveTransitionTime = 10814,
    TripAlarmType_ActiveState_TrueState = 10815,
    TripAlarmType_ActiveState_FalseState = 10816,
    TripAlarmType_SuppressedState = 10817,
    TripAlarmType_SuppressedState_Id = 10818,
    TripAlarmType_SuppressedState_Name = 10819,
    TripAlarmType_SuppressedState_Number = 10820,
    TripAlarmType_SuppressedState_EffectiveDisplayName = 10821,
    TripAlarmType_SuppressedState_TransitionTime = 10822,
    TripAlarmType_SuppressedState_EffectiveTransitionTime = 10823,
    TripAlarmType_SuppressedState_TrueState = 10824,
    TripAlarmType_SuppressedState_FalseState = 10825,
    TripAlarmType_ShelvingState_CurrentState = 10827,
    TripAlarmType_ShelvingState_CurrentState_Id = 10828,
    TripAlarmType_ShelvingState_CurrentState_Name = 10829,
    TripAlarmType_ShelvingState_CurrentState_Number = 10830,
    TripAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 10831,
    TripAlarmType_ShelvingState_LastTransition = 10832,
    TripAlarmType_ShelvingState_LastTransition_Id = 10833,
    TripAlarmType_ShelvingState_LastTransition_Name = 10834,
    TripAlarmType_ShelvingState_LastTransition_Number = 10835,
    TripAlarmType_ShelvingState_LastTransition_TransitionTime = 10836,
    TripAlarmType_ShelvingState_UnshelveTime = 10837,
    TripAlarmType_ShelvingState_TimedShelve_InputArguments = 10862,
    TripAlarmType_SuppressedOrShelved = 10863,
    TripAlarmType_MaxTimeShelved = 10864,
    AuditConditionShelvingEventType_EventId = 11094,
    AuditConditionShelvingEventType_EventType = 11095,
    AuditConditionShelvingEventType_SourceNode = 11096,
    AuditConditionShelvingEventType_SourceName = 11097,
    AuditConditionShelvingEventType_Time = 11098,
    AuditConditionShelvingEventType_ReceiveTime = 11099,
    AuditConditionShelvingEventType_LocalTime = 11100,
    AuditConditionShelvingEventType_Message = 11101,
    AuditConditionShelvingEventType_Severity = 11102,
    AuditConditionShelvingEventType_ActionTimeStamp = 11103,
    AuditConditionShelvingEventType_Status = 11104,
    AuditConditionShelvingEventType_ServerId = 11105,
    AuditConditionShelvingEventType_ClientAuditEntryId = 11106,
    AuditConditionShelvingEventType_ClientUserId = 11107,
    AuditConditionShelvingEventType_MethodId = 11108,
    AuditConditionShelvingEventType_InputArguments = 11109,
    TwoStateVariableType_TrueState = 11110,
    TwoStateVariableType_FalseState = 11111,
    ConditionType_ConditionClassId = 11112,
    ConditionType_ConditionClassName = 11113,
    DialogConditionType_ConditionClassId = 11114,
    DialogConditionType_ConditionClassName = 11115,
    AcknowledgeableConditionType_ConditionClassId = 11116,
    AcknowledgeableConditionType_ConditionClassName = 11117,
    AlarmConditionType_ConditionClassId = 11118,
    AlarmConditionType_ConditionClassName = 11119,
    AlarmConditionType_InputNode = 11120,
    LimitAlarmType_ConditionClassId = 11121,
    LimitAlarmType_ConditionClassName = 11122,
    LimitAlarmType_InputNode = 11123,
    LimitAlarmType_HighHighLimit = 11124,
    LimitAlarmType_HighLimit = 11125,
    LimitAlarmType_LowLimit = 11126,
    LimitAlarmType_LowLowLimit = 11127,
    ExclusiveLimitAlarmType_ConditionClassId = 11128,
    ExclusiveLimitAlarmType_ConditionClassName = 11129,
    ExclusiveLimitAlarmType_InputNode = 11130,
    ExclusiveLevelAlarmType_ConditionClassId = 11131,
    ExclusiveLevelAlarmType_ConditionClassName = 11132,
    ExclusiveLevelAlarmType_InputNode = 11133,
    ExclusiveRateOfChangeAlarmType_ConditionClassId = 11134,
    ExclusiveRateOfChangeAlarmType_ConditionClassName = 11135,
    ExclusiveRateOfChangeAlarmType_InputNode = 11136,
    ExclusiveDeviationAlarmType_ConditionClassId = 11137,
    ExclusiveDeviationAlarmType_ConditionClassName = 11138,
    ExclusiveDeviationAlarmType_InputNode = 11139,
    NonExclusiveLimitAlarmType_ConditionClassId = 11140,
    NonExclusiveLimitAlarmType_ConditionClassName = 11141,
    NonExclusiveLimitAlarmType_InputNode = 11142,
    NonExclusiveLevelAlarmType_ConditionClassId = 11143,
    NonExclusiveLevelAlarmType_ConditionClassName = 11144,
    NonExclusiveLevelAlarmType_InputNode = 11145,
    NonExclusiveRateOfChangeAlarmType_ConditionClassId = 11146,
    NonExclusiveRateOfChangeAlarmType_ConditionClassName = 11147,
    NonExclusiveRateOfChangeAlarmType_InputNode = 11148,
    NonExclusiveDeviationAlarmType_ConditionClassId = 11149,
    NonExclusiveDeviationAlarmType_ConditionClassName = 11150,
    NonExclusiveDeviationAlarmType_InputNode = 11151,
    DiscreteAlarmType_ConditionClassId = 11152,
    DiscreteAlarmType_ConditionClassName = 11153,
    DiscreteAlarmType_InputNode = 11154,
    OffNormalAlarmType_ConditionClassId = 11155,
    OffNormalAlarmType_ConditionClassName = 11156,
    OffNormalAlarmType_InputNode = 11157,
    OffNormalAlarmType_NormalState = 11158,
    TripAlarmType_ConditionClassId = 11159,
    TripAlarmType_ConditionClassName = 11160,
    TripAlarmType_InputNode = 11161,
    TripAlarmType_NormalState = 11162,
    HistoricalDataConfigurationType_AggregateConfiguration_TreatUncertainAsBad = 11168,
    HistoricalDataConfigurationType_AggregateConfiguration_PercentDataBad = 11169,
    HistoricalDataConfigurationType_AggregateConfiguration_PercentDataGood = 11170,
    HistoricalDataConfigurationType_AggregateConfiguration_UseSlopedExtrapolation = 11171,
    AggregateConfigurationType_TreatUncertainAsBad = 11188,
    AggregateConfigurationType_PercentDataBad = 11189,
    AggregateConfigurationType_PercentDataGood = 11190,
    AggregateConfigurationType_UseSlopedExtrapolation = 11191,
    HistoryServerCapabilities_AccessHistoryDataCapability = 11193,
    HistoryServerCapabilities_InsertDataCapability = 11196,
    HistoryServerCapabilities_ReplaceDataCapability = 11197,
    HistoryServerCapabilities_UpdateDataCapability = 11198,
    HistoryServerCapabilities_DeleteRawCapability = 11199,
    HistoryServerCapabilities_DeleteAtTimeCapability = 11200,
    HAConfiguration_AggregateConfiguration_TreatUncertainAsBad = 11204,
    HAConfiguration_AggregateConfiguration_PercentDataBad = 11205,
    HAConfiguration_AggregateConfiguration_PercentDataGood = 11206,
    HAConfiguration_AggregateConfiguration_UseSlopedExtrapolation = 11207,
    HAConfiguration_Stepped = 11208,
    HAConfiguration_Definition = 11209,
    HAConfiguration_MaxTimeInterval = 11210,
    HAConfiguration_MinTimeInterval = 11211,
    HAConfiguration_ExceptionDeviation = 11212,
    HAConfiguration_ExceptionDeviationFormat = 11213,
    Annotations = 11214,
    HistoricalEventFilter = 11215,
    MultiStateValueDiscreteType_Definition = 11239,
    MultiStateValueDiscreteType_ValuePrecision = 11240,
    MultiStateValueDiscreteType_EnumValues = 11241,
    HistoryServerCapabilities_AccessHistoryEventsCapability = 11242,
    HistoryServerCapabilitiesType_MaxReturnDataValues = 11268,
    HistoryServerCapabilitiesType_MaxReturnEventValues = 11269,
    HistoryServerCapabilitiesType_InsertAnnotationCapability = 11270,
    HistoryServerCapabilities_MaxReturnDataValues = 11273,
    HistoryServerCapabilities_MaxReturnEventValues = 11274,
    HistoryServerCapabilities_InsertAnnotationCapability = 11275,
    HistoryServerCapabilitiesType_InsertEventCapability = 11278,
    HistoryServerCapabilitiesType_ReplaceEventCapability = 11279,
    HistoryServerCapabilitiesType_UpdateEventCapability = 11280,
    HistoryServerCapabilities_InsertEventCapability = 11281,
    HistoryServerCapabilities_ReplaceEventCapability = 11282,
    HistoryServerCapabilities_UpdateEventCapability = 11283,
    Server_ServerRedundancy_CurrentServerId = 11312,
    Server_ServerRedundancy_RedundantServerArray = 11313,
    Server_ServerRedundancy_ServerUriArray = 11314,
    ShelvedStateMachineType_UnshelvedToTimedShelved_TransitionNumber = 11322,
    ShelvedStateMachineType_UnshelvedToOneShotShelved_TransitionNumber = 11323,
    ShelvedStateMachineType_TimedShelvedToUnshelved_TransitionNumber = 11324,
    ShelvedStateMachineType_TimedShelvedToOneShotShelved_TransitionNumber = 11325,
    ShelvedStateMachineType_OneShotShelvedToUnshelved_TransitionNumber = 11326,
    ShelvedStateMachineType_OneShotShelvedToTimedShelved_TransitionNumber = 11327,
    ExclusiveLimitStateMachineType_LowLowToLow_TransitionNumber = 11340,
    ExclusiveLimitStateMachineType_LowToLowLow_TransitionNumber = 11341,
    ExclusiveLimitStateMachineType_HighHighToHigh_TransitionNumber = 11342,
    ExclusiveLimitStateMachineType_HighToHighHigh_TransitionNumber = 11343,
    EnumStrings = 11432,
    ValueAsText = 11433,
    ProgressEventType_EventId = 11437,
    ProgressEventType_EventType = 11438,
    ProgressEventType_SourceNode = 11439,
    ProgressEventType_SourceName = 11440,
    ProgressEventType_Time = 11441,
    ProgressEventType_ReceiveTime = 11442,
    ProgressEventType_LocalTime = 11443,
    ProgressEventType_Message = 11444,
    ProgressEventType_Severity = 11445,
    SystemStatusChangeEventType_EventId = 11447,
    SystemStatusChangeEventType_EventType = 11448,
    SystemStatusChangeEventType_SourceNode = 11449,
    SystemStatusChangeEventType_SourceName = 11450,
    SystemStatusChangeEventType_Time = 11451,
    SystemStatusChangeEventType_ReceiveTime = 11452,
    SystemStatusChangeEventType_LocalTime = 11453,
    SystemStatusChangeEventType_Message = 11454,
    SystemStatusChangeEventType_Severity = 11455,
    TransitionVariableType_EffectiveTransitionTime = 11456,
    FiniteTransitionVariableType_EffectiveTransitionTime = 11457,
    StateMachineType_LastTransition_EffectiveTransitionTime = 11458,
    FiniteStateMachineType_LastTransition_EffectiveTransitionTime = 11459,
    TransitionEventType_Transition_EffectiveTransitionTime = 11460,
    MultiStateValueDiscreteType_ValueAsText = 11461,
    ProgramTransitionEventType_Transition_EffectiveTransitionTime = 11462,
    ProgramTransitionAuditEventType_Transition_EffectiveTransitionTime = 11463,
    ProgramStateMachineType_LastTransition_EffectiveTransitionTime = 11464,
    ShelvedStateMachineType_LastTransition_EffectiveTransitionTime = 11465,
    AlarmConditionType_ShelvingState_LastTransition_EffectiveTransitionTime = 11466,
    LimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11467,
    ExclusiveLimitStateMachineType_LastTransition_EffectiveTransitionTime = 11468,
    ExclusiveLimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11469,
    ExclusiveLimitAlarmType_LimitState_LastTransition_EffectiveTransitionTime = 11470,
    ExclusiveLevelAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11471,
    ExclusiveLevelAlarmType_LimitState_LastTransition_EffectiveTransitionTime = 11472,
    ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11473,
    ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_EffectiveTransitionTime = 11474,
    ExclusiveDeviationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11475,
    ExclusiveDeviationAlarmType_LimitState_LastTransition_EffectiveTransitionTime = 11476,
    NonExclusiveLimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11477,
    NonExclusiveLevelAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11478,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11479,
    NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11480,
    DiscreteAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11481,
    OffNormalAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11482,
    TripAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11483,
    AuditActivateSessionEventType_SecureChannelId = 11485,
    OptionSetType_OptionSetValues = 11488,
    ServerType_GetMonitoredItems_InputArguments = 11490,
    ServerType_GetMonitoredItems_OutputArguments = 11491,
    Server_GetMonitoredItems_InputArguments = 11493,
    Server_GetMonitoredItems_OutputArguments = 11494,
    GetMonitoredItemsMethodType_InputArguments = 11496,
    GetMonitoredItemsMethodType_OutputArguments = 11497,
    MaxStringLength = 11498,
    HistoricalDataConfigurationType_StartOfArchive = 11499,
    HistoricalDataConfigurationType_StartOfOnlineArchive = 11500,
    HistoryServerCapabilitiesType_DeleteEventCapability = 11501,
    HistoryServerCapabilities_DeleteEventCapability = 11502,
    HAConfiguration_StartOfArchive = 11503,
    HAConfiguration_StartOfOnlineArchive = 11504,
    ModellingRule_OptionalPlaceholder_NamingRule = 11509,
    ModellingRule_MandatoryPlaceholder_NamingRule = 11511,
    MaxArrayLength = 11512,
    EngineeringUnits = 11513,
    ServerType_ServerCapabilities_MaxArrayLength = 11514,
    ServerType_ServerCapabilities_MaxStringLength = 11515,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerRead = 11517,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerWrite = 11519,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall = 11521,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerBrowse = 11522,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes = 11523,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds = 11524,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement = 11525,
    ServerType_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall = 11526,
    ServerCapabilitiesType_MaxArrayLength = 11549,
    ServerCapabilitiesType_MaxStringLength = 11550,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerRead = 11552,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerWrite = 11554,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerMethodCall = 11556,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerBrowse = 11557,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerRegisterNodes = 11558,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds = 11559,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerNodeManagement = 11560,
    ServerCapabilitiesType_OperationLimits_MaxMonitoredItemsPerCall = 11561,
    ServerCapabilitiesType_VendorCapability_Placeholder = 11562,
    OperationLimitsType_MaxNodesPerRead = 11565,
    OperationLimitsType_MaxNodesPerWrite = 11567,
    OperationLimitsType_MaxNodesPerMethodCall = 11569,
    OperationLimitsType_MaxNodesPerBrowse = 11570,
    OperationLimitsType_MaxNodesPerRegisterNodes = 11571,
    OperationLimitsType_MaxNodesPerTranslateBrowsePathsToNodeIds = 11572,
    OperationLimitsType_MaxNodesPerNodeManagement = 11573,
    OperationLimitsType_MaxMonitoredItemsPerCall = 11574,
    FileType_Size = 11576,
    FileType_OpenCount = 11579,
    FileType_Open_InputArguments = 11581,
    FileType_Open_OutputArguments = 11582,
    FileType_Close_InputArguments = 11584,
    FileType_Read_InputArguments = 11586,
    FileType_Read_OutputArguments = 11587,
    FileType_Write_InputArguments = 11589,
    FileType_GetPosition_InputArguments = 11591,
    FileType_GetPosition_OutputArguments = 11592,
    FileType_SetPosition_InputArguments = 11594,
    AddressSpaceFileType_Size = 11596,
    AddressSpaceFileType_OpenCount = 11599,
    AddressSpaceFileType_Open_InputArguments = 11601,
    AddressSpaceFileType_Open_OutputArguments = 11602,
    AddressSpaceFileType_Close_InputArguments = 11604,
    AddressSpaceFileType_Read_InputArguments = 11606,
    AddressSpaceFileType_Read_OutputArguments = 11607,
    AddressSpaceFileType_Write_InputArguments = 11609,
    AddressSpaceFileType_GetPosition_InputArguments = 11611,
    AddressSpaceFileType_GetPosition_OutputArguments = 11612,
    AddressSpaceFileType_SetPosition_InputArguments = 11614,
    NamespaceMetadataType_NamespaceUri = 11617,
    NamespaceMetadataType_NamespaceVersion = 11618,
    NamespaceMetadataType_NamespacePublicationDate = 11619,
    NamespaceMetadataType_IsNamespaceSubset = 11620,
    NamespaceMetadataType_StaticNodeIdTypes = 11621,
    NamespaceMetadataType_StaticNumericNodeIdRange = 11622,
    NamespaceMetadataType_StaticStringNodeIdPattern = 11623,
    NamespaceMetadataType_NamespaceFile_Size = 11625,
    NamespaceMetadataType_NamespaceFile_OpenCount = 11628,
    NamespaceMetadataType_NamespaceFile_Open_InputArguments = 11630,
    NamespaceMetadataType_NamespaceFile_Open_OutputArguments = 11631,
    NamespaceMetadataType_NamespaceFile_Close_InputArguments = 11633,
    NamespaceMetadataType_NamespaceFile_Read_InputArguments = 11635,
    NamespaceMetadataType_NamespaceFile_Read_OutputArguments = 11636,
    NamespaceMetadataType_NamespaceFile_Write_InputArguments = 11638,
    NamespaceMetadataType_NamespaceFile_GetPosition_InputArguments = 11640,
    NamespaceMetadataType_NamespaceFile_GetPosition_OutputArguments = 11641,
    NamespaceMetadataType_NamespaceFile_SetPosition_InputArguments = 11643,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceUri = 11647,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceVersion = 11648,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespacePublicationDate = 11649,
    NamespacesType_NamespaceIdentifier_Placeholder_IsNamespaceSubset = 11650,
    NamespacesType_NamespaceIdentifier_Placeholder_StaticNodeIdTypes = 11651,
    NamespacesType_NamespaceIdentifier_Placeholder_StaticNumericNodeIdRange = 11652,
    NamespacesType_NamespaceIdentifier_Placeholder_StaticStringNodeIdPattern = 11653,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Size = 11655,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_OpenCount = 11658,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open_InputArguments = 11660,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open_OutputArguments = 11661,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Close_InputArguments = 11663,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read_InputArguments = 11665,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read_OutputArguments = 11666,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Write_InputArguments = 11668,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition_InputArguments = 11670,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition_OutputArguments =
        11671,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_SetPosition_InputArguments = 11673,
    SystemStatusChangeEventType_SystemState = 11696,
    SamplingIntervalDiagnosticsType_SampledMonitoredItemsCount = 11697,
    SamplingIntervalDiagnosticsType_MaxSampledMonitoredItemsCount = 11698,
    SamplingIntervalDiagnosticsType_DisabledMonitoredItemsSamplingCount = 11699,
    OptionSetType_BitMask = 11701,
    Server_ServerCapabilities_MaxArrayLength = 11702,
    Server_ServerCapabilities_MaxStringLength = 11703,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerRead = 11705,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerWrite = 11707,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall = 11709,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse = 11710,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes = 11711,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds = 11712,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement = 11713,
    Server_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall = 11714,
    OpenMethodType_InputArguments = 11739,
    OpenMethodType_OutputArguments = 11740,
    CloseMethodType_InputArguments = 11742,
    ReadMethodType_InputArguments = 11744,
    ReadMethodType_OutputArguments = 11745,
    WriteMethodType_InputArguments = 11747,
    GetPositionMethodType_InputArguments = 11749,
    GetPositionMethodType_OutputArguments = 11750,
    SetPositionMethodType_InputArguments = 11752,
    SystemOffNormalAlarmType_EventId = 11754,
    SystemOffNormalAlarmType_EventType = 11755,
    SystemOffNormalAlarmType_SourceNode = 11756,
    SystemOffNormalAlarmType_SourceName = 11757,
    SystemOffNormalAlarmType_Time = 11758,
    SystemOffNormalAlarmType_ReceiveTime = 11759,
    SystemOffNormalAlarmType_LocalTime = 11760,
    SystemOffNormalAlarmType_Message = 11761,
    SystemOffNormalAlarmType_Severity = 11762,
    SystemOffNormalAlarmType_ConditionClassId = 11763,
    SystemOffNormalAlarmType_ConditionClassName = 11764,
    SystemOffNormalAlarmType_ConditionName = 11765,
    SystemOffNormalAlarmType_BranchId = 11766,
    SystemOffNormalAlarmType_Retain = 11767,
    SystemOffNormalAlarmType_EnabledState = 11768,
    SystemOffNormalAlarmType_EnabledState_Id = 11769,
    SystemOffNormalAlarmType_EnabledState_Name = 11770,
    SystemOffNormalAlarmType_EnabledState_Number = 11771,
    SystemOffNormalAlarmType_EnabledState_EffectiveDisplayName = 11772,
    SystemOffNormalAlarmType_EnabledState_TransitionTime = 11773,
    SystemOffNormalAlarmType_EnabledState_EffectiveTransitionTime = 11774,
    SystemOffNormalAlarmType_EnabledState_TrueState = 11775,
    SystemOffNormalAlarmType_EnabledState_FalseState = 11776,
    SystemOffNormalAlarmType_Quality = 11777,
    SystemOffNormalAlarmType_Quality_SourceTimestamp = 11778,
    SystemOffNormalAlarmType_LastSeverity = 11779,
    SystemOffNormalAlarmType_LastSeverity_SourceTimestamp = 11780,
    SystemOffNormalAlarmType_Comment = 11781,
    SystemOffNormalAlarmType_Comment_SourceTimestamp = 11782,
    SystemOffNormalAlarmType_ClientUserId = 11783,
    SystemOffNormalAlarmType_AddComment_InputArguments = 11787,
    SystemOffNormalAlarmType_ConditionRefresh_InputArguments = 11789,
    SystemOffNormalAlarmType_AckedState = 11790,
    SystemOffNormalAlarmType_AckedState_Id = 11791,
    SystemOffNormalAlarmType_AckedState_Name = 11792,
    SystemOffNormalAlarmType_AckedState_Number = 11793,
    SystemOffNormalAlarmType_AckedState_EffectiveDisplayName = 11794,
    SystemOffNormalAlarmType_AckedState_TransitionTime = 11795,
    SystemOffNormalAlarmType_AckedState_EffectiveTransitionTime = 11796,
    SystemOffNormalAlarmType_AckedState_TrueState = 11797,
    SystemOffNormalAlarmType_AckedState_FalseState = 11798,
    SystemOffNormalAlarmType_ConfirmedState = 11799,
    SystemOffNormalAlarmType_ConfirmedState_Id = 11800,
    SystemOffNormalAlarmType_ConfirmedState_Name = 11801,
    SystemOffNormalAlarmType_ConfirmedState_Number = 11802,
    SystemOffNormalAlarmType_ConfirmedState_EffectiveDisplayName = 11803,
    SystemOffNormalAlarmType_ConfirmedState_TransitionTime = 11804,
    SystemOffNormalAlarmType_ConfirmedState_EffectiveTransitionTime = 11805,
    SystemOffNormalAlarmType_ConfirmedState_TrueState = 11806,
    SystemOffNormalAlarmType_ConfirmedState_FalseState = 11807,
    SystemOffNormalAlarmType_Acknowledge_InputArguments = 11809,
    SystemOffNormalAlarmType_Confirm_InputArguments = 11811,
    SystemOffNormalAlarmType_ActiveState = 11812,
    SystemOffNormalAlarmType_ActiveState_Id = 11813,
    SystemOffNormalAlarmType_ActiveState_Name = 11814,
    SystemOffNormalAlarmType_ActiveState_Number = 11815,
    SystemOffNormalAlarmType_ActiveState_EffectiveDisplayName = 11816,
    SystemOffNormalAlarmType_ActiveState_TransitionTime = 11817,
    SystemOffNormalAlarmType_ActiveState_EffectiveTransitionTime = 11818,
    SystemOffNormalAlarmType_ActiveState_TrueState = 11819,
    SystemOffNormalAlarmType_ActiveState_FalseState = 11820,
    SystemOffNormalAlarmType_InputNode = 11821,
    SystemOffNormalAlarmType_SuppressedState = 11822,
    SystemOffNormalAlarmType_SuppressedState_Id = 11823,
    SystemOffNormalAlarmType_SuppressedState_Name = 11824,
    SystemOffNormalAlarmType_SuppressedState_Number = 11825,
    SystemOffNormalAlarmType_SuppressedState_EffectiveDisplayName = 11826,
    SystemOffNormalAlarmType_SuppressedState_TransitionTime = 11827,
    SystemOffNormalAlarmType_SuppressedState_EffectiveTransitionTime = 11828,
    SystemOffNormalAlarmType_SuppressedState_TrueState = 11829,
    SystemOffNormalAlarmType_SuppressedState_FalseState = 11830,
    SystemOffNormalAlarmType_ShelvingState_CurrentState = 11832,
    SystemOffNormalAlarmType_ShelvingState_CurrentState_Id = 11833,
    SystemOffNormalAlarmType_ShelvingState_CurrentState_Name = 11834,
    SystemOffNormalAlarmType_ShelvingState_CurrentState_Number = 11835,
    SystemOffNormalAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 11836,
    SystemOffNormalAlarmType_ShelvingState_LastTransition = 11837,
    SystemOffNormalAlarmType_ShelvingState_LastTransition_Id = 11838,
    SystemOffNormalAlarmType_ShelvingState_LastTransition_Name = 11839,
    SystemOffNormalAlarmType_ShelvingState_LastTransition_Number = 11840,
    SystemOffNormalAlarmType_ShelvingState_LastTransition_TransitionTime = 11841,
    SystemOffNormalAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 11842,
    SystemOffNormalAlarmType_ShelvingState_UnshelveTime = 11843,
    SystemOffNormalAlarmType_ShelvingState_TimedShelve_InputArguments = 11847,
    SystemOffNormalAlarmType_SuppressedOrShelved = 11848,
    SystemOffNormalAlarmType_MaxTimeShelved = 11849,
    SystemOffNormalAlarmType_NormalState = 11850,
    AuditConditionCommentEventType_Comment = 11851,
    AuditConditionRespondEventType_SelectedResponse = 11852,
    AuditConditionAcknowledgeEventType_Comment = 11853,
    AuditConditionConfirmEventType_Comment = 11854,
    AuditConditionShelvingEventType_ShelvingTime = 11855,
    AuditProgramTransitionEventType_EventId = 11857,
    AuditProgramTransitionEventType_EventType = 11858,
    AuditProgramTransitionEventType_SourceNode = 11859,
    AuditProgramTransitionEventType_SourceName = 11860,
    AuditProgramTransitionEventType_Time = 11861,
    AuditProgramTransitionEventType_ReceiveTime = 11862,
    AuditProgramTransitionEventType_LocalTime = 11863,
    AuditProgramTransitionEventType_Message = 11864,
    AuditProgramTransitionEventType_Severity = 11865,
    AuditProgramTransitionEventType_ActionTimeStamp = 11866,
    AuditProgramTransitionEventType_Status = 11867,
    AuditProgramTransitionEventType_ServerId = 11868,
    AuditProgramTransitionEventType_ClientAuditEntryId = 11869,
    AuditProgramTransitionEventType_ClientUserId = 11870,
    AuditProgramTransitionEventType_MethodId = 11871,
    AuditProgramTransitionEventType_InputArguments = 11872,
    AuditProgramTransitionEventType_OldStateId = 11873,
    AuditProgramTransitionEventType_NewStateId = 11874,
    AuditProgramTransitionEventType_TransitionNumber = 11875,
    NodeClass_EnumValues = 11878,
    NodeAttributesMask_EnumValues = 11881,
    BrowseResultMask_EnumValues = 11883,
    HistoryUpdateType_EnumValues = 11884,
    PerformUpdateType_EnumValues = 11885,
    SessionDiagnosticsObjectType_SessionDiagnostics_UnauthorizedRequestCount = 11891,
    SessionDiagnosticsVariableType_UnauthorizedRequestCount = 11892,
    OpenFileMode_EnumValues = 11940,
    ModelChangeStructureVerbMask_EnumValues = 11942,
    NonTransparentNetworkRedundancyType_RedundancySupport = 11946,
    NonTransparentNetworkRedundancyType_ServerUriArray = 11947,
    NonTransparentNetworkRedundancyType_ServerNetworkGroups = 11948,
    OpcUa_BinarySchema_EndpointUrlListDataType = 11959,
    OpcUa_BinarySchema_EndpointUrlListDataType_DataTypeVersion = 11960,
    OpcUa_BinarySchema_EndpointUrlListDataType_DictionaryFragment = 11961,
    OpcUa_BinarySchema_NetworkGroupDataType = 11962,
    OpcUa_BinarySchema_NetworkGroupDataType_DataTypeVersion = 11963,
    OpcUa_BinarySchema_NetworkGroupDataType_DictionaryFragment = 11964,
    ArrayItemType_Definition = 12022,
    ArrayItemType_ValuePrecision = 12023,
    ArrayItemType_InstrumentRange = 12024,
    ArrayItemType_EURange = 12025,
    ArrayItemType_EngineeringUnits = 12026,
    ArrayItemType_Title = 12027,
    ArrayItemType_AxisScaleType = 12028,
    YArrayItemType_Definition = 12030,
    YArrayItemType_ValuePrecision = 12031,
    YArrayItemType_InstrumentRange = 12032,
    YArrayItemType_EURange = 12033,
    YArrayItemType_EngineeringUnits = 12034,
    YArrayItemType_Title = 12035,
    YArrayItemType_AxisScaleType = 12036,
    YArrayItemType_XAxisDefinition = 12037,
    XYArrayItemType_Definition = 12039,
    XYArrayItemType_ValuePrecision = 12040,
    XYArrayItemType_InstrumentRange = 12041,
    XYArrayItemType_EURange = 12042,
    XYArrayItemType_EngineeringUnits = 12043,
    XYArrayItemType_Title = 12044,
    XYArrayItemType_AxisScaleType = 12045,
    XYArrayItemType_XAxisDefinition = 12046,
    ImageItemType_Definition = 12048,
    ImageItemType_ValuePrecision = 12049,
    ImageItemType_InstrumentRange = 12050,
    ImageItemType_EURange = 12051,
    ImageItemType_EngineeringUnits = 12052,
    ImageItemType_Title = 12053,
    ImageItemType_AxisScaleType = 12054,
    ImageItemType_XAxisDefinition = 12055,
    ImageItemType_YAxisDefinition = 12056,
    CubeItemType_Definition = 12058,
    CubeItemType_ValuePrecision = 12059,
    CubeItemType_InstrumentRange = 12060,
    CubeItemType_EURange = 12061,
    CubeItemType_EngineeringUnits = 12062,
    CubeItemType_Title = 12063,
    CubeItemType_AxisScaleType = 12064,
    CubeItemType_XAxisDefinition = 12065,
    CubeItemType_YAxisDefinition = 12066,
    CubeItemType_ZAxisDefinition = 12067,
    NDimensionArrayItemType_Definition = 12069,
    NDimensionArrayItemType_ValuePrecision = 12070,
    NDimensionArrayItemType_InstrumentRange = 12071,
    NDimensionArrayItemType_EURange = 12072,
    NDimensionArrayItemType_EngineeringUnits = 12073,
    NDimensionArrayItemType_Title = 12074,
    NDimensionArrayItemType_AxisScaleType = 12075,
    NDimensionArrayItemType_AxisDefinition = 12076,
    AxisScaleEnumeration_EnumStrings = 12078,
    OpcUa_BinarySchema_AxisInformation = 12091,
    OpcUa_BinarySchema_AxisInformation_DataTypeVersion = 12092,
    OpcUa_BinarySchema_AxisInformation_DictionaryFragment = 12093,
    OpcUa_BinarySchema_XVType = 12094,
    OpcUa_BinarySchema_XVType_DataTypeVersion = 12095,
    OpcUa_BinarySchema_XVType_DictionaryFragment = 12096,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics = 12098,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SessionId = 12099,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SessionName = 12100,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientDescription =
        12101,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ServerUri = 12102,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_EndpointUrl = 12103,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_LocaleIds = 12104,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ActualSessionTimeout =
        12105,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_MaxResponseMessageSize =
        12106,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientConnectionTime =
        12107,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientLastContactTime =
        12108,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentSubscriptionsCount =
        12109,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentMonitoredItemsCount =
        12110,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentPublishRequestsInQueue =
        12111,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TotalRequestCount =
        12112,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_UnauthorizedRequestCount =
        12113,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ReadCount = 12114,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_HistoryReadCount =
        12115,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_WriteCount = 12116,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_HistoryUpdateCount =
        12117,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CallCount = 12118,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CreateMonitoredItemsCount =
        12119,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ModifyMonitoredItemsCount =
        12120,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetMonitoringModeCount =
        12121,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetTriggeringCount =
        12122,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteMonitoredItemsCount =
        12123,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CreateSubscriptionCount =
        12124,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ModifySubscriptionCount =
        12125,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetPublishingModeCount =
        12126,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_PublishCount = 12127,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_RepublishCount = 12128,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TransferSubscriptionsCount =
        12129,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteSubscriptionsCount =
        12130,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_AddNodesCount = 12131,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_AddReferencesCount =
        12132,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteNodesCount =
        12133,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteReferencesCount =
        12134,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_BrowseCount = 12135,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_BrowseNextCount =
        12136,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount =
        12137,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_QueryFirstCount =
        12138,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_QueryNextCount = 12139,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_RegisterNodesCount =
        12140,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_UnregisterNodesCount =
        12141,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics = 12142,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SessionId =
        12143,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientUserIdOfSession =
        12144,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientUserIdHistory =
        12145,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_AuthenticationMechanism =
        12146,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_Encoding =
        12147,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_TransportProtocol =
        12148,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SecurityMode =
        12149,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SecurityPolicyUri =
        12150,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientCertificate =
        12151,
    SessionsDiagnosticsSummaryType_ClientName_Placeholder_SubscriptionDiagnosticsArray = 12152,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData = 12153,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents = 12154,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData = 12155,
    ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents = 12156,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryReadData = 12157,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryReadEvents = 12158,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryUpdateData = 12159,
    ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryUpdateEvents = 12160,
    OperationLimitsType_MaxNodesPerHistoryReadData = 12161,
    OperationLimitsType_MaxNodesPerHistoryReadEvents = 12162,
    OperationLimitsType_MaxNodesPerHistoryUpdateData = 12163,
    OperationLimitsType_MaxNodesPerHistoryUpdateEvents = 12164,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData = 12165,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents = 12166,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData = 12167,
    Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents = 12168,
    NamingRuleType_EnumValues = 12169,
    ViewVersion = 12170,
    OpcUa_BinarySchema_ComplexNumberType = 12183,
    OpcUa_BinarySchema_ComplexNumberType_DataTypeVersion = 12184,
    OpcUa_BinarySchema_ComplexNumberType_DictionaryFragment = 12185,
    OpcUa_BinarySchema_DoubleComplexNumberType = 12186,
    OpcUa_BinarySchema_DoubleComplexNumberType_DataTypeVersion = 12187,
    OpcUa_BinarySchema_DoubleComplexNumberType_DictionaryFragment = 12188,
    OpcUa_BinarySchema_ServerOnNetwork = 12213,
    OpcUa_BinarySchema_ServerOnNetwork_DataTypeVersion = 12214,
    OpcUa_BinarySchema_ServerOnNetwork_DictionaryFragment = 12215,
    ProgressEventType_Context = 12502,
    ProgressEventType_Progress = 12503,
    OpenWithMasksMethodType_InputArguments = 12514,
    OpenWithMasksMethodType_OutputArguments = 12515,
    CloseAndUpdateMethodType_OutputArguments = 12517,
    AddCertificateMethodType_InputArguments = 12519,
    RemoveCertificateMethodType_InputArguments = 12521,
    TrustListType_Size = 12523,
    TrustListType_OpenCount = 12526,
    TrustListType_Open_InputArguments = 12528,
    TrustListType_Open_OutputArguments = 12529,
    TrustListType_Close_InputArguments = 12531,
    TrustListType_Read_InputArguments = 12533,
    TrustListType_Read_OutputArguments = 12534,
    TrustListType_Write_InputArguments = 12536,
    TrustListType_GetPosition_InputArguments = 12538,
    TrustListType_GetPosition_OutputArguments = 12539,
    TrustListType_SetPosition_InputArguments = 12541,
    TrustListType_LastUpdateTime = 12542,
    TrustListType_OpenWithMasks_InputArguments = 12544,
    TrustListType_OpenWithMasks_OutputArguments = 12545,
    TrustListType_CloseAndUpdate_OutputArguments = 12547,
    TrustListType_AddCertificate_InputArguments = 12549,
    TrustListType_RemoveCertificate_InputArguments = 12551,
    TrustListMasks_EnumValues = 12553,
    TrustListUpdatedAuditEventType_EventId = 12562,
    TrustListUpdatedAuditEventType_EventType = 12563,
    TrustListUpdatedAuditEventType_SourceNode = 12564,
    TrustListUpdatedAuditEventType_SourceName = 12565,
    TrustListUpdatedAuditEventType_Time = 12566,
    TrustListUpdatedAuditEventType_ReceiveTime = 12567,
    TrustListUpdatedAuditEventType_LocalTime = 12568,
    TrustListUpdatedAuditEventType_Message = 12569,
    TrustListUpdatedAuditEventType_Severity = 12570,
    TrustListUpdatedAuditEventType_ActionTimeStamp = 12571,
    TrustListUpdatedAuditEventType_Status = 12572,
    TrustListUpdatedAuditEventType_ServerId = 12573,
    TrustListUpdatedAuditEventType_ClientAuditEntryId = 12574,
    TrustListUpdatedAuditEventType_ClientUserId = 12575,
    TrustListUpdatedAuditEventType_MethodId = 12576,
    TrustListUpdatedAuditEventType_InputArguments = 12577,
    UpdateCertificateMethodType_InputArguments = 12579,
    UpdateCertificateMethodType_OutputArguments = 12580,
    ServerConfigurationType_SupportedPrivateKeyFormats = 12583,
    ServerConfigurationType_MaxTrustListSize = 12584,
    ServerConfigurationType_MulticastDnsEnabled = 12585,
    ServerConfigurationType_UpdateCertificate_InputArguments = 12617,
    ServerConfigurationType_UpdateCertificate_OutputArguments = 12618,
    CertificateUpdatedAuditEventType_EventId = 12621,
    CertificateUpdatedAuditEventType_EventType = 12622,
    CertificateUpdatedAuditEventType_SourceNode = 12623,
    CertificateUpdatedAuditEventType_SourceName = 12624,
    CertificateUpdatedAuditEventType_Time = 12625,
    CertificateUpdatedAuditEventType_ReceiveTime = 12626,
    CertificateUpdatedAuditEventType_LocalTime = 12627,
    CertificateUpdatedAuditEventType_Message = 12628,
    CertificateUpdatedAuditEventType_Severity = 12629,
    CertificateUpdatedAuditEventType_ActionTimeStamp = 12630,
    CertificateUpdatedAuditEventType_Status = 12631,
    CertificateUpdatedAuditEventType_ServerId = 12632,
    CertificateUpdatedAuditEventType_ClientAuditEntryId = 12633,
    CertificateUpdatedAuditEventType_ClientUserId = 12634,
    CertificateUpdatedAuditEventType_MethodId = 12635,
    CertificateUpdatedAuditEventType_InputArguments = 12636,
    ServerConfiguration_SupportedPrivateKeyFormats = 12639,
    ServerConfiguration_MaxTrustListSize = 12640,
    ServerConfiguration_MulticastDnsEnabled = 12641,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Size = 12643,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount = 12646,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments =
        12648,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments =
        12649,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments =
        12651,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments =
        12653,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments =
        12654,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments =
        12656,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments =
        12658,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments =
        12659,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments =
        12661,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime = 12662,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments =
        12664,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments =
        12665,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments =
        12667,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments =
        12669,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments =
        12671,
    OpcUa_BinarySchema_TrustListDataType = 12681,
    OpcUa_BinarySchema_TrustListDataType_DataTypeVersion = 12682,
    OpcUa_BinarySchema_TrustListDataType_DictionaryFragment = 12683,
    FileType_Writable = 12686,
    FileType_UserWritable = 12687,
    AddressSpaceFileType_Writable = 12688,
    AddressSpaceFileType_UserWritable = 12689,
    NamespaceMetadataType_NamespaceFile_Writable = 12690,
    NamespaceMetadataType_NamespaceFile_UserWritable = 12691,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Writable = 12692,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_UserWritable = 12693,
    TrustListType_Writable = 12698,
    TrustListType_UserWritable = 12699,
    CloseAndUpdateMethodType_InputArguments = 12704,
    TrustListType_CloseAndUpdate_InputArguments = 12705,
    ServerConfigurationType_ServerCapabilities = 12708,
    ServerConfiguration_ServerCapabilities = 12710,
    OpcUa_BinarySchema_RelativePathElement = 12718,
    OpcUa_BinarySchema_RelativePathElement_DataTypeVersion = 12719,
    OpcUa_BinarySchema_RelativePathElement_DictionaryFragment = 12720,
    OpcUa_BinarySchema_RelativePath = 12721,
    OpcUa_BinarySchema_RelativePath_DataTypeVersion = 12722,
    OpcUa_BinarySchema_RelativePath_DictionaryFragment = 12723,
    ServerConfigurationType_CreateSigningRequest_InputArguments = 12732,
    ServerConfigurationType_CreateSigningRequest_OutputArguments = 12733,
    ServerConfiguration_CreateSigningRequest_InputArguments = 12738,
    ServerConfiguration_CreateSigningRequest_OutputArguments = 12739,
    CreateSigningRequestMethodType_InputArguments = 12742,
    CreateSigningRequestMethodType_OutputArguments = 12743,
    OptionSetValues = 12745,
    ServerType_SetSubscriptionDurable_InputArguments = 12747,
    ServerType_SetSubscriptionDurable_OutputArguments = 12748,
    Server_SetSubscriptionDurable_InputArguments = 12750,
    Server_SetSubscriptionDurable_OutputArguments = 12751,
    SetSubscriptionDurableMethodType_InputArguments = 12753,
    SetSubscriptionDurableMethodType_OutputArguments = 12754,
    OpcUa_BinarySchema_OptionSet = 12767,
    OpcUa_BinarySchema_OptionSet_DataTypeVersion = 12768,
    OpcUa_BinarySchema_OptionSet_DictionaryFragment = 12769,
    OpcUa_BinarySchema_Union = 12770,
    OpcUa_BinarySchema_Union_DataTypeVersion = 12771,
    OpcUa_BinarySchema_Union_DictionaryFragment = 12772,
    GetRejectedListMethodType_OutputArguments = 12774,
    ServerConfigurationType_GetRejectedList_OutputArguments = 12776,
    ServerConfiguration_GetRejectedList_OutputArguments = 12778,
    SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics = 12779,
    SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_SamplingInterval = 12780,
    SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_SampledMonitoredItemsCount =
        12781,
    SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_MaxSampledMonitoredItemsCount =
        12782,
    SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_DisabledMonitoredItemsSamplingCount =
        12783,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics = 12784,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_SessionId = 12785,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_SubscriptionId = 12786,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_Priority = 12787,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishingInterval = 12788,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxKeepAliveCount = 12789,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxLifetimeCount = 12790,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxNotificationsPerPublish = 12791,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishingEnabled = 12792,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_ModifyCount = 12793,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EnableCount = 12794,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DisableCount = 12795,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishRequestCount = 12796,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishMessageRequestCount = 12797,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishMessageCount = 12798,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferRequestCount = 12799,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferredToAltClientCount = 12800,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferredToSameClientCount = 12801,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishRequestCount = 12802,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DataChangeNotificationsCount = 12803,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EventNotificationsCount = 12804,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_NotificationsCount = 12805,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_LatePublishRequestCount = 12806,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_CurrentKeepAliveCount = 12807,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_CurrentLifetimeCount = 12808,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_UnacknowledgedMessageCount = 12809,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DiscardedMessageCount = 12810,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MonitoredItemCount = 12811,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DisabledMonitoredItemCount = 12812,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MonitoringQueueOverflowCount = 12813,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_NextSequenceNumber = 12814,
    SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EventQueueOverflowCount = 12815,
    SessionDiagnosticsArrayType_SessionDiagnostics = 12816,
    SessionDiagnosticsArrayType_SessionDiagnostics_SessionId = 12817,
    SessionDiagnosticsArrayType_SessionDiagnostics_SessionName = 12818,
    SessionDiagnosticsArrayType_SessionDiagnostics_ClientDescription = 12819,
    SessionDiagnosticsArrayType_SessionDiagnostics_ServerUri = 12820,
    SessionDiagnosticsArrayType_SessionDiagnostics_EndpointUrl = 12821,
    SessionDiagnosticsArrayType_SessionDiagnostics_LocaleIds = 12822,
    SessionDiagnosticsArrayType_SessionDiagnostics_ActualSessionTimeout = 12823,
    SessionDiagnosticsArrayType_SessionDiagnostics_MaxResponseMessageSize = 12824,
    SessionDiagnosticsArrayType_SessionDiagnostics_ClientConnectionTime = 12825,
    SessionDiagnosticsArrayType_SessionDiagnostics_ClientLastContactTime = 12826,
    SessionDiagnosticsArrayType_SessionDiagnostics_CurrentSubscriptionsCount = 12827,
    SessionDiagnosticsArrayType_SessionDiagnostics_CurrentMonitoredItemsCount = 12828,
    SessionDiagnosticsArrayType_SessionDiagnostics_CurrentPublishRequestsInQueue = 12829,
    SessionDiagnosticsArrayType_SessionDiagnostics_TotalRequestCount = 12830,
    SessionDiagnosticsArrayType_SessionDiagnostics_UnauthorizedRequestCount = 12831,
    SessionDiagnosticsArrayType_SessionDiagnostics_ReadCount = 12832,
    SessionDiagnosticsArrayType_SessionDiagnostics_HistoryReadCount = 12833,
    SessionDiagnosticsArrayType_SessionDiagnostics_WriteCount = 12834,
    SessionDiagnosticsArrayType_SessionDiagnostics_HistoryUpdateCount = 12835,
    SessionDiagnosticsArrayType_SessionDiagnostics_CallCount = 12836,
    SessionDiagnosticsArrayType_SessionDiagnostics_CreateMonitoredItemsCount = 12837,
    SessionDiagnosticsArrayType_SessionDiagnostics_ModifyMonitoredItemsCount = 12838,
    SessionDiagnosticsArrayType_SessionDiagnostics_SetMonitoringModeCount = 12839,
    SessionDiagnosticsArrayType_SessionDiagnostics_SetTriggeringCount = 12840,
    SessionDiagnosticsArrayType_SessionDiagnostics_DeleteMonitoredItemsCount = 12841,
    SessionDiagnosticsArrayType_SessionDiagnostics_CreateSubscriptionCount = 12842,
    SessionDiagnosticsArrayType_SessionDiagnostics_ModifySubscriptionCount = 12843,
    SessionDiagnosticsArrayType_SessionDiagnostics_SetPublishingModeCount = 12844,
    SessionDiagnosticsArrayType_SessionDiagnostics_PublishCount = 12845,
    SessionDiagnosticsArrayType_SessionDiagnostics_RepublishCount = 12846,
    SessionDiagnosticsArrayType_SessionDiagnostics_TransferSubscriptionsCount = 12847,
    SessionDiagnosticsArrayType_SessionDiagnostics_DeleteSubscriptionsCount = 12848,
    SessionDiagnosticsArrayType_SessionDiagnostics_AddNodesCount = 12849,
    SessionDiagnosticsArrayType_SessionDiagnostics_AddReferencesCount = 12850,
    SessionDiagnosticsArrayType_SessionDiagnostics_DeleteNodesCount = 12851,
    SessionDiagnosticsArrayType_SessionDiagnostics_DeleteReferencesCount = 12852,
    SessionDiagnosticsArrayType_SessionDiagnostics_BrowseCount = 12853,
    SessionDiagnosticsArrayType_SessionDiagnostics_BrowseNextCount = 12854,
    SessionDiagnosticsArrayType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount = 12855,
    SessionDiagnosticsArrayType_SessionDiagnostics_QueryFirstCount = 12856,
    SessionDiagnosticsArrayType_SessionDiagnostics_QueryNextCount = 12857,
    SessionDiagnosticsArrayType_SessionDiagnostics_RegisterNodesCount = 12858,
    SessionDiagnosticsArrayType_SessionDiagnostics_UnregisterNodesCount = 12859,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics = 12860,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SessionId = 12861,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdOfSession = 12862,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdHistory = 12863,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_AuthenticationMechanism = 12864,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_Encoding = 12865,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_TransportProtocol = 12866,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityMode = 12867,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityPolicyUri = 12868,
    SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientCertificate = 12869,
    ServerType_ResendData_InputArguments = 12872,
    Server_ResendData_InputArguments = 12874,
    ResendDataMethodType_InputArguments = 12876,
    ServerType_EstimatedReturnTime = 12882,
    ServerType_RequestServerStateChange_InputArguments = 12884,
    Server_EstimatedReturnTime = 12885,
    Server_RequestServerStateChange_InputArguments = 12887,
    RequestServerStateChangeMethodType_InputArguments = 12889,
    OpcUa_BinarySchema_DiscoveryConfiguration = 12902,
    OpcUa_BinarySchema_DiscoveryConfiguration_DataTypeVersion = 12903,
    OpcUa_BinarySchema_DiscoveryConfiguration_DictionaryFragment = 12904,
    OpcUa_BinarySchema_MdnsDiscoveryConfiguration = 12905,
    OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DataTypeVersion = 12906,
    OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DictionaryFragment = 12907,
    MaxByteStringLength = 12908,
    ServerType_ServerCapabilities_MaxByteStringLength = 12909,
    ServerCapabilitiesType_MaxByteStringLength = 12910,
    Server_ServerCapabilities_MaxByteStringLength = 12911,
    ConditionType_ConditionRefresh2_InputArguments = 12913,
    ConditionRefresh2MethodType_InputArguments = 12915,
    DialogConditionType_ConditionRefresh2_InputArguments = 12917,
    AcknowledgeableConditionType_ConditionRefresh2_InputArguments = 12919,
    AlarmConditionType_ConditionRefresh2_InputArguments = 12985,
    LimitAlarmType_ConditionRefresh2_InputArguments = 12987,
    ExclusiveLimitAlarmType_ConditionRefresh2_InputArguments = 12989,
    NonExclusiveLimitAlarmType_ConditionRefresh2_InputArguments = 12991,
    NonExclusiveLevelAlarmType_ConditionRefresh2_InputArguments = 12993,
    ExclusiveLevelAlarmType_ConditionRefresh2_InputArguments = 12995,
    NonExclusiveDeviationAlarmType_ConditionRefresh2_InputArguments = 12997,
    ExclusiveDeviationAlarmType_ConditionRefresh2_InputArguments = 12999,
    NonExclusiveRateOfChangeAlarmType_ConditionRefresh2_InputArguments = 13001,
    ExclusiveRateOfChangeAlarmType_ConditionRefresh2_InputArguments = 13003,
    DiscreteAlarmType_ConditionRefresh2_InputArguments = 13005,
    OffNormalAlarmType_ConditionRefresh2_InputArguments = 13007,
    SystemOffNormalAlarmType_ConditionRefresh2_InputArguments = 13009,
    TripAlarmType_ConditionRefresh2_InputArguments = 13011,
    CertificateExpirationAlarmType_EventId = 13226,
    CertificateExpirationAlarmType_EventType = 13227,
    CertificateExpirationAlarmType_SourceNode = 13228,
    CertificateExpirationAlarmType_SourceName = 13229,
    CertificateExpirationAlarmType_Time = 13230,
    CertificateExpirationAlarmType_ReceiveTime = 13231,
    CertificateExpirationAlarmType_LocalTime = 13232,
    CertificateExpirationAlarmType_Message = 13233,
    CertificateExpirationAlarmType_Severity = 13234,
    CertificateExpirationAlarmType_ConditionClassId = 13235,
    CertificateExpirationAlarmType_ConditionClassName = 13236,
    CertificateExpirationAlarmType_ConditionName = 13237,
    CertificateExpirationAlarmType_BranchId = 13238,
    CertificateExpirationAlarmType_Retain = 13239,
    CertificateExpirationAlarmType_EnabledState = 13240,
    CertificateExpirationAlarmType_EnabledState_Id = 13241,
    CertificateExpirationAlarmType_EnabledState_Name = 13242,
    CertificateExpirationAlarmType_EnabledState_Number = 13243,
    CertificateExpirationAlarmType_EnabledState_EffectiveDisplayName = 13244,
    CertificateExpirationAlarmType_EnabledState_TransitionTime = 13245,
    CertificateExpirationAlarmType_EnabledState_EffectiveTransitionTime = 13246,
    CertificateExpirationAlarmType_EnabledState_TrueState = 13247,
    CertificateExpirationAlarmType_EnabledState_FalseState = 13248,
    CertificateExpirationAlarmType_Quality = 13249,
    CertificateExpirationAlarmType_Quality_SourceTimestamp = 13250,
    CertificateExpirationAlarmType_LastSeverity = 13251,
    CertificateExpirationAlarmType_LastSeverity_SourceTimestamp = 13252,
    CertificateExpirationAlarmType_Comment = 13253,
    CertificateExpirationAlarmType_Comment_SourceTimestamp = 13254,
    CertificateExpirationAlarmType_ClientUserId = 13255,
    CertificateExpirationAlarmType_AddComment_InputArguments = 13259,
    CertificateExpirationAlarmType_ConditionRefresh_InputArguments = 13261,
    CertificateExpirationAlarmType_ConditionRefresh2_InputArguments = 13263,
    CertificateExpirationAlarmType_AckedState = 13264,
    CertificateExpirationAlarmType_AckedState_Id = 13265,
    CertificateExpirationAlarmType_AckedState_Name = 13266,
    CertificateExpirationAlarmType_AckedState_Number = 13267,
    CertificateExpirationAlarmType_AckedState_EffectiveDisplayName = 13268,
    CertificateExpirationAlarmType_AckedState_TransitionTime = 13269,
    CertificateExpirationAlarmType_AckedState_EffectiveTransitionTime = 13270,
    CertificateExpirationAlarmType_AckedState_TrueState = 13271,
    CertificateExpirationAlarmType_AckedState_FalseState = 13272,
    CertificateExpirationAlarmType_ConfirmedState = 13273,
    CertificateExpirationAlarmType_ConfirmedState_Id = 13274,
    CertificateExpirationAlarmType_ConfirmedState_Name = 13275,
    CertificateExpirationAlarmType_ConfirmedState_Number = 13276,
    CertificateExpirationAlarmType_ConfirmedState_EffectiveDisplayName = 13277,
    CertificateExpirationAlarmType_ConfirmedState_TransitionTime = 13278,
    CertificateExpirationAlarmType_ConfirmedState_EffectiveTransitionTime = 13279,
    CertificateExpirationAlarmType_ConfirmedState_TrueState = 13280,
    CertificateExpirationAlarmType_ConfirmedState_FalseState = 13281,
    CertificateExpirationAlarmType_Acknowledge_InputArguments = 13283,
    CertificateExpirationAlarmType_Confirm_InputArguments = 13285,
    CertificateExpirationAlarmType_ActiveState = 13286,
    CertificateExpirationAlarmType_ActiveState_Id = 13287,
    CertificateExpirationAlarmType_ActiveState_Name = 13288,
    CertificateExpirationAlarmType_ActiveState_Number = 13289,
    CertificateExpirationAlarmType_ActiveState_EffectiveDisplayName = 13290,
    CertificateExpirationAlarmType_ActiveState_TransitionTime = 13291,
    CertificateExpirationAlarmType_ActiveState_EffectiveTransitionTime = 13292,
    CertificateExpirationAlarmType_ActiveState_TrueState = 13293,
    CertificateExpirationAlarmType_ActiveState_FalseState = 13294,
    CertificateExpirationAlarmType_InputNode = 13295,
    CertificateExpirationAlarmType_SuppressedState = 13296,
    CertificateExpirationAlarmType_SuppressedState_Id = 13297,
    CertificateExpirationAlarmType_SuppressedState_Name = 13298,
    CertificateExpirationAlarmType_SuppressedState_Number = 13299,
    CertificateExpirationAlarmType_SuppressedState_EffectiveDisplayName = 13300,
    CertificateExpirationAlarmType_SuppressedState_TransitionTime = 13301,
    CertificateExpirationAlarmType_SuppressedState_EffectiveTransitionTime = 13302,
    CertificateExpirationAlarmType_SuppressedState_TrueState = 13303,
    CertificateExpirationAlarmType_SuppressedState_FalseState = 13304,
    CertificateExpirationAlarmType_ShelvingState_CurrentState = 13306,
    CertificateExpirationAlarmType_ShelvingState_CurrentState_Id = 13307,
    CertificateExpirationAlarmType_ShelvingState_CurrentState_Name = 13308,
    CertificateExpirationAlarmType_ShelvingState_CurrentState_Number = 13309,
    CertificateExpirationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 13310,
    CertificateExpirationAlarmType_ShelvingState_LastTransition = 13311,
    CertificateExpirationAlarmType_ShelvingState_LastTransition_Id = 13312,
    CertificateExpirationAlarmType_ShelvingState_LastTransition_Name = 13313,
    CertificateExpirationAlarmType_ShelvingState_LastTransition_Number = 13314,
    CertificateExpirationAlarmType_ShelvingState_LastTransition_TransitionTime = 13315,
    CertificateExpirationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 13316,
    CertificateExpirationAlarmType_ShelvingState_UnshelveTime = 13317,
    CertificateExpirationAlarmType_ShelvingState_TimedShelve_InputArguments = 13321,
    CertificateExpirationAlarmType_SuppressedOrShelved = 13322,
    CertificateExpirationAlarmType_MaxTimeShelved = 13323,
    CertificateExpirationAlarmType_NormalState = 13324,
    CertificateExpirationAlarmType_ExpirationDate = 13325,
    CertificateExpirationAlarmType_CertificateType = 13326,
    CertificateExpirationAlarmType_Certificate = 13327,
    FileType_MimeType = 13341,
    CreateDirectoryMethodType_InputArguments = 13343,
    CreateDirectoryMethodType_OutputArguments = 13344,
    CreateFileMethodType_InputArguments = 13346,
    CreateFileMethodType_OutputArguments = 13347,
    DeleteFileMethodType_InputArguments = 13349,
    MoveOrCopyMethodType_InputArguments = 13351,
    MoveOrCopyMethodType_OutputArguments = 13352,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory_InputArguments = 13356,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory_OutputArguments = 13357,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateFile_InputArguments = 13359,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateFile_OutputArguments = 13360,
    FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy_InputArguments = 13364,
    FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy_OutputArguments = 13365,
    FileDirectoryType_FileName_Placeholder_Size = 13367,
    FileDirectoryType_FileName_Placeholder_Writable = 13368,
    FileDirectoryType_FileName_Placeholder_UserWritable = 13369,
    FileDirectoryType_FileName_Placeholder_OpenCount = 13370,
    FileDirectoryType_FileName_Placeholder_MimeType = 13371,
    FileDirectoryType_FileName_Placeholder_Open_InputArguments = 13373,
    FileDirectoryType_FileName_Placeholder_Open_OutputArguments = 13374,
    FileDirectoryType_FileName_Placeholder_Close_InputArguments = 13376,
    FileDirectoryType_FileName_Placeholder_Read_InputArguments = 13378,
    FileDirectoryType_FileName_Placeholder_Read_OutputArguments = 13379,
    FileDirectoryType_FileName_Placeholder_Write_InputArguments = 13381,
    FileDirectoryType_FileName_Placeholder_GetPosition_InputArguments = 13383,
    FileDirectoryType_FileName_Placeholder_GetPosition_OutputArguments = 13384,
    FileDirectoryType_FileName_Placeholder_SetPosition_InputArguments = 13386,
    FileDirectoryType_CreateDirectory_InputArguments = 13388,
    FileDirectoryType_CreateDirectory_OutputArguments = 13389,
    FileDirectoryType_CreateFile_InputArguments = 13391,
    FileDirectoryType_CreateFile_OutputArguments = 13392,
    FileDirectoryType_DeleteFileSystemObject_InputArguments = 13394,
    FileDirectoryType_MoveOrCopy_InputArguments = 13396,
    FileDirectoryType_MoveOrCopy_OutputArguments = 13397,
    AddressSpaceFileType_MimeType = 13398,
    NamespaceMetadataType_NamespaceFile_MimeType = 13399,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_MimeType = 13400,
    TrustListType_MimeType = 13403,
    CertificateGroupType_TrustList_Size = 13600,
    CertificateGroupType_TrustList_Writable = 13601,
    CertificateGroupType_TrustList_UserWritable = 13602,
    CertificateGroupType_TrustList_OpenCount = 13603,
    CertificateGroupType_TrustList_MimeType = 13604,
    CertificateGroupType_TrustList_Open_InputArguments = 13606,
    CertificateGroupType_TrustList_Open_OutputArguments = 13607,
    CertificateGroupType_TrustList_Close_InputArguments = 13609,
    CertificateGroupType_TrustList_Read_InputArguments = 13611,
    CertificateGroupType_TrustList_Read_OutputArguments = 13612,
    CertificateGroupType_TrustList_Write_InputArguments = 13614,
    CertificateGroupType_TrustList_GetPosition_InputArguments = 13616,
    CertificateGroupType_TrustList_GetPosition_OutputArguments = 13617,
    CertificateGroupType_TrustList_SetPosition_InputArguments = 13619,
    CertificateGroupType_TrustList_LastUpdateTime = 13620,
    CertificateGroupType_TrustList_OpenWithMasks_InputArguments = 13622,
    CertificateGroupType_TrustList_OpenWithMasks_OutputArguments = 13623,
    CertificateGroupType_TrustList_CloseAndUpdate_InputArguments = 13625,
    CertificateGroupType_TrustList_CloseAndUpdate_OutputArguments = 13626,
    CertificateGroupType_TrustList_AddCertificate_InputArguments = 13628,
    CertificateGroupType_TrustList_RemoveCertificate_InputArguments = 13630,
    CertificateGroupType_CertificateTypes = 13631,
    CertificateUpdatedAuditEventType_CertificateGroup = 13735,
    CertificateUpdatedAuditEventType_CertificateType = 13736,
    ServerConfiguration_UpdateCertificate_InputArguments = 13738,
    ServerConfiguration_UpdateCertificate_OutputArguments = 13739,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Size = 13816,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Writable = 13817,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_UserWritable = 13818,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenCount = 13819,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_MimeType = 13820,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open_InputArguments = 13822,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open_OutputArguments = 13823,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close_InputArguments = 13825,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read_InputArguments = 13827,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read_OutputArguments = 13828,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write_InputArguments = 13830,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition_InputArguments = 13832,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments =
        13833,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition_InputArguments = 13835,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_LastUpdateTime = 13836,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments =
        13838,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments =
        13839,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments =
        13841,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments =
        13842,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments =
        13844,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments =
        13846,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateTypes = 13847,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Size = 13850,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Writable = 13851,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_UserWritable = 13852,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenCount = 13853,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_MimeType = 13854,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open_InputArguments = 13856,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open_OutputArguments = 13857,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close_InputArguments = 13859,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read_InputArguments = 13861,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read_OutputArguments = 13862,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write_InputArguments = 13864,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition_InputArguments = 13866,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments = 13867,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition_InputArguments = 13869,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_LastUpdateTime = 13870,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments = 13872,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments = 13873,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments = 13875,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments = 13876,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments = 13878,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments = 13880,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateTypes = 13881,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Size = 13884,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Writable = 13885,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_UserWritable = 13886,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenCount = 13887,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_MimeType = 13888,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open_InputArguments = 13890,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open_OutputArguments = 13891,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close_InputArguments = 13893,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read_InputArguments = 13895,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read_OutputArguments = 13896,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write_InputArguments = 13898,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments = 13900,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments = 13901,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments = 13903,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_LastUpdateTime = 13904,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments = 13906,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments =
        13907,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments =
        13909,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments =
        13910,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments =
        13912,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments =
        13914,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateTypes = 13915,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Size = 13918,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Writable = 13919,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_UserWritable = 13920,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenCount = 13921,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_MimeType = 13922,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open_InputArguments = 13924,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open_OutputArguments = 13925,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Close_InputArguments = 13927,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read_InputArguments = 13929,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read_OutputArguments = 13930,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Write_InputArguments = 13932,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition_InputArguments =
        13934,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition_OutputArguments =
        13935,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_SetPosition_InputArguments =
        13937,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_LastUpdateTime = 13938,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks_InputArguments =
        13940,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks_OutputArguments =
        13941,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate_InputArguments =
        13943,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate_OutputArguments =
        13944,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_AddCertificate_InputArguments =
        13946,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_RemoveCertificate_InputArguments =
        13948,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateTypes = 13949,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Size = 13953,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Writable = 13954,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable =
        13955,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount = 13956,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType = 13957,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments =
        13959,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments =
        13960,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments =
        13962,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments =
        13964,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments =
        13965,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments =
        13967,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments =
        13969,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments =
        13970,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments =
        13972,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime =
        13973,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments =
        13975,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments =
        13976,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments =
        13978,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments =
        13979,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments =
        13981,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments =
        13983,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateTypes = 13984,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Size = 13987,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Writable = 13988,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable = 13989,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount = 13990,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType = 13991,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments =
        13993,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments =
        13994,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments =
        13996,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments =
        13998,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments =
        13999,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments =
        14001,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments =
        14003,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments =
        14004,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments =
        14006,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime = 14007,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments =
        14009,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments =
        14010,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments =
        14012,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments =
        14013,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments =
        14015,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments =
        14017,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateTypes = 14018,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Size = 14021,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable = 14022,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable = 14023,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount = 14024,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType = 14025,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments =
        14027,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments =
        14028,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments =
        14030,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments =
        14032,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments =
        14033,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments =
        14035,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments =
        14037,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments =
        14038,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments =
        14040,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime =
        14041,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments =
        14043,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments =
        14044,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments =
        14046,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments =
        14047,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments =
        14049,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments =
        14051,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateTypes = 14052,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Size = 14090,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Writable = 14091,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable = 14092,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount = 14093,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType = 14094,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments = 14096,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments = 14097,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments = 14099,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments = 14101,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments = 14102,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments = 14104,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments =
        14106,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments =
        14107,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments =
        14109,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime = 14110,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments =
        14112,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments =
        14113,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments =
        14115,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments =
        14116,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments =
        14118,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments =
        14120,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateTypes = 14121,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Size = 14124,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable = 14125,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable = 14126,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount = 14127,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType = 14128,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments =
        14130,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments =
        14131,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments =
        14133,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments =
        14135,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments =
        14136,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments =
        14138,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments =
        14140,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments =
        14141,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments =
        14143,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime = 14144,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments =
        14146,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments =
        14147,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments =
        14149,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments =
        14150,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments =
        14152,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments =
        14154,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateTypes = 14155,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Writable = 14157,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable = 14158,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType = 14159,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments =
        14160,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateTypes = 14161,
    RemoveConnectionMethodType_InputArguments = 14184,
    PubSubConnectionType_RemoveGroup_InputArguments = 14226,
    OpcUa_BinarySchema_PublishedVariableDataType = 14324,
    OpcUa_BinarySchema_PublishedVariableDataType_DataTypeVersion = 14325,
    OpcUa_BinarySchema_PublishedVariableDataType_DictionaryFragment = 14326,
    AuditCreateSessionEventType_SessionId = 14413,
    AuditUrlMismatchEventType_SessionId = 14414,
    Server_ServerRedundancy_ServerNetworkGroups = 14415,
    PublishSubscribeType_ConnectionName_Placeholder_PublisherId = 14418,
    PublishSubscribeType_ConnectionName_Placeholder_Status_State = 14420,
    PublishSubscribeType_ConnectionName_Placeholder_RemoveGroup_InputArguments = 14425,
    PublishSubscribeType_RemoveConnection_InputArguments = 14433,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItems_InputArguments = 14436,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItems_OutputArguments = 14437,
    PublishSubscribeType_PublishedDataSets_AddPublishedEvents_InputArguments = 14439,
    PublishSubscribeType_PublishedDataSets_AddPublishedEvents_OutputArguments = 14440,
    PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet_InputArguments = 14442,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems_InputArguments = 14480,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems_OutputArguments = 14481,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents_InputArguments = 14483,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents_OutputArguments = 14484,
    DataSetFolderType_DataSetFolderName_Placeholder_RemovePublishedDataSet_InputArguments = 14486,
    DataSetFolderType_PublishedDataSetName_Placeholder_ConfigurationVersion = 14489,
    DataSetFolderType_AddPublishedDataItems_InputArguments = 14494,
    DataSetFolderType_AddPublishedDataItems_OutputArguments = 14495,
    DataSetFolderType_AddPublishedEvents_InputArguments = 14497,
    DataSetFolderType_AddPublishedEvents_OutputArguments = 14498,
    DataSetFolderType_RemovePublishedDataSet_InputArguments = 14500,
    AddPublishedDataItemsMethodType_InputArguments = 14502,
    AddPublishedDataItemsMethodType_OutputArguments = 14503,
    AddPublishedEventsMethodType_InputArguments = 14505,
    AddPublishedEventsMethodType_OutputArguments = 14506,
    RemovePublishedDataSetMethodType_InputArguments = 14508,
    PublishedDataSetType_ConfigurationVersion = 14519,
    StructureType_EnumStrings = 14528,
    PublishedDataItemsType_ConfigurationVersion = 14544,
    PublishedDataItemsType_PublishedData = 14548,
    PublishedDataItemsType_AddVariables_InputArguments = 14556,
    PublishedDataItemsType_AddVariables_OutputArguments = 14557,
    PublishedDataItemsType_RemoveVariables_InputArguments = 14559,
    PublishedDataItemsType_RemoveVariables_OutputArguments = 14560,
    PublishedDataItemsAddVariablesMethodType_InputArguments = 14565,
    PublishedDataItemsAddVariablesMethodType_OutputArguments = 14566,
    PublishedDataItemsRemoveVariablesMethodType_InputArguments = 14568,
    PublishedDataItemsRemoveVariablesMethodType_OutputArguments = 14569,
    PublishedEventsType_ConfigurationVersion = 14582,
    PublishedEventsType_PubSubEventNotifier = 14586,
    PublishedEventsType_SelectedFields = 14587,
    PublishedEventsType_Filter = 14588,
    PubSubConnectionType_PublisherId = 14595,
    PubSubConnectionType_Status_State = 14601,
    PubSubConnectionTypeRemoveGroupMethodType_InputArguments = 14605,
    PubSubGroupTypeRemoveWriterMethodType_InputArguments = 14624,
    PubSubGroupTypeRemoveReaderMethodType_InputArguments = 14626,
    PubSubStatusType_State = 14644,
    PubSubState_EnumStrings = 14648,
    OpcUa_BinarySchema_DataSetMetaDataType = 14849,
    OpcUa_BinarySchema_DataSetMetaDataType_DataTypeVersion = 14850,
    OpcUa_BinarySchema_DataSetMetaDataType_DictionaryFragment = 14851,
    OpcUa_BinarySchema_FieldMetaData = 14852,
    OpcUa_BinarySchema_FieldMetaData_DataTypeVersion = 14853,
    OpcUa_BinarySchema_FieldMetaData_DictionaryFragment = 14854,
    OpcUa_BinarySchema_DataTypeDescription = 14855,
    OpcUa_BinarySchema_DataTypeDescription_DataTypeVersion = 14856,
    OpcUa_BinarySchema_DataTypeDescription_DictionaryFragment = 14857,
    OpcUa_BinarySchema_EnumField = 14870,
    OpcUa_BinarySchema_EnumField_DataTypeVersion = 14871,
    OpcUa_BinarySchema_EnumField_DictionaryFragment = 14872,
    OpcUa_BinarySchema_KeyValuePair = 14873,
    OpcUa_BinarySchema_KeyValuePair_DataTypeVersion = 14874,
    OpcUa_BinarySchema_KeyValuePair_DictionaryFragment = 14875,
    OpcUa_BinarySchema_ConfigurationVersionDataType = 14876,
    OpcUa_BinarySchema_ConfigurationVersionDataType_DataTypeVersion = 14877,
    OpcUa_BinarySchema_ConfigurationVersionDataType_DictionaryFragment = 14878,
    OpcUa_BinarySchema_FieldTargetDataType_DataTypeVersion = 14880,
    OpcUa_BinarySchema_FieldTargetDataType_DictionaryFragment = 14881,
    CertificateExpirationAlarmType_ExpirationLimit = 14900,
    DataTypeDictionaryType_Deprecated = 15001,
    MaxCharacters = 15002,
    ServerType_UrisVersion = 15003,
    Server_UrisVersion = 15004,
    BrokerTransportQualityOfService_EnumStrings = 15009,
    SecurityGroupFolderType_SecurityGroupName_Placeholder_KeyLifetime = 15010,
    SecurityGroupFolderType_SecurityGroupName_Placeholder_SecurityPolicyUri = 15011,
    SecurityGroupFolderType_SecurityGroupName_Placeholder_MaxFutureKeyCount = 15012,
    AuditConditionResetEventType_EventId = 15014,
    AuditConditionResetEventType_EventType = 15015,
    AuditConditionResetEventType_SourceNode = 15016,
    AuditConditionResetEventType_SourceName = 15017,
    AuditConditionResetEventType_Time = 15018,
    AuditConditionResetEventType_ReceiveTime = 15019,
    AuditConditionResetEventType_LocalTime = 15020,
    AuditConditionResetEventType_Message = 15021,
    AuditConditionResetEventType_Severity = 15022,
    AuditConditionResetEventType_ActionTimeStamp = 15023,
    AuditConditionResetEventType_Status = 15024,
    AuditConditionResetEventType_ServerId = 15025,
    AuditConditionResetEventType_ClientAuditEntryId = 15026,
    AuditConditionResetEventType_ClientUserId = 15027,
    AuditConditionResetEventType_MethodId = 15028,
    AuditConditionResetEventType_InputArguments = 15029,
    PermissionType_OptionSetValues = 15030,
    AccessLevelType_OptionSetValues = 15032,
    EventNotifierType_OptionSetValues = 15034,
    AccessRestrictionType_OptionSetValues = 15035,
    AttributeWriteMask_OptionSetValues = 15036,
    OpcUa_BinarySchema_Deprecated = 15037,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodInputValues = 15038,
    ProgramStateMachineType_ProgramDiagnostic_LastMethodOutputValues = 15040,
    SecurityGroupFolderType_SecurityGroupName_Placeholder_MaxPastKeyCount = 15043,
    SecurityGroupType_KeyLifetime = 15046,
    SecurityGroupType_SecurityPolicyUri = 15047,
    SecurityGroupType_MaxFutureKeyCount = 15048,
    PublishedEventsType_ModifyFieldSelection_InputArguments = 15053,
    PublishedEventsTypeModifyFieldSelectionMethodType_InputArguments = 15055,
    SecurityGroupType_MaxPastKeyCount = 15056,
    ChoiceStateType_StateNumber = 15110,
    TargetVariablesType_TargetVariables = 15114,
    TargetVariablesType_AddTargetVariables_InputArguments = 15116,
    TargetVariablesType_AddTargetVariables_OutputArguments = 15117,
    TargetVariablesType_RemoveTargetVariables_InputArguments = 15119,
    TargetVariablesType_RemoveTargetVariables_OutputArguments = 15120,
    TargetVariablesTypeAddTargetVariablesMethodType_InputArguments = 15122,
    TargetVariablesTypeAddTargetVariablesMethodType_OutputArguments = 15123,
    TargetVariablesTypeRemoveTargetVariablesMethodType_InputArguments = 15125,
    TargetVariablesTypeRemoveTargetVariablesMethodType_OutputArguments = 15126,
    ExpressionGuardVariableType_Expression = 15129,
    DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface = 15154,
    BrokerConnectionTransportType_ResourceUri = 15156,
    BrokerConnectionTransportType_AuthenticationProfileUri = 15178,
    PublishSubscribeType_GetSecurityKeys_InputArguments = 15213,
    PublishSubscribeType_GetSecurityKeys_OutputArguments = 15214,
    PublishSubscribe_GetSecurityKeys_InputArguments = 15216,
    PublishSubscribe_GetSecurityKeys_OutputArguments = 15217,
    GetSecurityKeysMethodType_InputArguments = 15219,
    GetSecurityKeysMethodType_OutputArguments = 15220,
    DataSetFolderType_PublishedDataSetName_Placeholder_DataSetMetaData = 15221,
    PublishedDataSetType_DataSetWriterName_Placeholder_Status_State = 15224,
    PublishedDataSetType_DataSetMetaData = 15229,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Status_State = 15232,
    PublishedDataItemsType_DataSetMetaData = 15237,
    PublishedEventsType_DataSetWriterName_Placeholder_Status_State = 15240,
    PublishedEventsType_DataSetMetaData = 15245,
    BrokerWriterGroupTransportType_ResourceUri = 15246,
    BrokerWriterGroupTransportType_AuthenticationProfileUri = 15247,
    BrokerWriterGroupTransportType_RequestedDeliveryGuarantee = 15249,
    BrokerDataSetWriterTransportType_ResourceUri = 15250,
    BrokerDataSetWriterTransportType_AuthenticationProfileUri = 15251,
    CreateCredentialMethodType_InputArguments = 15253,
    PubSubGroupType_Status_State = 15266,
    DataSetWriterType_Status_State = 15300,
    DataSetReaderType_Status_State = 15308,
    BrokerDataSetWriterTransportType_RequestedDeliveryGuarantee = 15330,
    BrokerDataSetReaderTransportType_ResourceUri = 15334,
    ProgramDiagnostic2Type_CreateSessionId = 15384,
    ProgramDiagnostic2Type_CreateClientName = 15385,
    ProgramDiagnostic2Type_InvocationCreationTime = 15386,
    ProgramDiagnostic2Type_LastTransitionTime = 15387,
    ProgramDiagnostic2Type_LastMethodCall = 15388,
    ProgramDiagnostic2Type_LastMethodSessionId = 15389,
    ProgramDiagnostic2Type_LastMethodInputArguments = 15390,
    ProgramDiagnostic2Type_LastMethodOutputArguments = 15391,
    ProgramDiagnostic2Type_LastMethodInputValues = 15392,
    ProgramDiagnostic2Type_LastMethodOutputValues = 15393,
    ProgramDiagnostic2Type_LastMethodCallTime = 15394,
    ProgramDiagnostic2Type_LastMethodReturnStatus = 15395,
    OpcUa_BinarySchema_ProgramDiagnostic2DataType = 15398,
    OpcUa_BinarySchema_ProgramDiagnostic2DataType_DataTypeVersion = 15399,
    OpcUa_BinarySchema_ProgramDiagnostic2DataType_DictionaryFragment = 15400,
    AccessLevelExType_OptionSetValues = 15407,
    RoleSetType_RoleName_Placeholder_ApplicationsExclude = 15408,
    RoleSetType_RoleName_Placeholder_EndpointsExclude = 15409,
    RoleType_ApplicationsExclude = 15410,
    RoleType_EndpointsExclude = 15411,
    WellKnownRole_Anonymous_ApplicationsExclude = 15412,
    WellKnownRole_Anonymous_EndpointsExclude = 15413,
    WellKnownRole_AuthenticatedUser_ApplicationsExclude = 15414,
    WellKnownRole_AuthenticatedUser_EndpointsExclude = 15415,
    WellKnownRole_Observer_ApplicationsExclude = 15416,
    WellKnownRole_Observer_EndpointsExclude = 15417,
    WellKnownRole_Operator_ApplicationsExclude = 15418,
    BrokerDataSetReaderTransportType_AuthenticationProfileUri = 15419,
    BrokerDataSetReaderTransportType_RequestedDeliveryGuarantee = 15420,
    WellKnownRole_Operator_EndpointsExclude = 15423,
    WellKnownRole_Engineer_ApplicationsExclude = 15424,
    WellKnownRole_Engineer_EndpointsExclude = 15425,
    WellKnownRole_Supervisor_ApplicationsExclude = 15426,
    WellKnownRole_Supervisor_EndpointsExclude = 15427,
    WellKnownRole_ConfigureAdmin_ApplicationsExclude = 15428,
    WellKnownRole_ConfigureAdmin_EndpointsExclude = 15429,
    WellKnownRole_SecurityAdmin_ApplicationsExclude = 15430,
    PublishSubscribeType_GetSecurityGroup_InputArguments = 15432,
    PublishSubscribeType_GetSecurityGroup_OutputArguments = 15433,
    PublishSubscribeType_SecurityGroups_AddSecurityGroup_InputArguments = 15436,
    PublishSubscribeType_SecurityGroups_AddSecurityGroup_OutputArguments = 15437,
    PublishSubscribeType_SecurityGroups_RemoveSecurityGroup_InputArguments = 15439,
    PublishSubscribe_GetSecurityGroup_InputArguments = 15441,
    PublishSubscribe_GetSecurityGroup_OutputArguments = 15442,
    PublishSubscribe_SecurityGroups_AddSecurityGroup_InputArguments = 15445,
    PublishSubscribe_SecurityGroups_AddSecurityGroup_OutputArguments = 15446,
    PublishSubscribe_SecurityGroups_RemoveSecurityGroup_InputArguments = 15448,
    GetSecurityGroupMethodType_InputArguments = 15450,
    GetSecurityGroupMethodType_OutputArguments = 15451,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup_InputArguments =
        15455,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup_OutputArguments =
        15456,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_RemoveSecurityGroup_InputArguments =
        15458,
    SecurityGroupFolderType_SecurityGroupName_Placeholder_SecurityGroupId = 15460,
    SecurityGroupFolderType_AddSecurityGroup_InputArguments = 15462,
    SecurityGroupFolderType_AddSecurityGroup_OutputArguments = 15463,
    SecurityGroupFolderType_RemoveSecurityGroup_InputArguments = 15465,
    AddSecurityGroupMethodType_InputArguments = 15467,
    AddSecurityGroupMethodType_OutputArguments = 15468,
    RemoveSecurityGroupMethodType_InputArguments = 15470,
    SecurityGroupType_SecurityGroupId = 15472,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField_InputArguments =
        15475,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField_OutputArguments =
        15476,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_RemoveExtensionField_InputArguments =
        15478,
    PublishedDataSetType_ExtensionFields_AddExtensionField_InputArguments = 15483,
    PublishedDataSetType_ExtensionFields_AddExtensionField_OutputArguments = 15484,
    PublishedDataSetType_ExtensionFields_RemoveExtensionField_InputArguments = 15486,
    ExtensionFieldsType_ExtensionFieldName_Placeholder = 15490,
    ExtensionFieldsType_AddExtensionField_InputArguments = 15492,
    ExtensionFieldsType_AddExtensionField_OutputArguments = 15493,
    ExtensionFieldsType_RemoveExtensionField_InputArguments = 15495,
    AddExtensionFieldMethodType_InputArguments = 15497,
    AddExtensionFieldMethodType_OutputArguments = 15498,
    RemoveExtensionFieldMethodType_InputArguments = 15500,
    OpcUa_BinarySchema_SimpleTypeDescription = 15501,
    PublishedDataItemsType_ExtensionFields_AddExtensionField_InputArguments = 15505,
    PublishedDataItemsType_ExtensionFields_AddExtensionField_OutputArguments = 15506,
    PublishedDataItemsType_ExtensionFields_RemoveExtensionField_InputArguments = 15508,
    OpcUa_BinarySchema_SimpleTypeDescription_DataTypeVersion = 15509,
    PublishedEventsType_ExtensionFields_AddExtensionField_InputArguments = 15513,
    PublishedEventsType_ExtensionFields_AddExtensionField_OutputArguments = 15514,
    PublishedEventsType_ExtensionFields_RemoveExtensionField_InputArguments = 15516,
    PublishedEventsType_ModifyFieldSelection_OutputArguments = 15517,
    PublishedEventsTypeModifyFieldSelectionMethodType_OutputArguments = 15518,
    OpcUa_BinarySchema_SimpleTypeDescription_DictionaryFragment = 15519,
    OpcUa_BinarySchema_UABinaryFileDataType = 15521,
    OpcUa_BinarySchema_UABinaryFileDataType_DataTypeVersion = 15522,
    OpcUa_BinarySchema_UABinaryFileDataType_DictionaryFragment = 15523,
    OpcUa_BinarySchema_BrokerConnectionTransportDataType = 15524,
    OpcUa_BinarySchema_BrokerConnectionTransportDataType_DataTypeVersion = 15525,
    OpcUa_BinarySchema_BrokerConnectionTransportDataType_DictionaryFragment = 15526,
    WellKnownRole_SecurityAdmin_EndpointsExclude = 15527,
    PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface = 15533,
    PubSubStatusEventType_EventId = 15536,
    PubSubStatusEventType_EventType = 15537,
    PubSubStatusEventType_SourceNode = 15538,
    PubSubStatusEventType_SourceName = 15539,
    PubSubStatusEventType_Time = 15540,
    PubSubStatusEventType_ReceiveTime = 15541,
    PubSubStatusEventType_LocalTime = 15542,
    PubSubStatusEventType_Message = 15543,
    PubSubStatusEventType_Severity = 15544,
    PubSubStatusEventType_ConnectionId = 15545,
    PubSubStatusEventType_GroupId = 15546,
    PubSubStatusEventType_State = 15547,
    PubSubTransportLimitsExceedEventType_EventId = 15549,
    PubSubTransportLimitsExceedEventType_EventType = 15550,
    PubSubTransportLimitsExceedEventType_SourceNode = 15551,
    PubSubTransportLimitsExceedEventType_SourceName = 15552,
    PubSubTransportLimitsExceedEventType_Time = 15553,
    PubSubTransportLimitsExceedEventType_ReceiveTime = 15554,
    PubSubTransportLimitsExceedEventType_LocalTime = 15555,
    PubSubTransportLimitsExceedEventType_Message = 15556,
    PubSubTransportLimitsExceedEventType_Severity = 15557,
    PubSubTransportLimitsExceedEventType_ConnectionId = 15558,
    PubSubTransportLimitsExceedEventType_GroupId = 15559,
    PubSubTransportLimitsExceedEventType_State = 15560,
    PubSubTransportLimitsExceedEventType_Actual = 15561,
    PubSubTransportLimitsExceedEventType_Maximum = 15562,
    PubSubCommunicationFailureEventType_EventId = 15564,
    PubSubCommunicationFailureEventType_EventType = 15565,
    PubSubCommunicationFailureEventType_SourceNode = 15566,
    PubSubCommunicationFailureEventType_SourceName = 15567,
    PubSubCommunicationFailureEventType_Time = 15568,
    PubSubCommunicationFailureEventType_ReceiveTime = 15569,
    PubSubCommunicationFailureEventType_LocalTime = 15570,
    PubSubCommunicationFailureEventType_Message = 15571,
    PubSubCommunicationFailureEventType_Severity = 15572,
    PubSubCommunicationFailureEventType_ConnectionId = 15573,
    PubSubCommunicationFailureEventType_GroupId = 15574,
    PubSubCommunicationFailureEventType_State = 15575,
    PubSubCommunicationFailureEventType_Error = 15576,
    DataSetFieldFlags_OptionSetValues = 15577,
    DataSetFieldContentMask_OptionSetValues = 15584,
    OpcUa_BinarySchema_StructureDescription = 15599,
    OpcUa_BinarySchema_StructureDescription_DataTypeVersion = 15600,
    OpcUa_BinarySchema_StructureDescription_DictionaryFragment = 15601,
    OpcUa_BinarySchema_EnumDescription = 15602,
    OpcUa_BinarySchema_EnumDescription_DataTypeVersion = 15603,
    OpcUa_BinarySchema_EnumDescription_DictionaryFragment = 15604,
    RoleSetType_RoleName_Placeholder_AddIdentity_InputArguments = 15613,
    RoleSetType_RoleName_Placeholder_RemoveIdentity_InputArguments = 15615,
    RoleType_AddIdentity_InputArguments = 15625,
    RoleType_RemoveIdentity_InputArguments = 15627,
    IdentityCriteriaType_EnumValues = 15633,
    AddIdentityMethodType_InputArguments = 15637,
    RemoveIdentityMethodType_InputArguments = 15639,
    DataSetOrderingType_EnumStrings = 15641,
    UadpNetworkMessageContentMask_OptionSetValues = 15643,
    UadpDataSetMessageContentMask_OptionSetValues = 15647,
    WellKnownRole_Anonymous_AddIdentity_InputArguments = 15649,
    WellKnownRole_Anonymous_RemoveIdentity_InputArguments = 15651,
    JsonNetworkMessageContentMask_OptionSetValues = 15655,
    JsonDataSetMessageContentMask_OptionSetValues = 15659,
    WellKnownRole_AuthenticatedUser_AddIdentity_InputArguments = 15661,
    WellKnownRole_AuthenticatedUser_RemoveIdentity_InputArguments = 15663,
    WellKnownRole_Observer_AddIdentity_InputArguments = 15673,
    WellKnownRole_Observer_RemoveIdentity_InputArguments = 15675,
    WellKnownRole_Operator_AddIdentity_InputArguments = 15685,
    WellKnownRole_Operator_RemoveIdentity_InputArguments = 15687,
    WellKnownRole_Supervisor_AddIdentity_InputArguments = 15697,
    WellKnownRole_Supervisor_RemoveIdentity_InputArguments = 15699,
    WellKnownRole_SecurityAdmin_AddIdentity_InputArguments = 15709,
    WellKnownRole_SecurityAdmin_RemoveIdentity_InputArguments = 15711,
    WellKnownRole_ConfigureAdmin_AddIdentity_InputArguments = 15721,
    WellKnownRole_ConfigureAdmin_RemoveIdentity_InputArguments = 15723,
    OpcUa_BinarySchema_EndpointType = 15734,
    OpcUa_BinarySchema_EndpointType_DataTypeVersion = 15735,
    OpcUa_BinarySchema_EndpointType_DictionaryFragment = 15737,
    OpcUa_BinarySchema_IdentityMappingRuleType = 15738,
    OpcUa_BinarySchema_IdentityMappingRuleType_DataTypeVersion = 15739,
    OpcUa_BinarySchema_IdentityMappingRuleType_DictionaryFragment = 15740,
    OpcUa_BinarySchema_DataTypeSchemaHeader = 15741,
    OpcUa_BinarySchema_DataTypeSchemaHeader_DataTypeVersion = 15742,
    OpcUa_BinarySchema_DataTypeSchemaHeader_DictionaryFragment = 15743,
    TemporaryFileTransferType_ClientProcessingTimeout = 15745,
    TemporaryFileTransferType_GenerateFileForRead_InputArguments = 15747,
    TemporaryFileTransferType_GenerateFileForRead_OutputArguments = 15748,
    TemporaryFileTransferType_GenerateFileForWrite_OutputArguments = 15750,
    TemporaryFileTransferType_CloseAndCommit_InputArguments = 15752,
    TemporaryFileTransferType_CloseAndCommit_OutputArguments = 15753,
    TemporaryFileTransferType_TransferState_Placeholder_CurrentState = 15755,
    TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Id = 15756,
    TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Name = 15757,
    TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Number = 15758,
    TemporaryFileTransferType_TransferState_Placeholder_CurrentState_EffectiveDisplayName = 15759,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition = 15760,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Id = 15761,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Name = 15762,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Number = 15763,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition_TransitionTime = 15764,
    TemporaryFileTransferType_TransferState_Placeholder_LastTransition_EffectiveTransitionTime =
        15765,
    OpcUa_BinarySchema_PublishedDataSetDataType = 15766,
    OpcUa_BinarySchema_PublishedDataSetDataType_DataTypeVersion = 15767,
    OpcUa_BinarySchema_PublishedDataSetDataType_DictionaryFragment = 15768,
    OpcUa_BinarySchema_PublishedDataSetSourceDataType = 15769,
    OpcUa_BinarySchema_PublishedDataSetSourceDataType_DataTypeVersion = 15770,
    OpcUa_BinarySchema_PublishedDataSetSourceDataType_DictionaryFragment = 15771,
    OpcUa_BinarySchema_PublishedDataItemsDataType = 15772,
    OpcUa_BinarySchema_PublishedDataItemsDataType_DataTypeVersion = 15773,
    OpcUa_BinarySchema_PublishedDataItemsDataType_DictionaryFragment = 15774,
    OpcUa_BinarySchema_PublishedEventsDataType = 15775,
    OpcUa_BinarySchema_PublishedEventsDataType_DataTypeVersion = 15776,
    OpcUa_BinarySchema_PublishedEventsDataType_DictionaryFragment = 15777,
    OpcUa_BinarySchema_DataSetWriterDataType = 15778,
    OpcUa_BinarySchema_DataSetWriterDataType_DataTypeVersion = 15779,
    OpcUa_BinarySchema_DataSetWriterDataType_DictionaryFragment = 15780,
    OpcUa_BinarySchema_DataSetWriterTransportDataType = 15781,
    OpcUa_BinarySchema_DataSetWriterTransportDataType_DataTypeVersion = 15782,
    OpcUa_BinarySchema_DataSetWriterTransportDataType_DictionaryFragment = 15783,
    OpcUa_BinarySchema_DataSetWriterMessageDataType = 15784,
    OpcUa_BinarySchema_DataSetWriterMessageDataType_DataTypeVersion = 15785,
    OpcUa_BinarySchema_DataSetWriterMessageDataType_DictionaryFragment = 15786,
    OpcUa_BinarySchema_PubSubGroupDataType = 15787,
    OpcUa_BinarySchema_PubSubGroupDataType_DataTypeVersion = 15788,
    OpcUa_BinarySchema_PubSubGroupDataType_DictionaryFragment = 15789,
    PublishSubscribe_ConnectionName_Placeholder_PublisherId = 15791,
    PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri = 15792,
    OpcUa_BinarySchema_WriterGroupTransportDataType = 15793,
    GenerateFileForReadMethodType_InputArguments = 15796,
    GenerateFileForReadMethodType_OutputArguments = 15797,
    GenerateFileForWriteMethodType_OutputArguments = 15799,
    CloseAndCommitMethodType_InputArguments = 15801,
    CloseAndCommitMethodType_OutputArguments = 15802,
    FileTransferStateMachineType_CurrentState = 15804,
    FileTransferStateMachineType_CurrentState_Id = 15805,
    FileTransferStateMachineType_CurrentState_Name = 15806,
    FileTransferStateMachineType_CurrentState_Number = 15807,
    FileTransferStateMachineType_CurrentState_EffectiveDisplayName = 15808,
    FileTransferStateMachineType_LastTransition = 15809,
    FileTransferStateMachineType_LastTransition_Id = 15810,
    FileTransferStateMachineType_LastTransition_Name = 15811,
    FileTransferStateMachineType_LastTransition_Number = 15812,
    FileTransferStateMachineType_LastTransition_TransitionTime = 15813,
    FileTransferStateMachineType_LastTransition_EffectiveTransitionTime = 15814,
    FileTransferStateMachineType_Idle_StateNumber = 15816,
    FileTransferStateMachineType_ReadPrepare_StateNumber = 15818,
    FileTransferStateMachineType_ReadTransfer_StateNumber = 15820,
    FileTransferStateMachineType_ApplyWrite_StateNumber = 15822,
    FileTransferStateMachineType_Error_StateNumber = 15824,
    FileTransferStateMachineType_IdleToReadPrepare_TransitionNumber = 15826,
    FileTransferStateMachineType_ReadPrepareToReadTransfer_TransitionNumber = 15828,
    FileTransferStateMachineType_ReadTransferToIdle_TransitionNumber = 15830,
    FileTransferStateMachineType_IdleToApplyWrite_TransitionNumber = 15832,
    FileTransferStateMachineType_ApplyWriteToIdle_TransitionNumber = 15834,
    FileTransferStateMachineType_ReadPrepareToError_TransitionNumber = 15836,
    FileTransferStateMachineType_ReadTransferToError_TransitionNumber = 15838,
    FileTransferStateMachineType_ApplyWriteToError_TransitionNumber = 15840,
    FileTransferStateMachineType_ErrorToIdle_TransitionNumber = 15842,
    PublishSubscribeType_Status_State = 15845,
    PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_Selections = 15848,
    PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_SelectionDescriptions = 15849,
    PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_RestrictToList = 15850,
    OpcUa_BinarySchema_WriterGroupTransportDataType_DataTypeVersion = 15852,
    OpcUa_BinarySchema_WriterGroupTransportDataType_DictionaryFragment = 15853,
    OpcUa_BinarySchema_WriterGroupMessageDataType = 15854,
    OpcUa_BinarySchema_WriterGroupMessageDataType_DataTypeVersion = 15855,
    OpcUa_BinarySchema_WriterGroupMessageDataType_DictionaryFragment = 15856,
    OpcUa_BinarySchema_PubSubConnectionDataType = 15857,
    OpcUa_BinarySchema_PubSubConnectionDataType_DataTypeVersion = 15858,
    OpcUa_BinarySchema_PubSubConnectionDataType_DictionaryFragment = 15859,
    OpcUa_BinarySchema_ConnectionTransportDataType = 15860,
    OpcUa_BinarySchema_ConnectionTransportDataType_DataTypeVersion = 15861,
    OpcUa_BinarySchema_ConnectionTransportDataType_DictionaryFragment = 15862,
    PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface = 15863,
    OpcUa_BinarySchema_ReaderGroupTransportDataType = 15866,
    OpcUa_BinarySchema_ReaderGroupTransportDataType_DataTypeVersion = 15867,
    OpcUa_BinarySchema_ReaderGroupTransportDataType_DictionaryFragment = 15868,
    OpcUa_BinarySchema_ReaderGroupMessageDataType = 15869,
    OpcUa_BinarySchema_ReaderGroupMessageDataType_DataTypeVersion = 15870,
    OpcUa_BinarySchema_ReaderGroupMessageDataType_DictionaryFragment = 15871,
    OpcUa_BinarySchema_DataSetReaderDataType = 15872,
    OpcUa_BinarySchema_DataSetReaderDataType_DataTypeVersion = 15873,
    OverrideValueHandling_EnumStrings = 15875,
    OpcUa_BinarySchema_DataSetReaderDataType_DictionaryFragment = 15876,
    OpcUa_BinarySchema_DataSetReaderTransportDataType = 15877,
    OpcUa_BinarySchema_DataSetReaderTransportDataType_DataTypeVersion = 15878,
    OpcUa_BinarySchema_DataSetReaderTransportDataType_DictionaryFragment = 15879,
    OpcUa_BinarySchema_DataSetReaderMessageDataType = 15880,
    OpcUa_BinarySchema_DataSetReaderMessageDataType_DataTypeVersion = 15881,
    OpcUa_BinarySchema_DataSetReaderMessageDataType_DictionaryFragment = 15882,
    OpcUa_BinarySchema_SubscribedDataSetDataType = 15883,
    OpcUa_BinarySchema_SubscribedDataSetDataType_DataTypeVersion = 15884,
    OpcUa_BinarySchema_SubscribedDataSetDataType_DictionaryFragment = 15885,
    OpcUa_BinarySchema_TargetVariablesDataType = 15886,
    OpcUa_BinarySchema_TargetVariablesDataType_DataTypeVersion = 15887,
    OpcUa_BinarySchema_TargetVariablesDataType_DictionaryFragment = 15888,
    OpcUa_BinarySchema_SubscribedDataSetMirrorDataType = 15889,
    OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DataTypeVersion = 15890,
    OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DictionaryFragment = 15891,
    PublishSubscribe_ConnectionName_Placeholder_Status_State = 15892,
    OpcUa_BinarySchema_UadpWriterGroupMessageDataType = 15895,
    OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DataTypeVersion = 15896,
    OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DictionaryFragment = 15897,
    OpcUa_BinarySchema_UadpDataSetWriterMessageDataType = 15898,
    OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DataTypeVersion = 15899,
    OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DictionaryFragment = 15900,
    PubSubKeyServiceType_GetSecurityKeys_InputArguments = 15908,
    PubSubKeyServiceType_GetSecurityKeys_OutputArguments = 15909,
    PubSubKeyServiceType_GetSecurityGroup_InputArguments = 15911,
    PubSubKeyServiceType_GetSecurityGroup_OutputArguments = 15912,
    PubSubKeyServiceType_SecurityGroups_AddSecurityGroup_InputArguments = 15915,
    PubSubKeyServiceType_SecurityGroups_AddSecurityGroup_OutputArguments = 15916,
    PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup_InputArguments = 15918,
    OpcUa_BinarySchema_UadpDataSetReaderMessageDataType = 15919,
    OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DataTypeVersion = 15920,
    OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DictionaryFragment = 15921,
    OpcUa_BinarySchema_JsonWriterGroupMessageDataType = 15922,
    OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DataTypeVersion = 15923,
    OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DictionaryFragment = 15924,
    OpcUa_BinarySchema_JsonDataSetWriterMessageDataType = 15925,
    PubSubGroupType_SecurityMode = 15926,
    PubSubGroupType_SecurityGroupId = 15927,
    PubSubGroupType_SecurityKeyServices = 15928,
    OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DataTypeVersion = 15929,
    OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DictionaryFragment = 15930,
    OpcUa_BinarySchema_JsonDataSetReaderMessageDataType = 15931,
    DataSetReaderType_SecurityMode = 15932,
    DataSetReaderType_SecurityGroupId = 15933,
    DataSetReaderType_SecurityKeyServices = 15934,
    OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DataTypeVersion = 15935,
    OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DictionaryFragment = 15936,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_DiagnosticsLevel = 15938,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation = 15939,
    OpcUa_BinarySchema_BrokerWriterGroupTransportDataType = 15940,
    OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DataTypeVersion = 15941,
    OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DictionaryFragment = 15942,
    OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType = 15943,
    OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DataTypeVersion = 15944,
    OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DictionaryFragment = 15945,
    OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType = 15946,
    OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DataTypeVersion = 15947,
    OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DictionaryFragment = 15948,
    OPCUANamespaceMetadata_NamespaceUri = 15958,
    OPCUANamespaceMetadata_NamespaceVersion = 15959,
    OPCUANamespaceMetadata_NamespacePublicationDate = 15960,
    OPCUANamespaceMetadata_IsNamespaceSubset = 15961,
    OPCUANamespaceMetadata_StaticNodeIdTypes = 15962,
    OPCUANamespaceMetadata_StaticNumericNodeIdRange = 15963,
    OPCUANamespaceMetadata_StaticStringNodeIdPattern = 15964,
    OPCUANamespaceMetadata_NamespaceFile_Size = 15966,
    OPCUANamespaceMetadata_NamespaceFile_Writable = 15967,
    OPCUANamespaceMetadata_NamespaceFile_UserWritable = 15968,
    OPCUANamespaceMetadata_NamespaceFile_OpenCount = 15969,
    OPCUANamespaceMetadata_NamespaceFile_MimeType = 15970,
    OPCUANamespaceMetadata_NamespaceFile_Open_InputArguments = 15972,
    OPCUANamespaceMetadata_NamespaceFile_Open_OutputArguments = 15973,
    OPCUANamespaceMetadata_NamespaceFile_Close_InputArguments = 15975,
    OPCUANamespaceMetadata_NamespaceFile_Read_InputArguments = 15977,
    OPCUANamespaceMetadata_NamespaceFile_Read_OutputArguments = 15978,
    OPCUANamespaceMetadata_NamespaceFile_Write_InputArguments = 15980,
    OPCUANamespaceMetadata_NamespaceFile_GetPosition_InputArguments = 15982,
    OPCUANamespaceMetadata_NamespaceFile_GetPosition_OutputArguments = 15983,
    OPCUANamespaceMetadata_NamespaceFile_SetPosition_InputArguments = 15985,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_Active = 15989,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_Classification = 15994,
    RoleSetType_AddRole_InputArguments = 15998,
    RoleSetType_AddRole_OutputArguments = 15999,
    RoleSetType_RemoveRole_InputArguments = 16001,
    AddRoleMethodType_InputArguments = 16003,
    AddRoleMethodType_OutputArguments = 16004,
    RemoveRoleMethodType_InputArguments = 16006,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        16013,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        16020,
    WellKnownRole_Engineer_AddIdentity_InputArguments = 16042,
    WellKnownRole_Engineer_RemoveIdentity_InputArguments = 16044,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError = 16059,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_Active = 16060,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_Classification = 16061,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel = 16074,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 16075,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_SubError = 16101,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError = 16103,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Active = 16122,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Classification =
        16123,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        16124,
    OpcUa_BinarySchema_RolePermissionType = 16131,
    OpcUa_BinarySchema_RolePermissionType_DataTypeVersion = 16132,
    OpcUa_BinarySchema_RolePermissionType_DictionaryFragment = 16133,
    OPCUANamespaceMetadata_DefaultRolePermissions = 16134,
    OPCUANamespaceMetadata_DefaultUserRolePermissions = 16135,
    OPCUANamespaceMetadata_DefaultAccessRestrictions = 16136,
    NamespaceMetadataType_DefaultRolePermissions = 16137,
    NamespaceMetadataType_DefaultUserRolePermissions = 16138,
    NamespaceMetadataType_DefaultAccessRestrictions = 16139,
    NamespacesType_NamespaceIdentifier_Placeholder_DefaultRolePermissions = 16140,
    NamespacesType_NamespaceIdentifier_Placeholder_DefaultUserRolePermissions = 16141,
    NamespacesType_NamespaceIdentifier_Placeholder_DefaultAccessRestrictions = 16142,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        16160,
    RoleSetType_RoleName_Placeholder_Identities = 16162,
    RoleSetType_RoleName_Placeholder_Applications = 16163,
    RoleSetType_RoleName_Placeholder_Endpoints = 16164,
    RoleSetType_RoleName_Placeholder_AddApplication_InputArguments = 16166,
    RoleSetType_RoleName_Placeholder_RemoveApplication_InputArguments = 16168,
    RoleSetType_RoleName_Placeholder_AddEndpoint_InputArguments = 16170,
    RoleSetType_RoleName_Placeholder_RemoveEndpoint_InputArguments = 16172,
    RoleType_Identities = 16173,
    RoleType_Applications = 16174,
    RoleType_Endpoints = 16175,
    RoleType_AddApplication_InputArguments = 16177,
    RoleType_RemoveApplication_InputArguments = 16179,
    RoleType_AddEndpoint_InputArguments = 16181,
    RoleType_RemoveEndpoint_InputArguments = 16183,
    AddApplicationMethodType_InputArguments = 16185,
    RemoveApplicationMethodType_InputArguments = 16187,
    AddEndpointMethodType_InputArguments = 16189,
    RemoveEndpointMethodType_InputArguments = 16191,
    WellKnownRole_Anonymous_Identities = 16192,
    WellKnownRole_Anonymous_Applications = 16193,
    WellKnownRole_Anonymous_Endpoints = 16194,
    WellKnownRole_Anonymous_AddApplication_InputArguments = 16196,
    WellKnownRole_Anonymous_RemoveApplication_InputArguments = 16198,
    WellKnownRole_Anonymous_AddEndpoint_InputArguments = 16200,
    WellKnownRole_Anonymous_RemoveEndpoint_InputArguments = 16202,
    WellKnownRole_AuthenticatedUser_Identities = 16203,
    WellKnownRole_AuthenticatedUser_Applications = 16204,
    WellKnownRole_AuthenticatedUser_Endpoints = 16205,
    WellKnownRole_AuthenticatedUser_AddApplication_InputArguments = 16207,
    WellKnownRole_AuthenticatedUser_RemoveApplication_InputArguments = 16209,
    WellKnownRole_AuthenticatedUser_AddEndpoint_InputArguments = 16211,
    WellKnownRole_AuthenticatedUser_RemoveEndpoint_InputArguments = 16213,
    WellKnownRole_Observer_Identities = 16214,
    WellKnownRole_Observer_Applications = 16215,
    WellKnownRole_Observer_Endpoints = 16216,
    WellKnownRole_Observer_AddApplication_InputArguments = 16218,
    WellKnownRole_Observer_RemoveApplication_InputArguments = 16220,
    WellKnownRole_Observer_AddEndpoint_InputArguments = 16222,
    WellKnownRole_Observer_RemoveEndpoint_InputArguments = 16224,
    WellKnownRole_Operator_Identities = 16225,
    WellKnownRole_Operator_Applications = 16226,
    WellKnownRole_Operator_Endpoints = 16227,
    WellKnownRole_Operator_AddApplication_InputArguments = 16229,
    WellKnownRole_Operator_RemoveApplication_InputArguments = 16231,
    WellKnownRole_Operator_AddEndpoint_InputArguments = 16233,
    WellKnownRole_Operator_RemoveEndpoint_InputArguments = 16235,
    WellKnownRole_Engineer_Identities = 16236,
    WellKnownRole_Engineer_Applications = 16237,
    WellKnownRole_Engineer_Endpoints = 16238,
    WellKnownRole_Engineer_AddApplication_InputArguments = 16240,
    WellKnownRole_Engineer_RemoveApplication_InputArguments = 16242,
    WellKnownRole_Engineer_AddEndpoint_InputArguments = 16244,
    WellKnownRole_Engineer_RemoveEndpoint_InputArguments = 16246,
    WellKnownRole_Supervisor_Identities = 16247,
    WellKnownRole_Supervisor_Applications = 16248,
    WellKnownRole_Supervisor_Endpoints = 16249,
    WellKnownRole_Supervisor_AddApplication_InputArguments = 16251,
    WellKnownRole_Supervisor_RemoveApplication_InputArguments = 16253,
    WellKnownRole_Supervisor_AddEndpoint_InputArguments = 16255,
    WellKnownRole_Supervisor_RemoveEndpoint_InputArguments = 16257,
    WellKnownRole_SecurityAdmin_Identities = 16258,
    WellKnownRole_SecurityAdmin_Applications = 16259,
    WellKnownRole_SecurityAdmin_Endpoints = 16260,
    WellKnownRole_SecurityAdmin_AddApplication_InputArguments = 16262,
    WellKnownRole_SecurityAdmin_RemoveApplication_InputArguments = 16264,
    WellKnownRole_SecurityAdmin_AddEndpoint_InputArguments = 16266,
    WellKnownRole_SecurityAdmin_RemoveEndpoint_InputArguments = 16268,
    WellKnownRole_ConfigureAdmin_Identities = 16269,
    WellKnownRole_ConfigureAdmin_Applications = 16270,
    WellKnownRole_ConfigureAdmin_Endpoints = 16271,
    WellKnownRole_ConfigureAdmin_AddApplication_InputArguments = 16273,
    WellKnownRole_ConfigureAdmin_RemoveApplication_InputArguments = 16275,
    WellKnownRole_ConfigureAdmin_AddEndpoint_InputArguments = 16277,
    WellKnownRole_ConfigureAdmin_RemoveEndpoint_InputArguments = 16279,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        16283,
    ServerType_ServerCapabilities_RoleSet_AddRole_InputArguments = 16291,
    ServerType_ServerCapabilities_RoleSet_AddRole_OutputArguments = 16292,
    ServerType_ServerCapabilities_RoleSet_RemoveRole_InputArguments = 16294,
    ServerCapabilitiesType_RoleSet_AddRole_InputArguments = 16297,
    ServerCapabilitiesType_RoleSet_AddRole_OutputArguments = 16298,
    ServerCapabilitiesType_RoleSet_RemoveRole_InputArguments = 16300,
    Server_ServerCapabilities_RoleSet_AddRole_InputArguments = 16302,
    Server_ServerCapabilities_RoleSet_AddRole_OutputArguments = 16303,
    Server_ServerCapabilities_RoleSet_RemoveRole_InputArguments = 16305,
    SelectionListType_RestrictToList = 16312,
    FileSystem_FileDirectoryName_Placeholder_CreateDirectory_InputArguments = 16317,
    FileSystem_FileDirectoryName_Placeholder_CreateDirectory_OutputArguments = 16318,
    FileSystem_FileDirectoryName_Placeholder_CreateFile_InputArguments = 16320,
    FileSystem_FileDirectoryName_Placeholder_CreateFile_OutputArguments = 16321,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        16322,
    FileSystem_FileDirectoryName_Placeholder_MoveOrCopy_InputArguments = 16325,
    FileSystem_FileDirectoryName_Placeholder_MoveOrCopy_OutputArguments = 16326,
    FileSystem_FileName_Placeholder_Size = 16328,
    FileSystem_FileName_Placeholder_Writable = 16329,
    FileSystem_FileName_Placeholder_UserWritable = 16330,
    FileSystem_FileName_Placeholder_OpenCount = 16331,
    FileSystem_FileName_Placeholder_MimeType = 16332,
    FileSystem_FileName_Placeholder_Open_InputArguments = 16334,
    FileSystem_FileName_Placeholder_Open_OutputArguments = 16335,
    FileSystem_FileName_Placeholder_Close_InputArguments = 16337,
    FileSystem_FileName_Placeholder_Read_InputArguments = 16339,
    FileSystem_FileName_Placeholder_Read_OutputArguments = 16340,
    FileSystem_FileName_Placeholder_Write_InputArguments = 16342,
    FileSystem_FileName_Placeholder_GetPosition_InputArguments = 16344,
    FileSystem_FileName_Placeholder_GetPosition_OutputArguments = 16345,
    FileSystem_FileName_Placeholder_SetPosition_InputArguments = 16347,
    FileSystem_CreateDirectory_InputArguments = 16349,
    FileSystem_CreateDirectory_OutputArguments = 16350,
    FileSystem_CreateFile_InputArguments = 16352,
    FileSystem_CreateFile_OutputArguments = 16353,
    FileSystem_DeleteFileSystemObject_InputArguments = 16355,
    FileSystem_MoveOrCopy_InputArguments = 16357,
    FileSystem_MoveOrCopy_OutputArguments = 16358,
    TemporaryFileTransferType_GenerateFileForWrite_InputArguments = 16359,
    GenerateFileForWriteMethodType_InputArguments = 16360,
    ConditionType_ConditionSubClassId = 16363,
    ConditionType_ConditionSubClassName = 16364,
    DialogConditionType_ConditionSubClassId = 16365,
    DialogConditionType_ConditionSubClassName = 16366,
    AcknowledgeableConditionType_ConditionSubClassId = 16367,
    AcknowledgeableConditionType_ConditionSubClassName = 16368,
    AlarmConditionType_ConditionSubClassId = 16369,
    AlarmConditionType_ConditionSubClassName = 16370,
    AlarmConditionType_OutOfServiceState = 16371,
    AlarmConditionType_OutOfServiceState_Id = 16372,
    AlarmConditionType_OutOfServiceState_Name = 16373,
    AlarmConditionType_OutOfServiceState_Number = 16374,
    AlarmConditionType_OutOfServiceState_EffectiveDisplayName = 16375,
    AlarmConditionType_OutOfServiceState_TransitionTime = 16376,
    AlarmConditionType_OutOfServiceState_EffectiveTransitionTime = 16377,
    AlarmConditionType_OutOfServiceState_TrueState = 16378,
    AlarmConditionType_OutOfServiceState_FalseState = 16379,
    AlarmConditionType_SilenceState = 16380,
    AlarmConditionType_SilenceState_Id = 16381,
    AlarmConditionType_SilenceState_Name = 16382,
    AlarmConditionType_SilenceState_Number = 16383,
    AlarmConditionType_SilenceState_EffectiveDisplayName = 16384,
    AlarmConditionType_SilenceState_TransitionTime = 16385,
    AlarmConditionType_SilenceState_EffectiveTransitionTime = 16386,
    AlarmConditionType_SilenceState_TrueState = 16387,
    AlarmConditionType_SilenceState_FalseState = 16388,
    AlarmConditionType_AudibleEnabled = 16389,
    AlarmConditionType_AudibleSound = 16390,
    AlarmConditionType_OnDelay = 16395,
    AlarmConditionType_OffDelay = 16396,
    AlarmConditionType_FirstInGroupFlag = 16397,
    AlarmConditionType_ReAlarmTime = 16400,
    AlarmConditionType_ReAlarmRepeatCount = 16401,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EventId = 16407,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EventType = 16408,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SourceNode = 16409,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SourceName = 16410,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Time = 16411,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ReceiveTime = 16412,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LocalTime = 16413,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Message = 16414,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Severity = 16415,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionClassId = 16416,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionClassName = 16417,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionSubClassId = 16418,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionSubClassName = 16419,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionName = 16420,
    AlarmGroupType_AlarmConditionInstance_Placeholder_BranchId = 16421,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Retain = 16422,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState = 16423,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Id = 16424,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Name = 16425,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Number = 16426,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_EffectiveDisplayName = 16427,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_TransitionTime = 16428,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_EffectiveTransitionTime = 16429,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_TrueState = 16430,
    AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_FalseState = 16431,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Quality = 16432,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Quality_SourceTimestamp = 16433,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LastSeverity = 16434,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LastSeverity_SourceTimestamp = 16435,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Comment = 16436,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Comment_SourceTimestamp = 16437,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ClientUserId = 16438,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AddComment_InputArguments = 16442,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState = 16443,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Id = 16444,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Name = 16445,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Number = 16446,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_EffectiveDisplayName = 16447,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_TransitionTime = 16448,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_EffectiveTransitionTime = 16449,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_TrueState = 16450,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_FalseState = 16451,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState = 16452,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Id = 16453,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Name = 16454,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Number = 16455,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_EffectiveDisplayName = 16456,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_TransitionTime = 16457,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_EffectiveTransitionTime =
        16458,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_TrueState = 16459,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_FalseState = 16460,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Acknowledge_InputArguments = 16462,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Confirm_InputArguments = 16464,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState = 16465,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Id = 16466,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Name = 16467,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Number = 16468,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_EffectiveDisplayName = 16469,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_TransitionTime = 16470,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_EffectiveTransitionTime = 16471,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_TrueState = 16472,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_FalseState = 16473,
    AlarmGroupType_AlarmConditionInstance_Placeholder_InputNode = 16474,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState = 16475,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Id = 16476,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Name = 16477,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Number = 16478,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_EffectiveDisplayName = 16479,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_TransitionTime = 16480,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_EffectiveTransitionTime =
        16481,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_TrueState = 16482,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_FalseState = 16483,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState = 16484,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Id = 16485,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Name = 16486,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Number = 16487,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_EffectiveDisplayName =
        16488,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_TransitionTime = 16489,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_EffectiveTransitionTime =
        16490,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_TrueState = 16491,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_FalseState = 16492,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState = 16493,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Id = 16494,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Name = 16495,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Number = 16496,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_EffectiveDisplayName = 16497,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_TransitionTime = 16498,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_EffectiveTransitionTime = 16499,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_TrueState = 16500,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_FalseState = 16501,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState = 16503,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Id = 16504,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Name = 16505,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Number = 16506,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_EffectiveDisplayName =
        16507,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition = 16508,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Id = 16509,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Name = 16510,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Number = 16511,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_TransitionTime =
        16512,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_EffectiveTransitionTime =
        16513,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_UnshelveTime = 16514,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_TimedShelve_InputArguments =
        16518,
    AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedOrShelved = 16519,
    AlarmGroupType_AlarmConditionInstance_Placeholder_MaxTimeShelved = 16520,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleEnabled = 16521,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound = 16522,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        16523,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OnDelay = 16527,
    AlarmGroupType_AlarmConditionInstance_Placeholder_OffDelay = 16528,
    AlarmGroupType_AlarmConditionInstance_Placeholder_FirstInGroupFlag = 16529,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ReAlarmTime = 16531,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ReAlarmRepeatCount = 16532,
    LimitAlarmType_ConditionSubClassId = 16536,
    LimitAlarmType_ConditionSubClassName = 16537,
    LimitAlarmType_OutOfServiceState = 16538,
    LimitAlarmType_OutOfServiceState_Id = 16539,
    LimitAlarmType_OutOfServiceState_Name = 16540,
    LimitAlarmType_OutOfServiceState_Number = 16541,
    LimitAlarmType_OutOfServiceState_EffectiveDisplayName = 16542,
    LimitAlarmType_OutOfServiceState_TransitionTime = 16543,
    LimitAlarmType_OutOfServiceState_EffectiveTransitionTime = 16544,
    LimitAlarmType_OutOfServiceState_TrueState = 16545,
    LimitAlarmType_OutOfServiceState_FalseState = 16546,
    LimitAlarmType_SilenceState = 16547,
    LimitAlarmType_SilenceState_Id = 16548,
    LimitAlarmType_SilenceState_Name = 16549,
    LimitAlarmType_SilenceState_Number = 16550,
    LimitAlarmType_SilenceState_EffectiveDisplayName = 16551,
    LimitAlarmType_SilenceState_TransitionTime = 16552,
    LimitAlarmType_SilenceState_EffectiveTransitionTime = 16553,
    LimitAlarmType_SilenceState_TrueState = 16554,
    LimitAlarmType_SilenceState_FalseState = 16555,
    LimitAlarmType_AudibleEnabled = 16556,
    LimitAlarmType_AudibleSound = 16557,
    PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup_InputArguments = 16558,
    PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup_OutputArguments = 16559,
    PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup_InputArguments = 16561,
    LimitAlarmType_OnDelay = 16562,
    LimitAlarmType_OffDelay = 16563,
    LimitAlarmType_FirstInGroupFlag = 16564,
    LimitAlarmType_ReAlarmTime = 16567,
    LimitAlarmType_ReAlarmRepeatCount = 16568,
    PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup_OutputArguments = 16571,
    LimitAlarmType_BaseHighHighLimit = 16572,
    LimitAlarmType_BaseHighLimit = 16573,
    LimitAlarmType_BaseLowLimit = 16574,
    LimitAlarmType_BaseLowLowLimit = 16575,
    ExclusiveLimitAlarmType_ConditionSubClassId = 16576,
    ExclusiveLimitAlarmType_ConditionSubClassName = 16577,
    ExclusiveLimitAlarmType_OutOfServiceState = 16578,
    ExclusiveLimitAlarmType_OutOfServiceState_Id = 16579,
    ExclusiveLimitAlarmType_OutOfServiceState_Name = 16580,
    ExclusiveLimitAlarmType_OutOfServiceState_Number = 16581,
    ExclusiveLimitAlarmType_OutOfServiceState_EffectiveDisplayName = 16582,
    ExclusiveLimitAlarmType_OutOfServiceState_TransitionTime = 16583,
    ExclusiveLimitAlarmType_OutOfServiceState_EffectiveTransitionTime = 16584,
    ExclusiveLimitAlarmType_OutOfServiceState_TrueState = 16585,
    ExclusiveLimitAlarmType_OutOfServiceState_FalseState = 16586,
    ExclusiveLimitAlarmType_SilenceState = 16587,
    ExclusiveLimitAlarmType_SilenceState_Id = 16588,
    ExclusiveLimitAlarmType_SilenceState_Name = 16589,
    ExclusiveLimitAlarmType_SilenceState_Number = 16590,
    ExclusiveLimitAlarmType_SilenceState_EffectiveDisplayName = 16591,
    ExclusiveLimitAlarmType_SilenceState_TransitionTime = 16592,
    ExclusiveLimitAlarmType_SilenceState_EffectiveTransitionTime = 16593,
    ExclusiveLimitAlarmType_SilenceState_TrueState = 16594,
    ExclusiveLimitAlarmType_SilenceState_FalseState = 16595,
    ExclusiveLimitAlarmType_AudibleEnabled = 16596,
    ExclusiveLimitAlarmType_AudibleSound = 16597,
    PublishSubscribeType_AddConnection_InputArguments = 16599,
    PublishSubscribeType_AddConnection_OutputArguments = 16600,
    ExclusiveLimitAlarmType_OnDelay = 16602,
    ExclusiveLimitAlarmType_OffDelay = 16603,
    ExclusiveLimitAlarmType_FirstInGroupFlag = 16604,
    ExclusiveLimitAlarmType_ReAlarmTime = 16607,
    ExclusiveLimitAlarmType_ReAlarmRepeatCount = 16608,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments = 16611,
    ExclusiveLimitAlarmType_BaseHighHighLimit = 16612,
    ExclusiveLimitAlarmType_BaseHighLimit = 16613,
    ExclusiveLimitAlarmType_BaseLowLimit = 16614,
    ExclusiveLimitAlarmType_BaseLowLowLimit = 16615,
    NonExclusiveLimitAlarmType_ConditionSubClassId = 16616,
    NonExclusiveLimitAlarmType_ConditionSubClassName = 16617,
    NonExclusiveLimitAlarmType_OutOfServiceState = 16618,
    NonExclusiveLimitAlarmType_OutOfServiceState_Id = 16619,
    NonExclusiveLimitAlarmType_OutOfServiceState_Name = 16620,
    NonExclusiveLimitAlarmType_OutOfServiceState_Number = 16621,
    NonExclusiveLimitAlarmType_OutOfServiceState_EffectiveDisplayName = 16622,
    NonExclusiveLimitAlarmType_OutOfServiceState_TransitionTime = 16623,
    NonExclusiveLimitAlarmType_OutOfServiceState_EffectiveTransitionTime = 16624,
    NonExclusiveLimitAlarmType_OutOfServiceState_TrueState = 16625,
    NonExclusiveLimitAlarmType_OutOfServiceState_FalseState = 16626,
    NonExclusiveLimitAlarmType_SilenceState = 16627,
    NonExclusiveLimitAlarmType_SilenceState_Id = 16628,
    NonExclusiveLimitAlarmType_SilenceState_Name = 16629,
    NonExclusiveLimitAlarmType_SilenceState_Number = 16630,
    NonExclusiveLimitAlarmType_SilenceState_EffectiveDisplayName = 16631,
    NonExclusiveLimitAlarmType_SilenceState_TransitionTime = 16632,
    NonExclusiveLimitAlarmType_SilenceState_EffectiveTransitionTime = 16633,
    NonExclusiveLimitAlarmType_SilenceState_TrueState = 16634,
    NonExclusiveLimitAlarmType_SilenceState_FalseState = 16635,
    NonExclusiveLimitAlarmType_AudibleEnabled = 16636,
    NonExclusiveLimitAlarmType_AudibleSound = 16637,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments = 16638,
    PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate_InputArguments = 16640,
    PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments = 16641,
    NonExclusiveLimitAlarmType_OnDelay = 16642,
    NonExclusiveLimitAlarmType_OffDelay = 16643,
    NonExclusiveLimitAlarmType_FirstInGroupFlag = 16644,
    NonExclusiveLimitAlarmType_ReAlarmTime = 16647,
    NonExclusiveLimitAlarmType_ReAlarmRepeatCount = 16648,
    NonExclusiveLimitAlarmType_BaseHighHighLimit = 16652,
    NonExclusiveLimitAlarmType_BaseHighLimit = 16653,
    NonExclusiveLimitAlarmType_BaseLowLimit = 16654,
    NonExclusiveLimitAlarmType_BaseLowLowLimit = 16655,
    NonExclusiveLevelAlarmType_ConditionSubClassId = 16656,
    NonExclusiveLevelAlarmType_ConditionSubClassName = 16657,
    NonExclusiveLevelAlarmType_OutOfServiceState = 16658,
    NonExclusiveLevelAlarmType_OutOfServiceState_Id = 16659,
    NonExclusiveLevelAlarmType_OutOfServiceState_Name = 16660,
    NonExclusiveLevelAlarmType_OutOfServiceState_Number = 16661,
    NonExclusiveLevelAlarmType_OutOfServiceState_EffectiveDisplayName = 16662,
    NonExclusiveLevelAlarmType_OutOfServiceState_TransitionTime = 16663,
    NonExclusiveLevelAlarmType_OutOfServiceState_EffectiveTransitionTime = 16664,
    NonExclusiveLevelAlarmType_OutOfServiceState_TrueState = 16665,
    NonExclusiveLevelAlarmType_OutOfServiceState_FalseState = 16666,
    NonExclusiveLevelAlarmType_SilenceState = 16667,
    NonExclusiveLevelAlarmType_SilenceState_Id = 16668,
    NonExclusiveLevelAlarmType_SilenceState_Name = 16669,
    NonExclusiveLevelAlarmType_SilenceState_Number = 16670,
    NonExclusiveLevelAlarmType_SilenceState_EffectiveDisplayName = 16671,
    NonExclusiveLevelAlarmType_SilenceState_TransitionTime = 16672,
    NonExclusiveLevelAlarmType_SilenceState_EffectiveTransitionTime = 16673,
    NonExclusiveLevelAlarmType_SilenceState_TrueState = 16674,
    NonExclusiveLevelAlarmType_SilenceState_FalseState = 16675,
    NonExclusiveLevelAlarmType_AudibleEnabled = 16676,
    NonExclusiveLevelAlarmType_AudibleSound = 16677,
    PublishSubscribeType_PublishedDataSets_AddDataSetFolder_InputArguments = 16678,
    PublishSubscribeType_PublishedDataSets_AddDataSetFolder_OutputArguments = 16679,
    PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder_InputArguments = 16681,
    NonExclusiveLevelAlarmType_OnDelay = 16682,
    NonExclusiveLevelAlarmType_OffDelay = 16683,
    NonExclusiveLevelAlarmType_FirstInGroupFlag = 16684,
    NonExclusiveLevelAlarmType_ReAlarmTime = 16687,
    NonExclusiveLevelAlarmType_ReAlarmRepeatCount = 16688,
    NonExclusiveLevelAlarmType_BaseHighHighLimit = 16692,
    NonExclusiveLevelAlarmType_BaseHighLimit = 16693,
    NonExclusiveLevelAlarmType_BaseLowLimit = 16694,
    NonExclusiveLevelAlarmType_BaseLowLowLimit = 16695,
    ExclusiveLevelAlarmType_ConditionSubClassId = 16696,
    ExclusiveLevelAlarmType_ConditionSubClassName = 16697,
    ExclusiveLevelAlarmType_OutOfServiceState = 16698,
    ExclusiveLevelAlarmType_OutOfServiceState_Id = 16699,
    ExclusiveLevelAlarmType_OutOfServiceState_Name = 16700,
    ExclusiveLevelAlarmType_OutOfServiceState_Number = 16701,
    ExclusiveLevelAlarmType_OutOfServiceState_EffectiveDisplayName = 16702,
    ExclusiveLevelAlarmType_OutOfServiceState_TransitionTime = 16703,
    ExclusiveLevelAlarmType_OutOfServiceState_EffectiveTransitionTime = 16704,
    ExclusiveLevelAlarmType_OutOfServiceState_TrueState = 16705,
    ExclusiveLevelAlarmType_OutOfServiceState_FalseState = 16706,
    ExclusiveLevelAlarmType_SilenceState = 16707,
    ExclusiveLevelAlarmType_SilenceState_Id = 16708,
    ExclusiveLevelAlarmType_SilenceState_Name = 16709,
    ExclusiveLevelAlarmType_SilenceState_Number = 16710,
    ExclusiveLevelAlarmType_SilenceState_EffectiveDisplayName = 16711,
    ExclusiveLevelAlarmType_SilenceState_TransitionTime = 16712,
    ExclusiveLevelAlarmType_SilenceState_EffectiveTransitionTime = 16713,
    ExclusiveLevelAlarmType_SilenceState_TrueState = 16714,
    ExclusiveLevelAlarmType_SilenceState_FalseState = 16715,
    ExclusiveLevelAlarmType_AudibleEnabled = 16716,
    ExclusiveLevelAlarmType_AudibleSound = 16717,
    AddConnectionMethodType_InputArguments = 16718,
    AddConnectionMethodType_OutputArguments = 16719,
    PublishedDataSetType_DataSetWriterName_Placeholder_DataSetWriterId = 16720,
    PublishedDataSetType_DataSetWriterName_Placeholder_DataSetFieldContentMask = 16721,
    ExclusiveLevelAlarmType_OnDelay = 16722,
    ExclusiveLevelAlarmType_OffDelay = 16723,
    ExclusiveLevelAlarmType_FirstInGroupFlag = 16724,
    ExclusiveLevelAlarmType_ReAlarmTime = 16727,
    ExclusiveLevelAlarmType_ReAlarmRepeatCount = 16728,
    PublishedDataSetType_DataSetWriterName_Placeholder_KeyFrameCount = 16731,
    ExclusiveLevelAlarmType_BaseHighHighLimit = 16732,
    ExclusiveLevelAlarmType_BaseHighLimit = 16733,
    ExclusiveLevelAlarmType_BaseLowLimit = 16734,
    ExclusiveLevelAlarmType_BaseLowLowLimit = 16735,
    NonExclusiveDeviationAlarmType_ConditionSubClassId = 16736,
    NonExclusiveDeviationAlarmType_ConditionSubClassName = 16737,
    NonExclusiveDeviationAlarmType_OutOfServiceState = 16738,
    NonExclusiveDeviationAlarmType_OutOfServiceState_Id = 16739,
    NonExclusiveDeviationAlarmType_OutOfServiceState_Name = 16740,
    NonExclusiveDeviationAlarmType_OutOfServiceState_Number = 16741,
    NonExclusiveDeviationAlarmType_OutOfServiceState_EffectiveDisplayName = 16742,
    NonExclusiveDeviationAlarmType_OutOfServiceState_TransitionTime = 16743,
    NonExclusiveDeviationAlarmType_OutOfServiceState_EffectiveTransitionTime = 16744,
    NonExclusiveDeviationAlarmType_OutOfServiceState_TrueState = 16745,
    NonExclusiveDeviationAlarmType_OutOfServiceState_FalseState = 16746,
    NonExclusiveDeviationAlarmType_SilenceState = 16747,
    NonExclusiveDeviationAlarmType_SilenceState_Id = 16748,
    NonExclusiveDeviationAlarmType_SilenceState_Name = 16749,
    NonExclusiveDeviationAlarmType_SilenceState_Number = 16750,
    NonExclusiveDeviationAlarmType_SilenceState_EffectiveDisplayName = 16751,
    NonExclusiveDeviationAlarmType_SilenceState_TransitionTime = 16752,
    NonExclusiveDeviationAlarmType_SilenceState_EffectiveTransitionTime = 16753,
    NonExclusiveDeviationAlarmType_SilenceState_TrueState = 16754,
    NonExclusiveDeviationAlarmType_SilenceState_FalseState = 16755,
    NonExclusiveDeviationAlarmType_AudibleEnabled = 16756,
    NonExclusiveDeviationAlarmType_AudibleSound = 16757,
    PublishedDataSetType_DataSetClassId = 16759,
    PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetWriterId = 16760,
    PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetFieldContentMask = 16761,
    NonExclusiveDeviationAlarmType_OnDelay = 16762,
    NonExclusiveDeviationAlarmType_OffDelay = 16763,
    NonExclusiveDeviationAlarmType_FirstInGroupFlag = 16764,
    NonExclusiveDeviationAlarmType_ReAlarmTime = 16767,
    NonExclusiveDeviationAlarmType_ReAlarmRepeatCount = 16768,
    PublishedDataItemsType_DataSetWriterName_Placeholder_KeyFrameCount = 16771,
    NonExclusiveDeviationAlarmType_BaseHighHighLimit = 16772,
    NonExclusiveDeviationAlarmType_BaseHighLimit = 16773,
    NonExclusiveDeviationAlarmType_BaseLowLimit = 16774,
    NonExclusiveDeviationAlarmType_BaseLowLowLimit = 16775,
    NonExclusiveDeviationAlarmType_BaseSetpointNode = 16776,
    ExclusiveDeviationAlarmType_ConditionSubClassId = 16777,
    ExclusiveDeviationAlarmType_ConditionSubClassName = 16778,
    ExclusiveDeviationAlarmType_OutOfServiceState = 16779,
    ExclusiveDeviationAlarmType_OutOfServiceState_Id = 16780,
    ExclusiveDeviationAlarmType_OutOfServiceState_Name = 16781,
    ExclusiveDeviationAlarmType_OutOfServiceState_Number = 16782,
    ExclusiveDeviationAlarmType_OutOfServiceState_EffectiveDisplayName = 16783,
    ExclusiveDeviationAlarmType_OutOfServiceState_TransitionTime = 16784,
    ExclusiveDeviationAlarmType_OutOfServiceState_EffectiveTransitionTime = 16785,
    ExclusiveDeviationAlarmType_OutOfServiceState_TrueState = 16786,
    ExclusiveDeviationAlarmType_OutOfServiceState_FalseState = 16787,
    ExclusiveDeviationAlarmType_SilenceState = 16788,
    ExclusiveDeviationAlarmType_SilenceState_Id = 16789,
    ExclusiveDeviationAlarmType_SilenceState_Name = 16790,
    ExclusiveDeviationAlarmType_SilenceState_Number = 16791,
    ExclusiveDeviationAlarmType_SilenceState_EffectiveDisplayName = 16792,
    ExclusiveDeviationAlarmType_SilenceState_TransitionTime = 16793,
    ExclusiveDeviationAlarmType_SilenceState_EffectiveTransitionTime = 16794,
    ExclusiveDeviationAlarmType_SilenceState_TrueState = 16795,
    ExclusiveDeviationAlarmType_SilenceState_FalseState = 16796,
    ExclusiveDeviationAlarmType_AudibleEnabled = 16797,
    ExclusiveDeviationAlarmType_AudibleSound = 16798,
    PublishedDataItemsType_DataSetClassId = 16800,
    PublishedEventsType_DataSetWriterName_Placeholder_DataSetWriterId = 16801,
    PublishedEventsType_DataSetWriterName_Placeholder_DataSetFieldContentMask = 16802,
    ExclusiveDeviationAlarmType_OnDelay = 16803,
    ExclusiveDeviationAlarmType_OffDelay = 16804,
    ExclusiveDeviationAlarmType_FirstInGroupFlag = 16805,
    ExclusiveDeviationAlarmType_ReAlarmTime = 16808,
    ExclusiveDeviationAlarmType_ReAlarmRepeatCount = 16809,
    PublishedEventsType_DataSetWriterName_Placeholder_KeyFrameCount = 16812,
    ExclusiveDeviationAlarmType_BaseHighHighLimit = 16813,
    ExclusiveDeviationAlarmType_BaseHighLimit = 16814,
    ExclusiveDeviationAlarmType_BaseLowLimit = 16815,
    ExclusiveDeviationAlarmType_BaseLowLowLimit = 16816,
    ExclusiveDeviationAlarmType_BaseSetpointNode = 16817,
    NonExclusiveRateOfChangeAlarmType_ConditionSubClassId = 16818,
    NonExclusiveRateOfChangeAlarmType_ConditionSubClassName = 16819,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState = 16820,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Id = 16821,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Name = 16822,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Number = 16823,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveDisplayName = 16824,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_TransitionTime = 16825,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveTransitionTime = 16826,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_TrueState = 16827,
    NonExclusiveRateOfChangeAlarmType_OutOfServiceState_FalseState = 16828,
    NonExclusiveRateOfChangeAlarmType_SilenceState = 16829,
    NonExclusiveRateOfChangeAlarmType_SilenceState_Id = 16830,
    NonExclusiveRateOfChangeAlarmType_SilenceState_Name = 16831,
    NonExclusiveRateOfChangeAlarmType_SilenceState_Number = 16832,
    NonExclusiveRateOfChangeAlarmType_SilenceState_EffectiveDisplayName = 16833,
    NonExclusiveRateOfChangeAlarmType_SilenceState_TransitionTime = 16834,
    NonExclusiveRateOfChangeAlarmType_SilenceState_EffectiveTransitionTime = 16835,
    NonExclusiveRateOfChangeAlarmType_SilenceState_TrueState = 16836,
    NonExclusiveRateOfChangeAlarmType_SilenceState_FalseState = 16837,
    NonExclusiveRateOfChangeAlarmType_AudibleEnabled = 16838,
    NonExclusiveRateOfChangeAlarmType_AudibleSound = 16839,
    PublishedEventsType_DataSetClassId = 16841,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate_InputArguments =
        16843,
    NonExclusiveRateOfChangeAlarmType_OnDelay = 16844,
    NonExclusiveRateOfChangeAlarmType_OffDelay = 16845,
    NonExclusiveRateOfChangeAlarmType_FirstInGroupFlag = 16846,
    NonExclusiveRateOfChangeAlarmType_ReAlarmTime = 16849,
    NonExclusiveRateOfChangeAlarmType_ReAlarmRepeatCount = 16850,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate_OutputArguments =
        16853,
    NonExclusiveRateOfChangeAlarmType_BaseHighHighLimit = 16854,
    NonExclusiveRateOfChangeAlarmType_BaseHighLimit = 16855,
    NonExclusiveRateOfChangeAlarmType_BaseLowLimit = 16856,
    NonExclusiveRateOfChangeAlarmType_BaseLowLowLimit = 16857,
    NonExclusiveRateOfChangeAlarmType_EngineeringUnits = 16858,
    ExclusiveRateOfChangeAlarmType_ConditionSubClassId = 16859,
    ExclusiveRateOfChangeAlarmType_ConditionSubClassName = 16860,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState = 16861,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_Id = 16862,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_Name = 16863,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_Number = 16864,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveDisplayName = 16865,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_TransitionTime = 16866,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveTransitionTime = 16867,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_TrueState = 16868,
    ExclusiveRateOfChangeAlarmType_OutOfServiceState_FalseState = 16869,
    ExclusiveRateOfChangeAlarmType_SilenceState = 16870,
    ExclusiveRateOfChangeAlarmType_SilenceState_Id = 16871,
    ExclusiveRateOfChangeAlarmType_SilenceState_Name = 16872,
    ExclusiveRateOfChangeAlarmType_SilenceState_Number = 16873,
    ExclusiveRateOfChangeAlarmType_SilenceState_EffectiveDisplayName = 16874,
    ExclusiveRateOfChangeAlarmType_SilenceState_TransitionTime = 16875,
    ExclusiveRateOfChangeAlarmType_SilenceState_EffectiveTransitionTime = 16876,
    ExclusiveRateOfChangeAlarmType_SilenceState_TrueState = 16877,
    ExclusiveRateOfChangeAlarmType_SilenceState_FalseState = 16878,
    ExclusiveRateOfChangeAlarmType_AudibleEnabled = 16879,
    ExclusiveRateOfChangeAlarmType_AudibleSound = 16880,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate_InputArguments =
        16882,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate_OutputArguments =
        16883,
    ExclusiveRateOfChangeAlarmType_OnDelay = 16885,
    ExclusiveRateOfChangeAlarmType_OffDelay = 16886,
    ExclusiveRateOfChangeAlarmType_FirstInGroupFlag = 16887,
    ExclusiveRateOfChangeAlarmType_ReAlarmTime = 16890,
    ExclusiveRateOfChangeAlarmType_ReAlarmRepeatCount = 16891,
    DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder_InputArguments = 16894,
    ExclusiveRateOfChangeAlarmType_BaseHighHighLimit = 16895,
    ExclusiveRateOfChangeAlarmType_BaseHighLimit = 16896,
    ExclusiveRateOfChangeAlarmType_BaseLowLimit = 16897,
    ExclusiveRateOfChangeAlarmType_BaseLowLowLimit = 16898,
    ExclusiveRateOfChangeAlarmType_EngineeringUnits = 16899,
    DiscreteAlarmType_ConditionSubClassId = 16900,
    DiscreteAlarmType_ConditionSubClassName = 16901,
    DiscreteAlarmType_OutOfServiceState = 16902,
    DiscreteAlarmType_OutOfServiceState_Id = 16903,
    DiscreteAlarmType_OutOfServiceState_Name = 16904,
    DiscreteAlarmType_OutOfServiceState_Number = 16905,
    DiscreteAlarmType_OutOfServiceState_EffectiveDisplayName = 16906,
    DiscreteAlarmType_OutOfServiceState_TransitionTime = 16907,
    DiscreteAlarmType_OutOfServiceState_EffectiveTransitionTime = 16908,
    DiscreteAlarmType_OutOfServiceState_TrueState = 16909,
    DiscreteAlarmType_OutOfServiceState_FalseState = 16910,
    DiscreteAlarmType_SilenceState = 16911,
    DiscreteAlarmType_SilenceState_Id = 16912,
    DiscreteAlarmType_SilenceState_Name = 16913,
    DiscreteAlarmType_SilenceState_Number = 16914,
    DiscreteAlarmType_SilenceState_EffectiveDisplayName = 16915,
    DiscreteAlarmType_SilenceState_TransitionTime = 16916,
    DiscreteAlarmType_SilenceState_EffectiveTransitionTime = 16917,
    DiscreteAlarmType_SilenceState_TrueState = 16918,
    DiscreteAlarmType_SilenceState_FalseState = 16919,
    DiscreteAlarmType_AudibleEnabled = 16920,
    DiscreteAlarmType_AudibleSound = 16921,
    DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder_OutputArguments = 16922,
    DataSetFolderType_DataSetFolderName_Placeholder_RemoveDataSetFolder_InputArguments = 16924,
    DataSetFolderType_PublishedDataSetName_Placeholder_DataSetClassId = 16925,
    DiscreteAlarmType_OnDelay = 16926,
    DiscreteAlarmType_OffDelay = 16927,
    DiscreteAlarmType_FirstInGroupFlag = 16928,
    DiscreteAlarmType_ReAlarmTime = 16931,
    DiscreteAlarmType_ReAlarmRepeatCount = 16932,
    OffNormalAlarmType_ConditionSubClassId = 16936,
    OffNormalAlarmType_ConditionSubClassName = 16937,
    OffNormalAlarmType_OutOfServiceState = 16938,
    OffNormalAlarmType_OutOfServiceState_Id = 16939,
    OffNormalAlarmType_OutOfServiceState_Name = 16940,
    OffNormalAlarmType_OutOfServiceState_Number = 16941,
    OffNormalAlarmType_OutOfServiceState_EffectiveDisplayName = 16942,
    OffNormalAlarmType_OutOfServiceState_TransitionTime = 16943,
    OffNormalAlarmType_OutOfServiceState_EffectiveTransitionTime = 16944,
    OffNormalAlarmType_OutOfServiceState_TrueState = 16945,
    OffNormalAlarmType_OutOfServiceState_FalseState = 16946,
    OffNormalAlarmType_SilenceState = 16947,
    OffNormalAlarmType_SilenceState_Id = 16948,
    OffNormalAlarmType_SilenceState_Name = 16949,
    OffNormalAlarmType_SilenceState_Number = 16950,
    OffNormalAlarmType_SilenceState_EffectiveDisplayName = 16951,
    OffNormalAlarmType_SilenceState_TransitionTime = 16952,
    OffNormalAlarmType_SilenceState_EffectiveTransitionTime = 16953,
    OffNormalAlarmType_SilenceState_TrueState = 16954,
    OffNormalAlarmType_SilenceState_FalseState = 16955,
    OffNormalAlarmType_AudibleEnabled = 16956,
    OffNormalAlarmType_AudibleSound = 16957,
    DataSetFolderType_AddPublishedDataItemsTemplate_InputArguments = 16958,
    DataSetFolderType_AddPublishedDataItemsTemplate_OutputArguments = 16959,
    DataSetFolderType_AddPublishedEventsTemplate_InputArguments = 16961,
    OffNormalAlarmType_OnDelay = 16962,
    OffNormalAlarmType_OffDelay = 16963,
    OffNormalAlarmType_FirstInGroupFlag = 16964,
    OffNormalAlarmType_ReAlarmTime = 16967,
    OffNormalAlarmType_ReAlarmRepeatCount = 16968,
    DataSetFolderType_AddPublishedEventsTemplate_OutputArguments = 16971,
    SystemOffNormalAlarmType_ConditionSubClassId = 16972,
    SystemOffNormalAlarmType_ConditionSubClassName = 16973,
    SystemOffNormalAlarmType_OutOfServiceState = 16974,
    SystemOffNormalAlarmType_OutOfServiceState_Id = 16975,
    SystemOffNormalAlarmType_OutOfServiceState_Name = 16976,
    SystemOffNormalAlarmType_OutOfServiceState_Number = 16977,
    SystemOffNormalAlarmType_OutOfServiceState_EffectiveDisplayName = 16978,
    SystemOffNormalAlarmType_OutOfServiceState_TransitionTime = 16979,
    SystemOffNormalAlarmType_OutOfServiceState_EffectiveTransitionTime = 16980,
    SystemOffNormalAlarmType_OutOfServiceState_TrueState = 16981,
    SystemOffNormalAlarmType_OutOfServiceState_FalseState = 16982,
    SystemOffNormalAlarmType_SilenceState = 16983,
    SystemOffNormalAlarmType_SilenceState_Id = 16984,
    SystemOffNormalAlarmType_SilenceState_Name = 16985,
    SystemOffNormalAlarmType_SilenceState_Number = 16986,
    SystemOffNormalAlarmType_SilenceState_EffectiveDisplayName = 16987,
    SystemOffNormalAlarmType_SilenceState_TransitionTime = 16988,
    SystemOffNormalAlarmType_SilenceState_EffectiveTransitionTime = 16989,
    SystemOffNormalAlarmType_SilenceState_TrueState = 16990,
    SystemOffNormalAlarmType_SilenceState_FalseState = 16991,
    SystemOffNormalAlarmType_AudibleEnabled = 16992,
    SystemOffNormalAlarmType_AudibleSound = 16993,
    DataSetFolderType_AddDataSetFolder_InputArguments = 16995,
    DataSetFolderType_AddDataSetFolder_OutputArguments = 16996,
    SystemOffNormalAlarmType_OnDelay = 16998,
    SystemOffNormalAlarmType_OffDelay = 16999,
    SystemOffNormalAlarmType_FirstInGroupFlag = 17000,
    SystemOffNormalAlarmType_ReAlarmTime = 17003,
    SystemOffNormalAlarmType_ReAlarmRepeatCount = 17004,
    DataSetFolderType_RemoveDataSetFolder_InputArguments = 17007,
    TripAlarmType_ConditionSubClassId = 17008,
    TripAlarmType_ConditionSubClassName = 17009,
    TripAlarmType_OutOfServiceState = 17010,
    TripAlarmType_OutOfServiceState_Id = 17011,
    TripAlarmType_OutOfServiceState_Name = 17012,
    TripAlarmType_OutOfServiceState_Number = 17013,
    TripAlarmType_OutOfServiceState_EffectiveDisplayName = 17014,
    TripAlarmType_OutOfServiceState_TransitionTime = 17015,
    TripAlarmType_OutOfServiceState_EffectiveTransitionTime = 17016,
    TripAlarmType_OutOfServiceState_TrueState = 17017,
    TripAlarmType_OutOfServiceState_FalseState = 17018,
    TripAlarmType_SilenceState = 17019,
    TripAlarmType_SilenceState_Id = 17020,
    TripAlarmType_SilenceState_Name = 17021,
    TripAlarmType_SilenceState_Number = 17022,
    TripAlarmType_SilenceState_EffectiveDisplayName = 17023,
    TripAlarmType_SilenceState_TransitionTime = 17024,
    TripAlarmType_SilenceState_EffectiveTransitionTime = 17025,
    TripAlarmType_SilenceState_TrueState = 17026,
    TripAlarmType_SilenceState_FalseState = 17027,
    TripAlarmType_AudibleEnabled = 17028,
    TripAlarmType_AudibleSound = 17029,
    AddPublishedDataItemsTemplateMethodType_InputArguments = 17031,
    AddPublishedDataItemsTemplateMethodType_OutputArguments = 17032,
    TripAlarmType_OnDelay = 17034,
    TripAlarmType_OffDelay = 17035,
    TripAlarmType_FirstInGroupFlag = 17036,
    TripAlarmType_ReAlarmTime = 17039,
    TripAlarmType_ReAlarmRepeatCount = 17040,
    AddPublishedEventsTemplateMethodType_InputArguments = 17043,
    CertificateExpirationAlarmType_ConditionSubClassId = 17044,
    CertificateExpirationAlarmType_ConditionSubClassName = 17045,
    CertificateExpirationAlarmType_OutOfServiceState = 17046,
    CertificateExpirationAlarmType_OutOfServiceState_Id = 17047,
    CertificateExpirationAlarmType_OutOfServiceState_Name = 17048,
    CertificateExpirationAlarmType_OutOfServiceState_Number = 17049,
    CertificateExpirationAlarmType_OutOfServiceState_EffectiveDisplayName = 17050,
    CertificateExpirationAlarmType_OutOfServiceState_TransitionTime = 17051,
    CertificateExpirationAlarmType_OutOfServiceState_EffectiveTransitionTime = 17052,
    CertificateExpirationAlarmType_OutOfServiceState_TrueState = 17053,
    CertificateExpirationAlarmType_OutOfServiceState_FalseState = 17054,
    CertificateExpirationAlarmType_SilenceState = 17055,
    CertificateExpirationAlarmType_SilenceState_Id = 17056,
    CertificateExpirationAlarmType_SilenceState_Name = 17057,
    CertificateExpirationAlarmType_SilenceState_Number = 17058,
    CertificateExpirationAlarmType_SilenceState_EffectiveDisplayName = 17059,
    CertificateExpirationAlarmType_SilenceState_TransitionTime = 17060,
    CertificateExpirationAlarmType_SilenceState_EffectiveTransitionTime = 17061,
    CertificateExpirationAlarmType_SilenceState_TrueState = 17062,
    CertificateExpirationAlarmType_SilenceState_FalseState = 17063,
    CertificateExpirationAlarmType_AudibleEnabled = 17064,
    CertificateExpirationAlarmType_AudibleSound = 17065,
    AddPublishedEventsTemplateMethodType_OutputArguments = 17066,
    AddDataSetFolderMethodType_InputArguments = 17068,
    AddDataSetFolderMethodType_OutputArguments = 17069,
    CertificateExpirationAlarmType_OnDelay = 17070,
    CertificateExpirationAlarmType_OffDelay = 17071,
    CertificateExpirationAlarmType_FirstInGroupFlag = 17072,
    CertificateExpirationAlarmType_ReAlarmTime = 17075,
    CertificateExpirationAlarmType_ReAlarmRepeatCount = 17076,
    DiscrepancyAlarmType_EventId = 17081,
    DiscrepancyAlarmType_EventType = 17082,
    DiscrepancyAlarmType_SourceNode = 17083,
    DiscrepancyAlarmType_SourceName = 17084,
    DiscrepancyAlarmType_Time = 17085,
    DiscrepancyAlarmType_ReceiveTime = 17086,
    DiscrepancyAlarmType_LocalTime = 17087,
    DiscrepancyAlarmType_Message = 17088,
    DiscrepancyAlarmType_Severity = 17089,
    DiscrepancyAlarmType_ConditionClassId = 17090,
    DiscrepancyAlarmType_ConditionClassName = 17091,
    DiscrepancyAlarmType_ConditionSubClassId = 17092,
    DiscrepancyAlarmType_ConditionSubClassName = 17093,
    DiscrepancyAlarmType_ConditionName = 17094,
    DiscrepancyAlarmType_BranchId = 17095,
    DiscrepancyAlarmType_Retain = 17096,
    DiscrepancyAlarmType_EnabledState = 17097,
    DiscrepancyAlarmType_EnabledState_Id = 17098,
    DiscrepancyAlarmType_EnabledState_Name = 17099,
    DiscrepancyAlarmType_EnabledState_Number = 17100,
    DiscrepancyAlarmType_EnabledState_EffectiveDisplayName = 17101,
    DiscrepancyAlarmType_EnabledState_TransitionTime = 17102,
    DiscrepancyAlarmType_EnabledState_EffectiveTransitionTime = 17103,
    DiscrepancyAlarmType_EnabledState_TrueState = 17104,
    DiscrepancyAlarmType_EnabledState_FalseState = 17105,
    DiscrepancyAlarmType_Quality = 17106,
    DiscrepancyAlarmType_Quality_SourceTimestamp = 17107,
    DiscrepancyAlarmType_LastSeverity = 17108,
    DiscrepancyAlarmType_LastSeverity_SourceTimestamp = 17109,
    DiscrepancyAlarmType_Comment = 17110,
    DiscrepancyAlarmType_Comment_SourceTimestamp = 17111,
    DiscrepancyAlarmType_ClientUserId = 17112,
    DiscrepancyAlarmType_AddComment_InputArguments = 17116,
    DiscrepancyAlarmType_ConditionRefresh_InputArguments = 17118,
    DiscrepancyAlarmType_ConditionRefresh2_InputArguments = 17120,
    DiscrepancyAlarmType_AckedState = 17121,
    DiscrepancyAlarmType_AckedState_Id = 17122,
    DiscrepancyAlarmType_AckedState_Name = 17123,
    DiscrepancyAlarmType_AckedState_Number = 17124,
    DiscrepancyAlarmType_AckedState_EffectiveDisplayName = 17125,
    DiscrepancyAlarmType_AckedState_TransitionTime = 17126,
    DiscrepancyAlarmType_AckedState_EffectiveTransitionTime = 17127,
    DiscrepancyAlarmType_AckedState_TrueState = 17128,
    DiscrepancyAlarmType_AckedState_FalseState = 17129,
    DiscrepancyAlarmType_ConfirmedState = 17130,
    DiscrepancyAlarmType_ConfirmedState_Id = 17131,
    DiscrepancyAlarmType_ConfirmedState_Name = 17132,
    DiscrepancyAlarmType_ConfirmedState_Number = 17133,
    DiscrepancyAlarmType_ConfirmedState_EffectiveDisplayName = 17134,
    DiscrepancyAlarmType_ConfirmedState_TransitionTime = 17135,
    DiscrepancyAlarmType_ConfirmedState_EffectiveTransitionTime = 17136,
    DiscrepancyAlarmType_ConfirmedState_TrueState = 17137,
    DiscrepancyAlarmType_ConfirmedState_FalseState = 17138,
    DiscrepancyAlarmType_Acknowledge_InputArguments = 17140,
    DiscrepancyAlarmType_Confirm_InputArguments = 17142,
    DiscrepancyAlarmType_ActiveState = 17143,
    DiscrepancyAlarmType_ActiveState_Id = 17144,
    DiscrepancyAlarmType_ActiveState_Name = 17145,
    DiscrepancyAlarmType_ActiveState_Number = 17146,
    DiscrepancyAlarmType_ActiveState_EffectiveDisplayName = 17147,
    DiscrepancyAlarmType_ActiveState_TransitionTime = 17148,
    DiscrepancyAlarmType_ActiveState_EffectiveTransitionTime = 17149,
    DiscrepancyAlarmType_ActiveState_TrueState = 17150,
    DiscrepancyAlarmType_ActiveState_FalseState = 17151,
    DiscrepancyAlarmType_InputNode = 17152,
    DiscrepancyAlarmType_SuppressedState = 17153,
    DiscrepancyAlarmType_SuppressedState_Id = 17154,
    DiscrepancyAlarmType_SuppressedState_Name = 17155,
    DiscrepancyAlarmType_SuppressedState_Number = 17156,
    DiscrepancyAlarmType_SuppressedState_EffectiveDisplayName = 17157,
    DiscrepancyAlarmType_SuppressedState_TransitionTime = 17158,
    DiscrepancyAlarmType_SuppressedState_EffectiveTransitionTime = 17159,
    DiscrepancyAlarmType_SuppressedState_TrueState = 17160,
    DiscrepancyAlarmType_SuppressedState_FalseState = 17161,
    DiscrepancyAlarmType_OutOfServiceState = 17162,
    DiscrepancyAlarmType_OutOfServiceState_Id = 17163,
    DiscrepancyAlarmType_OutOfServiceState_Name = 17164,
    DiscrepancyAlarmType_OutOfServiceState_Number = 17165,
    DiscrepancyAlarmType_OutOfServiceState_EffectiveDisplayName = 17166,
    DiscrepancyAlarmType_OutOfServiceState_TransitionTime = 17167,
    DiscrepancyAlarmType_OutOfServiceState_EffectiveTransitionTime = 17168,
    DiscrepancyAlarmType_OutOfServiceState_TrueState = 17169,
    DiscrepancyAlarmType_OutOfServiceState_FalseState = 17170,
    DiscrepancyAlarmType_SilenceState = 17171,
    DiscrepancyAlarmType_SilenceState_Id = 17172,
    DiscrepancyAlarmType_SilenceState_Name = 17173,
    DiscrepancyAlarmType_SilenceState_Number = 17174,
    DiscrepancyAlarmType_SilenceState_EffectiveDisplayName = 17175,
    DiscrepancyAlarmType_SilenceState_TransitionTime = 17176,
    DiscrepancyAlarmType_SilenceState_EffectiveTransitionTime = 17177,
    DiscrepancyAlarmType_SilenceState_TrueState = 17178,
    DiscrepancyAlarmType_SilenceState_FalseState = 17179,
    DiscrepancyAlarmType_ShelvingState_CurrentState = 17181,
    DiscrepancyAlarmType_ShelvingState_CurrentState_Id = 17182,
    DiscrepancyAlarmType_ShelvingState_CurrentState_Name = 17183,
    DiscrepancyAlarmType_ShelvingState_CurrentState_Number = 17184,
    DiscrepancyAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 17185,
    DiscrepancyAlarmType_ShelvingState_LastTransition = 17186,
    DiscrepancyAlarmType_ShelvingState_LastTransition_Id = 17187,
    DiscrepancyAlarmType_ShelvingState_LastTransition_Name = 17188,
    DiscrepancyAlarmType_ShelvingState_LastTransition_Number = 17189,
    DiscrepancyAlarmType_ShelvingState_LastTransition_TransitionTime = 17190,
    DiscrepancyAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 17191,
    DiscrepancyAlarmType_ShelvingState_UnshelveTime = 17192,
    DiscrepancyAlarmType_ShelvingState_TimedShelve_InputArguments = 17196,
    DiscrepancyAlarmType_SuppressedOrShelved = 17197,
    DiscrepancyAlarmType_MaxTimeShelved = 17198,
    DiscrepancyAlarmType_AudibleEnabled = 17199,
    DiscrepancyAlarmType_AudibleSound = 17200,
    RemoveDataSetFolderMethodType_InputArguments = 17201,
    PubSubConnectionType_Address_NetworkInterface = 17202,
    PubSubConnectionType_WriterGroupName_Placeholder_MaxNetworkMessageSize = 17204,
    DiscrepancyAlarmType_OnDelay = 17205,
    DiscrepancyAlarmType_OffDelay = 17206,
    DiscrepancyAlarmType_FirstInGroupFlag = 17207,
    DiscrepancyAlarmType_ReAlarmTime = 17210,
    DiscrepancyAlarmType_ReAlarmRepeatCount = 17211,
    PubSubConnectionType_WriterGroupName_Placeholder_WriterGroupId = 17214,
    DiscrepancyAlarmType_TargetValueNode = 17215,
    DiscrepancyAlarmType_ExpectedTime = 17216,
    DiscrepancyAlarmType_Tolerance = 17217,
    AuditConditionCommentEventType_ConditionEventId = 17222,
    AuditConditionAcknowledgeEventType_ConditionEventId = 17223,
    AuditConditionConfirmEventType_ConditionEventId = 17224,
    AuditConditionSuppressionEventType_EventId = 17226,
    AuditConditionSuppressionEventType_EventType = 17227,
    AuditConditionSuppressionEventType_SourceNode = 17228,
    AuditConditionSuppressionEventType_SourceName = 17229,
    AuditConditionSuppressionEventType_Time = 17230,
    AuditConditionSuppressionEventType_ReceiveTime = 17231,
    AuditConditionSuppressionEventType_LocalTime = 17232,
    AuditConditionSuppressionEventType_Message = 17233,
    AuditConditionSuppressionEventType_Severity = 17234,
    AuditConditionSuppressionEventType_ActionTimeStamp = 17235,
    AuditConditionSuppressionEventType_Status = 17236,
    AuditConditionSuppressionEventType_ServerId = 17237,
    AuditConditionSuppressionEventType_ClientAuditEntryId = 17238,
    AuditConditionSuppressionEventType_ClientUserId = 17239,
    AuditConditionSuppressionEventType_MethodId = 17240,
    AuditConditionSuppressionEventType_InputArguments = 17241,
    AuditConditionSilenceEventType_EventId = 17243,
    AuditConditionSilenceEventType_EventType = 17244,
    AuditConditionSilenceEventType_SourceNode = 17245,
    AuditConditionSilenceEventType_SourceName = 17246,
    AuditConditionSilenceEventType_Time = 17247,
    AuditConditionSilenceEventType_ReceiveTime = 17248,
    AuditConditionSilenceEventType_LocalTime = 17249,
    AuditConditionSilenceEventType_Message = 17250,
    AuditConditionSilenceEventType_Severity = 17251,
    AuditConditionSilenceEventType_ActionTimeStamp = 17252,
    AuditConditionSilenceEventType_Status = 17253,
    AuditConditionSilenceEventType_ServerId = 17254,
    AuditConditionSilenceEventType_ClientAuditEntryId = 17255,
    AuditConditionSilenceEventType_ClientUserId = 17256,
    AuditConditionSilenceEventType_MethodId = 17257,
    AuditConditionSilenceEventType_InputArguments = 17258,
    AuditConditionOutOfServiceEventType_EventId = 17260,
    AuditConditionOutOfServiceEventType_EventType = 17261,
    AuditConditionOutOfServiceEventType_SourceNode = 17262,
    AuditConditionOutOfServiceEventType_SourceName = 17263,
    AuditConditionOutOfServiceEventType_Time = 17264,
    AuditConditionOutOfServiceEventType_ReceiveTime = 17265,
    AuditConditionOutOfServiceEventType_LocalTime = 17266,
    AuditConditionOutOfServiceEventType_Message = 17267,
    AuditConditionOutOfServiceEventType_Severity = 17268,
    AuditConditionOutOfServiceEventType_ActionTimeStamp = 17269,
    AuditConditionOutOfServiceEventType_Status = 17270,
    AuditConditionOutOfServiceEventType_ServerId = 17271,
    AuditConditionOutOfServiceEventType_ClientAuditEntryId = 17272,
    AuditConditionOutOfServiceEventType_ClientUserId = 17273,
    AuditConditionOutOfServiceEventType_MethodId = 17274,
    AuditConditionOutOfServiceEventType_InputArguments = 17275,
    AlarmRateVariableType_Rate = 17278,
    AlarmMetricsType_AlarmCount = 17280,
    AlarmMetricsType_MaximumActiveState = 17281,
    AlarmMetricsType_MaximumUnAck = 17282,
    AlarmMetricsType_MaximumReAlarmCount = 17283,
    AlarmMetricsType_CurrentAlarmRate = 17284,
    AlarmMetricsType_CurrentAlarmRate_Rate = 17285,
    AlarmMetricsType_MaximumAlarmRate = 17286,
    AlarmMetricsType_MaximumAlarmRate_Rate = 17287,
    AlarmMetricsType_AverageAlarmRate = 17288,
    AlarmMetricsType_AverageAlarmRate_Rate = 17289,
    PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri = 17292,
    PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter_InputArguments = 17294,
    PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_RestrictToList = 17295,
    PublishSubscribeType_SetSecurityKeys_InputArguments = 17297,
    SetSecurityKeysMethodType_InputArguments = 17299,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        17300,
    PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter_OutputArguments = 17301,
    PubSubConnectionType_ReaderGroupName_Placeholder_MaxNetworkMessageSize = 17302,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        17303,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        17304,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        17305,
    PubSubConnectionType_TransportProfileUri = 17306,
    PubSubConnectionType_TransportProfileUri_RestrictToList = 17309,
    PubSubConnectionType_WriterGroupName_Placeholder_SecurityMode = 17311,
    PubSubConnectionType_WriterGroupName_Placeholder_SecurityGroupId = 17312,
    PubSubConnectionType_WriterGroupName_Placeholder_SecurityKeyServices = 17313,
    PubSubConnectionType_WriterGroupName_Placeholder_Status_State = 17315,
    PubSubConnectionType_WriterGroupName_Placeholder_PublishingInterval = 17318,
    PubSubConnectionType_WriterGroupName_Placeholder_KeepAliveTime = 17319,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        17320,
    PubSubConnectionType_WriterGroupName_Placeholder_Priority = 17321,
    PubSubConnectionType_WriterGroupName_Placeholder_LocaleIds = 17322,
    PubSubConnectionType_WriterGroupName_Placeholder_RemoveDataSetWriter_InputArguments = 17324,
    PubSubConnectionType_ReaderGroupName_Placeholder_SecurityMode = 17326,
    PubSubConnectionType_ReaderGroupName_Placeholder_SecurityGroupId = 17327,
    PubSubConnectionType_ReaderGroupName_Placeholder_SecurityKeyServices = 17328,
    PubSubConnectionType_ReaderGroupName_Placeholder_Status_State = 17330,
    PubSubConnectionType_ReaderGroupName_Placeholder_RemoveDataSetReader_InputArguments = 17334,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        17335,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        17336,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        17337,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        17338,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        17339,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        17340,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        17341,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent = 17342,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        17343,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        17344,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        17345,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        17346,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod = 17347,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        17348,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        17349,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        17350,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        17351,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress = 17353,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel =
        17354,
    PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup_InputArguments = 17357,
    PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup_OutputArguments = 17358,
    PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup_InputArguments = 17360,
    PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup_OutputArguments = 17361,
    PublishSubscribe_ConnectionName_Placeholder_RemoveGroup_InputArguments = 17363,
    PublishSubscribe_SetSecurityKeys_InputArguments = 17365,
    PublishSubscribe_AddConnection_InputArguments = 17367,
    PublishSubscribe_AddConnection_OutputArguments = 17368,
    PublishSubscribe_RemoveConnection_InputArguments = 17370,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItems_InputArguments = 17373,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItems_OutputArguments = 17374,
    PublishSubscribe_PublishedDataSets_AddPublishedEvents_InputArguments = 17376,
    PublishSubscribe_PublishedDataSets_AddPublishedEvents_OutputArguments = 17377,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments = 17379,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments = 17380,
    PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_InputArguments = 17382,
    PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments = 17383,
    PublishSubscribe_PublishedDataSets_RemovePublishedDataSet_InputArguments = 17385,
    DataSetReaderType_CreateTargetVariables_InputArguments = 17387,
    DataSetReaderType_CreateTargetVariables_OutputArguments = 17388,
    DataSetReaderType_CreateDataSetMirror_InputArguments = 17390,
    DataSetReaderType_CreateDataSetMirror_OutputArguments = 17391,
    DataSetReaderTypeCreateTargetVariablesMethodType_InputArguments = 17393,
    DataSetReaderTypeCreateTargetVariablesMethodType_OutputArguments = 17394,
    DataSetReaderTypeCreateDataSetMirrorMethodType_InputArguments = 17396,
    DataSetReaderTypeCreateDataSetMirrorMethodType_OutputArguments = 17397,
    PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader_InputArguments = 17399,
    PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader_OutputArguments = 17400,
    PublishSubscribe_PublishedDataSets_AddDataSetFolder_InputArguments = 17401,
    PublishSubscribe_PublishedDataSets_AddDataSetFolder_OutputArguments = 17402,
    PublishSubscribe_PublishedDataSets_RemoveDataSetFolder_InputArguments = 17404,
    PublishSubscribe_Status_State = 17406,
    PublishSubscribe_Diagnostics_DiagnosticsLevel = 17410,
    PublishSubscribe_Diagnostics_TotalInformation = 17411,
    PublishSubscribe_Diagnostics_TotalInformation_Active = 17412,
    PublishSubscribe_Diagnostics_TotalInformation_Classification = 17413,
    PublishSubscribe_Diagnostics_TotalInformation_DiagnosticsLevel = 17414,
    PublishSubscribe_Diagnostics_TotalInformation_TimeFirstChange = 17415,
    PublishSubscribe_Diagnostics_TotalError = 17416,
    PublishSubscribe_Diagnostics_TotalError_Active = 17417,
    PublishSubscribe_Diagnostics_TotalError_Classification = 17418,
    PublishSubscribe_Diagnostics_TotalError_DiagnosticsLevel = 17419,
    PublishSubscribe_Diagnostics_TotalError_TimeFirstChange = 17420,
    PublishSubscribe_Diagnostics_SubError = 17422,
    PublishSubscribe_Diagnostics_Counters_StateError = 17424,
    PublishSubscribe_Diagnostics_Counters_StateError_Active = 17425,
    PublishSubscribe_Diagnostics_Counters_StateError_Classification = 17426,
    PubSubConnectionType_AddWriterGroup_InputArguments = 17428,
    PublishSubscribe_Diagnostics_Counters_StateError_DiagnosticsLevel = 17429,
    PublishSubscribe_Diagnostics_Counters_StateError_TimeFirstChange = 17430,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod = 17431,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Active = 17432,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Classification = 17433,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 17434,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 17435,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByParent = 17436,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Active = 17437,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Classification = 17438,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 17439,
    PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 17440,
    PublishSubscribe_Diagnostics_Counters_StateOperationalFromError = 17441,
    PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Active = 17442,
    PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Classification = 17443,
    PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 17444,
    PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 17445,
    PublishSubscribe_Diagnostics_Counters_StatePausedByParent = 17446,
    PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Active = 17447,
    PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Classification = 17448,
    PublishSubscribe_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 17449,
    PublishSubscribe_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 17450,
    PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod = 17451,
    PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Active = 17452,
    PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Classification = 17453,
    PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 17454,
    PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 17455,
    PubSubConnectionType_AddWriterGroup_OutputArguments = 17456,
    PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters = 17458,
    PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel = 17459,
    PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders = 17460,
    PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel = 17461,
    PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters = 17462,
    PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel = 17463,
    PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders = 17464,
    PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel = 17466,
    OpcUa_BinarySchema_DatagramConnectionTransportDataType = 17469,
    OpcUa_BinarySchema_DatagramConnectionTransportDataType_DataTypeVersion = 17470,
    OpcUa_BinarySchema_DatagramConnectionTransportDataType_DictionaryFragment = 17471,
    UadpDataSetReaderMessageType_DataSetOffset = 17477,
    PublishSubscribeType_ConnectionName_Placeholder_ConnectionProperties = 17478,
    PublishSubscribeType_SupportedTransportProfiles = 17479,
    PublishSubscribe_ConnectionName_Placeholder_ConnectionProperties = 17480,
    PublishSubscribe_SupportedTransportProfiles = 17481,
    PublishedDataSetType_DataSetWriterName_Placeholder_DataSetWriterProperties = 17482,
    PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetWriterProperties = 17483,
    PublishedEventsType_DataSetWriterName_Placeholder_DataSetWriterProperties = 17484,
    PubSubConnectionType_ConnectionProperties = 17485,
    PubSubConnectionType_WriterGroupName_Placeholder_GroupProperties = 17486,
    PubSubConnectionType_ReaderGroupName_Placeholder_GroupProperties = 17487,
    PubSubGroupType_GroupProperties = 17488,
    WriterGroupType_GroupProperties = 17489,
    WriterGroupType_DataSetWriterName_Placeholder_DataSetWriterProperties = 17490,
    ReaderGroupType_GroupProperties = 17491,
    ReaderGroupType_DataSetReaderName_Placeholder_DataSetReaderProperties = 17492,
    DataSetWriterType_DataSetWriterProperties = 17493,
    DataSetReaderType_DataSetReaderProperties = 17494,
    CreateCredentialMethodType_OutputArguments = 17495,
    AnalogUnitType_Definition = 17498,
    AnalogUnitType_ValuePrecision = 17499,
    AnalogUnitType_InstrumentRange = 17500,
    AnalogUnitType_EURange = 17501,
    AnalogUnitType_EngineeringUnits = 17502,
    PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_Selections = 17503,
    PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_SelectionDescriptions =
        17504,
    PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_RestrictToList = 17505,
    PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_Selections = 17506,
    PubSubConnectionType_AddReaderGroup_InputArguments = 17507,
    PubSubConnectionType_AddReaderGroup_OutputArguments = 17508,
    PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_SelectionDescriptions =
        17509,
    PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_RestrictToList = 17510,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ResourceUri = 17512,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ProfileUri = 17513,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_EndpointUrls = 17514,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ServiceStatus = 17515,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey_InputArguments =
        17517,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey_OutputArguments =
        17518,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_UpdateCredential_InputArguments =
        17520,
    KeyCredentialConfigurationFolderType_CreateCredential_InputArguments = 17523,
    KeyCredentialConfigurationFolderType_CreateCredential_OutputArguments = 17524,
    KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey_InputArguments = 17526,
    KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey_OutputArguments = 17527,
    KeyCredentialConfiguration_CreateCredential_InputArguments = 17529,
    KeyCredentialConfiguration_CreateCredential_OutputArguments = 17530,
    GetEncryptingKeyMethodType_InputArguments = 17532,
    GetEncryptingKeyMethodType_OutputArguments = 17533,
    KeyCredentialConfigurationType_GetEncryptingKey_InputArguments = 17535,
    KeyCredentialConfigurationType_GetEncryptingKey_OutputArguments = 17536,
    OpcUa_BinarySchema_AdditionalParametersType = 17538,
    OpcUa_BinarySchema_AdditionalParametersType_DataTypeVersion = 17539,
    OpcUa_BinarySchema_AdditionalParametersType_DictionaryFragment = 17540,
    OpcUa_BinarySchema_EphemeralKeyType = 17550,
    OpcUa_BinarySchema_EphemeralKeyType_DataTypeVersion = 17551,
    OpcUa_BinarySchema_EphemeralKeyType_DictionaryFragment = 17552,
    PubSubConnectionType_WriterGroupName_Placeholder_HeaderLayoutUri = 17558,
    WriterGroupType_HeaderLayoutUri = 17559,
    ReaderGroupType_DataSetReaderName_Placeholder_KeyFrameCount = 17560,
    ReaderGroupType_DataSetReaderName_Placeholder_HeaderLayoutUri = 17562,
    DataSetReaderType_KeyFrameCount = 17563,
    DataSetReaderType_HeaderLayoutUri = 17564,
    BaseAnalogType_Definition = 17565,
    BaseAnalogType_ValuePrecision = 17566,
    BaseAnalogType_InstrumentRange = 17567,
    BaseAnalogType_EURange = 17568,
    BaseAnalogType_EngineeringUnits = 17569,
    AnalogUnitRangeType_Definition = 17571,
    AnalogUnitRangeType_ValuePrecision = 17572,
    AnalogUnitRangeType_InstrumentRange = 17573,
    AnalogUnitRangeType_EURange = 17574,
    AnalogUnitRangeType_EngineeringUnits = 17575,
    PubSubConnectionType_Address_NetworkInterface_Selections = 17576,
    PubSubConnectionType_Address_NetworkInterface_SelectionDescriptions = 17577,
    PubSubConnectionType_Address_NetworkInterface_RestrictToList = 17578,
    DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_Selections = 17579,
    DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_SelectionDescriptions = 17580,
    DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_RestrictToList = 17581,
    NetworkAddressType_NetworkInterface_Selections = 17582,
    NetworkAddressType_NetworkInterface_SelectionDescriptions = 17583,
    NetworkAddressType_NetworkInterface_RestrictToList = 17584,
    NetworkAddressUrlType_NetworkInterface_Selections = 17585,
    NetworkAddressUrlType_NetworkInterface_SelectionDescriptions = 17586,
    NetworkAddressUrlType_NetworkInterface_RestrictToList = 17587,
    DefaultInstanceBrowseName = 17605,
    ServerType_LocalTime = 17612,
    PubSubConnectionTypeAddWriterGroupMethodType_InputArguments = 17613,
    PubSubConnectionTypeAddWriterGroupMethodType_OutputArguments = 17614,
    AuditSecurityEventType_StatusCodeId = 17615,
    AuditChannelEventType_StatusCodeId = 17616,
    AuditOpenSecureChannelEventType_StatusCodeId = 17617,
    AuditSessionEventType_StatusCodeId = 17618,
    AuditCreateSessionEventType_StatusCodeId = 17619,
    AuditUrlMismatchEventType_StatusCodeId = 17620,
    AuditActivateSessionEventType_StatusCodeId = 17621,
    AuditCancelEventType_StatusCodeId = 17622,
    AuditCertificateEventType_StatusCodeId = 17623,
    AuditCertificateDataMismatchEventType_StatusCodeId = 17624,
    AuditCertificateExpiredEventType_StatusCodeId = 17625,
    AuditCertificateInvalidEventType_StatusCodeId = 17626,
    AuditCertificateUntrustedEventType_StatusCodeId = 17627,
    AuditCertificateRevokedEventType_StatusCodeId = 17628,
    AuditCertificateMismatchEventType_StatusCodeId = 17629,
    PubSubConnectionAddReaderGroupGroupMethodType_InputArguments = 17631,
    SelectionListType_Selections = 17632,
    SelectionListType_SelectionDescriptions = 17633,
    Server_LocalTime = 17634,
    FiniteStateMachineType_AvailableStates = 17635,
    FiniteStateMachineType_AvailableTransitions = 17636,
    TemporaryFileTransferType_TransferState_Placeholder_AvailableStates = 17637,
    TemporaryFileTransferType_TransferState_Placeholder_AvailableTransitions = 17638,
    FileTransferStateMachineType_AvailableStates = 17639,
    FileTransferStateMachineType_AvailableTransitions = 17640,
    RoleMappingRuleChangedAuditEventType_EventId = 17642,
    RoleMappingRuleChangedAuditEventType_EventType = 17643,
    RoleMappingRuleChangedAuditEventType_SourceNode = 17644,
    RoleMappingRuleChangedAuditEventType_SourceName = 17645,
    RoleMappingRuleChangedAuditEventType_Time = 17646,
    RoleMappingRuleChangedAuditEventType_ReceiveTime = 17647,
    RoleMappingRuleChangedAuditEventType_LocalTime = 17648,
    RoleMappingRuleChangedAuditEventType_Message = 17649,
    RoleMappingRuleChangedAuditEventType_Severity = 17650,
    RoleMappingRuleChangedAuditEventType_ActionTimeStamp = 17651,
    RoleMappingRuleChangedAuditEventType_Status = 17652,
    RoleMappingRuleChangedAuditEventType_ServerId = 17653,
    RoleMappingRuleChangedAuditEventType_ClientAuditEntryId = 17654,
    RoleMappingRuleChangedAuditEventType_ClientUserId = 17655,
    RoleMappingRuleChangedAuditEventType_MethodId = 17656,
    RoleMappingRuleChangedAuditEventType_InputArguments = 17657,
    AlarmConditionType_ShelvingState_AvailableStates = 17658,
    AlarmConditionType_ShelvingState_AvailableTransitions = 17659,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_AvailableStates = 17660,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_AvailableTransitions = 17661,
    ShelvedStateMachineType_AvailableStates = 17662,
    ShelvedStateMachineType_AvailableTransitions = 17663,
    LimitAlarmType_ShelvingState_AvailableStates = 17664,
    LimitAlarmType_ShelvingState_AvailableTransitions = 17665,
    ExclusiveLimitStateMachineType_AvailableStates = 17666,
    ExclusiveLimitStateMachineType_AvailableTransitions = 17667,
    ExclusiveLimitAlarmType_ShelvingState_AvailableStates = 17668,
    ExclusiveLimitAlarmType_ShelvingState_AvailableTransitions = 17669,
    ExclusiveLimitAlarmType_LimitState_AvailableStates = 17670,
    ExclusiveLimitAlarmType_LimitState_AvailableTransitions = 17671,
    NonExclusiveLimitAlarmType_ShelvingState_AvailableStates = 17672,
    NonExclusiveLimitAlarmType_ShelvingState_AvailableTransitions = 17673,
    NonExclusiveLevelAlarmType_ShelvingState_AvailableStates = 17674,
    NonExclusiveLevelAlarmType_ShelvingState_AvailableTransitions = 17675,
    ExclusiveLevelAlarmType_ShelvingState_AvailableStates = 17676,
    ExclusiveLevelAlarmType_ShelvingState_AvailableTransitions = 17677,
    ExclusiveLevelAlarmType_LimitState_AvailableStates = 17678,
    ExclusiveLevelAlarmType_LimitState_AvailableTransitions = 17679,
    NonExclusiveDeviationAlarmType_ShelvingState_AvailableStates = 17680,
    NonExclusiveDeviationAlarmType_ShelvingState_AvailableTransitions = 17681,
    ExclusiveDeviationAlarmType_ShelvingState_AvailableStates = 17682,
    ExclusiveDeviationAlarmType_ShelvingState_AvailableTransitions = 17683,
    ExclusiveDeviationAlarmType_LimitState_AvailableStates = 17684,
    ExclusiveDeviationAlarmType_LimitState_AvailableTransitions = 17685,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_AvailableStates = 17686,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_AvailableTransitions = 17687,
    ExclusiveRateOfChangeAlarmType_ShelvingState_AvailableStates = 17688,
    ExclusiveRateOfChangeAlarmType_ShelvingState_AvailableTransitions = 17689,
    ExclusiveRateOfChangeAlarmType_LimitState_AvailableStates = 17690,
    ExclusiveRateOfChangeAlarmType_LimitState_AvailableTransitions = 17691,
    DiscreteAlarmType_ShelvingState_AvailableStates = 17692,
    DiscreteAlarmType_ShelvingState_AvailableTransitions = 17693,
    OffNormalAlarmType_ShelvingState_AvailableStates = 17694,
    OffNormalAlarmType_ShelvingState_AvailableTransitions = 17695,
    SystemOffNormalAlarmType_ShelvingState_AvailableStates = 17696,
    SystemOffNormalAlarmType_ShelvingState_AvailableTransitions = 17697,
    TripAlarmType_ShelvingState_AvailableStates = 17698,
    TripAlarmType_ShelvingState_AvailableTransitions = 17699,
    CertificateExpirationAlarmType_ShelvingState_AvailableStates = 17700,
    CertificateExpirationAlarmType_ShelvingState_AvailableTransitions = 17701,
    DiscrepancyAlarmType_ShelvingState_AvailableStates = 17702,
    DiscrepancyAlarmType_ShelvingState_AvailableTransitions = 17703,
    ProgramStateMachineType_AvailableStates = 17704,
    ProgramStateMachineType_AvailableTransitions = 17705,
    PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_Selections = 17706,
    PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_SelectionDescriptions =
        17707,
    PubSubConnectionType_TransportProfileUri_Selections = 17710,
    PubSubConnectionType_TransportProfileUri_SelectionDescriptions = 17711,
    RationalNumberType_Numerator = 17712,
    RationalNumberType_Denominator = 17713,
    VectorType_VectorUnit = 17715,
    ThreeDVectorType_VectorUnit = 17717,
    FileDirectoryType_FileDirectoryName_Placeholder_DeleteFileSystemObject_InputArguments = 17719,
    PubSubConnectionAddReaderGroupGroupMethodType_OutputArguments = 17720,
    FileSystem_FileDirectoryName_Placeholder_DeleteFileSystemObject_InputArguments = 17723,
    PubSubGroupType_MaxNetworkMessageSize = 17724,
    WriterGroupType_SecurityMode = 17726,
    WriterGroupType_SecurityGroupId = 17727,
    WriterGroupType_SecurityKeyServices = 17728,
    WriterGroupType_MaxNetworkMessageSize = 17729,
    WriterGroupType_Status_State = 17731,
    WriterGroupType_WriterGroupId = 17736,
    WriterGroupType_PublishingInterval = 17737,
    WriterGroupType_KeepAliveTime = 17738,
    WriterGroupType_Priority = 17739,
    WriterGroupType_LocaleIds = 17740,
    WriterGroupType_DataSetWriterName_Placeholder_DataSetWriterId = 17744,
    WriterGroupType_DataSetWriterName_Placeholder_DataSetFieldContentMask = 17745,
    WriterGroupType_DataSetWriterName_Placeholder_KeyFrameCount = 17746,
    WriterGroupType_DataSetWriterName_Placeholder_Status_State = 17750,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel = 17754,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation = 17755,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active = 17756,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification =
        17757,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        17758,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        17759,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError = 17760,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active = 17761,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification = 17762,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel = 17763,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 17764,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_SubError = 17766,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError = 17768,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active = 17769,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification =
        17770,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        17771,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        17772,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        17773,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        17774,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        17775,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        17776,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        17777,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        17778,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        17779,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        17780,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        17781,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        17782,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        17783,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        17784,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        17785,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        17786,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        17787,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent = 17788,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        17789,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        17790,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        17791,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        17792,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        17793,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        17794,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        17795,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        17796,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        17797,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages =
        17799,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active =
        17800,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification =
        17801,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel =
        17802,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange =
        17803,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber =
        17804,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel =
        17805,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode = 17806,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel =
        17807,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion = 17808,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel =
        17809,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion = 17810,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel =
        17811,
    WriterGroupType_Diagnostics_DiagnosticsLevel = 17813,
    WriterGroupType_Diagnostics_TotalInformation = 17814,
    WriterGroupType_Diagnostics_TotalInformation_Active = 17815,
    WriterGroupType_Diagnostics_TotalInformation_Classification = 17816,
    WriterGroupType_Diagnostics_TotalInformation_DiagnosticsLevel = 17817,
    WriterGroupType_Diagnostics_TotalInformation_TimeFirstChange = 17818,
    WriterGroupType_Diagnostics_TotalError = 17819,
    WriterGroupType_Diagnostics_TotalError_Active = 17820,
    WriterGroupType_Diagnostics_TotalError_Classification = 17821,
    WriterGroupType_Diagnostics_TotalError_DiagnosticsLevel = 17822,
    WriterGroupType_Diagnostics_TotalError_TimeFirstChange = 17823,
    WriterGroupType_Diagnostics_SubError = 17825,
    WriterGroupType_Diagnostics_Counters_StateError = 17827,
    WriterGroupType_Diagnostics_Counters_StateError_Active = 17828,
    WriterGroupType_Diagnostics_Counters_StateError_Classification = 17829,
    WriterGroupType_Diagnostics_Counters_StateError_DiagnosticsLevel = 17830,
    WriterGroupType_Diagnostics_Counters_StateError_TimeFirstChange = 17831,
    WriterGroupType_Diagnostics_Counters_StateOperationalByMethod = 17832,
    WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_Active = 17833,
    WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_Classification = 17834,
    WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 17835,
    WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 17836,
    WriterGroupType_Diagnostics_Counters_StateOperationalByParent = 17837,
    WriterGroupType_Diagnostics_Counters_StateOperationalByParent_Active = 17838,
    WriterGroupType_Diagnostics_Counters_StateOperationalByParent_Classification = 17839,
    WriterGroupType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 17840,
    WriterGroupType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 17841,
    WriterGroupType_Diagnostics_Counters_StateOperationalFromError = 17842,
    WriterGroupType_Diagnostics_Counters_StateOperationalFromError_Active = 17843,
    WriterGroupType_Diagnostics_Counters_StateOperationalFromError_Classification = 17844,
    WriterGroupType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 17845,
    WriterGroupType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 17846,
    WriterGroupType_Diagnostics_Counters_StatePausedByParent = 17847,
    WriterGroupType_Diagnostics_Counters_StatePausedByParent_Active = 17848,
    WriterGroupType_Diagnostics_Counters_StatePausedByParent_Classification = 17849,
    WriterGroupType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 17850,
    WriterGroupType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 17851,
    WriterGroupType_Diagnostics_Counters_StateDisabledByMethod = 17853,
    WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_Active = 17854,
    WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_Classification = 17855,
    WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 17856,
    WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 17857,
    WriterGroupType_Diagnostics_Counters_SentNetworkMessages = 17859,
    AuthorizationServiceConfigurationType_ServiceCertificate = 17860,
    WriterGroupType_Diagnostics_Counters_SentNetworkMessages_Active = 17864,
    AlarmConditionType_AudibleSound_ListId = 17865,
    AlarmConditionType_AudibleSound_AgencyId = 17866,
    AlarmConditionType_AudibleSound_VersionId = 17867,
    WriterGroupType_Diagnostics_Counters_SentNetworkMessages_Classification = 17871,
    WriterGroupType_Diagnostics_Counters_SentNetworkMessages_DiagnosticsLevel = 17872,
    WriterGroupType_Diagnostics_Counters_SentNetworkMessages_TimeFirstChange = 17873,
    WriterGroupType_Diagnostics_Counters_FailedTransmissions = 17874,
    WriterGroupType_Diagnostics_Counters_FailedTransmissions_Active = 17878,
    LimitAlarmType_AudibleSound_ListId = 17879,
    LimitAlarmType_AudibleSound_AgencyId = 17880,
    LimitAlarmType_AudibleSound_VersionId = 17881,
    WriterGroupType_Diagnostics_Counters_FailedTransmissions_Classification = 17885,
    ExclusiveLimitAlarmType_AudibleSound_ListId = 17886,
    ExclusiveLimitAlarmType_AudibleSound_AgencyId = 17887,
    ExclusiveLimitAlarmType_AudibleSound_VersionId = 17888,
    WriterGroupType_Diagnostics_Counters_FailedTransmissions_DiagnosticsLevel = 17892,
    NonExclusiveLimitAlarmType_AudibleSound_ListId = 17893,
    NonExclusiveLimitAlarmType_AudibleSound_AgencyId = 17894,
    NonExclusiveLimitAlarmType_AudibleSound_VersionId = 17895,
    WriterGroupType_Diagnostics_Counters_FailedTransmissions_TimeFirstChange = 17899,
    WriterGroupType_Diagnostics_Counters_EncryptionErrors = 17900,
    WriterGroupType_Diagnostics_Counters_EncryptionErrors_Active = 17901,
    WriterGroupType_Diagnostics_Counters_EncryptionErrors_Classification = 17902,
    WriterGroupType_Diagnostics_Counters_EncryptionErrors_DiagnosticsLevel = 17903,
    WriterGroupType_Diagnostics_Counters_EncryptionErrors_TimeFirstChange = 17906,
    ExclusiveLevelAlarmType_AudibleSound_ListId = 17907,
    ExclusiveLevelAlarmType_AudibleSound_AgencyId = 17908,
    ExclusiveLevelAlarmType_AudibleSound_VersionId = 17909,
    WriterGroupType_Diagnostics_LiveValues_ConfiguredDataSetWriters = 17913,
    NonExclusiveDeviationAlarmType_AudibleSound_ListId = 17914,
    NonExclusiveDeviationAlarmType_AudibleSound_AgencyId = 17915,
    NonExclusiveDeviationAlarmType_AudibleSound_VersionId = 17916,
    WriterGroupType_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel = 17920,
    NonExclusiveRateOfChangeAlarmType_AudibleSound_ListId = 17921,
    NonExclusiveRateOfChangeAlarmType_AudibleSound_AgencyId = 17922,
    NonExclusiveRateOfChangeAlarmType_AudibleSound_VersionId = 17923,
    WriterGroupType_Diagnostics_LiveValues_OperationalDataSetWriters = 17927,
    ExclusiveDeviationAlarmType_AudibleSound_ListId = 17928,
    ExclusiveDeviationAlarmType_AudibleSound_AgencyId = 17929,
    ExclusiveDeviationAlarmType_AudibleSound_VersionId = 17930,
    WriterGroupType_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel = 17934,
    ExclusiveRateOfChangeAlarmType_AudibleSound_ListId = 17935,
    ExclusiveRateOfChangeAlarmType_AudibleSound_AgencyId = 17936,
    ExclusiveRateOfChangeAlarmType_AudibleSound_VersionId = 17937,
    WriterGroupType_Diagnostics_LiveValues_SecurityTokenID = 17941,
    DiscreteAlarmType_AudibleSound_ListId = 17942,
    DiscreteAlarmType_AudibleSound_AgencyId = 17943,
    DiscreteAlarmType_AudibleSound_VersionId = 17944,
    WriterGroupType_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel = 17948,
    OffNormalAlarmType_AudibleSound_ListId = 17949,
    OffNormalAlarmType_AudibleSound_AgencyId = 17950,
    OffNormalAlarmType_AudibleSound_VersionId = 17951,
    WriterGroupType_Diagnostics_LiveValues_TimeToNextTokenID = 17955,
    SystemOffNormalAlarmType_AudibleSound_ListId = 17956,
    SystemOffNormalAlarmType_AudibleSound_AgencyId = 17957,
    SystemOffNormalAlarmType_AudibleSound_VersionId = 17958,
    WriterGroupType_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel = 17962,
    TripAlarmType_AudibleSound_ListId = 17963,
    TripAlarmType_AudibleSound_AgencyId = 17964,
    TripAlarmType_AudibleSound_VersionId = 17965,
    CertificateExpirationAlarmType_AudibleSound_ListId = 17970,
    CertificateExpirationAlarmType_AudibleSound_AgencyId = 17971,
    CertificateExpirationAlarmType_AudibleSound_VersionId = 17972,
    WriterGroupType_AddDataSetWriter_InputArguments = 17976,
    DiscrepancyAlarmType_AudibleSound_ListId = 17977,
    DiscrepancyAlarmType_AudibleSound_AgencyId = 17978,
    DiscrepancyAlarmType_AudibleSound_VersionId = 17979,
    WriterGroupType_AddDataSetWriter_OutputArguments = 17987,
    AudioVariableType_ListId = 17988,
    AudioVariableType_AgencyId = 17989,
    AudioVariableType_VersionId = 17990,
    AlarmMetricsType_StartTime = 17991,
    WriterGroupType_RemoveDataSetWriter_InputArguments = 17993,
    PubSubGroupTypeAddWriterrMethodType_InputArguments = 17995,
    PubSubGroupTypeAddWriterrMethodType_OutputArguments = 17996,
    ReaderGroupType_SecurityMode = 18000,
    ReaderGroupType_SecurityGroupId = 18002,
    ReaderGroupType_SecurityKeyServices = 18003,
    KeyCredentialConfigurationType_EndpointUrls = 18004,
    KeyCredentialConfigurationType_ServiceStatus = 18005,
    KeyCredentialConfigurationType_UpdateCredential_InputArguments = 18007,
    KeyCredentialUpdateMethodType_InputArguments = 18010,
    KeyCredentialAuditEventType_EventId = 18012,
    KeyCredentialAuditEventType_EventType = 18013,
    KeyCredentialAuditEventType_SourceNode = 18014,
    KeyCredentialAuditEventType_SourceName = 18015,
    KeyCredentialAuditEventType_Time = 18016,
    KeyCredentialAuditEventType_ReceiveTime = 18017,
    KeyCredentialAuditEventType_LocalTime = 18018,
    KeyCredentialAuditEventType_Message = 18019,
    KeyCredentialAuditEventType_Severity = 18020,
    KeyCredentialAuditEventType_ActionTimeStamp = 18021,
    KeyCredentialAuditEventType_Status = 18022,
    KeyCredentialAuditEventType_ServerId = 18023,
    KeyCredentialAuditEventType_ClientAuditEntryId = 18024,
    KeyCredentialAuditEventType_ClientUserId = 18025,
    KeyCredentialAuditEventType_MethodId = 18026,
    KeyCredentialAuditEventType_InputArguments = 18027,
    KeyCredentialAuditEventType_ResourceUri = 18028,
    KeyCredentialUpdatedAuditEventType_EventId = 18030,
    KeyCredentialUpdatedAuditEventType_EventType = 18031,
    KeyCredentialUpdatedAuditEventType_SourceNode = 18032,
    KeyCredentialUpdatedAuditEventType_SourceName = 18033,
    KeyCredentialUpdatedAuditEventType_Time = 18034,
    KeyCredentialUpdatedAuditEventType_ReceiveTime = 18035,
    KeyCredentialUpdatedAuditEventType_LocalTime = 18036,
    KeyCredentialUpdatedAuditEventType_Message = 18037,
    KeyCredentialUpdatedAuditEventType_Severity = 18038,
    KeyCredentialUpdatedAuditEventType_ActionTimeStamp = 18039,
    KeyCredentialUpdatedAuditEventType_Status = 18040,
    KeyCredentialUpdatedAuditEventType_ServerId = 18041,
    KeyCredentialUpdatedAuditEventType_ClientAuditEntryId = 18042,
    KeyCredentialUpdatedAuditEventType_ClientUserId = 18043,
    KeyCredentialUpdatedAuditEventType_MethodId = 18044,
    KeyCredentialUpdatedAuditEventType_InputArguments = 18045,
    KeyCredentialUpdatedAuditEventType_ResourceUri = 18046,
    KeyCredentialDeletedAuditEventType_EventId = 18048,
    KeyCredentialDeletedAuditEventType_EventType = 18049,
    KeyCredentialDeletedAuditEventType_SourceNode = 18050,
    KeyCredentialDeletedAuditEventType_SourceName = 18051,
    KeyCredentialDeletedAuditEventType_Time = 18052,
    KeyCredentialDeletedAuditEventType_ReceiveTime = 18053,
    KeyCredentialDeletedAuditEventType_LocalTime = 18054,
    KeyCredentialDeletedAuditEventType_Message = 18055,
    KeyCredentialDeletedAuditEventType_Severity = 18056,
    KeyCredentialDeletedAuditEventType_ActionTimeStamp = 18057,
    KeyCredentialDeletedAuditEventType_Status = 18058,
    KeyCredentialDeletedAuditEventType_ServerId = 18059,
    KeyCredentialDeletedAuditEventType_ClientAuditEntryId = 18060,
    KeyCredentialDeletedAuditEventType_ClientUserId = 18061,
    KeyCredentialDeletedAuditEventType_MethodId = 18062,
    KeyCredentialDeletedAuditEventType_InputArguments = 18063,
    KeyCredentialDeletedAuditEventType_ResourceUri = 18064,
    ReaderGroupType_MaxNetworkMessageSize = 18065,
    ReaderGroupType_Status_State = 18068,
    KeyCredentialConfigurationType_ResourceUri = 18069,
    AuthorizationServiceConfigurationType_ServiceUri = 18072,
    AuthorizationServiceConfigurationType_IssuerEndpointUrl = 18073,
    ReaderGroupType_DataSetReaderName_Placeholder_PublisherId = 18077,
    ReaderGroupType_DataSetReaderName_Placeholder_WriterGroupId = 18078,
    ReaderGroupType_DataSetReaderName_Placeholder_DataSetWriterId = 18079,
    ReaderGroupType_DataSetReaderName_Placeholder_DataSetMetaData = 18080,
    ReaderGroupType_DataSetReaderName_Placeholder_DataSetFieldContentMask = 18081,
    ReaderGroupType_DataSetReaderName_Placeholder_MessageReceiveTimeout = 18082,
    ReaderGroupType_DataSetReaderName_Placeholder_SecurityMode = 18083,
    ReaderGroupType_DataSetReaderName_Placeholder_SecurityGroupId = 18084,
    ReaderGroupType_DataSetReaderName_Placeholder_SecurityKeyServices = 18085,
    ReaderGroupType_DataSetReaderName_Placeholder_Status_State = 18089,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_DiagnosticsLevel = 18093,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation = 18094,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_Active = 18095,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_Classification =
        18096,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        18097,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        18098,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError = 18099,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_Active = 18100,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_Classification = 18101,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel = 18102,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 18103,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_SubError = 18105,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError = 18107,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_Active = 18108,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_Classification =
        18109,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        18110,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        18111,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        18112,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        18113,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        18114,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        18115,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        18116,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        18117,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        18118,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        18119,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        18120,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        18121,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        18122,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        18123,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        18124,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        18125,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        18126,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent = 18127,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        18128,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        18129,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        18130,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        18131,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        18132,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        18133,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        18134,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        18135,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        18136,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages =
        18138,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active =
        18139,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification =
        18140,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel =
        18141,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange =
        18142,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors = 18143,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_Active =
        18144,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_Classification =
        18145,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel =
        18146,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_TimeFirstChange =
        18147,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber =
        18148,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel =
        18149,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_StatusCode = 18150,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel =
        18151,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MajorVersion = 18152,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel =
        18153,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MinorVersion = 18154,
    KeyCredentialConfiguration_ServiceName_Placeholder_ResourceUri = 18157,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel =
        18158,
    KeyCredentialConfiguration_ServiceName_Placeholder_EndpointUrls = 18159,
    KeyCredentialConfiguration_ServiceName_Placeholder_ServiceStatus = 18160,
    KeyCredentialConfiguration_ServiceName_Placeholder_UpdateCredential_InputArguments = 18162,
    KeyCredentialConfiguration_ServiceName_Placeholder_ProfileUri = 18164,
    KeyCredentialConfigurationType_ProfileUri = 18165,
    OpcUa_BinarySchema_DataTypeDefinition = 18178,
    OpcUa_BinarySchema_DataTypeDefinition_DataTypeVersion = 18179,
    OpcUa_BinarySchema_DataTypeDefinition_DictionaryFragment = 18180,
    OpcUa_BinarySchema_StructureField = 18181,
    OpcUa_BinarySchema_StructureField_DataTypeVersion = 18182,
    OpcUa_BinarySchema_StructureField_DictionaryFragment = 18183,
    OpcUa_BinarySchema_StructureDefinition = 18184,
    OpcUa_BinarySchema_StructureDefinition_DataTypeVersion = 18185,
    OpcUa_BinarySchema_StructureDefinition_DictionaryFragment = 18186,
    OpcUa_BinarySchema_EnumDefinition = 18187,
    OpcUa_BinarySchema_EnumDefinition_DataTypeVersion = 18188,
    OpcUa_BinarySchema_EnumDefinition_DictionaryFragment = 18189,
    AlarmConditionType_LatchedState = 18190,
    AlarmConditionType_LatchedState_Id = 18191,
    AlarmConditionType_LatchedState_Name = 18192,
    AlarmConditionType_LatchedState_Number = 18193,
    AlarmConditionType_LatchedState_EffectiveDisplayName = 18194,
    AlarmConditionType_LatchedState_TransitionTime = 18195,
    AlarmConditionType_LatchedState_EffectiveTransitionTime = 18196,
    AlarmConditionType_LatchedState_TrueState = 18197,
    AlarmConditionType_LatchedState_FalseState = 18198,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_ListId = 18200,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_AgencyId = 18201,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_VersionId = 18202,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState = 18203,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Id = 18204,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Name = 18205,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Number = 18206,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_EffectiveDisplayName = 18207,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_TransitionTime = 18208,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_EffectiveTransitionTime = 18209,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_TrueState = 18210,
    AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_FalseState = 18211,
    LimitAlarmType_LatchedState = 18213,
    LimitAlarmType_LatchedState_Id = 18214,
    LimitAlarmType_LatchedState_Name = 18215,
    LimitAlarmType_LatchedState_Number = 18216,
    LimitAlarmType_LatchedState_EffectiveDisplayName = 18217,
    LimitAlarmType_LatchedState_TransitionTime = 18218,
    LimitAlarmType_LatchedState_EffectiveTransitionTime = 18219,
    LimitAlarmType_LatchedState_TrueState = 18220,
    LimitAlarmType_LatchedState_FalseState = 18221,
    ExclusiveLimitAlarmType_LatchedState = 18223,
    ExclusiveLimitAlarmType_LatchedState_Id = 18224,
    ExclusiveLimitAlarmType_LatchedState_Name = 18225,
    ExclusiveLimitAlarmType_LatchedState_Number = 18226,
    ExclusiveLimitAlarmType_LatchedState_EffectiveDisplayName = 18227,
    ExclusiveLimitAlarmType_LatchedState_TransitionTime = 18228,
    ExclusiveLimitAlarmType_LatchedState_EffectiveTransitionTime = 18229,
    ExclusiveLimitAlarmType_LatchedState_TrueState = 18230,
    ExclusiveLimitAlarmType_LatchedState_FalseState = 18231,
    NonExclusiveLimitAlarmType_LatchedState = 18233,
    NonExclusiveLimitAlarmType_LatchedState_Id = 18234,
    NonExclusiveLimitAlarmType_LatchedState_Name = 18235,
    NonExclusiveLimitAlarmType_LatchedState_Number = 18236,
    NonExclusiveLimitAlarmType_LatchedState_EffectiveDisplayName = 18237,
    NonExclusiveLimitAlarmType_LatchedState_TransitionTime = 18238,
    NonExclusiveLimitAlarmType_LatchedState_EffectiveTransitionTime = 18239,
    NonExclusiveLimitAlarmType_LatchedState_TrueState = 18240,
    NonExclusiveLimitAlarmType_LatchedState_FalseState = 18241,
    NonExclusiveLevelAlarmType_AudibleSound_ListId = 18243,
    NonExclusiveLevelAlarmType_AudibleSound_AgencyId = 18244,
    NonExclusiveLevelAlarmType_AudibleSound_VersionId = 18245,
    NonExclusiveLevelAlarmType_LatchedState = 18246,
    NonExclusiveLevelAlarmType_LatchedState_Id = 18247,
    NonExclusiveLevelAlarmType_LatchedState_Name = 18248,
    NonExclusiveLevelAlarmType_LatchedState_Number = 18249,
    NonExclusiveLevelAlarmType_LatchedState_EffectiveDisplayName = 18250,
    NonExclusiveLevelAlarmType_LatchedState_TransitionTime = 18251,
    NonExclusiveLevelAlarmType_LatchedState_EffectiveTransitionTime = 18252,
    NonExclusiveLevelAlarmType_LatchedState_TrueState = 18253,
    NonExclusiveLevelAlarmType_LatchedState_FalseState = 18254,
    ExclusiveLevelAlarmType_LatchedState = 18257,
    ExclusiveLevelAlarmType_LatchedState_Id = 18258,
    ExclusiveLevelAlarmType_LatchedState_Name = 18259,
    ExclusiveLevelAlarmType_LatchedState_Number = 18260,
    ExclusiveLevelAlarmType_LatchedState_EffectiveDisplayName = 18261,
    ExclusiveLevelAlarmType_LatchedState_TransitionTime = 18262,
    ExclusiveLevelAlarmType_LatchedState_EffectiveTransitionTime = 18263,
    ExclusiveLevelAlarmType_LatchedState_TrueState = 18264,
    ExclusiveLevelAlarmType_LatchedState_FalseState = 18265,
    NonExclusiveDeviationAlarmType_LatchedState = 18267,
    NonExclusiveDeviationAlarmType_LatchedState_Id = 18268,
    NonExclusiveDeviationAlarmType_LatchedState_Name = 18269,
    NonExclusiveDeviationAlarmType_LatchedState_Number = 18270,
    NonExclusiveDeviationAlarmType_LatchedState_EffectiveDisplayName = 18271,
    NonExclusiveDeviationAlarmType_LatchedState_TransitionTime = 18272,
    NonExclusiveDeviationAlarmType_LatchedState_EffectiveTransitionTime = 18273,
    NonExclusiveDeviationAlarmType_LatchedState_TrueState = 18274,
    NonExclusiveDeviationAlarmType_LatchedState_FalseState = 18275,
    NonExclusiveRateOfChangeAlarmType_LatchedState = 18277,
    NonExclusiveRateOfChangeAlarmType_LatchedState_Id = 18278,
    NonExclusiveRateOfChangeAlarmType_LatchedState_Name = 18279,
    NonExclusiveRateOfChangeAlarmType_LatchedState_Number = 18280,
    NonExclusiveRateOfChangeAlarmType_LatchedState_EffectiveDisplayName = 18281,
    NonExclusiveRateOfChangeAlarmType_LatchedState_TransitionTime = 18282,
    NonExclusiveRateOfChangeAlarmType_LatchedState_EffectiveTransitionTime = 18283,
    NonExclusiveRateOfChangeAlarmType_LatchedState_TrueState = 18284,
    NonExclusiveRateOfChangeAlarmType_LatchedState_FalseState = 18285,
    ExclusiveDeviationAlarmType_LatchedState = 18287,
    ExclusiveDeviationAlarmType_LatchedState_Id = 18288,
    ExclusiveDeviationAlarmType_LatchedState_Name = 18289,
    ExclusiveDeviationAlarmType_LatchedState_Number = 18290,
    ExclusiveDeviationAlarmType_LatchedState_EffectiveDisplayName = 18291,
    ExclusiveDeviationAlarmType_LatchedState_TransitionTime = 18292,
    ExclusiveDeviationAlarmType_LatchedState_EffectiveTransitionTime = 18293,
    ExclusiveDeviationAlarmType_LatchedState_TrueState = 18294,
    ExclusiveDeviationAlarmType_LatchedState_FalseState = 18295,
    ExclusiveRateOfChangeAlarmType_LatchedState = 18297,
    ExclusiveRateOfChangeAlarmType_LatchedState_Id = 18298,
    ExclusiveRateOfChangeAlarmType_LatchedState_Name = 18299,
    ExclusiveRateOfChangeAlarmType_LatchedState_Number = 18300,
    ExclusiveRateOfChangeAlarmType_LatchedState_EffectiveDisplayName = 18301,
    ExclusiveRateOfChangeAlarmType_LatchedState_TransitionTime = 18302,
    ExclusiveRateOfChangeAlarmType_LatchedState_EffectiveTransitionTime = 18303,
    ExclusiveRateOfChangeAlarmType_LatchedState_TrueState = 18304,
    ExclusiveRateOfChangeAlarmType_LatchedState_FalseState = 18305,
    DiscreteAlarmType_LatchedState = 18307,
    DiscreteAlarmType_LatchedState_Id = 18308,
    DiscreteAlarmType_LatchedState_Name = 18309,
    DiscreteAlarmType_LatchedState_Number = 18310,
    DiscreteAlarmType_LatchedState_EffectiveDisplayName = 18311,
    DiscreteAlarmType_LatchedState_TransitionTime = 18312,
    DiscreteAlarmType_LatchedState_EffectiveTransitionTime = 18313,
    DiscreteAlarmType_LatchedState_TrueState = 18314,
    DiscreteAlarmType_LatchedState_FalseState = 18315,
    OffNormalAlarmType_LatchedState = 18317,
    OffNormalAlarmType_LatchedState_Id = 18318,
    OffNormalAlarmType_LatchedState_Name = 18319,
    OffNormalAlarmType_LatchedState_Number = 18320,
    OffNormalAlarmType_LatchedState_EffectiveDisplayName = 18321,
    OffNormalAlarmType_LatchedState_TransitionTime = 18322,
    OffNormalAlarmType_LatchedState_EffectiveTransitionTime = 18323,
    OffNormalAlarmType_LatchedState_TrueState = 18324,
    OffNormalAlarmType_LatchedState_FalseState = 18325,
    SystemOffNormalAlarmType_LatchedState = 18327,
    SystemOffNormalAlarmType_LatchedState_Id = 18328,
    SystemOffNormalAlarmType_LatchedState_Name = 18329,
    SystemOffNormalAlarmType_LatchedState_Number = 18330,
    SystemOffNormalAlarmType_LatchedState_EffectiveDisplayName = 18331,
    SystemOffNormalAlarmType_LatchedState_TransitionTime = 18332,
    SystemOffNormalAlarmType_LatchedState_EffectiveTransitionTime = 18333,
    SystemOffNormalAlarmType_LatchedState_TrueState = 18334,
    SystemOffNormalAlarmType_LatchedState_FalseState = 18335,
    TripAlarmType_LatchedState = 18337,
    TripAlarmType_LatchedState_Id = 18338,
    TripAlarmType_LatchedState_Name = 18339,
    TripAlarmType_LatchedState_Number = 18340,
    TripAlarmType_LatchedState_EffectiveDisplayName = 18341,
    TripAlarmType_LatchedState_TransitionTime = 18342,
    TripAlarmType_LatchedState_EffectiveTransitionTime = 18343,
    TripAlarmType_LatchedState_TrueState = 18344,
    TripAlarmType_LatchedState_FalseState = 18345,
    InstrumentDiagnosticAlarmType_EventId = 18348,
    InstrumentDiagnosticAlarmType_EventType = 18349,
    InstrumentDiagnosticAlarmType_SourceNode = 18350,
    InstrumentDiagnosticAlarmType_SourceName = 18351,
    InstrumentDiagnosticAlarmType_Time = 18352,
    InstrumentDiagnosticAlarmType_ReceiveTime = 18353,
    InstrumentDiagnosticAlarmType_LocalTime = 18354,
    InstrumentDiagnosticAlarmType_Message = 18355,
    InstrumentDiagnosticAlarmType_Severity = 18356,
    InstrumentDiagnosticAlarmType_ConditionClassId = 18357,
    InstrumentDiagnosticAlarmType_ConditionClassName = 18358,
    InstrumentDiagnosticAlarmType_ConditionSubClassId = 18359,
    InstrumentDiagnosticAlarmType_ConditionSubClassName = 18360,
    InstrumentDiagnosticAlarmType_ConditionName = 18361,
    InstrumentDiagnosticAlarmType_BranchId = 18362,
    InstrumentDiagnosticAlarmType_Retain = 18363,
    InstrumentDiagnosticAlarmType_EnabledState = 18364,
    InstrumentDiagnosticAlarmType_EnabledState_Id = 18365,
    InstrumentDiagnosticAlarmType_EnabledState_Name = 18366,
    InstrumentDiagnosticAlarmType_EnabledState_Number = 18367,
    InstrumentDiagnosticAlarmType_EnabledState_EffectiveDisplayName = 18368,
    InstrumentDiagnosticAlarmType_EnabledState_TransitionTime = 18369,
    InstrumentDiagnosticAlarmType_EnabledState_EffectiveTransitionTime = 18370,
    InstrumentDiagnosticAlarmType_EnabledState_TrueState = 18371,
    InstrumentDiagnosticAlarmType_EnabledState_FalseState = 18372,
    InstrumentDiagnosticAlarmType_Quality = 18373,
    InstrumentDiagnosticAlarmType_Quality_SourceTimestamp = 18374,
    InstrumentDiagnosticAlarmType_LastSeverity = 18375,
    InstrumentDiagnosticAlarmType_LastSeverity_SourceTimestamp = 18376,
    InstrumentDiagnosticAlarmType_Comment = 18377,
    InstrumentDiagnosticAlarmType_Comment_SourceTimestamp = 18378,
    InstrumentDiagnosticAlarmType_ClientUserId = 18379,
    InstrumentDiagnosticAlarmType_AddComment_InputArguments = 18383,
    InstrumentDiagnosticAlarmType_ConditionRefresh_InputArguments = 18385,
    InstrumentDiagnosticAlarmType_ConditionRefresh2_InputArguments = 18387,
    InstrumentDiagnosticAlarmType_AckedState = 18388,
    InstrumentDiagnosticAlarmType_AckedState_Id = 18389,
    InstrumentDiagnosticAlarmType_AckedState_Name = 18390,
    InstrumentDiagnosticAlarmType_AckedState_Number = 18391,
    InstrumentDiagnosticAlarmType_AckedState_EffectiveDisplayName = 18392,
    InstrumentDiagnosticAlarmType_AckedState_TransitionTime = 18393,
    InstrumentDiagnosticAlarmType_AckedState_EffectiveTransitionTime = 18394,
    InstrumentDiagnosticAlarmType_AckedState_TrueState = 18395,
    InstrumentDiagnosticAlarmType_AckedState_FalseState = 18396,
    InstrumentDiagnosticAlarmType_ConfirmedState = 18397,
    InstrumentDiagnosticAlarmType_ConfirmedState_Id = 18398,
    InstrumentDiagnosticAlarmType_ConfirmedState_Name = 18399,
    InstrumentDiagnosticAlarmType_ConfirmedState_Number = 18400,
    InstrumentDiagnosticAlarmType_ConfirmedState_EffectiveDisplayName = 18401,
    InstrumentDiagnosticAlarmType_ConfirmedState_TransitionTime = 18402,
    InstrumentDiagnosticAlarmType_ConfirmedState_EffectiveTransitionTime = 18403,
    InstrumentDiagnosticAlarmType_ConfirmedState_TrueState = 18404,
    InstrumentDiagnosticAlarmType_ConfirmedState_FalseState = 18405,
    InstrumentDiagnosticAlarmType_Acknowledge_InputArguments = 18407,
    InstrumentDiagnosticAlarmType_Confirm_InputArguments = 18409,
    InstrumentDiagnosticAlarmType_ActiveState = 18410,
    InstrumentDiagnosticAlarmType_ActiveState_Id = 18411,
    InstrumentDiagnosticAlarmType_ActiveState_Name = 18412,
    InstrumentDiagnosticAlarmType_ActiveState_Number = 18413,
    InstrumentDiagnosticAlarmType_ActiveState_EffectiveDisplayName = 18414,
    InstrumentDiagnosticAlarmType_ActiveState_TransitionTime = 18415,
    InstrumentDiagnosticAlarmType_ActiveState_EffectiveTransitionTime = 18416,
    InstrumentDiagnosticAlarmType_ActiveState_TrueState = 18417,
    InstrumentDiagnosticAlarmType_ActiveState_FalseState = 18418,
    InstrumentDiagnosticAlarmType_InputNode = 18419,
    InstrumentDiagnosticAlarmType_SuppressedState = 18420,
    InstrumentDiagnosticAlarmType_SuppressedState_Id = 18421,
    InstrumentDiagnosticAlarmType_SuppressedState_Name = 18422,
    InstrumentDiagnosticAlarmType_SuppressedState_Number = 18423,
    InstrumentDiagnosticAlarmType_SuppressedState_EffectiveDisplayName = 18424,
    InstrumentDiagnosticAlarmType_SuppressedState_TransitionTime = 18425,
    InstrumentDiagnosticAlarmType_SuppressedState_EffectiveTransitionTime = 18426,
    InstrumentDiagnosticAlarmType_SuppressedState_TrueState = 18427,
    InstrumentDiagnosticAlarmType_SuppressedState_FalseState = 18428,
    InstrumentDiagnosticAlarmType_OutOfServiceState = 18429,
    InstrumentDiagnosticAlarmType_OutOfServiceState_Id = 18430,
    InstrumentDiagnosticAlarmType_OutOfServiceState_Name = 18431,
    InstrumentDiagnosticAlarmType_OutOfServiceState_Number = 18432,
    InstrumentDiagnosticAlarmType_OutOfServiceState_EffectiveDisplayName = 18433,
    InstrumentDiagnosticAlarmType_OutOfServiceState_TransitionTime = 18434,
    InstrumentDiagnosticAlarmType_OutOfServiceState_EffectiveTransitionTime = 18435,
    InstrumentDiagnosticAlarmType_OutOfServiceState_TrueState = 18436,
    InstrumentDiagnosticAlarmType_OutOfServiceState_FalseState = 18437,
    InstrumentDiagnosticAlarmType_ShelvingState_CurrentState = 18439,
    InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Id = 18440,
    InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Name = 18441,
    InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Number = 18442,
    InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 18443,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition = 18444,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Id = 18445,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Name = 18446,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Number = 18447,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_TransitionTime = 18448,
    InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 18449,
    InstrumentDiagnosticAlarmType_ShelvingState_AvailableStates = 18450,
    InstrumentDiagnosticAlarmType_ShelvingState_AvailableTransitions = 18451,
    InstrumentDiagnosticAlarmType_ShelvingState_UnshelveTime = 18452,
    InstrumentDiagnosticAlarmType_ShelvingState_TimedShelve_InputArguments = 18454,
    InstrumentDiagnosticAlarmType_SuppressedOrShelved = 18457,
    InstrumentDiagnosticAlarmType_MaxTimeShelved = 18458,
    InstrumentDiagnosticAlarmType_AudibleEnabled = 18459,
    InstrumentDiagnosticAlarmType_AudibleSound = 18460,
    InstrumentDiagnosticAlarmType_AudibleSound_ListId = 18461,
    InstrumentDiagnosticAlarmType_AudibleSound_AgencyId = 18462,
    InstrumentDiagnosticAlarmType_AudibleSound_VersionId = 18463,
    InstrumentDiagnosticAlarmType_SilenceState = 18464,
    InstrumentDiagnosticAlarmType_SilenceState_Id = 18465,
    InstrumentDiagnosticAlarmType_SilenceState_Name = 18466,
    InstrumentDiagnosticAlarmType_SilenceState_Number = 18467,
    InstrumentDiagnosticAlarmType_SilenceState_EffectiveDisplayName = 18468,
    InstrumentDiagnosticAlarmType_SilenceState_TransitionTime = 18469,
    InstrumentDiagnosticAlarmType_SilenceState_EffectiveTransitionTime = 18470,
    InstrumentDiagnosticAlarmType_SilenceState_TrueState = 18471,
    InstrumentDiagnosticAlarmType_SilenceState_FalseState = 18472,
    InstrumentDiagnosticAlarmType_OnDelay = 18473,
    InstrumentDiagnosticAlarmType_OffDelay = 18474,
    InstrumentDiagnosticAlarmType_FirstInGroupFlag = 18475,
    InstrumentDiagnosticAlarmType_LatchedState = 18477,
    InstrumentDiagnosticAlarmType_LatchedState_Id = 18478,
    InstrumentDiagnosticAlarmType_LatchedState_Name = 18479,
    InstrumentDiagnosticAlarmType_LatchedState_Number = 18480,
    InstrumentDiagnosticAlarmType_LatchedState_EffectiveDisplayName = 18481,
    InstrumentDiagnosticAlarmType_LatchedState_TransitionTime = 18482,
    InstrumentDiagnosticAlarmType_LatchedState_EffectiveTransitionTime = 18483,
    InstrumentDiagnosticAlarmType_LatchedState_TrueState = 18484,
    InstrumentDiagnosticAlarmType_LatchedState_FalseState = 18485,
    InstrumentDiagnosticAlarmType_ReAlarmTime = 18487,
    InstrumentDiagnosticAlarmType_ReAlarmRepeatCount = 18488,
    InstrumentDiagnosticAlarmType_NormalState = 18495,
    SystemDiagnosticAlarmType_EventId = 18497,
    SystemDiagnosticAlarmType_EventType = 18498,
    SystemDiagnosticAlarmType_SourceNode = 18499,
    SystemDiagnosticAlarmType_SourceName = 18500,
    SystemDiagnosticAlarmType_Time = 18501,
    SystemDiagnosticAlarmType_ReceiveTime = 18502,
    SystemDiagnosticAlarmType_LocalTime = 18503,
    SystemDiagnosticAlarmType_Message = 18504,
    SystemDiagnosticAlarmType_Severity = 18505,
    SystemDiagnosticAlarmType_ConditionClassId = 18506,
    SystemDiagnosticAlarmType_ConditionClassName = 18507,
    SystemDiagnosticAlarmType_ConditionSubClassId = 18508,
    SystemDiagnosticAlarmType_ConditionSubClassName = 18509,
    SystemDiagnosticAlarmType_ConditionName = 18510,
    SystemDiagnosticAlarmType_BranchId = 18511,
    SystemDiagnosticAlarmType_Retain = 18512,
    SystemDiagnosticAlarmType_EnabledState = 18513,
    SystemDiagnosticAlarmType_EnabledState_Id = 18514,
    SystemDiagnosticAlarmType_EnabledState_Name = 18515,
    SystemDiagnosticAlarmType_EnabledState_Number = 18516,
    SystemDiagnosticAlarmType_EnabledState_EffectiveDisplayName = 18517,
    SystemDiagnosticAlarmType_EnabledState_TransitionTime = 18518,
    SystemDiagnosticAlarmType_EnabledState_EffectiveTransitionTime = 18519,
    SystemDiagnosticAlarmType_EnabledState_TrueState = 18520,
    SystemDiagnosticAlarmType_EnabledState_FalseState = 18521,
    SystemDiagnosticAlarmType_Quality = 18522,
    SystemDiagnosticAlarmType_Quality_SourceTimestamp = 18523,
    SystemDiagnosticAlarmType_LastSeverity = 18524,
    SystemDiagnosticAlarmType_LastSeverity_SourceTimestamp = 18525,
    SystemDiagnosticAlarmType_Comment = 18526,
    SystemDiagnosticAlarmType_Comment_SourceTimestamp = 18527,
    SystemDiagnosticAlarmType_ClientUserId = 18528,
    SystemDiagnosticAlarmType_AddComment_InputArguments = 18532,
    SystemDiagnosticAlarmType_ConditionRefresh_InputArguments = 18534,
    SystemDiagnosticAlarmType_ConditionRefresh2_InputArguments = 18536,
    SystemDiagnosticAlarmType_AckedState = 18537,
    SystemDiagnosticAlarmType_AckedState_Id = 18538,
    SystemDiagnosticAlarmType_AckedState_Name = 18539,
    SystemDiagnosticAlarmType_AckedState_Number = 18540,
    SystemDiagnosticAlarmType_AckedState_EffectiveDisplayName = 18541,
    SystemDiagnosticAlarmType_AckedState_TransitionTime = 18542,
    SystemDiagnosticAlarmType_AckedState_EffectiveTransitionTime = 18543,
    SystemDiagnosticAlarmType_AckedState_TrueState = 18544,
    SystemDiagnosticAlarmType_AckedState_FalseState = 18545,
    SystemDiagnosticAlarmType_ConfirmedState = 18546,
    SystemDiagnosticAlarmType_ConfirmedState_Id = 18547,
    SystemDiagnosticAlarmType_ConfirmedState_Name = 18548,
    SystemDiagnosticAlarmType_ConfirmedState_Number = 18549,
    SystemDiagnosticAlarmType_ConfirmedState_EffectiveDisplayName = 18550,
    SystemDiagnosticAlarmType_ConfirmedState_TransitionTime = 18551,
    SystemDiagnosticAlarmType_ConfirmedState_EffectiveTransitionTime = 18552,
    SystemDiagnosticAlarmType_ConfirmedState_TrueState = 18553,
    SystemDiagnosticAlarmType_ConfirmedState_FalseState = 18554,
    SystemDiagnosticAlarmType_Acknowledge_InputArguments = 18556,
    SystemDiagnosticAlarmType_Confirm_InputArguments = 18558,
    SystemDiagnosticAlarmType_ActiveState = 18559,
    SystemDiagnosticAlarmType_ActiveState_Id = 18560,
    SystemDiagnosticAlarmType_ActiveState_Name = 18561,
    SystemDiagnosticAlarmType_ActiveState_Number = 18562,
    SystemDiagnosticAlarmType_ActiveState_EffectiveDisplayName = 18563,
    SystemDiagnosticAlarmType_ActiveState_TransitionTime = 18564,
    SystemDiagnosticAlarmType_ActiveState_EffectiveTransitionTime = 18565,
    SystemDiagnosticAlarmType_ActiveState_TrueState = 18566,
    SystemDiagnosticAlarmType_ActiveState_FalseState = 18567,
    SystemDiagnosticAlarmType_InputNode = 18568,
    SystemDiagnosticAlarmType_SuppressedState = 18569,
    SystemDiagnosticAlarmType_SuppressedState_Id = 18570,
    SystemDiagnosticAlarmType_SuppressedState_Name = 18571,
    SystemDiagnosticAlarmType_SuppressedState_Number = 18572,
    SystemDiagnosticAlarmType_SuppressedState_EffectiveDisplayName = 18573,
    SystemDiagnosticAlarmType_SuppressedState_TransitionTime = 18574,
    SystemDiagnosticAlarmType_SuppressedState_EffectiveTransitionTime = 18575,
    SystemDiagnosticAlarmType_SuppressedState_TrueState = 18576,
    SystemDiagnosticAlarmType_SuppressedState_FalseState = 18577,
    SystemDiagnosticAlarmType_OutOfServiceState = 18578,
    SystemDiagnosticAlarmType_OutOfServiceState_Id = 18579,
    SystemDiagnosticAlarmType_OutOfServiceState_Name = 18580,
    SystemDiagnosticAlarmType_OutOfServiceState_Number = 18581,
    SystemDiagnosticAlarmType_OutOfServiceState_EffectiveDisplayName = 18582,
    SystemDiagnosticAlarmType_OutOfServiceState_TransitionTime = 18583,
    SystemDiagnosticAlarmType_OutOfServiceState_EffectiveTransitionTime = 18584,
    SystemDiagnosticAlarmType_OutOfServiceState_TrueState = 18585,
    SystemDiagnosticAlarmType_OutOfServiceState_FalseState = 18586,
    SystemDiagnosticAlarmType_ShelvingState_CurrentState = 18588,
    SystemDiagnosticAlarmType_ShelvingState_CurrentState_Id = 18589,
    SystemDiagnosticAlarmType_ShelvingState_CurrentState_Name = 18590,
    SystemDiagnosticAlarmType_ShelvingState_CurrentState_Number = 18591,
    SystemDiagnosticAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 18592,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition = 18593,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition_Id = 18594,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition_Name = 18595,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition_Number = 18596,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition_TransitionTime = 18597,
    SystemDiagnosticAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 18598,
    SystemDiagnosticAlarmType_ShelvingState_AvailableStates = 18599,
    SystemDiagnosticAlarmType_ShelvingState_AvailableTransitions = 18600,
    SystemDiagnosticAlarmType_ShelvingState_UnshelveTime = 18601,
    SystemDiagnosticAlarmType_ShelvingState_TimedShelve_InputArguments = 18603,
    SystemDiagnosticAlarmType_SuppressedOrShelved = 18606,
    SystemDiagnosticAlarmType_MaxTimeShelved = 18607,
    SystemDiagnosticAlarmType_AudibleEnabled = 18608,
    SystemDiagnosticAlarmType_AudibleSound = 18609,
    SystemDiagnosticAlarmType_AudibleSound_ListId = 18610,
    SystemDiagnosticAlarmType_AudibleSound_AgencyId = 18611,
    SystemDiagnosticAlarmType_AudibleSound_VersionId = 18612,
    SystemDiagnosticAlarmType_SilenceState = 18613,
    SystemDiagnosticAlarmType_SilenceState_Id = 18614,
    SystemDiagnosticAlarmType_SilenceState_Name = 18615,
    SystemDiagnosticAlarmType_SilenceState_Number = 18616,
    SystemDiagnosticAlarmType_SilenceState_EffectiveDisplayName = 18617,
    SystemDiagnosticAlarmType_SilenceState_TransitionTime = 18618,
    SystemDiagnosticAlarmType_SilenceState_EffectiveTransitionTime = 18619,
    SystemDiagnosticAlarmType_SilenceState_TrueState = 18620,
    SystemDiagnosticAlarmType_SilenceState_FalseState = 18621,
    SystemDiagnosticAlarmType_OnDelay = 18622,
    SystemDiagnosticAlarmType_OffDelay = 18623,
    SystemDiagnosticAlarmType_FirstInGroupFlag = 18624,
    SystemDiagnosticAlarmType_LatchedState = 18626,
    SystemDiagnosticAlarmType_LatchedState_Id = 18627,
    SystemDiagnosticAlarmType_LatchedState_Name = 18628,
    SystemDiagnosticAlarmType_LatchedState_Number = 18629,
    SystemDiagnosticAlarmType_LatchedState_EffectiveDisplayName = 18630,
    SystemDiagnosticAlarmType_LatchedState_TransitionTime = 18631,
    SystemDiagnosticAlarmType_LatchedState_EffectiveTransitionTime = 18632,
    SystemDiagnosticAlarmType_LatchedState_TrueState = 18633,
    SystemDiagnosticAlarmType_LatchedState_FalseState = 18634,
    SystemDiagnosticAlarmType_ReAlarmTime = 18636,
    SystemDiagnosticAlarmType_ReAlarmRepeatCount = 18637,
    SystemDiagnosticAlarmType_NormalState = 18644,
    CertificateExpirationAlarmType_LatchedState = 18645,
    CertificateExpirationAlarmType_LatchedState_Id = 18646,
    CertificateExpirationAlarmType_LatchedState_Name = 18647,
    CertificateExpirationAlarmType_LatchedState_Number = 18648,
    CertificateExpirationAlarmType_LatchedState_EffectiveDisplayName = 18649,
    CertificateExpirationAlarmType_LatchedState_TransitionTime = 18650,
    CertificateExpirationAlarmType_LatchedState_EffectiveTransitionTime = 18651,
    CertificateExpirationAlarmType_LatchedState_TrueState = 18652,
    CertificateExpirationAlarmType_LatchedState_FalseState = 18653,
    DiscrepancyAlarmType_LatchedState = 18655,
    DiscrepancyAlarmType_LatchedState_Id = 18656,
    DiscrepancyAlarmType_LatchedState_Name = 18657,
    DiscrepancyAlarmType_LatchedState_Number = 18658,
    DiscrepancyAlarmType_LatchedState_EffectiveDisplayName = 18659,
    DiscrepancyAlarmType_LatchedState_TransitionTime = 18660,
    DiscrepancyAlarmType_LatchedState_EffectiveTransitionTime = 18661,
    DiscrepancyAlarmType_LatchedState_TrueState = 18662,
    DiscrepancyAlarmType_LatchedState_FalseState = 18663,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_DiagnosticsLevel = 18668,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation = 18669,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_Active = 18670,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_Classification =
        18671,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        18672,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        18673,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError = 18674,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_Active = 18675,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_Classification = 18676,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel = 18677,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 18678,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_SubError = 18680,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError = 18682,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Active = 18683,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Classification =
        18684,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        18685,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        18686,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        18687,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        18688,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        18689,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        18690,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        18691,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        18692,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        18693,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        18694,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        18695,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        18696,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        18697,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        18698,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        18699,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        18700,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        18701,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        18702,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        18703,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        18704,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        18705,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        18706,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        18707,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        18708,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        18709,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        18710,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        18711,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress = 18713,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel =
        18714,
    PublishSubscribeType_Diagnostics_DiagnosticsLevel = 18716,
    PublishSubscribeType_Diagnostics_TotalInformation = 18717,
    PublishSubscribeType_Diagnostics_TotalInformation_Active = 18718,
    PublishSubscribeType_Diagnostics_TotalInformation_Classification = 18719,
    PublishSubscribeType_Diagnostics_TotalInformation_DiagnosticsLevel = 18720,
    PublishSubscribeType_Diagnostics_TotalInformation_TimeFirstChange = 18721,
    PublishSubscribeType_Diagnostics_TotalError = 18722,
    PublishSubscribeType_Diagnostics_TotalError_Active = 18723,
    PublishSubscribeType_Diagnostics_TotalError_Classification = 18724,
    PublishSubscribeType_Diagnostics_TotalError_DiagnosticsLevel = 18725,
    PublishSubscribeType_Diagnostics_TotalError_TimeFirstChange = 18726,
    PublishSubscribeType_Diagnostics_SubError = 18728,
    PublishSubscribeType_Diagnostics_Counters_StateError = 18730,
    PublishSubscribeType_Diagnostics_Counters_StateError_Active = 18731,
    PublishSubscribeType_Diagnostics_Counters_StateError_Classification = 18732,
    PublishSubscribeType_Diagnostics_Counters_StateError_DiagnosticsLevel = 18733,
    PublishSubscribeType_Diagnostics_Counters_StateError_TimeFirstChange = 18734,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod = 18735,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_Active = 18736,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_Classification = 18737,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 18738,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 18739,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent = 18740,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_Active = 18741,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_Classification = 18742,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 18743,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 18744,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError = 18745,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_Active = 18746,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_Classification = 18747,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 18748,
    PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 18749,
    PublishSubscribeType_Diagnostics_Counters_StatePausedByParent = 18750,
    PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_Active = 18751,
    PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_Classification = 18752,
    PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 18753,
    PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 18754,
    PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod = 18755,
    PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_Active = 18756,
    PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_Classification = 18757,
    PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 18758,
    PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 18759,
    PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetWriters = 18761,
    PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel = 18762,
    PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetReaders = 18763,
    PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel = 18764,
    PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetWriters = 18765,
    PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel = 18766,
    PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetReaders = 18767,
    PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel = 18768,
    ThreeDVectorType_X = 18769,
    ThreeDVectorType_Y = 18770,
    ThreeDVectorType_Z = 18771,
    CartesianCoordinatesType_LengthUnit = 18773,
    ThreeDCartesianCoordinatesType_LengthUnit = 18775,
    ThreeDCartesianCoordinatesType_X = 18776,
    ThreeDCartesianCoordinatesType_Y = 18777,
    ThreeDCartesianCoordinatesType_Z = 18778,
    OrientationType_AngleUnit = 18780,
    ThreeDOrientationType_AngleUnit = 18782,
    ThreeDOrientationType_A = 18783,
    ThreeDOrientationType_B = 18784,
    ThreeDOrientationType_C = 18785,
    FrameType_Orientation = 18787,
    FrameType_Constant = 18788,
    FrameType_BaseFrame = 18789,
    FrameType_FixedBase = 18790,
    ThreeDFrameType_Orientation = 18792,
    ThreeDFrameType_Constant = 18793,
    ThreeDFrameType_BaseFrame = 18794,
    ThreeDFrameType_FixedBase = 18795,
    ThreeDFrameType_CartesianCoordinates = 18796,
    ThreeDFrameType_CartesianCoordinates_LengthUnit = 18797,
    ThreeDFrameType_CartesianCoordinates_X = 18798,
    ThreeDFrameType_CartesianCoordinates_Y = 18799,
    ThreeDFrameType_CartesianCoordinates_Z = 18800,
    FrameType_CartesianCoordinates = 18801,
    FrameType_CartesianCoordinates_LengthUnit = 18802,
    FrameType_Orientation_AngleUnit = 18803,
    OpcUa_BinarySchema_RationalNumber = 18824,
    OpcUa_BinarySchema_RationalNumber_DataTypeVersion = 18825,
    OpcUa_BinarySchema_RationalNumber_DictionaryFragment = 18826,
    OpcUa_BinarySchema_Vector = 18827,
    OpcUa_BinarySchema_Vector_DataTypeVersion = 18828,
    OpcUa_BinarySchema_Vector_DictionaryFragment = 18829,
    OpcUa_BinarySchema_ThreeDVector = 18830,
    OpcUa_BinarySchema_ThreeDVector_DataTypeVersion = 18831,
    OpcUa_BinarySchema_ThreeDVector_DictionaryFragment = 18832,
    OpcUa_BinarySchema_CartesianCoordinates = 18833,
    OpcUa_BinarySchema_CartesianCoordinates_DataTypeVersion = 18834,
    OpcUa_BinarySchema_CartesianCoordinates_DictionaryFragment = 18835,
    OpcUa_BinarySchema_ThreeDCartesianCoordinates = 18836,
    OpcUa_BinarySchema_ThreeDCartesianCoordinates_DataTypeVersion = 18837,
    OpcUa_BinarySchema_ThreeDCartesianCoordinates_DictionaryFragment = 18838,
    OpcUa_BinarySchema_Orientation = 18839,
    OpcUa_BinarySchema_Orientation_DataTypeVersion = 18840,
    OpcUa_BinarySchema_Orientation_DictionaryFragment = 18841,
    OpcUa_BinarySchema_ThreeDOrientation = 18842,
    OpcUa_BinarySchema_ThreeDOrientation_DataTypeVersion = 18843,
    OpcUa_BinarySchema_ThreeDOrientation_DictionaryFragment = 18844,
    OpcUa_BinarySchema_Frame = 18845,
    OpcUa_BinarySchema_Frame_DataTypeVersion = 18846,
    OpcUa_BinarySchema_Frame_DictionaryFragment = 18847,
    OpcUa_BinarySchema_ThreeDFrame = 18848,
    OpcUa_BinarySchema_ThreeDFrame_DataTypeVersion = 18849,
    OpcUa_BinarySchema_ThreeDFrame_DictionaryFragment = 18850,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel = 18872,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation = 18873,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active = 18874,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification =
        18875,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        18876,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        18877,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError = 18878,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active = 18879,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification =
        18880,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel =
        18881,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange =
        18882,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_SubError = 18884,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError = 18886,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active =
        18887,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification =
        18888,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        18889,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        18890,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        18891,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        18892,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        18893,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        18894,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        18895,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        18896,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        18897,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        18898,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        18899,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        18900,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        18901,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        18902,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        18903,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        18904,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        18905,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        18906,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        18907,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        18908,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        18909,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        18910,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        18911,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        18912,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        18913,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        18914,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        18915,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages =
        18917,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active =
        18918,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification =
        18919,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel =
        18920,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange =
        18921,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber =
        18922,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel =
        18923,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode = 18924,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel =
        18925,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion = 18926,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel =
        18927,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion = 18928,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel =
        18929,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel = 18931,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation = 18932,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active =
        18933,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification =
        18934,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        18935,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        18936,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError = 18937,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active = 18938,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification =
        18939,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel =
        18940,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange =
        18941,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_SubError = 18943,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError = 18945,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active =
        18946,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification =
        18947,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        18948,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        18949,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        18950,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        18951,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        18952,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        18953,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        18954,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        18955,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        18956,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        18957,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        18958,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        18959,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        18960,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        18961,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        18962,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        18963,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        18964,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        18965,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        18966,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        18967,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        18968,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        18969,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        18970,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        18971,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        18972,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        18973,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        18974,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages =
        18976,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active =
        18977,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification =
        18978,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel =
        18979,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange =
        18980,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber =
        18981,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel =
        18982,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode = 18983,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel =
        18984,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion =
        18985,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel =
        18986,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion =
        18987,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel =
        18988,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel = 18990,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation = 18991,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active = 18992,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification =
        18993,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        18994,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        18995,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError = 18996,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active = 18997,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification = 18998,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel =
        18999,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange =
        19000,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_SubError = 19002,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError = 19004,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active =
        19005,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification =
        19006,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        19007,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        19008,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        19009,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        19010,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        19011,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        19012,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        19013,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        19014,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        19015,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        19016,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        19017,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        19018,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        19019,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        19020,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        19021,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        19022,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        19023,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        19024,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        19025,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        19026,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        19027,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        19028,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        19029,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        19030,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        19031,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        19032,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        19033,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages =
        19035,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active =
        19036,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification =
        19037,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel =
        19038,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange =
        19039,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber =
        19040,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel =
        19041,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode = 19042,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel =
        19043,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion = 19044,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel =
        19045,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion = 19046,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel =
        19047,
    ThreeDFrameType_Orientation_AngleUnit = 19073,
    ThreeDFrameType_Orientation_A = 19074,
    ThreeDFrameType_Orientation_B = 19075,
    ThreeDFrameType_Orientation_C = 19076,
    MultiStateDictionaryEntryDiscreteBaseType_Definition = 19078,
    MultiStateDictionaryEntryDiscreteBaseType_ValuePrecision = 19079,
    MultiStateDictionaryEntryDiscreteBaseType_EnumValues = 19080,
    MultiStateDictionaryEntryDiscreteBaseType_ValueAsText = 19081,
    MultiStateDictionaryEntryDiscreteBaseType_EnumDictionaryEntries = 19082,
    MultiStateDictionaryEntryDiscreteBaseType_ValueAsDictionaryEntries = 19083,
    MultiStateDictionaryEntryDiscreteType_Definition = 19085,
    MultiStateDictionaryEntryDiscreteType_ValuePrecision = 19086,
    MultiStateDictionaryEntryDiscreteType_EnumValues = 19087,
    MultiStateDictionaryEntryDiscreteType_ValueAsText = 19088,
    MultiStateDictionaryEntryDiscreteType_EnumDictionaryEntries = 19089,
    MultiStateDictionaryEntryDiscreteType_ValueAsDictionaryEntries = 19090,
    HistoryServerCapabilities_ServerTimestampSupported = 19091,
    HistoricalDataConfigurationType_ServerTimestampSupported = 19092,
    HAConfiguration_ServerTimestampSupported = 19093,
    HistoryServerCapabilitiesType_ServerTimestampSupported = 19094,
    AuditHistoryAnnotationUpdateEventType_EventId = 19096,
    AuditHistoryAnnotationUpdateEventType_EventType = 19097,
    AuditHistoryAnnotationUpdateEventType_SourceNode = 19098,
    AuditHistoryAnnotationUpdateEventType_SourceName = 19099,
    AuditHistoryAnnotationUpdateEventType_Time = 19100,
    AuditHistoryAnnotationUpdateEventType_ReceiveTime = 19101,
    AuditHistoryAnnotationUpdateEventType_LocalTime = 19102,
    AuditHistoryAnnotationUpdateEventType_Message = 19103,
    AuditHistoryAnnotationUpdateEventType_Severity = 19104,
    AuditHistoryAnnotationUpdateEventType_ActionTimeStamp = 19105,
    AuditHistoryAnnotationUpdateEventType_Status = 19106,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_DiagnosticsLevel = 19108,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation = 19109,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_Active = 19110,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_Classification =
        19111,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        19112,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        19113,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError = 19114,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_Active = 19115,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_Classification = 19116,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel =
        19117,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 19118,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_SubError = 19120,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError = 19122,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_Active = 19123,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_Classification =
        19124,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        19125,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        19126,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        19127,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        19128,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        19129,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        19130,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        19131,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        19132,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        19133,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        19134,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        19135,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        19136,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        19137,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        19138,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        19139,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        19140,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        19141,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        19142,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        19143,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        19144,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        19145,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        19146,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        19147,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        19148,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        19149,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        19150,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        19151,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages =
        19153,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_Active =
        19154,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_Classification =
        19155,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_DiagnosticsLevel =
        19156,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_TimeFirstChange =
        19157,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions =
        19158,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_Active =
        19159,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_Classification =
        19160,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_DiagnosticsLevel =
        19161,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_TimeFirstChange =
        19162,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors = 19163,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_Active =
        19164,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_Classification =
        19165,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_DiagnosticsLevel =
        19166,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_TimeFirstChange =
        19167,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetWriters =
        19168,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel =
        19169,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetWriters =
        19170,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel =
        19171,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_SecurityTokenID = 19172,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel =
        19173,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID =
        19174,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel =
        19175,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_DiagnosticsLevel = 19177,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation = 19178,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_Active = 19179,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_Classification =
        19180,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel =
        19181,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange =
        19182,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError = 19183,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_Active = 19184,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_Classification = 19185,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel =
        19186,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_TimeFirstChange = 19187,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_SubError = 19189,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError = 19191,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_Active = 19192,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_Classification =
        19193,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel =
        19194,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange =
        19195,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod =
        19196,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active =
        19197,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification =
        19198,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel =
        19199,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange =
        19200,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent =
        19201,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active =
        19202,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification =
        19203,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel =
        19204,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange =
        19205,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError =
        19206,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active =
        19207,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification =
        19208,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel =
        19209,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange =
        19210,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent =
        19211,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active =
        19212,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification =
        19213,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel =
        19214,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange =
        19215,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod =
        19216,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active =
        19217,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification =
        19218,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel =
        19219,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange =
        19220,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages =
        19222,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_Active =
        19223,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_Classification =
        19224,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_DiagnosticsLevel =
        19225,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_TimeFirstChange =
        19226,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages =
        19227,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Active =
        19228,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Classification =
        19229,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel =
        19230,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange =
        19231,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors = 19232,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_Active =
        19233,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_Classification =
        19234,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel =
        19235,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_TimeFirstChange =
        19236,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetReaders =
        19237,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel =
        19238,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetReaders =
        19239,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel =
        19240,
    PubSubConnectionType_Diagnostics_DiagnosticsLevel = 19242,
    PubSubConnectionType_Diagnostics_TotalInformation = 19243,
    PubSubConnectionType_Diagnostics_TotalInformation_Active = 19244,
    PubSubConnectionType_Diagnostics_TotalInformation_Classification = 19245,
    PubSubConnectionType_Diagnostics_TotalInformation_DiagnosticsLevel = 19246,
    PubSubConnectionType_Diagnostics_TotalInformation_TimeFirstChange = 19247,
    PubSubConnectionType_Diagnostics_TotalError = 19248,
    PubSubConnectionType_Diagnostics_TotalError_Active = 19249,
    PubSubConnectionType_Diagnostics_TotalError_Classification = 19250,
    PubSubConnectionType_Diagnostics_TotalError_DiagnosticsLevel = 19251,
    PubSubConnectionType_Diagnostics_TotalError_TimeFirstChange = 19252,
    PubSubConnectionType_Diagnostics_SubError = 19254,
    PubSubConnectionType_Diagnostics_Counters_StateError = 19256,
    PubSubConnectionType_Diagnostics_Counters_StateError_Active = 19257,
    PubSubConnectionType_Diagnostics_Counters_StateError_Classification = 19258,
    PubSubConnectionType_Diagnostics_Counters_StateError_DiagnosticsLevel = 19259,
    PubSubConnectionType_Diagnostics_Counters_StateError_TimeFirstChange = 19260,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod = 19261,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_Active = 19262,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_Classification = 19263,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 19264,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 19265,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent = 19266,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_Active = 19267,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_Classification = 19268,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 19269,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 19270,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError = 19271,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_Active = 19272,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_Classification = 19273,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 19274,
    PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 19275,
    PubSubConnectionType_Diagnostics_Counters_StatePausedByParent = 19276,
    PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_Active = 19277,
    PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_Classification = 19278,
    PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 19279,
    PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 19280,
    PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod = 19281,
    PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_Active = 19282,
    PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_Classification = 19283,
    PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 19284,
    PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 19285,
    PubSubConnectionType_Diagnostics_LiveValues_ResolvedAddress = 19287,
    PubSubConnectionType_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel = 19288,
    AuditHistoryAnnotationUpdateEventType_ServerId = 19289,
    AuditHistoryAnnotationUpdateEventType_ClientAuditEntryId = 19290,
    AuditHistoryAnnotationUpdateEventType_ClientUserId = 19291,
    AuditHistoryAnnotationUpdateEventType_ParameterDataTypeId = 19292,
    AuditHistoryAnnotationUpdateEventType_PerformInsertReplace = 19293,
    AuditHistoryAnnotationUpdateEventType_NewValues = 19294,
    AuditHistoryAnnotationUpdateEventType_OldValues = 19295,
    TrustListType_UpdateFrequency = 19296,
    TrustListOutOfDateAlarmType_EventId = 19298,
    TrustListOutOfDateAlarmType_EventType = 19299,
    TrustListOutOfDateAlarmType_SourceNode = 19300,
    TrustListOutOfDateAlarmType_SourceName = 19301,
    TrustListOutOfDateAlarmType_Time = 19302,
    TrustListOutOfDateAlarmType_ReceiveTime = 19303,
    TrustListOutOfDateAlarmType_LocalTime = 19304,
    TrustListOutOfDateAlarmType_Message = 19305,
    TrustListOutOfDateAlarmType_Severity = 19306,
    TrustListOutOfDateAlarmType_ConditionClassId = 19307,
    TrustListOutOfDateAlarmType_ConditionClassName = 19308,
    TrustListOutOfDateAlarmType_ConditionSubClassId = 19309,
    TrustListOutOfDateAlarmType_ConditionSubClassName = 19310,
    TrustListOutOfDateAlarmType_ConditionName = 19311,
    TrustListOutOfDateAlarmType_BranchId = 19312,
    TrustListOutOfDateAlarmType_Retain = 19313,
    TrustListOutOfDateAlarmType_EnabledState = 19314,
    TrustListOutOfDateAlarmType_EnabledState_Id = 19315,
    TrustListOutOfDateAlarmType_EnabledState_Name = 19316,
    TrustListOutOfDateAlarmType_EnabledState_Number = 19317,
    TrustListOutOfDateAlarmType_EnabledState_EffectiveDisplayName = 19318,
    TrustListOutOfDateAlarmType_EnabledState_TransitionTime = 19319,
    TrustListOutOfDateAlarmType_EnabledState_EffectiveTransitionTime = 19320,
    TrustListOutOfDateAlarmType_EnabledState_TrueState = 19321,
    TrustListOutOfDateAlarmType_EnabledState_FalseState = 19322,
    TrustListOutOfDateAlarmType_Quality = 19323,
    TrustListOutOfDateAlarmType_Quality_SourceTimestamp = 19324,
    TrustListOutOfDateAlarmType_LastSeverity = 19325,
    TrustListOutOfDateAlarmType_LastSeverity_SourceTimestamp = 19326,
    TrustListOutOfDateAlarmType_Comment = 19327,
    TrustListOutOfDateAlarmType_Comment_SourceTimestamp = 19328,
    TrustListOutOfDateAlarmType_ClientUserId = 19329,
    TrustListOutOfDateAlarmType_AddComment_InputArguments = 19333,
    TrustListOutOfDateAlarmType_ConditionRefresh_InputArguments = 19335,
    TrustListOutOfDateAlarmType_ConditionRefresh2_InputArguments = 19337,
    TrustListOutOfDateAlarmType_AckedState = 19338,
    TrustListOutOfDateAlarmType_AckedState_Id = 19339,
    TrustListOutOfDateAlarmType_AckedState_Name = 19340,
    TrustListOutOfDateAlarmType_AckedState_Number = 19341,
    TrustListOutOfDateAlarmType_AckedState_EffectiveDisplayName = 19342,
    TrustListOutOfDateAlarmType_AckedState_TransitionTime = 19343,
    TrustListOutOfDateAlarmType_AckedState_EffectiveTransitionTime = 19344,
    TrustListOutOfDateAlarmType_AckedState_TrueState = 19345,
    TrustListOutOfDateAlarmType_AckedState_FalseState = 19346,
    TrustListOutOfDateAlarmType_ConfirmedState = 19347,
    TrustListOutOfDateAlarmType_ConfirmedState_Id = 19348,
    TrustListOutOfDateAlarmType_ConfirmedState_Name = 19349,
    TrustListOutOfDateAlarmType_ConfirmedState_Number = 19350,
    TrustListOutOfDateAlarmType_ConfirmedState_EffectiveDisplayName = 19351,
    TrustListOutOfDateAlarmType_ConfirmedState_TransitionTime = 19352,
    TrustListOutOfDateAlarmType_ConfirmedState_EffectiveTransitionTime = 19353,
    TrustListOutOfDateAlarmType_ConfirmedState_TrueState = 19354,
    TrustListOutOfDateAlarmType_ConfirmedState_FalseState = 19355,
    TrustListOutOfDateAlarmType_Acknowledge_InputArguments = 19357,
    TrustListOutOfDateAlarmType_Confirm_InputArguments = 19359,
    TrustListOutOfDateAlarmType_ActiveState = 19360,
    TrustListOutOfDateAlarmType_ActiveState_Id = 19361,
    TrustListOutOfDateAlarmType_ActiveState_Name = 19362,
    TrustListOutOfDateAlarmType_ActiveState_Number = 19363,
    TrustListOutOfDateAlarmType_ActiveState_EffectiveDisplayName = 19364,
    TrustListOutOfDateAlarmType_ActiveState_TransitionTime = 19365,
    TrustListOutOfDateAlarmType_ActiveState_EffectiveTransitionTime = 19366,
    TrustListOutOfDateAlarmType_ActiveState_TrueState = 19367,
    TrustListOutOfDateAlarmType_ActiveState_FalseState = 19368,
    TrustListOutOfDateAlarmType_InputNode = 19369,
    TrustListOutOfDateAlarmType_SuppressedState = 19370,
    TrustListOutOfDateAlarmType_SuppressedState_Id = 19371,
    TrustListOutOfDateAlarmType_SuppressedState_Name = 19372,
    TrustListOutOfDateAlarmType_SuppressedState_Number = 19373,
    TrustListOutOfDateAlarmType_SuppressedState_EffectiveDisplayName = 19374,
    TrustListOutOfDateAlarmType_SuppressedState_TransitionTime = 19375,
    TrustListOutOfDateAlarmType_SuppressedState_EffectiveTransitionTime = 19376,
    TrustListOutOfDateAlarmType_SuppressedState_TrueState = 19377,
    TrustListOutOfDateAlarmType_SuppressedState_FalseState = 19378,
    TrustListOutOfDateAlarmType_OutOfServiceState = 19379,
    TrustListOutOfDateAlarmType_OutOfServiceState_Id = 19380,
    TrustListOutOfDateAlarmType_OutOfServiceState_Name = 19381,
    TrustListOutOfDateAlarmType_OutOfServiceState_Number = 19382,
    TrustListOutOfDateAlarmType_OutOfServiceState_EffectiveDisplayName = 19383,
    TrustListOutOfDateAlarmType_OutOfServiceState_TransitionTime = 19384,
    TrustListOutOfDateAlarmType_OutOfServiceState_EffectiveTransitionTime = 19385,
    TrustListOutOfDateAlarmType_OutOfServiceState_TrueState = 19386,
    TrustListOutOfDateAlarmType_OutOfServiceState_FalseState = 19387,
    TrustListOutOfDateAlarmType_ShelvingState_CurrentState = 19389,
    TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Id = 19390,
    TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Name = 19391,
    TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Number = 19392,
    TrustListOutOfDateAlarmType_ShelvingState_CurrentState_EffectiveDisplayName = 19393,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition = 19394,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Id = 19395,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Name = 19396,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Number = 19397,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition_TransitionTime = 19398,
    TrustListOutOfDateAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime = 19399,
    TrustListOutOfDateAlarmType_ShelvingState_AvailableStates = 19400,
    TrustListOutOfDateAlarmType_ShelvingState_AvailableTransitions = 19401,
    TrustListOutOfDateAlarmType_ShelvingState_UnshelveTime = 19402,
    TrustListOutOfDateAlarmType_ShelvingState_TimedShelve_InputArguments = 19404,
    TrustListOutOfDateAlarmType_SuppressedOrShelved = 19407,
    TrustListOutOfDateAlarmType_MaxTimeShelved = 19408,
    TrustListOutOfDateAlarmType_AudibleEnabled = 19409,
    TrustListOutOfDateAlarmType_AudibleSound = 19410,
    TrustListOutOfDateAlarmType_AudibleSound_ListId = 19411,
    TrustListOutOfDateAlarmType_AudibleSound_AgencyId = 19412,
    TrustListOutOfDateAlarmType_AudibleSound_VersionId = 19413,
    TrustListOutOfDateAlarmType_SilenceState = 19414,
    TrustListOutOfDateAlarmType_SilenceState_Id = 19415,
    TrustListOutOfDateAlarmType_SilenceState_Name = 19416,
    TrustListOutOfDateAlarmType_SilenceState_Number = 19417,
    TrustListOutOfDateAlarmType_SilenceState_EffectiveDisplayName = 19418,
    TrustListOutOfDateAlarmType_SilenceState_TransitionTime = 19419,
    TrustListOutOfDateAlarmType_SilenceState_EffectiveTransitionTime = 19420,
    TrustListOutOfDateAlarmType_SilenceState_TrueState = 19421,
    TrustListOutOfDateAlarmType_SilenceState_FalseState = 19422,
    TrustListOutOfDateAlarmType_OnDelay = 19423,
    TrustListOutOfDateAlarmType_OffDelay = 19424,
    TrustListOutOfDateAlarmType_FirstInGroupFlag = 19425,
    TrustListOutOfDateAlarmType_LatchedState = 19427,
    TrustListOutOfDateAlarmType_LatchedState_Id = 19428,
    TrustListOutOfDateAlarmType_LatchedState_Name = 19429,
    TrustListOutOfDateAlarmType_LatchedState_Number = 19430,
    TrustListOutOfDateAlarmType_LatchedState_EffectiveDisplayName = 19431,
    TrustListOutOfDateAlarmType_LatchedState_TransitionTime = 19432,
    TrustListOutOfDateAlarmType_LatchedState_EffectiveTransitionTime = 19433,
    TrustListOutOfDateAlarmType_LatchedState_TrueState = 19434,
    TrustListOutOfDateAlarmType_LatchedState_FalseState = 19435,
    TrustListOutOfDateAlarmType_ReAlarmTime = 19437,
    TrustListOutOfDateAlarmType_ReAlarmRepeatCount = 19438,
    TrustListOutOfDateAlarmType_NormalState = 19445,
    TrustListOutOfDateAlarmType_TrustListId = 19446,
    TrustListOutOfDateAlarmType_LastUpdateTime = 19447,
    TrustListOutOfDateAlarmType_UpdateFrequency = 19448,
    CertificateGroupType_TrustList_UpdateFrequency = 19449,
    CertificateGroupType_CertificateExpired_EventId = 19451,
    CertificateGroupType_CertificateExpired_EventType = 19452,
    CertificateGroupType_CertificateExpired_SourceNode = 19453,
    CertificateGroupType_CertificateExpired_SourceName = 19454,
    CertificateGroupType_CertificateExpired_Time = 19455,
    CertificateGroupType_CertificateExpired_ReceiveTime = 19456,
    CertificateGroupType_CertificateExpired_LocalTime = 19457,
    CertificateGroupType_CertificateExpired_Message = 19458,
    CertificateGroupType_CertificateExpired_Severity = 19459,
    CertificateGroupType_CertificateExpired_ConditionClassId = 19460,
    CertificateGroupType_CertificateExpired_ConditionClassName = 19461,
    CertificateGroupType_CertificateExpired_ConditionSubClassId = 19462,
    CertificateGroupType_CertificateExpired_ConditionSubClassName = 19463,
    CertificateGroupType_CertificateExpired_ConditionName = 19464,
    CertificateGroupType_CertificateExpired_BranchId = 19465,
    CertificateGroupType_CertificateExpired_Retain = 19466,
    CertificateGroupType_CertificateExpired_EnabledState = 19467,
    CertificateGroupType_CertificateExpired_EnabledState_Id = 19468,
    CertificateGroupType_CertificateExpired_EnabledState_Name = 19469,
    CertificateGroupType_CertificateExpired_EnabledState_Number = 19470,
    CertificateGroupType_CertificateExpired_EnabledState_EffectiveDisplayName = 19471,
    CertificateGroupType_CertificateExpired_EnabledState_TransitionTime = 19472,
    CertificateGroupType_CertificateExpired_EnabledState_EffectiveTransitionTime = 19473,
    CertificateGroupType_CertificateExpired_EnabledState_TrueState = 19474,
    CertificateGroupType_CertificateExpired_EnabledState_FalseState = 19475,
    CertificateGroupType_CertificateExpired_Quality = 19476,
    CertificateGroupType_CertificateExpired_Quality_SourceTimestamp = 19477,
    CertificateGroupType_CertificateExpired_LastSeverity = 19478,
    CertificateGroupType_CertificateExpired_LastSeverity_SourceTimestamp = 19479,
    CertificateGroupType_CertificateExpired_Comment = 19480,
    CertificateGroupType_CertificateExpired_Comment_SourceTimestamp = 19481,
    CertificateGroupType_CertificateExpired_ClientUserId = 19482,
    CertificateGroupType_CertificateExpired_AddComment_InputArguments = 19486,
    CertificateGroupType_CertificateExpired_AckedState = 19487,
    CertificateGroupType_CertificateExpired_AckedState_Id = 19488,
    CertificateGroupType_CertificateExpired_AckedState_Name = 19489,
    CertificateGroupType_CertificateExpired_AckedState_Number = 19490,
    CertificateGroupType_CertificateExpired_AckedState_EffectiveDisplayName = 19491,
    CertificateGroupType_CertificateExpired_AckedState_TransitionTime = 19492,
    CertificateGroupType_CertificateExpired_AckedState_EffectiveTransitionTime = 19493,
    CertificateGroupType_CertificateExpired_AckedState_TrueState = 19494,
    CertificateGroupType_CertificateExpired_AckedState_FalseState = 19495,
    CertificateGroupType_CertificateExpired_ConfirmedState = 19496,
    CertificateGroupType_CertificateExpired_ConfirmedState_Id = 19497,
    CertificateGroupType_CertificateExpired_ConfirmedState_Name = 19498,
    CertificateGroupType_CertificateExpired_ConfirmedState_Number = 19499,
    CertificateGroupType_CertificateExpired_ConfirmedState_EffectiveDisplayName = 19500,
    CertificateGroupType_CertificateExpired_ConfirmedState_TransitionTime = 19501,
    CertificateGroupType_CertificateExpired_ConfirmedState_EffectiveTransitionTime = 19502,
    CertificateGroupType_CertificateExpired_ConfirmedState_TrueState = 19503,
    CertificateGroupType_CertificateExpired_ConfirmedState_FalseState = 19504,
    CertificateGroupType_CertificateExpired_Acknowledge_InputArguments = 19506,
    CertificateGroupType_CertificateExpired_Confirm_InputArguments = 19508,
    CertificateGroupType_CertificateExpired_ActiveState = 19509,
    CertificateGroupType_CertificateExpired_ActiveState_Id = 19510,
    CertificateGroupType_CertificateExpired_ActiveState_Name = 19511,
    CertificateGroupType_CertificateExpired_ActiveState_Number = 19512,
    CertificateGroupType_CertificateExpired_ActiveState_EffectiveDisplayName = 19513,
    CertificateGroupType_CertificateExpired_ActiveState_TransitionTime = 19514,
    CertificateGroupType_CertificateExpired_ActiveState_EffectiveTransitionTime = 19515,
    CertificateGroupType_CertificateExpired_ActiveState_TrueState = 19516,
    CertificateGroupType_CertificateExpired_ActiveState_FalseState = 19517,
    CertificateGroupType_CertificateExpired_InputNode = 19518,
    CertificateGroupType_CertificateExpired_SuppressedState = 19519,
    CertificateGroupType_CertificateExpired_SuppressedState_Id = 19520,
    CertificateGroupType_CertificateExpired_SuppressedState_Name = 19521,
    CertificateGroupType_CertificateExpired_SuppressedState_Number = 19522,
    CertificateGroupType_CertificateExpired_SuppressedState_EffectiveDisplayName = 19523,
    CertificateGroupType_CertificateExpired_SuppressedState_TransitionTime = 19524,
    CertificateGroupType_CertificateExpired_SuppressedState_EffectiveTransitionTime = 19525,
    CertificateGroupType_CertificateExpired_SuppressedState_TrueState = 19526,
    CertificateGroupType_CertificateExpired_SuppressedState_FalseState = 19527,
    CertificateGroupType_CertificateExpired_OutOfServiceState = 19528,
    CertificateGroupType_CertificateExpired_OutOfServiceState_Id = 19529,
    CertificateGroupType_CertificateExpired_OutOfServiceState_Name = 19530,
    CertificateGroupType_CertificateExpired_OutOfServiceState_Number = 19531,
    CertificateGroupType_CertificateExpired_OutOfServiceState_EffectiveDisplayName = 19532,
    CertificateGroupType_CertificateExpired_OutOfServiceState_TransitionTime = 19533,
    CertificateGroupType_CertificateExpired_OutOfServiceState_EffectiveTransitionTime = 19534,
    CertificateGroupType_CertificateExpired_OutOfServiceState_TrueState = 19535,
    CertificateGroupType_CertificateExpired_OutOfServiceState_FalseState = 19536,
    CertificateGroupType_CertificateExpired_ShelvingState_CurrentState = 19538,
    CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Id = 19539,
    CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Name = 19540,
    CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Number = 19541,
    CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName = 19542,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition = 19543,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Id = 19544,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Name = 19545,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Number = 19546,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_TransitionTime = 19547,
    CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        19548,
    CertificateGroupType_CertificateExpired_ShelvingState_AvailableStates = 19549,
    DataSetWriterType_Diagnostics_DiagnosticsLevel = 19551,
    DataSetWriterType_Diagnostics_TotalInformation = 19552,
    DataSetWriterType_Diagnostics_TotalInformation_Active = 19553,
    DataSetWriterType_Diagnostics_TotalInformation_Classification = 19554,
    DataSetWriterType_Diagnostics_TotalInformation_DiagnosticsLevel = 19555,
    DataSetWriterType_Diagnostics_TotalInformation_TimeFirstChange = 19556,
    DataSetWriterType_Diagnostics_TotalError = 19557,
    DataSetWriterType_Diagnostics_TotalError_Active = 19558,
    DataSetWriterType_Diagnostics_TotalError_Classification = 19559,
    DataSetWriterType_Diagnostics_TotalError_DiagnosticsLevel = 19560,
    DataSetWriterType_Diagnostics_TotalError_TimeFirstChange = 19561,
    DataSetWriterType_Diagnostics_SubError = 19563,
    DataSetWriterType_Diagnostics_Counters_StateError = 19565,
    DataSetWriterType_Diagnostics_Counters_StateError_Active = 19566,
    DataSetWriterType_Diagnostics_Counters_StateError_Classification = 19567,
    DataSetWriterType_Diagnostics_Counters_StateError_DiagnosticsLevel = 19568,
    DataSetWriterType_Diagnostics_Counters_StateError_TimeFirstChange = 19569,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod = 19570,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_Active = 19571,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_Classification = 19572,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 19573,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 19574,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByParent = 19575,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_Active = 19576,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_Classification = 19577,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 19578,
    DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 19579,
    DataSetWriterType_Diagnostics_Counters_StateOperationalFromError = 19580,
    DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_Active = 19581,
    DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_Classification = 19582,
    DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 19583,
    DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 19584,
    DataSetWriterType_Diagnostics_Counters_StatePausedByParent = 19585,
    DataSetWriterType_Diagnostics_Counters_StatePausedByParent_Active = 19586,
    DataSetWriterType_Diagnostics_Counters_StatePausedByParent_Classification = 19587,
    DataSetWriterType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 19588,
    DataSetWriterType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 19589,
    DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod = 19590,
    DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_Active = 19591,
    DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_Classification = 19592,
    DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 19593,
    DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 19594,
    DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages = 19596,
    DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_Active = 19597,
    DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_Classification = 19598,
    DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel = 19599,
    DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange = 19600,
    DataSetWriterType_Diagnostics_LiveValues_MessageSequenceNumber = 19601,
    DataSetWriterType_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel = 19602,
    DataSetWriterType_Diagnostics_LiveValues_StatusCode = 19603,
    DataSetWriterType_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel = 19604,
    DataSetWriterType_Diagnostics_LiveValues_MajorVersion = 19605,
    DataSetWriterType_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel = 19606,
    DataSetWriterType_Diagnostics_LiveValues_MinorVersion = 19607,
    DataSetWriterType_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel = 19608,
    DataSetReaderType_Diagnostics_DiagnosticsLevel = 19610,
    DataSetReaderType_Diagnostics_TotalInformation = 19611,
    DataSetReaderType_Diagnostics_TotalInformation_Active = 19612,
    DataSetReaderType_Diagnostics_TotalInformation_Classification = 19613,
    DataSetReaderType_Diagnostics_TotalInformation_DiagnosticsLevel = 19614,
    DataSetReaderType_Diagnostics_TotalInformation_TimeFirstChange = 19615,
    DataSetReaderType_Diagnostics_TotalError = 19616,
    DataSetReaderType_Diagnostics_TotalError_Active = 19617,
    DataSetReaderType_Diagnostics_TotalError_Classification = 19618,
    DataSetReaderType_Diagnostics_TotalError_DiagnosticsLevel = 19619,
    DataSetReaderType_Diagnostics_TotalError_TimeFirstChange = 19620,
    DataSetReaderType_Diagnostics_SubError = 19622,
    DataSetReaderType_Diagnostics_Counters_StateError = 19624,
    DataSetReaderType_Diagnostics_Counters_StateError_Active = 19625,
    DataSetReaderType_Diagnostics_Counters_StateError_Classification = 19626,
    DataSetReaderType_Diagnostics_Counters_StateError_DiagnosticsLevel = 19627,
    DataSetReaderType_Diagnostics_Counters_StateError_TimeFirstChange = 19628,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod = 19629,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_Active = 19630,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_Classification = 19631,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 19632,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 19633,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByParent = 19634,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_Active = 19635,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_Classification = 19636,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 19637,
    DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 19638,
    DataSetReaderType_Diagnostics_Counters_StateOperationalFromError = 19639,
    DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_Active = 19640,
    DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_Classification = 19641,
    DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 19642,
    DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 19643,
    DataSetReaderType_Diagnostics_Counters_StatePausedByParent = 19644,
    DataSetReaderType_Diagnostics_Counters_StatePausedByParent_Active = 19645,
    DataSetReaderType_Diagnostics_Counters_StatePausedByParent_Classification = 19646,
    DataSetReaderType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 19647,
    DataSetReaderType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 19648,
    DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod = 19649,
    DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_Active = 19650,
    DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_Classification = 19651,
    DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 19652,
    DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 19653,
    DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages = 19655,
    DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_Active = 19656,
    DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_Classification = 19657,
    DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel = 19658,
    DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange = 19659,
    DataSetReaderType_Diagnostics_Counters_DecryptionErrors = 19660,
    DataSetReaderType_Diagnostics_Counters_DecryptionErrors_Active = 19661,
    DataSetReaderType_Diagnostics_Counters_DecryptionErrors_Classification = 19662,
    DataSetReaderType_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel = 19663,
    DataSetReaderType_Diagnostics_Counters_DecryptionErrors_TimeFirstChange = 19664,
    DataSetReaderType_Diagnostics_LiveValues_MessageSequenceNumber = 19665,
    DataSetReaderType_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel = 19666,
    DataSetReaderType_Diagnostics_LiveValues_StatusCode = 19667,
    DataSetReaderType_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel = 19668,
    DataSetReaderType_Diagnostics_LiveValues_MajorVersion = 19669,
    DataSetReaderType_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel = 19670,
    DataSetReaderType_Diagnostics_LiveValues_MinorVersion = 19671,
    DataSetReaderType_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel = 19672,
    DataSetReaderType_Diagnostics_LiveValues_SecurityTokenID = 19673,
    DataSetReaderType_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel = 19674,
    DataSetReaderType_Diagnostics_LiveValues_TimeToNextTokenID = 19675,
    DataSetReaderType_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel = 19676,
    PubSubDiagnosticsType_DiagnosticsLevel = 19678,
    PubSubDiagnosticsType_TotalInformation = 19679,
    PubSubDiagnosticsType_TotalInformation_Active = 19680,
    PubSubDiagnosticsType_TotalInformation_Classification = 19681,
    PubSubDiagnosticsType_TotalInformation_DiagnosticsLevel = 19682,
    PubSubDiagnosticsType_TotalInformation_TimeFirstChange = 19683,
    PubSubDiagnosticsType_TotalError = 19684,
    PubSubDiagnosticsType_TotalError_Active = 19685,
    PubSubDiagnosticsType_TotalError_Classification = 19686,
    PubSubDiagnosticsType_TotalError_DiagnosticsLevel = 19687,
    PubSubDiagnosticsType_TotalError_TimeFirstChange = 19688,
    PubSubDiagnosticsType_SubError = 19690,
    PubSubDiagnosticsType_Counters_StateError = 19692,
    PubSubDiagnosticsType_Counters_StateError_Active = 19693,
    PubSubDiagnosticsType_Counters_StateError_Classification = 19694,
    PubSubDiagnosticsType_Counters_StateError_DiagnosticsLevel = 19695,
    PubSubDiagnosticsType_Counters_StateError_TimeFirstChange = 19696,
    PubSubDiagnosticsType_Counters_StateOperationalByMethod = 19697,
    PubSubDiagnosticsType_Counters_StateOperationalByMethod_Active = 19698,
    PubSubDiagnosticsType_Counters_StateOperationalByMethod_Classification = 19699,
    PubSubDiagnosticsType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19700,
    PubSubDiagnosticsType_Counters_StateOperationalByMethod_TimeFirstChange = 19701,
    PubSubDiagnosticsType_Counters_StateOperationalByParent = 19702,
    PubSubDiagnosticsType_Counters_StateOperationalByParent_Active = 19703,
    PubSubDiagnosticsType_Counters_StateOperationalByParent_Classification = 19704,
    PubSubDiagnosticsType_Counters_StateOperationalByParent_DiagnosticsLevel = 19705,
    PubSubDiagnosticsType_Counters_StateOperationalByParent_TimeFirstChange = 19706,
    PubSubDiagnosticsType_Counters_StateOperationalFromError = 19707,
    PubSubDiagnosticsType_Counters_StateOperationalFromError_Active = 19708,
    PubSubDiagnosticsType_Counters_StateOperationalFromError_Classification = 19709,
    PubSubDiagnosticsType_Counters_StateOperationalFromError_DiagnosticsLevel = 19710,
    PubSubDiagnosticsType_Counters_StateOperationalFromError_TimeFirstChange = 19711,
    PubSubDiagnosticsType_Counters_StatePausedByParent = 19712,
    PubSubDiagnosticsType_Counters_StatePausedByParent_Active = 19713,
    PubSubDiagnosticsType_Counters_StatePausedByParent_Classification = 19714,
    PubSubDiagnosticsType_Counters_StatePausedByParent_DiagnosticsLevel = 19715,
    PubSubDiagnosticsType_Counters_StatePausedByParent_TimeFirstChange = 19716,
    PubSubDiagnosticsType_Counters_StateDisabledByMethod = 19717,
    PubSubDiagnosticsType_Counters_StateDisabledByMethod_Active = 19718,
    PubSubDiagnosticsType_Counters_StateDisabledByMethod_Classification = 19719,
    PubSubDiagnosticsType_Counters_StateDisabledByMethod_DiagnosticsLevel = 19720,
    PubSubDiagnosticsType_Counters_StateDisabledByMethod_TimeFirstChange = 19721,
    DiagnosticsLevel_EnumStrings = 19724,
    PubSubDiagnosticsCounterType_Active = 19726,
    PubSubDiagnosticsCounterType_Classification = 19727,
    PubSubDiagnosticsCounterType_DiagnosticsLevel = 19728,
    PubSubDiagnosticsCounterType_TimeFirstChange = 19729,
    PubSubDiagnosticsCounterClassification_EnumStrings = 19731,
    PubSubDiagnosticsRootType_DiagnosticsLevel = 19733,
    PubSubDiagnosticsRootType_TotalInformation = 19734,
    PubSubDiagnosticsRootType_TotalInformation_Active = 19735,
    PubSubDiagnosticsRootType_TotalInformation_Classification = 19736,
    PubSubDiagnosticsRootType_TotalInformation_DiagnosticsLevel = 19737,
    PubSubDiagnosticsRootType_TotalInformation_TimeFirstChange = 19738,
    PubSubDiagnosticsRootType_TotalError = 19739,
    PubSubDiagnosticsRootType_TotalError_Active = 19740,
    PubSubDiagnosticsRootType_TotalError_Classification = 19741,
    PubSubDiagnosticsRootType_TotalError_DiagnosticsLevel = 19742,
    PubSubDiagnosticsRootType_TotalError_TimeFirstChange = 19743,
    PubSubDiagnosticsRootType_SubError = 19745,
    PubSubDiagnosticsRootType_Counters_StateError = 19747,
    PubSubDiagnosticsRootType_Counters_StateError_Active = 19748,
    PubSubDiagnosticsRootType_Counters_StateError_Classification = 19749,
    PubSubDiagnosticsRootType_Counters_StateError_DiagnosticsLevel = 19750,
    PubSubDiagnosticsRootType_Counters_StateError_TimeFirstChange = 19751,
    PubSubDiagnosticsRootType_Counters_StateOperationalByMethod = 19752,
    PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_Active = 19753,
    PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_Classification = 19754,
    PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19755,
    PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_TimeFirstChange = 19756,
    PubSubDiagnosticsRootType_Counters_StateOperationalByParent = 19757,
    PubSubDiagnosticsRootType_Counters_StateOperationalByParent_Active = 19758,
    PubSubDiagnosticsRootType_Counters_StateOperationalByParent_Classification = 19759,
    PubSubDiagnosticsRootType_Counters_StateOperationalByParent_DiagnosticsLevel = 19760,
    PubSubDiagnosticsRootType_Counters_StateOperationalByParent_TimeFirstChange = 19761,
    PubSubDiagnosticsRootType_Counters_StateOperationalFromError = 19762,
    PubSubDiagnosticsRootType_Counters_StateOperationalFromError_Active = 19763,
    PubSubDiagnosticsRootType_Counters_StateOperationalFromError_Classification = 19764,
    PubSubDiagnosticsRootType_Counters_StateOperationalFromError_DiagnosticsLevel = 19765,
    PubSubDiagnosticsRootType_Counters_StateOperationalFromError_TimeFirstChange = 19766,
    PubSubDiagnosticsRootType_Counters_StatePausedByParent = 19767,
    PubSubDiagnosticsRootType_Counters_StatePausedByParent_Active = 19768,
    PubSubDiagnosticsRootType_Counters_StatePausedByParent_Classification = 19769,
    PubSubDiagnosticsRootType_Counters_StatePausedByParent_DiagnosticsLevel = 19770,
    PubSubDiagnosticsRootType_Counters_StatePausedByParent_TimeFirstChange = 19771,
    PubSubDiagnosticsRootType_Counters_StateDisabledByMethod = 19772,
    PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_Active = 19773,
    PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_Classification = 19774,
    PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_DiagnosticsLevel = 19775,
    PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_TimeFirstChange = 19776,
    PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetWriters = 19778,
    PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel = 19779,
    PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetReaders = 19780,
    PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel = 19781,
    PubSubDiagnosticsRootType_LiveValues_OperationalDataSetWriters = 19782,
    PubSubDiagnosticsRootType_LiveValues_OperationalDataSetWriters_DiagnosticsLevel = 19783,
    PubSubDiagnosticsRootType_LiveValues_OperationalDataSetReaders = 19784,
    PubSubDiagnosticsRootType_LiveValues_OperationalDataSetReaders_DiagnosticsLevel = 19785,
    PubSubDiagnosticsConnectionType_DiagnosticsLevel = 19787,
    PubSubDiagnosticsConnectionType_TotalInformation = 19788,
    PubSubDiagnosticsConnectionType_TotalInformation_Active = 19789,
    PubSubDiagnosticsConnectionType_TotalInformation_Classification = 19790,
    PubSubDiagnosticsConnectionType_TotalInformation_DiagnosticsLevel = 19791,
    PubSubDiagnosticsConnectionType_TotalInformation_TimeFirstChange = 19792,
    PubSubDiagnosticsConnectionType_TotalError = 19793,
    PubSubDiagnosticsConnectionType_TotalError_Active = 19794,
    PubSubDiagnosticsConnectionType_TotalError_Classification = 19795,
    PubSubDiagnosticsConnectionType_TotalError_DiagnosticsLevel = 19796,
    PubSubDiagnosticsConnectionType_TotalError_TimeFirstChange = 19797,
    PubSubDiagnosticsConnectionType_SubError = 19799,
    PubSubDiagnosticsConnectionType_Counters_StateError = 19801,
    PubSubDiagnosticsConnectionType_Counters_StateError_Active = 19802,
    PubSubDiagnosticsConnectionType_Counters_StateError_Classification = 19803,
    PubSubDiagnosticsConnectionType_Counters_StateError_DiagnosticsLevel = 19804,
    PubSubDiagnosticsConnectionType_Counters_StateError_TimeFirstChange = 19805,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod = 19806,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_Active = 19807,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_Classification = 19808,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19809,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_TimeFirstChange = 19810,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent = 19811,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_Active = 19812,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_Classification = 19813,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_DiagnosticsLevel = 19814,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_TimeFirstChange = 19815,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError = 19816,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_Active = 19817,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_Classification = 19818,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_DiagnosticsLevel = 19819,
    PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_TimeFirstChange = 19820,
    PubSubDiagnosticsConnectionType_Counters_StatePausedByParent = 19821,
    PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_Active = 19822,
    PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_Classification = 19823,
    PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_DiagnosticsLevel = 19824,
    PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_TimeFirstChange = 19825,
    PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod = 19826,
    PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_Active = 19827,
    PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_Classification = 19828,
    PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_DiagnosticsLevel = 19829,
    PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_TimeFirstChange = 19830,
    PubSubDiagnosticsConnectionType_LiveValues_ResolvedAddress = 19832,
    PubSubDiagnosticsConnectionType_LiveValues_ResolvedAddress_DiagnosticsLevel = 19833,
    PubSubDiagnosticsWriterGroupType_DiagnosticsLevel = 19835,
    PubSubDiagnosticsWriterGroupType_TotalInformation = 19836,
    PubSubDiagnosticsWriterGroupType_TotalInformation_Active = 19837,
    PubSubDiagnosticsWriterGroupType_TotalInformation_Classification = 19838,
    PubSubDiagnosticsWriterGroupType_TotalInformation_DiagnosticsLevel = 19839,
    PubSubDiagnosticsWriterGroupType_TotalInformation_TimeFirstChange = 19840,
    PubSubDiagnosticsWriterGroupType_TotalError = 19841,
    PubSubDiagnosticsWriterGroupType_TotalError_Active = 19842,
    PubSubDiagnosticsWriterGroupType_TotalError_Classification = 19843,
    PubSubDiagnosticsWriterGroupType_TotalError_DiagnosticsLevel = 19844,
    PubSubDiagnosticsWriterGroupType_TotalError_TimeFirstChange = 19845,
    PubSubDiagnosticsWriterGroupType_SubError = 19847,
    PubSubDiagnosticsWriterGroupType_Counters_StateError = 19849,
    PubSubDiagnosticsWriterGroupType_Counters_StateError_Active = 19850,
    PubSubDiagnosticsWriterGroupType_Counters_StateError_Classification = 19851,
    PubSubDiagnosticsWriterGroupType_Counters_StateError_DiagnosticsLevel = 19852,
    PubSubDiagnosticsWriterGroupType_Counters_StateError_TimeFirstChange = 19853,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod = 19854,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_Active = 19855,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_Classification = 19856,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19857,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_TimeFirstChange = 19858,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent = 19859,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_Active = 19860,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_Classification = 19861,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_DiagnosticsLevel = 19862,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_TimeFirstChange = 19863,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError = 19864,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_Active = 19865,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_Classification = 19866,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_DiagnosticsLevel = 19867,
    PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_TimeFirstChange = 19868,
    PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent = 19869,
    PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_Active = 19870,
    PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_Classification = 19871,
    PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_DiagnosticsLevel = 19872,
    PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_TimeFirstChange = 19873,
    PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod = 19874,
    PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_Active = 19875,
    PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_Classification = 19876,
    PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_DiagnosticsLevel = 19877,
    PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_TimeFirstChange = 19878,
    PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages = 19880,
    PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_Active = 19881,
    PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_Classification = 19882,
    PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_DiagnosticsLevel = 19883,
    PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_TimeFirstChange = 19884,
    PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions = 19885,
    PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_Active = 19886,
    PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_Classification = 19887,
    PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_DiagnosticsLevel = 19888,
    PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_TimeFirstChange = 19889,
    PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors = 19890,
    PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_Active = 19891,
    PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_Classification = 19892,
    PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_DiagnosticsLevel = 19893,
    PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_TimeFirstChange = 19894,
    PubSubDiagnosticsWriterGroupType_LiveValues_ConfiguredDataSetWriters = 19895,
    PubSubDiagnosticsWriterGroupType_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel = 19896,
    PubSubDiagnosticsWriterGroupType_LiveValues_OperationalDataSetWriters = 19897,
    PubSubDiagnosticsWriterGroupType_LiveValues_OperationalDataSetWriters_DiagnosticsLevel = 19898,
    PubSubDiagnosticsWriterGroupType_LiveValues_SecurityTokenID = 19899,
    PubSubDiagnosticsWriterGroupType_LiveValues_SecurityTokenID_DiagnosticsLevel = 19900,
    PubSubDiagnosticsWriterGroupType_LiveValues_TimeToNextTokenID = 19901,
    PubSubDiagnosticsWriterGroupType_LiveValues_TimeToNextTokenID_DiagnosticsLevel = 19902,
    PubSubDiagnosticsReaderGroupType_DiagnosticsLevel = 19904,
    PubSubDiagnosticsReaderGroupType_TotalInformation = 19905,
    PubSubDiagnosticsReaderGroupType_TotalInformation_Active = 19906,
    PubSubDiagnosticsReaderGroupType_TotalInformation_Classification = 19907,
    PubSubDiagnosticsReaderGroupType_TotalInformation_DiagnosticsLevel = 19908,
    PubSubDiagnosticsReaderGroupType_TotalInformation_TimeFirstChange = 19909,
    PubSubDiagnosticsReaderGroupType_TotalError = 19910,
    PubSubDiagnosticsReaderGroupType_TotalError_Active = 19911,
    PubSubDiagnosticsReaderGroupType_TotalError_Classification = 19912,
    PubSubDiagnosticsReaderGroupType_TotalError_DiagnosticsLevel = 19913,
    PubSubDiagnosticsReaderGroupType_TotalError_TimeFirstChange = 19914,
    PubSubDiagnosticsReaderGroupType_SubError = 19916,
    PubSubDiagnosticsReaderGroupType_Counters_StateError = 19918,
    PubSubDiagnosticsReaderGroupType_Counters_StateError_Active = 19919,
    PubSubDiagnosticsReaderGroupType_Counters_StateError_Classification = 19920,
    PubSubDiagnosticsReaderGroupType_Counters_StateError_DiagnosticsLevel = 19921,
    PubSubDiagnosticsReaderGroupType_Counters_StateError_TimeFirstChange = 19922,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod = 19923,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_Active = 19924,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_Classification = 19925,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19926,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_TimeFirstChange = 19927,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent = 19928,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_Active = 19929,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_Classification = 19930,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_DiagnosticsLevel = 19931,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_TimeFirstChange = 19932,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError = 19933,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_Active = 19934,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_Classification = 19935,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_DiagnosticsLevel = 19936,
    PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_TimeFirstChange = 19937,
    PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent = 19938,
    PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_Active = 19939,
    PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_Classification = 19940,
    PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_DiagnosticsLevel = 19941,
    PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_TimeFirstChange = 19942,
    PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod = 19943,
    PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_Active = 19944,
    PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_Classification = 19945,
    PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_DiagnosticsLevel = 19946,
    PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_TimeFirstChange = 19947,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages = 19949,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_Active = 19950,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_Classification = 19951,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_DiagnosticsLevel = 19952,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_TimeFirstChange = 19953,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages = 19954,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_Active = 19955,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_Classification = 19956,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel =
        19957,
    PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange =
        19958,
    PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors = 19959,
    PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_Active = 19960,
    PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_Classification = 19961,
    PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_DiagnosticsLevel = 19962,
    PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_TimeFirstChange = 19963,
    PubSubDiagnosticsReaderGroupType_LiveValues_ConfiguredDataSetReaders = 19964,
    PubSubDiagnosticsReaderGroupType_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel = 19965,
    PubSubDiagnosticsReaderGroupType_LiveValues_OperationalDataSetReaders = 19966,
    PubSubDiagnosticsReaderGroupType_LiveValues_OperationalDataSetReaders_DiagnosticsLevel = 19967,
    PubSubDiagnosticsDataSetWriterType_DiagnosticsLevel = 19969,
    PubSubDiagnosticsDataSetWriterType_TotalInformation = 19970,
    PubSubDiagnosticsDataSetWriterType_TotalInformation_Active = 19971,
    PubSubDiagnosticsDataSetWriterType_TotalInformation_Classification = 19972,
    PubSubDiagnosticsDataSetWriterType_TotalInformation_DiagnosticsLevel = 19973,
    PubSubDiagnosticsDataSetWriterType_TotalInformation_TimeFirstChange = 19974,
    PubSubDiagnosticsDataSetWriterType_TotalError = 19975,
    PubSubDiagnosticsDataSetWriterType_TotalError_Active = 19976,
    PubSubDiagnosticsDataSetWriterType_TotalError_Classification = 19977,
    PubSubDiagnosticsDataSetWriterType_TotalError_DiagnosticsLevel = 19978,
    PubSubDiagnosticsDataSetWriterType_TotalError_TimeFirstChange = 19979,
    PubSubDiagnosticsDataSetWriterType_SubError = 19981,
    PubSubDiagnosticsDataSetWriterType_Counters_StateError = 19983,
    PubSubDiagnosticsDataSetWriterType_Counters_StateError_Active = 19984,
    PubSubDiagnosticsDataSetWriterType_Counters_StateError_Classification = 19985,
    PubSubDiagnosticsDataSetWriterType_Counters_StateError_DiagnosticsLevel = 19986,
    PubSubDiagnosticsDataSetWriterType_Counters_StateError_TimeFirstChange = 19987,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod = 19988,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_Active = 19989,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_Classification = 19990,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_DiagnosticsLevel = 19991,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_TimeFirstChange = 19992,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent = 19993,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_Active = 19994,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_Classification = 19995,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_DiagnosticsLevel = 19996,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_TimeFirstChange = 19997,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError = 19998,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_Active = 19999,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_Classification = 20000,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_DiagnosticsLevel = 20001,
    PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_TimeFirstChange = 20002,
    PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent = 20003,
    PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_Active = 20004,
    PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_Classification = 20005,
    PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_DiagnosticsLevel = 20006,
    PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_TimeFirstChange = 20007,
    PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod = 20008,
    PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_Active = 20009,
    PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_Classification = 20010,
    PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_DiagnosticsLevel = 20011,
    PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_TimeFirstChange = 20012,
    PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages = 20014,
    PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_Active = 20015,
    PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_Classification = 20016,
    PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_DiagnosticsLevel = 20017,
    PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_TimeFirstChange = 20018,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MessageSequenceNumber = 20019,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MessageSequenceNumber_DiagnosticsLevel = 20020,
    PubSubDiagnosticsDataSetWriterType_LiveValues_StatusCode = 20021,
    PubSubDiagnosticsDataSetWriterType_LiveValues_StatusCode_DiagnosticsLevel = 20022,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MajorVersion = 20023,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MajorVersion_DiagnosticsLevel = 20024,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MinorVersion = 20025,
    PubSubDiagnosticsDataSetWriterType_LiveValues_MinorVersion_DiagnosticsLevel = 20026,
    PubSubDiagnosticsDataSetReaderType_DiagnosticsLevel = 20028,
    PubSubDiagnosticsDataSetReaderType_TotalInformation = 20029,
    PubSubDiagnosticsDataSetReaderType_TotalInformation_Active = 20030,
    PubSubDiagnosticsDataSetReaderType_TotalInformation_Classification = 20031,
    PubSubDiagnosticsDataSetReaderType_TotalInformation_DiagnosticsLevel = 20032,
    PubSubDiagnosticsDataSetReaderType_TotalInformation_TimeFirstChange = 20033,
    PubSubDiagnosticsDataSetReaderType_TotalError = 20034,
    PubSubDiagnosticsDataSetReaderType_TotalError_Active = 20035,
    PubSubDiagnosticsDataSetReaderType_TotalError_Classification = 20036,
    PubSubDiagnosticsDataSetReaderType_TotalError_DiagnosticsLevel = 20037,
    PubSubDiagnosticsDataSetReaderType_TotalError_TimeFirstChange = 20038,
    PubSubDiagnosticsDataSetReaderType_SubError = 20040,
    PubSubDiagnosticsDataSetReaderType_Counters_StateError = 20042,
    PubSubDiagnosticsDataSetReaderType_Counters_StateError_Active = 20043,
    PubSubDiagnosticsDataSetReaderType_Counters_StateError_Classification = 20044,
    PubSubDiagnosticsDataSetReaderType_Counters_StateError_DiagnosticsLevel = 20045,
    PubSubDiagnosticsDataSetReaderType_Counters_StateError_TimeFirstChange = 20046,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod = 20047,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_Active = 20048,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_Classification = 20049,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_DiagnosticsLevel = 20050,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_TimeFirstChange = 20051,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent = 20052,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_Active = 20053,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_Classification = 20054,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_DiagnosticsLevel = 20055,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_TimeFirstChange = 20056,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError = 20057,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_Active = 20058,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_Classification = 20059,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_DiagnosticsLevel = 20060,
    PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_TimeFirstChange = 20061,
    PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent = 20062,
    PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_Active = 20063,
    PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_Classification = 20064,
    PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_DiagnosticsLevel = 20065,
    PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_TimeFirstChange = 20066,
    PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod = 20067,
    PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_Active = 20068,
    PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_Classification = 20069,
    PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_DiagnosticsLevel = 20070,
    PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_TimeFirstChange = 20071,
    PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages = 20073,
    PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_Active = 20074,
    PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_Classification = 20075,
    PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_DiagnosticsLevel = 20076,
    PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_TimeFirstChange = 20077,
    PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors = 20078,
    PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_Active = 20079,
    PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_Classification = 20080,
    PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_DiagnosticsLevel = 20081,
    PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_TimeFirstChange = 20082,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MessageSequenceNumber = 20083,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MessageSequenceNumber_DiagnosticsLevel = 20084,
    PubSubDiagnosticsDataSetReaderType_LiveValues_StatusCode = 20085,
    PubSubDiagnosticsDataSetReaderType_LiveValues_StatusCode_DiagnosticsLevel = 20086,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MajorVersion = 20087,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MajorVersion_DiagnosticsLevel = 20088,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MinorVersion = 20089,
    PubSubDiagnosticsDataSetReaderType_LiveValues_MinorVersion_DiagnosticsLevel = 20090,
    PubSubDiagnosticsDataSetReaderType_LiveValues_SecurityTokenID = 20091,
    PubSubDiagnosticsDataSetReaderType_LiveValues_SecurityTokenID_DiagnosticsLevel = 20092,
    PubSubDiagnosticsDataSetReaderType_LiveValues_TimeToNextTokenID = 20093,
    PubSubDiagnosticsDataSetReaderType_LiveValues_TimeToNextTokenID_DiagnosticsLevel = 20094,
    CertificateGroupType_CertificateExpired_ShelvingState_AvailableTransitions = 20095,
    CertificateGroupType_CertificateExpired_ShelvingState_UnshelveTime = 20096,
    CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve_InputArguments = 20098,
    CertificateGroupType_CertificateExpired_SuppressedOrShelved = 20101,
    CertificateGroupType_CertificateExpired_MaxTimeShelved = 20102,
    CertificateGroupType_CertificateExpired_AudibleEnabled = 20103,
    CertificateGroupType_CertificateExpired_AudibleSound = 20104,
    CertificateGroupType_CertificateExpired_AudibleSound_ListId = 20105,
    CertificateGroupType_CertificateExpired_AudibleSound_AgencyId = 20106,
    CertificateGroupType_CertificateExpired_AudibleSound_VersionId = 20107,
    CertificateGroupType_CertificateExpired_SilenceState = 20108,
    CertificateGroupType_CertificateExpired_SilenceState_Id = 20109,
    CertificateGroupType_CertificateExpired_SilenceState_Name = 20110,
    CertificateGroupType_CertificateExpired_SilenceState_Number = 20111,
    CertificateGroupType_CertificateExpired_SilenceState_EffectiveDisplayName = 20112,
    CertificateGroupType_CertificateExpired_SilenceState_TransitionTime = 20113,
    CertificateGroupType_CertificateExpired_SilenceState_EffectiveTransitionTime = 20114,
    CertificateGroupType_CertificateExpired_SilenceState_TrueState = 20115,
    CertificateGroupType_CertificateExpired_SilenceState_FalseState = 20116,
    CertificateGroupType_CertificateExpired_OnDelay = 20117,
    CertificateGroupType_CertificateExpired_OffDelay = 20118,
    CertificateGroupType_CertificateExpired_FirstInGroupFlag = 20119,
    CertificateGroupType_CertificateExpired_LatchedState = 20121,
    CertificateGroupType_CertificateExpired_LatchedState_Id = 20122,
    CertificateGroupType_CertificateExpired_LatchedState_Name = 20123,
    CertificateGroupType_CertificateExpired_LatchedState_Number = 20124,
    CertificateGroupType_CertificateExpired_LatchedState_EffectiveDisplayName = 20125,
    CertificateGroupType_CertificateExpired_LatchedState_TransitionTime = 20126,
    CertificateGroupType_CertificateExpired_LatchedState_EffectiveTransitionTime = 20127,
    CertificateGroupType_CertificateExpired_LatchedState_TrueState = 20128,
    CertificateGroupType_CertificateExpired_LatchedState_FalseState = 20129,
    CertificateGroupType_CertificateExpired_ReAlarmTime = 20130,
    CertificateGroupType_CertificateExpired_ReAlarmRepeatCount = 20131,
    CertificateGroupType_CertificateExpired_NormalState = 20138,
    CertificateGroupType_CertificateExpired_ExpirationDate = 20139,
    CertificateGroupType_CertificateExpired_ExpirationLimit = 20140,
    CertificateGroupType_CertificateExpired_CertificateType = 20141,
    CertificateGroupType_CertificateExpired_Certificate = 20142,
    CertificateGroupType_TrustListOutOfDate_EventId = 20144,
    CertificateGroupType_TrustListOutOfDate_EventType = 20145,
    CertificateGroupType_TrustListOutOfDate_SourceNode = 20146,
    CertificateGroupType_TrustListOutOfDate_SourceName = 20147,
    CertificateGroupType_TrustListOutOfDate_Time = 20148,
    CertificateGroupType_TrustListOutOfDate_ReceiveTime = 20149,
    CertificateGroupType_TrustListOutOfDate_LocalTime = 20150,
    CertificateGroupType_TrustListOutOfDate_Message = 20151,
    CertificateGroupType_TrustListOutOfDate_Severity = 20152,
    CertificateGroupType_TrustListOutOfDate_ConditionClassId = 20153,
    CertificateGroupType_TrustListOutOfDate_ConditionClassName = 20154,
    CertificateGroupType_TrustListOutOfDate_ConditionSubClassId = 20155,
    CertificateGroupType_TrustListOutOfDate_ConditionSubClassName = 20156,
    CertificateGroupType_TrustListOutOfDate_ConditionName = 20157,
    CertificateGroupType_TrustListOutOfDate_BranchId = 20158,
    CertificateGroupType_TrustListOutOfDate_Retain = 20159,
    CertificateGroupType_TrustListOutOfDate_EnabledState = 20160,
    CertificateGroupType_TrustListOutOfDate_EnabledState_Id = 20161,
    CertificateGroupType_TrustListOutOfDate_EnabledState_Name = 20162,
    CertificateGroupType_TrustListOutOfDate_EnabledState_Number = 20163,
    CertificateGroupType_TrustListOutOfDate_EnabledState_EffectiveDisplayName = 20164,
    CertificateGroupType_TrustListOutOfDate_EnabledState_TransitionTime = 20165,
    CertificateGroupType_TrustListOutOfDate_EnabledState_EffectiveTransitionTime = 20166,
    CertificateGroupType_TrustListOutOfDate_EnabledState_TrueState = 20167,
    CertificateGroupType_TrustListOutOfDate_EnabledState_FalseState = 20168,
    CertificateGroupType_TrustListOutOfDate_Quality = 20169,
    CertificateGroupType_TrustListOutOfDate_Quality_SourceTimestamp = 20170,
    CertificateGroupType_TrustListOutOfDate_LastSeverity = 20171,
    CertificateGroupType_TrustListOutOfDate_LastSeverity_SourceTimestamp = 20172,
    CertificateGroupType_TrustListOutOfDate_Comment = 20173,
    CertificateGroupType_TrustListOutOfDate_Comment_SourceTimestamp = 20174,
    CertificateGroupType_TrustListOutOfDate_ClientUserId = 20175,
    CertificateGroupType_TrustListOutOfDate_AddComment_InputArguments = 20179,
    CertificateGroupType_TrustListOutOfDate_AckedState = 20180,
    CertificateGroupType_TrustListOutOfDate_AckedState_Id = 20181,
    CertificateGroupType_TrustListOutOfDate_AckedState_Name = 20182,
    CertificateGroupType_TrustListOutOfDate_AckedState_Number = 20183,
    CertificateGroupType_TrustListOutOfDate_AckedState_EffectiveDisplayName = 20184,
    CertificateGroupType_TrustListOutOfDate_AckedState_TransitionTime = 20185,
    CertificateGroupType_TrustListOutOfDate_AckedState_EffectiveTransitionTime = 20186,
    CertificateGroupType_TrustListOutOfDate_AckedState_TrueState = 20187,
    CertificateGroupType_TrustListOutOfDate_AckedState_FalseState = 20188,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState = 20189,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_Id = 20190,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_Name = 20191,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_Number = 20192,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName = 20193,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_TransitionTime = 20194,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime = 20195,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_TrueState = 20196,
    CertificateGroupType_TrustListOutOfDate_ConfirmedState_FalseState = 20197,
    CertificateGroupType_TrustListOutOfDate_Acknowledge_InputArguments = 20199,
    CertificateGroupType_TrustListOutOfDate_Confirm_InputArguments = 20201,
    CertificateGroupType_TrustListOutOfDate_ActiveState = 20202,
    CertificateGroupType_TrustListOutOfDate_ActiveState_Id = 20203,
    CertificateGroupType_TrustListOutOfDate_ActiveState_Name = 20204,
    CertificateGroupType_TrustListOutOfDate_ActiveState_Number = 20205,
    CertificateGroupType_TrustListOutOfDate_ActiveState_EffectiveDisplayName = 20206,
    CertificateGroupType_TrustListOutOfDate_ActiveState_TransitionTime = 20207,
    CertificateGroupType_TrustListOutOfDate_ActiveState_EffectiveTransitionTime = 20208,
    CertificateGroupType_TrustListOutOfDate_ActiveState_TrueState = 20209,
    CertificateGroupType_TrustListOutOfDate_ActiveState_FalseState = 20210,
    CertificateGroupType_TrustListOutOfDate_InputNode = 20211,
    CertificateGroupType_TrustListOutOfDate_SuppressedState = 20212,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_Id = 20213,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_Name = 20214,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_Number = 20215,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_EffectiveDisplayName = 20216,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_TransitionTime = 20217,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime = 20218,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_TrueState = 20219,
    CertificateGroupType_TrustListOutOfDate_SuppressedState_FalseState = 20220,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState = 20221,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Id = 20222,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Name = 20223,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Number = 20224,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName = 20225,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_TransitionTime = 20226,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime = 20227,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_TrueState = 20228,
    CertificateGroupType_TrustListOutOfDate_OutOfServiceState_FalseState = 20229,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState = 20231,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Id = 20232,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Name = 20233,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Number = 20234,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName = 20235,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition = 20236,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Id = 20237,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Name = 20238,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Number = 20239,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime = 20240,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        20241,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_AvailableStates = 20242,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_AvailableTransitions = 20243,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_UnshelveTime = 20244,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments = 20246,
    CertificateGroupType_TrustListOutOfDate_SuppressedOrShelved = 20249,
    CertificateGroupType_TrustListOutOfDate_MaxTimeShelved = 20250,
    CertificateGroupType_TrustListOutOfDate_AudibleEnabled = 20251,
    CertificateGroupType_TrustListOutOfDate_AudibleSound = 20252,
    CertificateGroupType_TrustListOutOfDate_AudibleSound_ListId = 20253,
    CertificateGroupType_TrustListOutOfDate_AudibleSound_AgencyId = 20254,
    CertificateGroupType_TrustListOutOfDate_AudibleSound_VersionId = 20255,
    CertificateGroupType_TrustListOutOfDate_SilenceState = 20256,
    CertificateGroupType_TrustListOutOfDate_SilenceState_Id = 20257,
    CertificateGroupType_TrustListOutOfDate_SilenceState_Name = 20258,
    CertificateGroupType_TrustListOutOfDate_SilenceState_Number = 20259,
    CertificateGroupType_TrustListOutOfDate_SilenceState_EffectiveDisplayName = 20260,
    CertificateGroupType_TrustListOutOfDate_SilenceState_TransitionTime = 20261,
    CertificateGroupType_TrustListOutOfDate_SilenceState_EffectiveTransitionTime = 20262,
    CertificateGroupType_TrustListOutOfDate_SilenceState_TrueState = 20263,
    CertificateGroupType_TrustListOutOfDate_SilenceState_FalseState = 20264,
    CertificateGroupType_TrustListOutOfDate_OnDelay = 20265,
    CertificateGroupType_TrustListOutOfDate_OffDelay = 20266,
    CertificateGroupType_TrustListOutOfDate_FirstInGroupFlag = 20267,
    CertificateGroupType_TrustListOutOfDate_LatchedState = 20269,
    CertificateGroupType_TrustListOutOfDate_LatchedState_Id = 20270,
    CertificateGroupType_TrustListOutOfDate_LatchedState_Name = 20271,
    CertificateGroupType_TrustListOutOfDate_LatchedState_Number = 20272,
    CertificateGroupType_TrustListOutOfDate_LatchedState_EffectiveDisplayName = 20273,
    CertificateGroupType_TrustListOutOfDate_LatchedState_TransitionTime = 20274,
    CertificateGroupType_TrustListOutOfDate_LatchedState_EffectiveTransitionTime = 20275,
    CertificateGroupType_TrustListOutOfDate_LatchedState_TrueState = 20276,
    CertificateGroupType_TrustListOutOfDate_LatchedState_FalseState = 20277,
    CertificateGroupType_TrustListOutOfDate_ReAlarmTime = 20278,
    CertificateGroupType_TrustListOutOfDate_ReAlarmRepeatCount = 20279,
    CertificateGroupType_TrustListOutOfDate_NormalState = 20286,
    CertificateGroupType_TrustListOutOfDate_TrustListId = 20287,
    CertificateGroupType_TrustListOutOfDate_LastUpdateTime = 20288,
    CertificateGroupType_TrustListOutOfDate_UpdateFrequency = 20289,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_UpdateFrequency = 20290,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EventId = 20292,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EventType = 20293,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SourceNode = 20294,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SourceName = 20295,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Time = 20296,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReceiveTime = 20297,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LocalTime = 20298,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Message = 20299,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Severity = 20300,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionClassId = 20301,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionClassName =
        20302,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId =
        20303,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName =
        20304,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionName = 20305,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_BranchId = 20306,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Retain = 20307,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState = 20308,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Id = 20309,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Name = 20310,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Number =
        20311,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        20312,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime =
        20313,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        20314,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState =
        20315,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState =
        20316,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Quality = 20317,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp =
        20318,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LastSeverity = 20319,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        20320,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Comment = 20321,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp =
        20322,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ClientUserId = 20323,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments =
        20327,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState = 20328,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Id = 20329,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Name = 20330,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Number = 20331,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        20332,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime =
        20333,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        20334,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState =
        20335,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState =
        20336,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState = 20337,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id = 20338,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name =
        20339,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number =
        20340,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        20341,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime =
        20342,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        20343,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState =
        20344,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState =
        20345,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments =
        20347,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments =
        20349,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState = 20350,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Id = 20351,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Name = 20352,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Number =
        20353,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        20354,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime =
        20355,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        20356,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState =
        20357,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState =
        20358,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_InputNode = 20359,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState = 20360,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id =
        20361,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name =
        20362,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number =
        20363,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        20364,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime =
        20365,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        20366,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState =
        20367,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState =
        20368,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState = 20369,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id =
        20370,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name =
        20371,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number =
        20372,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        20373,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        20374,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        20375,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState =
        20376,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState =
        20377,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState =
        20379,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        20380,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        20381,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        20382,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        20383,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition =
        20384,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        20385,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        20386,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        20387,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        20388,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        20389,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates =
        20390,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        20391,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime =
        20392,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        20394,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved =
        20397,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved = 20398,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleEnabled = 20399,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound = 20400,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId =
        20401,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId =
        20402,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId =
        20403,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState = 20404,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Id = 20405,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Name = 20406,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Number =
        20407,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_SecurityTokenID = 20409,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        20410,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime =
        20411,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        20412,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState =
        20413,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState =
        20414,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OnDelay = 20415,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OffDelay = 20416,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag = 20417,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState = 20419,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Id = 20420,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Name = 20421,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Number =
        20422,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        20423,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime =
        20424,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        20425,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState =
        20426,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState =
        20427,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReAlarmTime = 20428,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount =
        20429,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_NormalState = 20436,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ExpirationDate = 20437,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ExpirationLimit = 20438,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_CertificateType = 20439,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Certificate = 20440,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EventId = 20442,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EventType = 20443,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SourceNode = 20444,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SourceName = 20445,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Time = 20446,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime = 20447,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LocalTime = 20448,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Message = 20449,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Severity = 20450,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId = 20451,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName =
        20452,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId =
        20453,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName =
        20454,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionName = 20455,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_BranchId = 20456,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Retain = 20457,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState = 20458,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id = 20459,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name = 20460,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number =
        20461,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        20462,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        20463,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        20464,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState =
        20465,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState =
        20466,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Quality = 20467,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        20468,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity = 20469,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        20470,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Comment = 20471,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        20472,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId = 20473,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments =
        20477,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState = 20478,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id = 20479,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name = 20480,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number = 20481,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        20482,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime =
        20483,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        20484,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState =
        20485,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState =
        20486,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState = 20487,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id = 20488,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name =
        20489,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number =
        20490,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        20491,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        20492,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        20493,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        20494,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        20495,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        20497,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments =
        20499,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState = 20500,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id = 20501,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name = 20502,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number =
        20503,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        20504,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        20505,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        20506,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState =
        20507,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState =
        20508,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_InputNode = 20509,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState = 20510,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id =
        20511,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name =
        20512,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number =
        20513,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        20514,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        20515,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        20516,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState =
        20517,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState =
        20518,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState = 20519,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id =
        20520,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name =
        20521,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number =
        20522,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        20523,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        20524,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        20525,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        20526,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        20527,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        20529,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        20530,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        20531,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        20532,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        20533,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        20534,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        20535,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        20536,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        20537,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        20538,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        20539,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        20540,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        20541,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        20542,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        20544,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved =
        20547,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved = 20548,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled = 20549,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound = 20550,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId =
        20551,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        20552,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId =
        20553,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState = 20554,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id = 20555,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name = 20556,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number =
        20557,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        20558,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        20559,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        20560,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState =
        20561,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState =
        20562,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OnDelay = 20563,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OffDelay = 20564,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag = 20565,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState = 20567,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id = 20568,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name = 20569,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number =
        20570,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        20571,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        20572,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        20573,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState =
        20574,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState =
        20575,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime = 20576,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        20577,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_NormalState = 20584,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_TrustListId = 20585,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime = 20586,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency = 20587,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_UpdateFrequency = 20588,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EventId = 20590,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EventType = 20591,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SourceNode = 20592,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SourceName = 20593,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Time = 20594,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReceiveTime = 20595,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LocalTime = 20596,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Message = 20597,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Severity = 20598,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionClassId = 20599,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionClassName = 20600,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId = 20601,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName = 20602,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionName = 20603,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_BranchId = 20604,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Retain = 20605,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState = 20606,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Id = 20607,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Name = 20608,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Number = 20609,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        20610,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime =
        20611,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        20612,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState = 20613,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState = 20614,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Quality = 20615,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp = 20616,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LastSeverity = 20617,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        20618,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Comment = 20619,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp = 20620,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ClientUserId = 20621,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments =
        20625,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState = 20626,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Id = 20627,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Name = 20628,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Number = 20629,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        20630,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime =
        20631,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        20632,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState = 20633,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState = 20634,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState = 20635,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id = 20636,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name = 20637,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number = 20638,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        20639,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime =
        20640,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        20641,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState =
        20642,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState =
        20643,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments =
        20645,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments = 20647,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState = 20648,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Id = 20649,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Name = 20650,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Number = 20651,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        20652,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime =
        20653,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        20654,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState = 20655,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState = 20656,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_InputNode = 20657,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState = 20658,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id = 20659,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name = 20660,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number = 20661,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        20662,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime =
        20663,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        20664,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState =
        20665,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState =
        20666,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState = 20667,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id = 20668,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name = 20669,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number =
        20670,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        20671,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        20672,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        20673,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState =
        20674,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState =
        20675,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState =
        20677,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        20678,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        20679,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        20680,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        20681,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition =
        20682,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        20683,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        20684,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        20685,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        20686,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        20687,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates =
        20688,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        20689,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime =
        20690,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        20692,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved = 20695,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved = 20696,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleEnabled = 20697,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound = 20698,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId = 20699,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId = 20700,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId = 20701,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState = 20702,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Id = 20703,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Name = 20704,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Number = 20705,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        20706,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime =
        20707,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        20708,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState = 20709,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState = 20710,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OnDelay = 20711,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OffDelay = 20712,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag = 20713,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState = 20715,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Id = 20716,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Name = 20717,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Number = 20718,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        20719,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime =
        20720,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        20721,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState = 20722,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState = 20723,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReAlarmTime = 20724,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount = 20725,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_NormalState = 20732,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ExpirationDate = 20733,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ExpirationLimit = 20734,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_CertificateType = 20735,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Certificate = 20736,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EventId = 20738,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EventType = 20739,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SourceNode = 20740,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SourceName = 20741,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Time = 20742,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime = 20743,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LocalTime = 20744,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Message = 20745,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Severity = 20746,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId = 20747,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName = 20748,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId = 20749,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName = 20750,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionName = 20751,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_BranchId = 20752,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Retain = 20753,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState = 20754,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id = 20755,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name = 20756,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number = 20757,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        20758,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        20759,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        20760,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState = 20761,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState = 20762,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Quality = 20763,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp = 20764,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity = 20765,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        20766,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Comment = 20767,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp = 20768,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId = 20769,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments =
        20773,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState = 20774,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id = 20775,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name = 20776,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number = 20777,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        20778,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime =
        20779,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        20780,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState = 20781,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState = 20782,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState = 20783,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id = 20784,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name = 20785,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number = 20786,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        20787,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        20788,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        20789,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        20790,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        20791,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        20793,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments = 20795,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState = 20796,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id = 20797,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name = 20798,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number = 20799,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        20800,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        20801,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        20802,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState = 20803,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState = 20804,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_InputNode = 20805,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState = 20806,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id = 20807,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name = 20808,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number = 20809,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        20810,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        20811,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        20812,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState =
        20813,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState =
        20814,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState = 20815,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id = 20816,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name = 20817,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number =
        20818,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        20819,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        20820,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        20821,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        20822,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        20823,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        20825,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        20826,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        20827,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        20828,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        20829,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        20830,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        20831,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        20832,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        20833,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        20834,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        20835,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        20836,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        20837,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        20838,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        20840,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved = 20843,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved = 20844,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled = 20845,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound = 20846,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId = 20847,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId = 20848,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId = 20849,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState = 20850,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id = 20851,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name = 20852,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number = 20853,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        20854,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        20855,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        20856,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState = 20857,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState = 20858,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OnDelay = 20859,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OffDelay = 20860,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag = 20861,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState = 20863,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id = 20864,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name = 20865,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number = 20866,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        20867,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        20868,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        20869,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState = 20870,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState = 20871,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime = 20872,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount = 20873,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_NormalState = 20880,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_TrustListId = 20881,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime = 20882,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency = 20883,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_UpdateFrequency = 20884,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EventId = 20886,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EventType = 20887,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SourceNode = 20888,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SourceName = 20889,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Time = 20890,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReceiveTime = 20891,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LocalTime = 20892,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Message = 20893,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Severity = 20894,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionClassId = 20895,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionClassName = 20896,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId = 20897,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName =
        20898,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionName = 20899,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_BranchId = 20900,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Retain = 20901,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState = 20902,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id = 20903,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name = 20904,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number = 20905,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        20906,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime =
        20907,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        20908,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState =
        20909,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState =
        20910,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Quality = 20911,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp =
        20912,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LastSeverity = 20913,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        20914,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Comment = 20915,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp =
        20916,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ClientUserId = 20917,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments =
        20921,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState = 20922,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Id = 20923,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Name = 20924,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Number = 20925,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        20926,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime =
        20927,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        20928,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState =
        20929,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState =
        20930,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState = 20931,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id = 20932,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name = 20933,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number =
        20934,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        20935,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime =
        20936,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        20937,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState =
        20938,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState =
        20939,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments =
        20941,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments =
        20943,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState = 20944,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id = 20945,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name = 20946,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number = 20947,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        20948,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime =
        20949,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        20950,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState =
        20951,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState =
        20952,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_InputNode = 20953,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState = 20954,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id = 20955,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name =
        20956,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number =
        20957,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        20958,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime =
        20959,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        20960,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState =
        20961,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState =
        20962,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState = 20963,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id =
        20964,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name =
        20965,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number =
        20966,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        20967,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        20968,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        20969,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState =
        20970,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState =
        20971,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState =
        20973,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        20974,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        20975,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        20976,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        20977,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition =
        20978,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        20979,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        20980,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        20981,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        20982,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        20983,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates =
        20984,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        20985,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime =
        20986,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        20988,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved = 20991,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved = 20992,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled = 20993,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound = 20994,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId = 20995,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId =
        20996,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId =
        20997,
    OpcUa_BinarySchema_FieldTargetDataType = 21002,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel =
        21003,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID = 21004,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel =
        21005,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState = 21007,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id = 21008,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables_InputArguments = 21010,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables_OutputArguments = 21011,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror_InputArguments = 21013,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror_OutputArguments = 21014,
    ReaderGroupType_Diagnostics_DiagnosticsLevel = 21016,
    ReaderGroupType_Diagnostics_TotalInformation = 21017,
    ReaderGroupType_Diagnostics_TotalInformation_Active = 21018,
    ReaderGroupType_Diagnostics_TotalInformation_Classification = 21019,
    ReaderGroupType_Diagnostics_TotalInformation_DiagnosticsLevel = 21020,
    ReaderGroupType_Diagnostics_TotalInformation_TimeFirstChange = 21021,
    ReaderGroupType_Diagnostics_TotalError = 21022,
    ReaderGroupType_Diagnostics_TotalError_Active = 21023,
    ReaderGroupType_Diagnostics_TotalError_Classification = 21024,
    ReaderGroupType_Diagnostics_TotalError_DiagnosticsLevel = 21025,
    ReaderGroupType_Diagnostics_TotalError_TimeFirstChange = 21026,
    ReaderGroupType_Diagnostics_SubError = 21028,
    ReaderGroupType_Diagnostics_Counters_StateError = 21030,
    ReaderGroupType_Diagnostics_Counters_StateError_Active = 21031,
    ReaderGroupType_Diagnostics_Counters_StateError_Classification = 21032,
    ReaderGroupType_Diagnostics_Counters_StateError_DiagnosticsLevel = 21033,
    ReaderGroupType_Diagnostics_Counters_StateError_TimeFirstChange = 21034,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod = 21035,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_Active = 21036,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_Classification = 21037,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel = 21038,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange = 21039,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByParent = 21040,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_Active = 21041,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_Classification = 21042,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel = 21043,
    ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange = 21044,
    ReaderGroupType_Diagnostics_Counters_StateOperationalFromError = 21045,
    ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_Active = 21046,
    ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_Classification = 21047,
    ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel = 21048,
    ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange = 21049,
    ReaderGroupType_Diagnostics_Counters_StatePausedByParent = 21050,
    ReaderGroupType_Diagnostics_Counters_StatePausedByParent_Active = 21051,
    ReaderGroupType_Diagnostics_Counters_StatePausedByParent_Classification = 21052,
    ReaderGroupType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel = 21053,
    ReaderGroupType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange = 21054,
    ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod = 21055,
    ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_Active = 21056,
    ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_Classification = 21057,
    ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel = 21058,
    ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange = 21059,
    ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages = 21061,
    ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_Active = 21062,
    ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_Classification = 21063,
    ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_DiagnosticsLevel = 21064,
    ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_TimeFirstChange = 21065,
    ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages = 21066,
    ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Active = 21067,
    ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Classification = 21068,
    ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel = 21069,
    ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange = 21070,
    ReaderGroupType_Diagnostics_Counters_DecryptionErrors = 21071,
    ReaderGroupType_Diagnostics_Counters_DecryptionErrors_Active = 21072,
    ReaderGroupType_Diagnostics_Counters_DecryptionErrors_Classification = 21073,
    ReaderGroupType_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel = 21074,
    ReaderGroupType_Diagnostics_Counters_DecryptionErrors_TimeFirstChange = 21075,
    ReaderGroupType_Diagnostics_LiveValues_ConfiguredDataSetReaders = 21076,
    ReaderGroupType_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel = 21077,
    ReaderGroupType_Diagnostics_LiveValues_OperationalDataSetReaders = 21078,
    ReaderGroupType_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel = 21079,
    ReaderGroupType_AddDataSetReader_InputArguments = 21083,
    ReaderGroupType_AddDataSetReader_OutputArguments = 21084,
    ReaderGroupType_RemoveDataSetReader_InputArguments = 21086,
    PubSubGroupTypeAddReaderMethodType_InputArguments = 21088,
    PubSubGroupTypeAddReaderMethodType_OutputArguments = 21089,
    DataSetWriterType_DataSetWriterId = 21092,
    DataSetWriterType_DataSetFieldContentMask = 21093,
    DataSetWriterType_KeyFrameCount = 21094,
    DataSetReaderType_PublisherId = 21097,
    DataSetReaderType_WriterGroupId = 21098,
    DataSetReaderType_DataSetWriterId = 21099,
    DataSetReaderType_DataSetMetaData = 21100,
    DataSetReaderType_DataSetFieldContentMask = 21101,
    DataSetReaderType_MessageReceiveTimeout = 21102,
    UadpWriterGroupMessageType_GroupVersion = 21106,
    UadpWriterGroupMessageType_DataSetOrdering = 21107,
    UadpWriterGroupMessageType_NetworkMessageContentMask = 21108,
    UadpWriterGroupMessageType_SamplingOffset = 21109,
    UadpWriterGroupMessageType_PublishingOffset = 21110,
    UadpDataSetWriterMessageType_DataSetMessageContentMask = 21112,
    UadpDataSetWriterMessageType_ConfiguredSize = 21113,
    UadpDataSetWriterMessageType_NetworkMessageNumber = 21114,
    UadpDataSetWriterMessageType_DataSetOffset = 21115,
    UadpDataSetReaderMessageType_GroupVersion = 21117,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name = 21118,
    UadpDataSetReaderMessageType_NetworkMessageNumber = 21119,
    UadpDataSetReaderMessageType_DataSetClassId = 21120,
    UadpDataSetReaderMessageType_NetworkMessageContentMask = 21121,
    UadpDataSetReaderMessageType_DataSetMessageContentMask = 21122,
    UadpDataSetReaderMessageType_PublishingInterval = 21123,
    UadpDataSetReaderMessageType_ProcessingOffset = 21124,
    UadpDataSetReaderMessageType_ReceiveOffset = 21125,
    JsonWriterGroupMessageType_NetworkMessageContentMask = 21127,
    JsonDataSetWriterMessageType_DataSetMessageContentMask = 21129,
    JsonDataSetReaderMessageType_NetworkMessageContentMask = 21131,
    JsonDataSetReaderMessageType_DataSetMessageContentMask = 21132,
    DatagramWriterGroupTransportType_MessageRepeatCount = 21134,
    DatagramWriterGroupTransportType_MessageRepeatDelay = 21135,
    BrokerWriterGroupTransportType_QueueName = 21137,
    BrokerDataSetWriterTransportType_QueueName = 21139,
    BrokerDataSetWriterTransportType_MetaDataQueueName = 21140,
    BrokerDataSetWriterTransportType_MetaDataUpdateTime = 21141,
    BrokerDataSetReaderTransportType_QueueName = 21143,
    BrokerDataSetReaderTransportType_MetaDataQueueName = 21144,
    NetworkAddressType_NetworkInterface = 21146,
    NetworkAddressUrlType_NetworkInterface = 21148,
    NetworkAddressUrlType_Url = 21149,
    OpcUa_BinarySchema_WriterGroupDataType = 21156,
    OpcUa_BinarySchema_WriterGroupDataType_DataTypeVersion = 21157,
    OpcUa_BinarySchema_WriterGroupDataType_DictionaryFragment = 21158,
    OpcUa_BinarySchema_NetworkAddressDataType = 21159,
    OpcUa_BinarySchema_NetworkAddressDataType_DataTypeVersion = 21160,
    OpcUa_BinarySchema_NetworkAddressDataType_DictionaryFragment = 21161,
    OpcUa_BinarySchema_NetworkAddressUrlDataType = 21162,
    OpcUa_BinarySchema_NetworkAddressUrlDataType_DataTypeVersion = 21163,
    OpcUa_BinarySchema_NetworkAddressUrlDataType_DictionaryFragment = 21164,
    OpcUa_BinarySchema_ReaderGroupDataType = 21165,
    OpcUa_BinarySchema_ReaderGroupDataType_DataTypeVersion = 21166,
    OpcUa_BinarySchema_ReaderGroupDataType_DictionaryFragment = 21167,
    OpcUa_BinarySchema_PubSubConfigurationDataType = 21168,
    OpcUa_BinarySchema_PubSubConfigurationDataType_DataTypeVersion = 21169,
    OpcUa_BinarySchema_PubSubConfigurationDataType_DictionaryFragment = 21170,
    OpcUa_BinarySchema_DatagramWriterGroupTransportDataType = 21171,
    OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DataTypeVersion = 21172,
    OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DictionaryFragment = 21173,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number = 21204,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        21205,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime =
        21206,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        21207,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState =
        21208,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState =
        21209,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OnDelay = 21210,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OffDelay = 21211,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag = 21212,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState = 21214,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id = 21215,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name = 21216,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number = 21217,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        21218,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime =
        21219,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        21220,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState =
        21221,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState =
        21222,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime = 21223,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount = 21224,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_NormalState = 21231,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ExpirationDate = 21232,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit = 21233,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_CertificateType = 21234,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Certificate = 21235,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EventId = 21237,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EventType = 21238,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode = 21239,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SourceName = 21240,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Time = 21241,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime = 21242,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime = 21243,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Message = 21244,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Severity = 21245,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId = 21246,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName = 21247,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId = 21248,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName =
        21249,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName = 21250,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_BranchId = 21251,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Retain = 21252,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState = 21253,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id = 21254,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name = 21255,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number = 21256,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        21257,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        21258,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        21259,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState =
        21260,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState =
        21261,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Quality = 21262,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        21263,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity = 21264,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        21265,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Comment = 21266,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        21267,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId = 21268,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments =
        21272,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState = 21273,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id = 21274,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name = 21275,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number = 21276,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        21277,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime =
        21278,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        21279,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState =
        21280,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState =
        21281,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState = 21282,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id = 21283,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name = 21284,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number =
        21285,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        21286,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        21287,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        21288,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        21289,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        21290,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        21292,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments =
        21294,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState = 21295,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id = 21296,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name = 21297,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number = 21298,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        21299,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        21300,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        21301,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState =
        21302,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState =
        21303,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_InputNode = 21304,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState = 21305,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id = 21306,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name =
        21307,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number =
        21308,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        21309,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        21310,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        21311,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState =
        21312,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState =
        21313,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState = 21314,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id =
        21315,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name =
        21316,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number =
        21317,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        21318,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        21319,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        21320,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        21321,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        21322,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        21324,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        21325,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        21326,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        21327,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        21328,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        21329,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        21330,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        21331,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        21332,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        21333,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        21334,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        21335,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        21336,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        21337,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        21339,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved = 21342,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved = 21343,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled = 21344,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound = 21345,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId = 21346,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        21347,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId =
        21348,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState = 21349,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id = 21350,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name = 21351,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number = 21352,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        21353,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        21354,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        21355,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState =
        21356,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState =
        21357,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay = 21358,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay = 21359,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag = 21360,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState = 21362,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id = 21363,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name = 21364,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number = 21365,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        21366,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        21367,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        21368,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState =
        21369,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState =
        21370,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime = 21371,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount = 21372,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_NormalState = 21379,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId = 21380,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime = 21381,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency = 21382,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_UpdateFrequency = 21383,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EventId = 21385,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EventType = 21386,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SourceNode = 21387,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SourceName = 21388,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Time = 21389,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReceiveTime = 21390,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LocalTime = 21391,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Message = 21392,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Severity = 21393,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionClassId =
        21394,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionClassName =
        21395,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionSubClassId =
        21396,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionSubClassName =
        21397,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionName = 21398,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_BranchId = 21399,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Retain = 21400,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState = 21401,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Id =
        21402,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Name =
        21403,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Number =
        21404,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_EffectiveDisplayName =
        21405,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_TransitionTime =
        21406,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_EffectiveTransitionTime =
        21407,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_TrueState =
        21408,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_FalseState =
        21409,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Quality = 21410,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Quality_SourceTimestamp =
        21411,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LastSeverity = 21412,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LastSeverity_SourceTimestamp =
        21413,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Comment = 21414,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Comment_SourceTimestamp =
        21415,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ClientUserId = 21416,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AddComment_InputArguments =
        21420,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState = 21421,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Id = 21422,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Name =
        21423,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Number =
        21424,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_EffectiveDisplayName =
        21425,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_TransitionTime =
        21426,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_EffectiveTransitionTime =
        21427,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_TrueState =
        21428,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_FalseState =
        21429,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState =
        21430,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Id =
        21431,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Name =
        21432,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Number =
        21433,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        21434,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_TransitionTime =
        21435,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        21436,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_TrueState =
        21437,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_FalseState =
        21438,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Acknowledge_InputArguments =
        21440,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Confirm_InputArguments =
        21442,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState = 21443,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Id =
        21444,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Name =
        21445,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Number =
        21446,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_EffectiveDisplayName =
        21447,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_TransitionTime =
        21448,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_EffectiveTransitionTime =
        21449,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_TrueState =
        21450,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_FalseState =
        21451,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_InputNode = 21452,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState =
        21453,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Id =
        21454,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Name =
        21455,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Number =
        21456,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_EffectiveDisplayName =
        21457,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_TransitionTime =
        21458,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        21459,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_TrueState =
        21460,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_FalseState =
        21461,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState =
        21462,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Id =
        21463,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Name =
        21464,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Number =
        21465,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        21466,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_TransitionTime =
        21467,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        21468,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_TrueState =
        21469,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_FalseState =
        21470,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState =
        21472,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Id =
        21473,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Name =
        21474,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Number =
        21475,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        21476,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition =
        21477,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Id =
        21478,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Name =
        21479,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Number =
        21480,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        21481,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        21482,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_AvailableStates =
        21483,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_AvailableTransitions =
        21484,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_UnshelveTime =
        21485,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        21487,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedOrShelved =
        21490,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_MaxTimeShelved =
        21491,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleEnabled =
        21492,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound = 21493,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_ListId =
        21494,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_AgencyId =
        21495,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_VersionId =
        21496,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState = 21497,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Id =
        21498,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Name =
        21499,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Number =
        21500,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_EffectiveDisplayName =
        21501,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_TransitionTime =
        21502,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_EffectiveTransitionTime =
        21503,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_TrueState =
        21504,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_FalseState =
        21505,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OnDelay = 21506,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OffDelay = 21507,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_FirstInGroupFlag =
        21508,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState = 21510,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Id =
        21511,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Name =
        21512,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Number =
        21513,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_EffectiveDisplayName =
        21514,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_TransitionTime =
        21515,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_EffectiveTransitionTime =
        21516,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_TrueState =
        21517,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_FalseState =
        21518,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReAlarmTime = 21519,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReAlarmRepeatCount =
        21520,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_NormalState = 21527,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ExpirationDate =
        21528,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ExpirationLimit =
        21529,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_CertificateType =
        21530,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Certificate = 21531,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EventId = 21533,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EventType = 21534,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SourceNode = 21535,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SourceName = 21536,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Time = 21537,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReceiveTime = 21538,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LocalTime = 21539,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Message = 21540,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Severity = 21541,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionClassId =
        21542,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionClassName =
        21543,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionSubClassId =
        21544,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionSubClassName =
        21545,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionName = 21546,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_BranchId = 21547,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Retain = 21548,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState = 21549,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Id =
        21550,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Name =
        21551,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Number =
        21552,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        21553,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_TransitionTime =
        21554,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        21555,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_TrueState =
        21556,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_FalseState =
        21557,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Quality = 21558,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Quality_SourceTimestamp =
        21559,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastSeverity = 21560,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        21561,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Comment = 21562,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Comment_SourceTimestamp =
        21563,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ClientUserId = 21564,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AddComment_InputArguments =
        21568,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState = 21569,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Id = 21570,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Name =
        21571,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Number =
        21572,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        21573,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_TransitionTime =
        21574,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        21575,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_TrueState =
        21576,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_FalseState =
        21577,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState =
        21578,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Id =
        21579,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Name =
        21580,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Number =
        21581,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        21582,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_TransitionTime =
        21583,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        21584,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_TrueState =
        21585,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_FalseState =
        21586,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Acknowledge_InputArguments =
        21588,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Confirm_InputArguments =
        21590,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState = 21591,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Id =
        21592,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Name =
        21593,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Number =
        21594,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        21595,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_TransitionTime =
        21596,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        21597,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_TrueState =
        21598,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_FalseState =
        21599,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_InputNode = 21600,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState =
        21601,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Id =
        21602,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Name =
        21603,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Number =
        21604,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        21605,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_TransitionTime =
        21606,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        21607,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_TrueState =
        21608,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_FalseState =
        21609,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState =
        21610,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Id =
        21611,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Name =
        21612,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Number =
        21613,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        21614,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        21615,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        21616,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_TrueState =
        21617,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_FalseState =
        21618,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState =
        21620,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        21621,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        21622,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        21623,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        21624,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition =
        21625,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        21626,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        21627,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        21628,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        21629,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        21630,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_AvailableStates =
        21631,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        21632,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_UnshelveTime =
        21633,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        21635,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedOrShelved =
        21638,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_MaxTimeShelved =
        21639,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleEnabled =
        21640,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound = 21641,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_ListId =
        21642,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_AgencyId =
        21643,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_VersionId =
        21644,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState = 21645,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Id =
        21646,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Name =
        21647,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Number =
        21648,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        21649,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_TransitionTime =
        21650,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        21651,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_TrueState =
        21652,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_FalseState =
        21653,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OnDelay = 21654,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OffDelay = 21655,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_FirstInGroupFlag =
        21656,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState = 21658,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Id =
        21659,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Name =
        21660,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Number =
        21661,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        21662,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_TransitionTime =
        21663,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        21664,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_TrueState =
        21665,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_FalseState =
        21666,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReAlarmTime = 21667,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReAlarmRepeatCount =
        21668,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_NormalState = 21675,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_TrustListId = 21676,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastUpdateTime =
        21677,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_UpdateFrequency =
        21678,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency =
        21679,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId =
        21681,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType =
        21682,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode =
        21683,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName =
        21684,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time =
        21685,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime =
        21686,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime =
        21687,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message =
        21688,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity =
        21689,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId =
        21690,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName =
        21691,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId =
        21692,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName =
        21693,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName =
        21694,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId =
        21695,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain =
        21696,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState =
        21697,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id =
        21698,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name =
        21699,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number =
        21700,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        21701,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime =
        21702,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        21703,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState =
        21704,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState =
        21705,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality =
        21706,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp =
        21707,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity =
        21708,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        21709,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment =
        21710,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp =
        21711,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId =
        21712,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments =
        21716,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState =
        21717,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id =
        21718,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name =
        21719,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number =
        21720,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        21721,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime =
        21722,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        21723,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState =
        21724,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState =
        21725,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState =
        21726,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id =
        21727,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name =
        21728,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number =
        21729,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        21730,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime =
        21731,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        21732,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState =
        21733,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState =
        21734,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments =
        21736,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments =
        21738,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState =
        21739,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id =
        21740,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name =
        21741,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number =
        21742,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        21743,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime =
        21744,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        21745,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState =
        21746,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState =
        21747,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode =
        21748,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState =
        21749,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id =
        21750,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name =
        21751,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number =
        21752,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        21753,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime =
        21754,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        21755,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState =
        21756,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState =
        21757,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState =
        21758,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id =
        21759,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name =
        21760,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number =
        21761,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        21762,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        21763,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        21764,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState =
        21765,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState =
        21766,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState =
        21768,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        21769,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        21770,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        21771,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        21772,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition =
        21773,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        21774,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        21775,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        21776,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        21777,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        21778,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates =
        21779,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        21780,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime =
        21781,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        21783,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved =
        21786,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved =
        21787,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled =
        21788,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound =
        21789,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId =
        21790,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId =
        21791,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId =
        21792,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState =
        21793,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id =
        21794,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name =
        21795,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number =
        21796,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        21797,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime =
        21798,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        21799,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState =
        21800,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState =
        21801,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay =
        21802,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay =
        21803,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag =
        21804,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState =
        21806,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id =
        21807,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name =
        21808,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number =
        21809,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        21810,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime =
        21811,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        21812,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState =
        21813,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState =
        21814,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime =
        21815,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount =
        21816,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState =
        21823,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate =
        21824,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit =
        21825,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType =
        21826,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate =
        21827,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId =
        21829,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType =
        21830,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode =
        21831,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName =
        21832,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time =
        21833,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime =
        21834,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime =
        21835,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message =
        21836,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity =
        21837,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId =
        21838,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName =
        21839,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId =
        21840,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName =
        21841,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName =
        21842,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId =
        21843,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain =
        21844,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState =
        21845,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id =
        21846,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name =
        21847,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number =
        21848,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        21849,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        21850,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        21851,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState =
        21852,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState =
        21853,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality =
        21854,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        21855,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity =
        21856,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        21857,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment =
        21858,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        21859,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId =
        21860,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments =
        21864,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState =
        21865,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id =
        21866,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name =
        21867,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number =
        21868,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        21869,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime =
        21870,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        21871,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState =
        21872,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState =
        21873,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState =
        21874,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id =
        21875,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name =
        21876,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number =
        21877,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        21878,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        21879,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        21880,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        21881,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        21882,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        21884,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments =
        21886,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState =
        21887,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id =
        21888,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name =
        21889,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number =
        21890,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        21891,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        21892,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        21893,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState =
        21894,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState =
        21895,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode =
        21896,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState =
        21897,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id =
        21898,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name =
        21899,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number =
        21900,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        21901,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        21902,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        21903,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState =
        21904,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState =
        21905,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState =
        21906,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id =
        21907,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name =
        21908,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number =
        21909,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        21910,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        21911,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        21912,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        21913,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        21914,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        21916,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        21917,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        21918,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        21919,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        21920,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        21921,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        21922,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        21923,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        21924,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        21925,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        21926,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        21927,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        21928,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        21929,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        21931,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved =
        21934,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved =
        21935,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled =
        21936,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound =
        21937,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId =
        21938,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        21939,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId =
        21940,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState =
        21941,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id =
        21942,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name =
        21943,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number =
        21944,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        21945,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        21946,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        21947,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState =
        21948,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState =
        21949,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay =
        21950,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay =
        21951,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag =
        21952,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState =
        21954,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id =
        21955,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name =
        21956,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number =
        21957,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        21958,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        21959,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        21960,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState =
        21961,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState =
        21962,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime =
        21963,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        21964,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState =
        21971,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId =
        21972,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime =
        21973,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency =
        21974,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency = 21975,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId = 21977,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType =
        21978,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode =
        21979,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName =
        21980,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time = 21981,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime =
        21982,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime =
        21983,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message = 21984,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity = 21985,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId =
        21986,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName =
        21987,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId =
        21988,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName =
        21989,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName =
        21990,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId = 21991,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain = 21992,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState =
        21993,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id =
        21994,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name =
        21995,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number =
        21996,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        21997,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime =
        21998,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        21999,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState =
        22000,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState =
        22001,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality = 22002,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp =
        22003,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity =
        22004,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        22005,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment = 22006,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp =
        22007,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId =
        22008,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments =
        22012,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState =
        22013,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id =
        22014,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name =
        22015,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number =
        22016,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        22017,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime =
        22018,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        22019,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState =
        22020,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState =
        22021,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState =
        22022,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id =
        22023,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name =
        22024,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number =
        22025,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        22026,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime =
        22027,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        22028,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState =
        22029,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState =
        22030,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments =
        22032,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments =
        22034,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState =
        22035,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id =
        22036,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name =
        22037,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number =
        22038,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        22039,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime =
        22040,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        22041,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState =
        22042,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState =
        22043,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode =
        22044,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState =
        22045,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id =
        22046,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name =
        22047,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number =
        22048,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        22049,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime =
        22050,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        22051,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState =
        22052,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState =
        22053,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState =
        22054,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id =
        22055,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name =
        22056,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number =
        22057,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        22058,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        22059,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        22060,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState =
        22061,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState =
        22062,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState =
        22064,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        22065,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        22066,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        22067,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        22068,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition =
        22069,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        22070,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        22071,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        22072,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        22073,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        22074,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates =
        22075,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        22076,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime =
        22077,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        22079,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved =
        22082,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved =
        22083,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled =
        22084,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound =
        22085,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId =
        22086,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId =
        22087,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId =
        22088,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState =
        22089,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id =
        22090,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name =
        22091,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number =
        22092,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        22093,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime =
        22094,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        22095,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState =
        22096,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState =
        22097,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay = 22098,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay = 22099,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag =
        22100,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState =
        22102,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id =
        22103,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name =
        22104,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number =
        22105,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        22106,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime =
        22107,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        22108,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState =
        22109,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState =
        22110,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime =
        22111,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount =
        22112,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState =
        22119,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate =
        22120,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit =
        22121,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType =
        22122,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate =
        22123,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId = 22125,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType =
        22126,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode =
        22127,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName =
        22128,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time = 22129,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime =
        22130,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime =
        22131,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message = 22132,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity = 22133,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId =
        22134,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName =
        22135,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId =
        22136,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName =
        22137,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName =
        22138,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId = 22139,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain = 22140,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState =
        22141,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id =
        22142,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name =
        22143,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number =
        22144,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        22145,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        22146,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        22147,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState =
        22148,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState =
        22149,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality = 22150,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        22151,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity =
        22152,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        22153,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment = 22154,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        22155,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId =
        22156,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments =
        22160,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState =
        22161,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id =
        22162,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name =
        22163,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number =
        22164,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        22165,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime =
        22166,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        22167,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState =
        22168,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState =
        22169,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState =
        22170,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id =
        22171,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name =
        22172,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number =
        22173,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        22174,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        22175,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        22176,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        22177,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        22178,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        22180,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments =
        22182,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState =
        22183,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id =
        22184,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name =
        22185,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number =
        22186,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        22187,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        22188,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        22189,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState =
        22190,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState =
        22191,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode =
        22192,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState =
        22193,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id =
        22194,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name =
        22195,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number =
        22196,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        22197,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        22198,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        22199,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState =
        22200,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState =
        22201,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState =
        22202,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id =
        22203,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name =
        22204,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number =
        22205,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        22206,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        22207,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        22208,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        22209,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        22210,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        22212,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        22213,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        22214,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        22215,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        22216,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        22217,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        22218,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        22219,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        22220,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        22221,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        22222,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        22223,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        22224,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        22225,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        22227,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved =
        22230,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved =
        22231,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled =
        22232,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound =
        22233,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId =
        22234,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        22235,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId =
        22236,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState =
        22237,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id =
        22238,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name =
        22239,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number =
        22240,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        22241,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        22242,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        22243,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState =
        22244,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState =
        22245,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay = 22246,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay = 22247,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag =
        22248,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState =
        22250,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id =
        22251,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name =
        22252,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number =
        22253,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        22254,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        22255,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        22256,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState =
        22257,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState =
        22258,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime =
        22259,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        22260,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState =
        22267,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId =
        22268,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime =
        22269,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency =
        22270,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency =
        22271,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId =
        22273,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType =
        22274,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode =
        22275,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName =
        22276,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time = 22277,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime =
        22278,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime =
        22279,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message =
        22280,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity =
        22281,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId =
        22282,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName =
        22283,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId =
        22284,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName =
        22285,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName =
        22286,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId =
        22287,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain =
        22288,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState =
        22289,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id =
        22290,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name =
        22291,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number =
        22292,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        22293,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime =
        22294,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        22295,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState =
        22296,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState =
        22297,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality =
        22298,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp =
        22299,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity =
        22300,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        22301,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment =
        22302,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp =
        22303,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId =
        22304,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments =
        22308,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState =
        22309,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id =
        22310,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name =
        22311,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number =
        22312,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        22313,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime =
        22314,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        22315,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState =
        22316,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState =
        22317,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState =
        22318,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id =
        22319,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name =
        22320,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number =
        22321,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        22322,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime =
        22323,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        22324,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState =
        22325,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState =
        22326,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments =
        22328,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments =
        22330,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState =
        22331,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id =
        22332,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name =
        22333,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number =
        22334,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        22335,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime =
        22336,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        22337,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState =
        22338,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState =
        22339,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode =
        22340,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState =
        22341,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id =
        22342,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name =
        22343,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number =
        22344,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        22345,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime =
        22346,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        22347,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState =
        22348,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState =
        22349,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState =
        22350,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id =
        22351,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name =
        22352,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number =
        22353,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        22354,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        22355,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        22356,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState =
        22357,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState =
        22358,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState =
        22360,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        22361,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        22362,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        22363,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        22364,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition =
        22365,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        22366,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        22367,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        22368,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        22369,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        22370,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates =
        22371,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        22372,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime =
        22373,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        22375,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved =
        22378,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved =
        22379,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled =
        22380,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound =
        22381,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId =
        22382,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId =
        22383,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId =
        22384,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState =
        22385,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id =
        22386,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name =
        22387,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number =
        22388,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        22389,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime =
        22390,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        22391,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState =
        22392,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState =
        22393,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay =
        22394,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay =
        22395,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag =
        22396,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState =
        22398,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id =
        22399,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name =
        22400,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number =
        22401,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        22402,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime =
        22403,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        22404,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState =
        22405,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState =
        22406,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime =
        22407,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount =
        22408,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState =
        22415,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate =
        22416,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit =
        22417,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType =
        22418,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate =
        22419,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId =
        22421,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType =
        22422,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode =
        22423,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName =
        22424,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time = 22425,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime =
        22426,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime =
        22427,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message =
        22428,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity =
        22429,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId =
        22430,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName =
        22431,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId =
        22432,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName =
        22433,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName =
        22434,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId =
        22435,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain =
        22436,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState =
        22437,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id =
        22438,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name =
        22439,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number =
        22440,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        22441,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        22442,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        22443,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState =
        22444,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState =
        22445,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality =
        22446,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        22447,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity =
        22448,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        22449,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment =
        22450,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        22451,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId =
        22452,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments =
        22456,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState =
        22457,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id =
        22458,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name =
        22459,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number =
        22460,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        22461,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime =
        22462,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        22463,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState =
        22464,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState =
        22465,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState =
        22466,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id =
        22467,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name =
        22468,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number =
        22469,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        22470,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        22471,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        22472,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        22473,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        22474,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        22476,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments =
        22478,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState =
        22479,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id =
        22480,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name =
        22481,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number =
        22482,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        22483,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        22484,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        22485,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState =
        22486,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState =
        22487,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode =
        22488,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState =
        22489,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id =
        22490,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name =
        22491,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number =
        22492,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        22493,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        22494,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        22495,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState =
        22496,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState =
        22497,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState =
        22498,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id =
        22499,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name =
        22500,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number =
        22501,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        22502,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        22503,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        22504,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        22505,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        22506,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        22508,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        22509,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        22510,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        22511,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        22512,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        22513,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        22514,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        22515,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        22516,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        22517,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        22518,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        22519,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        22520,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        22521,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        22523,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved =
        22526,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved =
        22527,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled =
        22528,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound =
        22529,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId =
        22530,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        22531,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId =
        22532,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState =
        22533,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id =
        22534,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name =
        22535,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number =
        22536,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        22537,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        22538,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        22539,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState =
        22540,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState =
        22541,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay =
        22542,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay =
        22543,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag =
        22544,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState =
        22546,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id =
        22547,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name =
        22548,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number =
        22549,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        22550,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        22551,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        22552,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState =
        22553,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState =
        22554,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime =
        22555,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        22556,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState =
        22563,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId =
        22564,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime =
        22565,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency =
        22566,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency = 22567,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId =
        22569,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType =
        22570,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode =
        22571,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName =
        22572,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time = 22573,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime =
        22574,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime =
        22575,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message =
        22576,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity =
        22577,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId =
        22578,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName =
        22579,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId =
        22580,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName =
        22581,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName =
        22582,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId =
        22583,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain = 22584,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState =
        22585,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id =
        22586,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name =
        22587,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number =
        22588,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        22589,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime =
        22590,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        22591,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState =
        22592,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState =
        22593,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality =
        22594,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp =
        22595,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity =
        22596,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        22597,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment =
        22598,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp =
        22599,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId =
        22600,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments =
        22604,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState =
        22605,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id =
        22606,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name =
        22607,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number =
        22608,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        22609,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime =
        22610,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        22611,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState =
        22612,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState =
        22613,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState =
        22614,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id =
        22615,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name =
        22616,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number =
        22617,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        22618,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime =
        22619,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        22620,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState =
        22621,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState =
        22622,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments =
        22624,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments =
        22626,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState =
        22627,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id =
        22628,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name =
        22629,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number =
        22630,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        22631,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime =
        22632,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        22633,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState =
        22634,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState =
        22635,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode =
        22636,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState =
        22637,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id =
        22638,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name =
        22639,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number =
        22640,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        22641,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime =
        22642,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        22643,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState =
        22644,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState =
        22645,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState =
        22646,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id =
        22647,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name =
        22648,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number =
        22649,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        22650,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        22651,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        22652,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState =
        22653,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState =
        22654,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState =
        22656,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        22657,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        22658,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        22659,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        22660,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition =
        22661,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        22662,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        22663,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        22664,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        22665,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        22666,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates =
        22667,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        22668,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime =
        22669,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        22671,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved =
        22674,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved =
        22675,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled =
        22676,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound =
        22677,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId =
        22678,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId =
        22679,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId =
        22680,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState =
        22681,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id =
        22682,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name =
        22683,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number =
        22684,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        22685,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime =
        22686,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        22687,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState =
        22688,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState =
        22689,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay =
        22690,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay =
        22691,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag =
        22692,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState =
        22694,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id =
        22695,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name =
        22696,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number =
        22697,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        22698,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime =
        22699,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        22700,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState =
        22701,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState =
        22702,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime =
        22703,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount =
        22704,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState =
        22711,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate =
        22712,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit =
        22713,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType =
        22714,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate =
        22715,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId =
        22717,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType =
        22718,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode =
        22719,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName =
        22720,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time = 22721,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime =
        22722,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime =
        22723,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message =
        22724,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity =
        22725,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId =
        22726,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName =
        22727,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId =
        22728,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName =
        22729,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName =
        22730,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId =
        22731,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain = 22732,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState =
        22733,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id =
        22734,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name =
        22735,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number =
        22736,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        22737,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        22738,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        22739,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState =
        22740,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState =
        22741,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality =
        22742,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        22743,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity =
        22744,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        22745,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment =
        22746,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        22747,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId =
        22748,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments =
        22752,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState =
        22753,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id =
        22754,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name =
        22755,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number =
        22756,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        22757,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime =
        22758,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        22759,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState =
        22760,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState =
        22761,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState =
        22762,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id =
        22763,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name =
        22764,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number =
        22765,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        22766,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        22767,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        22768,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        22769,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        22770,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        22772,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments =
        22774,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState =
        22775,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id =
        22776,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name =
        22777,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number =
        22778,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        22779,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        22780,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        22781,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState =
        22782,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState =
        22783,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode =
        22784,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState =
        22785,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id =
        22786,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name =
        22787,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number =
        22788,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        22789,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        22790,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        22791,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState =
        22792,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState =
        22793,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState =
        22794,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id =
        22795,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name =
        22796,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number =
        22797,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        22798,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        22799,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        22800,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        22801,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        22802,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        22804,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        22805,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        22806,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        22807,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        22808,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        22809,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        22810,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        22811,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        22812,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        22813,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        22814,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        22815,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        22816,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        22817,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        22819,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved =
        22822,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved =
        22823,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled =
        22824,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound =
        22825,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId =
        22826,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        22827,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId =
        22828,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState =
        22829,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id =
        22830,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name =
        22831,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number =
        22832,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        22833,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        22834,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        22835,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState =
        22836,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState =
        22837,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay =
        22838,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay =
        22839,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag =
        22840,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState =
        22842,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id =
        22843,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name =
        22844,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number =
        22845,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        22846,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        22847,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        22848,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState =
        22849,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState =
        22850,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime =
        22851,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        22852,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState =
        22859,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId =
        22860,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime =
        22861,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency =
        22862,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency = 22863,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId = 22865,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType = 22866,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode = 22867,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName = 22868,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time = 22869,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime = 22870,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime = 22871,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message = 22872,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity = 22873,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId =
        22874,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName =
        22875,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId =
        22876,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName =
        22877,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName =
        22878,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId = 22879,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain = 22880,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState = 22881,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id =
        22882,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name =
        22883,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number =
        22884,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        22885,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime =
        22886,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        22887,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState =
        22888,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState =
        22889,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality = 22890,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp =
        22891,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity = 22892,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        22893,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment = 22894,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp =
        22895,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId = 22896,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments =
        22900,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState = 22901,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id =
        22902,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name =
        22903,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number =
        22904,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        22905,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime =
        22906,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        22907,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState =
        22908,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState =
        22909,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState =
        22910,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id =
        22911,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name =
        22912,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number =
        22913,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        22914,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime =
        22915,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        22916,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState =
        22917,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState =
        22918,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments =
        22920,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments =
        22922,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState = 22923,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id =
        22924,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name =
        22925,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number =
        22926,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        22927,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime =
        22928,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        22929,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState =
        22930,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState =
        22931,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode = 22932,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState =
        22933,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id =
        22934,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name =
        22935,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number =
        22936,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        22937,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime =
        22938,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        22939,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState =
        22940,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState =
        22941,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState =
        22942,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id =
        22943,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name =
        22944,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number =
        22945,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        22946,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        22947,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        22948,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState =
        22949,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState =
        22950,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState =
        22952,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        22953,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        22954,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        22955,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        22956,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition =
        22957,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        22958,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        22959,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        22960,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        22961,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        22962,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates =
        22963,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        22964,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime =
        22965,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        22967,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved =
        22970,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved =
        22971,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled =
        22972,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound = 22973,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId =
        22974,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId =
        22975,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId =
        22976,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState = 22977,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id =
        22978,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name =
        22979,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number =
        22980,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        22981,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime =
        22982,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        22983,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState =
        22984,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState =
        22985,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay = 22986,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay = 22987,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag =
        22988,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState = 22990,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id =
        22991,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name =
        22992,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number =
        22993,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        22994,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime =
        22995,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        22996,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState =
        22997,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState =
        22998,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime = 22999,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount =
        23000,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState = 23007,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate =
        23008,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit =
        23009,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType =
        23010,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate = 23011,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId = 23013,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType = 23014,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode = 23015,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName = 23016,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time = 23017,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime = 23018,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime = 23019,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message = 23020,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity = 23021,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId =
        23022,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName =
        23023,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId =
        23024,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName =
        23025,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName =
        23026,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId = 23027,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain = 23028,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState = 23029,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id =
        23030,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name =
        23031,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number =
        23032,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        23033,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        23034,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        23035,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState =
        23036,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState =
        23037,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality = 23038,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        23039,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity = 23040,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        23041,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment = 23042,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        23043,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId = 23044,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments =
        23048,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState = 23049,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id =
        23050,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name =
        23051,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number =
        23052,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        23053,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime =
        23054,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        23055,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState =
        23056,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState =
        23057,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState =
        23058,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id =
        23059,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name =
        23060,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number =
        23061,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        23062,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        23063,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        23064,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        23065,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        23066,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        23068,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments =
        23070,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState = 23071,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id =
        23072,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name =
        23073,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number =
        23074,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        23075,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        23076,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        23077,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState =
        23078,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState =
        23079,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode = 23080,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState =
        23081,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id =
        23082,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name =
        23083,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number =
        23084,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        23085,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        23086,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        23087,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState =
        23088,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState =
        23089,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState =
        23090,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id =
        23091,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name =
        23092,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number =
        23093,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        23094,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        23095,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        23096,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        23097,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        23098,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        23100,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        23101,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        23102,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        23103,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        23104,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        23105,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        23106,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        23107,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        23108,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        23109,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        23110,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        23111,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        23112,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        23113,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        23115,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved =
        23118,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved =
        23119,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled =
        23120,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound = 23121,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId =
        23122,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        23123,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId =
        23124,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState = 23125,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id =
        23126,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name =
        23127,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number =
        23128,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        23129,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        23130,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        23131,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState =
        23132,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState =
        23133,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay = 23134,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay = 23135,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag =
        23136,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState = 23138,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id =
        23139,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name =
        23140,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number =
        23141,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        23142,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        23143,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        23144,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState =
        23145,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState =
        23146,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime = 23147,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        23148,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState = 23155,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId = 23156,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime =
        23157,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency =
        23158,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency = 23159,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId = 23161,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType =
        23162,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode =
        23163,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName =
        23164,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time = 23165,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime =
        23166,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime =
        23167,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message = 23168,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity = 23169,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId =
        23170,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName =
        23171,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId =
        23172,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName =
        23173,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName =
        23174,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId = 23175,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain = 23176,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState =
        23177,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id =
        23178,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name =
        23179,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number =
        23180,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName =
        23181,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime =
        23182,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime =
        23183,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState =
        23184,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState =
        23185,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality = 23186,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp =
        23187,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity =
        23188,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp =
        23189,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment = 23190,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp =
        23191,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId =
        23192,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments =
        23196,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState =
        23197,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id =
        23198,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name =
        23199,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number =
        23200,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName =
        23201,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime =
        23202,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime =
        23203,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState =
        23204,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState =
        23205,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState =
        23206,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id =
        23207,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name =
        23208,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number =
        23209,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName =
        23210,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime =
        23211,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime =
        23212,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState =
        23213,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState =
        23214,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments =
        23216,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments =
        23218,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState =
        23219,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id =
        23220,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name =
        23221,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number =
        23222,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName =
        23223,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime =
        23224,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime =
        23225,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState =
        23226,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState =
        23227,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode =
        23228,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState =
        23229,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id =
        23230,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name =
        23231,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number =
        23232,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName =
        23233,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime =
        23234,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime =
        23235,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState =
        23236,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState =
        23237,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState =
        23238,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id =
        23239,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name =
        23240,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number =
        23241,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName =
        23242,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime =
        23243,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime =
        23244,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState =
        23245,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState =
        23246,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState =
        23248,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id =
        23249,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name =
        23250,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number =
        23251,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName =
        23252,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition =
        23253,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id =
        23254,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name =
        23255,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number =
        23256,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime =
        23257,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime =
        23258,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates =
        23259,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions =
        23260,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime =
        23261,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments =
        23263,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved =
        23266,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved =
        23267,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled =
        23268,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound =
        23269,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId =
        23270,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId =
        23271,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId =
        23272,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState =
        23273,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id =
        23274,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name =
        23275,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number =
        23276,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName =
        23277,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime =
        23278,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime =
        23279,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState =
        23280,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState =
        23281,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay = 23282,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay = 23283,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag =
        23284,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState =
        23286,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id =
        23287,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name =
        23288,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number =
        23289,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName =
        23290,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime =
        23291,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime =
        23292,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState =
        23293,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState =
        23294,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime =
        23295,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount =
        23296,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState =
        23303,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate =
        23304,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit =
        23305,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType =
        23306,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate =
        23307,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId = 23309,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType =
        23310,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode =
        23311,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName =
        23312,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time = 23313,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime =
        23314,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime =
        23315,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message = 23316,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity = 23317,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId =
        23318,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName =
        23319,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId =
        23320,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName =
        23321,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName =
        23322,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId = 23323,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain = 23324,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState =
        23325,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id =
        23326,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name =
        23327,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number =
        23328,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName =
        23329,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime =
        23330,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime =
        23331,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState =
        23332,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState =
        23333,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality = 23334,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp =
        23335,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity =
        23336,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp =
        23337,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment = 23338,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp =
        23339,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId =
        23340,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments =
        23344,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState =
        23345,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id =
        23346,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name =
        23347,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number =
        23348,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName =
        23349,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime =
        23350,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime =
        23351,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState =
        23352,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState =
        23353,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState =
        23354,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id =
        23355,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name =
        23356,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number =
        23357,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName =
        23358,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime =
        23359,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime =
        23360,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState =
        23361,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState =
        23362,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments =
        23364,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments =
        23366,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState =
        23367,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id =
        23368,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name =
        23369,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number =
        23370,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName =
        23371,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime =
        23372,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime =
        23373,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState =
        23374,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState =
        23375,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode =
        23376,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState =
        23377,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id =
        23378,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name =
        23379,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number =
        23380,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName =
        23381,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime =
        23382,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime =
        23383,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState =
        23384,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState =
        23385,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState =
        23386,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id =
        23387,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name =
        23388,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number =
        23389,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName =
        23390,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime =
        23391,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime =
        23392,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState =
        23393,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState =
        23394,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState =
        23396,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id =
        23397,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name =
        23398,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number =
        23399,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName =
        23400,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition =
        23401,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id =
        23402,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name =
        23403,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number =
        23404,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime =
        23405,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime =
        23406,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates =
        23407,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions =
        23408,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime =
        23409,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments =
        23411,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved =
        23414,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved =
        23415,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled =
        23416,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound =
        23417,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId =
        23418,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId =
        23419,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId =
        23420,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState =
        23421,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id =
        23422,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name =
        23423,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number =
        23424,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName =
        23425,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime =
        23426,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime =
        23427,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState =
        23428,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState =
        23429,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay = 23430,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay = 23431,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag =
        23432,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState =
        23434,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id =
        23435,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name =
        23436,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number =
        23437,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName =
        23438,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime =
        23439,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime =
        23440,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState =
        23441,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState =
        23442,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime =
        23443,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount =
        23444,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState =
        23451,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId =
        23452,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime =
        23453,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency =
        23454,
    AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias_InputArguments = 23460,
    AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments = 23461,
    AliasNameCategoryType_FindAlias_InputArguments = 23463,
    AliasNameCategoryType_FindAlias_OutputArguments = 23464,
    FindAliasMethodType_InputArguments = 23466,
    FindAliasMethodType_OutputArguments = 23467,
    Aliases_SubAliasNameCategories_Placeholder_FindAlias_InputArguments = 23474,
    Aliases_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments = 23475,
    Aliases_FindAlias_InputArguments = 23477,
    Aliases_FindAlias_OutputArguments = 23478,
    TagVariables_SubAliasNameCategories_Placeholder_FindAlias_InputArguments = 23483,
    TagVariables_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments = 23484,
    TagVariables_FindAlias_InputArguments = 23486,
    TagVariables_FindAlias_OutputArguments = 23487,
    Topics_SubAliasNameCategories_Placeholder_FindAlias_InputArguments = 23492,
    Topics_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments = 23493,
    Topics_FindAlias_InputArguments = 23495,
    Topics_FindAlias_OutputArguments = 23496,
    CurrencyUnit = 23501,
    OpcUa_BinarySchema_AliasNameDataType = 23502,
    OpcUa_BinarySchema_AliasNameDataType_DataTypeVersion = 23503,
    OpcUa_BinarySchema_AliasNameDataType_DictionaryFragment = 23504,
    OpcUa_BinarySchema_CurrencyUnitType = 23514,
    OpcUa_BinarySchema_CurrencyUnitType_DataTypeVersion = 23515,
    OpcUa_BinarySchema_CurrencyUnitType_DictionaryFragment = 23516,
    IOrderedObjectType_NumberInList = 23517,
    OrderedListType_OrderedObject_Placeholder_NumberInList = 23521,
    OrderedListType_NodeVersion = 23525,
    CertificateGroupType_GetRejectedList_OutputArguments = 23527,
    CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList_OutputArguments = 23530,
    CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList_OutputArguments = 23532,
    CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList_OutputArguments = 23534,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_GetRejectedList_OutputArguments = 23536,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments =
        23545,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments =
        23547,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments =
        23549,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments =
        23551,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments = 23553,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments =
        23555,
    AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_ServiceUri = 23558,
    AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_ServiceCertificate = 23559,
    AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_IssuerEndpointUrl = 23560,
}

impl<'a> From<&'a VariableId> for NodeId {
    fn from(r: &'a VariableId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for VariableId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for VariableId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for VariableId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            104 => Ok(VariableId::DataTypeDescriptionType_DataTypeVersion),
            105 => Ok(VariableId::DataTypeDescriptionType_DictionaryFragment),
            106 => Ok(VariableId::DataTypeDictionaryType_DataTypeVersion),
            107 => Ok(VariableId::DataTypeDictionaryType_NamespaceUri),
            111 => Ok(VariableId::ModellingRuleType_NamingRule),
            112 => Ok(VariableId::ModellingRule_Mandatory_NamingRule),
            113 => Ok(VariableId::ModellingRule_Optional_NamingRule),
            114 => Ok(VariableId::ModellingRule_ExposesItsArray_NamingRule),
            2005 => Ok(VariableId::ServerType_ServerArray),
            2006 => Ok(VariableId::ServerType_NamespaceArray),
            2007 => Ok(VariableId::ServerType_ServerStatus),
            2008 => Ok(VariableId::ServerType_ServiceLevel),
            2014 => Ok(VariableId::ServerCapabilitiesType_ServerProfileArray),
            2016 => Ok(VariableId::ServerCapabilitiesType_LocaleIdArray),
            2017 => Ok(VariableId::ServerCapabilitiesType_MinSupportedSampleRate),
            2021 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary),
            2022 => Ok(VariableId::ServerDiagnosticsType_SamplingIntervalDiagnosticsArray),
            2023 => Ok(VariableId::ServerDiagnosticsType_SubscriptionDiagnosticsArray),
            2025 => Ok(VariableId::ServerDiagnosticsType_EnabledFlag),
            2027 => Ok(VariableId::SessionsDiagnosticsSummaryType_SessionDiagnosticsArray),
            2028 => Ok(VariableId::SessionsDiagnosticsSummaryType_SessionSecurityDiagnosticsArray),
            2030 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics),
            2031 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics),
            2032 => Ok(VariableId::SessionDiagnosticsObjectType_SubscriptionDiagnosticsArray),
            2035 => Ok(VariableId::ServerRedundancyType_RedundancySupport),
            2037 => Ok(VariableId::TransparentRedundancyType_CurrentServerId),
            2038 => Ok(VariableId::TransparentRedundancyType_RedundantServerArray),
            2040 => Ok(VariableId::NonTransparentRedundancyType_ServerUriArray),
            2042 => Ok(VariableId::BaseEventType_EventId),
            2043 => Ok(VariableId::BaseEventType_EventType),
            2044 => Ok(VariableId::BaseEventType_SourceNode),
            2045 => Ok(VariableId::BaseEventType_SourceName),
            2046 => Ok(VariableId::BaseEventType_Time),
            2047 => Ok(VariableId::BaseEventType_ReceiveTime),
            2050 => Ok(VariableId::BaseEventType_Message),
            2051 => Ok(VariableId::BaseEventType_Severity),
            2053 => Ok(VariableId::AuditEventType_ActionTimeStamp),
            2054 => Ok(VariableId::AuditEventType_Status),
            2055 => Ok(VariableId::AuditEventType_ServerId),
            2056 => Ok(VariableId::AuditEventType_ClientAuditEntryId),
            2057 => Ok(VariableId::AuditEventType_ClientUserId),
            2061 => Ok(VariableId::AuditOpenSecureChannelEventType_ClientCertificate),
            2062 => Ok(VariableId::AuditOpenSecureChannelEventType_RequestType),
            2063 => Ok(VariableId::AuditOpenSecureChannelEventType_SecurityPolicyUri),
            2065 => Ok(VariableId::AuditOpenSecureChannelEventType_SecurityMode),
            2066 => Ok(VariableId::AuditOpenSecureChannelEventType_RequestedLifetime),
            2070 => Ok(VariableId::AuditSessionEventType_SessionId),
            2072 => Ok(VariableId::AuditCreateSessionEventType_SecureChannelId),
            2073 => Ok(VariableId::AuditCreateSessionEventType_ClientCertificate),
            2074 => Ok(VariableId::AuditCreateSessionEventType_RevisedSessionTimeout),
            2076 => Ok(VariableId::AuditActivateSessionEventType_ClientSoftwareCertificates),
            2077 => Ok(VariableId::AuditActivateSessionEventType_UserIdentityToken),
            2079 => Ok(VariableId::AuditCancelEventType_RequestHandle),
            2081 => Ok(VariableId::AuditCertificateEventType_Certificate),
            2083 => Ok(VariableId::AuditCertificateDataMismatchEventType_InvalidHostname),
            2084 => Ok(VariableId::AuditCertificateDataMismatchEventType_InvalidUri),
            2092 => Ok(VariableId::AuditAddNodesEventType_NodesToAdd),
            2094 => Ok(VariableId::AuditDeleteNodesEventType_NodesToDelete),
            2096 => Ok(VariableId::AuditAddReferencesEventType_ReferencesToAdd),
            2098 => Ok(VariableId::AuditDeleteReferencesEventType_ReferencesToDelete),
            2101 => Ok(VariableId::AuditWriteUpdateEventType_IndexRange),
            2102 => Ok(VariableId::AuditWriteUpdateEventType_OldValue),
            2103 => Ok(VariableId::AuditWriteUpdateEventType_NewValue),
            2128 => Ok(VariableId::AuditUpdateMethodEventType_MethodId),
            2129 => Ok(VariableId::AuditUpdateMethodEventType_InputArguments),
            2134 => Ok(VariableId::GeneralModelChangeEventType_Changes),
            2139 => Ok(VariableId::ServerStatusType_StartTime),
            2140 => Ok(VariableId::ServerStatusType_CurrentTime),
            2141 => Ok(VariableId::ServerStatusType_State),
            2142 => Ok(VariableId::ServerStatusType_BuildInfo),
            2151 => Ok(VariableId::ServerDiagnosticsSummaryType_ServerViewCount),
            2152 => Ok(VariableId::ServerDiagnosticsSummaryType_CurrentSessionCount),
            2153 => Ok(VariableId::ServerDiagnosticsSummaryType_CumulatedSessionCount),
            2154 => Ok(VariableId::ServerDiagnosticsSummaryType_SecurityRejectedSessionCount),
            2155 => Ok(VariableId::ServerDiagnosticsSummaryType_RejectedSessionCount),
            2156 => Ok(VariableId::ServerDiagnosticsSummaryType_SessionTimeoutCount),
            2157 => Ok(VariableId::ServerDiagnosticsSummaryType_SessionAbortCount),
            2159 => Ok(VariableId::ServerDiagnosticsSummaryType_PublishingIntervalCount),
            2160 => Ok(VariableId::ServerDiagnosticsSummaryType_CurrentSubscriptionCount),
            2161 => Ok(VariableId::ServerDiagnosticsSummaryType_CumulatedSubscriptionCount),
            2162 => Ok(VariableId::ServerDiagnosticsSummaryType_SecurityRejectedRequestsCount),
            2163 => Ok(VariableId::ServerDiagnosticsSummaryType_RejectedRequestsCount),
            2166 => Ok(VariableId::SamplingIntervalDiagnosticsType_SamplingInterval),
            2173 => Ok(VariableId::SubscriptionDiagnosticsType_SessionId),
            2174 => Ok(VariableId::SubscriptionDiagnosticsType_SubscriptionId),
            2175 => Ok(VariableId::SubscriptionDiagnosticsType_Priority),
            2176 => Ok(VariableId::SubscriptionDiagnosticsType_PublishingInterval),
            2177 => Ok(VariableId::SubscriptionDiagnosticsType_MaxKeepAliveCount),
            2179 => Ok(VariableId::SubscriptionDiagnosticsType_MaxNotificationsPerPublish),
            2180 => Ok(VariableId::SubscriptionDiagnosticsType_PublishingEnabled),
            2181 => Ok(VariableId::SubscriptionDiagnosticsType_ModifyCount),
            2182 => Ok(VariableId::SubscriptionDiagnosticsType_EnableCount),
            2183 => Ok(VariableId::SubscriptionDiagnosticsType_DisableCount),
            2184 => Ok(VariableId::SubscriptionDiagnosticsType_RepublishRequestCount),
            2185 => Ok(VariableId::SubscriptionDiagnosticsType_RepublishMessageRequestCount),
            2186 => Ok(VariableId::SubscriptionDiagnosticsType_RepublishMessageCount),
            2187 => Ok(VariableId::SubscriptionDiagnosticsType_TransferRequestCount),
            2188 => Ok(VariableId::SubscriptionDiagnosticsType_TransferredToAltClientCount),
            2189 => Ok(VariableId::SubscriptionDiagnosticsType_TransferredToSameClientCount),
            2190 => Ok(VariableId::SubscriptionDiagnosticsType_PublishRequestCount),
            2191 => Ok(VariableId::SubscriptionDiagnosticsType_DataChangeNotificationsCount),
            2193 => Ok(VariableId::SubscriptionDiagnosticsType_NotificationsCount),
            2198 => Ok(VariableId::SessionDiagnosticsVariableType_SessionId),
            2199 => Ok(VariableId::SessionDiagnosticsVariableType_SessionName),
            2200 => Ok(VariableId::SessionDiagnosticsVariableType_ClientDescription),
            2201 => Ok(VariableId::SessionDiagnosticsVariableType_ServerUri),
            2202 => Ok(VariableId::SessionDiagnosticsVariableType_EndpointUrl),
            2203 => Ok(VariableId::SessionDiagnosticsVariableType_LocaleIds),
            2204 => Ok(VariableId::SessionDiagnosticsVariableType_ActualSessionTimeout),
            2205 => Ok(VariableId::SessionDiagnosticsVariableType_ClientConnectionTime),
            2206 => Ok(VariableId::SessionDiagnosticsVariableType_ClientLastContactTime),
            2207 => Ok(VariableId::SessionDiagnosticsVariableType_CurrentSubscriptionsCount),
            2208 => Ok(VariableId::SessionDiagnosticsVariableType_CurrentMonitoredItemsCount),
            2209 => Ok(VariableId::SessionDiagnosticsVariableType_CurrentPublishRequestsInQueue),
            2217 => Ok(VariableId::SessionDiagnosticsVariableType_ReadCount),
            2218 => Ok(VariableId::SessionDiagnosticsVariableType_HistoryReadCount),
            2219 => Ok(VariableId::SessionDiagnosticsVariableType_WriteCount),
            2220 => Ok(VariableId::SessionDiagnosticsVariableType_HistoryUpdateCount),
            2221 => Ok(VariableId::SessionDiagnosticsVariableType_CallCount),
            2222 => Ok(VariableId::SessionDiagnosticsVariableType_CreateMonitoredItemsCount),
            2223 => Ok(VariableId::SessionDiagnosticsVariableType_ModifyMonitoredItemsCount),
            2224 => Ok(VariableId::SessionDiagnosticsVariableType_SetMonitoringModeCount),
            2225 => Ok(VariableId::SessionDiagnosticsVariableType_SetTriggeringCount),
            2226 => Ok(VariableId::SessionDiagnosticsVariableType_DeleteMonitoredItemsCount),
            2227 => Ok(VariableId::SessionDiagnosticsVariableType_CreateSubscriptionCount),
            2228 => Ok(VariableId::SessionDiagnosticsVariableType_ModifySubscriptionCount),
            2229 => Ok(VariableId::SessionDiagnosticsVariableType_SetPublishingModeCount),
            2230 => Ok(VariableId::SessionDiagnosticsVariableType_PublishCount),
            2231 => Ok(VariableId::SessionDiagnosticsVariableType_RepublishCount),
            2232 => Ok(VariableId::SessionDiagnosticsVariableType_TransferSubscriptionsCount),
            2233 => Ok(VariableId::SessionDiagnosticsVariableType_DeleteSubscriptionsCount),
            2234 => Ok(VariableId::SessionDiagnosticsVariableType_AddNodesCount),
            2235 => Ok(VariableId::SessionDiagnosticsVariableType_AddReferencesCount),
            2236 => Ok(VariableId::SessionDiagnosticsVariableType_DeleteNodesCount),
            2237 => Ok(VariableId::SessionDiagnosticsVariableType_DeleteReferencesCount),
            2238 => Ok(VariableId::SessionDiagnosticsVariableType_BrowseCount),
            2239 => Ok(VariableId::SessionDiagnosticsVariableType_BrowseNextCount),
            2240 => Ok(VariableId::SessionDiagnosticsVariableType_TranslateBrowsePathsToNodeIdsCount),
            2241 => Ok(VariableId::SessionDiagnosticsVariableType_QueryFirstCount),
            2242 => Ok(VariableId::SessionDiagnosticsVariableType_QueryNextCount),
            2245 => Ok(VariableId::SessionSecurityDiagnosticsType_SessionId),
            2246 => Ok(VariableId::SessionSecurityDiagnosticsType_ClientUserIdOfSession),
            2247 => Ok(VariableId::SessionSecurityDiagnosticsType_ClientUserIdHistory),
            2248 => Ok(VariableId::SessionSecurityDiagnosticsType_AuthenticationMechanism),
            2249 => Ok(VariableId::SessionSecurityDiagnosticsType_Encoding),
            2250 => Ok(VariableId::SessionSecurityDiagnosticsType_TransportProtocol),
            2251 => Ok(VariableId::SessionSecurityDiagnosticsType_SecurityMode),
            2252 => Ok(VariableId::SessionSecurityDiagnosticsType_SecurityPolicyUri),
            2254 => Ok(VariableId::Server_ServerArray),
            2255 => Ok(VariableId::Server_NamespaceArray),
            2256 => Ok(VariableId::Server_ServerStatus),
            2257 => Ok(VariableId::Server_ServerStatus_StartTime),
            2258 => Ok(VariableId::Server_ServerStatus_CurrentTime),
            2259 => Ok(VariableId::Server_ServerStatus_State),
            2260 => Ok(VariableId::Server_ServerStatus_BuildInfo),
            2261 => Ok(VariableId::Server_ServerStatus_BuildInfo_ProductName),
            2262 => Ok(VariableId::Server_ServerStatus_BuildInfo_ProductUri),
            2263 => Ok(VariableId::Server_ServerStatus_BuildInfo_ManufacturerName),
            2264 => Ok(VariableId::Server_ServerStatus_BuildInfo_SoftwareVersion),
            2265 => Ok(VariableId::Server_ServerStatus_BuildInfo_BuildNumber),
            2266 => Ok(VariableId::Server_ServerStatus_BuildInfo_BuildDate),
            2267 => Ok(VariableId::Server_ServiceLevel),
            2269 => Ok(VariableId::Server_ServerCapabilities_ServerProfileArray),
            2271 => Ok(VariableId::Server_ServerCapabilities_LocaleIdArray),
            2272 => Ok(VariableId::Server_ServerCapabilities_MinSupportedSampleRate),
            2275 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary),
            2276 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount),
            2277 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount),
            2278 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount),
            2279 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount),
            2281 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount),
            2282 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount),
            2284 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount),
            2285 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount),
            2286 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount),
            2287 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount),
            2288 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount),
            2289 => Ok(VariableId::Server_ServerDiagnostics_SamplingIntervalDiagnosticsArray),
            2290 => Ok(VariableId::Server_ServerDiagnostics_SubscriptionDiagnosticsArray),
            2294 => Ok(VariableId::Server_ServerDiagnostics_EnabledFlag),
            2308 => Ok(VariableId::StateType_StateNumber),
            2312 => Ok(VariableId::TransitionType_TransitionNumber),
            2323 => Ok(VariableId::HistoricalDataConfigurationType_Stepped),
            2324 => Ok(VariableId::HistoricalDataConfigurationType_Definition),
            2325 => Ok(VariableId::HistoricalDataConfigurationType_MaxTimeInterval),
            2326 => Ok(VariableId::HistoricalDataConfigurationType_MinTimeInterval),
            2327 => Ok(VariableId::HistoricalDataConfigurationType_ExceptionDeviation),
            2328 => Ok(VariableId::HistoricalDataConfigurationType_ExceptionDeviationFormat),
            2331 => Ok(VariableId::HistoryServerCapabilitiesType_AccessHistoryDataCapability),
            2332 => Ok(VariableId::HistoryServerCapabilitiesType_AccessHistoryEventsCapability),
            2334 => Ok(VariableId::HistoryServerCapabilitiesType_InsertDataCapability),
            2335 => Ok(VariableId::HistoryServerCapabilitiesType_ReplaceDataCapability),
            2336 => Ok(VariableId::HistoryServerCapabilitiesType_UpdateDataCapability),
            2337 => Ok(VariableId::HistoryServerCapabilitiesType_DeleteRawCapability),
            2338 => Ok(VariableId::HistoryServerCapabilitiesType_DeleteAtTimeCapability),
            2366 => Ok(VariableId::DataItemType_Definition),
            2367 => Ok(VariableId::DataItemType_ValuePrecision),
            2369 => Ok(VariableId::AnalogItemType_EURange),
            2370 => Ok(VariableId::AnalogItemType_InstrumentRange),
            2371 => Ok(VariableId::AnalogItemType_EngineeringUnits),
            2374 => Ok(VariableId::TwoStateDiscreteType_FalseState),
            2375 => Ok(VariableId::TwoStateDiscreteType_TrueState),
            2377 => Ok(VariableId::MultiStateDiscreteType_EnumStrings),
            2379 => Ok(VariableId::ProgramTransitionEventType_IntermediateResult),
            2381 => Ok(VariableId::ProgramDiagnosticType_CreateSessionId),
            2382 => Ok(VariableId::ProgramDiagnosticType_CreateClientName),
            2383 => Ok(VariableId::ProgramDiagnosticType_InvocationCreationTime),
            2384 => Ok(VariableId::ProgramDiagnosticType_LastTransitionTime),
            2385 => Ok(VariableId::ProgramDiagnosticType_LastMethodCall),
            2386 => Ok(VariableId::ProgramDiagnosticType_LastMethodSessionId),
            2387 => Ok(VariableId::ProgramDiagnosticType_LastMethodInputArguments),
            2388 => Ok(VariableId::ProgramDiagnosticType_LastMethodOutputArguments),
            2389 => Ok(VariableId::ProgramDiagnosticType_LastMethodCallTime),
            2390 => Ok(VariableId::ProgramDiagnosticType_LastMethodReturnStatus),
            2392 => Ok(VariableId::ProgramStateMachineType_Creatable),
            2393 => Ok(VariableId::ProgramStateMachineType_Deletable),
            2394 => Ok(VariableId::ProgramStateMachineType_AutoDelete),
            2395 => Ok(VariableId::ProgramStateMachineType_RecycleCount),
            2396 => Ok(VariableId::ProgramStateMachineType_InstanceCount),
            2397 => Ok(VariableId::ProgramStateMachineType_MaxInstanceCount),
            2398 => Ok(VariableId::ProgramStateMachineType_MaxRecycleCount),
            2399 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic),
            2401 => Ok(VariableId::ProgramStateMachineType_Ready_StateNumber),
            2403 => Ok(VariableId::ProgramStateMachineType_Running_StateNumber),
            2405 => Ok(VariableId::ProgramStateMachineType_Suspended_StateNumber),
            2407 => Ok(VariableId::ProgramStateMachineType_Halted_StateNumber),
            2409 => Ok(VariableId::ProgramStateMachineType_HaltedToReady_TransitionNumber),
            2411 => Ok(VariableId::ProgramStateMachineType_ReadyToRunning_TransitionNumber),
            2413 => Ok(VariableId::ProgramStateMachineType_RunningToHalted_TransitionNumber),
            2415 => Ok(VariableId::ProgramStateMachineType_RunningToReady_TransitionNumber),
            2417 => Ok(VariableId::ProgramStateMachineType_RunningToSuspended_TransitionNumber),
            2419 => Ok(VariableId::ProgramStateMachineType_SuspendedToRunning_TransitionNumber),
            2421 => Ok(VariableId::ProgramStateMachineType_SuspendedToHalted_TransitionNumber),
            2423 => Ok(VariableId::ProgramStateMachineType_SuspendedToReady_TransitionNumber),
            2425 => Ok(VariableId::ProgramStateMachineType_ReadyToHalted_TransitionNumber),
            2730 => Ok(VariableId::SessionDiagnosticsVariableType_RegisterNodesCount),
            2731 => Ok(VariableId::SessionDiagnosticsVariableType_UnregisterNodesCount),
            2732 => Ok(VariableId::ServerCapabilitiesType_MaxBrowseContinuationPoints),
            2733 => Ok(VariableId::ServerCapabilitiesType_MaxQueryContinuationPoints),
            2734 => Ok(VariableId::ServerCapabilitiesType_MaxHistoryContinuationPoints),
            2735 => Ok(VariableId::Server_ServerCapabilities_MaxBrowseContinuationPoints),
            2736 => Ok(VariableId::Server_ServerCapabilities_MaxQueryContinuationPoints),
            2737 => Ok(VariableId::Server_ServerCapabilities_MaxHistoryContinuationPoints),
            2739 => Ok(VariableId::SemanticChangeEventType_Changes),
            2742 => Ok(VariableId::ServerType_Auditing),
            2745 => Ok(VariableId::AuditChannelEventType_SecureChannelId),
            2746 => Ok(VariableId::AuditOpenSecureChannelEventType_ClientCertificateThumbprint),
            2747 => Ok(VariableId::AuditCreateSessionEventType_ClientCertificateThumbprint),
            2749 => Ok(VariableId::AuditUrlMismatchEventType_EndpointUrl),
            2750 => Ok(VariableId::AuditWriteUpdateEventType_AttributeId),
            2751 => Ok(VariableId::AuditHistoryUpdateEventType_ParameterDataTypeId),
            2752 => Ok(VariableId::ServerStatusType_SecondsTillShutdown),
            2753 => Ok(VariableId::ServerStatusType_ShutdownReason),
            2756 => Ok(VariableId::StateVariableType_Id),
            2757 => Ok(VariableId::StateVariableType_Name),
            2758 => Ok(VariableId::StateVariableType_Number),
            2759 => Ok(VariableId::StateVariableType_EffectiveDisplayName),
            2761 => Ok(VariableId::FiniteStateVariableType_Id),
            2763 => Ok(VariableId::TransitionVariableType_Id),
            2764 => Ok(VariableId::TransitionVariableType_Name),
            2765 => Ok(VariableId::TransitionVariableType_Number),
            2766 => Ok(VariableId::TransitionVariableType_TransitionTime),
            2768 => Ok(VariableId::FiniteTransitionVariableType_Id),
            2769 => Ok(VariableId::StateMachineType_CurrentState),
            2770 => Ok(VariableId::StateMachineType_LastTransition),
            2772 => Ok(VariableId::FiniteStateMachineType_CurrentState),
            2773 => Ok(VariableId::FiniteStateMachineType_LastTransition),
            2774 => Ok(VariableId::TransitionEventType_Transition),
            2775 => Ok(VariableId::TransitionEventType_FromState),
            2776 => Ok(VariableId::TransitionEventType_ToState),
            2777 => Ok(VariableId::AuditUpdateStateEventType_OldStateId),
            2778 => Ok(VariableId::AuditUpdateStateEventType_NewStateId),
            2831 => Ok(VariableId::DialogConditionType_Prompt),
            2991 => Ok(VariableId::ShelvedStateMachineType_TimedShelve_InputArguments),
            2992 => Ok(VariableId::Server_ServerStatus_SecondsTillShutdown),
            2993 => Ok(VariableId::Server_ServerStatus_ShutdownReason),
            2994 => Ok(VariableId::Server_Auditing),
            2998 => Ok(VariableId::SubscriptionDiagnosticsType_EventNotificationsCount),
            3003 => Ok(VariableId::AuditHistoryEventUpdateEventType_Filter),
            3015 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_IsDeleteModified),
            3016 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_StartTime),
            3017 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_EndTime),
            3020 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ReqTimes),
            3021 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_OldValues),
            3023 => Ok(VariableId::AuditHistoryEventDeleteEventType_EventIds),
            3024 => Ok(VariableId::AuditHistoryEventDeleteEventType_OldValues),
            3025 => Ok(VariableId::AuditHistoryEventUpdateEventType_UpdatedNode),
            3026 => Ok(VariableId::AuditHistoryValueUpdateEventType_UpdatedNode),
            3027 => Ok(VariableId::AuditHistoryDeleteEventType_UpdatedNode),
            3028 => Ok(VariableId::AuditHistoryEventUpdateEventType_PerformInsertReplace),
            3029 => Ok(VariableId::AuditHistoryEventUpdateEventType_NewValues),
            3030 => Ok(VariableId::AuditHistoryEventUpdateEventType_OldValues),
            3031 => Ok(VariableId::AuditHistoryValueUpdateEventType_PerformInsertReplace),
            3032 => Ok(VariableId::AuditHistoryValueUpdateEventType_NewValues),
            3033 => Ok(VariableId::AuditHistoryValueUpdateEventType_OldValues),
            3034 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_OldValues),
            3049 => Ok(VariableId::ServerCapabilitiesType_SoftwareCertificates),
            3050 => Ok(VariableId::SessionDiagnosticsVariableType_MaxResponseMessageSize),
            3052 => Ok(VariableId::BuildInfoType_ProductUri),
            3053 => Ok(VariableId::BuildInfoType_ManufacturerName),
            3054 => Ok(VariableId::BuildInfoType_ProductName),
            3055 => Ok(VariableId::BuildInfoType_SoftwareVersion),
            3056 => Ok(VariableId::BuildInfoType_BuildNumber),
            3057 => Ok(VariableId::BuildInfoType_BuildDate),
            3058 => Ok(VariableId::SessionSecurityDiagnosticsType_ClientCertificate),
            3067 => Ok(VariableId::Icon),
            3068 => Ok(VariableId::NodeVersion),
            3069 => Ok(VariableId::LocalTime),
            3070 => Ok(VariableId::AllowNulls),
            3071 => Ok(VariableId::EnumValues),
            3072 => Ok(VariableId::InputArguments),
            3073 => Ok(VariableId::OutputArguments),
            3074 => Ok(VariableId::ServerType_ServerStatus_StartTime),
            3075 => Ok(VariableId::ServerType_ServerStatus_CurrentTime),
            3076 => Ok(VariableId::ServerType_ServerStatus_State),
            3077 => Ok(VariableId::ServerType_ServerStatus_BuildInfo),
            3078 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_ProductUri),
            3079 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_ManufacturerName),
            3080 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_ProductName),
            3081 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_SoftwareVersion),
            3082 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_BuildNumber),
            3083 => Ok(VariableId::ServerType_ServerStatus_BuildInfo_BuildDate),
            3084 => Ok(VariableId::ServerType_ServerStatus_SecondsTillShutdown),
            3085 => Ok(VariableId::ServerType_ServerStatus_ShutdownReason),
            3086 => Ok(VariableId::ServerType_ServerCapabilities_ServerProfileArray),
            3087 => Ok(VariableId::ServerType_ServerCapabilities_LocaleIdArray),
            3088 => Ok(VariableId::ServerType_ServerCapabilities_MinSupportedSampleRate),
            3089 => Ok(VariableId::ServerType_ServerCapabilities_MaxBrowseContinuationPoints),
            3090 => Ok(VariableId::ServerType_ServerCapabilities_MaxQueryContinuationPoints),
            3091 => Ok(VariableId::ServerType_ServerCapabilities_MaxHistoryContinuationPoints),
            3092 => Ok(VariableId::ServerType_ServerCapabilities_SoftwareCertificates),
            3095 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary),
            3096 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_ServerViewCount),
            3097 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSessionCount),
            3098 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSessionCount),
            3099 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedSessionCount),
            3100 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount),
            3101 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SessionTimeoutCount),
            3102 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SessionAbortCount),
            3104 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_PublishingIntervalCount),
            3105 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CurrentSubscriptionCount),
            3106 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_CumulatedSubscriptionCount),
            3107 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_SecurityRejectedRequestsCount),
            3108 => Ok(VariableId::ServerType_ServerDiagnostics_ServerDiagnosticsSummary_RejectedRequestsCount),
            3109 => Ok(VariableId::ServerType_ServerDiagnostics_SamplingIntervalDiagnosticsArray),
            3110 => Ok(VariableId::ServerType_ServerDiagnostics_SubscriptionDiagnosticsArray),
            3112 => Ok(VariableId::ServerType_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray),
            3113 => Ok(VariableId::ServerType_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray),
            3114 => Ok(VariableId::ServerType_ServerDiagnostics_EnabledFlag),
            3115 => Ok(VariableId::ServerType_ServerRedundancy_RedundancySupport),
            3116 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_ServerViewCount),
            3117 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_CurrentSessionCount),
            3118 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_CumulatedSessionCount),
            3119 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_SecurityRejectedSessionCount),
            3120 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_RejectedSessionCount),
            3121 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_SessionTimeoutCount),
            3122 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_SessionAbortCount),
            3124 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_PublishingIntervalCount),
            3125 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_CurrentSubscriptionCount),
            3126 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_CumulatedSubscriptionCount),
            3127 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_SecurityRejectedRequestsCount),
            3128 => Ok(VariableId::ServerDiagnosticsType_ServerDiagnosticsSummary_RejectedRequestsCount),
            3129 => Ok(VariableId::ServerDiagnosticsType_SessionsDiagnosticsSummary_SessionDiagnosticsArray),
            3130 => Ok(VariableId::ServerDiagnosticsType_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray),
            3131 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_SessionId),
            3132 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_SessionName),
            3133 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ClientDescription),
            3134 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ServerUri),
            3135 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_EndpointUrl),
            3136 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_LocaleIds),
            3137 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ActualSessionTimeout),
            3138 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_MaxResponseMessageSize),
            3139 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ClientConnectionTime),
            3140 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ClientLastContactTime),
            3141 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CurrentSubscriptionsCount),
            3142 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CurrentMonitoredItemsCount),
            3143 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CurrentPublishRequestsInQueue),
            3151 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ReadCount),
            3152 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_HistoryReadCount),
            3153 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_WriteCount),
            3154 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_HistoryUpdateCount),
            3155 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CallCount),
            3156 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CreateMonitoredItemsCount),
            3157 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ModifyMonitoredItemsCount),
            3158 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_SetMonitoringModeCount),
            3159 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_SetTriggeringCount),
            3160 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_DeleteMonitoredItemsCount),
            3161 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_CreateSubscriptionCount),
            3162 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_ModifySubscriptionCount),
            3163 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_SetPublishingModeCount),
            3164 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_PublishCount),
            3165 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_RepublishCount),
            3166 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_TransferSubscriptionsCount),
            3167 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_DeleteSubscriptionsCount),
            3168 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_AddNodesCount),
            3169 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_AddReferencesCount),
            3170 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_DeleteNodesCount),
            3171 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_DeleteReferencesCount),
            3172 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_BrowseCount),
            3173 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_BrowseNextCount),
            3174 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount),
            3175 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_QueryFirstCount),
            3176 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_QueryNextCount),
            3177 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_RegisterNodesCount),
            3178 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_UnregisterNodesCount),
            3179 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SessionId),
            3180 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdOfSession),
            3181 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientUserIdHistory),
            3182 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_AuthenticationMechanism),
            3183 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_Encoding),
            3184 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_TransportProtocol),
            3185 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityMode),
            3186 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_SecurityPolicyUri),
            3187 => Ok(VariableId::SessionDiagnosticsObjectType_SessionSecurityDiagnostics_ClientCertificate),
            3188 => Ok(VariableId::TransparentRedundancyType_RedundancySupport),
            3189 => Ok(VariableId::NonTransparentRedundancyType_RedundancySupport),
            3190 => Ok(VariableId::BaseEventType_LocalTime),
            3191 => Ok(VariableId::EventQueueOverflowEventType_EventId),
            3192 => Ok(VariableId::EventQueueOverflowEventType_EventType),
            3193 => Ok(VariableId::EventQueueOverflowEventType_SourceNode),
            3194 => Ok(VariableId::EventQueueOverflowEventType_SourceName),
            3195 => Ok(VariableId::EventQueueOverflowEventType_Time),
            3196 => Ok(VariableId::EventQueueOverflowEventType_ReceiveTime),
            3197 => Ok(VariableId::EventQueueOverflowEventType_LocalTime),
            3198 => Ok(VariableId::EventQueueOverflowEventType_Message),
            3199 => Ok(VariableId::EventQueueOverflowEventType_Severity),
            3200 => Ok(VariableId::AuditEventType_EventId),
            3201 => Ok(VariableId::AuditEventType_EventType),
            3202 => Ok(VariableId::AuditEventType_SourceNode),
            3203 => Ok(VariableId::AuditEventType_SourceName),
            3204 => Ok(VariableId::AuditEventType_Time),
            3205 => Ok(VariableId::AuditEventType_ReceiveTime),
            3206 => Ok(VariableId::AuditEventType_LocalTime),
            3207 => Ok(VariableId::AuditEventType_Message),
            3208 => Ok(VariableId::AuditEventType_Severity),
            3209 => Ok(VariableId::AuditSecurityEventType_EventId),
            3210 => Ok(VariableId::AuditSecurityEventType_EventType),
            3211 => Ok(VariableId::AuditSecurityEventType_SourceNode),
            3212 => Ok(VariableId::AuditSecurityEventType_SourceName),
            3213 => Ok(VariableId::AuditSecurityEventType_Time),
            3214 => Ok(VariableId::AuditSecurityEventType_ReceiveTime),
            3215 => Ok(VariableId::AuditSecurityEventType_LocalTime),
            3216 => Ok(VariableId::AuditSecurityEventType_Message),
            3217 => Ok(VariableId::AuditSecurityEventType_Severity),
            3218 => Ok(VariableId::AuditSecurityEventType_ActionTimeStamp),
            3219 => Ok(VariableId::AuditSecurityEventType_Status),
            3220 => Ok(VariableId::AuditSecurityEventType_ServerId),
            3221 => Ok(VariableId::AuditSecurityEventType_ClientAuditEntryId),
            3222 => Ok(VariableId::AuditSecurityEventType_ClientUserId),
            3223 => Ok(VariableId::AuditChannelEventType_EventId),
            3224 => Ok(VariableId::AuditChannelEventType_EventType),
            3225 => Ok(VariableId::AuditChannelEventType_SourceNode),
            3226 => Ok(VariableId::AuditChannelEventType_SourceName),
            3227 => Ok(VariableId::AuditChannelEventType_Time),
            3228 => Ok(VariableId::AuditChannelEventType_ReceiveTime),
            3229 => Ok(VariableId::AuditChannelEventType_LocalTime),
            3230 => Ok(VariableId::AuditChannelEventType_Message),
            3231 => Ok(VariableId::AuditChannelEventType_Severity),
            3232 => Ok(VariableId::AuditChannelEventType_ActionTimeStamp),
            3233 => Ok(VariableId::AuditChannelEventType_Status),
            3234 => Ok(VariableId::AuditChannelEventType_ServerId),
            3235 => Ok(VariableId::AuditChannelEventType_ClientAuditEntryId),
            3236 => Ok(VariableId::AuditChannelEventType_ClientUserId),
            3237 => Ok(VariableId::AuditOpenSecureChannelEventType_EventId),
            3238 => Ok(VariableId::AuditOpenSecureChannelEventType_EventType),
            3239 => Ok(VariableId::AuditOpenSecureChannelEventType_SourceNode),
            3240 => Ok(VariableId::AuditOpenSecureChannelEventType_SourceName),
            3241 => Ok(VariableId::AuditOpenSecureChannelEventType_Time),
            3242 => Ok(VariableId::AuditOpenSecureChannelEventType_ReceiveTime),
            3243 => Ok(VariableId::AuditOpenSecureChannelEventType_LocalTime),
            3244 => Ok(VariableId::AuditOpenSecureChannelEventType_Message),
            3245 => Ok(VariableId::AuditOpenSecureChannelEventType_Severity),
            3246 => Ok(VariableId::AuditOpenSecureChannelEventType_ActionTimeStamp),
            3247 => Ok(VariableId::AuditOpenSecureChannelEventType_Status),
            3248 => Ok(VariableId::AuditOpenSecureChannelEventType_ServerId),
            3249 => Ok(VariableId::AuditOpenSecureChannelEventType_ClientAuditEntryId),
            3250 => Ok(VariableId::AuditOpenSecureChannelEventType_ClientUserId),
            3251 => Ok(VariableId::AuditOpenSecureChannelEventType_SecureChannelId),
            3252 => Ok(VariableId::AuditSessionEventType_EventId),
            3253 => Ok(VariableId::AuditSessionEventType_EventType),
            3254 => Ok(VariableId::AuditSessionEventType_SourceNode),
            3255 => Ok(VariableId::AuditSessionEventType_SourceName),
            3256 => Ok(VariableId::AuditSessionEventType_Time),
            3257 => Ok(VariableId::AuditSessionEventType_ReceiveTime),
            3258 => Ok(VariableId::AuditSessionEventType_LocalTime),
            3259 => Ok(VariableId::AuditSessionEventType_Message),
            3260 => Ok(VariableId::AuditSessionEventType_Severity),
            3261 => Ok(VariableId::AuditSessionEventType_ActionTimeStamp),
            3262 => Ok(VariableId::AuditSessionEventType_Status),
            3263 => Ok(VariableId::AuditSessionEventType_ServerId),
            3264 => Ok(VariableId::AuditSessionEventType_ClientAuditEntryId),
            3265 => Ok(VariableId::AuditSessionEventType_ClientUserId),
            3266 => Ok(VariableId::AuditCreateSessionEventType_EventId),
            3267 => Ok(VariableId::AuditCreateSessionEventType_EventType),
            3268 => Ok(VariableId::AuditCreateSessionEventType_SourceNode),
            3269 => Ok(VariableId::AuditCreateSessionEventType_SourceName),
            3270 => Ok(VariableId::AuditCreateSessionEventType_Time),
            3271 => Ok(VariableId::AuditCreateSessionEventType_ReceiveTime),
            3272 => Ok(VariableId::AuditCreateSessionEventType_LocalTime),
            3273 => Ok(VariableId::AuditCreateSessionEventType_Message),
            3274 => Ok(VariableId::AuditCreateSessionEventType_Severity),
            3275 => Ok(VariableId::AuditCreateSessionEventType_ActionTimeStamp),
            3276 => Ok(VariableId::AuditCreateSessionEventType_Status),
            3277 => Ok(VariableId::AuditCreateSessionEventType_ServerId),
            3278 => Ok(VariableId::AuditCreateSessionEventType_ClientAuditEntryId),
            3279 => Ok(VariableId::AuditCreateSessionEventType_ClientUserId),
            3281 => Ok(VariableId::AuditUrlMismatchEventType_EventId),
            3282 => Ok(VariableId::AuditUrlMismatchEventType_EventType),
            3283 => Ok(VariableId::AuditUrlMismatchEventType_SourceNode),
            3284 => Ok(VariableId::AuditUrlMismatchEventType_SourceName),
            3285 => Ok(VariableId::AuditUrlMismatchEventType_Time),
            3286 => Ok(VariableId::AuditUrlMismatchEventType_ReceiveTime),
            3287 => Ok(VariableId::AuditUrlMismatchEventType_LocalTime),
            3288 => Ok(VariableId::AuditUrlMismatchEventType_Message),
            3289 => Ok(VariableId::AuditUrlMismatchEventType_Severity),
            3290 => Ok(VariableId::AuditUrlMismatchEventType_ActionTimeStamp),
            3291 => Ok(VariableId::AuditUrlMismatchEventType_Status),
            3292 => Ok(VariableId::AuditUrlMismatchEventType_ServerId),
            3293 => Ok(VariableId::AuditUrlMismatchEventType_ClientAuditEntryId),
            3294 => Ok(VariableId::AuditUrlMismatchEventType_ClientUserId),
            3296 => Ok(VariableId::AuditUrlMismatchEventType_SecureChannelId),
            3297 => Ok(VariableId::AuditUrlMismatchEventType_ClientCertificate),
            3298 => Ok(VariableId::AuditUrlMismatchEventType_ClientCertificateThumbprint),
            3299 => Ok(VariableId::AuditUrlMismatchEventType_RevisedSessionTimeout),
            3300 => Ok(VariableId::AuditActivateSessionEventType_EventId),
            3301 => Ok(VariableId::AuditActivateSessionEventType_EventType),
            3302 => Ok(VariableId::AuditActivateSessionEventType_SourceNode),
            3303 => Ok(VariableId::AuditActivateSessionEventType_SourceName),
            3304 => Ok(VariableId::AuditActivateSessionEventType_Time),
            3305 => Ok(VariableId::AuditActivateSessionEventType_ReceiveTime),
            3306 => Ok(VariableId::AuditActivateSessionEventType_LocalTime),
            3307 => Ok(VariableId::AuditActivateSessionEventType_Message),
            3308 => Ok(VariableId::AuditActivateSessionEventType_Severity),
            3309 => Ok(VariableId::AuditActivateSessionEventType_ActionTimeStamp),
            3310 => Ok(VariableId::AuditActivateSessionEventType_Status),
            3311 => Ok(VariableId::AuditActivateSessionEventType_ServerId),
            3312 => Ok(VariableId::AuditActivateSessionEventType_ClientAuditEntryId),
            3313 => Ok(VariableId::AuditActivateSessionEventType_ClientUserId),
            3314 => Ok(VariableId::AuditActivateSessionEventType_SessionId),
            3315 => Ok(VariableId::AuditCancelEventType_EventId),
            3316 => Ok(VariableId::AuditCancelEventType_EventType),
            3317 => Ok(VariableId::AuditCancelEventType_SourceNode),
            3318 => Ok(VariableId::AuditCancelEventType_SourceName),
            3319 => Ok(VariableId::AuditCancelEventType_Time),
            3320 => Ok(VariableId::AuditCancelEventType_ReceiveTime),
            3321 => Ok(VariableId::AuditCancelEventType_LocalTime),
            3322 => Ok(VariableId::AuditCancelEventType_Message),
            3323 => Ok(VariableId::AuditCancelEventType_Severity),
            3324 => Ok(VariableId::AuditCancelEventType_ActionTimeStamp),
            3325 => Ok(VariableId::AuditCancelEventType_Status),
            3326 => Ok(VariableId::AuditCancelEventType_ServerId),
            3327 => Ok(VariableId::AuditCancelEventType_ClientAuditEntryId),
            3328 => Ok(VariableId::AuditCancelEventType_ClientUserId),
            3329 => Ok(VariableId::AuditCancelEventType_SessionId),
            3330 => Ok(VariableId::AuditCertificateEventType_EventId),
            3331 => Ok(VariableId::AuditCertificateEventType_EventType),
            3332 => Ok(VariableId::AuditCertificateEventType_SourceNode),
            3333 => Ok(VariableId::AuditCertificateEventType_SourceName),
            3334 => Ok(VariableId::AuditCertificateEventType_Time),
            3335 => Ok(VariableId::AuditCertificateEventType_ReceiveTime),
            3336 => Ok(VariableId::AuditCertificateEventType_LocalTime),
            3337 => Ok(VariableId::AuditCertificateEventType_Message),
            3338 => Ok(VariableId::AuditCertificateEventType_Severity),
            3339 => Ok(VariableId::AuditCertificateEventType_ActionTimeStamp),
            3340 => Ok(VariableId::AuditCertificateEventType_Status),
            3341 => Ok(VariableId::AuditCertificateEventType_ServerId),
            3342 => Ok(VariableId::AuditCertificateEventType_ClientAuditEntryId),
            3343 => Ok(VariableId::AuditCertificateEventType_ClientUserId),
            3344 => Ok(VariableId::AuditCertificateDataMismatchEventType_EventId),
            3345 => Ok(VariableId::AuditCertificateDataMismatchEventType_EventType),
            3346 => Ok(VariableId::AuditCertificateDataMismatchEventType_SourceNode),
            3347 => Ok(VariableId::AuditCertificateDataMismatchEventType_SourceName),
            3348 => Ok(VariableId::AuditCertificateDataMismatchEventType_Time),
            3349 => Ok(VariableId::AuditCertificateDataMismatchEventType_ReceiveTime),
            3350 => Ok(VariableId::AuditCertificateDataMismatchEventType_LocalTime),
            3351 => Ok(VariableId::AuditCertificateDataMismatchEventType_Message),
            3352 => Ok(VariableId::AuditCertificateDataMismatchEventType_Severity),
            3353 => Ok(VariableId::AuditCertificateDataMismatchEventType_ActionTimeStamp),
            3354 => Ok(VariableId::AuditCertificateDataMismatchEventType_Status),
            3355 => Ok(VariableId::AuditCertificateDataMismatchEventType_ServerId),
            3356 => Ok(VariableId::AuditCertificateDataMismatchEventType_ClientAuditEntryId),
            3357 => Ok(VariableId::AuditCertificateDataMismatchEventType_ClientUserId),
            3358 => Ok(VariableId::AuditCertificateDataMismatchEventType_Certificate),
            3359 => Ok(VariableId::AuditCertificateExpiredEventType_EventId),
            3360 => Ok(VariableId::AuditCertificateExpiredEventType_EventType),
            3361 => Ok(VariableId::AuditCertificateExpiredEventType_SourceNode),
            3362 => Ok(VariableId::AuditCertificateExpiredEventType_SourceName),
            3363 => Ok(VariableId::AuditCertificateExpiredEventType_Time),
            3364 => Ok(VariableId::AuditCertificateExpiredEventType_ReceiveTime),
            3365 => Ok(VariableId::AuditCertificateExpiredEventType_LocalTime),
            3366 => Ok(VariableId::AuditCertificateExpiredEventType_Message),
            3367 => Ok(VariableId::AuditCertificateExpiredEventType_Severity),
            3368 => Ok(VariableId::AuditCertificateExpiredEventType_ActionTimeStamp),
            3369 => Ok(VariableId::AuditCertificateExpiredEventType_Status),
            3370 => Ok(VariableId::AuditCertificateExpiredEventType_ServerId),
            3371 => Ok(VariableId::AuditCertificateExpiredEventType_ClientAuditEntryId),
            3372 => Ok(VariableId::AuditCertificateExpiredEventType_ClientUserId),
            3373 => Ok(VariableId::AuditCertificateExpiredEventType_Certificate),
            3374 => Ok(VariableId::AuditCertificateInvalidEventType_EventId),
            3375 => Ok(VariableId::AuditCertificateInvalidEventType_EventType),
            3376 => Ok(VariableId::AuditCertificateInvalidEventType_SourceNode),
            3377 => Ok(VariableId::AuditCertificateInvalidEventType_SourceName),
            3378 => Ok(VariableId::AuditCertificateInvalidEventType_Time),
            3379 => Ok(VariableId::AuditCertificateInvalidEventType_ReceiveTime),
            3380 => Ok(VariableId::AuditCertificateInvalidEventType_LocalTime),
            3381 => Ok(VariableId::AuditCertificateInvalidEventType_Message),
            3382 => Ok(VariableId::AuditCertificateInvalidEventType_Severity),
            3383 => Ok(VariableId::AuditCertificateInvalidEventType_ActionTimeStamp),
            3384 => Ok(VariableId::AuditCertificateInvalidEventType_Status),
            3385 => Ok(VariableId::AuditCertificateInvalidEventType_ServerId),
            3386 => Ok(VariableId::AuditCertificateInvalidEventType_ClientAuditEntryId),
            3387 => Ok(VariableId::AuditCertificateInvalidEventType_ClientUserId),
            3388 => Ok(VariableId::AuditCertificateInvalidEventType_Certificate),
            3389 => Ok(VariableId::AuditCertificateUntrustedEventType_EventId),
            3390 => Ok(VariableId::AuditCertificateUntrustedEventType_EventType),
            3391 => Ok(VariableId::AuditCertificateUntrustedEventType_SourceNode),
            3392 => Ok(VariableId::AuditCertificateUntrustedEventType_SourceName),
            3393 => Ok(VariableId::AuditCertificateUntrustedEventType_Time),
            3394 => Ok(VariableId::AuditCertificateUntrustedEventType_ReceiveTime),
            3395 => Ok(VariableId::AuditCertificateUntrustedEventType_LocalTime),
            3396 => Ok(VariableId::AuditCertificateUntrustedEventType_Message),
            3397 => Ok(VariableId::AuditCertificateUntrustedEventType_Severity),
            3398 => Ok(VariableId::AuditCertificateUntrustedEventType_ActionTimeStamp),
            3399 => Ok(VariableId::AuditCertificateUntrustedEventType_Status),
            3400 => Ok(VariableId::AuditCertificateUntrustedEventType_ServerId),
            3401 => Ok(VariableId::AuditCertificateUntrustedEventType_ClientAuditEntryId),
            3402 => Ok(VariableId::AuditCertificateUntrustedEventType_ClientUserId),
            3403 => Ok(VariableId::AuditCertificateUntrustedEventType_Certificate),
            3404 => Ok(VariableId::AuditCertificateRevokedEventType_EventId),
            3405 => Ok(VariableId::AuditCertificateRevokedEventType_EventType),
            3406 => Ok(VariableId::AuditCertificateRevokedEventType_SourceNode),
            3407 => Ok(VariableId::AuditCertificateRevokedEventType_SourceName),
            3408 => Ok(VariableId::AuditCertificateRevokedEventType_Time),
            3409 => Ok(VariableId::AuditCertificateRevokedEventType_ReceiveTime),
            3410 => Ok(VariableId::AuditCertificateRevokedEventType_LocalTime),
            3411 => Ok(VariableId::AuditCertificateRevokedEventType_Message),
            3412 => Ok(VariableId::AuditCertificateRevokedEventType_Severity),
            3413 => Ok(VariableId::AuditCertificateRevokedEventType_ActionTimeStamp),
            3414 => Ok(VariableId::AuditCertificateRevokedEventType_Status),
            3415 => Ok(VariableId::AuditCertificateRevokedEventType_ServerId),
            3416 => Ok(VariableId::AuditCertificateRevokedEventType_ClientAuditEntryId),
            3417 => Ok(VariableId::AuditCertificateRevokedEventType_ClientUserId),
            3418 => Ok(VariableId::AuditCertificateRevokedEventType_Certificate),
            3419 => Ok(VariableId::AuditCertificateMismatchEventType_EventId),
            3420 => Ok(VariableId::AuditCertificateMismatchEventType_EventType),
            3421 => Ok(VariableId::AuditCertificateMismatchEventType_SourceNode),
            3422 => Ok(VariableId::AuditCertificateMismatchEventType_SourceName),
            3423 => Ok(VariableId::AuditCertificateMismatchEventType_Time),
            3424 => Ok(VariableId::AuditCertificateMismatchEventType_ReceiveTime),
            3425 => Ok(VariableId::AuditCertificateMismatchEventType_LocalTime),
            3426 => Ok(VariableId::AuditCertificateMismatchEventType_Message),
            3427 => Ok(VariableId::AuditCertificateMismatchEventType_Severity),
            3428 => Ok(VariableId::AuditCertificateMismatchEventType_ActionTimeStamp),
            3429 => Ok(VariableId::AuditCertificateMismatchEventType_Status),
            3430 => Ok(VariableId::AuditCertificateMismatchEventType_ServerId),
            3431 => Ok(VariableId::AuditCertificateMismatchEventType_ClientAuditEntryId),
            3432 => Ok(VariableId::AuditCertificateMismatchEventType_ClientUserId),
            3433 => Ok(VariableId::AuditCertificateMismatchEventType_Certificate),
            3434 => Ok(VariableId::AuditNodeManagementEventType_EventId),
            3435 => Ok(VariableId::AuditNodeManagementEventType_EventType),
            3436 => Ok(VariableId::AuditNodeManagementEventType_SourceNode),
            3437 => Ok(VariableId::AuditNodeManagementEventType_SourceName),
            3438 => Ok(VariableId::AuditNodeManagementEventType_Time),
            3439 => Ok(VariableId::AuditNodeManagementEventType_ReceiveTime),
            3440 => Ok(VariableId::AuditNodeManagementEventType_LocalTime),
            3441 => Ok(VariableId::AuditNodeManagementEventType_Message),
            3442 => Ok(VariableId::AuditNodeManagementEventType_Severity),
            3443 => Ok(VariableId::AuditNodeManagementEventType_ActionTimeStamp),
            3444 => Ok(VariableId::AuditNodeManagementEventType_Status),
            3445 => Ok(VariableId::AuditNodeManagementEventType_ServerId),
            3446 => Ok(VariableId::AuditNodeManagementEventType_ClientAuditEntryId),
            3447 => Ok(VariableId::AuditNodeManagementEventType_ClientUserId),
            3448 => Ok(VariableId::AuditAddNodesEventType_EventId),
            3449 => Ok(VariableId::AuditAddNodesEventType_EventType),
            3450 => Ok(VariableId::AuditAddNodesEventType_SourceNode),
            3451 => Ok(VariableId::AuditAddNodesEventType_SourceName),
            3452 => Ok(VariableId::AuditAddNodesEventType_Time),
            3453 => Ok(VariableId::AuditAddNodesEventType_ReceiveTime),
            3454 => Ok(VariableId::AuditAddNodesEventType_LocalTime),
            3455 => Ok(VariableId::AuditAddNodesEventType_Message),
            3456 => Ok(VariableId::AuditAddNodesEventType_Severity),
            3457 => Ok(VariableId::AuditAddNodesEventType_ActionTimeStamp),
            3458 => Ok(VariableId::AuditAddNodesEventType_Status),
            3459 => Ok(VariableId::AuditAddNodesEventType_ServerId),
            3460 => Ok(VariableId::AuditAddNodesEventType_ClientAuditEntryId),
            3461 => Ok(VariableId::AuditAddNodesEventType_ClientUserId),
            3462 => Ok(VariableId::AuditDeleteNodesEventType_EventId),
            3463 => Ok(VariableId::AuditDeleteNodesEventType_EventType),
            3464 => Ok(VariableId::AuditDeleteNodesEventType_SourceNode),
            3465 => Ok(VariableId::AuditDeleteNodesEventType_SourceName),
            3466 => Ok(VariableId::AuditDeleteNodesEventType_Time),
            3467 => Ok(VariableId::AuditDeleteNodesEventType_ReceiveTime),
            3468 => Ok(VariableId::AuditDeleteNodesEventType_LocalTime),
            3469 => Ok(VariableId::AuditDeleteNodesEventType_Message),
            3470 => Ok(VariableId::AuditDeleteNodesEventType_Severity),
            3471 => Ok(VariableId::AuditDeleteNodesEventType_ActionTimeStamp),
            3472 => Ok(VariableId::AuditDeleteNodesEventType_Status),
            3473 => Ok(VariableId::AuditDeleteNodesEventType_ServerId),
            3474 => Ok(VariableId::AuditDeleteNodesEventType_ClientAuditEntryId),
            3475 => Ok(VariableId::AuditDeleteNodesEventType_ClientUserId),
            3476 => Ok(VariableId::AuditAddReferencesEventType_EventId),
            3477 => Ok(VariableId::AuditAddReferencesEventType_EventType),
            3478 => Ok(VariableId::AuditAddReferencesEventType_SourceNode),
            3479 => Ok(VariableId::AuditAddReferencesEventType_SourceName),
            3480 => Ok(VariableId::AuditAddReferencesEventType_Time),
            3481 => Ok(VariableId::AuditAddReferencesEventType_ReceiveTime),
            3482 => Ok(VariableId::AuditAddReferencesEventType_LocalTime),
            3483 => Ok(VariableId::AuditAddReferencesEventType_Message),
            3484 => Ok(VariableId::AuditAddReferencesEventType_Severity),
            3485 => Ok(VariableId::AuditAddReferencesEventType_ActionTimeStamp),
            3486 => Ok(VariableId::AuditAddReferencesEventType_Status),
            3487 => Ok(VariableId::AuditAddReferencesEventType_ServerId),
            3488 => Ok(VariableId::AuditAddReferencesEventType_ClientAuditEntryId),
            3489 => Ok(VariableId::AuditAddReferencesEventType_ClientUserId),
            3490 => Ok(VariableId::AuditDeleteReferencesEventType_EventId),
            3491 => Ok(VariableId::AuditDeleteReferencesEventType_EventType),
            3492 => Ok(VariableId::AuditDeleteReferencesEventType_SourceNode),
            3493 => Ok(VariableId::AuditDeleteReferencesEventType_SourceName),
            3494 => Ok(VariableId::AuditDeleteReferencesEventType_Time),
            3495 => Ok(VariableId::AuditDeleteReferencesEventType_ReceiveTime),
            3496 => Ok(VariableId::AuditDeleteReferencesEventType_LocalTime),
            3497 => Ok(VariableId::AuditDeleteReferencesEventType_Message),
            3498 => Ok(VariableId::AuditDeleteReferencesEventType_Severity),
            3499 => Ok(VariableId::AuditDeleteReferencesEventType_ActionTimeStamp),
            3500 => Ok(VariableId::AuditDeleteReferencesEventType_Status),
            3501 => Ok(VariableId::AuditDeleteReferencesEventType_ServerId),
            3502 => Ok(VariableId::AuditDeleteReferencesEventType_ClientAuditEntryId),
            3503 => Ok(VariableId::AuditDeleteReferencesEventType_ClientUserId),
            3504 => Ok(VariableId::AuditUpdateEventType_EventId),
            3505 => Ok(VariableId::AuditUpdateEventType_EventType),
            3506 => Ok(VariableId::AuditUpdateEventType_SourceNode),
            3507 => Ok(VariableId::AuditUpdateEventType_SourceName),
            3508 => Ok(VariableId::AuditUpdateEventType_Time),
            3509 => Ok(VariableId::AuditUpdateEventType_ReceiveTime),
            3510 => Ok(VariableId::AuditUpdateEventType_LocalTime),
            3511 => Ok(VariableId::AuditUpdateEventType_Message),
            3512 => Ok(VariableId::AuditUpdateEventType_Severity),
            3513 => Ok(VariableId::AuditUpdateEventType_ActionTimeStamp),
            3514 => Ok(VariableId::AuditUpdateEventType_Status),
            3515 => Ok(VariableId::AuditUpdateEventType_ServerId),
            3516 => Ok(VariableId::AuditUpdateEventType_ClientAuditEntryId),
            3517 => Ok(VariableId::AuditUpdateEventType_ClientUserId),
            3518 => Ok(VariableId::AuditWriteUpdateEventType_EventId),
            3519 => Ok(VariableId::AuditWriteUpdateEventType_EventType),
            3520 => Ok(VariableId::AuditWriteUpdateEventType_SourceNode),
            3521 => Ok(VariableId::AuditWriteUpdateEventType_SourceName),
            3522 => Ok(VariableId::AuditWriteUpdateEventType_Time),
            3523 => Ok(VariableId::AuditWriteUpdateEventType_ReceiveTime),
            3524 => Ok(VariableId::AuditWriteUpdateEventType_LocalTime),
            3525 => Ok(VariableId::AuditWriteUpdateEventType_Message),
            3526 => Ok(VariableId::AuditWriteUpdateEventType_Severity),
            3527 => Ok(VariableId::AuditWriteUpdateEventType_ActionTimeStamp),
            3528 => Ok(VariableId::AuditWriteUpdateEventType_Status),
            3529 => Ok(VariableId::AuditWriteUpdateEventType_ServerId),
            3530 => Ok(VariableId::AuditWriteUpdateEventType_ClientAuditEntryId),
            3531 => Ok(VariableId::AuditWriteUpdateEventType_ClientUserId),
            3532 => Ok(VariableId::AuditHistoryUpdateEventType_EventId),
            3533 => Ok(VariableId::AuditHistoryUpdateEventType_EventType),
            3534 => Ok(VariableId::AuditHistoryUpdateEventType_SourceNode),
            3535 => Ok(VariableId::AuditHistoryUpdateEventType_SourceName),
            3536 => Ok(VariableId::AuditHistoryUpdateEventType_Time),
            3537 => Ok(VariableId::AuditHistoryUpdateEventType_ReceiveTime),
            3538 => Ok(VariableId::AuditHistoryUpdateEventType_LocalTime),
            3539 => Ok(VariableId::AuditHistoryUpdateEventType_Message),
            3540 => Ok(VariableId::AuditHistoryUpdateEventType_Severity),
            3541 => Ok(VariableId::AuditHistoryUpdateEventType_ActionTimeStamp),
            3542 => Ok(VariableId::AuditHistoryUpdateEventType_Status),
            3543 => Ok(VariableId::AuditHistoryUpdateEventType_ServerId),
            3544 => Ok(VariableId::AuditHistoryUpdateEventType_ClientAuditEntryId),
            3545 => Ok(VariableId::AuditHistoryUpdateEventType_ClientUserId),
            3546 => Ok(VariableId::AuditHistoryEventUpdateEventType_EventId),
            3547 => Ok(VariableId::AuditHistoryEventUpdateEventType_EventType),
            3548 => Ok(VariableId::AuditHistoryEventUpdateEventType_SourceNode),
            3549 => Ok(VariableId::AuditHistoryEventUpdateEventType_SourceName),
            3550 => Ok(VariableId::AuditHistoryEventUpdateEventType_Time),
            3551 => Ok(VariableId::AuditHistoryEventUpdateEventType_ReceiveTime),
            3552 => Ok(VariableId::AuditHistoryEventUpdateEventType_LocalTime),
            3553 => Ok(VariableId::AuditHistoryEventUpdateEventType_Message),
            3554 => Ok(VariableId::AuditHistoryEventUpdateEventType_Severity),
            3555 => Ok(VariableId::AuditHistoryEventUpdateEventType_ActionTimeStamp),
            3556 => Ok(VariableId::AuditHistoryEventUpdateEventType_Status),
            3557 => Ok(VariableId::AuditHistoryEventUpdateEventType_ServerId),
            3558 => Ok(VariableId::AuditHistoryEventUpdateEventType_ClientAuditEntryId),
            3559 => Ok(VariableId::AuditHistoryEventUpdateEventType_ClientUserId),
            3560 => Ok(VariableId::AuditHistoryEventUpdateEventType_ParameterDataTypeId),
            3561 => Ok(VariableId::AuditHistoryValueUpdateEventType_EventId),
            3562 => Ok(VariableId::AuditHistoryValueUpdateEventType_EventType),
            3563 => Ok(VariableId::AuditHistoryValueUpdateEventType_SourceNode),
            3564 => Ok(VariableId::AuditHistoryValueUpdateEventType_SourceName),
            3565 => Ok(VariableId::AuditHistoryValueUpdateEventType_Time),
            3566 => Ok(VariableId::AuditHistoryValueUpdateEventType_ReceiveTime),
            3567 => Ok(VariableId::AuditHistoryValueUpdateEventType_LocalTime),
            3568 => Ok(VariableId::AuditHistoryValueUpdateEventType_Message),
            3569 => Ok(VariableId::AuditHistoryValueUpdateEventType_Severity),
            3570 => Ok(VariableId::AuditHistoryValueUpdateEventType_ActionTimeStamp),
            3571 => Ok(VariableId::AuditHistoryValueUpdateEventType_Status),
            3572 => Ok(VariableId::AuditHistoryValueUpdateEventType_ServerId),
            3573 => Ok(VariableId::AuditHistoryValueUpdateEventType_ClientAuditEntryId),
            3574 => Ok(VariableId::AuditHistoryValueUpdateEventType_ClientUserId),
            3575 => Ok(VariableId::AuditHistoryValueUpdateEventType_ParameterDataTypeId),
            3576 => Ok(VariableId::AuditHistoryDeleteEventType_EventId),
            3577 => Ok(VariableId::AuditHistoryDeleteEventType_EventType),
            3578 => Ok(VariableId::AuditHistoryDeleteEventType_SourceNode),
            3579 => Ok(VariableId::AuditHistoryDeleteEventType_SourceName),
            3580 => Ok(VariableId::AuditHistoryDeleteEventType_Time),
            3581 => Ok(VariableId::AuditHistoryDeleteEventType_ReceiveTime),
            3582 => Ok(VariableId::AuditHistoryDeleteEventType_LocalTime),
            3583 => Ok(VariableId::AuditHistoryDeleteEventType_Message),
            3584 => Ok(VariableId::AuditHistoryDeleteEventType_Severity),
            3585 => Ok(VariableId::AuditHistoryDeleteEventType_ActionTimeStamp),
            3586 => Ok(VariableId::AuditHistoryDeleteEventType_Status),
            3587 => Ok(VariableId::AuditHistoryDeleteEventType_ServerId),
            3588 => Ok(VariableId::AuditHistoryDeleteEventType_ClientAuditEntryId),
            3589 => Ok(VariableId::AuditHistoryDeleteEventType_ClientUserId),
            3590 => Ok(VariableId::AuditHistoryDeleteEventType_ParameterDataTypeId),
            3591 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_EventId),
            3592 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_EventType),
            3593 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_SourceNode),
            3594 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_SourceName),
            3595 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_Time),
            3596 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ReceiveTime),
            3597 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_LocalTime),
            3598 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_Message),
            3599 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_Severity),
            3600 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ActionTimeStamp),
            3601 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_Status),
            3602 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ServerId),
            3603 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ClientAuditEntryId),
            3604 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ClientUserId),
            3605 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_ParameterDataTypeId),
            3606 => Ok(VariableId::AuditHistoryRawModifyDeleteEventType_UpdatedNode),
            3607 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_EventId),
            3608 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_EventType),
            3609 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_SourceNode),
            3610 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_SourceName),
            3611 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_Time),
            3612 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ReceiveTime),
            3613 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_LocalTime),
            3614 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_Message),
            3615 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_Severity),
            3616 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ActionTimeStamp),
            3617 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_Status),
            3618 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ServerId),
            3619 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ClientAuditEntryId),
            3620 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ClientUserId),
            3621 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_ParameterDataTypeId),
            3622 => Ok(VariableId::AuditHistoryAtTimeDeleteEventType_UpdatedNode),
            3623 => Ok(VariableId::AuditHistoryEventDeleteEventType_EventId),
            3624 => Ok(VariableId::AuditHistoryEventDeleteEventType_EventType),
            3625 => Ok(VariableId::AuditHistoryEventDeleteEventType_SourceNode),
            3626 => Ok(VariableId::AuditHistoryEventDeleteEventType_SourceName),
            3627 => Ok(VariableId::AuditHistoryEventDeleteEventType_Time),
            3628 => Ok(VariableId::AuditHistoryEventDeleteEventType_ReceiveTime),
            3629 => Ok(VariableId::AuditHistoryEventDeleteEventType_LocalTime),
            3630 => Ok(VariableId::AuditHistoryEventDeleteEventType_Message),
            3631 => Ok(VariableId::AuditHistoryEventDeleteEventType_Severity),
            3632 => Ok(VariableId::AuditHistoryEventDeleteEventType_ActionTimeStamp),
            3633 => Ok(VariableId::AuditHistoryEventDeleteEventType_Status),
            3634 => Ok(VariableId::AuditHistoryEventDeleteEventType_ServerId),
            3635 => Ok(VariableId::AuditHistoryEventDeleteEventType_ClientAuditEntryId),
            3636 => Ok(VariableId::AuditHistoryEventDeleteEventType_ClientUserId),
            3637 => Ok(VariableId::AuditHistoryEventDeleteEventType_ParameterDataTypeId),
            3638 => Ok(VariableId::AuditHistoryEventDeleteEventType_UpdatedNode),
            3639 => Ok(VariableId::AuditUpdateMethodEventType_EventId),
            3640 => Ok(VariableId::AuditUpdateMethodEventType_EventType),
            3641 => Ok(VariableId::AuditUpdateMethodEventType_SourceNode),
            3642 => Ok(VariableId::AuditUpdateMethodEventType_SourceName),
            3643 => Ok(VariableId::AuditUpdateMethodEventType_Time),
            3644 => Ok(VariableId::AuditUpdateMethodEventType_ReceiveTime),
            3645 => Ok(VariableId::AuditUpdateMethodEventType_LocalTime),
            3646 => Ok(VariableId::AuditUpdateMethodEventType_Message),
            3647 => Ok(VariableId::AuditUpdateMethodEventType_Severity),
            3648 => Ok(VariableId::AuditUpdateMethodEventType_ActionTimeStamp),
            3649 => Ok(VariableId::AuditUpdateMethodEventType_Status),
            3650 => Ok(VariableId::AuditUpdateMethodEventType_ServerId),
            3651 => Ok(VariableId::AuditUpdateMethodEventType_ClientAuditEntryId),
            3652 => Ok(VariableId::AuditUpdateMethodEventType_ClientUserId),
            3653 => Ok(VariableId::SystemEventType_EventId),
            3654 => Ok(VariableId::SystemEventType_EventType),
            3655 => Ok(VariableId::SystemEventType_SourceNode),
            3656 => Ok(VariableId::SystemEventType_SourceName),
            3657 => Ok(VariableId::SystemEventType_Time),
            3658 => Ok(VariableId::SystemEventType_ReceiveTime),
            3659 => Ok(VariableId::SystemEventType_LocalTime),
            3660 => Ok(VariableId::SystemEventType_Message),
            3661 => Ok(VariableId::SystemEventType_Severity),
            3662 => Ok(VariableId::DeviceFailureEventType_EventId),
            3663 => Ok(VariableId::DeviceFailureEventType_EventType),
            3664 => Ok(VariableId::DeviceFailureEventType_SourceNode),
            3665 => Ok(VariableId::DeviceFailureEventType_SourceName),
            3666 => Ok(VariableId::DeviceFailureEventType_Time),
            3667 => Ok(VariableId::DeviceFailureEventType_ReceiveTime),
            3668 => Ok(VariableId::DeviceFailureEventType_LocalTime),
            3669 => Ok(VariableId::DeviceFailureEventType_Message),
            3670 => Ok(VariableId::DeviceFailureEventType_Severity),
            3671 => Ok(VariableId::BaseModelChangeEventType_EventId),
            3672 => Ok(VariableId::BaseModelChangeEventType_EventType),
            3673 => Ok(VariableId::BaseModelChangeEventType_SourceNode),
            3674 => Ok(VariableId::BaseModelChangeEventType_SourceName),
            3675 => Ok(VariableId::BaseModelChangeEventType_Time),
            3676 => Ok(VariableId::BaseModelChangeEventType_ReceiveTime),
            3677 => Ok(VariableId::BaseModelChangeEventType_LocalTime),
            3678 => Ok(VariableId::BaseModelChangeEventType_Message),
            3679 => Ok(VariableId::BaseModelChangeEventType_Severity),
            3680 => Ok(VariableId::GeneralModelChangeEventType_EventId),
            3681 => Ok(VariableId::GeneralModelChangeEventType_EventType),
            3682 => Ok(VariableId::GeneralModelChangeEventType_SourceNode),
            3683 => Ok(VariableId::GeneralModelChangeEventType_SourceName),
            3684 => Ok(VariableId::GeneralModelChangeEventType_Time),
            3685 => Ok(VariableId::GeneralModelChangeEventType_ReceiveTime),
            3686 => Ok(VariableId::GeneralModelChangeEventType_LocalTime),
            3687 => Ok(VariableId::GeneralModelChangeEventType_Message),
            3688 => Ok(VariableId::GeneralModelChangeEventType_Severity),
            3689 => Ok(VariableId::SemanticChangeEventType_EventId),
            3690 => Ok(VariableId::SemanticChangeEventType_EventType),
            3691 => Ok(VariableId::SemanticChangeEventType_SourceNode),
            3692 => Ok(VariableId::SemanticChangeEventType_SourceName),
            3693 => Ok(VariableId::SemanticChangeEventType_Time),
            3694 => Ok(VariableId::SemanticChangeEventType_ReceiveTime),
            3695 => Ok(VariableId::SemanticChangeEventType_LocalTime),
            3696 => Ok(VariableId::SemanticChangeEventType_Message),
            3697 => Ok(VariableId::SemanticChangeEventType_Severity),
            3698 => Ok(VariableId::ServerStatusType_BuildInfo_ProductUri),
            3699 => Ok(VariableId::ServerStatusType_BuildInfo_ManufacturerName),
            3700 => Ok(VariableId::ServerStatusType_BuildInfo_ProductName),
            3701 => Ok(VariableId::ServerStatusType_BuildInfo_SoftwareVersion),
            3702 => Ok(VariableId::ServerStatusType_BuildInfo_BuildNumber),
            3703 => Ok(VariableId::ServerStatusType_BuildInfo_BuildDate),
            3704 => Ok(VariableId::Server_ServerCapabilities_SoftwareCertificates),
            3705 => Ok(VariableId::Server_ServerDiagnostics_ServerDiagnosticsSummary_RejectedSessionCount),
            3707 => Ok(VariableId::Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionDiagnosticsArray),
            3708 => Ok(VariableId::Server_ServerDiagnostics_SessionsDiagnosticsSummary_SessionSecurityDiagnosticsArray),
            3709 => Ok(VariableId::Server_ServerRedundancy_RedundancySupport),
            3714 => Ok(VariableId::FiniteStateVariableType_Name),
            3715 => Ok(VariableId::FiniteStateVariableType_Number),
            3716 => Ok(VariableId::FiniteStateVariableType_EffectiveDisplayName),
            3717 => Ok(VariableId::FiniteTransitionVariableType_Name),
            3718 => Ok(VariableId::FiniteTransitionVariableType_Number),
            3719 => Ok(VariableId::FiniteTransitionVariableType_TransitionTime),
            3720 => Ok(VariableId::StateMachineType_CurrentState_Id),
            3721 => Ok(VariableId::StateMachineType_CurrentState_Name),
            3722 => Ok(VariableId::StateMachineType_CurrentState_Number),
            3723 => Ok(VariableId::StateMachineType_CurrentState_EffectiveDisplayName),
            3724 => Ok(VariableId::StateMachineType_LastTransition_Id),
            3725 => Ok(VariableId::StateMachineType_LastTransition_Name),
            3726 => Ok(VariableId::StateMachineType_LastTransition_Number),
            3727 => Ok(VariableId::StateMachineType_LastTransition_TransitionTime),
            3728 => Ok(VariableId::FiniteStateMachineType_CurrentState_Id),
            3729 => Ok(VariableId::FiniteStateMachineType_CurrentState_Name),
            3730 => Ok(VariableId::FiniteStateMachineType_CurrentState_Number),
            3731 => Ok(VariableId::FiniteStateMachineType_CurrentState_EffectiveDisplayName),
            3732 => Ok(VariableId::FiniteStateMachineType_LastTransition_Id),
            3733 => Ok(VariableId::FiniteStateMachineType_LastTransition_Name),
            3734 => Ok(VariableId::FiniteStateMachineType_LastTransition_Number),
            3735 => Ok(VariableId::FiniteStateMachineType_LastTransition_TransitionTime),
            3736 => Ok(VariableId::InitialStateType_StateNumber),
            3737 => Ok(VariableId::TransitionEventType_EventId),
            3738 => Ok(VariableId::TransitionEventType_EventType),
            3739 => Ok(VariableId::TransitionEventType_SourceNode),
            3740 => Ok(VariableId::TransitionEventType_SourceName),
            3741 => Ok(VariableId::TransitionEventType_Time),
            3742 => Ok(VariableId::TransitionEventType_ReceiveTime),
            3743 => Ok(VariableId::TransitionEventType_LocalTime),
            3744 => Ok(VariableId::TransitionEventType_Message),
            3745 => Ok(VariableId::TransitionEventType_Severity),
            3746 => Ok(VariableId::TransitionEventType_FromState_Id),
            3747 => Ok(VariableId::TransitionEventType_FromState_Name),
            3748 => Ok(VariableId::TransitionEventType_FromState_Number),
            3749 => Ok(VariableId::TransitionEventType_FromState_EffectiveDisplayName),
            3750 => Ok(VariableId::TransitionEventType_ToState_Id),
            3751 => Ok(VariableId::TransitionEventType_ToState_Name),
            3752 => Ok(VariableId::TransitionEventType_ToState_Number),
            3753 => Ok(VariableId::TransitionEventType_ToState_EffectiveDisplayName),
            3754 => Ok(VariableId::TransitionEventType_Transition_Id),
            3755 => Ok(VariableId::TransitionEventType_Transition_Name),
            3756 => Ok(VariableId::TransitionEventType_Transition_Number),
            3757 => Ok(VariableId::TransitionEventType_Transition_TransitionTime),
            3758 => Ok(VariableId::AuditUpdateStateEventType_EventId),
            3759 => Ok(VariableId::AuditUpdateStateEventType_EventType),
            3760 => Ok(VariableId::AuditUpdateStateEventType_SourceNode),
            3761 => Ok(VariableId::AuditUpdateStateEventType_SourceName),
            3762 => Ok(VariableId::AuditUpdateStateEventType_Time),
            3763 => Ok(VariableId::AuditUpdateStateEventType_ReceiveTime),
            3764 => Ok(VariableId::AuditUpdateStateEventType_LocalTime),
            3765 => Ok(VariableId::AuditUpdateStateEventType_Message),
            3766 => Ok(VariableId::AuditUpdateStateEventType_Severity),
            3767 => Ok(VariableId::AuditUpdateStateEventType_ActionTimeStamp),
            3768 => Ok(VariableId::AuditUpdateStateEventType_Status),
            3769 => Ok(VariableId::AuditUpdateStateEventType_ServerId),
            3770 => Ok(VariableId::AuditUpdateStateEventType_ClientAuditEntryId),
            3771 => Ok(VariableId::AuditUpdateStateEventType_ClientUserId),
            3772 => Ok(VariableId::AuditUpdateStateEventType_MethodId),
            3773 => Ok(VariableId::AuditUpdateStateEventType_InputArguments),
            3774 => Ok(VariableId::AnalogItemType_Definition),
            3775 => Ok(VariableId::AnalogItemType_ValuePrecision),
            3776 => Ok(VariableId::DiscreteItemType_Definition),
            3777 => Ok(VariableId::DiscreteItemType_ValuePrecision),
            3778 => Ok(VariableId::TwoStateDiscreteType_Definition),
            3779 => Ok(VariableId::TwoStateDiscreteType_ValuePrecision),
            3780 => Ok(VariableId::MultiStateDiscreteType_Definition),
            3781 => Ok(VariableId::MultiStateDiscreteType_ValuePrecision),
            3782 => Ok(VariableId::ProgramTransitionEventType_EventId),
            3783 => Ok(VariableId::ProgramTransitionEventType_EventType),
            3784 => Ok(VariableId::ProgramTransitionEventType_SourceNode),
            3785 => Ok(VariableId::ProgramTransitionEventType_SourceName),
            3786 => Ok(VariableId::ProgramTransitionEventType_Time),
            3787 => Ok(VariableId::ProgramTransitionEventType_ReceiveTime),
            3788 => Ok(VariableId::ProgramTransitionEventType_LocalTime),
            3789 => Ok(VariableId::ProgramTransitionEventType_Message),
            3790 => Ok(VariableId::ProgramTransitionEventType_Severity),
            3791 => Ok(VariableId::ProgramTransitionEventType_FromState),
            3792 => Ok(VariableId::ProgramTransitionEventType_FromState_Id),
            3793 => Ok(VariableId::ProgramTransitionEventType_FromState_Name),
            3794 => Ok(VariableId::ProgramTransitionEventType_FromState_Number),
            3795 => Ok(VariableId::ProgramTransitionEventType_FromState_EffectiveDisplayName),
            3796 => Ok(VariableId::ProgramTransitionEventType_ToState),
            3797 => Ok(VariableId::ProgramTransitionEventType_ToState_Id),
            3798 => Ok(VariableId::ProgramTransitionEventType_ToState_Name),
            3799 => Ok(VariableId::ProgramTransitionEventType_ToState_Number),
            3800 => Ok(VariableId::ProgramTransitionEventType_ToState_EffectiveDisplayName),
            3801 => Ok(VariableId::ProgramTransitionEventType_Transition),
            3802 => Ok(VariableId::ProgramTransitionEventType_Transition_Id),
            3803 => Ok(VariableId::ProgramTransitionEventType_Transition_Name),
            3804 => Ok(VariableId::ProgramTransitionEventType_Transition_Number),
            3805 => Ok(VariableId::ProgramTransitionEventType_Transition_TransitionTime),
            3807 => Ok(VariableId::ProgramTransitionAuditEventType_EventId),
            3808 => Ok(VariableId::ProgramTransitionAuditEventType_EventType),
            3809 => Ok(VariableId::ProgramTransitionAuditEventType_SourceNode),
            3810 => Ok(VariableId::ProgramTransitionAuditEventType_SourceName),
            3811 => Ok(VariableId::ProgramTransitionAuditEventType_Time),
            3812 => Ok(VariableId::ProgramTransitionAuditEventType_ReceiveTime),
            3813 => Ok(VariableId::ProgramTransitionAuditEventType_LocalTime),
            3814 => Ok(VariableId::ProgramTransitionAuditEventType_Message),
            3815 => Ok(VariableId::ProgramTransitionAuditEventType_Severity),
            3816 => Ok(VariableId::ProgramTransitionAuditEventType_ActionTimeStamp),
            3817 => Ok(VariableId::ProgramTransitionAuditEventType_Status),
            3818 => Ok(VariableId::ProgramTransitionAuditEventType_ServerId),
            3819 => Ok(VariableId::ProgramTransitionAuditEventType_ClientAuditEntryId),
            3820 => Ok(VariableId::ProgramTransitionAuditEventType_ClientUserId),
            3821 => Ok(VariableId::ProgramTransitionAuditEventType_MethodId),
            3822 => Ok(VariableId::ProgramTransitionAuditEventType_InputArguments),
            3823 => Ok(VariableId::ProgramTransitionAuditEventType_OldStateId),
            3824 => Ok(VariableId::ProgramTransitionAuditEventType_NewStateId),
            3825 => Ok(VariableId::ProgramTransitionAuditEventType_Transition),
            3826 => Ok(VariableId::ProgramTransitionAuditEventType_Transition_Id),
            3827 => Ok(VariableId::ProgramTransitionAuditEventType_Transition_Name),
            3828 => Ok(VariableId::ProgramTransitionAuditEventType_Transition_Number),
            3829 => Ok(VariableId::ProgramTransitionAuditEventType_Transition_TransitionTime),
            3830 => Ok(VariableId::ProgramStateMachineType_CurrentState),
            3831 => Ok(VariableId::ProgramStateMachineType_CurrentState_Id),
            3832 => Ok(VariableId::ProgramStateMachineType_CurrentState_Name),
            3833 => Ok(VariableId::ProgramStateMachineType_CurrentState_Number),
            3834 => Ok(VariableId::ProgramStateMachineType_CurrentState_EffectiveDisplayName),
            3835 => Ok(VariableId::ProgramStateMachineType_LastTransition),
            3836 => Ok(VariableId::ProgramStateMachineType_LastTransition_Id),
            3837 => Ok(VariableId::ProgramStateMachineType_LastTransition_Name),
            3838 => Ok(VariableId::ProgramStateMachineType_LastTransition_Number),
            3839 => Ok(VariableId::ProgramStateMachineType_LastTransition_TransitionTime),
            3840 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_CreateSessionId),
            3841 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_CreateClientName),
            3842 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_InvocationCreationTime),
            3843 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastTransitionTime),
            3844 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodCall),
            3845 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodSessionId),
            3846 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodInputArguments),
            3847 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodOutputArguments),
            3848 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodCallTime),
            3849 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodReturnStatus),
            3864 => Ok(VariableId::AddCommentMethodType_InputArguments),
            3865 => Ok(VariableId::ConditionType_EventId),
            3866 => Ok(VariableId::ConditionType_EventType),
            3867 => Ok(VariableId::ConditionType_SourceNode),
            3868 => Ok(VariableId::ConditionType_SourceName),
            3869 => Ok(VariableId::ConditionType_Time),
            3870 => Ok(VariableId::ConditionType_ReceiveTime),
            3871 => Ok(VariableId::ConditionType_LocalTime),
            3872 => Ok(VariableId::ConditionType_Message),
            3873 => Ok(VariableId::ConditionType_Severity),
            3874 => Ok(VariableId::ConditionType_Retain),
            3876 => Ok(VariableId::ConditionType_ConditionRefresh_InputArguments),
            3969 => Ok(VariableId::RefreshStartEventType_EventId),
            3970 => Ok(VariableId::RefreshStartEventType_EventType),
            3971 => Ok(VariableId::RefreshStartEventType_SourceNode),
            3972 => Ok(VariableId::RefreshStartEventType_SourceName),
            3973 => Ok(VariableId::RefreshStartEventType_Time),
            3974 => Ok(VariableId::RefreshStartEventType_ReceiveTime),
            3975 => Ok(VariableId::RefreshStartEventType_LocalTime),
            3976 => Ok(VariableId::RefreshStartEventType_Message),
            3977 => Ok(VariableId::RefreshStartEventType_Severity),
            3978 => Ok(VariableId::RefreshEndEventType_EventId),
            3979 => Ok(VariableId::RefreshEndEventType_EventType),
            3980 => Ok(VariableId::RefreshEndEventType_SourceNode),
            3981 => Ok(VariableId::RefreshEndEventType_SourceName),
            3982 => Ok(VariableId::RefreshEndEventType_Time),
            3983 => Ok(VariableId::RefreshEndEventType_ReceiveTime),
            3984 => Ok(VariableId::RefreshEndEventType_LocalTime),
            3985 => Ok(VariableId::RefreshEndEventType_Message),
            3986 => Ok(VariableId::RefreshEndEventType_Severity),
            3987 => Ok(VariableId::RefreshRequiredEventType_EventId),
            3988 => Ok(VariableId::RefreshRequiredEventType_EventType),
            3989 => Ok(VariableId::RefreshRequiredEventType_SourceNode),
            3990 => Ok(VariableId::RefreshRequiredEventType_SourceName),
            3991 => Ok(VariableId::RefreshRequiredEventType_Time),
            3992 => Ok(VariableId::RefreshRequiredEventType_ReceiveTime),
            3993 => Ok(VariableId::RefreshRequiredEventType_LocalTime),
            3994 => Ok(VariableId::RefreshRequiredEventType_Message),
            3995 => Ok(VariableId::RefreshRequiredEventType_Severity),
            3996 => Ok(VariableId::AuditConditionEventType_EventId),
            3997 => Ok(VariableId::AuditConditionEventType_EventType),
            3998 => Ok(VariableId::AuditConditionEventType_SourceNode),
            3999 => Ok(VariableId::AuditConditionEventType_SourceName),
            4000 => Ok(VariableId::AuditConditionEventType_Time),
            4001 => Ok(VariableId::AuditConditionEventType_ReceiveTime),
            4002 => Ok(VariableId::AuditConditionEventType_LocalTime),
            4003 => Ok(VariableId::AuditConditionEventType_Message),
            4004 => Ok(VariableId::AuditConditionEventType_Severity),
            4005 => Ok(VariableId::AuditConditionEventType_ActionTimeStamp),
            4006 => Ok(VariableId::AuditConditionEventType_Status),
            4007 => Ok(VariableId::AuditConditionEventType_ServerId),
            4008 => Ok(VariableId::AuditConditionEventType_ClientAuditEntryId),
            4009 => Ok(VariableId::AuditConditionEventType_ClientUserId),
            4010 => Ok(VariableId::AuditConditionEventType_MethodId),
            4011 => Ok(VariableId::AuditConditionEventType_InputArguments),
            4106 => Ok(VariableId::AuditConditionEnableEventType_EventId),
            4107 => Ok(VariableId::AuditConditionEnableEventType_EventType),
            4108 => Ok(VariableId::AuditConditionEnableEventType_SourceNode),
            4109 => Ok(VariableId::AuditConditionEnableEventType_SourceName),
            4110 => Ok(VariableId::AuditConditionEnableEventType_Time),
            4111 => Ok(VariableId::AuditConditionEnableEventType_ReceiveTime),
            4112 => Ok(VariableId::AuditConditionEnableEventType_LocalTime),
            4113 => Ok(VariableId::AuditConditionEnableEventType_Message),
            4114 => Ok(VariableId::AuditConditionEnableEventType_Severity),
            4115 => Ok(VariableId::AuditConditionEnableEventType_ActionTimeStamp),
            4116 => Ok(VariableId::AuditConditionEnableEventType_Status),
            4117 => Ok(VariableId::AuditConditionEnableEventType_ServerId),
            4118 => Ok(VariableId::AuditConditionEnableEventType_ClientAuditEntryId),
            4119 => Ok(VariableId::AuditConditionEnableEventType_ClientUserId),
            4120 => Ok(VariableId::AuditConditionEnableEventType_MethodId),
            4121 => Ok(VariableId::AuditConditionEnableEventType_InputArguments),
            4170 => Ok(VariableId::AuditConditionCommentEventType_EventId),
            4171 => Ok(VariableId::AuditConditionCommentEventType_EventType),
            4172 => Ok(VariableId::AuditConditionCommentEventType_SourceNode),
            4173 => Ok(VariableId::AuditConditionCommentEventType_SourceName),
            4174 => Ok(VariableId::AuditConditionCommentEventType_Time),
            4175 => Ok(VariableId::AuditConditionCommentEventType_ReceiveTime),
            4176 => Ok(VariableId::AuditConditionCommentEventType_LocalTime),
            4177 => Ok(VariableId::AuditConditionCommentEventType_Message),
            4178 => Ok(VariableId::AuditConditionCommentEventType_Severity),
            4179 => Ok(VariableId::AuditConditionCommentEventType_ActionTimeStamp),
            4180 => Ok(VariableId::AuditConditionCommentEventType_Status),
            4181 => Ok(VariableId::AuditConditionCommentEventType_ServerId),
            4182 => Ok(VariableId::AuditConditionCommentEventType_ClientAuditEntryId),
            4183 => Ok(VariableId::AuditConditionCommentEventType_ClientUserId),
            4184 => Ok(VariableId::AuditConditionCommentEventType_MethodId),
            4185 => Ok(VariableId::AuditConditionCommentEventType_InputArguments),
            4188 => Ok(VariableId::DialogConditionType_EventId),
            4189 => Ok(VariableId::DialogConditionType_EventType),
            4190 => Ok(VariableId::DialogConditionType_SourceNode),
            4191 => Ok(VariableId::DialogConditionType_SourceName),
            4192 => Ok(VariableId::DialogConditionType_Time),
            4193 => Ok(VariableId::DialogConditionType_ReceiveTime),
            4194 => Ok(VariableId::DialogConditionType_LocalTime),
            4195 => Ok(VariableId::DialogConditionType_Message),
            4196 => Ok(VariableId::DialogConditionType_Severity),
            4197 => Ok(VariableId::DialogConditionType_Retain),
            4199 => Ok(VariableId::DialogConditionType_ConditionRefresh_InputArguments),
            5113 => Ok(VariableId::AcknowledgeableConditionType_EventId),
            5114 => Ok(VariableId::AcknowledgeableConditionType_EventType),
            5115 => Ok(VariableId::AcknowledgeableConditionType_SourceNode),
            5116 => Ok(VariableId::AcknowledgeableConditionType_SourceName),
            5117 => Ok(VariableId::AcknowledgeableConditionType_Time),
            5118 => Ok(VariableId::AcknowledgeableConditionType_ReceiveTime),
            5119 => Ok(VariableId::AcknowledgeableConditionType_LocalTime),
            5120 => Ok(VariableId::AcknowledgeableConditionType_Message),
            5121 => Ok(VariableId::AcknowledgeableConditionType_Severity),
            5122 => Ok(VariableId::AcknowledgeableConditionType_Retain),
            5124 => Ok(VariableId::AcknowledgeableConditionType_ConditionRefresh_InputArguments),
            5540 => Ok(VariableId::AlarmConditionType_EventId),
            5541 => Ok(VariableId::AlarmConditionType_EventType),
            5542 => Ok(VariableId::AlarmConditionType_SourceNode),
            5543 => Ok(VariableId::AlarmConditionType_SourceName),
            5544 => Ok(VariableId::AlarmConditionType_Time),
            5545 => Ok(VariableId::AlarmConditionType_ReceiveTime),
            5546 => Ok(VariableId::AlarmConditionType_LocalTime),
            5547 => Ok(VariableId::AlarmConditionType_Message),
            5548 => Ok(VariableId::AlarmConditionType_Severity),
            5549 => Ok(VariableId::AlarmConditionType_Retain),
            5551 => Ok(VariableId::AlarmConditionType_ConditionRefresh_InputArguments),
            6088 => Ok(VariableId::ShelvedStateMachineType_CurrentState),
            6089 => Ok(VariableId::ShelvedStateMachineType_CurrentState_Id),
            6090 => Ok(VariableId::ShelvedStateMachineType_CurrentState_Name),
            6091 => Ok(VariableId::ShelvedStateMachineType_CurrentState_Number),
            6092 => Ok(VariableId::ShelvedStateMachineType_CurrentState_EffectiveDisplayName),
            6093 => Ok(VariableId::ShelvedStateMachineType_LastTransition),
            6094 => Ok(VariableId::ShelvedStateMachineType_LastTransition_Id),
            6095 => Ok(VariableId::ShelvedStateMachineType_LastTransition_Name),
            6096 => Ok(VariableId::ShelvedStateMachineType_LastTransition_Number),
            6097 => Ok(VariableId::ShelvedStateMachineType_LastTransition_TransitionTime),
            6098 => Ok(VariableId::ShelvedStateMachineType_Unshelved_StateNumber),
            6100 => Ok(VariableId::ShelvedStateMachineType_TimedShelved_StateNumber),
            6101 => Ok(VariableId::ShelvedStateMachineType_OneShotShelved_StateNumber),
            6103 => Ok(VariableId::TimedShelveMethodType_InputArguments),
            6116 => Ok(VariableId::LimitAlarmType_EventId),
            6117 => Ok(VariableId::LimitAlarmType_EventType),
            6118 => Ok(VariableId::LimitAlarmType_SourceNode),
            6119 => Ok(VariableId::LimitAlarmType_SourceName),
            6120 => Ok(VariableId::LimitAlarmType_Time),
            6121 => Ok(VariableId::LimitAlarmType_ReceiveTime),
            6122 => Ok(VariableId::LimitAlarmType_LocalTime),
            6123 => Ok(VariableId::LimitAlarmType_Message),
            6124 => Ok(VariableId::LimitAlarmType_Severity),
            6125 => Ok(VariableId::LimitAlarmType_Retain),
            6127 => Ok(VariableId::LimitAlarmType_ConditionRefresh_InputArguments),
            7591 => Ok(VariableId::IdType_EnumStrings),
            7595 => Ok(VariableId::MessageSecurityMode_EnumStrings),
            7596 => Ok(VariableId::UserTokenType_EnumStrings),
            7597 => Ok(VariableId::ApplicationType_EnumStrings),
            7598 => Ok(VariableId::SecurityTokenRequestType_EnumStrings),
            7603 => Ok(VariableId::BrowseDirection_EnumStrings),
            7605 => Ok(VariableId::FilterOperator_EnumStrings),
            7606 => Ok(VariableId::TimestampsToReturn_EnumStrings),
            7608 => Ok(VariableId::MonitoringMode_EnumStrings),
            7609 => Ok(VariableId::DataChangeTrigger_EnumStrings),
            7610 => Ok(VariableId::DeadbandType_EnumStrings),
            7611 => Ok(VariableId::RedundancySupport_EnumStrings),
            7612 => Ok(VariableId::ServerState_EnumStrings),
            7614 => Ok(VariableId::ExceptionDeviationFormat_EnumStrings),
            7617 => Ok(VariableId::OpcUa_BinarySchema),
            7618 => Ok(VariableId::OpcUa_BinarySchema_DataTypeVersion),
            7619 => Ok(VariableId::OpcUa_BinarySchema_NamespaceUri),
            7650 => Ok(VariableId::OpcUa_BinarySchema_Argument),
            7651 => Ok(VariableId::OpcUa_BinarySchema_Argument_DataTypeVersion),
            7652 => Ok(VariableId::OpcUa_BinarySchema_Argument_DictionaryFragment),
            7656 => Ok(VariableId::OpcUa_BinarySchema_EnumValueType),
            7657 => Ok(VariableId::OpcUa_BinarySchema_EnumValueType_DataTypeVersion),
            7658 => Ok(VariableId::OpcUa_BinarySchema_EnumValueType_DictionaryFragment),
            7659 => Ok(VariableId::OpcUa_BinarySchema_StatusResult),
            7660 => Ok(VariableId::OpcUa_BinarySchema_StatusResult_DataTypeVersion),
            7661 => Ok(VariableId::OpcUa_BinarySchema_StatusResult_DictionaryFragment),
            7662 => Ok(VariableId::OpcUa_BinarySchema_UserTokenPolicy),
            7663 => Ok(VariableId::OpcUa_BinarySchema_UserTokenPolicy_DataTypeVersion),
            7664 => Ok(VariableId::OpcUa_BinarySchema_UserTokenPolicy_DictionaryFragment),
            7665 => Ok(VariableId::OpcUa_BinarySchema_ApplicationDescription),
            7666 => Ok(VariableId::OpcUa_BinarySchema_ApplicationDescription_DataTypeVersion),
            7667 => Ok(VariableId::OpcUa_BinarySchema_ApplicationDescription_DictionaryFragment),
            7668 => Ok(VariableId::OpcUa_BinarySchema_EndpointDescription),
            7669 => Ok(VariableId::OpcUa_BinarySchema_EndpointDescription_DataTypeVersion),
            7670 => Ok(VariableId::OpcUa_BinarySchema_EndpointDescription_DictionaryFragment),
            7671 => Ok(VariableId::OpcUa_BinarySchema_UserIdentityToken),
            7672 => Ok(VariableId::OpcUa_BinarySchema_UserIdentityToken_DataTypeVersion),
            7673 => Ok(VariableId::OpcUa_BinarySchema_UserIdentityToken_DictionaryFragment),
            7674 => Ok(VariableId::OpcUa_BinarySchema_AnonymousIdentityToken),
            7675 => Ok(VariableId::OpcUa_BinarySchema_AnonymousIdentityToken_DataTypeVersion),
            7676 => Ok(VariableId::OpcUa_BinarySchema_AnonymousIdentityToken_DictionaryFragment),
            7677 => Ok(VariableId::OpcUa_BinarySchema_UserNameIdentityToken),
            7678 => Ok(VariableId::OpcUa_BinarySchema_UserNameIdentityToken_DataTypeVersion),
            7679 => Ok(VariableId::OpcUa_BinarySchema_UserNameIdentityToken_DictionaryFragment),
            7680 => Ok(VariableId::OpcUa_BinarySchema_X509IdentityToken),
            7681 => Ok(VariableId::OpcUa_BinarySchema_X509IdentityToken_DataTypeVersion),
            7682 => Ok(VariableId::OpcUa_BinarySchema_X509IdentityToken_DictionaryFragment),
            7683 => Ok(VariableId::OpcUa_BinarySchema_IssuedIdentityToken),
            7684 => Ok(VariableId::OpcUa_BinarySchema_IssuedIdentityToken_DataTypeVersion),
            7685 => Ok(VariableId::OpcUa_BinarySchema_IssuedIdentityToken_DictionaryFragment),
            7686 => Ok(VariableId::OpcUa_BinarySchema_EndpointConfiguration),
            7687 => Ok(VariableId::OpcUa_BinarySchema_EndpointConfiguration_DataTypeVersion),
            7688 => Ok(VariableId::OpcUa_BinarySchema_EndpointConfiguration_DictionaryFragment),
            7692 => Ok(VariableId::OpcUa_BinarySchema_BuildInfo),
            7693 => Ok(VariableId::OpcUa_BinarySchema_BuildInfo_DataTypeVersion),
            7694 => Ok(VariableId::OpcUa_BinarySchema_BuildInfo_DictionaryFragment),
            7698 => Ok(VariableId::OpcUa_BinarySchema_SignedSoftwareCertificate),
            7699 => Ok(VariableId::OpcUa_BinarySchema_SignedSoftwareCertificate_DataTypeVersion),
            7700 => Ok(VariableId::OpcUa_BinarySchema_SignedSoftwareCertificate_DictionaryFragment),
            7728 => Ok(VariableId::OpcUa_BinarySchema_AddNodesItem),
            7729 => Ok(VariableId::OpcUa_BinarySchema_AddNodesItem_DataTypeVersion),
            7730 => Ok(VariableId::OpcUa_BinarySchema_AddNodesItem_DictionaryFragment),
            7731 => Ok(VariableId::OpcUa_BinarySchema_AddReferencesItem),
            7732 => Ok(VariableId::OpcUa_BinarySchema_AddReferencesItem_DataTypeVersion),
            7733 => Ok(VariableId::OpcUa_BinarySchema_AddReferencesItem_DictionaryFragment),
            7734 => Ok(VariableId::OpcUa_BinarySchema_DeleteNodesItem),
            7735 => Ok(VariableId::OpcUa_BinarySchema_DeleteNodesItem_DataTypeVersion),
            7736 => Ok(VariableId::OpcUa_BinarySchema_DeleteNodesItem_DictionaryFragment),
            7737 => Ok(VariableId::OpcUa_BinarySchema_DeleteReferencesItem),
            7738 => Ok(VariableId::OpcUa_BinarySchema_DeleteReferencesItem_DataTypeVersion),
            7739 => Ok(VariableId::OpcUa_BinarySchema_DeleteReferencesItem_DictionaryFragment),
            7782 => Ok(VariableId::OpcUa_BinarySchema_RegisteredServer),
            7783 => Ok(VariableId::OpcUa_BinarySchema_RegisteredServer_DataTypeVersion),
            7784 => Ok(VariableId::OpcUa_BinarySchema_RegisteredServer_DictionaryFragment),
            7929 => Ok(VariableId::OpcUa_BinarySchema_ContentFilterElement),
            7930 => Ok(VariableId::OpcUa_BinarySchema_ContentFilterElement_DataTypeVersion),
            7931 => Ok(VariableId::OpcUa_BinarySchema_ContentFilterElement_DictionaryFragment),
            7932 => Ok(VariableId::OpcUa_BinarySchema_ContentFilter),
            7933 => Ok(VariableId::OpcUa_BinarySchema_ContentFilter_DataTypeVersion),
            7934 => Ok(VariableId::OpcUa_BinarySchema_ContentFilter_DictionaryFragment),
            7935 => Ok(VariableId::OpcUa_BinarySchema_FilterOperand),
            7936 => Ok(VariableId::OpcUa_BinarySchema_FilterOperand_DataTypeVersion),
            7937 => Ok(VariableId::OpcUa_BinarySchema_FilterOperand_DictionaryFragment),
            7938 => Ok(VariableId::OpcUa_BinarySchema_ElementOperand),
            7939 => Ok(VariableId::OpcUa_BinarySchema_ElementOperand_DataTypeVersion),
            7940 => Ok(VariableId::OpcUa_BinarySchema_ElementOperand_DictionaryFragment),
            7941 => Ok(VariableId::OpcUa_BinarySchema_LiteralOperand),
            7942 => Ok(VariableId::OpcUa_BinarySchema_LiteralOperand_DataTypeVersion),
            7943 => Ok(VariableId::OpcUa_BinarySchema_LiteralOperand_DictionaryFragment),
            7944 => Ok(VariableId::OpcUa_BinarySchema_AttributeOperand),
            7945 => Ok(VariableId::OpcUa_BinarySchema_AttributeOperand_DataTypeVersion),
            7946 => Ok(VariableId::OpcUa_BinarySchema_AttributeOperand_DictionaryFragment),
            7947 => Ok(VariableId::OpcUa_BinarySchema_SimpleAttributeOperand),
            7948 => Ok(VariableId::OpcUa_BinarySchema_SimpleAttributeOperand_DataTypeVersion),
            7949 => Ok(VariableId::OpcUa_BinarySchema_SimpleAttributeOperand_DictionaryFragment),
            8004 => Ok(VariableId::OpcUa_BinarySchema_HistoryEvent),
            8005 => Ok(VariableId::OpcUa_BinarySchema_HistoryEvent_DataTypeVersion),
            8006 => Ok(VariableId::OpcUa_BinarySchema_HistoryEvent_DictionaryFragment),
            8067 => Ok(VariableId::OpcUa_BinarySchema_MonitoringFilter),
            8068 => Ok(VariableId::OpcUa_BinarySchema_MonitoringFilter_DataTypeVersion),
            8069 => Ok(VariableId::OpcUa_BinarySchema_MonitoringFilter_DictionaryFragment),
            8073 => Ok(VariableId::OpcUa_BinarySchema_EventFilter),
            8074 => Ok(VariableId::OpcUa_BinarySchema_EventFilter_DataTypeVersion),
            8075 => Ok(VariableId::OpcUa_BinarySchema_EventFilter_DictionaryFragment),
            8076 => Ok(VariableId::OpcUa_BinarySchema_AggregateConfiguration),
            8077 => Ok(VariableId::OpcUa_BinarySchema_AggregateConfiguration_DataTypeVersion),
            8078 => Ok(VariableId::OpcUa_BinarySchema_AggregateConfiguration_DictionaryFragment),
            8172 => Ok(VariableId::OpcUa_BinarySchema_HistoryEventFieldList),
            8173 => Ok(VariableId::OpcUa_BinarySchema_HistoryEventFieldList_DataTypeVersion),
            8174 => Ok(VariableId::OpcUa_BinarySchema_HistoryEventFieldList_DictionaryFragment),
            8208 => Ok(VariableId::OpcUa_BinarySchema_RedundantServerDataType),
            8209 => Ok(VariableId::OpcUa_BinarySchema_RedundantServerDataType_DataTypeVersion),
            8210 => Ok(VariableId::OpcUa_BinarySchema_RedundantServerDataType_DictionaryFragment),
            8211 => Ok(VariableId::OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType),
            8212 => Ok(VariableId::OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DataTypeVersion),
            8213 => Ok(VariableId::OpcUa_BinarySchema_SamplingIntervalDiagnosticsDataType_DictionaryFragment),
            8214 => Ok(VariableId::OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType),
            8215 => Ok(VariableId::OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DataTypeVersion),
            8216 => Ok(VariableId::OpcUa_BinarySchema_ServerDiagnosticsSummaryDataType_DictionaryFragment),
            8217 => Ok(VariableId::OpcUa_BinarySchema_ServerStatusDataType),
            8218 => Ok(VariableId::OpcUa_BinarySchema_ServerStatusDataType_DataTypeVersion),
            8219 => Ok(VariableId::OpcUa_BinarySchema_ServerStatusDataType_DictionaryFragment),
            8220 => Ok(VariableId::OpcUa_BinarySchema_SessionDiagnosticsDataType),
            8221 => Ok(VariableId::OpcUa_BinarySchema_SessionDiagnosticsDataType_DataTypeVersion),
            8222 => Ok(VariableId::OpcUa_BinarySchema_SessionDiagnosticsDataType_DictionaryFragment),
            8223 => Ok(VariableId::OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType),
            8224 => Ok(VariableId::OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DataTypeVersion),
            8225 => Ok(VariableId::OpcUa_BinarySchema_SessionSecurityDiagnosticsDataType_DictionaryFragment),
            8226 => Ok(VariableId::OpcUa_BinarySchema_ServiceCounterDataType),
            8227 => Ok(VariableId::OpcUa_BinarySchema_ServiceCounterDataType_DataTypeVersion),
            8228 => Ok(VariableId::OpcUa_BinarySchema_ServiceCounterDataType_DictionaryFragment),
            8229 => Ok(VariableId::OpcUa_BinarySchema_SubscriptionDiagnosticsDataType),
            8230 => Ok(VariableId::OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DataTypeVersion),
            8231 => Ok(VariableId::OpcUa_BinarySchema_SubscriptionDiagnosticsDataType_DictionaryFragment),
            8232 => Ok(VariableId::OpcUa_BinarySchema_ModelChangeStructureDataType),
            8233 => Ok(VariableId::OpcUa_BinarySchema_ModelChangeStructureDataType_DataTypeVersion),
            8234 => Ok(VariableId::OpcUa_BinarySchema_ModelChangeStructureDataType_DictionaryFragment),
            8235 => Ok(VariableId::OpcUa_BinarySchema_SemanticChangeStructureDataType),
            8236 => Ok(VariableId::OpcUa_BinarySchema_SemanticChangeStructureDataType_DataTypeVersion),
            8237 => Ok(VariableId::OpcUa_BinarySchema_SemanticChangeStructureDataType_DictionaryFragment),
            8238 => Ok(VariableId::OpcUa_BinarySchema_Range),
            8239 => Ok(VariableId::OpcUa_BinarySchema_Range_DataTypeVersion),
            8240 => Ok(VariableId::OpcUa_BinarySchema_Range_DictionaryFragment),
            8241 => Ok(VariableId::OpcUa_BinarySchema_EUInformation),
            8242 => Ok(VariableId::OpcUa_BinarySchema_EUInformation_DataTypeVersion),
            8243 => Ok(VariableId::OpcUa_BinarySchema_EUInformation_DictionaryFragment),
            8244 => Ok(VariableId::OpcUa_BinarySchema_Annotation),
            8245 => Ok(VariableId::OpcUa_BinarySchema_Annotation_DataTypeVersion),
            8246 => Ok(VariableId::OpcUa_BinarySchema_Annotation_DictionaryFragment),
            8247 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnosticDataType),
            8248 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnosticDataType_DataTypeVersion),
            8249 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnosticDataType_DictionaryFragment),
            8252 => Ok(VariableId::OpcUa_XmlSchema),
            8888 => Ok(VariableId::SubscriptionDiagnosticsType_MaxLifetimeCount),
            8889 => Ok(VariableId::SubscriptionDiagnosticsType_LatePublishRequestCount),
            8890 => Ok(VariableId::SubscriptionDiagnosticsType_CurrentKeepAliveCount),
            8891 => Ok(VariableId::SubscriptionDiagnosticsType_CurrentLifetimeCount),
            8892 => Ok(VariableId::SubscriptionDiagnosticsType_UnacknowledgedMessageCount),
            8893 => Ok(VariableId::SubscriptionDiagnosticsType_DiscardedMessageCount),
            8894 => Ok(VariableId::SubscriptionDiagnosticsType_MonitoredItemCount),
            8895 => Ok(VariableId::SubscriptionDiagnosticsType_DisabledMonitoredItemCount),
            8896 => Ok(VariableId::SubscriptionDiagnosticsType_MonitoringQueueOverflowCount),
            8897 => Ok(VariableId::SubscriptionDiagnosticsType_NextSequenceNumber),
            8898 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_TotalRequestCount),
            8900 => Ok(VariableId::SessionDiagnosticsVariableType_TotalRequestCount),
            8902 => Ok(VariableId::SubscriptionDiagnosticsType_EventQueueOverflowCount),
            8914 => Ok(VariableId::OpcUa_BinarySchema_TimeZoneDataType),
            8915 => Ok(VariableId::OpcUa_BinarySchema_TimeZoneDataType_DataTypeVersion),
            8916 => Ok(VariableId::OpcUa_BinarySchema_TimeZoneDataType_DictionaryFragment),
            8928 => Ok(VariableId::AuditConditionRespondEventType_EventId),
            8929 => Ok(VariableId::AuditConditionRespondEventType_EventType),
            8930 => Ok(VariableId::AuditConditionRespondEventType_SourceNode),
            8931 => Ok(VariableId::AuditConditionRespondEventType_SourceName),
            8932 => Ok(VariableId::AuditConditionRespondEventType_Time),
            8933 => Ok(VariableId::AuditConditionRespondEventType_ReceiveTime),
            8934 => Ok(VariableId::AuditConditionRespondEventType_LocalTime),
            8935 => Ok(VariableId::AuditConditionRespondEventType_Message),
            8936 => Ok(VariableId::AuditConditionRespondEventType_Severity),
            8937 => Ok(VariableId::AuditConditionRespondEventType_ActionTimeStamp),
            8938 => Ok(VariableId::AuditConditionRespondEventType_Status),
            8939 => Ok(VariableId::AuditConditionRespondEventType_ServerId),
            8940 => Ok(VariableId::AuditConditionRespondEventType_ClientAuditEntryId),
            8941 => Ok(VariableId::AuditConditionRespondEventType_ClientUserId),
            8942 => Ok(VariableId::AuditConditionRespondEventType_MethodId),
            8943 => Ok(VariableId::AuditConditionRespondEventType_InputArguments),
            8945 => Ok(VariableId::AuditConditionAcknowledgeEventType_EventId),
            8946 => Ok(VariableId::AuditConditionAcknowledgeEventType_EventType),
            8947 => Ok(VariableId::AuditConditionAcknowledgeEventType_SourceNode),
            8948 => Ok(VariableId::AuditConditionAcknowledgeEventType_SourceName),
            8949 => Ok(VariableId::AuditConditionAcknowledgeEventType_Time),
            8950 => Ok(VariableId::AuditConditionAcknowledgeEventType_ReceiveTime),
            8951 => Ok(VariableId::AuditConditionAcknowledgeEventType_LocalTime),
            8952 => Ok(VariableId::AuditConditionAcknowledgeEventType_Message),
            8953 => Ok(VariableId::AuditConditionAcknowledgeEventType_Severity),
            8954 => Ok(VariableId::AuditConditionAcknowledgeEventType_ActionTimeStamp),
            8955 => Ok(VariableId::AuditConditionAcknowledgeEventType_Status),
            8956 => Ok(VariableId::AuditConditionAcknowledgeEventType_ServerId),
            8957 => Ok(VariableId::AuditConditionAcknowledgeEventType_ClientAuditEntryId),
            8958 => Ok(VariableId::AuditConditionAcknowledgeEventType_ClientUserId),
            8959 => Ok(VariableId::AuditConditionAcknowledgeEventType_MethodId),
            8960 => Ok(VariableId::AuditConditionAcknowledgeEventType_InputArguments),
            8962 => Ok(VariableId::AuditConditionConfirmEventType_EventId),
            8963 => Ok(VariableId::AuditConditionConfirmEventType_EventType),
            8964 => Ok(VariableId::AuditConditionConfirmEventType_SourceNode),
            8965 => Ok(VariableId::AuditConditionConfirmEventType_SourceName),
            8966 => Ok(VariableId::AuditConditionConfirmEventType_Time),
            8967 => Ok(VariableId::AuditConditionConfirmEventType_ReceiveTime),
            8968 => Ok(VariableId::AuditConditionConfirmEventType_LocalTime),
            8969 => Ok(VariableId::AuditConditionConfirmEventType_Message),
            8970 => Ok(VariableId::AuditConditionConfirmEventType_Severity),
            8971 => Ok(VariableId::AuditConditionConfirmEventType_ActionTimeStamp),
            8972 => Ok(VariableId::AuditConditionConfirmEventType_Status),
            8973 => Ok(VariableId::AuditConditionConfirmEventType_ServerId),
            8974 => Ok(VariableId::AuditConditionConfirmEventType_ClientAuditEntryId),
            8975 => Ok(VariableId::AuditConditionConfirmEventType_ClientUserId),
            8976 => Ok(VariableId::AuditConditionConfirmEventType_MethodId),
            8977 => Ok(VariableId::AuditConditionConfirmEventType_InputArguments),
            8996 => Ok(VariableId::TwoStateVariableType_Id),
            8997 => Ok(VariableId::TwoStateVariableType_Name),
            8998 => Ok(VariableId::TwoStateVariableType_Number),
            8999 => Ok(VariableId::TwoStateVariableType_EffectiveDisplayName),
            9000 => Ok(VariableId::TwoStateVariableType_TransitionTime),
            9001 => Ok(VariableId::TwoStateVariableType_EffectiveTransitionTime),
            9003 => Ok(VariableId::ConditionVariableType_SourceTimestamp),
            9008 => Ok(VariableId::ConditionRefreshMethodType_InputArguments),
            9009 => Ok(VariableId::ConditionType_ConditionName),
            9010 => Ok(VariableId::ConditionType_BranchId),
            9011 => Ok(VariableId::ConditionType_EnabledState),
            9012 => Ok(VariableId::ConditionType_EnabledState_Id),
            9013 => Ok(VariableId::ConditionType_EnabledState_Name),
            9014 => Ok(VariableId::ConditionType_EnabledState_Number),
            9015 => Ok(VariableId::ConditionType_EnabledState_EffectiveDisplayName),
            9016 => Ok(VariableId::ConditionType_EnabledState_TransitionTime),
            9017 => Ok(VariableId::ConditionType_EnabledState_EffectiveTransitionTime),
            9018 => Ok(VariableId::ConditionType_EnabledState_TrueState),
            9019 => Ok(VariableId::ConditionType_EnabledState_FalseState),
            9020 => Ok(VariableId::ConditionType_Quality),
            9021 => Ok(VariableId::ConditionType_Quality_SourceTimestamp),
            9022 => Ok(VariableId::ConditionType_LastSeverity),
            9023 => Ok(VariableId::ConditionType_LastSeverity_SourceTimestamp),
            9024 => Ok(VariableId::ConditionType_Comment),
            9025 => Ok(VariableId::ConditionType_Comment_SourceTimestamp),
            9026 => Ok(VariableId::ConditionType_ClientUserId),
            9030 => Ok(VariableId::ConditionType_AddComment_InputArguments),
            9032 => Ok(VariableId::DialogResponseMethodType_InputArguments),
            9033 => Ok(VariableId::DialogConditionType_ConditionName),
            9034 => Ok(VariableId::DialogConditionType_BranchId),
            9035 => Ok(VariableId::DialogConditionType_EnabledState),
            9036 => Ok(VariableId::DialogConditionType_EnabledState_Id),
            9037 => Ok(VariableId::DialogConditionType_EnabledState_Name),
            9038 => Ok(VariableId::DialogConditionType_EnabledState_Number),
            9039 => Ok(VariableId::DialogConditionType_EnabledState_EffectiveDisplayName),
            9040 => Ok(VariableId::DialogConditionType_EnabledState_TransitionTime),
            9041 => Ok(VariableId::DialogConditionType_EnabledState_EffectiveTransitionTime),
            9042 => Ok(VariableId::DialogConditionType_EnabledState_TrueState),
            9043 => Ok(VariableId::DialogConditionType_EnabledState_FalseState),
            9044 => Ok(VariableId::DialogConditionType_Quality),
            9045 => Ok(VariableId::DialogConditionType_Quality_SourceTimestamp),
            9046 => Ok(VariableId::DialogConditionType_LastSeverity),
            9047 => Ok(VariableId::DialogConditionType_LastSeverity_SourceTimestamp),
            9048 => Ok(VariableId::DialogConditionType_Comment),
            9049 => Ok(VariableId::DialogConditionType_Comment_SourceTimestamp),
            9050 => Ok(VariableId::DialogConditionType_ClientUserId),
            9054 => Ok(VariableId::DialogConditionType_AddComment_InputArguments),
            9055 => Ok(VariableId::DialogConditionType_DialogState),
            9056 => Ok(VariableId::DialogConditionType_DialogState_Id),
            9057 => Ok(VariableId::DialogConditionType_DialogState_Name),
            9058 => Ok(VariableId::DialogConditionType_DialogState_Number),
            9059 => Ok(VariableId::DialogConditionType_DialogState_EffectiveDisplayName),
            9060 => Ok(VariableId::DialogConditionType_DialogState_TransitionTime),
            9061 => Ok(VariableId::DialogConditionType_DialogState_EffectiveTransitionTime),
            9062 => Ok(VariableId::DialogConditionType_DialogState_TrueState),
            9063 => Ok(VariableId::DialogConditionType_DialogState_FalseState),
            9064 => Ok(VariableId::DialogConditionType_ResponseOptionSet),
            9065 => Ok(VariableId::DialogConditionType_DefaultResponse),
            9066 => Ok(VariableId::DialogConditionType_OkResponse),
            9067 => Ok(VariableId::DialogConditionType_CancelResponse),
            9068 => Ok(VariableId::DialogConditionType_LastResponse),
            9070 => Ok(VariableId::DialogConditionType_Respond_InputArguments),
            9071 => Ok(VariableId::AcknowledgeableConditionType_ConditionName),
            9072 => Ok(VariableId::AcknowledgeableConditionType_BranchId),
            9073 => Ok(VariableId::AcknowledgeableConditionType_EnabledState),
            9074 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_Id),
            9075 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_Name),
            9076 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_Number),
            9077 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_EffectiveDisplayName),
            9078 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_TransitionTime),
            9079 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_EffectiveTransitionTime),
            9080 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_TrueState),
            9081 => Ok(VariableId::AcknowledgeableConditionType_EnabledState_FalseState),
            9082 => Ok(VariableId::AcknowledgeableConditionType_Quality),
            9083 => Ok(VariableId::AcknowledgeableConditionType_Quality_SourceTimestamp),
            9084 => Ok(VariableId::AcknowledgeableConditionType_LastSeverity),
            9085 => Ok(VariableId::AcknowledgeableConditionType_LastSeverity_SourceTimestamp),
            9086 => Ok(VariableId::AcknowledgeableConditionType_Comment),
            9087 => Ok(VariableId::AcknowledgeableConditionType_Comment_SourceTimestamp),
            9088 => Ok(VariableId::AcknowledgeableConditionType_ClientUserId),
            9092 => Ok(VariableId::AcknowledgeableConditionType_AddComment_InputArguments),
            9093 => Ok(VariableId::AcknowledgeableConditionType_AckedState),
            9094 => Ok(VariableId::AcknowledgeableConditionType_AckedState_Id),
            9095 => Ok(VariableId::AcknowledgeableConditionType_AckedState_Name),
            9096 => Ok(VariableId::AcknowledgeableConditionType_AckedState_Number),
            9097 => Ok(VariableId::AcknowledgeableConditionType_AckedState_EffectiveDisplayName),
            9098 => Ok(VariableId::AcknowledgeableConditionType_AckedState_TransitionTime),
            9099 => Ok(VariableId::AcknowledgeableConditionType_AckedState_EffectiveTransitionTime),
            9100 => Ok(VariableId::AcknowledgeableConditionType_AckedState_TrueState),
            9101 => Ok(VariableId::AcknowledgeableConditionType_AckedState_FalseState),
            9102 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState),
            9103 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_Id),
            9104 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_Name),
            9105 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_Number),
            9106 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_EffectiveDisplayName),
            9107 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_TransitionTime),
            9108 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_EffectiveTransitionTime),
            9109 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_TrueState),
            9110 => Ok(VariableId::AcknowledgeableConditionType_ConfirmedState_FalseState),
            9112 => Ok(VariableId::AcknowledgeableConditionType_Acknowledge_InputArguments),
            9114 => Ok(VariableId::AcknowledgeableConditionType_Confirm_InputArguments),
            9115 => Ok(VariableId::ShelvedStateMachineType_UnshelveTime),
            9116 => Ok(VariableId::AlarmConditionType_ConditionName),
            9117 => Ok(VariableId::AlarmConditionType_BranchId),
            9118 => Ok(VariableId::AlarmConditionType_EnabledState),
            9119 => Ok(VariableId::AlarmConditionType_EnabledState_Id),
            9120 => Ok(VariableId::AlarmConditionType_EnabledState_Name),
            9121 => Ok(VariableId::AlarmConditionType_EnabledState_Number),
            9122 => Ok(VariableId::AlarmConditionType_EnabledState_EffectiveDisplayName),
            9123 => Ok(VariableId::AlarmConditionType_EnabledState_TransitionTime),
            9124 => Ok(VariableId::AlarmConditionType_EnabledState_EffectiveTransitionTime),
            9125 => Ok(VariableId::AlarmConditionType_EnabledState_TrueState),
            9126 => Ok(VariableId::AlarmConditionType_EnabledState_FalseState),
            9127 => Ok(VariableId::AlarmConditionType_Quality),
            9128 => Ok(VariableId::AlarmConditionType_Quality_SourceTimestamp),
            9129 => Ok(VariableId::AlarmConditionType_LastSeverity),
            9130 => Ok(VariableId::AlarmConditionType_LastSeverity_SourceTimestamp),
            9131 => Ok(VariableId::AlarmConditionType_Comment),
            9132 => Ok(VariableId::AlarmConditionType_Comment_SourceTimestamp),
            9133 => Ok(VariableId::AlarmConditionType_ClientUserId),
            9137 => Ok(VariableId::AlarmConditionType_AddComment_InputArguments),
            9138 => Ok(VariableId::AlarmConditionType_AckedState),
            9139 => Ok(VariableId::AlarmConditionType_AckedState_Id),
            9140 => Ok(VariableId::AlarmConditionType_AckedState_Name),
            9141 => Ok(VariableId::AlarmConditionType_AckedState_Number),
            9142 => Ok(VariableId::AlarmConditionType_AckedState_EffectiveDisplayName),
            9143 => Ok(VariableId::AlarmConditionType_AckedState_TransitionTime),
            9144 => Ok(VariableId::AlarmConditionType_AckedState_EffectiveTransitionTime),
            9145 => Ok(VariableId::AlarmConditionType_AckedState_TrueState),
            9146 => Ok(VariableId::AlarmConditionType_AckedState_FalseState),
            9147 => Ok(VariableId::AlarmConditionType_ConfirmedState),
            9148 => Ok(VariableId::AlarmConditionType_ConfirmedState_Id),
            9149 => Ok(VariableId::AlarmConditionType_ConfirmedState_Name),
            9150 => Ok(VariableId::AlarmConditionType_ConfirmedState_Number),
            9151 => Ok(VariableId::AlarmConditionType_ConfirmedState_EffectiveDisplayName),
            9152 => Ok(VariableId::AlarmConditionType_ConfirmedState_TransitionTime),
            9153 => Ok(VariableId::AlarmConditionType_ConfirmedState_EffectiveTransitionTime),
            9154 => Ok(VariableId::AlarmConditionType_ConfirmedState_TrueState),
            9155 => Ok(VariableId::AlarmConditionType_ConfirmedState_FalseState),
            9157 => Ok(VariableId::AlarmConditionType_Acknowledge_InputArguments),
            9159 => Ok(VariableId::AlarmConditionType_Confirm_InputArguments),
            9160 => Ok(VariableId::AlarmConditionType_ActiveState),
            9161 => Ok(VariableId::AlarmConditionType_ActiveState_Id),
            9162 => Ok(VariableId::AlarmConditionType_ActiveState_Name),
            9163 => Ok(VariableId::AlarmConditionType_ActiveState_Number),
            9164 => Ok(VariableId::AlarmConditionType_ActiveState_EffectiveDisplayName),
            9165 => Ok(VariableId::AlarmConditionType_ActiveState_TransitionTime),
            9166 => Ok(VariableId::AlarmConditionType_ActiveState_EffectiveTransitionTime),
            9167 => Ok(VariableId::AlarmConditionType_ActiveState_TrueState),
            9168 => Ok(VariableId::AlarmConditionType_ActiveState_FalseState),
            9169 => Ok(VariableId::AlarmConditionType_SuppressedState),
            9170 => Ok(VariableId::AlarmConditionType_SuppressedState_Id),
            9171 => Ok(VariableId::AlarmConditionType_SuppressedState_Name),
            9172 => Ok(VariableId::AlarmConditionType_SuppressedState_Number),
            9173 => Ok(VariableId::AlarmConditionType_SuppressedState_EffectiveDisplayName),
            9174 => Ok(VariableId::AlarmConditionType_SuppressedState_TransitionTime),
            9175 => Ok(VariableId::AlarmConditionType_SuppressedState_EffectiveTransitionTime),
            9176 => Ok(VariableId::AlarmConditionType_SuppressedState_TrueState),
            9177 => Ok(VariableId::AlarmConditionType_SuppressedState_FalseState),
            9179 => Ok(VariableId::AlarmConditionType_ShelvingState_CurrentState),
            9180 => Ok(VariableId::AlarmConditionType_ShelvingState_CurrentState_Id),
            9181 => Ok(VariableId::AlarmConditionType_ShelvingState_CurrentState_Name),
            9182 => Ok(VariableId::AlarmConditionType_ShelvingState_CurrentState_Number),
            9183 => Ok(VariableId::AlarmConditionType_ShelvingState_CurrentState_EffectiveDisplayName),
            9184 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition),
            9185 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition_Id),
            9186 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition_Name),
            9187 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition_Number),
            9188 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition_TransitionTime),
            9189 => Ok(VariableId::AlarmConditionType_ShelvingState_UnshelveTime),
            9214 => Ok(VariableId::AlarmConditionType_ShelvingState_TimedShelve_InputArguments),
            9215 => Ok(VariableId::AlarmConditionType_SuppressedOrShelved),
            9216 => Ok(VariableId::AlarmConditionType_MaxTimeShelved),
            9217 => Ok(VariableId::LimitAlarmType_ConditionName),
            9218 => Ok(VariableId::LimitAlarmType_BranchId),
            9219 => Ok(VariableId::LimitAlarmType_EnabledState),
            9220 => Ok(VariableId::LimitAlarmType_EnabledState_Id),
            9221 => Ok(VariableId::LimitAlarmType_EnabledState_Name),
            9222 => Ok(VariableId::LimitAlarmType_EnabledState_Number),
            9223 => Ok(VariableId::LimitAlarmType_EnabledState_EffectiveDisplayName),
            9224 => Ok(VariableId::LimitAlarmType_EnabledState_TransitionTime),
            9225 => Ok(VariableId::LimitAlarmType_EnabledState_EffectiveTransitionTime),
            9226 => Ok(VariableId::LimitAlarmType_EnabledState_TrueState),
            9227 => Ok(VariableId::LimitAlarmType_EnabledState_FalseState),
            9228 => Ok(VariableId::LimitAlarmType_Quality),
            9229 => Ok(VariableId::LimitAlarmType_Quality_SourceTimestamp),
            9230 => Ok(VariableId::LimitAlarmType_LastSeverity),
            9231 => Ok(VariableId::LimitAlarmType_LastSeverity_SourceTimestamp),
            9232 => Ok(VariableId::LimitAlarmType_Comment),
            9233 => Ok(VariableId::LimitAlarmType_Comment_SourceTimestamp),
            9234 => Ok(VariableId::LimitAlarmType_ClientUserId),
            9238 => Ok(VariableId::LimitAlarmType_AddComment_InputArguments),
            9239 => Ok(VariableId::LimitAlarmType_AckedState),
            9240 => Ok(VariableId::LimitAlarmType_AckedState_Id),
            9241 => Ok(VariableId::LimitAlarmType_AckedState_Name),
            9242 => Ok(VariableId::LimitAlarmType_AckedState_Number),
            9243 => Ok(VariableId::LimitAlarmType_AckedState_EffectiveDisplayName),
            9244 => Ok(VariableId::LimitAlarmType_AckedState_TransitionTime),
            9245 => Ok(VariableId::LimitAlarmType_AckedState_EffectiveTransitionTime),
            9246 => Ok(VariableId::LimitAlarmType_AckedState_TrueState),
            9247 => Ok(VariableId::LimitAlarmType_AckedState_FalseState),
            9248 => Ok(VariableId::LimitAlarmType_ConfirmedState),
            9249 => Ok(VariableId::LimitAlarmType_ConfirmedState_Id),
            9250 => Ok(VariableId::LimitAlarmType_ConfirmedState_Name),
            9251 => Ok(VariableId::LimitAlarmType_ConfirmedState_Number),
            9252 => Ok(VariableId::LimitAlarmType_ConfirmedState_EffectiveDisplayName),
            9253 => Ok(VariableId::LimitAlarmType_ConfirmedState_TransitionTime),
            9254 => Ok(VariableId::LimitAlarmType_ConfirmedState_EffectiveTransitionTime),
            9255 => Ok(VariableId::LimitAlarmType_ConfirmedState_TrueState),
            9256 => Ok(VariableId::LimitAlarmType_ConfirmedState_FalseState),
            9258 => Ok(VariableId::LimitAlarmType_Acknowledge_InputArguments),
            9260 => Ok(VariableId::LimitAlarmType_Confirm_InputArguments),
            9261 => Ok(VariableId::LimitAlarmType_ActiveState),
            9262 => Ok(VariableId::LimitAlarmType_ActiveState_Id),
            9263 => Ok(VariableId::LimitAlarmType_ActiveState_Name),
            9264 => Ok(VariableId::LimitAlarmType_ActiveState_Number),
            9265 => Ok(VariableId::LimitAlarmType_ActiveState_EffectiveDisplayName),
            9266 => Ok(VariableId::LimitAlarmType_ActiveState_TransitionTime),
            9267 => Ok(VariableId::LimitAlarmType_ActiveState_EffectiveTransitionTime),
            9268 => Ok(VariableId::LimitAlarmType_ActiveState_TrueState),
            9269 => Ok(VariableId::LimitAlarmType_ActiveState_FalseState),
            9270 => Ok(VariableId::LimitAlarmType_SuppressedState),
            9271 => Ok(VariableId::LimitAlarmType_SuppressedState_Id),
            9272 => Ok(VariableId::LimitAlarmType_SuppressedState_Name),
            9273 => Ok(VariableId::LimitAlarmType_SuppressedState_Number),
            9274 => Ok(VariableId::LimitAlarmType_SuppressedState_EffectiveDisplayName),
            9275 => Ok(VariableId::LimitAlarmType_SuppressedState_TransitionTime),
            9276 => Ok(VariableId::LimitAlarmType_SuppressedState_EffectiveTransitionTime),
            9277 => Ok(VariableId::LimitAlarmType_SuppressedState_TrueState),
            9278 => Ok(VariableId::LimitAlarmType_SuppressedState_FalseState),
            9280 => Ok(VariableId::LimitAlarmType_ShelvingState_CurrentState),
            9281 => Ok(VariableId::LimitAlarmType_ShelvingState_CurrentState_Id),
            9282 => Ok(VariableId::LimitAlarmType_ShelvingState_CurrentState_Name),
            9283 => Ok(VariableId::LimitAlarmType_ShelvingState_CurrentState_Number),
            9284 => Ok(VariableId::LimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9285 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition),
            9286 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition_Id),
            9287 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition_Name),
            9288 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition_Number),
            9289 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition_TransitionTime),
            9290 => Ok(VariableId::LimitAlarmType_ShelvingState_UnshelveTime),
            9315 => Ok(VariableId::LimitAlarmType_ShelvingState_TimedShelve_InputArguments),
            9316 => Ok(VariableId::LimitAlarmType_SuppressedOrShelved),
            9317 => Ok(VariableId::LimitAlarmType_MaxTimeShelved),
            9319 => Ok(VariableId::ExclusiveLimitStateMachineType_CurrentState),
            9320 => Ok(VariableId::ExclusiveLimitStateMachineType_CurrentState_Id),
            9321 => Ok(VariableId::ExclusiveLimitStateMachineType_CurrentState_Name),
            9322 => Ok(VariableId::ExclusiveLimitStateMachineType_CurrentState_Number),
            9323 => Ok(VariableId::ExclusiveLimitStateMachineType_CurrentState_EffectiveDisplayName),
            9324 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition),
            9325 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition_Id),
            9326 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition_Name),
            9327 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition_Number),
            9328 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition_TransitionTime),
            9330 => Ok(VariableId::ExclusiveLimitStateMachineType_HighHigh_StateNumber),
            9332 => Ok(VariableId::ExclusiveLimitStateMachineType_High_StateNumber),
            9334 => Ok(VariableId::ExclusiveLimitStateMachineType_Low_StateNumber),
            9336 => Ok(VariableId::ExclusiveLimitStateMachineType_LowLow_StateNumber),
            9342 => Ok(VariableId::ExclusiveLimitAlarmType_EventId),
            9343 => Ok(VariableId::ExclusiveLimitAlarmType_EventType),
            9344 => Ok(VariableId::ExclusiveLimitAlarmType_SourceNode),
            9345 => Ok(VariableId::ExclusiveLimitAlarmType_SourceName),
            9346 => Ok(VariableId::ExclusiveLimitAlarmType_Time),
            9347 => Ok(VariableId::ExclusiveLimitAlarmType_ReceiveTime),
            9348 => Ok(VariableId::ExclusiveLimitAlarmType_LocalTime),
            9349 => Ok(VariableId::ExclusiveLimitAlarmType_Message),
            9350 => Ok(VariableId::ExclusiveLimitAlarmType_Severity),
            9351 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionName),
            9352 => Ok(VariableId::ExclusiveLimitAlarmType_BranchId),
            9353 => Ok(VariableId::ExclusiveLimitAlarmType_Retain),
            9354 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState),
            9355 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_Id),
            9356 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_Name),
            9357 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_Number),
            9358 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_EffectiveDisplayName),
            9359 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_TransitionTime),
            9360 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_EffectiveTransitionTime),
            9361 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_TrueState),
            9362 => Ok(VariableId::ExclusiveLimitAlarmType_EnabledState_FalseState),
            9363 => Ok(VariableId::ExclusiveLimitAlarmType_Quality),
            9364 => Ok(VariableId::ExclusiveLimitAlarmType_Quality_SourceTimestamp),
            9365 => Ok(VariableId::ExclusiveLimitAlarmType_LastSeverity),
            9366 => Ok(VariableId::ExclusiveLimitAlarmType_LastSeverity_SourceTimestamp),
            9367 => Ok(VariableId::ExclusiveLimitAlarmType_Comment),
            9368 => Ok(VariableId::ExclusiveLimitAlarmType_Comment_SourceTimestamp),
            9369 => Ok(VariableId::ExclusiveLimitAlarmType_ClientUserId),
            9373 => Ok(VariableId::ExclusiveLimitAlarmType_AddComment_InputArguments),
            9375 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionRefresh_InputArguments),
            9376 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState),
            9377 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_Id),
            9378 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_Name),
            9379 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_Number),
            9380 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_EffectiveDisplayName),
            9381 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_TransitionTime),
            9382 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_EffectiveTransitionTime),
            9383 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_TrueState),
            9384 => Ok(VariableId::ExclusiveLimitAlarmType_AckedState_FalseState),
            9385 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState),
            9386 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_Id),
            9387 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_Name),
            9388 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_Number),
            9389 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_EffectiveDisplayName),
            9390 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_TransitionTime),
            9391 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_EffectiveTransitionTime),
            9392 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_TrueState),
            9393 => Ok(VariableId::ExclusiveLimitAlarmType_ConfirmedState_FalseState),
            9395 => Ok(VariableId::ExclusiveLimitAlarmType_Acknowledge_InputArguments),
            9397 => Ok(VariableId::ExclusiveLimitAlarmType_Confirm_InputArguments),
            9398 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState),
            9399 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_Id),
            9400 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_Name),
            9401 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_Number),
            9402 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_EffectiveDisplayName),
            9403 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_TransitionTime),
            9404 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_EffectiveTransitionTime),
            9405 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_TrueState),
            9406 => Ok(VariableId::ExclusiveLimitAlarmType_ActiveState_FalseState),
            9407 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState),
            9408 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_Id),
            9409 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_Name),
            9410 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_Number),
            9411 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_EffectiveDisplayName),
            9412 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_TransitionTime),
            9413 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_EffectiveTransitionTime),
            9414 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_TrueState),
            9415 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedState_FalseState),
            9417 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_CurrentState),
            9418 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_CurrentState_Id),
            9419 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_CurrentState_Name),
            9420 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_CurrentState_Number),
            9421 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9422 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition),
            9423 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition_Id),
            9424 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition_Name),
            9425 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition_Number),
            9426 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition_TransitionTime),
            9427 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_UnshelveTime),
            9452 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_TimedShelve_InputArguments),
            9453 => Ok(VariableId::ExclusiveLimitAlarmType_SuppressedOrShelved),
            9454 => Ok(VariableId::ExclusiveLimitAlarmType_MaxTimeShelved),
            9456 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_CurrentState),
            9457 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_CurrentState_Id),
            9458 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_CurrentState_Name),
            9459 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_CurrentState_Number),
            9460 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_CurrentState_EffectiveDisplayName),
            9461 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition),
            9462 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition_Id),
            9463 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition_Name),
            9464 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition_Number),
            9465 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition_TransitionTime),
            9478 => Ok(VariableId::ExclusiveLimitAlarmType_HighHighLimit),
            9479 => Ok(VariableId::ExclusiveLimitAlarmType_HighLimit),
            9480 => Ok(VariableId::ExclusiveLimitAlarmType_LowLimit),
            9481 => Ok(VariableId::ExclusiveLimitAlarmType_LowLowLimit),
            9483 => Ok(VariableId::ExclusiveLevelAlarmType_EventId),
            9484 => Ok(VariableId::ExclusiveLevelAlarmType_EventType),
            9485 => Ok(VariableId::ExclusiveLevelAlarmType_SourceNode),
            9486 => Ok(VariableId::ExclusiveLevelAlarmType_SourceName),
            9487 => Ok(VariableId::ExclusiveLevelAlarmType_Time),
            9488 => Ok(VariableId::ExclusiveLevelAlarmType_ReceiveTime),
            9489 => Ok(VariableId::ExclusiveLevelAlarmType_LocalTime),
            9490 => Ok(VariableId::ExclusiveLevelAlarmType_Message),
            9491 => Ok(VariableId::ExclusiveLevelAlarmType_Severity),
            9492 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionName),
            9493 => Ok(VariableId::ExclusiveLevelAlarmType_BranchId),
            9494 => Ok(VariableId::ExclusiveLevelAlarmType_Retain),
            9495 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState),
            9496 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_Id),
            9497 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_Name),
            9498 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_Number),
            9499 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_EffectiveDisplayName),
            9500 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_TransitionTime),
            9501 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_EffectiveTransitionTime),
            9502 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_TrueState),
            9503 => Ok(VariableId::ExclusiveLevelAlarmType_EnabledState_FalseState),
            9504 => Ok(VariableId::ExclusiveLevelAlarmType_Quality),
            9505 => Ok(VariableId::ExclusiveLevelAlarmType_Quality_SourceTimestamp),
            9506 => Ok(VariableId::ExclusiveLevelAlarmType_LastSeverity),
            9507 => Ok(VariableId::ExclusiveLevelAlarmType_LastSeverity_SourceTimestamp),
            9508 => Ok(VariableId::ExclusiveLevelAlarmType_Comment),
            9509 => Ok(VariableId::ExclusiveLevelAlarmType_Comment_SourceTimestamp),
            9510 => Ok(VariableId::ExclusiveLevelAlarmType_ClientUserId),
            9514 => Ok(VariableId::ExclusiveLevelAlarmType_AddComment_InputArguments),
            9516 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionRefresh_InputArguments),
            9517 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState),
            9518 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_Id),
            9519 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_Name),
            9520 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_Number),
            9521 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_EffectiveDisplayName),
            9522 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_TransitionTime),
            9523 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_EffectiveTransitionTime),
            9524 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_TrueState),
            9525 => Ok(VariableId::ExclusiveLevelAlarmType_AckedState_FalseState),
            9526 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState),
            9527 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_Id),
            9528 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_Name),
            9529 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_Number),
            9530 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_EffectiveDisplayName),
            9531 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_TransitionTime),
            9532 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_EffectiveTransitionTime),
            9533 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_TrueState),
            9534 => Ok(VariableId::ExclusiveLevelAlarmType_ConfirmedState_FalseState),
            9536 => Ok(VariableId::ExclusiveLevelAlarmType_Acknowledge_InputArguments),
            9538 => Ok(VariableId::ExclusiveLevelAlarmType_Confirm_InputArguments),
            9539 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState),
            9540 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_Id),
            9541 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_Name),
            9542 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_Number),
            9543 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_EffectiveDisplayName),
            9544 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_TransitionTime),
            9545 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_EffectiveTransitionTime),
            9546 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_TrueState),
            9547 => Ok(VariableId::ExclusiveLevelAlarmType_ActiveState_FalseState),
            9548 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState),
            9549 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_Id),
            9550 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_Name),
            9551 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_Number),
            9552 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_EffectiveDisplayName),
            9553 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_TransitionTime),
            9554 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_EffectiveTransitionTime),
            9555 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_TrueState),
            9556 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedState_FalseState),
            9558 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_CurrentState),
            9559 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_CurrentState_Id),
            9560 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_CurrentState_Name),
            9561 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_CurrentState_Number),
            9562 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9563 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition),
            9564 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition_Id),
            9565 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition_Name),
            9566 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition_Number),
            9567 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition_TransitionTime),
            9568 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_UnshelveTime),
            9593 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_TimedShelve_InputArguments),
            9594 => Ok(VariableId::ExclusiveLevelAlarmType_SuppressedOrShelved),
            9595 => Ok(VariableId::ExclusiveLevelAlarmType_MaxTimeShelved),
            9597 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_CurrentState),
            9598 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_CurrentState_Id),
            9599 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_CurrentState_Name),
            9600 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_CurrentState_Number),
            9601 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_CurrentState_EffectiveDisplayName),
            9602 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition),
            9603 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition_Id),
            9604 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition_Name),
            9605 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition_Number),
            9606 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition_TransitionTime),
            9619 => Ok(VariableId::ExclusiveLevelAlarmType_HighHighLimit),
            9620 => Ok(VariableId::ExclusiveLevelAlarmType_HighLimit),
            9621 => Ok(VariableId::ExclusiveLevelAlarmType_LowLimit),
            9622 => Ok(VariableId::ExclusiveLevelAlarmType_LowLowLimit),
            9624 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EventId),
            9625 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EventType),
            9626 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SourceNode),
            9627 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SourceName),
            9628 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Time),
            9629 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ReceiveTime),
            9630 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LocalTime),
            9631 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Message),
            9632 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Severity),
            9633 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionName),
            9634 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_BranchId),
            9635 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Retain),
            9636 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState),
            9637 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_Id),
            9638 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_Name),
            9639 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_Number),
            9640 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_EffectiveDisplayName),
            9641 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_TransitionTime),
            9642 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_EffectiveTransitionTime),
            9643 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_TrueState),
            9644 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EnabledState_FalseState),
            9645 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Quality),
            9646 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Quality_SourceTimestamp),
            9647 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LastSeverity),
            9648 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LastSeverity_SourceTimestamp),
            9649 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Comment),
            9650 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Comment_SourceTimestamp),
            9651 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ClientUserId),
            9655 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AddComment_InputArguments),
            9657 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionRefresh_InputArguments),
            9658 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState),
            9659 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_Id),
            9660 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_Name),
            9661 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_Number),
            9662 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_EffectiveDisplayName),
            9663 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_TransitionTime),
            9664 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_EffectiveTransitionTime),
            9665 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_TrueState),
            9666 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AckedState_FalseState),
            9667 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState),
            9668 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_Id),
            9669 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_Name),
            9670 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_Number),
            9671 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveDisplayName),
            9672 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_TransitionTime),
            9673 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveTransitionTime),
            9674 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_TrueState),
            9675 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConfirmedState_FalseState),
            9677 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Acknowledge_InputArguments),
            9679 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_Confirm_InputArguments),
            9680 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState),
            9681 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_Id),
            9682 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_Name),
            9683 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_Number),
            9684 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_EffectiveDisplayName),
            9685 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_TransitionTime),
            9686 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_EffectiveTransitionTime),
            9687 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_TrueState),
            9688 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ActiveState_FalseState),
            9689 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState),
            9690 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_Id),
            9691 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_Name),
            9692 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_Number),
            9693 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveDisplayName),
            9694 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_TransitionTime),
            9695 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveTransitionTime),
            9696 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_TrueState),
            9697 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedState_FalseState),
            9699 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState),
            9700 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Id),
            9701 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Name),
            9702 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Number),
            9703 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9704 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition),
            9705 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Id),
            9706 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Name),
            9707 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Number),
            9708 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_TransitionTime),
            9709 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_UnshelveTime),
            9734 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve_InputArguments),
            9735 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SuppressedOrShelved),
            9736 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_MaxTimeShelved),
            9738 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_CurrentState),
            9739 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Id),
            9740 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Name),
            9741 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_Number),
            9742 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_CurrentState_EffectiveDisplayName),
            9743 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition),
            9744 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Id),
            9745 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Name),
            9746 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_Number),
            9747 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_TransitionTime),
            9760 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_HighHighLimit),
            9761 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_HighLimit),
            9762 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LowLimit),
            9763 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LowLowLimit),
            9765 => Ok(VariableId::ExclusiveDeviationAlarmType_EventId),
            9766 => Ok(VariableId::ExclusiveDeviationAlarmType_EventType),
            9767 => Ok(VariableId::ExclusiveDeviationAlarmType_SourceNode),
            9768 => Ok(VariableId::ExclusiveDeviationAlarmType_SourceName),
            9769 => Ok(VariableId::ExclusiveDeviationAlarmType_Time),
            9770 => Ok(VariableId::ExclusiveDeviationAlarmType_ReceiveTime),
            9771 => Ok(VariableId::ExclusiveDeviationAlarmType_LocalTime),
            9772 => Ok(VariableId::ExclusiveDeviationAlarmType_Message),
            9773 => Ok(VariableId::ExclusiveDeviationAlarmType_Severity),
            9774 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionName),
            9775 => Ok(VariableId::ExclusiveDeviationAlarmType_BranchId),
            9776 => Ok(VariableId::ExclusiveDeviationAlarmType_Retain),
            9777 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState),
            9778 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_Id),
            9779 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_Name),
            9780 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_Number),
            9781 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_EffectiveDisplayName),
            9782 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_TransitionTime),
            9783 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_EffectiveTransitionTime),
            9784 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_TrueState),
            9785 => Ok(VariableId::ExclusiveDeviationAlarmType_EnabledState_FalseState),
            9786 => Ok(VariableId::ExclusiveDeviationAlarmType_Quality),
            9787 => Ok(VariableId::ExclusiveDeviationAlarmType_Quality_SourceTimestamp),
            9788 => Ok(VariableId::ExclusiveDeviationAlarmType_LastSeverity),
            9789 => Ok(VariableId::ExclusiveDeviationAlarmType_LastSeverity_SourceTimestamp),
            9790 => Ok(VariableId::ExclusiveDeviationAlarmType_Comment),
            9791 => Ok(VariableId::ExclusiveDeviationAlarmType_Comment_SourceTimestamp),
            9792 => Ok(VariableId::ExclusiveDeviationAlarmType_ClientUserId),
            9796 => Ok(VariableId::ExclusiveDeviationAlarmType_AddComment_InputArguments),
            9798 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionRefresh_InputArguments),
            9799 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState),
            9800 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_Id),
            9801 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_Name),
            9802 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_Number),
            9803 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_EffectiveDisplayName),
            9804 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_TransitionTime),
            9805 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_EffectiveTransitionTime),
            9806 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_TrueState),
            9807 => Ok(VariableId::ExclusiveDeviationAlarmType_AckedState_FalseState),
            9808 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState),
            9809 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_Id),
            9810 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_Name),
            9811 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_Number),
            9812 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_EffectiveDisplayName),
            9813 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_TransitionTime),
            9814 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_EffectiveTransitionTime),
            9815 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_TrueState),
            9816 => Ok(VariableId::ExclusiveDeviationAlarmType_ConfirmedState_FalseState),
            9818 => Ok(VariableId::ExclusiveDeviationAlarmType_Acknowledge_InputArguments),
            9820 => Ok(VariableId::ExclusiveDeviationAlarmType_Confirm_InputArguments),
            9821 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState),
            9822 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_Id),
            9823 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_Name),
            9824 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_Number),
            9825 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_EffectiveDisplayName),
            9826 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_TransitionTime),
            9827 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_EffectiveTransitionTime),
            9828 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_TrueState),
            9829 => Ok(VariableId::ExclusiveDeviationAlarmType_ActiveState_FalseState),
            9830 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState),
            9831 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_Id),
            9832 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_Name),
            9833 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_Number),
            9834 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_EffectiveDisplayName),
            9835 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_TransitionTime),
            9836 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_EffectiveTransitionTime),
            9837 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_TrueState),
            9838 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedState_FalseState),
            9840 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_CurrentState),
            9841 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Id),
            9842 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Name),
            9843 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_CurrentState_Number),
            9844 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9845 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition),
            9846 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Id),
            9847 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Name),
            9848 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition_Number),
            9849 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition_TransitionTime),
            9850 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_UnshelveTime),
            9875 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_TimedShelve_InputArguments),
            9876 => Ok(VariableId::ExclusiveDeviationAlarmType_SuppressedOrShelved),
            9877 => Ok(VariableId::ExclusiveDeviationAlarmType_MaxTimeShelved),
            9879 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_CurrentState),
            9880 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_CurrentState_Id),
            9881 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_CurrentState_Name),
            9882 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_CurrentState_Number),
            9883 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_CurrentState_EffectiveDisplayName),
            9884 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition),
            9885 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition_Id),
            9886 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition_Name),
            9887 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition_Number),
            9888 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition_TransitionTime),
            9901 => Ok(VariableId::ExclusiveDeviationAlarmType_HighHighLimit),
            9902 => Ok(VariableId::ExclusiveDeviationAlarmType_HighLimit),
            9903 => Ok(VariableId::ExclusiveDeviationAlarmType_LowLimit),
            9904 => Ok(VariableId::ExclusiveDeviationAlarmType_LowLowLimit),
            9905 => Ok(VariableId::ExclusiveDeviationAlarmType_SetpointNode),
            9907 => Ok(VariableId::NonExclusiveLimitAlarmType_EventId),
            9908 => Ok(VariableId::NonExclusiveLimitAlarmType_EventType),
            9909 => Ok(VariableId::NonExclusiveLimitAlarmType_SourceNode),
            9910 => Ok(VariableId::NonExclusiveLimitAlarmType_SourceName),
            9911 => Ok(VariableId::NonExclusiveLimitAlarmType_Time),
            9912 => Ok(VariableId::NonExclusiveLimitAlarmType_ReceiveTime),
            9913 => Ok(VariableId::NonExclusiveLimitAlarmType_LocalTime),
            9914 => Ok(VariableId::NonExclusiveLimitAlarmType_Message),
            9915 => Ok(VariableId::NonExclusiveLimitAlarmType_Severity),
            9916 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionName),
            9917 => Ok(VariableId::NonExclusiveLimitAlarmType_BranchId),
            9918 => Ok(VariableId::NonExclusiveLimitAlarmType_Retain),
            9919 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState),
            9920 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_Id),
            9921 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_Name),
            9922 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_Number),
            9923 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_EffectiveDisplayName),
            9924 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_TransitionTime),
            9925 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_EffectiveTransitionTime),
            9926 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_TrueState),
            9927 => Ok(VariableId::NonExclusiveLimitAlarmType_EnabledState_FalseState),
            9928 => Ok(VariableId::NonExclusiveLimitAlarmType_Quality),
            9929 => Ok(VariableId::NonExclusiveLimitAlarmType_Quality_SourceTimestamp),
            9930 => Ok(VariableId::NonExclusiveLimitAlarmType_LastSeverity),
            9931 => Ok(VariableId::NonExclusiveLimitAlarmType_LastSeverity_SourceTimestamp),
            9932 => Ok(VariableId::NonExclusiveLimitAlarmType_Comment),
            9933 => Ok(VariableId::NonExclusiveLimitAlarmType_Comment_SourceTimestamp),
            9934 => Ok(VariableId::NonExclusiveLimitAlarmType_ClientUserId),
            9938 => Ok(VariableId::NonExclusiveLimitAlarmType_AddComment_InputArguments),
            9940 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionRefresh_InputArguments),
            9941 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState),
            9942 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_Id),
            9943 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_Name),
            9944 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_Number),
            9945 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_EffectiveDisplayName),
            9946 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_TransitionTime),
            9947 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_EffectiveTransitionTime),
            9948 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_TrueState),
            9949 => Ok(VariableId::NonExclusiveLimitAlarmType_AckedState_FalseState),
            9950 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState),
            9951 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_Id),
            9952 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_Name),
            9953 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_Number),
            9954 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_EffectiveDisplayName),
            9955 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_TransitionTime),
            9956 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_EffectiveTransitionTime),
            9957 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_TrueState),
            9958 => Ok(VariableId::NonExclusiveLimitAlarmType_ConfirmedState_FalseState),
            9960 => Ok(VariableId::NonExclusiveLimitAlarmType_Acknowledge_InputArguments),
            9962 => Ok(VariableId::NonExclusiveLimitAlarmType_Confirm_InputArguments),
            9963 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState),
            9964 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_Id),
            9965 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_Name),
            9966 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_Number),
            9967 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_EffectiveDisplayName),
            9968 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_TransitionTime),
            9969 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_EffectiveTransitionTime),
            9970 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_TrueState),
            9971 => Ok(VariableId::NonExclusiveLimitAlarmType_ActiveState_FalseState),
            9972 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState),
            9973 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_Id),
            9974 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_Name),
            9975 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_Number),
            9976 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_EffectiveDisplayName),
            9977 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_TransitionTime),
            9978 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_EffectiveTransitionTime),
            9979 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_TrueState),
            9980 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedState_FalseState),
            9982 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_CurrentState),
            9983 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Id),
            9984 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Name),
            9985 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_CurrentState_Number),
            9986 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            9987 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition),
            9988 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Id),
            9989 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Name),
            9990 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition_Number),
            9991 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition_TransitionTime),
            9992 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_UnshelveTime),
            10017 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_TimedShelve_InputArguments),
            10018 => Ok(VariableId::NonExclusiveLimitAlarmType_SuppressedOrShelved),
            10019 => Ok(VariableId::NonExclusiveLimitAlarmType_MaxTimeShelved),
            10020 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState),
            10021 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_Id),
            10022 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_Name),
            10023 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_Number),
            10024 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_EffectiveDisplayName),
            10025 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_TransitionTime),
            10026 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_EffectiveTransitionTime),
            10027 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_TrueState),
            10028 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighState_FalseState),
            10029 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState),
            10030 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_Id),
            10031 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_Name),
            10032 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_Number),
            10033 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_EffectiveDisplayName),
            10034 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_TransitionTime),
            10035 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_EffectiveTransitionTime),
            10036 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_TrueState),
            10037 => Ok(VariableId::NonExclusiveLimitAlarmType_HighState_FalseState),
            10038 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState),
            10039 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_Id),
            10040 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_Name),
            10041 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_Number),
            10042 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_EffectiveDisplayName),
            10043 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_TransitionTime),
            10044 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_EffectiveTransitionTime),
            10045 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_TrueState),
            10046 => Ok(VariableId::NonExclusiveLimitAlarmType_LowState_FalseState),
            10047 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState),
            10048 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_Id),
            10049 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_Name),
            10050 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_Number),
            10051 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_EffectiveDisplayName),
            10052 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_TransitionTime),
            10053 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_EffectiveTransitionTime),
            10054 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_TrueState),
            10055 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowState_FalseState),
            10056 => Ok(VariableId::NonExclusiveLimitAlarmType_HighHighLimit),
            10057 => Ok(VariableId::NonExclusiveLimitAlarmType_HighLimit),
            10058 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLimit),
            10059 => Ok(VariableId::NonExclusiveLimitAlarmType_LowLowLimit),
            10061 => Ok(VariableId::NonExclusiveLevelAlarmType_EventId),
            10062 => Ok(VariableId::NonExclusiveLevelAlarmType_EventType),
            10063 => Ok(VariableId::NonExclusiveLevelAlarmType_SourceNode),
            10064 => Ok(VariableId::NonExclusiveLevelAlarmType_SourceName),
            10065 => Ok(VariableId::NonExclusiveLevelAlarmType_Time),
            10066 => Ok(VariableId::NonExclusiveLevelAlarmType_ReceiveTime),
            10067 => Ok(VariableId::NonExclusiveLevelAlarmType_LocalTime),
            10068 => Ok(VariableId::NonExclusiveLevelAlarmType_Message),
            10069 => Ok(VariableId::NonExclusiveLevelAlarmType_Severity),
            10070 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionName),
            10071 => Ok(VariableId::NonExclusiveLevelAlarmType_BranchId),
            10072 => Ok(VariableId::NonExclusiveLevelAlarmType_Retain),
            10073 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState),
            10074 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_Id),
            10075 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_Name),
            10076 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_Number),
            10077 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_EffectiveDisplayName),
            10078 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_TransitionTime),
            10079 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_EffectiveTransitionTime),
            10080 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_TrueState),
            10081 => Ok(VariableId::NonExclusiveLevelAlarmType_EnabledState_FalseState),
            10082 => Ok(VariableId::NonExclusiveLevelAlarmType_Quality),
            10083 => Ok(VariableId::NonExclusiveLevelAlarmType_Quality_SourceTimestamp),
            10084 => Ok(VariableId::NonExclusiveLevelAlarmType_LastSeverity),
            10085 => Ok(VariableId::NonExclusiveLevelAlarmType_LastSeverity_SourceTimestamp),
            10086 => Ok(VariableId::NonExclusiveLevelAlarmType_Comment),
            10087 => Ok(VariableId::NonExclusiveLevelAlarmType_Comment_SourceTimestamp),
            10088 => Ok(VariableId::NonExclusiveLevelAlarmType_ClientUserId),
            10092 => Ok(VariableId::NonExclusiveLevelAlarmType_AddComment_InputArguments),
            10094 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionRefresh_InputArguments),
            10095 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState),
            10096 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_Id),
            10097 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_Name),
            10098 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_Number),
            10099 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_EffectiveDisplayName),
            10100 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_TransitionTime),
            10101 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_EffectiveTransitionTime),
            10102 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_TrueState),
            10103 => Ok(VariableId::NonExclusiveLevelAlarmType_AckedState_FalseState),
            10104 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState),
            10105 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_Id),
            10106 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_Name),
            10107 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_Number),
            10108 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_EffectiveDisplayName),
            10109 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_TransitionTime),
            10110 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_EffectiveTransitionTime),
            10111 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_TrueState),
            10112 => Ok(VariableId::NonExclusiveLevelAlarmType_ConfirmedState_FalseState),
            10114 => Ok(VariableId::NonExclusiveLevelAlarmType_Acknowledge_InputArguments),
            10116 => Ok(VariableId::NonExclusiveLevelAlarmType_Confirm_InputArguments),
            10117 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState),
            10118 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_Id),
            10119 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_Name),
            10120 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_Number),
            10121 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_EffectiveDisplayName),
            10122 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_TransitionTime),
            10123 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_EffectiveTransitionTime),
            10124 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_TrueState),
            10125 => Ok(VariableId::NonExclusiveLevelAlarmType_ActiveState_FalseState),
            10126 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState),
            10127 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_Id),
            10128 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_Name),
            10129 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_Number),
            10130 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_EffectiveDisplayName),
            10131 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_TransitionTime),
            10132 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_EffectiveTransitionTime),
            10133 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_TrueState),
            10134 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedState_FalseState),
            10136 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_CurrentState),
            10137 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Id),
            10138 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Name),
            10139 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_CurrentState_Number),
            10140 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10141 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition),
            10142 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Id),
            10143 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Name),
            10144 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition_Number),
            10145 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition_TransitionTime),
            10146 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_UnshelveTime),
            10171 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_TimedShelve_InputArguments),
            10172 => Ok(VariableId::NonExclusiveLevelAlarmType_SuppressedOrShelved),
            10173 => Ok(VariableId::NonExclusiveLevelAlarmType_MaxTimeShelved),
            10174 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState),
            10175 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_Id),
            10176 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_Name),
            10177 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_Number),
            10178 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_EffectiveDisplayName),
            10179 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_TransitionTime),
            10180 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_EffectiveTransitionTime),
            10181 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_TrueState),
            10182 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighState_FalseState),
            10183 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState),
            10184 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_Id),
            10185 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_Name),
            10186 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_Number),
            10187 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_EffectiveDisplayName),
            10188 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_TransitionTime),
            10189 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_EffectiveTransitionTime),
            10190 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_TrueState),
            10191 => Ok(VariableId::NonExclusiveLevelAlarmType_HighState_FalseState),
            10192 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState),
            10193 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_Id),
            10194 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_Name),
            10195 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_Number),
            10196 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_EffectiveDisplayName),
            10197 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_TransitionTime),
            10198 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_EffectiveTransitionTime),
            10199 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_TrueState),
            10200 => Ok(VariableId::NonExclusiveLevelAlarmType_LowState_FalseState),
            10201 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState),
            10202 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_Id),
            10203 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_Name),
            10204 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_Number),
            10205 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_EffectiveDisplayName),
            10206 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_TransitionTime),
            10207 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_EffectiveTransitionTime),
            10208 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_TrueState),
            10209 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowState_FalseState),
            10210 => Ok(VariableId::NonExclusiveLevelAlarmType_HighHighLimit),
            10211 => Ok(VariableId::NonExclusiveLevelAlarmType_HighLimit),
            10212 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLimit),
            10213 => Ok(VariableId::NonExclusiveLevelAlarmType_LowLowLimit),
            10215 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EventId),
            10216 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EventType),
            10217 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SourceNode),
            10218 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SourceName),
            10219 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Time),
            10220 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ReceiveTime),
            10221 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LocalTime),
            10222 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Message),
            10223 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Severity),
            10224 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionName),
            10225 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_BranchId),
            10226 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Retain),
            10227 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState),
            10228 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_Id),
            10229 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_Name),
            10230 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_Number),
            10231 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_EffectiveDisplayName),
            10232 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_TransitionTime),
            10233 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_EffectiveTransitionTime),
            10234 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_TrueState),
            10235 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EnabledState_FalseState),
            10236 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Quality),
            10237 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Quality_SourceTimestamp),
            10238 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LastSeverity),
            10239 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LastSeverity_SourceTimestamp),
            10240 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Comment),
            10241 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Comment_SourceTimestamp),
            10242 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ClientUserId),
            10246 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AddComment_InputArguments),
            10248 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionRefresh_InputArguments),
            10249 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState),
            10250 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_Id),
            10251 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_Name),
            10252 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_Number),
            10253 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_EffectiveDisplayName),
            10254 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_TransitionTime),
            10255 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_EffectiveTransitionTime),
            10256 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_TrueState),
            10257 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AckedState_FalseState),
            10258 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState),
            10259 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_Id),
            10260 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_Name),
            10261 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_Number),
            10262 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveDisplayName),
            10263 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_TransitionTime),
            10264 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_EffectiveTransitionTime),
            10265 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_TrueState),
            10266 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConfirmedState_FalseState),
            10268 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Acknowledge_InputArguments),
            10270 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_Confirm_InputArguments),
            10271 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState),
            10272 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_Id),
            10273 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_Name),
            10274 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_Number),
            10275 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_EffectiveDisplayName),
            10276 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_TransitionTime),
            10277 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_EffectiveTransitionTime),
            10278 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_TrueState),
            10279 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ActiveState_FalseState),
            10280 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState),
            10281 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_Id),
            10282 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_Name),
            10283 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_Number),
            10284 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveDisplayName),
            10285 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_TransitionTime),
            10286 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_EffectiveTransitionTime),
            10287 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_TrueState),
            10288 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedState_FalseState),
            10290 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState),
            10291 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Id),
            10292 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Name),
            10293 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_Number),
            10294 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10295 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition),
            10296 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Id),
            10297 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Name),
            10298 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_Number),
            10299 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_TransitionTime),
            10300 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_UnshelveTime),
            10325 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve_InputArguments),
            10326 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SuppressedOrShelved),
            10327 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_MaxTimeShelved),
            10328 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState),
            10329 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_Id),
            10330 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_Name),
            10331 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_Number),
            10332 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_EffectiveDisplayName),
            10333 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_TransitionTime),
            10334 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_EffectiveTransitionTime),
            10335 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_TrueState),
            10336 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighState_FalseState),
            10337 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState),
            10338 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_Id),
            10339 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_Name),
            10340 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_Number),
            10341 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_EffectiveDisplayName),
            10342 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_TransitionTime),
            10343 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_EffectiveTransitionTime),
            10344 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_TrueState),
            10345 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighState_FalseState),
            10346 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState),
            10347 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_Id),
            10348 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_Name),
            10349 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_Number),
            10350 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_EffectiveDisplayName),
            10351 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_TransitionTime),
            10352 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_EffectiveTransitionTime),
            10353 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_TrueState),
            10354 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowState_FalseState),
            10355 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState),
            10356 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_Id),
            10357 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_Name),
            10358 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_Number),
            10359 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_EffectiveDisplayName),
            10360 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_TransitionTime),
            10361 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_EffectiveTransitionTime),
            10362 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_TrueState),
            10363 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowState_FalseState),
            10364 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighHighLimit),
            10365 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_HighLimit),
            10366 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLimit),
            10367 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LowLowLimit),
            10369 => Ok(VariableId::NonExclusiveDeviationAlarmType_EventId),
            10370 => Ok(VariableId::NonExclusiveDeviationAlarmType_EventType),
            10371 => Ok(VariableId::NonExclusiveDeviationAlarmType_SourceNode),
            10372 => Ok(VariableId::NonExclusiveDeviationAlarmType_SourceName),
            10373 => Ok(VariableId::NonExclusiveDeviationAlarmType_Time),
            10374 => Ok(VariableId::NonExclusiveDeviationAlarmType_ReceiveTime),
            10375 => Ok(VariableId::NonExclusiveDeviationAlarmType_LocalTime),
            10376 => Ok(VariableId::NonExclusiveDeviationAlarmType_Message),
            10377 => Ok(VariableId::NonExclusiveDeviationAlarmType_Severity),
            10378 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionName),
            10379 => Ok(VariableId::NonExclusiveDeviationAlarmType_BranchId),
            10380 => Ok(VariableId::NonExclusiveDeviationAlarmType_Retain),
            10381 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState),
            10382 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_Id),
            10383 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_Name),
            10384 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_Number),
            10385 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_EffectiveDisplayName),
            10386 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_TransitionTime),
            10387 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_EffectiveTransitionTime),
            10388 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_TrueState),
            10389 => Ok(VariableId::NonExclusiveDeviationAlarmType_EnabledState_FalseState),
            10390 => Ok(VariableId::NonExclusiveDeviationAlarmType_Quality),
            10391 => Ok(VariableId::NonExclusiveDeviationAlarmType_Quality_SourceTimestamp),
            10392 => Ok(VariableId::NonExclusiveDeviationAlarmType_LastSeverity),
            10393 => Ok(VariableId::NonExclusiveDeviationAlarmType_LastSeverity_SourceTimestamp),
            10394 => Ok(VariableId::NonExclusiveDeviationAlarmType_Comment),
            10395 => Ok(VariableId::NonExclusiveDeviationAlarmType_Comment_SourceTimestamp),
            10396 => Ok(VariableId::NonExclusiveDeviationAlarmType_ClientUserId),
            10400 => Ok(VariableId::NonExclusiveDeviationAlarmType_AddComment_InputArguments),
            10402 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionRefresh_InputArguments),
            10403 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState),
            10404 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_Id),
            10405 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_Name),
            10406 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_Number),
            10407 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_EffectiveDisplayName),
            10408 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_TransitionTime),
            10409 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_EffectiveTransitionTime),
            10410 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_TrueState),
            10411 => Ok(VariableId::NonExclusiveDeviationAlarmType_AckedState_FalseState),
            10412 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState),
            10413 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_Id),
            10414 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_Name),
            10415 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_Number),
            10416 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_EffectiveDisplayName),
            10417 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_TransitionTime),
            10418 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_EffectiveTransitionTime),
            10419 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_TrueState),
            10420 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConfirmedState_FalseState),
            10422 => Ok(VariableId::NonExclusiveDeviationAlarmType_Acknowledge_InputArguments),
            10424 => Ok(VariableId::NonExclusiveDeviationAlarmType_Confirm_InputArguments),
            10425 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState),
            10426 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_Id),
            10427 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_Name),
            10428 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_Number),
            10429 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_EffectiveDisplayName),
            10430 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_TransitionTime),
            10431 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_EffectiveTransitionTime),
            10432 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_TrueState),
            10433 => Ok(VariableId::NonExclusiveDeviationAlarmType_ActiveState_FalseState),
            10434 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState),
            10435 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_Id),
            10436 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_Name),
            10437 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_Number),
            10438 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_EffectiveDisplayName),
            10439 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_TransitionTime),
            10440 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_EffectiveTransitionTime),
            10441 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_TrueState),
            10442 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedState_FalseState),
            10444 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_CurrentState),
            10445 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Id),
            10446 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Name),
            10447 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_Number),
            10448 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10449 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition),
            10450 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Id),
            10451 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Name),
            10452 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_Number),
            10453 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_TransitionTime),
            10454 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_UnshelveTime),
            10479 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_TimedShelve_InputArguments),
            10480 => Ok(VariableId::NonExclusiveDeviationAlarmType_SuppressedOrShelved),
            10481 => Ok(VariableId::NonExclusiveDeviationAlarmType_MaxTimeShelved),
            10482 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState),
            10483 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_Id),
            10484 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_Name),
            10485 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_Number),
            10486 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_EffectiveDisplayName),
            10487 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_TransitionTime),
            10488 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_EffectiveTransitionTime),
            10489 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_TrueState),
            10490 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighState_FalseState),
            10491 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState),
            10492 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_Id),
            10493 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_Name),
            10494 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_Number),
            10495 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_EffectiveDisplayName),
            10496 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_TransitionTime),
            10497 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_EffectiveTransitionTime),
            10498 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_TrueState),
            10499 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighState_FalseState),
            10500 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState),
            10501 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_Id),
            10502 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_Name),
            10503 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_Number),
            10504 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_EffectiveDisplayName),
            10505 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_TransitionTime),
            10506 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_EffectiveTransitionTime),
            10507 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_TrueState),
            10508 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowState_FalseState),
            10509 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState),
            10510 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_Id),
            10511 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_Name),
            10512 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_Number),
            10513 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_EffectiveDisplayName),
            10514 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_TransitionTime),
            10515 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_EffectiveTransitionTime),
            10516 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_TrueState),
            10517 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowState_FalseState),
            10518 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighHighLimit),
            10519 => Ok(VariableId::NonExclusiveDeviationAlarmType_HighLimit),
            10520 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLimit),
            10521 => Ok(VariableId::NonExclusiveDeviationAlarmType_LowLowLimit),
            10522 => Ok(VariableId::NonExclusiveDeviationAlarmType_SetpointNode),
            10524 => Ok(VariableId::DiscreteAlarmType_EventId),
            10525 => Ok(VariableId::DiscreteAlarmType_EventType),
            10526 => Ok(VariableId::DiscreteAlarmType_SourceNode),
            10527 => Ok(VariableId::DiscreteAlarmType_SourceName),
            10528 => Ok(VariableId::DiscreteAlarmType_Time),
            10529 => Ok(VariableId::DiscreteAlarmType_ReceiveTime),
            10530 => Ok(VariableId::DiscreteAlarmType_LocalTime),
            10531 => Ok(VariableId::DiscreteAlarmType_Message),
            10532 => Ok(VariableId::DiscreteAlarmType_Severity),
            10533 => Ok(VariableId::DiscreteAlarmType_ConditionName),
            10534 => Ok(VariableId::DiscreteAlarmType_BranchId),
            10535 => Ok(VariableId::DiscreteAlarmType_Retain),
            10536 => Ok(VariableId::DiscreteAlarmType_EnabledState),
            10537 => Ok(VariableId::DiscreteAlarmType_EnabledState_Id),
            10538 => Ok(VariableId::DiscreteAlarmType_EnabledState_Name),
            10539 => Ok(VariableId::DiscreteAlarmType_EnabledState_Number),
            10540 => Ok(VariableId::DiscreteAlarmType_EnabledState_EffectiveDisplayName),
            10541 => Ok(VariableId::DiscreteAlarmType_EnabledState_TransitionTime),
            10542 => Ok(VariableId::DiscreteAlarmType_EnabledState_EffectiveTransitionTime),
            10543 => Ok(VariableId::DiscreteAlarmType_EnabledState_TrueState),
            10544 => Ok(VariableId::DiscreteAlarmType_EnabledState_FalseState),
            10545 => Ok(VariableId::DiscreteAlarmType_Quality),
            10546 => Ok(VariableId::DiscreteAlarmType_Quality_SourceTimestamp),
            10547 => Ok(VariableId::DiscreteAlarmType_LastSeverity),
            10548 => Ok(VariableId::DiscreteAlarmType_LastSeverity_SourceTimestamp),
            10549 => Ok(VariableId::DiscreteAlarmType_Comment),
            10550 => Ok(VariableId::DiscreteAlarmType_Comment_SourceTimestamp),
            10551 => Ok(VariableId::DiscreteAlarmType_ClientUserId),
            10555 => Ok(VariableId::DiscreteAlarmType_AddComment_InputArguments),
            10557 => Ok(VariableId::DiscreteAlarmType_ConditionRefresh_InputArguments),
            10558 => Ok(VariableId::DiscreteAlarmType_AckedState),
            10559 => Ok(VariableId::DiscreteAlarmType_AckedState_Id),
            10560 => Ok(VariableId::DiscreteAlarmType_AckedState_Name),
            10561 => Ok(VariableId::DiscreteAlarmType_AckedState_Number),
            10562 => Ok(VariableId::DiscreteAlarmType_AckedState_EffectiveDisplayName),
            10563 => Ok(VariableId::DiscreteAlarmType_AckedState_TransitionTime),
            10564 => Ok(VariableId::DiscreteAlarmType_AckedState_EffectiveTransitionTime),
            10565 => Ok(VariableId::DiscreteAlarmType_AckedState_TrueState),
            10566 => Ok(VariableId::DiscreteAlarmType_AckedState_FalseState),
            10567 => Ok(VariableId::DiscreteAlarmType_ConfirmedState),
            10568 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_Id),
            10569 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_Name),
            10570 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_Number),
            10571 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_EffectiveDisplayName),
            10572 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_TransitionTime),
            10573 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_EffectiveTransitionTime),
            10574 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_TrueState),
            10575 => Ok(VariableId::DiscreteAlarmType_ConfirmedState_FalseState),
            10577 => Ok(VariableId::DiscreteAlarmType_Acknowledge_InputArguments),
            10579 => Ok(VariableId::DiscreteAlarmType_Confirm_InputArguments),
            10580 => Ok(VariableId::DiscreteAlarmType_ActiveState),
            10581 => Ok(VariableId::DiscreteAlarmType_ActiveState_Id),
            10582 => Ok(VariableId::DiscreteAlarmType_ActiveState_Name),
            10583 => Ok(VariableId::DiscreteAlarmType_ActiveState_Number),
            10584 => Ok(VariableId::DiscreteAlarmType_ActiveState_EffectiveDisplayName),
            10585 => Ok(VariableId::DiscreteAlarmType_ActiveState_TransitionTime),
            10586 => Ok(VariableId::DiscreteAlarmType_ActiveState_EffectiveTransitionTime),
            10587 => Ok(VariableId::DiscreteAlarmType_ActiveState_TrueState),
            10588 => Ok(VariableId::DiscreteAlarmType_ActiveState_FalseState),
            10589 => Ok(VariableId::DiscreteAlarmType_SuppressedState),
            10590 => Ok(VariableId::DiscreteAlarmType_SuppressedState_Id),
            10591 => Ok(VariableId::DiscreteAlarmType_SuppressedState_Name),
            10592 => Ok(VariableId::DiscreteAlarmType_SuppressedState_Number),
            10593 => Ok(VariableId::DiscreteAlarmType_SuppressedState_EffectiveDisplayName),
            10594 => Ok(VariableId::DiscreteAlarmType_SuppressedState_TransitionTime),
            10595 => Ok(VariableId::DiscreteAlarmType_SuppressedState_EffectiveTransitionTime),
            10596 => Ok(VariableId::DiscreteAlarmType_SuppressedState_TrueState),
            10597 => Ok(VariableId::DiscreteAlarmType_SuppressedState_FalseState),
            10599 => Ok(VariableId::DiscreteAlarmType_ShelvingState_CurrentState),
            10600 => Ok(VariableId::DiscreteAlarmType_ShelvingState_CurrentState_Id),
            10601 => Ok(VariableId::DiscreteAlarmType_ShelvingState_CurrentState_Name),
            10602 => Ok(VariableId::DiscreteAlarmType_ShelvingState_CurrentState_Number),
            10603 => Ok(VariableId::DiscreteAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10604 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition),
            10605 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition_Id),
            10606 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition_Name),
            10607 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition_Number),
            10608 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition_TransitionTime),
            10609 => Ok(VariableId::DiscreteAlarmType_ShelvingState_UnshelveTime),
            10634 => Ok(VariableId::DiscreteAlarmType_ShelvingState_TimedShelve_InputArguments),
            10635 => Ok(VariableId::DiscreteAlarmType_SuppressedOrShelved),
            10636 => Ok(VariableId::DiscreteAlarmType_MaxTimeShelved),
            10638 => Ok(VariableId::OffNormalAlarmType_EventId),
            10639 => Ok(VariableId::OffNormalAlarmType_EventType),
            10640 => Ok(VariableId::OffNormalAlarmType_SourceNode),
            10641 => Ok(VariableId::OffNormalAlarmType_SourceName),
            10642 => Ok(VariableId::OffNormalAlarmType_Time),
            10643 => Ok(VariableId::OffNormalAlarmType_ReceiveTime),
            10644 => Ok(VariableId::OffNormalAlarmType_LocalTime),
            10645 => Ok(VariableId::OffNormalAlarmType_Message),
            10646 => Ok(VariableId::OffNormalAlarmType_Severity),
            10647 => Ok(VariableId::OffNormalAlarmType_ConditionName),
            10648 => Ok(VariableId::OffNormalAlarmType_BranchId),
            10649 => Ok(VariableId::OffNormalAlarmType_Retain),
            10650 => Ok(VariableId::OffNormalAlarmType_EnabledState),
            10651 => Ok(VariableId::OffNormalAlarmType_EnabledState_Id),
            10652 => Ok(VariableId::OffNormalAlarmType_EnabledState_Name),
            10653 => Ok(VariableId::OffNormalAlarmType_EnabledState_Number),
            10654 => Ok(VariableId::OffNormalAlarmType_EnabledState_EffectiveDisplayName),
            10655 => Ok(VariableId::OffNormalAlarmType_EnabledState_TransitionTime),
            10656 => Ok(VariableId::OffNormalAlarmType_EnabledState_EffectiveTransitionTime),
            10657 => Ok(VariableId::OffNormalAlarmType_EnabledState_TrueState),
            10658 => Ok(VariableId::OffNormalAlarmType_EnabledState_FalseState),
            10659 => Ok(VariableId::OffNormalAlarmType_Quality),
            10660 => Ok(VariableId::OffNormalAlarmType_Quality_SourceTimestamp),
            10661 => Ok(VariableId::OffNormalAlarmType_LastSeverity),
            10662 => Ok(VariableId::OffNormalAlarmType_LastSeverity_SourceTimestamp),
            10663 => Ok(VariableId::OffNormalAlarmType_Comment),
            10664 => Ok(VariableId::OffNormalAlarmType_Comment_SourceTimestamp),
            10665 => Ok(VariableId::OffNormalAlarmType_ClientUserId),
            10669 => Ok(VariableId::OffNormalAlarmType_AddComment_InputArguments),
            10671 => Ok(VariableId::OffNormalAlarmType_ConditionRefresh_InputArguments),
            10672 => Ok(VariableId::OffNormalAlarmType_AckedState),
            10673 => Ok(VariableId::OffNormalAlarmType_AckedState_Id),
            10674 => Ok(VariableId::OffNormalAlarmType_AckedState_Name),
            10675 => Ok(VariableId::OffNormalAlarmType_AckedState_Number),
            10676 => Ok(VariableId::OffNormalAlarmType_AckedState_EffectiveDisplayName),
            10677 => Ok(VariableId::OffNormalAlarmType_AckedState_TransitionTime),
            10678 => Ok(VariableId::OffNormalAlarmType_AckedState_EffectiveTransitionTime),
            10679 => Ok(VariableId::OffNormalAlarmType_AckedState_TrueState),
            10680 => Ok(VariableId::OffNormalAlarmType_AckedState_FalseState),
            10681 => Ok(VariableId::OffNormalAlarmType_ConfirmedState),
            10682 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_Id),
            10683 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_Name),
            10684 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_Number),
            10685 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_EffectiveDisplayName),
            10686 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_TransitionTime),
            10687 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_EffectiveTransitionTime),
            10688 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_TrueState),
            10689 => Ok(VariableId::OffNormalAlarmType_ConfirmedState_FalseState),
            10691 => Ok(VariableId::OffNormalAlarmType_Acknowledge_InputArguments),
            10693 => Ok(VariableId::OffNormalAlarmType_Confirm_InputArguments),
            10694 => Ok(VariableId::OffNormalAlarmType_ActiveState),
            10695 => Ok(VariableId::OffNormalAlarmType_ActiveState_Id),
            10696 => Ok(VariableId::OffNormalAlarmType_ActiveState_Name),
            10697 => Ok(VariableId::OffNormalAlarmType_ActiveState_Number),
            10698 => Ok(VariableId::OffNormalAlarmType_ActiveState_EffectiveDisplayName),
            10699 => Ok(VariableId::OffNormalAlarmType_ActiveState_TransitionTime),
            10700 => Ok(VariableId::OffNormalAlarmType_ActiveState_EffectiveTransitionTime),
            10701 => Ok(VariableId::OffNormalAlarmType_ActiveState_TrueState),
            10702 => Ok(VariableId::OffNormalAlarmType_ActiveState_FalseState),
            10703 => Ok(VariableId::OffNormalAlarmType_SuppressedState),
            10704 => Ok(VariableId::OffNormalAlarmType_SuppressedState_Id),
            10705 => Ok(VariableId::OffNormalAlarmType_SuppressedState_Name),
            10706 => Ok(VariableId::OffNormalAlarmType_SuppressedState_Number),
            10707 => Ok(VariableId::OffNormalAlarmType_SuppressedState_EffectiveDisplayName),
            10708 => Ok(VariableId::OffNormalAlarmType_SuppressedState_TransitionTime),
            10709 => Ok(VariableId::OffNormalAlarmType_SuppressedState_EffectiveTransitionTime),
            10710 => Ok(VariableId::OffNormalAlarmType_SuppressedState_TrueState),
            10711 => Ok(VariableId::OffNormalAlarmType_SuppressedState_FalseState),
            10713 => Ok(VariableId::OffNormalAlarmType_ShelvingState_CurrentState),
            10714 => Ok(VariableId::OffNormalAlarmType_ShelvingState_CurrentState_Id),
            10715 => Ok(VariableId::OffNormalAlarmType_ShelvingState_CurrentState_Name),
            10716 => Ok(VariableId::OffNormalAlarmType_ShelvingState_CurrentState_Number),
            10717 => Ok(VariableId::OffNormalAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10718 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition),
            10719 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition_Id),
            10720 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition_Name),
            10721 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition_Number),
            10722 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition_TransitionTime),
            10723 => Ok(VariableId::OffNormalAlarmType_ShelvingState_UnshelveTime),
            10748 => Ok(VariableId::OffNormalAlarmType_ShelvingState_TimedShelve_InputArguments),
            10749 => Ok(VariableId::OffNormalAlarmType_SuppressedOrShelved),
            10750 => Ok(VariableId::OffNormalAlarmType_MaxTimeShelved),
            10752 => Ok(VariableId::TripAlarmType_EventId),
            10753 => Ok(VariableId::TripAlarmType_EventType),
            10754 => Ok(VariableId::TripAlarmType_SourceNode),
            10755 => Ok(VariableId::TripAlarmType_SourceName),
            10756 => Ok(VariableId::TripAlarmType_Time),
            10757 => Ok(VariableId::TripAlarmType_ReceiveTime),
            10758 => Ok(VariableId::TripAlarmType_LocalTime),
            10759 => Ok(VariableId::TripAlarmType_Message),
            10760 => Ok(VariableId::TripAlarmType_Severity),
            10761 => Ok(VariableId::TripAlarmType_ConditionName),
            10762 => Ok(VariableId::TripAlarmType_BranchId),
            10763 => Ok(VariableId::TripAlarmType_Retain),
            10764 => Ok(VariableId::TripAlarmType_EnabledState),
            10765 => Ok(VariableId::TripAlarmType_EnabledState_Id),
            10766 => Ok(VariableId::TripAlarmType_EnabledState_Name),
            10767 => Ok(VariableId::TripAlarmType_EnabledState_Number),
            10768 => Ok(VariableId::TripAlarmType_EnabledState_EffectiveDisplayName),
            10769 => Ok(VariableId::TripAlarmType_EnabledState_TransitionTime),
            10770 => Ok(VariableId::TripAlarmType_EnabledState_EffectiveTransitionTime),
            10771 => Ok(VariableId::TripAlarmType_EnabledState_TrueState),
            10772 => Ok(VariableId::TripAlarmType_EnabledState_FalseState),
            10773 => Ok(VariableId::TripAlarmType_Quality),
            10774 => Ok(VariableId::TripAlarmType_Quality_SourceTimestamp),
            10775 => Ok(VariableId::TripAlarmType_LastSeverity),
            10776 => Ok(VariableId::TripAlarmType_LastSeverity_SourceTimestamp),
            10777 => Ok(VariableId::TripAlarmType_Comment),
            10778 => Ok(VariableId::TripAlarmType_Comment_SourceTimestamp),
            10779 => Ok(VariableId::TripAlarmType_ClientUserId),
            10783 => Ok(VariableId::TripAlarmType_AddComment_InputArguments),
            10785 => Ok(VariableId::TripAlarmType_ConditionRefresh_InputArguments),
            10786 => Ok(VariableId::TripAlarmType_AckedState),
            10787 => Ok(VariableId::TripAlarmType_AckedState_Id),
            10788 => Ok(VariableId::TripAlarmType_AckedState_Name),
            10789 => Ok(VariableId::TripAlarmType_AckedState_Number),
            10790 => Ok(VariableId::TripAlarmType_AckedState_EffectiveDisplayName),
            10791 => Ok(VariableId::TripAlarmType_AckedState_TransitionTime),
            10792 => Ok(VariableId::TripAlarmType_AckedState_EffectiveTransitionTime),
            10793 => Ok(VariableId::TripAlarmType_AckedState_TrueState),
            10794 => Ok(VariableId::TripAlarmType_AckedState_FalseState),
            10795 => Ok(VariableId::TripAlarmType_ConfirmedState),
            10796 => Ok(VariableId::TripAlarmType_ConfirmedState_Id),
            10797 => Ok(VariableId::TripAlarmType_ConfirmedState_Name),
            10798 => Ok(VariableId::TripAlarmType_ConfirmedState_Number),
            10799 => Ok(VariableId::TripAlarmType_ConfirmedState_EffectiveDisplayName),
            10800 => Ok(VariableId::TripAlarmType_ConfirmedState_TransitionTime),
            10801 => Ok(VariableId::TripAlarmType_ConfirmedState_EffectiveTransitionTime),
            10802 => Ok(VariableId::TripAlarmType_ConfirmedState_TrueState),
            10803 => Ok(VariableId::TripAlarmType_ConfirmedState_FalseState),
            10805 => Ok(VariableId::TripAlarmType_Acknowledge_InputArguments),
            10807 => Ok(VariableId::TripAlarmType_Confirm_InputArguments),
            10808 => Ok(VariableId::TripAlarmType_ActiveState),
            10809 => Ok(VariableId::TripAlarmType_ActiveState_Id),
            10810 => Ok(VariableId::TripAlarmType_ActiveState_Name),
            10811 => Ok(VariableId::TripAlarmType_ActiveState_Number),
            10812 => Ok(VariableId::TripAlarmType_ActiveState_EffectiveDisplayName),
            10813 => Ok(VariableId::TripAlarmType_ActiveState_TransitionTime),
            10814 => Ok(VariableId::TripAlarmType_ActiveState_EffectiveTransitionTime),
            10815 => Ok(VariableId::TripAlarmType_ActiveState_TrueState),
            10816 => Ok(VariableId::TripAlarmType_ActiveState_FalseState),
            10817 => Ok(VariableId::TripAlarmType_SuppressedState),
            10818 => Ok(VariableId::TripAlarmType_SuppressedState_Id),
            10819 => Ok(VariableId::TripAlarmType_SuppressedState_Name),
            10820 => Ok(VariableId::TripAlarmType_SuppressedState_Number),
            10821 => Ok(VariableId::TripAlarmType_SuppressedState_EffectiveDisplayName),
            10822 => Ok(VariableId::TripAlarmType_SuppressedState_TransitionTime),
            10823 => Ok(VariableId::TripAlarmType_SuppressedState_EffectiveTransitionTime),
            10824 => Ok(VariableId::TripAlarmType_SuppressedState_TrueState),
            10825 => Ok(VariableId::TripAlarmType_SuppressedState_FalseState),
            10827 => Ok(VariableId::TripAlarmType_ShelvingState_CurrentState),
            10828 => Ok(VariableId::TripAlarmType_ShelvingState_CurrentState_Id),
            10829 => Ok(VariableId::TripAlarmType_ShelvingState_CurrentState_Name),
            10830 => Ok(VariableId::TripAlarmType_ShelvingState_CurrentState_Number),
            10831 => Ok(VariableId::TripAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            10832 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition),
            10833 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition_Id),
            10834 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition_Name),
            10835 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition_Number),
            10836 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition_TransitionTime),
            10837 => Ok(VariableId::TripAlarmType_ShelvingState_UnshelveTime),
            10862 => Ok(VariableId::TripAlarmType_ShelvingState_TimedShelve_InputArguments),
            10863 => Ok(VariableId::TripAlarmType_SuppressedOrShelved),
            10864 => Ok(VariableId::TripAlarmType_MaxTimeShelved),
            11094 => Ok(VariableId::AuditConditionShelvingEventType_EventId),
            11095 => Ok(VariableId::AuditConditionShelvingEventType_EventType),
            11096 => Ok(VariableId::AuditConditionShelvingEventType_SourceNode),
            11097 => Ok(VariableId::AuditConditionShelvingEventType_SourceName),
            11098 => Ok(VariableId::AuditConditionShelvingEventType_Time),
            11099 => Ok(VariableId::AuditConditionShelvingEventType_ReceiveTime),
            11100 => Ok(VariableId::AuditConditionShelvingEventType_LocalTime),
            11101 => Ok(VariableId::AuditConditionShelvingEventType_Message),
            11102 => Ok(VariableId::AuditConditionShelvingEventType_Severity),
            11103 => Ok(VariableId::AuditConditionShelvingEventType_ActionTimeStamp),
            11104 => Ok(VariableId::AuditConditionShelvingEventType_Status),
            11105 => Ok(VariableId::AuditConditionShelvingEventType_ServerId),
            11106 => Ok(VariableId::AuditConditionShelvingEventType_ClientAuditEntryId),
            11107 => Ok(VariableId::AuditConditionShelvingEventType_ClientUserId),
            11108 => Ok(VariableId::AuditConditionShelvingEventType_MethodId),
            11109 => Ok(VariableId::AuditConditionShelvingEventType_InputArguments),
            11110 => Ok(VariableId::TwoStateVariableType_TrueState),
            11111 => Ok(VariableId::TwoStateVariableType_FalseState),
            11112 => Ok(VariableId::ConditionType_ConditionClassId),
            11113 => Ok(VariableId::ConditionType_ConditionClassName),
            11114 => Ok(VariableId::DialogConditionType_ConditionClassId),
            11115 => Ok(VariableId::DialogConditionType_ConditionClassName),
            11116 => Ok(VariableId::AcknowledgeableConditionType_ConditionClassId),
            11117 => Ok(VariableId::AcknowledgeableConditionType_ConditionClassName),
            11118 => Ok(VariableId::AlarmConditionType_ConditionClassId),
            11119 => Ok(VariableId::AlarmConditionType_ConditionClassName),
            11120 => Ok(VariableId::AlarmConditionType_InputNode),
            11121 => Ok(VariableId::LimitAlarmType_ConditionClassId),
            11122 => Ok(VariableId::LimitAlarmType_ConditionClassName),
            11123 => Ok(VariableId::LimitAlarmType_InputNode),
            11124 => Ok(VariableId::LimitAlarmType_HighHighLimit),
            11125 => Ok(VariableId::LimitAlarmType_HighLimit),
            11126 => Ok(VariableId::LimitAlarmType_LowLimit),
            11127 => Ok(VariableId::LimitAlarmType_LowLowLimit),
            11128 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionClassId),
            11129 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionClassName),
            11130 => Ok(VariableId::ExclusiveLimitAlarmType_InputNode),
            11131 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionClassId),
            11132 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionClassName),
            11133 => Ok(VariableId::ExclusiveLevelAlarmType_InputNode),
            11134 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionClassId),
            11135 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionClassName),
            11136 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_InputNode),
            11137 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionClassId),
            11138 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionClassName),
            11139 => Ok(VariableId::ExclusiveDeviationAlarmType_InputNode),
            11140 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionClassId),
            11141 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionClassName),
            11142 => Ok(VariableId::NonExclusiveLimitAlarmType_InputNode),
            11143 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionClassId),
            11144 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionClassName),
            11145 => Ok(VariableId::NonExclusiveLevelAlarmType_InputNode),
            11146 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionClassId),
            11147 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionClassName),
            11148 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_InputNode),
            11149 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionClassId),
            11150 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionClassName),
            11151 => Ok(VariableId::NonExclusiveDeviationAlarmType_InputNode),
            11152 => Ok(VariableId::DiscreteAlarmType_ConditionClassId),
            11153 => Ok(VariableId::DiscreteAlarmType_ConditionClassName),
            11154 => Ok(VariableId::DiscreteAlarmType_InputNode),
            11155 => Ok(VariableId::OffNormalAlarmType_ConditionClassId),
            11156 => Ok(VariableId::OffNormalAlarmType_ConditionClassName),
            11157 => Ok(VariableId::OffNormalAlarmType_InputNode),
            11158 => Ok(VariableId::OffNormalAlarmType_NormalState),
            11159 => Ok(VariableId::TripAlarmType_ConditionClassId),
            11160 => Ok(VariableId::TripAlarmType_ConditionClassName),
            11161 => Ok(VariableId::TripAlarmType_InputNode),
            11162 => Ok(VariableId::TripAlarmType_NormalState),
            11168 => Ok(VariableId::HistoricalDataConfigurationType_AggregateConfiguration_TreatUncertainAsBad),
            11169 => Ok(VariableId::HistoricalDataConfigurationType_AggregateConfiguration_PercentDataBad),
            11170 => Ok(VariableId::HistoricalDataConfigurationType_AggregateConfiguration_PercentDataGood),
            11171 => Ok(VariableId::HistoricalDataConfigurationType_AggregateConfiguration_UseSlopedExtrapolation),
            11188 => Ok(VariableId::AggregateConfigurationType_TreatUncertainAsBad),
            11189 => Ok(VariableId::AggregateConfigurationType_PercentDataBad),
            11190 => Ok(VariableId::AggregateConfigurationType_PercentDataGood),
            11191 => Ok(VariableId::AggregateConfigurationType_UseSlopedExtrapolation),
            11193 => Ok(VariableId::HistoryServerCapabilities_AccessHistoryDataCapability),
            11196 => Ok(VariableId::HistoryServerCapabilities_InsertDataCapability),
            11197 => Ok(VariableId::HistoryServerCapabilities_ReplaceDataCapability),
            11198 => Ok(VariableId::HistoryServerCapabilities_UpdateDataCapability),
            11199 => Ok(VariableId::HistoryServerCapabilities_DeleteRawCapability),
            11200 => Ok(VariableId::HistoryServerCapabilities_DeleteAtTimeCapability),
            11204 => Ok(VariableId::HAConfiguration_AggregateConfiguration_TreatUncertainAsBad),
            11205 => Ok(VariableId::HAConfiguration_AggregateConfiguration_PercentDataBad),
            11206 => Ok(VariableId::HAConfiguration_AggregateConfiguration_PercentDataGood),
            11207 => Ok(VariableId::HAConfiguration_AggregateConfiguration_UseSlopedExtrapolation),
            11208 => Ok(VariableId::HAConfiguration_Stepped),
            11209 => Ok(VariableId::HAConfiguration_Definition),
            11210 => Ok(VariableId::HAConfiguration_MaxTimeInterval),
            11211 => Ok(VariableId::HAConfiguration_MinTimeInterval),
            11212 => Ok(VariableId::HAConfiguration_ExceptionDeviation),
            11213 => Ok(VariableId::HAConfiguration_ExceptionDeviationFormat),
            11214 => Ok(VariableId::Annotations),
            11215 => Ok(VariableId::HistoricalEventFilter),
            11239 => Ok(VariableId::MultiStateValueDiscreteType_Definition),
            11240 => Ok(VariableId::MultiStateValueDiscreteType_ValuePrecision),
            11241 => Ok(VariableId::MultiStateValueDiscreteType_EnumValues),
            11242 => Ok(VariableId::HistoryServerCapabilities_AccessHistoryEventsCapability),
            11268 => Ok(VariableId::HistoryServerCapabilitiesType_MaxReturnDataValues),
            11269 => Ok(VariableId::HistoryServerCapabilitiesType_MaxReturnEventValues),
            11270 => Ok(VariableId::HistoryServerCapabilitiesType_InsertAnnotationCapability),
            11273 => Ok(VariableId::HistoryServerCapabilities_MaxReturnDataValues),
            11274 => Ok(VariableId::HistoryServerCapabilities_MaxReturnEventValues),
            11275 => Ok(VariableId::HistoryServerCapabilities_InsertAnnotationCapability),
            11278 => Ok(VariableId::HistoryServerCapabilitiesType_InsertEventCapability),
            11279 => Ok(VariableId::HistoryServerCapabilitiesType_ReplaceEventCapability),
            11280 => Ok(VariableId::HistoryServerCapabilitiesType_UpdateEventCapability),
            11281 => Ok(VariableId::HistoryServerCapabilities_InsertEventCapability),
            11282 => Ok(VariableId::HistoryServerCapabilities_ReplaceEventCapability),
            11283 => Ok(VariableId::HistoryServerCapabilities_UpdateEventCapability),
            11312 => Ok(VariableId::Server_ServerRedundancy_CurrentServerId),
            11313 => Ok(VariableId::Server_ServerRedundancy_RedundantServerArray),
            11314 => Ok(VariableId::Server_ServerRedundancy_ServerUriArray),
            11322 => Ok(VariableId::ShelvedStateMachineType_UnshelvedToTimedShelved_TransitionNumber),
            11323 => Ok(VariableId::ShelvedStateMachineType_UnshelvedToOneShotShelved_TransitionNumber),
            11324 => Ok(VariableId::ShelvedStateMachineType_TimedShelvedToUnshelved_TransitionNumber),
            11325 => Ok(VariableId::ShelvedStateMachineType_TimedShelvedToOneShotShelved_TransitionNumber),
            11326 => Ok(VariableId::ShelvedStateMachineType_OneShotShelvedToUnshelved_TransitionNumber),
            11327 => Ok(VariableId::ShelvedStateMachineType_OneShotShelvedToTimedShelved_TransitionNumber),
            11340 => Ok(VariableId::ExclusiveLimitStateMachineType_LowLowToLow_TransitionNumber),
            11341 => Ok(VariableId::ExclusiveLimitStateMachineType_LowToLowLow_TransitionNumber),
            11342 => Ok(VariableId::ExclusiveLimitStateMachineType_HighHighToHigh_TransitionNumber),
            11343 => Ok(VariableId::ExclusiveLimitStateMachineType_HighToHighHigh_TransitionNumber),
            11432 => Ok(VariableId::EnumStrings),
            11433 => Ok(VariableId::ValueAsText),
            11437 => Ok(VariableId::ProgressEventType_EventId),
            11438 => Ok(VariableId::ProgressEventType_EventType),
            11439 => Ok(VariableId::ProgressEventType_SourceNode),
            11440 => Ok(VariableId::ProgressEventType_SourceName),
            11441 => Ok(VariableId::ProgressEventType_Time),
            11442 => Ok(VariableId::ProgressEventType_ReceiveTime),
            11443 => Ok(VariableId::ProgressEventType_LocalTime),
            11444 => Ok(VariableId::ProgressEventType_Message),
            11445 => Ok(VariableId::ProgressEventType_Severity),
            11447 => Ok(VariableId::SystemStatusChangeEventType_EventId),
            11448 => Ok(VariableId::SystemStatusChangeEventType_EventType),
            11449 => Ok(VariableId::SystemStatusChangeEventType_SourceNode),
            11450 => Ok(VariableId::SystemStatusChangeEventType_SourceName),
            11451 => Ok(VariableId::SystemStatusChangeEventType_Time),
            11452 => Ok(VariableId::SystemStatusChangeEventType_ReceiveTime),
            11453 => Ok(VariableId::SystemStatusChangeEventType_LocalTime),
            11454 => Ok(VariableId::SystemStatusChangeEventType_Message),
            11455 => Ok(VariableId::SystemStatusChangeEventType_Severity),
            11456 => Ok(VariableId::TransitionVariableType_EffectiveTransitionTime),
            11457 => Ok(VariableId::FiniteTransitionVariableType_EffectiveTransitionTime),
            11458 => Ok(VariableId::StateMachineType_LastTransition_EffectiveTransitionTime),
            11459 => Ok(VariableId::FiniteStateMachineType_LastTransition_EffectiveTransitionTime),
            11460 => Ok(VariableId::TransitionEventType_Transition_EffectiveTransitionTime),
            11461 => Ok(VariableId::MultiStateValueDiscreteType_ValueAsText),
            11462 => Ok(VariableId::ProgramTransitionEventType_Transition_EffectiveTransitionTime),
            11463 => Ok(VariableId::ProgramTransitionAuditEventType_Transition_EffectiveTransitionTime),
            11464 => Ok(VariableId::ProgramStateMachineType_LastTransition_EffectiveTransitionTime),
            11465 => Ok(VariableId::ShelvedStateMachineType_LastTransition_EffectiveTransitionTime),
            11466 => Ok(VariableId::AlarmConditionType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11467 => Ok(VariableId::LimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11468 => Ok(VariableId::ExclusiveLimitStateMachineType_LastTransition_EffectiveTransitionTime),
            11469 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11470 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_LastTransition_EffectiveTransitionTime),
            11471 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11472 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_LastTransition_EffectiveTransitionTime),
            11473 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11474 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_LastTransition_EffectiveTransitionTime),
            11475 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11476 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_LastTransition_EffectiveTransitionTime),
            11477 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11478 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11479 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11480 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11481 => Ok(VariableId::DiscreteAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11482 => Ok(VariableId::OffNormalAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11483 => Ok(VariableId::TripAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11485 => Ok(VariableId::AuditActivateSessionEventType_SecureChannelId),
            11488 => Ok(VariableId::OptionSetType_OptionSetValues),
            11490 => Ok(VariableId::ServerType_GetMonitoredItems_InputArguments),
            11491 => Ok(VariableId::ServerType_GetMonitoredItems_OutputArguments),
            11493 => Ok(VariableId::Server_GetMonitoredItems_InputArguments),
            11494 => Ok(VariableId::Server_GetMonitoredItems_OutputArguments),
            11496 => Ok(VariableId::GetMonitoredItemsMethodType_InputArguments),
            11497 => Ok(VariableId::GetMonitoredItemsMethodType_OutputArguments),
            11498 => Ok(VariableId::MaxStringLength),
            11499 => Ok(VariableId::HistoricalDataConfigurationType_StartOfArchive),
            11500 => Ok(VariableId::HistoricalDataConfigurationType_StartOfOnlineArchive),
            11501 => Ok(VariableId::HistoryServerCapabilitiesType_DeleteEventCapability),
            11502 => Ok(VariableId::HistoryServerCapabilities_DeleteEventCapability),
            11503 => Ok(VariableId::HAConfiguration_StartOfArchive),
            11504 => Ok(VariableId::HAConfiguration_StartOfOnlineArchive),
            11509 => Ok(VariableId::ModellingRule_OptionalPlaceholder_NamingRule),
            11511 => Ok(VariableId::ModellingRule_MandatoryPlaceholder_NamingRule),
            11512 => Ok(VariableId::MaxArrayLength),
            11513 => Ok(VariableId::EngineeringUnits),
            11514 => Ok(VariableId::ServerType_ServerCapabilities_MaxArrayLength),
            11515 => Ok(VariableId::ServerType_ServerCapabilities_MaxStringLength),
            11517 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerRead),
            11519 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerWrite),
            11521 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall),
            11522 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerBrowse),
            11523 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes),
            11524 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds),
            11525 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement),
            11526 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall),
            11549 => Ok(VariableId::ServerCapabilitiesType_MaxArrayLength),
            11550 => Ok(VariableId::ServerCapabilitiesType_MaxStringLength),
            11552 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerRead),
            11554 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerWrite),
            11556 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerMethodCall),
            11557 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerBrowse),
            11558 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerRegisterNodes),
            11559 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds),
            11560 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerNodeManagement),
            11561 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxMonitoredItemsPerCall),
            11562 => Ok(VariableId::ServerCapabilitiesType_VendorCapability_Placeholder),
            11565 => Ok(VariableId::OperationLimitsType_MaxNodesPerRead),
            11567 => Ok(VariableId::OperationLimitsType_MaxNodesPerWrite),
            11569 => Ok(VariableId::OperationLimitsType_MaxNodesPerMethodCall),
            11570 => Ok(VariableId::OperationLimitsType_MaxNodesPerBrowse),
            11571 => Ok(VariableId::OperationLimitsType_MaxNodesPerRegisterNodes),
            11572 => Ok(VariableId::OperationLimitsType_MaxNodesPerTranslateBrowsePathsToNodeIds),
            11573 => Ok(VariableId::OperationLimitsType_MaxNodesPerNodeManagement),
            11574 => Ok(VariableId::OperationLimitsType_MaxMonitoredItemsPerCall),
            11576 => Ok(VariableId::FileType_Size),
            11579 => Ok(VariableId::FileType_OpenCount),
            11581 => Ok(VariableId::FileType_Open_InputArguments),
            11582 => Ok(VariableId::FileType_Open_OutputArguments),
            11584 => Ok(VariableId::FileType_Close_InputArguments),
            11586 => Ok(VariableId::FileType_Read_InputArguments),
            11587 => Ok(VariableId::FileType_Read_OutputArguments),
            11589 => Ok(VariableId::FileType_Write_InputArguments),
            11591 => Ok(VariableId::FileType_GetPosition_InputArguments),
            11592 => Ok(VariableId::FileType_GetPosition_OutputArguments),
            11594 => Ok(VariableId::FileType_SetPosition_InputArguments),
            11596 => Ok(VariableId::AddressSpaceFileType_Size),
            11599 => Ok(VariableId::AddressSpaceFileType_OpenCount),
            11601 => Ok(VariableId::AddressSpaceFileType_Open_InputArguments),
            11602 => Ok(VariableId::AddressSpaceFileType_Open_OutputArguments),
            11604 => Ok(VariableId::AddressSpaceFileType_Close_InputArguments),
            11606 => Ok(VariableId::AddressSpaceFileType_Read_InputArguments),
            11607 => Ok(VariableId::AddressSpaceFileType_Read_OutputArguments),
            11609 => Ok(VariableId::AddressSpaceFileType_Write_InputArguments),
            11611 => Ok(VariableId::AddressSpaceFileType_GetPosition_InputArguments),
            11612 => Ok(VariableId::AddressSpaceFileType_GetPosition_OutputArguments),
            11614 => Ok(VariableId::AddressSpaceFileType_SetPosition_InputArguments),
            11617 => Ok(VariableId::NamespaceMetadataType_NamespaceUri),
            11618 => Ok(VariableId::NamespaceMetadataType_NamespaceVersion),
            11619 => Ok(VariableId::NamespaceMetadataType_NamespacePublicationDate),
            11620 => Ok(VariableId::NamespaceMetadataType_IsNamespaceSubset),
            11621 => Ok(VariableId::NamespaceMetadataType_StaticNodeIdTypes),
            11622 => Ok(VariableId::NamespaceMetadataType_StaticNumericNodeIdRange),
            11623 => Ok(VariableId::NamespaceMetadataType_StaticStringNodeIdPattern),
            11625 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Size),
            11628 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_OpenCount),
            11630 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Open_InputArguments),
            11631 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Open_OutputArguments),
            11633 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Close_InputArguments),
            11635 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Read_InputArguments),
            11636 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Read_OutputArguments),
            11638 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Write_InputArguments),
            11640 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_GetPosition_InputArguments),
            11641 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_GetPosition_OutputArguments),
            11643 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_SetPosition_InputArguments),
            11647 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceUri),
            11648 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceVersion),
            11649 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespacePublicationDate),
            11650 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_IsNamespaceSubset),
            11651 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_StaticNodeIdTypes),
            11652 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_StaticNumericNodeIdRange),
            11653 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_StaticStringNodeIdPattern),
            11655 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Size),
            11658 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_OpenCount),
            11660 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open_InputArguments),
            11661 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open_OutputArguments),
            11663 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Close_InputArguments),
            11665 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read_InputArguments),
            11666 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read_OutputArguments),
            11668 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Write_InputArguments),
            11670 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition_InputArguments),
            11671 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition_OutputArguments),
            11673 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_SetPosition_InputArguments),
            11696 => Ok(VariableId::SystemStatusChangeEventType_SystemState),
            11697 => Ok(VariableId::SamplingIntervalDiagnosticsType_SampledMonitoredItemsCount),
            11698 => Ok(VariableId::SamplingIntervalDiagnosticsType_MaxSampledMonitoredItemsCount),
            11699 => Ok(VariableId::SamplingIntervalDiagnosticsType_DisabledMonitoredItemsSamplingCount),
            11701 => Ok(VariableId::OptionSetType_BitMask),
            11702 => Ok(VariableId::Server_ServerCapabilities_MaxArrayLength),
            11703 => Ok(VariableId::Server_ServerCapabilities_MaxStringLength),
            11705 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerRead),
            11707 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerWrite),
            11709 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerMethodCall),
            11710 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerBrowse),
            11711 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerRegisterNodes),
            11712 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerTranslateBrowsePathsToNodeIds),
            11713 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerNodeManagement),
            11714 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxMonitoredItemsPerCall),
            11739 => Ok(VariableId::OpenMethodType_InputArguments),
            11740 => Ok(VariableId::OpenMethodType_OutputArguments),
            11742 => Ok(VariableId::CloseMethodType_InputArguments),
            11744 => Ok(VariableId::ReadMethodType_InputArguments),
            11745 => Ok(VariableId::ReadMethodType_OutputArguments),
            11747 => Ok(VariableId::WriteMethodType_InputArguments),
            11749 => Ok(VariableId::GetPositionMethodType_InputArguments),
            11750 => Ok(VariableId::GetPositionMethodType_OutputArguments),
            11752 => Ok(VariableId::SetPositionMethodType_InputArguments),
            11754 => Ok(VariableId::SystemOffNormalAlarmType_EventId),
            11755 => Ok(VariableId::SystemOffNormalAlarmType_EventType),
            11756 => Ok(VariableId::SystemOffNormalAlarmType_SourceNode),
            11757 => Ok(VariableId::SystemOffNormalAlarmType_SourceName),
            11758 => Ok(VariableId::SystemOffNormalAlarmType_Time),
            11759 => Ok(VariableId::SystemOffNormalAlarmType_ReceiveTime),
            11760 => Ok(VariableId::SystemOffNormalAlarmType_LocalTime),
            11761 => Ok(VariableId::SystemOffNormalAlarmType_Message),
            11762 => Ok(VariableId::SystemOffNormalAlarmType_Severity),
            11763 => Ok(VariableId::SystemOffNormalAlarmType_ConditionClassId),
            11764 => Ok(VariableId::SystemOffNormalAlarmType_ConditionClassName),
            11765 => Ok(VariableId::SystemOffNormalAlarmType_ConditionName),
            11766 => Ok(VariableId::SystemOffNormalAlarmType_BranchId),
            11767 => Ok(VariableId::SystemOffNormalAlarmType_Retain),
            11768 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState),
            11769 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_Id),
            11770 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_Name),
            11771 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_Number),
            11772 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_EffectiveDisplayName),
            11773 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_TransitionTime),
            11774 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_EffectiveTransitionTime),
            11775 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_TrueState),
            11776 => Ok(VariableId::SystemOffNormalAlarmType_EnabledState_FalseState),
            11777 => Ok(VariableId::SystemOffNormalAlarmType_Quality),
            11778 => Ok(VariableId::SystemOffNormalAlarmType_Quality_SourceTimestamp),
            11779 => Ok(VariableId::SystemOffNormalAlarmType_LastSeverity),
            11780 => Ok(VariableId::SystemOffNormalAlarmType_LastSeverity_SourceTimestamp),
            11781 => Ok(VariableId::SystemOffNormalAlarmType_Comment),
            11782 => Ok(VariableId::SystemOffNormalAlarmType_Comment_SourceTimestamp),
            11783 => Ok(VariableId::SystemOffNormalAlarmType_ClientUserId),
            11787 => Ok(VariableId::SystemOffNormalAlarmType_AddComment_InputArguments),
            11789 => Ok(VariableId::SystemOffNormalAlarmType_ConditionRefresh_InputArguments),
            11790 => Ok(VariableId::SystemOffNormalAlarmType_AckedState),
            11791 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_Id),
            11792 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_Name),
            11793 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_Number),
            11794 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_EffectiveDisplayName),
            11795 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_TransitionTime),
            11796 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_EffectiveTransitionTime),
            11797 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_TrueState),
            11798 => Ok(VariableId::SystemOffNormalAlarmType_AckedState_FalseState),
            11799 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState),
            11800 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_Id),
            11801 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_Name),
            11802 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_Number),
            11803 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_EffectiveDisplayName),
            11804 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_TransitionTime),
            11805 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_EffectiveTransitionTime),
            11806 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_TrueState),
            11807 => Ok(VariableId::SystemOffNormalAlarmType_ConfirmedState_FalseState),
            11809 => Ok(VariableId::SystemOffNormalAlarmType_Acknowledge_InputArguments),
            11811 => Ok(VariableId::SystemOffNormalAlarmType_Confirm_InputArguments),
            11812 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState),
            11813 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_Id),
            11814 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_Name),
            11815 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_Number),
            11816 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_EffectiveDisplayName),
            11817 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_TransitionTime),
            11818 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_EffectiveTransitionTime),
            11819 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_TrueState),
            11820 => Ok(VariableId::SystemOffNormalAlarmType_ActiveState_FalseState),
            11821 => Ok(VariableId::SystemOffNormalAlarmType_InputNode),
            11822 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState),
            11823 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_Id),
            11824 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_Name),
            11825 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_Number),
            11826 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_EffectiveDisplayName),
            11827 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_TransitionTime),
            11828 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_EffectiveTransitionTime),
            11829 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_TrueState),
            11830 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedState_FalseState),
            11832 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_CurrentState),
            11833 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_CurrentState_Id),
            11834 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_CurrentState_Name),
            11835 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_CurrentState_Number),
            11836 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            11837 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition),
            11838 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition_Id),
            11839 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition_Name),
            11840 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition_Number),
            11841 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition_TransitionTime),
            11842 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            11843 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_UnshelveTime),
            11847 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_TimedShelve_InputArguments),
            11848 => Ok(VariableId::SystemOffNormalAlarmType_SuppressedOrShelved),
            11849 => Ok(VariableId::SystemOffNormalAlarmType_MaxTimeShelved),
            11850 => Ok(VariableId::SystemOffNormalAlarmType_NormalState),
            11851 => Ok(VariableId::AuditConditionCommentEventType_Comment),
            11852 => Ok(VariableId::AuditConditionRespondEventType_SelectedResponse),
            11853 => Ok(VariableId::AuditConditionAcknowledgeEventType_Comment),
            11854 => Ok(VariableId::AuditConditionConfirmEventType_Comment),
            11855 => Ok(VariableId::AuditConditionShelvingEventType_ShelvingTime),
            11857 => Ok(VariableId::AuditProgramTransitionEventType_EventId),
            11858 => Ok(VariableId::AuditProgramTransitionEventType_EventType),
            11859 => Ok(VariableId::AuditProgramTransitionEventType_SourceNode),
            11860 => Ok(VariableId::AuditProgramTransitionEventType_SourceName),
            11861 => Ok(VariableId::AuditProgramTransitionEventType_Time),
            11862 => Ok(VariableId::AuditProgramTransitionEventType_ReceiveTime),
            11863 => Ok(VariableId::AuditProgramTransitionEventType_LocalTime),
            11864 => Ok(VariableId::AuditProgramTransitionEventType_Message),
            11865 => Ok(VariableId::AuditProgramTransitionEventType_Severity),
            11866 => Ok(VariableId::AuditProgramTransitionEventType_ActionTimeStamp),
            11867 => Ok(VariableId::AuditProgramTransitionEventType_Status),
            11868 => Ok(VariableId::AuditProgramTransitionEventType_ServerId),
            11869 => Ok(VariableId::AuditProgramTransitionEventType_ClientAuditEntryId),
            11870 => Ok(VariableId::AuditProgramTransitionEventType_ClientUserId),
            11871 => Ok(VariableId::AuditProgramTransitionEventType_MethodId),
            11872 => Ok(VariableId::AuditProgramTransitionEventType_InputArguments),
            11873 => Ok(VariableId::AuditProgramTransitionEventType_OldStateId),
            11874 => Ok(VariableId::AuditProgramTransitionEventType_NewStateId),
            11875 => Ok(VariableId::AuditProgramTransitionEventType_TransitionNumber),
            11878 => Ok(VariableId::NodeClass_EnumValues),
            11881 => Ok(VariableId::NodeAttributesMask_EnumValues),
            11883 => Ok(VariableId::BrowseResultMask_EnumValues),
            11884 => Ok(VariableId::HistoryUpdateType_EnumValues),
            11885 => Ok(VariableId::PerformUpdateType_EnumValues),
            11891 => Ok(VariableId::SessionDiagnosticsObjectType_SessionDiagnostics_UnauthorizedRequestCount),
            11892 => Ok(VariableId::SessionDiagnosticsVariableType_UnauthorizedRequestCount),
            11940 => Ok(VariableId::OpenFileMode_EnumValues),
            11942 => Ok(VariableId::ModelChangeStructureVerbMask_EnumValues),
            11946 => Ok(VariableId::NonTransparentNetworkRedundancyType_RedundancySupport),
            11947 => Ok(VariableId::NonTransparentNetworkRedundancyType_ServerUriArray),
            11948 => Ok(VariableId::NonTransparentNetworkRedundancyType_ServerNetworkGroups),
            11959 => Ok(VariableId::OpcUa_BinarySchema_EndpointUrlListDataType),
            11960 => Ok(VariableId::OpcUa_BinarySchema_EndpointUrlListDataType_DataTypeVersion),
            11961 => Ok(VariableId::OpcUa_BinarySchema_EndpointUrlListDataType_DictionaryFragment),
            11962 => Ok(VariableId::OpcUa_BinarySchema_NetworkGroupDataType),
            11963 => Ok(VariableId::OpcUa_BinarySchema_NetworkGroupDataType_DataTypeVersion),
            11964 => Ok(VariableId::OpcUa_BinarySchema_NetworkGroupDataType_DictionaryFragment),
            12022 => Ok(VariableId::ArrayItemType_Definition),
            12023 => Ok(VariableId::ArrayItemType_ValuePrecision),
            12024 => Ok(VariableId::ArrayItemType_InstrumentRange),
            12025 => Ok(VariableId::ArrayItemType_EURange),
            12026 => Ok(VariableId::ArrayItemType_EngineeringUnits),
            12027 => Ok(VariableId::ArrayItemType_Title),
            12028 => Ok(VariableId::ArrayItemType_AxisScaleType),
            12030 => Ok(VariableId::YArrayItemType_Definition),
            12031 => Ok(VariableId::YArrayItemType_ValuePrecision),
            12032 => Ok(VariableId::YArrayItemType_InstrumentRange),
            12033 => Ok(VariableId::YArrayItemType_EURange),
            12034 => Ok(VariableId::YArrayItemType_EngineeringUnits),
            12035 => Ok(VariableId::YArrayItemType_Title),
            12036 => Ok(VariableId::YArrayItemType_AxisScaleType),
            12037 => Ok(VariableId::YArrayItemType_XAxisDefinition),
            12039 => Ok(VariableId::XYArrayItemType_Definition),
            12040 => Ok(VariableId::XYArrayItemType_ValuePrecision),
            12041 => Ok(VariableId::XYArrayItemType_InstrumentRange),
            12042 => Ok(VariableId::XYArrayItemType_EURange),
            12043 => Ok(VariableId::XYArrayItemType_EngineeringUnits),
            12044 => Ok(VariableId::XYArrayItemType_Title),
            12045 => Ok(VariableId::XYArrayItemType_AxisScaleType),
            12046 => Ok(VariableId::XYArrayItemType_XAxisDefinition),
            12048 => Ok(VariableId::ImageItemType_Definition),
            12049 => Ok(VariableId::ImageItemType_ValuePrecision),
            12050 => Ok(VariableId::ImageItemType_InstrumentRange),
            12051 => Ok(VariableId::ImageItemType_EURange),
            12052 => Ok(VariableId::ImageItemType_EngineeringUnits),
            12053 => Ok(VariableId::ImageItemType_Title),
            12054 => Ok(VariableId::ImageItemType_AxisScaleType),
            12055 => Ok(VariableId::ImageItemType_XAxisDefinition),
            12056 => Ok(VariableId::ImageItemType_YAxisDefinition),
            12058 => Ok(VariableId::CubeItemType_Definition),
            12059 => Ok(VariableId::CubeItemType_ValuePrecision),
            12060 => Ok(VariableId::CubeItemType_InstrumentRange),
            12061 => Ok(VariableId::CubeItemType_EURange),
            12062 => Ok(VariableId::CubeItemType_EngineeringUnits),
            12063 => Ok(VariableId::CubeItemType_Title),
            12064 => Ok(VariableId::CubeItemType_AxisScaleType),
            12065 => Ok(VariableId::CubeItemType_XAxisDefinition),
            12066 => Ok(VariableId::CubeItemType_YAxisDefinition),
            12067 => Ok(VariableId::CubeItemType_ZAxisDefinition),
            12069 => Ok(VariableId::NDimensionArrayItemType_Definition),
            12070 => Ok(VariableId::NDimensionArrayItemType_ValuePrecision),
            12071 => Ok(VariableId::NDimensionArrayItemType_InstrumentRange),
            12072 => Ok(VariableId::NDimensionArrayItemType_EURange),
            12073 => Ok(VariableId::NDimensionArrayItemType_EngineeringUnits),
            12074 => Ok(VariableId::NDimensionArrayItemType_Title),
            12075 => Ok(VariableId::NDimensionArrayItemType_AxisScaleType),
            12076 => Ok(VariableId::NDimensionArrayItemType_AxisDefinition),
            12078 => Ok(VariableId::AxisScaleEnumeration_EnumStrings),
            12091 => Ok(VariableId::OpcUa_BinarySchema_AxisInformation),
            12092 => Ok(VariableId::OpcUa_BinarySchema_AxisInformation_DataTypeVersion),
            12093 => Ok(VariableId::OpcUa_BinarySchema_AxisInformation_DictionaryFragment),
            12094 => Ok(VariableId::OpcUa_BinarySchema_XVType),
            12095 => Ok(VariableId::OpcUa_BinarySchema_XVType_DataTypeVersion),
            12096 => Ok(VariableId::OpcUa_BinarySchema_XVType_DictionaryFragment),
            12098 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics),
            12099 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SessionId),
            12100 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SessionName),
            12101 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientDescription),
            12102 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ServerUri),
            12103 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_EndpointUrl),
            12104 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_LocaleIds),
            12105 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ActualSessionTimeout),
            12106 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_MaxResponseMessageSize),
            12107 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientConnectionTime),
            12108 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ClientLastContactTime),
            12109 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentSubscriptionsCount),
            12110 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentMonitoredItemsCount),
            12111 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CurrentPublishRequestsInQueue),
            12112 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TotalRequestCount),
            12113 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_UnauthorizedRequestCount),
            12114 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ReadCount),
            12115 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_HistoryReadCount),
            12116 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_WriteCount),
            12117 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_HistoryUpdateCount),
            12118 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CallCount),
            12119 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CreateMonitoredItemsCount),
            12120 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ModifyMonitoredItemsCount),
            12121 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetMonitoringModeCount),
            12122 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetTriggeringCount),
            12123 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteMonitoredItemsCount),
            12124 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_CreateSubscriptionCount),
            12125 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_ModifySubscriptionCount),
            12126 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_SetPublishingModeCount),
            12127 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_PublishCount),
            12128 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_RepublishCount),
            12129 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TransferSubscriptionsCount),
            12130 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteSubscriptionsCount),
            12131 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_AddNodesCount),
            12132 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_AddReferencesCount),
            12133 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteNodesCount),
            12134 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_DeleteReferencesCount),
            12135 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_BrowseCount),
            12136 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_BrowseNextCount),
            12137 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount),
            12138 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_QueryFirstCount),
            12139 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_QueryNextCount),
            12140 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_RegisterNodesCount),
            12141 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionDiagnostics_UnregisterNodesCount),
            12142 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics),
            12143 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SessionId),
            12144 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientUserIdOfSession),
            12145 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientUserIdHistory),
            12146 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_AuthenticationMechanism),
            12147 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_Encoding),
            12148 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_TransportProtocol),
            12149 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SecurityMode),
            12150 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_SecurityPolicyUri),
            12151 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SessionSecurityDiagnostics_ClientCertificate),
            12152 => Ok(VariableId::SessionsDiagnosticsSummaryType_ClientName_Placeholder_SubscriptionDiagnosticsArray),
            12153 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData),
            12154 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents),
            12155 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData),
            12156 => Ok(VariableId::ServerType_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents),
            12157 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryReadData),
            12158 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryReadEvents),
            12159 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryUpdateData),
            12160 => Ok(VariableId::ServerCapabilitiesType_OperationLimits_MaxNodesPerHistoryUpdateEvents),
            12161 => Ok(VariableId::OperationLimitsType_MaxNodesPerHistoryReadData),
            12162 => Ok(VariableId::OperationLimitsType_MaxNodesPerHistoryReadEvents),
            12163 => Ok(VariableId::OperationLimitsType_MaxNodesPerHistoryUpdateData),
            12164 => Ok(VariableId::OperationLimitsType_MaxNodesPerHistoryUpdateEvents),
            12165 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadData),
            12166 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryReadEvents),
            12167 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateData),
            12168 => Ok(VariableId::Server_ServerCapabilities_OperationLimits_MaxNodesPerHistoryUpdateEvents),
            12169 => Ok(VariableId::NamingRuleType_EnumValues),
            12170 => Ok(VariableId::ViewVersion),
            12183 => Ok(VariableId::OpcUa_BinarySchema_ComplexNumberType),
            12184 => Ok(VariableId::OpcUa_BinarySchema_ComplexNumberType_DataTypeVersion),
            12185 => Ok(VariableId::OpcUa_BinarySchema_ComplexNumberType_DictionaryFragment),
            12186 => Ok(VariableId::OpcUa_BinarySchema_DoubleComplexNumberType),
            12187 => Ok(VariableId::OpcUa_BinarySchema_DoubleComplexNumberType_DataTypeVersion),
            12188 => Ok(VariableId::OpcUa_BinarySchema_DoubleComplexNumberType_DictionaryFragment),
            12213 => Ok(VariableId::OpcUa_BinarySchema_ServerOnNetwork),
            12214 => Ok(VariableId::OpcUa_BinarySchema_ServerOnNetwork_DataTypeVersion),
            12215 => Ok(VariableId::OpcUa_BinarySchema_ServerOnNetwork_DictionaryFragment),
            12502 => Ok(VariableId::ProgressEventType_Context),
            12503 => Ok(VariableId::ProgressEventType_Progress),
            12514 => Ok(VariableId::OpenWithMasksMethodType_InputArguments),
            12515 => Ok(VariableId::OpenWithMasksMethodType_OutputArguments),
            12517 => Ok(VariableId::CloseAndUpdateMethodType_OutputArguments),
            12519 => Ok(VariableId::AddCertificateMethodType_InputArguments),
            12521 => Ok(VariableId::RemoveCertificateMethodType_InputArguments),
            12523 => Ok(VariableId::TrustListType_Size),
            12526 => Ok(VariableId::TrustListType_OpenCount),
            12528 => Ok(VariableId::TrustListType_Open_InputArguments),
            12529 => Ok(VariableId::TrustListType_Open_OutputArguments),
            12531 => Ok(VariableId::TrustListType_Close_InputArguments),
            12533 => Ok(VariableId::TrustListType_Read_InputArguments),
            12534 => Ok(VariableId::TrustListType_Read_OutputArguments),
            12536 => Ok(VariableId::TrustListType_Write_InputArguments),
            12538 => Ok(VariableId::TrustListType_GetPosition_InputArguments),
            12539 => Ok(VariableId::TrustListType_GetPosition_OutputArguments),
            12541 => Ok(VariableId::TrustListType_SetPosition_InputArguments),
            12542 => Ok(VariableId::TrustListType_LastUpdateTime),
            12544 => Ok(VariableId::TrustListType_OpenWithMasks_InputArguments),
            12545 => Ok(VariableId::TrustListType_OpenWithMasks_OutputArguments),
            12547 => Ok(VariableId::TrustListType_CloseAndUpdate_OutputArguments),
            12549 => Ok(VariableId::TrustListType_AddCertificate_InputArguments),
            12551 => Ok(VariableId::TrustListType_RemoveCertificate_InputArguments),
            12553 => Ok(VariableId::TrustListMasks_EnumValues),
            12562 => Ok(VariableId::TrustListUpdatedAuditEventType_EventId),
            12563 => Ok(VariableId::TrustListUpdatedAuditEventType_EventType),
            12564 => Ok(VariableId::TrustListUpdatedAuditEventType_SourceNode),
            12565 => Ok(VariableId::TrustListUpdatedAuditEventType_SourceName),
            12566 => Ok(VariableId::TrustListUpdatedAuditEventType_Time),
            12567 => Ok(VariableId::TrustListUpdatedAuditEventType_ReceiveTime),
            12568 => Ok(VariableId::TrustListUpdatedAuditEventType_LocalTime),
            12569 => Ok(VariableId::TrustListUpdatedAuditEventType_Message),
            12570 => Ok(VariableId::TrustListUpdatedAuditEventType_Severity),
            12571 => Ok(VariableId::TrustListUpdatedAuditEventType_ActionTimeStamp),
            12572 => Ok(VariableId::TrustListUpdatedAuditEventType_Status),
            12573 => Ok(VariableId::TrustListUpdatedAuditEventType_ServerId),
            12574 => Ok(VariableId::TrustListUpdatedAuditEventType_ClientAuditEntryId),
            12575 => Ok(VariableId::TrustListUpdatedAuditEventType_ClientUserId),
            12576 => Ok(VariableId::TrustListUpdatedAuditEventType_MethodId),
            12577 => Ok(VariableId::TrustListUpdatedAuditEventType_InputArguments),
            12579 => Ok(VariableId::UpdateCertificateMethodType_InputArguments),
            12580 => Ok(VariableId::UpdateCertificateMethodType_OutputArguments),
            12583 => Ok(VariableId::ServerConfigurationType_SupportedPrivateKeyFormats),
            12584 => Ok(VariableId::ServerConfigurationType_MaxTrustListSize),
            12585 => Ok(VariableId::ServerConfigurationType_MulticastDnsEnabled),
            12617 => Ok(VariableId::ServerConfigurationType_UpdateCertificate_InputArguments),
            12618 => Ok(VariableId::ServerConfigurationType_UpdateCertificate_OutputArguments),
            12621 => Ok(VariableId::CertificateUpdatedAuditEventType_EventId),
            12622 => Ok(VariableId::CertificateUpdatedAuditEventType_EventType),
            12623 => Ok(VariableId::CertificateUpdatedAuditEventType_SourceNode),
            12624 => Ok(VariableId::CertificateUpdatedAuditEventType_SourceName),
            12625 => Ok(VariableId::CertificateUpdatedAuditEventType_Time),
            12626 => Ok(VariableId::CertificateUpdatedAuditEventType_ReceiveTime),
            12627 => Ok(VariableId::CertificateUpdatedAuditEventType_LocalTime),
            12628 => Ok(VariableId::CertificateUpdatedAuditEventType_Message),
            12629 => Ok(VariableId::CertificateUpdatedAuditEventType_Severity),
            12630 => Ok(VariableId::CertificateUpdatedAuditEventType_ActionTimeStamp),
            12631 => Ok(VariableId::CertificateUpdatedAuditEventType_Status),
            12632 => Ok(VariableId::CertificateUpdatedAuditEventType_ServerId),
            12633 => Ok(VariableId::CertificateUpdatedAuditEventType_ClientAuditEntryId),
            12634 => Ok(VariableId::CertificateUpdatedAuditEventType_ClientUserId),
            12635 => Ok(VariableId::CertificateUpdatedAuditEventType_MethodId),
            12636 => Ok(VariableId::CertificateUpdatedAuditEventType_InputArguments),
            12639 => Ok(VariableId::ServerConfiguration_SupportedPrivateKeyFormats),
            12640 => Ok(VariableId::ServerConfiguration_MaxTrustListSize),
            12641 => Ok(VariableId::ServerConfiguration_MulticastDnsEnabled),
            12643 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Size),
            12646 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount),
            12648 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments),
            12649 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments),
            12651 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments),
            12653 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments),
            12654 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments),
            12656 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments),
            12658 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments),
            12659 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments),
            12661 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments),
            12662 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime),
            12664 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments),
            12665 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments),
            12667 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments),
            12669 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments),
            12671 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments),
            12681 => Ok(VariableId::OpcUa_BinarySchema_TrustListDataType),
            12682 => Ok(VariableId::OpcUa_BinarySchema_TrustListDataType_DataTypeVersion),
            12683 => Ok(VariableId::OpcUa_BinarySchema_TrustListDataType_DictionaryFragment),
            12686 => Ok(VariableId::FileType_Writable),
            12687 => Ok(VariableId::FileType_UserWritable),
            12688 => Ok(VariableId::AddressSpaceFileType_Writable),
            12689 => Ok(VariableId::AddressSpaceFileType_UserWritable),
            12690 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_Writable),
            12691 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_UserWritable),
            12692 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Writable),
            12693 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_UserWritable),
            12698 => Ok(VariableId::TrustListType_Writable),
            12699 => Ok(VariableId::TrustListType_UserWritable),
            12704 => Ok(VariableId::CloseAndUpdateMethodType_InputArguments),
            12705 => Ok(VariableId::TrustListType_CloseAndUpdate_InputArguments),
            12708 => Ok(VariableId::ServerConfigurationType_ServerCapabilities),
            12710 => Ok(VariableId::ServerConfiguration_ServerCapabilities),
            12718 => Ok(VariableId::OpcUa_BinarySchema_RelativePathElement),
            12719 => Ok(VariableId::OpcUa_BinarySchema_RelativePathElement_DataTypeVersion),
            12720 => Ok(VariableId::OpcUa_BinarySchema_RelativePathElement_DictionaryFragment),
            12721 => Ok(VariableId::OpcUa_BinarySchema_RelativePath),
            12722 => Ok(VariableId::OpcUa_BinarySchema_RelativePath_DataTypeVersion),
            12723 => Ok(VariableId::OpcUa_BinarySchema_RelativePath_DictionaryFragment),
            12732 => Ok(VariableId::ServerConfigurationType_CreateSigningRequest_InputArguments),
            12733 => Ok(VariableId::ServerConfigurationType_CreateSigningRequest_OutputArguments),
            12738 => Ok(VariableId::ServerConfiguration_CreateSigningRequest_InputArguments),
            12739 => Ok(VariableId::ServerConfiguration_CreateSigningRequest_OutputArguments),
            12742 => Ok(VariableId::CreateSigningRequestMethodType_InputArguments),
            12743 => Ok(VariableId::CreateSigningRequestMethodType_OutputArguments),
            12745 => Ok(VariableId::OptionSetValues),
            12747 => Ok(VariableId::ServerType_SetSubscriptionDurable_InputArguments),
            12748 => Ok(VariableId::ServerType_SetSubscriptionDurable_OutputArguments),
            12750 => Ok(VariableId::Server_SetSubscriptionDurable_InputArguments),
            12751 => Ok(VariableId::Server_SetSubscriptionDurable_OutputArguments),
            12753 => Ok(VariableId::SetSubscriptionDurableMethodType_InputArguments),
            12754 => Ok(VariableId::SetSubscriptionDurableMethodType_OutputArguments),
            12767 => Ok(VariableId::OpcUa_BinarySchema_OptionSet),
            12768 => Ok(VariableId::OpcUa_BinarySchema_OptionSet_DataTypeVersion),
            12769 => Ok(VariableId::OpcUa_BinarySchema_OptionSet_DictionaryFragment),
            12770 => Ok(VariableId::OpcUa_BinarySchema_Union),
            12771 => Ok(VariableId::OpcUa_BinarySchema_Union_DataTypeVersion),
            12772 => Ok(VariableId::OpcUa_BinarySchema_Union_DictionaryFragment),
            12774 => Ok(VariableId::GetRejectedListMethodType_OutputArguments),
            12776 => Ok(VariableId::ServerConfigurationType_GetRejectedList_OutputArguments),
            12778 => Ok(VariableId::ServerConfiguration_GetRejectedList_OutputArguments),
            12779 => Ok(VariableId::SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics),
            12780 => Ok(VariableId::SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_SamplingInterval),
            12781 => Ok(VariableId::SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_SampledMonitoredItemsCount),
            12782 => Ok(VariableId::SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_MaxSampledMonitoredItemsCount),
            12783 => Ok(VariableId::SamplingIntervalDiagnosticsArrayType_SamplingIntervalDiagnostics_DisabledMonitoredItemsSamplingCount),
            12784 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics),
            12785 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_SessionId),
            12786 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_SubscriptionId),
            12787 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_Priority),
            12788 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishingInterval),
            12789 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxKeepAliveCount),
            12790 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxLifetimeCount),
            12791 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MaxNotificationsPerPublish),
            12792 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishingEnabled),
            12793 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_ModifyCount),
            12794 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EnableCount),
            12795 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DisableCount),
            12796 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishRequestCount),
            12797 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishMessageRequestCount),
            12798 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_RepublishMessageCount),
            12799 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferRequestCount),
            12800 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferredToAltClientCount),
            12801 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_TransferredToSameClientCount),
            12802 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_PublishRequestCount),
            12803 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DataChangeNotificationsCount),
            12804 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EventNotificationsCount),
            12805 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_NotificationsCount),
            12806 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_LatePublishRequestCount),
            12807 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_CurrentKeepAliveCount),
            12808 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_CurrentLifetimeCount),
            12809 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_UnacknowledgedMessageCount),
            12810 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DiscardedMessageCount),
            12811 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MonitoredItemCount),
            12812 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_DisabledMonitoredItemCount),
            12813 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_MonitoringQueueOverflowCount),
            12814 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_NextSequenceNumber),
            12815 => Ok(VariableId::SubscriptionDiagnosticsArrayType_SubscriptionDiagnostics_EventQueueOverflowCount),
            12816 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics),
            12817 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_SessionId),
            12818 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_SessionName),
            12819 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ClientDescription),
            12820 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ServerUri),
            12821 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_EndpointUrl),
            12822 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_LocaleIds),
            12823 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ActualSessionTimeout),
            12824 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_MaxResponseMessageSize),
            12825 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ClientConnectionTime),
            12826 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ClientLastContactTime),
            12827 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CurrentSubscriptionsCount),
            12828 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CurrentMonitoredItemsCount),
            12829 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CurrentPublishRequestsInQueue),
            12830 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_TotalRequestCount),
            12831 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_UnauthorizedRequestCount),
            12832 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ReadCount),
            12833 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_HistoryReadCount),
            12834 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_WriteCount),
            12835 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_HistoryUpdateCount),
            12836 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CallCount),
            12837 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CreateMonitoredItemsCount),
            12838 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ModifyMonitoredItemsCount),
            12839 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_SetMonitoringModeCount),
            12840 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_SetTriggeringCount),
            12841 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_DeleteMonitoredItemsCount),
            12842 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_CreateSubscriptionCount),
            12843 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_ModifySubscriptionCount),
            12844 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_SetPublishingModeCount),
            12845 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_PublishCount),
            12846 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_RepublishCount),
            12847 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_TransferSubscriptionsCount),
            12848 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_DeleteSubscriptionsCount),
            12849 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_AddNodesCount),
            12850 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_AddReferencesCount),
            12851 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_DeleteNodesCount),
            12852 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_DeleteReferencesCount),
            12853 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_BrowseCount),
            12854 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_BrowseNextCount),
            12855 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_TranslateBrowsePathsToNodeIdsCount),
            12856 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_QueryFirstCount),
            12857 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_QueryNextCount),
            12858 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_RegisterNodesCount),
            12859 => Ok(VariableId::SessionDiagnosticsArrayType_SessionDiagnostics_UnregisterNodesCount),
            12860 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics),
            12861 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SessionId),
            12862 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdOfSession),
            12863 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientUserIdHistory),
            12864 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_AuthenticationMechanism),
            12865 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_Encoding),
            12866 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_TransportProtocol),
            12867 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityMode),
            12868 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_SecurityPolicyUri),
            12869 => Ok(VariableId::SessionSecurityDiagnosticsArrayType_SessionSecurityDiagnostics_ClientCertificate),
            12872 => Ok(VariableId::ServerType_ResendData_InputArguments),
            12874 => Ok(VariableId::Server_ResendData_InputArguments),
            12876 => Ok(VariableId::ResendDataMethodType_InputArguments),
            12882 => Ok(VariableId::ServerType_EstimatedReturnTime),
            12884 => Ok(VariableId::ServerType_RequestServerStateChange_InputArguments),
            12885 => Ok(VariableId::Server_EstimatedReturnTime),
            12887 => Ok(VariableId::Server_RequestServerStateChange_InputArguments),
            12889 => Ok(VariableId::RequestServerStateChangeMethodType_InputArguments),
            12902 => Ok(VariableId::OpcUa_BinarySchema_DiscoveryConfiguration),
            12903 => Ok(VariableId::OpcUa_BinarySchema_DiscoveryConfiguration_DataTypeVersion),
            12904 => Ok(VariableId::OpcUa_BinarySchema_DiscoveryConfiguration_DictionaryFragment),
            12905 => Ok(VariableId::OpcUa_BinarySchema_MdnsDiscoveryConfiguration),
            12906 => Ok(VariableId::OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DataTypeVersion),
            12907 => Ok(VariableId::OpcUa_BinarySchema_MdnsDiscoveryConfiguration_DictionaryFragment),
            12908 => Ok(VariableId::MaxByteStringLength),
            12909 => Ok(VariableId::ServerType_ServerCapabilities_MaxByteStringLength),
            12910 => Ok(VariableId::ServerCapabilitiesType_MaxByteStringLength),
            12911 => Ok(VariableId::Server_ServerCapabilities_MaxByteStringLength),
            12913 => Ok(VariableId::ConditionType_ConditionRefresh2_InputArguments),
            12915 => Ok(VariableId::ConditionRefresh2MethodType_InputArguments),
            12917 => Ok(VariableId::DialogConditionType_ConditionRefresh2_InputArguments),
            12919 => Ok(VariableId::AcknowledgeableConditionType_ConditionRefresh2_InputArguments),
            12985 => Ok(VariableId::AlarmConditionType_ConditionRefresh2_InputArguments),
            12987 => Ok(VariableId::LimitAlarmType_ConditionRefresh2_InputArguments),
            12989 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionRefresh2_InputArguments),
            12991 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionRefresh2_InputArguments),
            12993 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionRefresh2_InputArguments),
            12995 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionRefresh2_InputArguments),
            12997 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionRefresh2_InputArguments),
            12999 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionRefresh2_InputArguments),
            13001 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionRefresh2_InputArguments),
            13003 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionRefresh2_InputArguments),
            13005 => Ok(VariableId::DiscreteAlarmType_ConditionRefresh2_InputArguments),
            13007 => Ok(VariableId::OffNormalAlarmType_ConditionRefresh2_InputArguments),
            13009 => Ok(VariableId::SystemOffNormalAlarmType_ConditionRefresh2_InputArguments),
            13011 => Ok(VariableId::TripAlarmType_ConditionRefresh2_InputArguments),
            13226 => Ok(VariableId::CertificateExpirationAlarmType_EventId),
            13227 => Ok(VariableId::CertificateExpirationAlarmType_EventType),
            13228 => Ok(VariableId::CertificateExpirationAlarmType_SourceNode),
            13229 => Ok(VariableId::CertificateExpirationAlarmType_SourceName),
            13230 => Ok(VariableId::CertificateExpirationAlarmType_Time),
            13231 => Ok(VariableId::CertificateExpirationAlarmType_ReceiveTime),
            13232 => Ok(VariableId::CertificateExpirationAlarmType_LocalTime),
            13233 => Ok(VariableId::CertificateExpirationAlarmType_Message),
            13234 => Ok(VariableId::CertificateExpirationAlarmType_Severity),
            13235 => Ok(VariableId::CertificateExpirationAlarmType_ConditionClassId),
            13236 => Ok(VariableId::CertificateExpirationAlarmType_ConditionClassName),
            13237 => Ok(VariableId::CertificateExpirationAlarmType_ConditionName),
            13238 => Ok(VariableId::CertificateExpirationAlarmType_BranchId),
            13239 => Ok(VariableId::CertificateExpirationAlarmType_Retain),
            13240 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState),
            13241 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_Id),
            13242 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_Name),
            13243 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_Number),
            13244 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_EffectiveDisplayName),
            13245 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_TransitionTime),
            13246 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_EffectiveTransitionTime),
            13247 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_TrueState),
            13248 => Ok(VariableId::CertificateExpirationAlarmType_EnabledState_FalseState),
            13249 => Ok(VariableId::CertificateExpirationAlarmType_Quality),
            13250 => Ok(VariableId::CertificateExpirationAlarmType_Quality_SourceTimestamp),
            13251 => Ok(VariableId::CertificateExpirationAlarmType_LastSeverity),
            13252 => Ok(VariableId::CertificateExpirationAlarmType_LastSeverity_SourceTimestamp),
            13253 => Ok(VariableId::CertificateExpirationAlarmType_Comment),
            13254 => Ok(VariableId::CertificateExpirationAlarmType_Comment_SourceTimestamp),
            13255 => Ok(VariableId::CertificateExpirationAlarmType_ClientUserId),
            13259 => Ok(VariableId::CertificateExpirationAlarmType_AddComment_InputArguments),
            13261 => Ok(VariableId::CertificateExpirationAlarmType_ConditionRefresh_InputArguments),
            13263 => Ok(VariableId::CertificateExpirationAlarmType_ConditionRefresh2_InputArguments),
            13264 => Ok(VariableId::CertificateExpirationAlarmType_AckedState),
            13265 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_Id),
            13266 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_Name),
            13267 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_Number),
            13268 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_EffectiveDisplayName),
            13269 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_TransitionTime),
            13270 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_EffectiveTransitionTime),
            13271 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_TrueState),
            13272 => Ok(VariableId::CertificateExpirationAlarmType_AckedState_FalseState),
            13273 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState),
            13274 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_Id),
            13275 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_Name),
            13276 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_Number),
            13277 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_EffectiveDisplayName),
            13278 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_TransitionTime),
            13279 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_EffectiveTransitionTime),
            13280 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_TrueState),
            13281 => Ok(VariableId::CertificateExpirationAlarmType_ConfirmedState_FalseState),
            13283 => Ok(VariableId::CertificateExpirationAlarmType_Acknowledge_InputArguments),
            13285 => Ok(VariableId::CertificateExpirationAlarmType_Confirm_InputArguments),
            13286 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState),
            13287 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_Id),
            13288 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_Name),
            13289 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_Number),
            13290 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_EffectiveDisplayName),
            13291 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_TransitionTime),
            13292 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_EffectiveTransitionTime),
            13293 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_TrueState),
            13294 => Ok(VariableId::CertificateExpirationAlarmType_ActiveState_FalseState),
            13295 => Ok(VariableId::CertificateExpirationAlarmType_InputNode),
            13296 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState),
            13297 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_Id),
            13298 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_Name),
            13299 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_Number),
            13300 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_EffectiveDisplayName),
            13301 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_TransitionTime),
            13302 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_EffectiveTransitionTime),
            13303 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_TrueState),
            13304 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedState_FalseState),
            13306 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_CurrentState),
            13307 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_CurrentState_Id),
            13308 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_CurrentState_Name),
            13309 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_CurrentState_Number),
            13310 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            13311 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition),
            13312 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition_Id),
            13313 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition_Name),
            13314 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition_Number),
            13315 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition_TransitionTime),
            13316 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            13317 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_UnshelveTime),
            13321 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_TimedShelve_InputArguments),
            13322 => Ok(VariableId::CertificateExpirationAlarmType_SuppressedOrShelved),
            13323 => Ok(VariableId::CertificateExpirationAlarmType_MaxTimeShelved),
            13324 => Ok(VariableId::CertificateExpirationAlarmType_NormalState),
            13325 => Ok(VariableId::CertificateExpirationAlarmType_ExpirationDate),
            13326 => Ok(VariableId::CertificateExpirationAlarmType_CertificateType),
            13327 => Ok(VariableId::CertificateExpirationAlarmType_Certificate),
            13341 => Ok(VariableId::FileType_MimeType),
            13343 => Ok(VariableId::CreateDirectoryMethodType_InputArguments),
            13344 => Ok(VariableId::CreateDirectoryMethodType_OutputArguments),
            13346 => Ok(VariableId::CreateFileMethodType_InputArguments),
            13347 => Ok(VariableId::CreateFileMethodType_OutputArguments),
            13349 => Ok(VariableId::DeleteFileMethodType_InputArguments),
            13351 => Ok(VariableId::MoveOrCopyMethodType_InputArguments),
            13352 => Ok(VariableId::MoveOrCopyMethodType_OutputArguments),
            13356 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory_InputArguments),
            13357 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory_OutputArguments),
            13359 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_CreateFile_InputArguments),
            13360 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_CreateFile_OutputArguments),
            13364 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy_InputArguments),
            13365 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy_OutputArguments),
            13367 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Size),
            13368 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Writable),
            13369 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_UserWritable),
            13370 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_OpenCount),
            13371 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_MimeType),
            13373 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Open_InputArguments),
            13374 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Open_OutputArguments),
            13376 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Close_InputArguments),
            13378 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Read_InputArguments),
            13379 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Read_OutputArguments),
            13381 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_Write_InputArguments),
            13383 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_GetPosition_InputArguments),
            13384 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_GetPosition_OutputArguments),
            13386 => Ok(VariableId::FileDirectoryType_FileName_Placeholder_SetPosition_InputArguments),
            13388 => Ok(VariableId::FileDirectoryType_CreateDirectory_InputArguments),
            13389 => Ok(VariableId::FileDirectoryType_CreateDirectory_OutputArguments),
            13391 => Ok(VariableId::FileDirectoryType_CreateFile_InputArguments),
            13392 => Ok(VariableId::FileDirectoryType_CreateFile_OutputArguments),
            13394 => Ok(VariableId::FileDirectoryType_DeleteFileSystemObject_InputArguments),
            13396 => Ok(VariableId::FileDirectoryType_MoveOrCopy_InputArguments),
            13397 => Ok(VariableId::FileDirectoryType_MoveOrCopy_OutputArguments),
            13398 => Ok(VariableId::AddressSpaceFileType_MimeType),
            13399 => Ok(VariableId::NamespaceMetadataType_NamespaceFile_MimeType),
            13400 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_MimeType),
            13403 => Ok(VariableId::TrustListType_MimeType),
            13600 => Ok(VariableId::CertificateGroupType_TrustList_Size),
            13601 => Ok(VariableId::CertificateGroupType_TrustList_Writable),
            13602 => Ok(VariableId::CertificateGroupType_TrustList_UserWritable),
            13603 => Ok(VariableId::CertificateGroupType_TrustList_OpenCount),
            13604 => Ok(VariableId::CertificateGroupType_TrustList_MimeType),
            13606 => Ok(VariableId::CertificateGroupType_TrustList_Open_InputArguments),
            13607 => Ok(VariableId::CertificateGroupType_TrustList_Open_OutputArguments),
            13609 => Ok(VariableId::CertificateGroupType_TrustList_Close_InputArguments),
            13611 => Ok(VariableId::CertificateGroupType_TrustList_Read_InputArguments),
            13612 => Ok(VariableId::CertificateGroupType_TrustList_Read_OutputArguments),
            13614 => Ok(VariableId::CertificateGroupType_TrustList_Write_InputArguments),
            13616 => Ok(VariableId::CertificateGroupType_TrustList_GetPosition_InputArguments),
            13617 => Ok(VariableId::CertificateGroupType_TrustList_GetPosition_OutputArguments),
            13619 => Ok(VariableId::CertificateGroupType_TrustList_SetPosition_InputArguments),
            13620 => Ok(VariableId::CertificateGroupType_TrustList_LastUpdateTime),
            13622 => Ok(VariableId::CertificateGroupType_TrustList_OpenWithMasks_InputArguments),
            13623 => Ok(VariableId::CertificateGroupType_TrustList_OpenWithMasks_OutputArguments),
            13625 => Ok(VariableId::CertificateGroupType_TrustList_CloseAndUpdate_InputArguments),
            13626 => Ok(VariableId::CertificateGroupType_TrustList_CloseAndUpdate_OutputArguments),
            13628 => Ok(VariableId::CertificateGroupType_TrustList_AddCertificate_InputArguments),
            13630 => Ok(VariableId::CertificateGroupType_TrustList_RemoveCertificate_InputArguments),
            13631 => Ok(VariableId::CertificateGroupType_CertificateTypes),
            13735 => Ok(VariableId::CertificateUpdatedAuditEventType_CertificateGroup),
            13736 => Ok(VariableId::CertificateUpdatedAuditEventType_CertificateType),
            13738 => Ok(VariableId::ServerConfiguration_UpdateCertificate_InputArguments),
            13739 => Ok(VariableId::ServerConfiguration_UpdateCertificate_OutputArguments),
            13816 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Size),
            13817 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Writable),
            13818 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_UserWritable),
            13819 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenCount),
            13820 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_MimeType),
            13822 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open_InputArguments),
            13823 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open_OutputArguments),
            13825 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close_InputArguments),
            13827 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read_InputArguments),
            13828 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read_OutputArguments),
            13830 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write_InputArguments),
            13832 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition_InputArguments),
            13833 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments),
            13835 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition_InputArguments),
            13836 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_LastUpdateTime),
            13838 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments),
            13839 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments),
            13841 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments),
            13842 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments),
            13844 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments),
            13846 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments),
            13847 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateTypes),
            13850 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Size),
            13851 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Writable),
            13852 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_UserWritable),
            13853 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenCount),
            13854 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_MimeType),
            13856 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open_InputArguments),
            13857 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open_OutputArguments),
            13859 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close_InputArguments),
            13861 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read_InputArguments),
            13862 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read_OutputArguments),
            13864 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write_InputArguments),
            13866 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition_InputArguments),
            13867 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments),
            13869 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition_InputArguments),
            13870 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_LastUpdateTime),
            13872 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments),
            13873 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments),
            13875 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments),
            13876 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments),
            13878 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments),
            13880 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments),
            13881 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateTypes),
            13884 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Size),
            13885 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Writable),
            13886 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_UserWritable),
            13887 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenCount),
            13888 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_MimeType),
            13890 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open_InputArguments),
            13891 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open_OutputArguments),
            13893 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close_InputArguments),
            13895 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read_InputArguments),
            13896 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read_OutputArguments),
            13898 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write_InputArguments),
            13900 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments),
            13901 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments),
            13903 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments),
            13904 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_LastUpdateTime),
            13906 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments),
            13907 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments),
            13909 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments),
            13910 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments),
            13912 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments),
            13914 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments),
            13915 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateTypes),
            13918 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Size),
            13919 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Writable),
            13920 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_UserWritable),
            13921 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenCount),
            13922 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_MimeType),
            13924 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open_InputArguments),
            13925 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open_OutputArguments),
            13927 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Close_InputArguments),
            13929 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read_InputArguments),
            13930 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read_OutputArguments),
            13932 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Write_InputArguments),
            13934 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition_InputArguments),
            13935 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition_OutputArguments),
            13937 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_SetPosition_InputArguments),
            13938 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_LastUpdateTime),
            13940 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks_InputArguments),
            13941 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks_OutputArguments),
            13943 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate_InputArguments),
            13944 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate_OutputArguments),
            13946 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_AddCertificate_InputArguments),
            13948 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_RemoveCertificate_InputArguments),
            13949 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateTypes),
            13953 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Size),
            13954 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Writable),
            13955 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable),
            13956 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenCount),
            13957 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType),
            13959 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open_InputArguments),
            13960 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open_OutputArguments),
            13962 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close_InputArguments),
            13964 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read_InputArguments),
            13965 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read_OutputArguments),
            13967 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write_InputArguments),
            13969 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_InputArguments),
            13970 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition_OutputArguments),
            13972 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition_InputArguments),
            13973 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_LastUpdateTime),
            13975 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_InputArguments),
            13976 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks_OutputArguments),
            13978 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments),
            13979 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_OutputArguments),
            13981 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate_InputArguments),
            13983 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate_InputArguments),
            13984 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateTypes),
            13987 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Size),
            13988 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Writable),
            13989 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable),
            13990 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount),
            13991 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType),
            13993 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments),
            13994 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments),
            13996 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments),
            13998 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments),
            13999 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments),
            14001 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments),
            14003 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments),
            14004 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments),
            14006 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments),
            14007 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime),
            14009 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments),
            14010 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments),
            14012 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments),
            14013 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments),
            14015 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments),
            14017 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments),
            14018 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateTypes),
            14021 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Size),
            14022 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable),
            14023 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable),
            14024 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount),
            14025 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType),
            14027 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments),
            14028 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments),
            14030 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments),
            14032 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments),
            14033 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments),
            14035 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments),
            14037 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments),
            14038 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments),
            14040 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments),
            14041 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime),
            14043 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments),
            14044 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments),
            14046 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments),
            14047 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments),
            14049 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments),
            14051 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments),
            14052 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateTypes),
            14090 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Size),
            14091 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Writable),
            14092 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UserWritable),
            14093 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenCount),
            14094 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_MimeType),
            14096 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_InputArguments),
            14097 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open_OutputArguments),
            14099 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close_InputArguments),
            14101 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_InputArguments),
            14102 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read_OutputArguments),
            14104 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write_InputArguments),
            14106 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_InputArguments),
            14107 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition_OutputArguments),
            14109 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition_InputArguments),
            14110 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_LastUpdateTime),
            14112 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_InputArguments),
            14113 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks_OutputArguments),
            14115 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_InputArguments),
            14116 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate_OutputArguments),
            14118 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate_InputArguments),
            14120 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate_InputArguments),
            14121 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateTypes),
            14124 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Size),
            14125 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Writable),
            14126 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UserWritable),
            14127 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenCount),
            14128 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_MimeType),
            14130 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_InputArguments),
            14131 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open_OutputArguments),
            14133 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close_InputArguments),
            14135 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_InputArguments),
            14136 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read_OutputArguments),
            14138 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write_InputArguments),
            14140 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_InputArguments),
            14141 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition_OutputArguments),
            14143 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition_InputArguments),
            14144 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_LastUpdateTime),
            14146 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_InputArguments),
            14147 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks_OutputArguments),
            14149 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_InputArguments),
            14150 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate_OutputArguments),
            14152 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate_InputArguments),
            14154 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate_InputArguments),
            14155 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateTypes),
            14157 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Writable),
            14158 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UserWritable),
            14159 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_MimeType),
            14160 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate_InputArguments),
            14161 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateTypes),
            14184 => Ok(VariableId::RemoveConnectionMethodType_InputArguments),
            14226 => Ok(VariableId::PubSubConnectionType_RemoveGroup_InputArguments),
            14324 => Ok(VariableId::OpcUa_BinarySchema_PublishedVariableDataType),
            14325 => Ok(VariableId::OpcUa_BinarySchema_PublishedVariableDataType_DataTypeVersion),
            14326 => Ok(VariableId::OpcUa_BinarySchema_PublishedVariableDataType_DictionaryFragment),
            14413 => Ok(VariableId::AuditCreateSessionEventType_SessionId),
            14414 => Ok(VariableId::AuditUrlMismatchEventType_SessionId),
            14415 => Ok(VariableId::Server_ServerRedundancy_ServerNetworkGroups),
            14418 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_PublisherId),
            14420 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Status_State),
            14425 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_RemoveGroup_InputArguments),
            14433 => Ok(VariableId::PublishSubscribeType_RemoveConnection_InputArguments),
            14436 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItems_InputArguments),
            14437 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItems_OutputArguments),
            14439 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedEvents_InputArguments),
            14440 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedEvents_OutputArguments),
            14442 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet_InputArguments),
            14480 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems_InputArguments),
            14481 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems_OutputArguments),
            14483 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents_InputArguments),
            14484 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents_OutputArguments),
            14486 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_RemovePublishedDataSet_InputArguments),
            14489 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_ConfigurationVersion),
            14494 => Ok(VariableId::DataSetFolderType_AddPublishedDataItems_InputArguments),
            14495 => Ok(VariableId::DataSetFolderType_AddPublishedDataItems_OutputArguments),
            14497 => Ok(VariableId::DataSetFolderType_AddPublishedEvents_InputArguments),
            14498 => Ok(VariableId::DataSetFolderType_AddPublishedEvents_OutputArguments),
            14500 => Ok(VariableId::DataSetFolderType_RemovePublishedDataSet_InputArguments),
            14502 => Ok(VariableId::AddPublishedDataItemsMethodType_InputArguments),
            14503 => Ok(VariableId::AddPublishedDataItemsMethodType_OutputArguments),
            14505 => Ok(VariableId::AddPublishedEventsMethodType_InputArguments),
            14506 => Ok(VariableId::AddPublishedEventsMethodType_OutputArguments),
            14508 => Ok(VariableId::RemovePublishedDataSetMethodType_InputArguments),
            14519 => Ok(VariableId::PublishedDataSetType_ConfigurationVersion),
            14528 => Ok(VariableId::StructureType_EnumStrings),
            14544 => Ok(VariableId::PublishedDataItemsType_ConfigurationVersion),
            14548 => Ok(VariableId::PublishedDataItemsType_PublishedData),
            14556 => Ok(VariableId::PublishedDataItemsType_AddVariables_InputArguments),
            14557 => Ok(VariableId::PublishedDataItemsType_AddVariables_OutputArguments),
            14559 => Ok(VariableId::PublishedDataItemsType_RemoveVariables_InputArguments),
            14560 => Ok(VariableId::PublishedDataItemsType_RemoveVariables_OutputArguments),
            14565 => Ok(VariableId::PublishedDataItemsAddVariablesMethodType_InputArguments),
            14566 => Ok(VariableId::PublishedDataItemsAddVariablesMethodType_OutputArguments),
            14568 => Ok(VariableId::PublishedDataItemsRemoveVariablesMethodType_InputArguments),
            14569 => Ok(VariableId::PublishedDataItemsRemoveVariablesMethodType_OutputArguments),
            14582 => Ok(VariableId::PublishedEventsType_ConfigurationVersion),
            14586 => Ok(VariableId::PublishedEventsType_PubSubEventNotifier),
            14587 => Ok(VariableId::PublishedEventsType_SelectedFields),
            14588 => Ok(VariableId::PublishedEventsType_Filter),
            14595 => Ok(VariableId::PubSubConnectionType_PublisherId),
            14601 => Ok(VariableId::PubSubConnectionType_Status_State),
            14605 => Ok(VariableId::PubSubConnectionTypeRemoveGroupMethodType_InputArguments),
            14624 => Ok(VariableId::PubSubGroupTypeRemoveWriterMethodType_InputArguments),
            14626 => Ok(VariableId::PubSubGroupTypeRemoveReaderMethodType_InputArguments),
            14644 => Ok(VariableId::PubSubStatusType_State),
            14648 => Ok(VariableId::PubSubState_EnumStrings),
            14849 => Ok(VariableId::OpcUa_BinarySchema_DataSetMetaDataType),
            14850 => Ok(VariableId::OpcUa_BinarySchema_DataSetMetaDataType_DataTypeVersion),
            14851 => Ok(VariableId::OpcUa_BinarySchema_DataSetMetaDataType_DictionaryFragment),
            14852 => Ok(VariableId::OpcUa_BinarySchema_FieldMetaData),
            14853 => Ok(VariableId::OpcUa_BinarySchema_FieldMetaData_DataTypeVersion),
            14854 => Ok(VariableId::OpcUa_BinarySchema_FieldMetaData_DictionaryFragment),
            14855 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDescription),
            14856 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDescription_DataTypeVersion),
            14857 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDescription_DictionaryFragment),
            14870 => Ok(VariableId::OpcUa_BinarySchema_EnumField),
            14871 => Ok(VariableId::OpcUa_BinarySchema_EnumField_DataTypeVersion),
            14872 => Ok(VariableId::OpcUa_BinarySchema_EnumField_DictionaryFragment),
            14873 => Ok(VariableId::OpcUa_BinarySchema_KeyValuePair),
            14874 => Ok(VariableId::OpcUa_BinarySchema_KeyValuePair_DataTypeVersion),
            14875 => Ok(VariableId::OpcUa_BinarySchema_KeyValuePair_DictionaryFragment),
            14876 => Ok(VariableId::OpcUa_BinarySchema_ConfigurationVersionDataType),
            14877 => Ok(VariableId::OpcUa_BinarySchema_ConfigurationVersionDataType_DataTypeVersion),
            14878 => Ok(VariableId::OpcUa_BinarySchema_ConfigurationVersionDataType_DictionaryFragment),
            14880 => Ok(VariableId::OpcUa_BinarySchema_FieldTargetDataType_DataTypeVersion),
            14881 => Ok(VariableId::OpcUa_BinarySchema_FieldTargetDataType_DictionaryFragment),
            14900 => Ok(VariableId::CertificateExpirationAlarmType_ExpirationLimit),
            15001 => Ok(VariableId::DataTypeDictionaryType_Deprecated),
            15002 => Ok(VariableId::MaxCharacters),
            15003 => Ok(VariableId::ServerType_UrisVersion),
            15004 => Ok(VariableId::Server_UrisVersion),
            15009 => Ok(VariableId::BrokerTransportQualityOfService_EnumStrings),
            15010 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupName_Placeholder_KeyLifetime),
            15011 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupName_Placeholder_SecurityPolicyUri),
            15012 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupName_Placeholder_MaxFutureKeyCount),
            15014 => Ok(VariableId::AuditConditionResetEventType_EventId),
            15015 => Ok(VariableId::AuditConditionResetEventType_EventType),
            15016 => Ok(VariableId::AuditConditionResetEventType_SourceNode),
            15017 => Ok(VariableId::AuditConditionResetEventType_SourceName),
            15018 => Ok(VariableId::AuditConditionResetEventType_Time),
            15019 => Ok(VariableId::AuditConditionResetEventType_ReceiveTime),
            15020 => Ok(VariableId::AuditConditionResetEventType_LocalTime),
            15021 => Ok(VariableId::AuditConditionResetEventType_Message),
            15022 => Ok(VariableId::AuditConditionResetEventType_Severity),
            15023 => Ok(VariableId::AuditConditionResetEventType_ActionTimeStamp),
            15024 => Ok(VariableId::AuditConditionResetEventType_Status),
            15025 => Ok(VariableId::AuditConditionResetEventType_ServerId),
            15026 => Ok(VariableId::AuditConditionResetEventType_ClientAuditEntryId),
            15027 => Ok(VariableId::AuditConditionResetEventType_ClientUserId),
            15028 => Ok(VariableId::AuditConditionResetEventType_MethodId),
            15029 => Ok(VariableId::AuditConditionResetEventType_InputArguments),
            15030 => Ok(VariableId::PermissionType_OptionSetValues),
            15032 => Ok(VariableId::AccessLevelType_OptionSetValues),
            15034 => Ok(VariableId::EventNotifierType_OptionSetValues),
            15035 => Ok(VariableId::AccessRestrictionType_OptionSetValues),
            15036 => Ok(VariableId::AttributeWriteMask_OptionSetValues),
            15037 => Ok(VariableId::OpcUa_BinarySchema_Deprecated),
            15038 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodInputValues),
            15040 => Ok(VariableId::ProgramStateMachineType_ProgramDiagnostic_LastMethodOutputValues),
            15043 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupName_Placeholder_MaxPastKeyCount),
            15046 => Ok(VariableId::SecurityGroupType_KeyLifetime),
            15047 => Ok(VariableId::SecurityGroupType_SecurityPolicyUri),
            15048 => Ok(VariableId::SecurityGroupType_MaxFutureKeyCount),
            15053 => Ok(VariableId::PublishedEventsType_ModifyFieldSelection_InputArguments),
            15055 => Ok(VariableId::PublishedEventsTypeModifyFieldSelectionMethodType_InputArguments),
            15056 => Ok(VariableId::SecurityGroupType_MaxPastKeyCount),
            15110 => Ok(VariableId::ChoiceStateType_StateNumber),
            15114 => Ok(VariableId::TargetVariablesType_TargetVariables),
            15116 => Ok(VariableId::TargetVariablesType_AddTargetVariables_InputArguments),
            15117 => Ok(VariableId::TargetVariablesType_AddTargetVariables_OutputArguments),
            15119 => Ok(VariableId::TargetVariablesType_RemoveTargetVariables_InputArguments),
            15120 => Ok(VariableId::TargetVariablesType_RemoveTargetVariables_OutputArguments),
            15122 => Ok(VariableId::TargetVariablesTypeAddTargetVariablesMethodType_InputArguments),
            15123 => Ok(VariableId::TargetVariablesTypeAddTargetVariablesMethodType_OutputArguments),
            15125 => Ok(VariableId::TargetVariablesTypeRemoveTargetVariablesMethodType_InputArguments),
            15126 => Ok(VariableId::TargetVariablesTypeRemoveTargetVariablesMethodType_OutputArguments),
            15129 => Ok(VariableId::ExpressionGuardVariableType_Expression),
            15154 => Ok(VariableId::DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface),
            15156 => Ok(VariableId::BrokerConnectionTransportType_ResourceUri),
            15178 => Ok(VariableId::BrokerConnectionTransportType_AuthenticationProfileUri),
            15213 => Ok(VariableId::PublishSubscribeType_GetSecurityKeys_InputArguments),
            15214 => Ok(VariableId::PublishSubscribeType_GetSecurityKeys_OutputArguments),
            15216 => Ok(VariableId::PublishSubscribe_GetSecurityKeys_InputArguments),
            15217 => Ok(VariableId::PublishSubscribe_GetSecurityKeys_OutputArguments),
            15219 => Ok(VariableId::GetSecurityKeysMethodType_InputArguments),
            15220 => Ok(VariableId::GetSecurityKeysMethodType_OutputArguments),
            15221 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_DataSetMetaData),
            15224 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Status_State),
            15229 => Ok(VariableId::PublishedDataSetType_DataSetMetaData),
            15232 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Status_State),
            15237 => Ok(VariableId::PublishedDataItemsType_DataSetMetaData),
            15240 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Status_State),
            15245 => Ok(VariableId::PublishedEventsType_DataSetMetaData),
            15246 => Ok(VariableId::BrokerWriterGroupTransportType_ResourceUri),
            15247 => Ok(VariableId::BrokerWriterGroupTransportType_AuthenticationProfileUri),
            15249 => Ok(VariableId::BrokerWriterGroupTransportType_RequestedDeliveryGuarantee),
            15250 => Ok(VariableId::BrokerDataSetWriterTransportType_ResourceUri),
            15251 => Ok(VariableId::BrokerDataSetWriterTransportType_AuthenticationProfileUri),
            15253 => Ok(VariableId::CreateCredentialMethodType_InputArguments),
            15266 => Ok(VariableId::PubSubGroupType_Status_State),
            15300 => Ok(VariableId::DataSetWriterType_Status_State),
            15308 => Ok(VariableId::DataSetReaderType_Status_State),
            15330 => Ok(VariableId::BrokerDataSetWriterTransportType_RequestedDeliveryGuarantee),
            15334 => Ok(VariableId::BrokerDataSetReaderTransportType_ResourceUri),
            15384 => Ok(VariableId::ProgramDiagnostic2Type_CreateSessionId),
            15385 => Ok(VariableId::ProgramDiagnostic2Type_CreateClientName),
            15386 => Ok(VariableId::ProgramDiagnostic2Type_InvocationCreationTime),
            15387 => Ok(VariableId::ProgramDiagnostic2Type_LastTransitionTime),
            15388 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodCall),
            15389 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodSessionId),
            15390 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodInputArguments),
            15391 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodOutputArguments),
            15392 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodInputValues),
            15393 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodOutputValues),
            15394 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodCallTime),
            15395 => Ok(VariableId::ProgramDiagnostic2Type_LastMethodReturnStatus),
            15398 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnostic2DataType),
            15399 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnostic2DataType_DataTypeVersion),
            15400 => Ok(VariableId::OpcUa_BinarySchema_ProgramDiagnostic2DataType_DictionaryFragment),
            15407 => Ok(VariableId::AccessLevelExType_OptionSetValues),
            15408 => Ok(VariableId::RoleSetType_RoleName_Placeholder_ApplicationsExclude),
            15409 => Ok(VariableId::RoleSetType_RoleName_Placeholder_EndpointsExclude),
            15410 => Ok(VariableId::RoleType_ApplicationsExclude),
            15411 => Ok(VariableId::RoleType_EndpointsExclude),
            15412 => Ok(VariableId::WellKnownRole_Anonymous_ApplicationsExclude),
            15413 => Ok(VariableId::WellKnownRole_Anonymous_EndpointsExclude),
            15414 => Ok(VariableId::WellKnownRole_AuthenticatedUser_ApplicationsExclude),
            15415 => Ok(VariableId::WellKnownRole_AuthenticatedUser_EndpointsExclude),
            15416 => Ok(VariableId::WellKnownRole_Observer_ApplicationsExclude),
            15417 => Ok(VariableId::WellKnownRole_Observer_EndpointsExclude),
            15418 => Ok(VariableId::WellKnownRole_Operator_ApplicationsExclude),
            15419 => Ok(VariableId::BrokerDataSetReaderTransportType_AuthenticationProfileUri),
            15420 => Ok(VariableId::BrokerDataSetReaderTransportType_RequestedDeliveryGuarantee),
            15423 => Ok(VariableId::WellKnownRole_Operator_EndpointsExclude),
            15424 => Ok(VariableId::WellKnownRole_Engineer_ApplicationsExclude),
            15425 => Ok(VariableId::WellKnownRole_Engineer_EndpointsExclude),
            15426 => Ok(VariableId::WellKnownRole_Supervisor_ApplicationsExclude),
            15427 => Ok(VariableId::WellKnownRole_Supervisor_EndpointsExclude),
            15428 => Ok(VariableId::WellKnownRole_ConfigureAdmin_ApplicationsExclude),
            15429 => Ok(VariableId::WellKnownRole_ConfigureAdmin_EndpointsExclude),
            15430 => Ok(VariableId::WellKnownRole_SecurityAdmin_ApplicationsExclude),
            15432 => Ok(VariableId::PublishSubscribeType_GetSecurityGroup_InputArguments),
            15433 => Ok(VariableId::PublishSubscribeType_GetSecurityGroup_OutputArguments),
            15436 => Ok(VariableId::PublishSubscribeType_SecurityGroups_AddSecurityGroup_InputArguments),
            15437 => Ok(VariableId::PublishSubscribeType_SecurityGroups_AddSecurityGroup_OutputArguments),
            15439 => Ok(VariableId::PublishSubscribeType_SecurityGroups_RemoveSecurityGroup_InputArguments),
            15441 => Ok(VariableId::PublishSubscribe_GetSecurityGroup_InputArguments),
            15442 => Ok(VariableId::PublishSubscribe_GetSecurityGroup_OutputArguments),
            15445 => Ok(VariableId::PublishSubscribe_SecurityGroups_AddSecurityGroup_InputArguments),
            15446 => Ok(VariableId::PublishSubscribe_SecurityGroups_AddSecurityGroup_OutputArguments),
            15448 => Ok(VariableId::PublishSubscribe_SecurityGroups_RemoveSecurityGroup_InputArguments),
            15450 => Ok(VariableId::GetSecurityGroupMethodType_InputArguments),
            15451 => Ok(VariableId::GetSecurityGroupMethodType_OutputArguments),
            15455 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup_InputArguments),
            15456 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup_OutputArguments),
            15458 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_RemoveSecurityGroup_InputArguments),
            15460 => Ok(VariableId::SecurityGroupFolderType_SecurityGroupName_Placeholder_SecurityGroupId),
            15462 => Ok(VariableId::SecurityGroupFolderType_AddSecurityGroup_InputArguments),
            15463 => Ok(VariableId::SecurityGroupFolderType_AddSecurityGroup_OutputArguments),
            15465 => Ok(VariableId::SecurityGroupFolderType_RemoveSecurityGroup_InputArguments),
            15467 => Ok(VariableId::AddSecurityGroupMethodType_InputArguments),
            15468 => Ok(VariableId::AddSecurityGroupMethodType_OutputArguments),
            15470 => Ok(VariableId::RemoveSecurityGroupMethodType_InputArguments),
            15472 => Ok(VariableId::SecurityGroupType_SecurityGroupId),
            15475 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField_InputArguments),
            15476 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField_OutputArguments),
            15478 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_RemoveExtensionField_InputArguments),
            15483 => Ok(VariableId::PublishedDataSetType_ExtensionFields_AddExtensionField_InputArguments),
            15484 => Ok(VariableId::PublishedDataSetType_ExtensionFields_AddExtensionField_OutputArguments),
            15486 => Ok(VariableId::PublishedDataSetType_ExtensionFields_RemoveExtensionField_InputArguments),
            15490 => Ok(VariableId::ExtensionFieldsType_ExtensionFieldName_Placeholder),
            15492 => Ok(VariableId::ExtensionFieldsType_AddExtensionField_InputArguments),
            15493 => Ok(VariableId::ExtensionFieldsType_AddExtensionField_OutputArguments),
            15495 => Ok(VariableId::ExtensionFieldsType_RemoveExtensionField_InputArguments),
            15497 => Ok(VariableId::AddExtensionFieldMethodType_InputArguments),
            15498 => Ok(VariableId::AddExtensionFieldMethodType_OutputArguments),
            15500 => Ok(VariableId::RemoveExtensionFieldMethodType_InputArguments),
            15501 => Ok(VariableId::OpcUa_BinarySchema_SimpleTypeDescription),
            15505 => Ok(VariableId::PublishedDataItemsType_ExtensionFields_AddExtensionField_InputArguments),
            15506 => Ok(VariableId::PublishedDataItemsType_ExtensionFields_AddExtensionField_OutputArguments),
            15508 => Ok(VariableId::PublishedDataItemsType_ExtensionFields_RemoveExtensionField_InputArguments),
            15509 => Ok(VariableId::OpcUa_BinarySchema_SimpleTypeDescription_DataTypeVersion),
            15513 => Ok(VariableId::PublishedEventsType_ExtensionFields_AddExtensionField_InputArguments),
            15514 => Ok(VariableId::PublishedEventsType_ExtensionFields_AddExtensionField_OutputArguments),
            15516 => Ok(VariableId::PublishedEventsType_ExtensionFields_RemoveExtensionField_InputArguments),
            15517 => Ok(VariableId::PublishedEventsType_ModifyFieldSelection_OutputArguments),
            15518 => Ok(VariableId::PublishedEventsTypeModifyFieldSelectionMethodType_OutputArguments),
            15519 => Ok(VariableId::OpcUa_BinarySchema_SimpleTypeDescription_DictionaryFragment),
            15521 => Ok(VariableId::OpcUa_BinarySchema_UABinaryFileDataType),
            15522 => Ok(VariableId::OpcUa_BinarySchema_UABinaryFileDataType_DataTypeVersion),
            15523 => Ok(VariableId::OpcUa_BinarySchema_UABinaryFileDataType_DictionaryFragment),
            15524 => Ok(VariableId::OpcUa_BinarySchema_BrokerConnectionTransportDataType),
            15525 => Ok(VariableId::OpcUa_BinarySchema_BrokerConnectionTransportDataType_DataTypeVersion),
            15526 => Ok(VariableId::OpcUa_BinarySchema_BrokerConnectionTransportDataType_DictionaryFragment),
            15527 => Ok(VariableId::WellKnownRole_SecurityAdmin_EndpointsExclude),
            15533 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface),
            15536 => Ok(VariableId::PubSubStatusEventType_EventId),
            15537 => Ok(VariableId::PubSubStatusEventType_EventType),
            15538 => Ok(VariableId::PubSubStatusEventType_SourceNode),
            15539 => Ok(VariableId::PubSubStatusEventType_SourceName),
            15540 => Ok(VariableId::PubSubStatusEventType_Time),
            15541 => Ok(VariableId::PubSubStatusEventType_ReceiveTime),
            15542 => Ok(VariableId::PubSubStatusEventType_LocalTime),
            15543 => Ok(VariableId::PubSubStatusEventType_Message),
            15544 => Ok(VariableId::PubSubStatusEventType_Severity),
            15545 => Ok(VariableId::PubSubStatusEventType_ConnectionId),
            15546 => Ok(VariableId::PubSubStatusEventType_GroupId),
            15547 => Ok(VariableId::PubSubStatusEventType_State),
            15549 => Ok(VariableId::PubSubTransportLimitsExceedEventType_EventId),
            15550 => Ok(VariableId::PubSubTransportLimitsExceedEventType_EventType),
            15551 => Ok(VariableId::PubSubTransportLimitsExceedEventType_SourceNode),
            15552 => Ok(VariableId::PubSubTransportLimitsExceedEventType_SourceName),
            15553 => Ok(VariableId::PubSubTransportLimitsExceedEventType_Time),
            15554 => Ok(VariableId::PubSubTransportLimitsExceedEventType_ReceiveTime),
            15555 => Ok(VariableId::PubSubTransportLimitsExceedEventType_LocalTime),
            15556 => Ok(VariableId::PubSubTransportLimitsExceedEventType_Message),
            15557 => Ok(VariableId::PubSubTransportLimitsExceedEventType_Severity),
            15558 => Ok(VariableId::PubSubTransportLimitsExceedEventType_ConnectionId),
            15559 => Ok(VariableId::PubSubTransportLimitsExceedEventType_GroupId),
            15560 => Ok(VariableId::PubSubTransportLimitsExceedEventType_State),
            15561 => Ok(VariableId::PubSubTransportLimitsExceedEventType_Actual),
            15562 => Ok(VariableId::PubSubTransportLimitsExceedEventType_Maximum),
            15564 => Ok(VariableId::PubSubCommunicationFailureEventType_EventId),
            15565 => Ok(VariableId::PubSubCommunicationFailureEventType_EventType),
            15566 => Ok(VariableId::PubSubCommunicationFailureEventType_SourceNode),
            15567 => Ok(VariableId::PubSubCommunicationFailureEventType_SourceName),
            15568 => Ok(VariableId::PubSubCommunicationFailureEventType_Time),
            15569 => Ok(VariableId::PubSubCommunicationFailureEventType_ReceiveTime),
            15570 => Ok(VariableId::PubSubCommunicationFailureEventType_LocalTime),
            15571 => Ok(VariableId::PubSubCommunicationFailureEventType_Message),
            15572 => Ok(VariableId::PubSubCommunicationFailureEventType_Severity),
            15573 => Ok(VariableId::PubSubCommunicationFailureEventType_ConnectionId),
            15574 => Ok(VariableId::PubSubCommunicationFailureEventType_GroupId),
            15575 => Ok(VariableId::PubSubCommunicationFailureEventType_State),
            15576 => Ok(VariableId::PubSubCommunicationFailureEventType_Error),
            15577 => Ok(VariableId::DataSetFieldFlags_OptionSetValues),
            15584 => Ok(VariableId::DataSetFieldContentMask_OptionSetValues),
            15599 => Ok(VariableId::OpcUa_BinarySchema_StructureDescription),
            15600 => Ok(VariableId::OpcUa_BinarySchema_StructureDescription_DataTypeVersion),
            15601 => Ok(VariableId::OpcUa_BinarySchema_StructureDescription_DictionaryFragment),
            15602 => Ok(VariableId::OpcUa_BinarySchema_EnumDescription),
            15603 => Ok(VariableId::OpcUa_BinarySchema_EnumDescription_DataTypeVersion),
            15604 => Ok(VariableId::OpcUa_BinarySchema_EnumDescription_DictionaryFragment),
            15613 => Ok(VariableId::RoleSetType_RoleName_Placeholder_AddIdentity_InputArguments),
            15615 => Ok(VariableId::RoleSetType_RoleName_Placeholder_RemoveIdentity_InputArguments),
            15625 => Ok(VariableId::RoleType_AddIdentity_InputArguments),
            15627 => Ok(VariableId::RoleType_RemoveIdentity_InputArguments),
            15633 => Ok(VariableId::IdentityCriteriaType_EnumValues),
            15637 => Ok(VariableId::AddIdentityMethodType_InputArguments),
            15639 => Ok(VariableId::RemoveIdentityMethodType_InputArguments),
            15641 => Ok(VariableId::DataSetOrderingType_EnumStrings),
            15643 => Ok(VariableId::UadpNetworkMessageContentMask_OptionSetValues),
            15647 => Ok(VariableId::UadpDataSetMessageContentMask_OptionSetValues),
            15649 => Ok(VariableId::WellKnownRole_Anonymous_AddIdentity_InputArguments),
            15651 => Ok(VariableId::WellKnownRole_Anonymous_RemoveIdentity_InputArguments),
            15655 => Ok(VariableId::JsonNetworkMessageContentMask_OptionSetValues),
            15659 => Ok(VariableId::JsonDataSetMessageContentMask_OptionSetValues),
            15661 => Ok(VariableId::WellKnownRole_AuthenticatedUser_AddIdentity_InputArguments),
            15663 => Ok(VariableId::WellKnownRole_AuthenticatedUser_RemoveIdentity_InputArguments),
            15673 => Ok(VariableId::WellKnownRole_Observer_AddIdentity_InputArguments),
            15675 => Ok(VariableId::WellKnownRole_Observer_RemoveIdentity_InputArguments),
            15685 => Ok(VariableId::WellKnownRole_Operator_AddIdentity_InputArguments),
            15687 => Ok(VariableId::WellKnownRole_Operator_RemoveIdentity_InputArguments),
            15697 => Ok(VariableId::WellKnownRole_Supervisor_AddIdentity_InputArguments),
            15699 => Ok(VariableId::WellKnownRole_Supervisor_RemoveIdentity_InputArguments),
            15709 => Ok(VariableId::WellKnownRole_SecurityAdmin_AddIdentity_InputArguments),
            15711 => Ok(VariableId::WellKnownRole_SecurityAdmin_RemoveIdentity_InputArguments),
            15721 => Ok(VariableId::WellKnownRole_ConfigureAdmin_AddIdentity_InputArguments),
            15723 => Ok(VariableId::WellKnownRole_ConfigureAdmin_RemoveIdentity_InputArguments),
            15734 => Ok(VariableId::OpcUa_BinarySchema_EndpointType),
            15735 => Ok(VariableId::OpcUa_BinarySchema_EndpointType_DataTypeVersion),
            15737 => Ok(VariableId::OpcUa_BinarySchema_EndpointType_DictionaryFragment),
            15738 => Ok(VariableId::OpcUa_BinarySchema_IdentityMappingRuleType),
            15739 => Ok(VariableId::OpcUa_BinarySchema_IdentityMappingRuleType_DataTypeVersion),
            15740 => Ok(VariableId::OpcUa_BinarySchema_IdentityMappingRuleType_DictionaryFragment),
            15741 => Ok(VariableId::OpcUa_BinarySchema_DataTypeSchemaHeader),
            15742 => Ok(VariableId::OpcUa_BinarySchema_DataTypeSchemaHeader_DataTypeVersion),
            15743 => Ok(VariableId::OpcUa_BinarySchema_DataTypeSchemaHeader_DictionaryFragment),
            15745 => Ok(VariableId::TemporaryFileTransferType_ClientProcessingTimeout),
            15747 => Ok(VariableId::TemporaryFileTransferType_GenerateFileForRead_InputArguments),
            15748 => Ok(VariableId::TemporaryFileTransferType_GenerateFileForRead_OutputArguments),
            15750 => Ok(VariableId::TemporaryFileTransferType_GenerateFileForWrite_OutputArguments),
            15752 => Ok(VariableId::TemporaryFileTransferType_CloseAndCommit_InputArguments),
            15753 => Ok(VariableId::TemporaryFileTransferType_CloseAndCommit_OutputArguments),
            15755 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_CurrentState),
            15756 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Id),
            15757 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Name),
            15758 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_CurrentState_Number),
            15759 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_CurrentState_EffectiveDisplayName),
            15760 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition),
            15761 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Id),
            15762 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Name),
            15763 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition_Number),
            15764 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition_TransitionTime),
            15765 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_LastTransition_EffectiveTransitionTime),
            15766 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetDataType),
            15767 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetDataType_DataTypeVersion),
            15768 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetDataType_DictionaryFragment),
            15769 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetSourceDataType),
            15770 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetSourceDataType_DataTypeVersion),
            15771 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataSetSourceDataType_DictionaryFragment),
            15772 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataItemsDataType),
            15773 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataItemsDataType_DataTypeVersion),
            15774 => Ok(VariableId::OpcUa_BinarySchema_PublishedDataItemsDataType_DictionaryFragment),
            15775 => Ok(VariableId::OpcUa_BinarySchema_PublishedEventsDataType),
            15776 => Ok(VariableId::OpcUa_BinarySchema_PublishedEventsDataType_DataTypeVersion),
            15777 => Ok(VariableId::OpcUa_BinarySchema_PublishedEventsDataType_DictionaryFragment),
            15778 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterDataType),
            15779 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterDataType_DataTypeVersion),
            15780 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterDataType_DictionaryFragment),
            15781 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterTransportDataType),
            15782 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterTransportDataType_DataTypeVersion),
            15783 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterTransportDataType_DictionaryFragment),
            15784 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterMessageDataType),
            15785 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterMessageDataType_DataTypeVersion),
            15786 => Ok(VariableId::OpcUa_BinarySchema_DataSetWriterMessageDataType_DictionaryFragment),
            15787 => Ok(VariableId::OpcUa_BinarySchema_PubSubGroupDataType),
            15788 => Ok(VariableId::OpcUa_BinarySchema_PubSubGroupDataType_DataTypeVersion),
            15789 => Ok(VariableId::OpcUa_BinarySchema_PubSubGroupDataType_DictionaryFragment),
            15791 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_PublisherId),
            15792 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri),
            15793 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupTransportDataType),
            15796 => Ok(VariableId::GenerateFileForReadMethodType_InputArguments),
            15797 => Ok(VariableId::GenerateFileForReadMethodType_OutputArguments),
            15799 => Ok(VariableId::GenerateFileForWriteMethodType_OutputArguments),
            15801 => Ok(VariableId::CloseAndCommitMethodType_InputArguments),
            15802 => Ok(VariableId::CloseAndCommitMethodType_OutputArguments),
            15804 => Ok(VariableId::FileTransferStateMachineType_CurrentState),
            15805 => Ok(VariableId::FileTransferStateMachineType_CurrentState_Id),
            15806 => Ok(VariableId::FileTransferStateMachineType_CurrentState_Name),
            15807 => Ok(VariableId::FileTransferStateMachineType_CurrentState_Number),
            15808 => Ok(VariableId::FileTransferStateMachineType_CurrentState_EffectiveDisplayName),
            15809 => Ok(VariableId::FileTransferStateMachineType_LastTransition),
            15810 => Ok(VariableId::FileTransferStateMachineType_LastTransition_Id),
            15811 => Ok(VariableId::FileTransferStateMachineType_LastTransition_Name),
            15812 => Ok(VariableId::FileTransferStateMachineType_LastTransition_Number),
            15813 => Ok(VariableId::FileTransferStateMachineType_LastTransition_TransitionTime),
            15814 => Ok(VariableId::FileTransferStateMachineType_LastTransition_EffectiveTransitionTime),
            15816 => Ok(VariableId::FileTransferStateMachineType_Idle_StateNumber),
            15818 => Ok(VariableId::FileTransferStateMachineType_ReadPrepare_StateNumber),
            15820 => Ok(VariableId::FileTransferStateMachineType_ReadTransfer_StateNumber),
            15822 => Ok(VariableId::FileTransferStateMachineType_ApplyWrite_StateNumber),
            15824 => Ok(VariableId::FileTransferStateMachineType_Error_StateNumber),
            15826 => Ok(VariableId::FileTransferStateMachineType_IdleToReadPrepare_TransitionNumber),
            15828 => Ok(VariableId::FileTransferStateMachineType_ReadPrepareToReadTransfer_TransitionNumber),
            15830 => Ok(VariableId::FileTransferStateMachineType_ReadTransferToIdle_TransitionNumber),
            15832 => Ok(VariableId::FileTransferStateMachineType_IdleToApplyWrite_TransitionNumber),
            15834 => Ok(VariableId::FileTransferStateMachineType_ApplyWriteToIdle_TransitionNumber),
            15836 => Ok(VariableId::FileTransferStateMachineType_ReadPrepareToError_TransitionNumber),
            15838 => Ok(VariableId::FileTransferStateMachineType_ReadTransferToError_TransitionNumber),
            15840 => Ok(VariableId::FileTransferStateMachineType_ApplyWriteToError_TransitionNumber),
            15842 => Ok(VariableId::FileTransferStateMachineType_ErrorToIdle_TransitionNumber),
            15845 => Ok(VariableId::PublishSubscribeType_Status_State),
            15848 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_Selections),
            15849 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_SelectionDescriptions),
            15850 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_TransportProfileUri_RestrictToList),
            15852 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupTransportDataType_DataTypeVersion),
            15853 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupTransportDataType_DictionaryFragment),
            15854 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupMessageDataType),
            15855 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupMessageDataType_DataTypeVersion),
            15856 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupMessageDataType_DictionaryFragment),
            15857 => Ok(VariableId::OpcUa_BinarySchema_PubSubConnectionDataType),
            15858 => Ok(VariableId::OpcUa_BinarySchema_PubSubConnectionDataType_DataTypeVersion),
            15859 => Ok(VariableId::OpcUa_BinarySchema_PubSubConnectionDataType_DictionaryFragment),
            15860 => Ok(VariableId::OpcUa_BinarySchema_ConnectionTransportDataType),
            15861 => Ok(VariableId::OpcUa_BinarySchema_ConnectionTransportDataType_DataTypeVersion),
            15862 => Ok(VariableId::OpcUa_BinarySchema_ConnectionTransportDataType_DictionaryFragment),
            15863 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface),
            15866 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupTransportDataType),
            15867 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupTransportDataType_DataTypeVersion),
            15868 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupTransportDataType_DictionaryFragment),
            15869 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupMessageDataType),
            15870 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupMessageDataType_DataTypeVersion),
            15871 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupMessageDataType_DictionaryFragment),
            15872 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderDataType),
            15873 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderDataType_DataTypeVersion),
            15875 => Ok(VariableId::OverrideValueHandling_EnumStrings),
            15876 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderDataType_DictionaryFragment),
            15877 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderTransportDataType),
            15878 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderTransportDataType_DataTypeVersion),
            15879 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderTransportDataType_DictionaryFragment),
            15880 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderMessageDataType),
            15881 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderMessageDataType_DataTypeVersion),
            15882 => Ok(VariableId::OpcUa_BinarySchema_DataSetReaderMessageDataType_DictionaryFragment),
            15883 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetDataType),
            15884 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetDataType_DataTypeVersion),
            15885 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetDataType_DictionaryFragment),
            15886 => Ok(VariableId::OpcUa_BinarySchema_TargetVariablesDataType),
            15887 => Ok(VariableId::OpcUa_BinarySchema_TargetVariablesDataType_DataTypeVersion),
            15888 => Ok(VariableId::OpcUa_BinarySchema_TargetVariablesDataType_DictionaryFragment),
            15889 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetMirrorDataType),
            15890 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DataTypeVersion),
            15891 => Ok(VariableId::OpcUa_BinarySchema_SubscribedDataSetMirrorDataType_DictionaryFragment),
            15892 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Status_State),
            15895 => Ok(VariableId::OpcUa_BinarySchema_UadpWriterGroupMessageDataType),
            15896 => Ok(VariableId::OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DataTypeVersion),
            15897 => Ok(VariableId::OpcUa_BinarySchema_UadpWriterGroupMessageDataType_DictionaryFragment),
            15898 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetWriterMessageDataType),
            15899 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DataTypeVersion),
            15900 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetWriterMessageDataType_DictionaryFragment),
            15908 => Ok(VariableId::PubSubKeyServiceType_GetSecurityKeys_InputArguments),
            15909 => Ok(VariableId::PubSubKeyServiceType_GetSecurityKeys_OutputArguments),
            15911 => Ok(VariableId::PubSubKeyServiceType_GetSecurityGroup_InputArguments),
            15912 => Ok(VariableId::PubSubKeyServiceType_GetSecurityGroup_OutputArguments),
            15915 => Ok(VariableId::PubSubKeyServiceType_SecurityGroups_AddSecurityGroup_InputArguments),
            15916 => Ok(VariableId::PubSubKeyServiceType_SecurityGroups_AddSecurityGroup_OutputArguments),
            15918 => Ok(VariableId::PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup_InputArguments),
            15919 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetReaderMessageDataType),
            15920 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DataTypeVersion),
            15921 => Ok(VariableId::OpcUa_BinarySchema_UadpDataSetReaderMessageDataType_DictionaryFragment),
            15922 => Ok(VariableId::OpcUa_BinarySchema_JsonWriterGroupMessageDataType),
            15923 => Ok(VariableId::OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DataTypeVersion),
            15924 => Ok(VariableId::OpcUa_BinarySchema_JsonWriterGroupMessageDataType_DictionaryFragment),
            15925 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetWriterMessageDataType),
            15926 => Ok(VariableId::PubSubGroupType_SecurityMode),
            15927 => Ok(VariableId::PubSubGroupType_SecurityGroupId),
            15928 => Ok(VariableId::PubSubGroupType_SecurityKeyServices),
            15929 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DataTypeVersion),
            15930 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetWriterMessageDataType_DictionaryFragment),
            15931 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetReaderMessageDataType),
            15932 => Ok(VariableId::DataSetReaderType_SecurityMode),
            15933 => Ok(VariableId::DataSetReaderType_SecurityGroupId),
            15934 => Ok(VariableId::DataSetReaderType_SecurityKeyServices),
            15935 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DataTypeVersion),
            15936 => Ok(VariableId::OpcUa_BinarySchema_JsonDataSetReaderMessageDataType_DictionaryFragment),
            15938 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_DiagnosticsLevel),
            15939 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation),
            15940 => Ok(VariableId::OpcUa_BinarySchema_BrokerWriterGroupTransportDataType),
            15941 => Ok(VariableId::OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DataTypeVersion),
            15942 => Ok(VariableId::OpcUa_BinarySchema_BrokerWriterGroupTransportDataType_DictionaryFragment),
            15943 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType),
            15944 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DataTypeVersion),
            15945 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetWriterTransportDataType_DictionaryFragment),
            15946 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType),
            15947 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DataTypeVersion),
            15948 => Ok(VariableId::OpcUa_BinarySchema_BrokerDataSetReaderTransportDataType_DictionaryFragment),
            15958 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceUri),
            15959 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceVersion),
            15960 => Ok(VariableId::OPCUANamespaceMetadata_NamespacePublicationDate),
            15961 => Ok(VariableId::OPCUANamespaceMetadata_IsNamespaceSubset),
            15962 => Ok(VariableId::OPCUANamespaceMetadata_StaticNodeIdTypes),
            15963 => Ok(VariableId::OPCUANamespaceMetadata_StaticNumericNodeIdRange),
            15964 => Ok(VariableId::OPCUANamespaceMetadata_StaticStringNodeIdPattern),
            15966 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Size),
            15967 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Writable),
            15968 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_UserWritable),
            15969 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_OpenCount),
            15970 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_MimeType),
            15972 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Open_InputArguments),
            15973 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Open_OutputArguments),
            15975 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Close_InputArguments),
            15977 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Read_InputArguments),
            15978 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Read_OutputArguments),
            15980 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_Write_InputArguments),
            15982 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_GetPosition_InputArguments),
            15983 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_GetPosition_OutputArguments),
            15985 => Ok(VariableId::OPCUANamespaceMetadata_NamespaceFile_SetPosition_InputArguments),
            15989 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_Active),
            15994 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_Classification),
            15998 => Ok(VariableId::RoleSetType_AddRole_InputArguments),
            15999 => Ok(VariableId::RoleSetType_AddRole_OutputArguments),
            16001 => Ok(VariableId::RoleSetType_RemoveRole_InputArguments),
            16003 => Ok(VariableId::AddRoleMethodType_InputArguments),
            16004 => Ok(VariableId::AddRoleMethodType_OutputArguments),
            16006 => Ok(VariableId::RemoveRoleMethodType_InputArguments),
            16013 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            16020 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            16042 => Ok(VariableId::WellKnownRole_Engineer_AddIdentity_InputArguments),
            16044 => Ok(VariableId::WellKnownRole_Engineer_RemoveIdentity_InputArguments),
            16059 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError),
            16060 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_Active),
            16061 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_Classification),
            16074 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            16075 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            16101 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_SubError),
            16103 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError),
            16122 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Active),
            16123 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Classification),
            16124 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            16131 => Ok(VariableId::OpcUa_BinarySchema_RolePermissionType),
            16132 => Ok(VariableId::OpcUa_BinarySchema_RolePermissionType_DataTypeVersion),
            16133 => Ok(VariableId::OpcUa_BinarySchema_RolePermissionType_DictionaryFragment),
            16134 => Ok(VariableId::OPCUANamespaceMetadata_DefaultRolePermissions),
            16135 => Ok(VariableId::OPCUANamespaceMetadata_DefaultUserRolePermissions),
            16136 => Ok(VariableId::OPCUANamespaceMetadata_DefaultAccessRestrictions),
            16137 => Ok(VariableId::NamespaceMetadataType_DefaultRolePermissions),
            16138 => Ok(VariableId::NamespaceMetadataType_DefaultUserRolePermissions),
            16139 => Ok(VariableId::NamespaceMetadataType_DefaultAccessRestrictions),
            16140 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_DefaultRolePermissions),
            16141 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_DefaultUserRolePermissions),
            16142 => Ok(VariableId::NamespacesType_NamespaceIdentifier_Placeholder_DefaultAccessRestrictions),
            16160 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            16162 => Ok(VariableId::RoleSetType_RoleName_Placeholder_Identities),
            16163 => Ok(VariableId::RoleSetType_RoleName_Placeholder_Applications),
            16164 => Ok(VariableId::RoleSetType_RoleName_Placeholder_Endpoints),
            16166 => Ok(VariableId::RoleSetType_RoleName_Placeholder_AddApplication_InputArguments),
            16168 => Ok(VariableId::RoleSetType_RoleName_Placeholder_RemoveApplication_InputArguments),
            16170 => Ok(VariableId::RoleSetType_RoleName_Placeholder_AddEndpoint_InputArguments),
            16172 => Ok(VariableId::RoleSetType_RoleName_Placeholder_RemoveEndpoint_InputArguments),
            16173 => Ok(VariableId::RoleType_Identities),
            16174 => Ok(VariableId::RoleType_Applications),
            16175 => Ok(VariableId::RoleType_Endpoints),
            16177 => Ok(VariableId::RoleType_AddApplication_InputArguments),
            16179 => Ok(VariableId::RoleType_RemoveApplication_InputArguments),
            16181 => Ok(VariableId::RoleType_AddEndpoint_InputArguments),
            16183 => Ok(VariableId::RoleType_RemoveEndpoint_InputArguments),
            16185 => Ok(VariableId::AddApplicationMethodType_InputArguments),
            16187 => Ok(VariableId::RemoveApplicationMethodType_InputArguments),
            16189 => Ok(VariableId::AddEndpointMethodType_InputArguments),
            16191 => Ok(VariableId::RemoveEndpointMethodType_InputArguments),
            16192 => Ok(VariableId::WellKnownRole_Anonymous_Identities),
            16193 => Ok(VariableId::WellKnownRole_Anonymous_Applications),
            16194 => Ok(VariableId::WellKnownRole_Anonymous_Endpoints),
            16196 => Ok(VariableId::WellKnownRole_Anonymous_AddApplication_InputArguments),
            16198 => Ok(VariableId::WellKnownRole_Anonymous_RemoveApplication_InputArguments),
            16200 => Ok(VariableId::WellKnownRole_Anonymous_AddEndpoint_InputArguments),
            16202 => Ok(VariableId::WellKnownRole_Anonymous_RemoveEndpoint_InputArguments),
            16203 => Ok(VariableId::WellKnownRole_AuthenticatedUser_Identities),
            16204 => Ok(VariableId::WellKnownRole_AuthenticatedUser_Applications),
            16205 => Ok(VariableId::WellKnownRole_AuthenticatedUser_Endpoints),
            16207 => Ok(VariableId::WellKnownRole_AuthenticatedUser_AddApplication_InputArguments),
            16209 => Ok(VariableId::WellKnownRole_AuthenticatedUser_RemoveApplication_InputArguments),
            16211 => Ok(VariableId::WellKnownRole_AuthenticatedUser_AddEndpoint_InputArguments),
            16213 => Ok(VariableId::WellKnownRole_AuthenticatedUser_RemoveEndpoint_InputArguments),
            16214 => Ok(VariableId::WellKnownRole_Observer_Identities),
            16215 => Ok(VariableId::WellKnownRole_Observer_Applications),
            16216 => Ok(VariableId::WellKnownRole_Observer_Endpoints),
            16218 => Ok(VariableId::WellKnownRole_Observer_AddApplication_InputArguments),
            16220 => Ok(VariableId::WellKnownRole_Observer_RemoveApplication_InputArguments),
            16222 => Ok(VariableId::WellKnownRole_Observer_AddEndpoint_InputArguments),
            16224 => Ok(VariableId::WellKnownRole_Observer_RemoveEndpoint_InputArguments),
            16225 => Ok(VariableId::WellKnownRole_Operator_Identities),
            16226 => Ok(VariableId::WellKnownRole_Operator_Applications),
            16227 => Ok(VariableId::WellKnownRole_Operator_Endpoints),
            16229 => Ok(VariableId::WellKnownRole_Operator_AddApplication_InputArguments),
            16231 => Ok(VariableId::WellKnownRole_Operator_RemoveApplication_InputArguments),
            16233 => Ok(VariableId::WellKnownRole_Operator_AddEndpoint_InputArguments),
            16235 => Ok(VariableId::WellKnownRole_Operator_RemoveEndpoint_InputArguments),
            16236 => Ok(VariableId::WellKnownRole_Engineer_Identities),
            16237 => Ok(VariableId::WellKnownRole_Engineer_Applications),
            16238 => Ok(VariableId::WellKnownRole_Engineer_Endpoints),
            16240 => Ok(VariableId::WellKnownRole_Engineer_AddApplication_InputArguments),
            16242 => Ok(VariableId::WellKnownRole_Engineer_RemoveApplication_InputArguments),
            16244 => Ok(VariableId::WellKnownRole_Engineer_AddEndpoint_InputArguments),
            16246 => Ok(VariableId::WellKnownRole_Engineer_RemoveEndpoint_InputArguments),
            16247 => Ok(VariableId::WellKnownRole_Supervisor_Identities),
            16248 => Ok(VariableId::WellKnownRole_Supervisor_Applications),
            16249 => Ok(VariableId::WellKnownRole_Supervisor_Endpoints),
            16251 => Ok(VariableId::WellKnownRole_Supervisor_AddApplication_InputArguments),
            16253 => Ok(VariableId::WellKnownRole_Supervisor_RemoveApplication_InputArguments),
            16255 => Ok(VariableId::WellKnownRole_Supervisor_AddEndpoint_InputArguments),
            16257 => Ok(VariableId::WellKnownRole_Supervisor_RemoveEndpoint_InputArguments),
            16258 => Ok(VariableId::WellKnownRole_SecurityAdmin_Identities),
            16259 => Ok(VariableId::WellKnownRole_SecurityAdmin_Applications),
            16260 => Ok(VariableId::WellKnownRole_SecurityAdmin_Endpoints),
            16262 => Ok(VariableId::WellKnownRole_SecurityAdmin_AddApplication_InputArguments),
            16264 => Ok(VariableId::WellKnownRole_SecurityAdmin_RemoveApplication_InputArguments),
            16266 => Ok(VariableId::WellKnownRole_SecurityAdmin_AddEndpoint_InputArguments),
            16268 => Ok(VariableId::WellKnownRole_SecurityAdmin_RemoveEndpoint_InputArguments),
            16269 => Ok(VariableId::WellKnownRole_ConfigureAdmin_Identities),
            16270 => Ok(VariableId::WellKnownRole_ConfigureAdmin_Applications),
            16271 => Ok(VariableId::WellKnownRole_ConfigureAdmin_Endpoints),
            16273 => Ok(VariableId::WellKnownRole_ConfigureAdmin_AddApplication_InputArguments),
            16275 => Ok(VariableId::WellKnownRole_ConfigureAdmin_RemoveApplication_InputArguments),
            16277 => Ok(VariableId::WellKnownRole_ConfigureAdmin_AddEndpoint_InputArguments),
            16279 => Ok(VariableId::WellKnownRole_ConfigureAdmin_RemoveEndpoint_InputArguments),
            16283 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            16291 => Ok(VariableId::ServerType_ServerCapabilities_RoleSet_AddRole_InputArguments),
            16292 => Ok(VariableId::ServerType_ServerCapabilities_RoleSet_AddRole_OutputArguments),
            16294 => Ok(VariableId::ServerType_ServerCapabilities_RoleSet_RemoveRole_InputArguments),
            16297 => Ok(VariableId::ServerCapabilitiesType_RoleSet_AddRole_InputArguments),
            16298 => Ok(VariableId::ServerCapabilitiesType_RoleSet_AddRole_OutputArguments),
            16300 => Ok(VariableId::ServerCapabilitiesType_RoleSet_RemoveRole_InputArguments),
            16302 => Ok(VariableId::Server_ServerCapabilities_RoleSet_AddRole_InputArguments),
            16303 => Ok(VariableId::Server_ServerCapabilities_RoleSet_AddRole_OutputArguments),
            16305 => Ok(VariableId::Server_ServerCapabilities_RoleSet_RemoveRole_InputArguments),
            16312 => Ok(VariableId::SelectionListType_RestrictToList),
            16317 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_CreateDirectory_InputArguments),
            16318 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_CreateDirectory_OutputArguments),
            16320 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_CreateFile_InputArguments),
            16321 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_CreateFile_OutputArguments),
            16322 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            16325 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_MoveOrCopy_InputArguments),
            16326 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_MoveOrCopy_OutputArguments),
            16328 => Ok(VariableId::FileSystem_FileName_Placeholder_Size),
            16329 => Ok(VariableId::FileSystem_FileName_Placeholder_Writable),
            16330 => Ok(VariableId::FileSystem_FileName_Placeholder_UserWritable),
            16331 => Ok(VariableId::FileSystem_FileName_Placeholder_OpenCount),
            16332 => Ok(VariableId::FileSystem_FileName_Placeholder_MimeType),
            16334 => Ok(VariableId::FileSystem_FileName_Placeholder_Open_InputArguments),
            16335 => Ok(VariableId::FileSystem_FileName_Placeholder_Open_OutputArguments),
            16337 => Ok(VariableId::FileSystem_FileName_Placeholder_Close_InputArguments),
            16339 => Ok(VariableId::FileSystem_FileName_Placeholder_Read_InputArguments),
            16340 => Ok(VariableId::FileSystem_FileName_Placeholder_Read_OutputArguments),
            16342 => Ok(VariableId::FileSystem_FileName_Placeholder_Write_InputArguments),
            16344 => Ok(VariableId::FileSystem_FileName_Placeholder_GetPosition_InputArguments),
            16345 => Ok(VariableId::FileSystem_FileName_Placeholder_GetPosition_OutputArguments),
            16347 => Ok(VariableId::FileSystem_FileName_Placeholder_SetPosition_InputArguments),
            16349 => Ok(VariableId::FileSystem_CreateDirectory_InputArguments),
            16350 => Ok(VariableId::FileSystem_CreateDirectory_OutputArguments),
            16352 => Ok(VariableId::FileSystem_CreateFile_InputArguments),
            16353 => Ok(VariableId::FileSystem_CreateFile_OutputArguments),
            16355 => Ok(VariableId::FileSystem_DeleteFileSystemObject_InputArguments),
            16357 => Ok(VariableId::FileSystem_MoveOrCopy_InputArguments),
            16358 => Ok(VariableId::FileSystem_MoveOrCopy_OutputArguments),
            16359 => Ok(VariableId::TemporaryFileTransferType_GenerateFileForWrite_InputArguments),
            16360 => Ok(VariableId::GenerateFileForWriteMethodType_InputArguments),
            16363 => Ok(VariableId::ConditionType_ConditionSubClassId),
            16364 => Ok(VariableId::ConditionType_ConditionSubClassName),
            16365 => Ok(VariableId::DialogConditionType_ConditionSubClassId),
            16366 => Ok(VariableId::DialogConditionType_ConditionSubClassName),
            16367 => Ok(VariableId::AcknowledgeableConditionType_ConditionSubClassId),
            16368 => Ok(VariableId::AcknowledgeableConditionType_ConditionSubClassName),
            16369 => Ok(VariableId::AlarmConditionType_ConditionSubClassId),
            16370 => Ok(VariableId::AlarmConditionType_ConditionSubClassName),
            16371 => Ok(VariableId::AlarmConditionType_OutOfServiceState),
            16372 => Ok(VariableId::AlarmConditionType_OutOfServiceState_Id),
            16373 => Ok(VariableId::AlarmConditionType_OutOfServiceState_Name),
            16374 => Ok(VariableId::AlarmConditionType_OutOfServiceState_Number),
            16375 => Ok(VariableId::AlarmConditionType_OutOfServiceState_EffectiveDisplayName),
            16376 => Ok(VariableId::AlarmConditionType_OutOfServiceState_TransitionTime),
            16377 => Ok(VariableId::AlarmConditionType_OutOfServiceState_EffectiveTransitionTime),
            16378 => Ok(VariableId::AlarmConditionType_OutOfServiceState_TrueState),
            16379 => Ok(VariableId::AlarmConditionType_OutOfServiceState_FalseState),
            16380 => Ok(VariableId::AlarmConditionType_SilenceState),
            16381 => Ok(VariableId::AlarmConditionType_SilenceState_Id),
            16382 => Ok(VariableId::AlarmConditionType_SilenceState_Name),
            16383 => Ok(VariableId::AlarmConditionType_SilenceState_Number),
            16384 => Ok(VariableId::AlarmConditionType_SilenceState_EffectiveDisplayName),
            16385 => Ok(VariableId::AlarmConditionType_SilenceState_TransitionTime),
            16386 => Ok(VariableId::AlarmConditionType_SilenceState_EffectiveTransitionTime),
            16387 => Ok(VariableId::AlarmConditionType_SilenceState_TrueState),
            16388 => Ok(VariableId::AlarmConditionType_SilenceState_FalseState),
            16389 => Ok(VariableId::AlarmConditionType_AudibleEnabled),
            16390 => Ok(VariableId::AlarmConditionType_AudibleSound),
            16395 => Ok(VariableId::AlarmConditionType_OnDelay),
            16396 => Ok(VariableId::AlarmConditionType_OffDelay),
            16397 => Ok(VariableId::AlarmConditionType_FirstInGroupFlag),
            16400 => Ok(VariableId::AlarmConditionType_ReAlarmTime),
            16401 => Ok(VariableId::AlarmConditionType_ReAlarmRepeatCount),
            16407 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EventId),
            16408 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EventType),
            16409 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SourceNode),
            16410 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SourceName),
            16411 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Time),
            16412 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ReceiveTime),
            16413 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LocalTime),
            16414 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Message),
            16415 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Severity),
            16416 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionClassId),
            16417 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionClassName),
            16418 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionSubClassId),
            16419 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionSubClassName),
            16420 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConditionName),
            16421 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_BranchId),
            16422 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Retain),
            16423 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState),
            16424 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Id),
            16425 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Name),
            16426 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_Number),
            16427 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_EffectiveDisplayName),
            16428 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_TransitionTime),
            16429 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_EffectiveTransitionTime),
            16430 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_TrueState),
            16431 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_EnabledState_FalseState),
            16432 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Quality),
            16433 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Quality_SourceTimestamp),
            16434 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LastSeverity),
            16435 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LastSeverity_SourceTimestamp),
            16436 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Comment),
            16437 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Comment_SourceTimestamp),
            16438 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ClientUserId),
            16442 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AddComment_InputArguments),
            16443 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState),
            16444 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Id),
            16445 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Name),
            16446 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_Number),
            16447 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_EffectiveDisplayName),
            16448 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_TransitionTime),
            16449 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_EffectiveTransitionTime),
            16450 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_TrueState),
            16451 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AckedState_FalseState),
            16452 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState),
            16453 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Id),
            16454 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Name),
            16455 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_Number),
            16456 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_EffectiveDisplayName),
            16457 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_TransitionTime),
            16458 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_EffectiveTransitionTime),
            16459 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_TrueState),
            16460 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ConfirmedState_FalseState),
            16462 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Acknowledge_InputArguments),
            16464 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_Confirm_InputArguments),
            16465 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState),
            16466 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Id),
            16467 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Name),
            16468 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_Number),
            16469 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_EffectiveDisplayName),
            16470 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_TransitionTime),
            16471 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_EffectiveTransitionTime),
            16472 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_TrueState),
            16473 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ActiveState_FalseState),
            16474 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_InputNode),
            16475 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState),
            16476 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Id),
            16477 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Name),
            16478 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_Number),
            16479 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_EffectiveDisplayName),
            16480 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_TransitionTime),
            16481 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_EffectiveTransitionTime),
            16482 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_TrueState),
            16483 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedState_FalseState),
            16484 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState),
            16485 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Id),
            16486 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Name),
            16487 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_Number),
            16488 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_EffectiveDisplayName),
            16489 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_TransitionTime),
            16490 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_EffectiveTransitionTime),
            16491 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_TrueState),
            16492 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OutOfServiceState_FalseState),
            16493 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState),
            16494 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Id),
            16495 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Name),
            16496 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_Number),
            16497 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_EffectiveDisplayName),
            16498 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_TransitionTime),
            16499 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_EffectiveTransitionTime),
            16500 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_TrueState),
            16501 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SilenceState_FalseState),
            16503 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState),
            16504 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Id),
            16505 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Name),
            16506 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_Number),
            16507 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_CurrentState_EffectiveDisplayName),
            16508 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition),
            16509 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Id),
            16510 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Name),
            16511 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_Number),
            16512 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_TransitionTime),
            16513 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_LastTransition_EffectiveTransitionTime),
            16514 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_UnshelveTime),
            16518 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_TimedShelve_InputArguments),
            16519 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_SuppressedOrShelved),
            16520 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_MaxTimeShelved),
            16521 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleEnabled),
            16522 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound),
            16523 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            16527 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OnDelay),
            16528 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_OffDelay),
            16529 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_FirstInGroupFlag),
            16531 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ReAlarmTime),
            16532 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ReAlarmRepeatCount),
            16536 => Ok(VariableId::LimitAlarmType_ConditionSubClassId),
            16537 => Ok(VariableId::LimitAlarmType_ConditionSubClassName),
            16538 => Ok(VariableId::LimitAlarmType_OutOfServiceState),
            16539 => Ok(VariableId::LimitAlarmType_OutOfServiceState_Id),
            16540 => Ok(VariableId::LimitAlarmType_OutOfServiceState_Name),
            16541 => Ok(VariableId::LimitAlarmType_OutOfServiceState_Number),
            16542 => Ok(VariableId::LimitAlarmType_OutOfServiceState_EffectiveDisplayName),
            16543 => Ok(VariableId::LimitAlarmType_OutOfServiceState_TransitionTime),
            16544 => Ok(VariableId::LimitAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16545 => Ok(VariableId::LimitAlarmType_OutOfServiceState_TrueState),
            16546 => Ok(VariableId::LimitAlarmType_OutOfServiceState_FalseState),
            16547 => Ok(VariableId::LimitAlarmType_SilenceState),
            16548 => Ok(VariableId::LimitAlarmType_SilenceState_Id),
            16549 => Ok(VariableId::LimitAlarmType_SilenceState_Name),
            16550 => Ok(VariableId::LimitAlarmType_SilenceState_Number),
            16551 => Ok(VariableId::LimitAlarmType_SilenceState_EffectiveDisplayName),
            16552 => Ok(VariableId::LimitAlarmType_SilenceState_TransitionTime),
            16553 => Ok(VariableId::LimitAlarmType_SilenceState_EffectiveTransitionTime),
            16554 => Ok(VariableId::LimitAlarmType_SilenceState_TrueState),
            16555 => Ok(VariableId::LimitAlarmType_SilenceState_FalseState),
            16556 => Ok(VariableId::LimitAlarmType_AudibleEnabled),
            16557 => Ok(VariableId::LimitAlarmType_AudibleSound),
            16558 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup_InputArguments),
            16559 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup_OutputArguments),
            16561 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup_InputArguments),
            16562 => Ok(VariableId::LimitAlarmType_OnDelay),
            16563 => Ok(VariableId::LimitAlarmType_OffDelay),
            16564 => Ok(VariableId::LimitAlarmType_FirstInGroupFlag),
            16567 => Ok(VariableId::LimitAlarmType_ReAlarmTime),
            16568 => Ok(VariableId::LimitAlarmType_ReAlarmRepeatCount),
            16571 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup_OutputArguments),
            16572 => Ok(VariableId::LimitAlarmType_BaseHighHighLimit),
            16573 => Ok(VariableId::LimitAlarmType_BaseHighLimit),
            16574 => Ok(VariableId::LimitAlarmType_BaseLowLimit),
            16575 => Ok(VariableId::LimitAlarmType_BaseLowLowLimit),
            16576 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionSubClassId),
            16577 => Ok(VariableId::ExclusiveLimitAlarmType_ConditionSubClassName),
            16578 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState),
            16579 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_Id),
            16580 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_Name),
            16581 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_Number),
            16582 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_EffectiveDisplayName),
            16583 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_TransitionTime),
            16584 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16585 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_TrueState),
            16586 => Ok(VariableId::ExclusiveLimitAlarmType_OutOfServiceState_FalseState),
            16587 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState),
            16588 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_Id),
            16589 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_Name),
            16590 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_Number),
            16591 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_EffectiveDisplayName),
            16592 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_TransitionTime),
            16593 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_EffectiveTransitionTime),
            16594 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_TrueState),
            16595 => Ok(VariableId::ExclusiveLimitAlarmType_SilenceState_FalseState),
            16596 => Ok(VariableId::ExclusiveLimitAlarmType_AudibleEnabled),
            16597 => Ok(VariableId::ExclusiveLimitAlarmType_AudibleSound),
            16599 => Ok(VariableId::PublishSubscribeType_AddConnection_InputArguments),
            16600 => Ok(VariableId::PublishSubscribeType_AddConnection_OutputArguments),
            16602 => Ok(VariableId::ExclusiveLimitAlarmType_OnDelay),
            16603 => Ok(VariableId::ExclusiveLimitAlarmType_OffDelay),
            16604 => Ok(VariableId::ExclusiveLimitAlarmType_FirstInGroupFlag),
            16607 => Ok(VariableId::ExclusiveLimitAlarmType_ReAlarmTime),
            16608 => Ok(VariableId::ExclusiveLimitAlarmType_ReAlarmRepeatCount),
            16611 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments),
            16612 => Ok(VariableId::ExclusiveLimitAlarmType_BaseHighHighLimit),
            16613 => Ok(VariableId::ExclusiveLimitAlarmType_BaseHighLimit),
            16614 => Ok(VariableId::ExclusiveLimitAlarmType_BaseLowLimit),
            16615 => Ok(VariableId::ExclusiveLimitAlarmType_BaseLowLowLimit),
            16616 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionSubClassId),
            16617 => Ok(VariableId::NonExclusiveLimitAlarmType_ConditionSubClassName),
            16618 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState),
            16619 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_Id),
            16620 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_Name),
            16621 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_Number),
            16622 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_EffectiveDisplayName),
            16623 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_TransitionTime),
            16624 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16625 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_TrueState),
            16626 => Ok(VariableId::NonExclusiveLimitAlarmType_OutOfServiceState_FalseState),
            16627 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState),
            16628 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_Id),
            16629 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_Name),
            16630 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_Number),
            16631 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_EffectiveDisplayName),
            16632 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_TransitionTime),
            16633 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_EffectiveTransitionTime),
            16634 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_TrueState),
            16635 => Ok(VariableId::NonExclusiveLimitAlarmType_SilenceState_FalseState),
            16636 => Ok(VariableId::NonExclusiveLimitAlarmType_AudibleEnabled),
            16637 => Ok(VariableId::NonExclusiveLimitAlarmType_AudibleSound),
            16638 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments),
            16640 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate_InputArguments),
            16641 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments),
            16642 => Ok(VariableId::NonExclusiveLimitAlarmType_OnDelay),
            16643 => Ok(VariableId::NonExclusiveLimitAlarmType_OffDelay),
            16644 => Ok(VariableId::NonExclusiveLimitAlarmType_FirstInGroupFlag),
            16647 => Ok(VariableId::NonExclusiveLimitAlarmType_ReAlarmTime),
            16648 => Ok(VariableId::NonExclusiveLimitAlarmType_ReAlarmRepeatCount),
            16652 => Ok(VariableId::NonExclusiveLimitAlarmType_BaseHighHighLimit),
            16653 => Ok(VariableId::NonExclusiveLimitAlarmType_BaseHighLimit),
            16654 => Ok(VariableId::NonExclusiveLimitAlarmType_BaseLowLimit),
            16655 => Ok(VariableId::NonExclusiveLimitAlarmType_BaseLowLowLimit),
            16656 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionSubClassId),
            16657 => Ok(VariableId::NonExclusiveLevelAlarmType_ConditionSubClassName),
            16658 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState),
            16659 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_Id),
            16660 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_Name),
            16661 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_Number),
            16662 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_EffectiveDisplayName),
            16663 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_TransitionTime),
            16664 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16665 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_TrueState),
            16666 => Ok(VariableId::NonExclusiveLevelAlarmType_OutOfServiceState_FalseState),
            16667 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState),
            16668 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_Id),
            16669 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_Name),
            16670 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_Number),
            16671 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_EffectiveDisplayName),
            16672 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_TransitionTime),
            16673 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_EffectiveTransitionTime),
            16674 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_TrueState),
            16675 => Ok(VariableId::NonExclusiveLevelAlarmType_SilenceState_FalseState),
            16676 => Ok(VariableId::NonExclusiveLevelAlarmType_AudibleEnabled),
            16677 => Ok(VariableId::NonExclusiveLevelAlarmType_AudibleSound),
            16678 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddDataSetFolder_InputArguments),
            16679 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_AddDataSetFolder_OutputArguments),
            16681 => Ok(VariableId::PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder_InputArguments),
            16682 => Ok(VariableId::NonExclusiveLevelAlarmType_OnDelay),
            16683 => Ok(VariableId::NonExclusiveLevelAlarmType_OffDelay),
            16684 => Ok(VariableId::NonExclusiveLevelAlarmType_FirstInGroupFlag),
            16687 => Ok(VariableId::NonExclusiveLevelAlarmType_ReAlarmTime),
            16688 => Ok(VariableId::NonExclusiveLevelAlarmType_ReAlarmRepeatCount),
            16692 => Ok(VariableId::NonExclusiveLevelAlarmType_BaseHighHighLimit),
            16693 => Ok(VariableId::NonExclusiveLevelAlarmType_BaseHighLimit),
            16694 => Ok(VariableId::NonExclusiveLevelAlarmType_BaseLowLimit),
            16695 => Ok(VariableId::NonExclusiveLevelAlarmType_BaseLowLowLimit),
            16696 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionSubClassId),
            16697 => Ok(VariableId::ExclusiveLevelAlarmType_ConditionSubClassName),
            16698 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState),
            16699 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_Id),
            16700 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_Name),
            16701 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_Number),
            16702 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_EffectiveDisplayName),
            16703 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_TransitionTime),
            16704 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16705 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_TrueState),
            16706 => Ok(VariableId::ExclusiveLevelAlarmType_OutOfServiceState_FalseState),
            16707 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState),
            16708 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_Id),
            16709 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_Name),
            16710 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_Number),
            16711 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_EffectiveDisplayName),
            16712 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_TransitionTime),
            16713 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_EffectiveTransitionTime),
            16714 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_TrueState),
            16715 => Ok(VariableId::ExclusiveLevelAlarmType_SilenceState_FalseState),
            16716 => Ok(VariableId::ExclusiveLevelAlarmType_AudibleEnabled),
            16717 => Ok(VariableId::ExclusiveLevelAlarmType_AudibleSound),
            16718 => Ok(VariableId::AddConnectionMethodType_InputArguments),
            16719 => Ok(VariableId::AddConnectionMethodType_OutputArguments),
            16720 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_DataSetWriterId),
            16721 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_DataSetFieldContentMask),
            16722 => Ok(VariableId::ExclusiveLevelAlarmType_OnDelay),
            16723 => Ok(VariableId::ExclusiveLevelAlarmType_OffDelay),
            16724 => Ok(VariableId::ExclusiveLevelAlarmType_FirstInGroupFlag),
            16727 => Ok(VariableId::ExclusiveLevelAlarmType_ReAlarmTime),
            16728 => Ok(VariableId::ExclusiveLevelAlarmType_ReAlarmRepeatCount),
            16731 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_KeyFrameCount),
            16732 => Ok(VariableId::ExclusiveLevelAlarmType_BaseHighHighLimit),
            16733 => Ok(VariableId::ExclusiveLevelAlarmType_BaseHighLimit),
            16734 => Ok(VariableId::ExclusiveLevelAlarmType_BaseLowLimit),
            16735 => Ok(VariableId::ExclusiveLevelAlarmType_BaseLowLowLimit),
            16736 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionSubClassId),
            16737 => Ok(VariableId::NonExclusiveDeviationAlarmType_ConditionSubClassName),
            16738 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState),
            16739 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_Id),
            16740 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_Name),
            16741 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_Number),
            16742 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_EffectiveDisplayName),
            16743 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_TransitionTime),
            16744 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16745 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_TrueState),
            16746 => Ok(VariableId::NonExclusiveDeviationAlarmType_OutOfServiceState_FalseState),
            16747 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState),
            16748 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_Id),
            16749 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_Name),
            16750 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_Number),
            16751 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_EffectiveDisplayName),
            16752 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_TransitionTime),
            16753 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_EffectiveTransitionTime),
            16754 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_TrueState),
            16755 => Ok(VariableId::NonExclusiveDeviationAlarmType_SilenceState_FalseState),
            16756 => Ok(VariableId::NonExclusiveDeviationAlarmType_AudibleEnabled),
            16757 => Ok(VariableId::NonExclusiveDeviationAlarmType_AudibleSound),
            16759 => Ok(VariableId::PublishedDataSetType_DataSetClassId),
            16760 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetWriterId),
            16761 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetFieldContentMask),
            16762 => Ok(VariableId::NonExclusiveDeviationAlarmType_OnDelay),
            16763 => Ok(VariableId::NonExclusiveDeviationAlarmType_OffDelay),
            16764 => Ok(VariableId::NonExclusiveDeviationAlarmType_FirstInGroupFlag),
            16767 => Ok(VariableId::NonExclusiveDeviationAlarmType_ReAlarmTime),
            16768 => Ok(VariableId::NonExclusiveDeviationAlarmType_ReAlarmRepeatCount),
            16771 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_KeyFrameCount),
            16772 => Ok(VariableId::NonExclusiveDeviationAlarmType_BaseHighHighLimit),
            16773 => Ok(VariableId::NonExclusiveDeviationAlarmType_BaseHighLimit),
            16774 => Ok(VariableId::NonExclusiveDeviationAlarmType_BaseLowLimit),
            16775 => Ok(VariableId::NonExclusiveDeviationAlarmType_BaseLowLowLimit),
            16776 => Ok(VariableId::NonExclusiveDeviationAlarmType_BaseSetpointNode),
            16777 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionSubClassId),
            16778 => Ok(VariableId::ExclusiveDeviationAlarmType_ConditionSubClassName),
            16779 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState),
            16780 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_Id),
            16781 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_Name),
            16782 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_Number),
            16783 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_EffectiveDisplayName),
            16784 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_TransitionTime),
            16785 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16786 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_TrueState),
            16787 => Ok(VariableId::ExclusiveDeviationAlarmType_OutOfServiceState_FalseState),
            16788 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState),
            16789 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_Id),
            16790 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_Name),
            16791 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_Number),
            16792 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_EffectiveDisplayName),
            16793 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_TransitionTime),
            16794 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_EffectiveTransitionTime),
            16795 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_TrueState),
            16796 => Ok(VariableId::ExclusiveDeviationAlarmType_SilenceState_FalseState),
            16797 => Ok(VariableId::ExclusiveDeviationAlarmType_AudibleEnabled),
            16798 => Ok(VariableId::ExclusiveDeviationAlarmType_AudibleSound),
            16800 => Ok(VariableId::PublishedDataItemsType_DataSetClassId),
            16801 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_DataSetWriterId),
            16802 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_DataSetFieldContentMask),
            16803 => Ok(VariableId::ExclusiveDeviationAlarmType_OnDelay),
            16804 => Ok(VariableId::ExclusiveDeviationAlarmType_OffDelay),
            16805 => Ok(VariableId::ExclusiveDeviationAlarmType_FirstInGroupFlag),
            16808 => Ok(VariableId::ExclusiveDeviationAlarmType_ReAlarmTime),
            16809 => Ok(VariableId::ExclusiveDeviationAlarmType_ReAlarmRepeatCount),
            16812 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_KeyFrameCount),
            16813 => Ok(VariableId::ExclusiveDeviationAlarmType_BaseHighHighLimit),
            16814 => Ok(VariableId::ExclusiveDeviationAlarmType_BaseHighLimit),
            16815 => Ok(VariableId::ExclusiveDeviationAlarmType_BaseLowLimit),
            16816 => Ok(VariableId::ExclusiveDeviationAlarmType_BaseLowLowLimit),
            16817 => Ok(VariableId::ExclusiveDeviationAlarmType_BaseSetpointNode),
            16818 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionSubClassId),
            16819 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ConditionSubClassName),
            16820 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState),
            16821 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Id),
            16822 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Name),
            16823 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_Number),
            16824 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveDisplayName),
            16825 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_TransitionTime),
            16826 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16827 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_TrueState),
            16828 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OutOfServiceState_FalseState),
            16829 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState),
            16830 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_Id),
            16831 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_Name),
            16832 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_Number),
            16833 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_EffectiveDisplayName),
            16834 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_TransitionTime),
            16835 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_EffectiveTransitionTime),
            16836 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_TrueState),
            16837 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_SilenceState_FalseState),
            16838 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AudibleEnabled),
            16839 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AudibleSound),
            16841 => Ok(VariableId::PublishedEventsType_DataSetClassId),
            16843 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate_InputArguments),
            16844 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OnDelay),
            16845 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_OffDelay),
            16846 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_FirstInGroupFlag),
            16849 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ReAlarmTime),
            16850 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ReAlarmRepeatCount),
            16853 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate_OutputArguments),
            16854 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_BaseHighHighLimit),
            16855 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_BaseHighLimit),
            16856 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_BaseLowLimit),
            16857 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_BaseLowLowLimit),
            16858 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_EngineeringUnits),
            16859 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionSubClassId),
            16860 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ConditionSubClassName),
            16861 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState),
            16862 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_Id),
            16863 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_Name),
            16864 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_Number),
            16865 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveDisplayName),
            16866 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_TransitionTime),
            16867 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16868 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_TrueState),
            16869 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OutOfServiceState_FalseState),
            16870 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState),
            16871 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_Id),
            16872 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_Name),
            16873 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_Number),
            16874 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_EffectiveDisplayName),
            16875 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_TransitionTime),
            16876 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_EffectiveTransitionTime),
            16877 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_TrueState),
            16878 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_SilenceState_FalseState),
            16879 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AudibleEnabled),
            16880 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AudibleSound),
            16882 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate_InputArguments),
            16883 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate_OutputArguments),
            16885 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OnDelay),
            16886 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_OffDelay),
            16887 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_FirstInGroupFlag),
            16890 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ReAlarmTime),
            16891 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ReAlarmRepeatCount),
            16894 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder_InputArguments),
            16895 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_BaseHighHighLimit),
            16896 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_BaseHighLimit),
            16897 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_BaseLowLimit),
            16898 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_BaseLowLowLimit),
            16899 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_EngineeringUnits),
            16900 => Ok(VariableId::DiscreteAlarmType_ConditionSubClassId),
            16901 => Ok(VariableId::DiscreteAlarmType_ConditionSubClassName),
            16902 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState),
            16903 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_Id),
            16904 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_Name),
            16905 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_Number),
            16906 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_EffectiveDisplayName),
            16907 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_TransitionTime),
            16908 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16909 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_TrueState),
            16910 => Ok(VariableId::DiscreteAlarmType_OutOfServiceState_FalseState),
            16911 => Ok(VariableId::DiscreteAlarmType_SilenceState),
            16912 => Ok(VariableId::DiscreteAlarmType_SilenceState_Id),
            16913 => Ok(VariableId::DiscreteAlarmType_SilenceState_Name),
            16914 => Ok(VariableId::DiscreteAlarmType_SilenceState_Number),
            16915 => Ok(VariableId::DiscreteAlarmType_SilenceState_EffectiveDisplayName),
            16916 => Ok(VariableId::DiscreteAlarmType_SilenceState_TransitionTime),
            16917 => Ok(VariableId::DiscreteAlarmType_SilenceState_EffectiveTransitionTime),
            16918 => Ok(VariableId::DiscreteAlarmType_SilenceState_TrueState),
            16919 => Ok(VariableId::DiscreteAlarmType_SilenceState_FalseState),
            16920 => Ok(VariableId::DiscreteAlarmType_AudibleEnabled),
            16921 => Ok(VariableId::DiscreteAlarmType_AudibleSound),
            16922 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder_OutputArguments),
            16924 => Ok(VariableId::DataSetFolderType_DataSetFolderName_Placeholder_RemoveDataSetFolder_InputArguments),
            16925 => Ok(VariableId::DataSetFolderType_PublishedDataSetName_Placeholder_DataSetClassId),
            16926 => Ok(VariableId::DiscreteAlarmType_OnDelay),
            16927 => Ok(VariableId::DiscreteAlarmType_OffDelay),
            16928 => Ok(VariableId::DiscreteAlarmType_FirstInGroupFlag),
            16931 => Ok(VariableId::DiscreteAlarmType_ReAlarmTime),
            16932 => Ok(VariableId::DiscreteAlarmType_ReAlarmRepeatCount),
            16936 => Ok(VariableId::OffNormalAlarmType_ConditionSubClassId),
            16937 => Ok(VariableId::OffNormalAlarmType_ConditionSubClassName),
            16938 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState),
            16939 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_Id),
            16940 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_Name),
            16941 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_Number),
            16942 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_EffectiveDisplayName),
            16943 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_TransitionTime),
            16944 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16945 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_TrueState),
            16946 => Ok(VariableId::OffNormalAlarmType_OutOfServiceState_FalseState),
            16947 => Ok(VariableId::OffNormalAlarmType_SilenceState),
            16948 => Ok(VariableId::OffNormalAlarmType_SilenceState_Id),
            16949 => Ok(VariableId::OffNormalAlarmType_SilenceState_Name),
            16950 => Ok(VariableId::OffNormalAlarmType_SilenceState_Number),
            16951 => Ok(VariableId::OffNormalAlarmType_SilenceState_EffectiveDisplayName),
            16952 => Ok(VariableId::OffNormalAlarmType_SilenceState_TransitionTime),
            16953 => Ok(VariableId::OffNormalAlarmType_SilenceState_EffectiveTransitionTime),
            16954 => Ok(VariableId::OffNormalAlarmType_SilenceState_TrueState),
            16955 => Ok(VariableId::OffNormalAlarmType_SilenceState_FalseState),
            16956 => Ok(VariableId::OffNormalAlarmType_AudibleEnabled),
            16957 => Ok(VariableId::OffNormalAlarmType_AudibleSound),
            16958 => Ok(VariableId::DataSetFolderType_AddPublishedDataItemsTemplate_InputArguments),
            16959 => Ok(VariableId::DataSetFolderType_AddPublishedDataItemsTemplate_OutputArguments),
            16961 => Ok(VariableId::DataSetFolderType_AddPublishedEventsTemplate_InputArguments),
            16962 => Ok(VariableId::OffNormalAlarmType_OnDelay),
            16963 => Ok(VariableId::OffNormalAlarmType_OffDelay),
            16964 => Ok(VariableId::OffNormalAlarmType_FirstInGroupFlag),
            16967 => Ok(VariableId::OffNormalAlarmType_ReAlarmTime),
            16968 => Ok(VariableId::OffNormalAlarmType_ReAlarmRepeatCount),
            16971 => Ok(VariableId::DataSetFolderType_AddPublishedEventsTemplate_OutputArguments),
            16972 => Ok(VariableId::SystemOffNormalAlarmType_ConditionSubClassId),
            16973 => Ok(VariableId::SystemOffNormalAlarmType_ConditionSubClassName),
            16974 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState),
            16975 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_Id),
            16976 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_Name),
            16977 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_Number),
            16978 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_EffectiveDisplayName),
            16979 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_TransitionTime),
            16980 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_EffectiveTransitionTime),
            16981 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_TrueState),
            16982 => Ok(VariableId::SystemOffNormalAlarmType_OutOfServiceState_FalseState),
            16983 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState),
            16984 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_Id),
            16985 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_Name),
            16986 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_Number),
            16987 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_EffectiveDisplayName),
            16988 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_TransitionTime),
            16989 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_EffectiveTransitionTime),
            16990 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_TrueState),
            16991 => Ok(VariableId::SystemOffNormalAlarmType_SilenceState_FalseState),
            16992 => Ok(VariableId::SystemOffNormalAlarmType_AudibleEnabled),
            16993 => Ok(VariableId::SystemOffNormalAlarmType_AudibleSound),
            16995 => Ok(VariableId::DataSetFolderType_AddDataSetFolder_InputArguments),
            16996 => Ok(VariableId::DataSetFolderType_AddDataSetFolder_OutputArguments),
            16998 => Ok(VariableId::SystemOffNormalAlarmType_OnDelay),
            16999 => Ok(VariableId::SystemOffNormalAlarmType_OffDelay),
            17000 => Ok(VariableId::SystemOffNormalAlarmType_FirstInGroupFlag),
            17003 => Ok(VariableId::SystemOffNormalAlarmType_ReAlarmTime),
            17004 => Ok(VariableId::SystemOffNormalAlarmType_ReAlarmRepeatCount),
            17007 => Ok(VariableId::DataSetFolderType_RemoveDataSetFolder_InputArguments),
            17008 => Ok(VariableId::TripAlarmType_ConditionSubClassId),
            17009 => Ok(VariableId::TripAlarmType_ConditionSubClassName),
            17010 => Ok(VariableId::TripAlarmType_OutOfServiceState),
            17011 => Ok(VariableId::TripAlarmType_OutOfServiceState_Id),
            17012 => Ok(VariableId::TripAlarmType_OutOfServiceState_Name),
            17013 => Ok(VariableId::TripAlarmType_OutOfServiceState_Number),
            17014 => Ok(VariableId::TripAlarmType_OutOfServiceState_EffectiveDisplayName),
            17015 => Ok(VariableId::TripAlarmType_OutOfServiceState_TransitionTime),
            17016 => Ok(VariableId::TripAlarmType_OutOfServiceState_EffectiveTransitionTime),
            17017 => Ok(VariableId::TripAlarmType_OutOfServiceState_TrueState),
            17018 => Ok(VariableId::TripAlarmType_OutOfServiceState_FalseState),
            17019 => Ok(VariableId::TripAlarmType_SilenceState),
            17020 => Ok(VariableId::TripAlarmType_SilenceState_Id),
            17021 => Ok(VariableId::TripAlarmType_SilenceState_Name),
            17022 => Ok(VariableId::TripAlarmType_SilenceState_Number),
            17023 => Ok(VariableId::TripAlarmType_SilenceState_EffectiveDisplayName),
            17024 => Ok(VariableId::TripAlarmType_SilenceState_TransitionTime),
            17025 => Ok(VariableId::TripAlarmType_SilenceState_EffectiveTransitionTime),
            17026 => Ok(VariableId::TripAlarmType_SilenceState_TrueState),
            17027 => Ok(VariableId::TripAlarmType_SilenceState_FalseState),
            17028 => Ok(VariableId::TripAlarmType_AudibleEnabled),
            17029 => Ok(VariableId::TripAlarmType_AudibleSound),
            17031 => Ok(VariableId::AddPublishedDataItemsTemplateMethodType_InputArguments),
            17032 => Ok(VariableId::AddPublishedDataItemsTemplateMethodType_OutputArguments),
            17034 => Ok(VariableId::TripAlarmType_OnDelay),
            17035 => Ok(VariableId::TripAlarmType_OffDelay),
            17036 => Ok(VariableId::TripAlarmType_FirstInGroupFlag),
            17039 => Ok(VariableId::TripAlarmType_ReAlarmTime),
            17040 => Ok(VariableId::TripAlarmType_ReAlarmRepeatCount),
            17043 => Ok(VariableId::AddPublishedEventsTemplateMethodType_InputArguments),
            17044 => Ok(VariableId::CertificateExpirationAlarmType_ConditionSubClassId),
            17045 => Ok(VariableId::CertificateExpirationAlarmType_ConditionSubClassName),
            17046 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState),
            17047 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_Id),
            17048 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_Name),
            17049 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_Number),
            17050 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_EffectiveDisplayName),
            17051 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_TransitionTime),
            17052 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_EffectiveTransitionTime),
            17053 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_TrueState),
            17054 => Ok(VariableId::CertificateExpirationAlarmType_OutOfServiceState_FalseState),
            17055 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState),
            17056 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_Id),
            17057 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_Name),
            17058 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_Number),
            17059 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_EffectiveDisplayName),
            17060 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_TransitionTime),
            17061 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_EffectiveTransitionTime),
            17062 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_TrueState),
            17063 => Ok(VariableId::CertificateExpirationAlarmType_SilenceState_FalseState),
            17064 => Ok(VariableId::CertificateExpirationAlarmType_AudibleEnabled),
            17065 => Ok(VariableId::CertificateExpirationAlarmType_AudibleSound),
            17066 => Ok(VariableId::AddPublishedEventsTemplateMethodType_OutputArguments),
            17068 => Ok(VariableId::AddDataSetFolderMethodType_InputArguments),
            17069 => Ok(VariableId::AddDataSetFolderMethodType_OutputArguments),
            17070 => Ok(VariableId::CertificateExpirationAlarmType_OnDelay),
            17071 => Ok(VariableId::CertificateExpirationAlarmType_OffDelay),
            17072 => Ok(VariableId::CertificateExpirationAlarmType_FirstInGroupFlag),
            17075 => Ok(VariableId::CertificateExpirationAlarmType_ReAlarmTime),
            17076 => Ok(VariableId::CertificateExpirationAlarmType_ReAlarmRepeatCount),
            17081 => Ok(VariableId::DiscrepancyAlarmType_EventId),
            17082 => Ok(VariableId::DiscrepancyAlarmType_EventType),
            17083 => Ok(VariableId::DiscrepancyAlarmType_SourceNode),
            17084 => Ok(VariableId::DiscrepancyAlarmType_SourceName),
            17085 => Ok(VariableId::DiscrepancyAlarmType_Time),
            17086 => Ok(VariableId::DiscrepancyAlarmType_ReceiveTime),
            17087 => Ok(VariableId::DiscrepancyAlarmType_LocalTime),
            17088 => Ok(VariableId::DiscrepancyAlarmType_Message),
            17089 => Ok(VariableId::DiscrepancyAlarmType_Severity),
            17090 => Ok(VariableId::DiscrepancyAlarmType_ConditionClassId),
            17091 => Ok(VariableId::DiscrepancyAlarmType_ConditionClassName),
            17092 => Ok(VariableId::DiscrepancyAlarmType_ConditionSubClassId),
            17093 => Ok(VariableId::DiscrepancyAlarmType_ConditionSubClassName),
            17094 => Ok(VariableId::DiscrepancyAlarmType_ConditionName),
            17095 => Ok(VariableId::DiscrepancyAlarmType_BranchId),
            17096 => Ok(VariableId::DiscrepancyAlarmType_Retain),
            17097 => Ok(VariableId::DiscrepancyAlarmType_EnabledState),
            17098 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_Id),
            17099 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_Name),
            17100 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_Number),
            17101 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_EffectiveDisplayName),
            17102 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_TransitionTime),
            17103 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_EffectiveTransitionTime),
            17104 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_TrueState),
            17105 => Ok(VariableId::DiscrepancyAlarmType_EnabledState_FalseState),
            17106 => Ok(VariableId::DiscrepancyAlarmType_Quality),
            17107 => Ok(VariableId::DiscrepancyAlarmType_Quality_SourceTimestamp),
            17108 => Ok(VariableId::DiscrepancyAlarmType_LastSeverity),
            17109 => Ok(VariableId::DiscrepancyAlarmType_LastSeverity_SourceTimestamp),
            17110 => Ok(VariableId::DiscrepancyAlarmType_Comment),
            17111 => Ok(VariableId::DiscrepancyAlarmType_Comment_SourceTimestamp),
            17112 => Ok(VariableId::DiscrepancyAlarmType_ClientUserId),
            17116 => Ok(VariableId::DiscrepancyAlarmType_AddComment_InputArguments),
            17118 => Ok(VariableId::DiscrepancyAlarmType_ConditionRefresh_InputArguments),
            17120 => Ok(VariableId::DiscrepancyAlarmType_ConditionRefresh2_InputArguments),
            17121 => Ok(VariableId::DiscrepancyAlarmType_AckedState),
            17122 => Ok(VariableId::DiscrepancyAlarmType_AckedState_Id),
            17123 => Ok(VariableId::DiscrepancyAlarmType_AckedState_Name),
            17124 => Ok(VariableId::DiscrepancyAlarmType_AckedState_Number),
            17125 => Ok(VariableId::DiscrepancyAlarmType_AckedState_EffectiveDisplayName),
            17126 => Ok(VariableId::DiscrepancyAlarmType_AckedState_TransitionTime),
            17127 => Ok(VariableId::DiscrepancyAlarmType_AckedState_EffectiveTransitionTime),
            17128 => Ok(VariableId::DiscrepancyAlarmType_AckedState_TrueState),
            17129 => Ok(VariableId::DiscrepancyAlarmType_AckedState_FalseState),
            17130 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState),
            17131 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_Id),
            17132 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_Name),
            17133 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_Number),
            17134 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_EffectiveDisplayName),
            17135 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_TransitionTime),
            17136 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_EffectiveTransitionTime),
            17137 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_TrueState),
            17138 => Ok(VariableId::DiscrepancyAlarmType_ConfirmedState_FalseState),
            17140 => Ok(VariableId::DiscrepancyAlarmType_Acknowledge_InputArguments),
            17142 => Ok(VariableId::DiscrepancyAlarmType_Confirm_InputArguments),
            17143 => Ok(VariableId::DiscrepancyAlarmType_ActiveState),
            17144 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_Id),
            17145 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_Name),
            17146 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_Number),
            17147 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_EffectiveDisplayName),
            17148 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_TransitionTime),
            17149 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_EffectiveTransitionTime),
            17150 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_TrueState),
            17151 => Ok(VariableId::DiscrepancyAlarmType_ActiveState_FalseState),
            17152 => Ok(VariableId::DiscrepancyAlarmType_InputNode),
            17153 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState),
            17154 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_Id),
            17155 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_Name),
            17156 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_Number),
            17157 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_EffectiveDisplayName),
            17158 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_TransitionTime),
            17159 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_EffectiveTransitionTime),
            17160 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_TrueState),
            17161 => Ok(VariableId::DiscrepancyAlarmType_SuppressedState_FalseState),
            17162 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState),
            17163 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_Id),
            17164 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_Name),
            17165 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_Number),
            17166 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_EffectiveDisplayName),
            17167 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_TransitionTime),
            17168 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_EffectiveTransitionTime),
            17169 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_TrueState),
            17170 => Ok(VariableId::DiscrepancyAlarmType_OutOfServiceState_FalseState),
            17171 => Ok(VariableId::DiscrepancyAlarmType_SilenceState),
            17172 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_Id),
            17173 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_Name),
            17174 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_Number),
            17175 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_EffectiveDisplayName),
            17176 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_TransitionTime),
            17177 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_EffectiveTransitionTime),
            17178 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_TrueState),
            17179 => Ok(VariableId::DiscrepancyAlarmType_SilenceState_FalseState),
            17181 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_CurrentState),
            17182 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_CurrentState_Id),
            17183 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_CurrentState_Name),
            17184 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_CurrentState_Number),
            17185 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            17186 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition),
            17187 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition_Id),
            17188 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition_Name),
            17189 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition_Number),
            17190 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition_TransitionTime),
            17191 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            17192 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_UnshelveTime),
            17196 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_TimedShelve_InputArguments),
            17197 => Ok(VariableId::DiscrepancyAlarmType_SuppressedOrShelved),
            17198 => Ok(VariableId::DiscrepancyAlarmType_MaxTimeShelved),
            17199 => Ok(VariableId::DiscrepancyAlarmType_AudibleEnabled),
            17200 => Ok(VariableId::DiscrepancyAlarmType_AudibleSound),
            17201 => Ok(VariableId::RemoveDataSetFolderMethodType_InputArguments),
            17202 => Ok(VariableId::PubSubConnectionType_Address_NetworkInterface),
            17204 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_MaxNetworkMessageSize),
            17205 => Ok(VariableId::DiscrepancyAlarmType_OnDelay),
            17206 => Ok(VariableId::DiscrepancyAlarmType_OffDelay),
            17207 => Ok(VariableId::DiscrepancyAlarmType_FirstInGroupFlag),
            17210 => Ok(VariableId::DiscrepancyAlarmType_ReAlarmTime),
            17211 => Ok(VariableId::DiscrepancyAlarmType_ReAlarmRepeatCount),
            17214 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_WriterGroupId),
            17215 => Ok(VariableId::DiscrepancyAlarmType_TargetValueNode),
            17216 => Ok(VariableId::DiscrepancyAlarmType_ExpectedTime),
            17217 => Ok(VariableId::DiscrepancyAlarmType_Tolerance),
            17222 => Ok(VariableId::AuditConditionCommentEventType_ConditionEventId),
            17223 => Ok(VariableId::AuditConditionAcknowledgeEventType_ConditionEventId),
            17224 => Ok(VariableId::AuditConditionConfirmEventType_ConditionEventId),
            17226 => Ok(VariableId::AuditConditionSuppressionEventType_EventId),
            17227 => Ok(VariableId::AuditConditionSuppressionEventType_EventType),
            17228 => Ok(VariableId::AuditConditionSuppressionEventType_SourceNode),
            17229 => Ok(VariableId::AuditConditionSuppressionEventType_SourceName),
            17230 => Ok(VariableId::AuditConditionSuppressionEventType_Time),
            17231 => Ok(VariableId::AuditConditionSuppressionEventType_ReceiveTime),
            17232 => Ok(VariableId::AuditConditionSuppressionEventType_LocalTime),
            17233 => Ok(VariableId::AuditConditionSuppressionEventType_Message),
            17234 => Ok(VariableId::AuditConditionSuppressionEventType_Severity),
            17235 => Ok(VariableId::AuditConditionSuppressionEventType_ActionTimeStamp),
            17236 => Ok(VariableId::AuditConditionSuppressionEventType_Status),
            17237 => Ok(VariableId::AuditConditionSuppressionEventType_ServerId),
            17238 => Ok(VariableId::AuditConditionSuppressionEventType_ClientAuditEntryId),
            17239 => Ok(VariableId::AuditConditionSuppressionEventType_ClientUserId),
            17240 => Ok(VariableId::AuditConditionSuppressionEventType_MethodId),
            17241 => Ok(VariableId::AuditConditionSuppressionEventType_InputArguments),
            17243 => Ok(VariableId::AuditConditionSilenceEventType_EventId),
            17244 => Ok(VariableId::AuditConditionSilenceEventType_EventType),
            17245 => Ok(VariableId::AuditConditionSilenceEventType_SourceNode),
            17246 => Ok(VariableId::AuditConditionSilenceEventType_SourceName),
            17247 => Ok(VariableId::AuditConditionSilenceEventType_Time),
            17248 => Ok(VariableId::AuditConditionSilenceEventType_ReceiveTime),
            17249 => Ok(VariableId::AuditConditionSilenceEventType_LocalTime),
            17250 => Ok(VariableId::AuditConditionSilenceEventType_Message),
            17251 => Ok(VariableId::AuditConditionSilenceEventType_Severity),
            17252 => Ok(VariableId::AuditConditionSilenceEventType_ActionTimeStamp),
            17253 => Ok(VariableId::AuditConditionSilenceEventType_Status),
            17254 => Ok(VariableId::AuditConditionSilenceEventType_ServerId),
            17255 => Ok(VariableId::AuditConditionSilenceEventType_ClientAuditEntryId),
            17256 => Ok(VariableId::AuditConditionSilenceEventType_ClientUserId),
            17257 => Ok(VariableId::AuditConditionSilenceEventType_MethodId),
            17258 => Ok(VariableId::AuditConditionSilenceEventType_InputArguments),
            17260 => Ok(VariableId::AuditConditionOutOfServiceEventType_EventId),
            17261 => Ok(VariableId::AuditConditionOutOfServiceEventType_EventType),
            17262 => Ok(VariableId::AuditConditionOutOfServiceEventType_SourceNode),
            17263 => Ok(VariableId::AuditConditionOutOfServiceEventType_SourceName),
            17264 => Ok(VariableId::AuditConditionOutOfServiceEventType_Time),
            17265 => Ok(VariableId::AuditConditionOutOfServiceEventType_ReceiveTime),
            17266 => Ok(VariableId::AuditConditionOutOfServiceEventType_LocalTime),
            17267 => Ok(VariableId::AuditConditionOutOfServiceEventType_Message),
            17268 => Ok(VariableId::AuditConditionOutOfServiceEventType_Severity),
            17269 => Ok(VariableId::AuditConditionOutOfServiceEventType_ActionTimeStamp),
            17270 => Ok(VariableId::AuditConditionOutOfServiceEventType_Status),
            17271 => Ok(VariableId::AuditConditionOutOfServiceEventType_ServerId),
            17272 => Ok(VariableId::AuditConditionOutOfServiceEventType_ClientAuditEntryId),
            17273 => Ok(VariableId::AuditConditionOutOfServiceEventType_ClientUserId),
            17274 => Ok(VariableId::AuditConditionOutOfServiceEventType_MethodId),
            17275 => Ok(VariableId::AuditConditionOutOfServiceEventType_InputArguments),
            17278 => Ok(VariableId::AlarmRateVariableType_Rate),
            17280 => Ok(VariableId::AlarmMetricsType_AlarmCount),
            17281 => Ok(VariableId::AlarmMetricsType_MaximumActiveState),
            17282 => Ok(VariableId::AlarmMetricsType_MaximumUnAck),
            17283 => Ok(VariableId::AlarmMetricsType_MaximumReAlarmCount),
            17284 => Ok(VariableId::AlarmMetricsType_CurrentAlarmRate),
            17285 => Ok(VariableId::AlarmMetricsType_CurrentAlarmRate_Rate),
            17286 => Ok(VariableId::AlarmMetricsType_MaximumAlarmRate),
            17287 => Ok(VariableId::AlarmMetricsType_MaximumAlarmRate_Rate),
            17288 => Ok(VariableId::AlarmMetricsType_AverageAlarmRate),
            17289 => Ok(VariableId::AlarmMetricsType_AverageAlarmRate_Rate),
            17292 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri),
            17294 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter_InputArguments),
            17295 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_RestrictToList),
            17297 => Ok(VariableId::PublishSubscribeType_SetSecurityKeys_InputArguments),
            17299 => Ok(VariableId::SetSecurityKeysMethodType_InputArguments),
            17300 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            17301 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter_OutputArguments),
            17302 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_MaxNetworkMessageSize),
            17303 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            17304 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            17305 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            17306 => Ok(VariableId::PubSubConnectionType_TransportProfileUri),
            17309 => Ok(VariableId::PubSubConnectionType_TransportProfileUri_RestrictToList),
            17311 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_SecurityMode),
            17312 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_SecurityGroupId),
            17313 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_SecurityKeyServices),
            17315 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Status_State),
            17318 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_PublishingInterval),
            17319 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_KeepAliveTime),
            17320 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            17321 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Priority),
            17322 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_LocaleIds),
            17324 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_RemoveDataSetWriter_InputArguments),
            17326 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_SecurityMode),
            17327 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_SecurityGroupId),
            17328 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_SecurityKeyServices),
            17330 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Status_State),
            17334 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_RemoveDataSetReader_InputArguments),
            17335 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            17336 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            17337 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            17338 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            17339 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            17340 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            17341 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            17342 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            17343 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            17344 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            17345 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            17346 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            17347 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            17348 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            17349 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            17350 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            17351 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            17353 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress),
            17354 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel),
            17357 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup_InputArguments),
            17358 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup_OutputArguments),
            17360 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup_InputArguments),
            17361 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup_OutputArguments),
            17363 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_RemoveGroup_InputArguments),
            17365 => Ok(VariableId::PublishSubscribe_SetSecurityKeys_InputArguments),
            17367 => Ok(VariableId::PublishSubscribe_AddConnection_InputArguments),
            17368 => Ok(VariableId::PublishSubscribe_AddConnection_OutputArguments),
            17370 => Ok(VariableId::PublishSubscribe_RemoveConnection_InputArguments),
            17373 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedDataItems_InputArguments),
            17374 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedDataItems_OutputArguments),
            17376 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedEvents_InputArguments),
            17377 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedEvents_OutputArguments),
            17379 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_InputArguments),
            17380 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate_OutputArguments),
            17382 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_InputArguments),
            17383 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate_OutputArguments),
            17385 => Ok(VariableId::PublishSubscribe_PublishedDataSets_RemovePublishedDataSet_InputArguments),
            17387 => Ok(VariableId::DataSetReaderType_CreateTargetVariables_InputArguments),
            17388 => Ok(VariableId::DataSetReaderType_CreateTargetVariables_OutputArguments),
            17390 => Ok(VariableId::DataSetReaderType_CreateDataSetMirror_InputArguments),
            17391 => Ok(VariableId::DataSetReaderType_CreateDataSetMirror_OutputArguments),
            17393 => Ok(VariableId::DataSetReaderTypeCreateTargetVariablesMethodType_InputArguments),
            17394 => Ok(VariableId::DataSetReaderTypeCreateTargetVariablesMethodType_OutputArguments),
            17396 => Ok(VariableId::DataSetReaderTypeCreateDataSetMirrorMethodType_InputArguments),
            17397 => Ok(VariableId::DataSetReaderTypeCreateDataSetMirrorMethodType_OutputArguments),
            17399 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader_InputArguments),
            17400 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader_OutputArguments),
            17401 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddDataSetFolder_InputArguments),
            17402 => Ok(VariableId::PublishSubscribe_PublishedDataSets_AddDataSetFolder_OutputArguments),
            17404 => Ok(VariableId::PublishSubscribe_PublishedDataSets_RemoveDataSetFolder_InputArguments),
            17406 => Ok(VariableId::PublishSubscribe_Status_State),
            17410 => Ok(VariableId::PublishSubscribe_Diagnostics_DiagnosticsLevel),
            17411 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalInformation),
            17412 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalInformation_Active),
            17413 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalInformation_Classification),
            17414 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalInformation_DiagnosticsLevel),
            17415 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalInformation_TimeFirstChange),
            17416 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalError),
            17417 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalError_Active),
            17418 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalError_Classification),
            17419 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalError_DiagnosticsLevel),
            17420 => Ok(VariableId::PublishSubscribe_Diagnostics_TotalError_TimeFirstChange),
            17422 => Ok(VariableId::PublishSubscribe_Diagnostics_SubError),
            17424 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateError),
            17425 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateError_Active),
            17426 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateError_Classification),
            17428 => Ok(VariableId::PubSubConnectionType_AddWriterGroup_InputArguments),
            17429 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateError_DiagnosticsLevel),
            17430 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateError_TimeFirstChange),
            17431 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod),
            17432 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Active),
            17433 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_Classification),
            17434 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            17435 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            17436 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByParent),
            17437 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Active),
            17438 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_Classification),
            17439 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            17440 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            17441 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalFromError),
            17442 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Active),
            17443 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_Classification),
            17444 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            17445 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            17446 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StatePausedByParent),
            17447 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Active),
            17448 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StatePausedByParent_Classification),
            17449 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            17450 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            17451 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod),
            17452 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Active),
            17453 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_Classification),
            17454 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            17455 => Ok(VariableId::PublishSubscribe_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            17456 => Ok(VariableId::PubSubConnectionType_AddWriterGroup_OutputArguments),
            17458 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters),
            17459 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            17460 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders),
            17461 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            17462 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters),
            17463 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            17464 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders),
            17466 => Ok(VariableId::PublishSubscribe_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            17469 => Ok(VariableId::OpcUa_BinarySchema_DatagramConnectionTransportDataType),
            17470 => Ok(VariableId::OpcUa_BinarySchema_DatagramConnectionTransportDataType_DataTypeVersion),
            17471 => Ok(VariableId::OpcUa_BinarySchema_DatagramConnectionTransportDataType_DictionaryFragment),
            17477 => Ok(VariableId::UadpDataSetReaderMessageType_DataSetOffset),
            17478 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_ConnectionProperties),
            17479 => Ok(VariableId::PublishSubscribeType_SupportedTransportProfiles),
            17480 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_ConnectionProperties),
            17481 => Ok(VariableId::PublishSubscribe_SupportedTransportProfiles),
            17482 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_DataSetWriterProperties),
            17483 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_DataSetWriterProperties),
            17484 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_DataSetWriterProperties),
            17485 => Ok(VariableId::PubSubConnectionType_ConnectionProperties),
            17486 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_GroupProperties),
            17487 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_GroupProperties),
            17488 => Ok(VariableId::PubSubGroupType_GroupProperties),
            17489 => Ok(VariableId::WriterGroupType_GroupProperties),
            17490 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_DataSetWriterProperties),
            17491 => Ok(VariableId::ReaderGroupType_GroupProperties),
            17492 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_DataSetReaderProperties),
            17493 => Ok(VariableId::DataSetWriterType_DataSetWriterProperties),
            17494 => Ok(VariableId::DataSetReaderType_DataSetReaderProperties),
            17495 => Ok(VariableId::CreateCredentialMethodType_OutputArguments),
            17498 => Ok(VariableId::AnalogUnitType_Definition),
            17499 => Ok(VariableId::AnalogUnitType_ValuePrecision),
            17500 => Ok(VariableId::AnalogUnitType_InstrumentRange),
            17501 => Ok(VariableId::AnalogUnitType_EURange),
            17502 => Ok(VariableId::AnalogUnitType_EngineeringUnits),
            17503 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_Selections),
            17504 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_SelectionDescriptions),
            17505 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Address_NetworkInterface_RestrictToList),
            17506 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_Selections),
            17507 => Ok(VariableId::PubSubConnectionType_AddReaderGroup_InputArguments),
            17508 => Ok(VariableId::PubSubConnectionType_AddReaderGroup_OutputArguments),
            17509 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_SelectionDescriptions),
            17510 => Ok(VariableId::PublishSubscribe_ConnectionName_Placeholder_Address_NetworkInterface_RestrictToList),
            17512 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ResourceUri),
            17513 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ProfileUri),
            17514 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_EndpointUrls),
            17515 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_ServiceStatus),
            17517 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey_InputArguments),
            17518 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey_OutputArguments),
            17520 => Ok(VariableId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_UpdateCredential_InputArguments),
            17523 => Ok(VariableId::KeyCredentialConfigurationFolderType_CreateCredential_InputArguments),
            17524 => Ok(VariableId::KeyCredentialConfigurationFolderType_CreateCredential_OutputArguments),
            17526 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey_InputArguments),
            17527 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey_OutputArguments),
            17529 => Ok(VariableId::KeyCredentialConfiguration_CreateCredential_InputArguments),
            17530 => Ok(VariableId::KeyCredentialConfiguration_CreateCredential_OutputArguments),
            17532 => Ok(VariableId::GetEncryptingKeyMethodType_InputArguments),
            17533 => Ok(VariableId::GetEncryptingKeyMethodType_OutputArguments),
            17535 => Ok(VariableId::KeyCredentialConfigurationType_GetEncryptingKey_InputArguments),
            17536 => Ok(VariableId::KeyCredentialConfigurationType_GetEncryptingKey_OutputArguments),
            17538 => Ok(VariableId::OpcUa_BinarySchema_AdditionalParametersType),
            17539 => Ok(VariableId::OpcUa_BinarySchema_AdditionalParametersType_DataTypeVersion),
            17540 => Ok(VariableId::OpcUa_BinarySchema_AdditionalParametersType_DictionaryFragment),
            17550 => Ok(VariableId::OpcUa_BinarySchema_EphemeralKeyType),
            17551 => Ok(VariableId::OpcUa_BinarySchema_EphemeralKeyType_DataTypeVersion),
            17552 => Ok(VariableId::OpcUa_BinarySchema_EphemeralKeyType_DictionaryFragment),
            17558 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_HeaderLayoutUri),
            17559 => Ok(VariableId::WriterGroupType_HeaderLayoutUri),
            17560 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_KeyFrameCount),
            17562 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_HeaderLayoutUri),
            17563 => Ok(VariableId::DataSetReaderType_KeyFrameCount),
            17564 => Ok(VariableId::DataSetReaderType_HeaderLayoutUri),
            17565 => Ok(VariableId::BaseAnalogType_Definition),
            17566 => Ok(VariableId::BaseAnalogType_ValuePrecision),
            17567 => Ok(VariableId::BaseAnalogType_InstrumentRange),
            17568 => Ok(VariableId::BaseAnalogType_EURange),
            17569 => Ok(VariableId::BaseAnalogType_EngineeringUnits),
            17571 => Ok(VariableId::AnalogUnitRangeType_Definition),
            17572 => Ok(VariableId::AnalogUnitRangeType_ValuePrecision),
            17573 => Ok(VariableId::AnalogUnitRangeType_InstrumentRange),
            17574 => Ok(VariableId::AnalogUnitRangeType_EURange),
            17575 => Ok(VariableId::AnalogUnitRangeType_EngineeringUnits),
            17576 => Ok(VariableId::PubSubConnectionType_Address_NetworkInterface_Selections),
            17577 => Ok(VariableId::PubSubConnectionType_Address_NetworkInterface_SelectionDescriptions),
            17578 => Ok(VariableId::PubSubConnectionType_Address_NetworkInterface_RestrictToList),
            17579 => Ok(VariableId::DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_Selections),
            17580 => Ok(VariableId::DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_SelectionDescriptions),
            17581 => Ok(VariableId::DatagramConnectionTransportType_DiscoveryAddress_NetworkInterface_RestrictToList),
            17582 => Ok(VariableId::NetworkAddressType_NetworkInterface_Selections),
            17583 => Ok(VariableId::NetworkAddressType_NetworkInterface_SelectionDescriptions),
            17584 => Ok(VariableId::NetworkAddressType_NetworkInterface_RestrictToList),
            17585 => Ok(VariableId::NetworkAddressUrlType_NetworkInterface_Selections),
            17586 => Ok(VariableId::NetworkAddressUrlType_NetworkInterface_SelectionDescriptions),
            17587 => Ok(VariableId::NetworkAddressUrlType_NetworkInterface_RestrictToList),
            17605 => Ok(VariableId::DefaultInstanceBrowseName),
            17612 => Ok(VariableId::ServerType_LocalTime),
            17613 => Ok(VariableId::PubSubConnectionTypeAddWriterGroupMethodType_InputArguments),
            17614 => Ok(VariableId::PubSubConnectionTypeAddWriterGroupMethodType_OutputArguments),
            17615 => Ok(VariableId::AuditSecurityEventType_StatusCodeId),
            17616 => Ok(VariableId::AuditChannelEventType_StatusCodeId),
            17617 => Ok(VariableId::AuditOpenSecureChannelEventType_StatusCodeId),
            17618 => Ok(VariableId::AuditSessionEventType_StatusCodeId),
            17619 => Ok(VariableId::AuditCreateSessionEventType_StatusCodeId),
            17620 => Ok(VariableId::AuditUrlMismatchEventType_StatusCodeId),
            17621 => Ok(VariableId::AuditActivateSessionEventType_StatusCodeId),
            17622 => Ok(VariableId::AuditCancelEventType_StatusCodeId),
            17623 => Ok(VariableId::AuditCertificateEventType_StatusCodeId),
            17624 => Ok(VariableId::AuditCertificateDataMismatchEventType_StatusCodeId),
            17625 => Ok(VariableId::AuditCertificateExpiredEventType_StatusCodeId),
            17626 => Ok(VariableId::AuditCertificateInvalidEventType_StatusCodeId),
            17627 => Ok(VariableId::AuditCertificateUntrustedEventType_StatusCodeId),
            17628 => Ok(VariableId::AuditCertificateRevokedEventType_StatusCodeId),
            17629 => Ok(VariableId::AuditCertificateMismatchEventType_StatusCodeId),
            17631 => Ok(VariableId::PubSubConnectionAddReaderGroupGroupMethodType_InputArguments),
            17632 => Ok(VariableId::SelectionListType_Selections),
            17633 => Ok(VariableId::SelectionListType_SelectionDescriptions),
            17634 => Ok(VariableId::Server_LocalTime),
            17635 => Ok(VariableId::FiniteStateMachineType_AvailableStates),
            17636 => Ok(VariableId::FiniteStateMachineType_AvailableTransitions),
            17637 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_AvailableStates),
            17638 => Ok(VariableId::TemporaryFileTransferType_TransferState_Placeholder_AvailableTransitions),
            17639 => Ok(VariableId::FileTransferStateMachineType_AvailableStates),
            17640 => Ok(VariableId::FileTransferStateMachineType_AvailableTransitions),
            17642 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_EventId),
            17643 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_EventType),
            17644 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_SourceNode),
            17645 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_SourceName),
            17646 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_Time),
            17647 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_ReceiveTime),
            17648 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_LocalTime),
            17649 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_Message),
            17650 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_Severity),
            17651 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_ActionTimeStamp),
            17652 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_Status),
            17653 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_ServerId),
            17654 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_ClientAuditEntryId),
            17655 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_ClientUserId),
            17656 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_MethodId),
            17657 => Ok(VariableId::RoleMappingRuleChangedAuditEventType_InputArguments),
            17658 => Ok(VariableId::AlarmConditionType_ShelvingState_AvailableStates),
            17659 => Ok(VariableId::AlarmConditionType_ShelvingState_AvailableTransitions),
            17660 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_AvailableStates),
            17661 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_AvailableTransitions),
            17662 => Ok(VariableId::ShelvedStateMachineType_AvailableStates),
            17663 => Ok(VariableId::ShelvedStateMachineType_AvailableTransitions),
            17664 => Ok(VariableId::LimitAlarmType_ShelvingState_AvailableStates),
            17665 => Ok(VariableId::LimitAlarmType_ShelvingState_AvailableTransitions),
            17666 => Ok(VariableId::ExclusiveLimitStateMachineType_AvailableStates),
            17667 => Ok(VariableId::ExclusiveLimitStateMachineType_AvailableTransitions),
            17668 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_AvailableStates),
            17669 => Ok(VariableId::ExclusiveLimitAlarmType_ShelvingState_AvailableTransitions),
            17670 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_AvailableStates),
            17671 => Ok(VariableId::ExclusiveLimitAlarmType_LimitState_AvailableTransitions),
            17672 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_AvailableStates),
            17673 => Ok(VariableId::NonExclusiveLimitAlarmType_ShelvingState_AvailableTransitions),
            17674 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_AvailableStates),
            17675 => Ok(VariableId::NonExclusiveLevelAlarmType_ShelvingState_AvailableTransitions),
            17676 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_AvailableStates),
            17677 => Ok(VariableId::ExclusiveLevelAlarmType_ShelvingState_AvailableTransitions),
            17678 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_AvailableStates),
            17679 => Ok(VariableId::ExclusiveLevelAlarmType_LimitState_AvailableTransitions),
            17680 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_AvailableStates),
            17681 => Ok(VariableId::NonExclusiveDeviationAlarmType_ShelvingState_AvailableTransitions),
            17682 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_AvailableStates),
            17683 => Ok(VariableId::ExclusiveDeviationAlarmType_ShelvingState_AvailableTransitions),
            17684 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_AvailableStates),
            17685 => Ok(VariableId::ExclusiveDeviationAlarmType_LimitState_AvailableTransitions),
            17686 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_AvailableStates),
            17687 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_ShelvingState_AvailableTransitions),
            17688 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_AvailableStates),
            17689 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_ShelvingState_AvailableTransitions),
            17690 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_AvailableStates),
            17691 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LimitState_AvailableTransitions),
            17692 => Ok(VariableId::DiscreteAlarmType_ShelvingState_AvailableStates),
            17693 => Ok(VariableId::DiscreteAlarmType_ShelvingState_AvailableTransitions),
            17694 => Ok(VariableId::OffNormalAlarmType_ShelvingState_AvailableStates),
            17695 => Ok(VariableId::OffNormalAlarmType_ShelvingState_AvailableTransitions),
            17696 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_AvailableStates),
            17697 => Ok(VariableId::SystemOffNormalAlarmType_ShelvingState_AvailableTransitions),
            17698 => Ok(VariableId::TripAlarmType_ShelvingState_AvailableStates),
            17699 => Ok(VariableId::TripAlarmType_ShelvingState_AvailableTransitions),
            17700 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_AvailableStates),
            17701 => Ok(VariableId::CertificateExpirationAlarmType_ShelvingState_AvailableTransitions),
            17702 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_AvailableStates),
            17703 => Ok(VariableId::DiscrepancyAlarmType_ShelvingState_AvailableTransitions),
            17704 => Ok(VariableId::ProgramStateMachineType_AvailableStates),
            17705 => Ok(VariableId::ProgramStateMachineType_AvailableTransitions),
            17706 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_Selections),
            17707 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_TransportProfileUri_SelectionDescriptions),
            17710 => Ok(VariableId::PubSubConnectionType_TransportProfileUri_Selections),
            17711 => Ok(VariableId::PubSubConnectionType_TransportProfileUri_SelectionDescriptions),
            17712 => Ok(VariableId::RationalNumberType_Numerator),
            17713 => Ok(VariableId::RationalNumberType_Denominator),
            17715 => Ok(VariableId::VectorType_VectorUnit),
            17717 => Ok(VariableId::ThreeDVectorType_VectorUnit),
            17719 => Ok(VariableId::FileDirectoryType_FileDirectoryName_Placeholder_DeleteFileSystemObject_InputArguments),
            17720 => Ok(VariableId::PubSubConnectionAddReaderGroupGroupMethodType_OutputArguments),
            17723 => Ok(VariableId::FileSystem_FileDirectoryName_Placeholder_DeleteFileSystemObject_InputArguments),
            17724 => Ok(VariableId::PubSubGroupType_MaxNetworkMessageSize),
            17726 => Ok(VariableId::WriterGroupType_SecurityMode),
            17727 => Ok(VariableId::WriterGroupType_SecurityGroupId),
            17728 => Ok(VariableId::WriterGroupType_SecurityKeyServices),
            17729 => Ok(VariableId::WriterGroupType_MaxNetworkMessageSize),
            17731 => Ok(VariableId::WriterGroupType_Status_State),
            17736 => Ok(VariableId::WriterGroupType_WriterGroupId),
            17737 => Ok(VariableId::WriterGroupType_PublishingInterval),
            17738 => Ok(VariableId::WriterGroupType_KeepAliveTime),
            17739 => Ok(VariableId::WriterGroupType_Priority),
            17740 => Ok(VariableId::WriterGroupType_LocaleIds),
            17744 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_DataSetWriterId),
            17745 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_DataSetFieldContentMask),
            17746 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_KeyFrameCount),
            17750 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Status_State),
            17754 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel),
            17755 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation),
            17756 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active),
            17757 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification),
            17758 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            17759 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            17760 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError),
            17761 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active),
            17762 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification),
            17763 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            17764 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            17766 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_SubError),
            17768 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError),
            17769 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active),
            17770 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification),
            17771 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            17772 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            17773 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            17774 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            17775 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            17776 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            17777 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            17778 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            17779 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            17780 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            17781 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            17782 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            17783 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            17784 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            17785 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            17786 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            17787 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            17788 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            17789 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            17790 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            17791 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            17792 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            17793 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            17794 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            17795 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            17796 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            17797 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            17799 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages),
            17800 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active),
            17801 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification),
            17802 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            17803 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            17804 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber),
            17805 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            17806 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode),
            17807 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            17808 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion),
            17809 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            17810 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion),
            17811 => Ok(VariableId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            17813 => Ok(VariableId::WriterGroupType_Diagnostics_DiagnosticsLevel),
            17814 => Ok(VariableId::WriterGroupType_Diagnostics_TotalInformation),
            17815 => Ok(VariableId::WriterGroupType_Diagnostics_TotalInformation_Active),
            17816 => Ok(VariableId::WriterGroupType_Diagnostics_TotalInformation_Classification),
            17817 => Ok(VariableId::WriterGroupType_Diagnostics_TotalInformation_DiagnosticsLevel),
            17818 => Ok(VariableId::WriterGroupType_Diagnostics_TotalInformation_TimeFirstChange),
            17819 => Ok(VariableId::WriterGroupType_Diagnostics_TotalError),
            17820 => Ok(VariableId::WriterGroupType_Diagnostics_TotalError_Active),
            17821 => Ok(VariableId::WriterGroupType_Diagnostics_TotalError_Classification),
            17822 => Ok(VariableId::WriterGroupType_Diagnostics_TotalError_DiagnosticsLevel),
            17823 => Ok(VariableId::WriterGroupType_Diagnostics_TotalError_TimeFirstChange),
            17825 => Ok(VariableId::WriterGroupType_Diagnostics_SubError),
            17827 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateError),
            17828 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateError_Active),
            17829 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateError_Classification),
            17830 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            17831 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateError_TimeFirstChange),
            17832 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByMethod),
            17833 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_Active),
            17834 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            17835 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            17836 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            17837 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByParent),
            17838 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByParent_Active),
            17839 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByParent_Classification),
            17840 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            17841 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            17842 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalFromError),
            17843 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalFromError_Active),
            17844 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalFromError_Classification),
            17845 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            17846 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            17847 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StatePausedByParent),
            17848 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StatePausedByParent_Active),
            17849 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StatePausedByParent_Classification),
            17850 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            17851 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            17853 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateDisabledByMethod),
            17854 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_Active),
            17855 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            17856 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            17857 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            17859 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_SentNetworkMessages),
            17860 => Ok(VariableId::AuthorizationServiceConfigurationType_ServiceCertificate),
            17864 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_SentNetworkMessages_Active),
            17865 => Ok(VariableId::AlarmConditionType_AudibleSound_ListId),
            17866 => Ok(VariableId::AlarmConditionType_AudibleSound_AgencyId),
            17867 => Ok(VariableId::AlarmConditionType_AudibleSound_VersionId),
            17871 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_SentNetworkMessages_Classification),
            17872 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_SentNetworkMessages_DiagnosticsLevel),
            17873 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_SentNetworkMessages_TimeFirstChange),
            17874 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_FailedTransmissions),
            17878 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_FailedTransmissions_Active),
            17879 => Ok(VariableId::LimitAlarmType_AudibleSound_ListId),
            17880 => Ok(VariableId::LimitAlarmType_AudibleSound_AgencyId),
            17881 => Ok(VariableId::LimitAlarmType_AudibleSound_VersionId),
            17885 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_FailedTransmissions_Classification),
            17886 => Ok(VariableId::ExclusiveLimitAlarmType_AudibleSound_ListId),
            17887 => Ok(VariableId::ExclusiveLimitAlarmType_AudibleSound_AgencyId),
            17888 => Ok(VariableId::ExclusiveLimitAlarmType_AudibleSound_VersionId),
            17892 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_FailedTransmissions_DiagnosticsLevel),
            17893 => Ok(VariableId::NonExclusiveLimitAlarmType_AudibleSound_ListId),
            17894 => Ok(VariableId::NonExclusiveLimitAlarmType_AudibleSound_AgencyId),
            17895 => Ok(VariableId::NonExclusiveLimitAlarmType_AudibleSound_VersionId),
            17899 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_FailedTransmissions_TimeFirstChange),
            17900 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_EncryptionErrors),
            17901 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_EncryptionErrors_Active),
            17902 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_EncryptionErrors_Classification),
            17903 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_EncryptionErrors_DiagnosticsLevel),
            17906 => Ok(VariableId::WriterGroupType_Diagnostics_Counters_EncryptionErrors_TimeFirstChange),
            17907 => Ok(VariableId::ExclusiveLevelAlarmType_AudibleSound_ListId),
            17908 => Ok(VariableId::ExclusiveLevelAlarmType_AudibleSound_AgencyId),
            17909 => Ok(VariableId::ExclusiveLevelAlarmType_AudibleSound_VersionId),
            17913 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_ConfiguredDataSetWriters),
            17914 => Ok(VariableId::NonExclusiveDeviationAlarmType_AudibleSound_ListId),
            17915 => Ok(VariableId::NonExclusiveDeviationAlarmType_AudibleSound_AgencyId),
            17916 => Ok(VariableId::NonExclusiveDeviationAlarmType_AudibleSound_VersionId),
            17920 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            17921 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AudibleSound_ListId),
            17922 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AudibleSound_AgencyId),
            17923 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_AudibleSound_VersionId),
            17927 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_OperationalDataSetWriters),
            17928 => Ok(VariableId::ExclusiveDeviationAlarmType_AudibleSound_ListId),
            17929 => Ok(VariableId::ExclusiveDeviationAlarmType_AudibleSound_AgencyId),
            17930 => Ok(VariableId::ExclusiveDeviationAlarmType_AudibleSound_VersionId),
            17934 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            17935 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AudibleSound_ListId),
            17936 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AudibleSound_AgencyId),
            17937 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_AudibleSound_VersionId),
            17941 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_SecurityTokenID),
            17942 => Ok(VariableId::DiscreteAlarmType_AudibleSound_ListId),
            17943 => Ok(VariableId::DiscreteAlarmType_AudibleSound_AgencyId),
            17944 => Ok(VariableId::DiscreteAlarmType_AudibleSound_VersionId),
            17948 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel),
            17949 => Ok(VariableId::OffNormalAlarmType_AudibleSound_ListId),
            17950 => Ok(VariableId::OffNormalAlarmType_AudibleSound_AgencyId),
            17951 => Ok(VariableId::OffNormalAlarmType_AudibleSound_VersionId),
            17955 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_TimeToNextTokenID),
            17956 => Ok(VariableId::SystemOffNormalAlarmType_AudibleSound_ListId),
            17957 => Ok(VariableId::SystemOffNormalAlarmType_AudibleSound_AgencyId),
            17958 => Ok(VariableId::SystemOffNormalAlarmType_AudibleSound_VersionId),
            17962 => Ok(VariableId::WriterGroupType_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            17963 => Ok(VariableId::TripAlarmType_AudibleSound_ListId),
            17964 => Ok(VariableId::TripAlarmType_AudibleSound_AgencyId),
            17965 => Ok(VariableId::TripAlarmType_AudibleSound_VersionId),
            17970 => Ok(VariableId::CertificateExpirationAlarmType_AudibleSound_ListId),
            17971 => Ok(VariableId::CertificateExpirationAlarmType_AudibleSound_AgencyId),
            17972 => Ok(VariableId::CertificateExpirationAlarmType_AudibleSound_VersionId),
            17976 => Ok(VariableId::WriterGroupType_AddDataSetWriter_InputArguments),
            17977 => Ok(VariableId::DiscrepancyAlarmType_AudibleSound_ListId),
            17978 => Ok(VariableId::DiscrepancyAlarmType_AudibleSound_AgencyId),
            17979 => Ok(VariableId::DiscrepancyAlarmType_AudibleSound_VersionId),
            17987 => Ok(VariableId::WriterGroupType_AddDataSetWriter_OutputArguments),
            17988 => Ok(VariableId::AudioVariableType_ListId),
            17989 => Ok(VariableId::AudioVariableType_AgencyId),
            17990 => Ok(VariableId::AudioVariableType_VersionId),
            17991 => Ok(VariableId::AlarmMetricsType_StartTime),
            17993 => Ok(VariableId::WriterGroupType_RemoveDataSetWriter_InputArguments),
            17995 => Ok(VariableId::PubSubGroupTypeAddWriterrMethodType_InputArguments),
            17996 => Ok(VariableId::PubSubGroupTypeAddWriterrMethodType_OutputArguments),
            18000 => Ok(VariableId::ReaderGroupType_SecurityMode),
            18002 => Ok(VariableId::ReaderGroupType_SecurityGroupId),
            18003 => Ok(VariableId::ReaderGroupType_SecurityKeyServices),
            18004 => Ok(VariableId::KeyCredentialConfigurationType_EndpointUrls),
            18005 => Ok(VariableId::KeyCredentialConfigurationType_ServiceStatus),
            18007 => Ok(VariableId::KeyCredentialConfigurationType_UpdateCredential_InputArguments),
            18010 => Ok(VariableId::KeyCredentialUpdateMethodType_InputArguments),
            18012 => Ok(VariableId::KeyCredentialAuditEventType_EventId),
            18013 => Ok(VariableId::KeyCredentialAuditEventType_EventType),
            18014 => Ok(VariableId::KeyCredentialAuditEventType_SourceNode),
            18015 => Ok(VariableId::KeyCredentialAuditEventType_SourceName),
            18016 => Ok(VariableId::KeyCredentialAuditEventType_Time),
            18017 => Ok(VariableId::KeyCredentialAuditEventType_ReceiveTime),
            18018 => Ok(VariableId::KeyCredentialAuditEventType_LocalTime),
            18019 => Ok(VariableId::KeyCredentialAuditEventType_Message),
            18020 => Ok(VariableId::KeyCredentialAuditEventType_Severity),
            18021 => Ok(VariableId::KeyCredentialAuditEventType_ActionTimeStamp),
            18022 => Ok(VariableId::KeyCredentialAuditEventType_Status),
            18023 => Ok(VariableId::KeyCredentialAuditEventType_ServerId),
            18024 => Ok(VariableId::KeyCredentialAuditEventType_ClientAuditEntryId),
            18025 => Ok(VariableId::KeyCredentialAuditEventType_ClientUserId),
            18026 => Ok(VariableId::KeyCredentialAuditEventType_MethodId),
            18027 => Ok(VariableId::KeyCredentialAuditEventType_InputArguments),
            18028 => Ok(VariableId::KeyCredentialAuditEventType_ResourceUri),
            18030 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_EventId),
            18031 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_EventType),
            18032 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_SourceNode),
            18033 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_SourceName),
            18034 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_Time),
            18035 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ReceiveTime),
            18036 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_LocalTime),
            18037 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_Message),
            18038 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_Severity),
            18039 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ActionTimeStamp),
            18040 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_Status),
            18041 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ServerId),
            18042 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ClientAuditEntryId),
            18043 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ClientUserId),
            18044 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_MethodId),
            18045 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_InputArguments),
            18046 => Ok(VariableId::KeyCredentialUpdatedAuditEventType_ResourceUri),
            18048 => Ok(VariableId::KeyCredentialDeletedAuditEventType_EventId),
            18049 => Ok(VariableId::KeyCredentialDeletedAuditEventType_EventType),
            18050 => Ok(VariableId::KeyCredentialDeletedAuditEventType_SourceNode),
            18051 => Ok(VariableId::KeyCredentialDeletedAuditEventType_SourceName),
            18052 => Ok(VariableId::KeyCredentialDeletedAuditEventType_Time),
            18053 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ReceiveTime),
            18054 => Ok(VariableId::KeyCredentialDeletedAuditEventType_LocalTime),
            18055 => Ok(VariableId::KeyCredentialDeletedAuditEventType_Message),
            18056 => Ok(VariableId::KeyCredentialDeletedAuditEventType_Severity),
            18057 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ActionTimeStamp),
            18058 => Ok(VariableId::KeyCredentialDeletedAuditEventType_Status),
            18059 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ServerId),
            18060 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ClientAuditEntryId),
            18061 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ClientUserId),
            18062 => Ok(VariableId::KeyCredentialDeletedAuditEventType_MethodId),
            18063 => Ok(VariableId::KeyCredentialDeletedAuditEventType_InputArguments),
            18064 => Ok(VariableId::KeyCredentialDeletedAuditEventType_ResourceUri),
            18065 => Ok(VariableId::ReaderGroupType_MaxNetworkMessageSize),
            18068 => Ok(VariableId::ReaderGroupType_Status_State),
            18069 => Ok(VariableId::KeyCredentialConfigurationType_ResourceUri),
            18072 => Ok(VariableId::AuthorizationServiceConfigurationType_ServiceUri),
            18073 => Ok(VariableId::AuthorizationServiceConfigurationType_IssuerEndpointUrl),
            18077 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_PublisherId),
            18078 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_WriterGroupId),
            18079 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_DataSetWriterId),
            18080 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_DataSetMetaData),
            18081 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_DataSetFieldContentMask),
            18082 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_MessageReceiveTimeout),
            18083 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_SecurityMode),
            18084 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_SecurityGroupId),
            18085 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_SecurityKeyServices),
            18089 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Status_State),
            18093 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_DiagnosticsLevel),
            18094 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation),
            18095 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_Active),
            18096 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_Classification),
            18097 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            18098 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            18099 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError),
            18100 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_Active),
            18101 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_Classification),
            18102 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            18103 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            18105 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_SubError),
            18107 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError),
            18108 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_Active),
            18109 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_Classification),
            18110 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            18111 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            18112 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            18113 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            18114 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            18115 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            18116 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            18117 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            18118 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            18119 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            18120 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            18121 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            18122 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            18123 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            18124 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            18125 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            18126 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            18127 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            18128 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            18129 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            18130 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            18131 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            18132 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            18133 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            18134 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            18135 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            18136 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            18138 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages),
            18139 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active),
            18140 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification),
            18141 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            18142 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            18143 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors),
            18144 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_Active),
            18145 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_Classification),
            18146 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel),
            18147 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Counters_DecryptionErrors_TimeFirstChange),
            18148 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber),
            18149 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            18150 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_StatusCode),
            18151 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            18152 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MajorVersion),
            18153 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            18154 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MinorVersion),
            18157 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_ResourceUri),
            18158 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            18159 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_EndpointUrls),
            18160 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_ServiceStatus),
            18162 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_UpdateCredential_InputArguments),
            18164 => Ok(VariableId::KeyCredentialConfiguration_ServiceName_Placeholder_ProfileUri),
            18165 => Ok(VariableId::KeyCredentialConfigurationType_ProfileUri),
            18178 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDefinition),
            18179 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDefinition_DataTypeVersion),
            18180 => Ok(VariableId::OpcUa_BinarySchema_DataTypeDefinition_DictionaryFragment),
            18181 => Ok(VariableId::OpcUa_BinarySchema_StructureField),
            18182 => Ok(VariableId::OpcUa_BinarySchema_StructureField_DataTypeVersion),
            18183 => Ok(VariableId::OpcUa_BinarySchema_StructureField_DictionaryFragment),
            18184 => Ok(VariableId::OpcUa_BinarySchema_StructureDefinition),
            18185 => Ok(VariableId::OpcUa_BinarySchema_StructureDefinition_DataTypeVersion),
            18186 => Ok(VariableId::OpcUa_BinarySchema_StructureDefinition_DictionaryFragment),
            18187 => Ok(VariableId::OpcUa_BinarySchema_EnumDefinition),
            18188 => Ok(VariableId::OpcUa_BinarySchema_EnumDefinition_DataTypeVersion),
            18189 => Ok(VariableId::OpcUa_BinarySchema_EnumDefinition_DictionaryFragment),
            18190 => Ok(VariableId::AlarmConditionType_LatchedState),
            18191 => Ok(VariableId::AlarmConditionType_LatchedState_Id),
            18192 => Ok(VariableId::AlarmConditionType_LatchedState_Name),
            18193 => Ok(VariableId::AlarmConditionType_LatchedState_Number),
            18194 => Ok(VariableId::AlarmConditionType_LatchedState_EffectiveDisplayName),
            18195 => Ok(VariableId::AlarmConditionType_LatchedState_TransitionTime),
            18196 => Ok(VariableId::AlarmConditionType_LatchedState_EffectiveTransitionTime),
            18197 => Ok(VariableId::AlarmConditionType_LatchedState_TrueState),
            18198 => Ok(VariableId::AlarmConditionType_LatchedState_FalseState),
            18200 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_ListId),
            18201 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_AgencyId),
            18202 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_AudibleSound_VersionId),
            18203 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState),
            18204 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Id),
            18205 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Name),
            18206 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_Number),
            18207 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_EffectiveDisplayName),
            18208 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_TransitionTime),
            18209 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_EffectiveTransitionTime),
            18210 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_TrueState),
            18211 => Ok(VariableId::AlarmGroupType_AlarmConditionInstance_Placeholder_LatchedState_FalseState),
            18213 => Ok(VariableId::LimitAlarmType_LatchedState),
            18214 => Ok(VariableId::LimitAlarmType_LatchedState_Id),
            18215 => Ok(VariableId::LimitAlarmType_LatchedState_Name),
            18216 => Ok(VariableId::LimitAlarmType_LatchedState_Number),
            18217 => Ok(VariableId::LimitAlarmType_LatchedState_EffectiveDisplayName),
            18218 => Ok(VariableId::LimitAlarmType_LatchedState_TransitionTime),
            18219 => Ok(VariableId::LimitAlarmType_LatchedState_EffectiveTransitionTime),
            18220 => Ok(VariableId::LimitAlarmType_LatchedState_TrueState),
            18221 => Ok(VariableId::LimitAlarmType_LatchedState_FalseState),
            18223 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState),
            18224 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_Id),
            18225 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_Name),
            18226 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_Number),
            18227 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_EffectiveDisplayName),
            18228 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_TransitionTime),
            18229 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_EffectiveTransitionTime),
            18230 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_TrueState),
            18231 => Ok(VariableId::ExclusiveLimitAlarmType_LatchedState_FalseState),
            18233 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState),
            18234 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_Id),
            18235 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_Name),
            18236 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_Number),
            18237 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_EffectiveDisplayName),
            18238 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_TransitionTime),
            18239 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_EffectiveTransitionTime),
            18240 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_TrueState),
            18241 => Ok(VariableId::NonExclusiveLimitAlarmType_LatchedState_FalseState),
            18243 => Ok(VariableId::NonExclusiveLevelAlarmType_AudibleSound_ListId),
            18244 => Ok(VariableId::NonExclusiveLevelAlarmType_AudibleSound_AgencyId),
            18245 => Ok(VariableId::NonExclusiveLevelAlarmType_AudibleSound_VersionId),
            18246 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState),
            18247 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_Id),
            18248 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_Name),
            18249 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_Number),
            18250 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_EffectiveDisplayName),
            18251 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_TransitionTime),
            18252 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_EffectiveTransitionTime),
            18253 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_TrueState),
            18254 => Ok(VariableId::NonExclusiveLevelAlarmType_LatchedState_FalseState),
            18257 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState),
            18258 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_Id),
            18259 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_Name),
            18260 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_Number),
            18261 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_EffectiveDisplayName),
            18262 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_TransitionTime),
            18263 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_EffectiveTransitionTime),
            18264 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_TrueState),
            18265 => Ok(VariableId::ExclusiveLevelAlarmType_LatchedState_FalseState),
            18267 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState),
            18268 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_Id),
            18269 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_Name),
            18270 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_Number),
            18271 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_EffectiveDisplayName),
            18272 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_TransitionTime),
            18273 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_EffectiveTransitionTime),
            18274 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_TrueState),
            18275 => Ok(VariableId::NonExclusiveDeviationAlarmType_LatchedState_FalseState),
            18277 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState),
            18278 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_Id),
            18279 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_Name),
            18280 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_Number),
            18281 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_EffectiveDisplayName),
            18282 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_TransitionTime),
            18283 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_EffectiveTransitionTime),
            18284 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_TrueState),
            18285 => Ok(VariableId::NonExclusiveRateOfChangeAlarmType_LatchedState_FalseState),
            18287 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState),
            18288 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_Id),
            18289 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_Name),
            18290 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_Number),
            18291 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_EffectiveDisplayName),
            18292 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_TransitionTime),
            18293 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_EffectiveTransitionTime),
            18294 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_TrueState),
            18295 => Ok(VariableId::ExclusiveDeviationAlarmType_LatchedState_FalseState),
            18297 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState),
            18298 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_Id),
            18299 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_Name),
            18300 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_Number),
            18301 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_EffectiveDisplayName),
            18302 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_TransitionTime),
            18303 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_EffectiveTransitionTime),
            18304 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_TrueState),
            18305 => Ok(VariableId::ExclusiveRateOfChangeAlarmType_LatchedState_FalseState),
            18307 => Ok(VariableId::DiscreteAlarmType_LatchedState),
            18308 => Ok(VariableId::DiscreteAlarmType_LatchedState_Id),
            18309 => Ok(VariableId::DiscreteAlarmType_LatchedState_Name),
            18310 => Ok(VariableId::DiscreteAlarmType_LatchedState_Number),
            18311 => Ok(VariableId::DiscreteAlarmType_LatchedState_EffectiveDisplayName),
            18312 => Ok(VariableId::DiscreteAlarmType_LatchedState_TransitionTime),
            18313 => Ok(VariableId::DiscreteAlarmType_LatchedState_EffectiveTransitionTime),
            18314 => Ok(VariableId::DiscreteAlarmType_LatchedState_TrueState),
            18315 => Ok(VariableId::DiscreteAlarmType_LatchedState_FalseState),
            18317 => Ok(VariableId::OffNormalAlarmType_LatchedState),
            18318 => Ok(VariableId::OffNormalAlarmType_LatchedState_Id),
            18319 => Ok(VariableId::OffNormalAlarmType_LatchedState_Name),
            18320 => Ok(VariableId::OffNormalAlarmType_LatchedState_Number),
            18321 => Ok(VariableId::OffNormalAlarmType_LatchedState_EffectiveDisplayName),
            18322 => Ok(VariableId::OffNormalAlarmType_LatchedState_TransitionTime),
            18323 => Ok(VariableId::OffNormalAlarmType_LatchedState_EffectiveTransitionTime),
            18324 => Ok(VariableId::OffNormalAlarmType_LatchedState_TrueState),
            18325 => Ok(VariableId::OffNormalAlarmType_LatchedState_FalseState),
            18327 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState),
            18328 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_Id),
            18329 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_Name),
            18330 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_Number),
            18331 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_EffectiveDisplayName),
            18332 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_TransitionTime),
            18333 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_EffectiveTransitionTime),
            18334 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_TrueState),
            18335 => Ok(VariableId::SystemOffNormalAlarmType_LatchedState_FalseState),
            18337 => Ok(VariableId::TripAlarmType_LatchedState),
            18338 => Ok(VariableId::TripAlarmType_LatchedState_Id),
            18339 => Ok(VariableId::TripAlarmType_LatchedState_Name),
            18340 => Ok(VariableId::TripAlarmType_LatchedState_Number),
            18341 => Ok(VariableId::TripAlarmType_LatchedState_EffectiveDisplayName),
            18342 => Ok(VariableId::TripAlarmType_LatchedState_TransitionTime),
            18343 => Ok(VariableId::TripAlarmType_LatchedState_EffectiveTransitionTime),
            18344 => Ok(VariableId::TripAlarmType_LatchedState_TrueState),
            18345 => Ok(VariableId::TripAlarmType_LatchedState_FalseState),
            18348 => Ok(VariableId::InstrumentDiagnosticAlarmType_EventId),
            18349 => Ok(VariableId::InstrumentDiagnosticAlarmType_EventType),
            18350 => Ok(VariableId::InstrumentDiagnosticAlarmType_SourceNode),
            18351 => Ok(VariableId::InstrumentDiagnosticAlarmType_SourceName),
            18352 => Ok(VariableId::InstrumentDiagnosticAlarmType_Time),
            18353 => Ok(VariableId::InstrumentDiagnosticAlarmType_ReceiveTime),
            18354 => Ok(VariableId::InstrumentDiagnosticAlarmType_LocalTime),
            18355 => Ok(VariableId::InstrumentDiagnosticAlarmType_Message),
            18356 => Ok(VariableId::InstrumentDiagnosticAlarmType_Severity),
            18357 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionClassId),
            18358 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionClassName),
            18359 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionSubClassId),
            18360 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionSubClassName),
            18361 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionName),
            18362 => Ok(VariableId::InstrumentDiagnosticAlarmType_BranchId),
            18363 => Ok(VariableId::InstrumentDiagnosticAlarmType_Retain),
            18364 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState),
            18365 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_Id),
            18366 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_Name),
            18367 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_Number),
            18368 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_EffectiveDisplayName),
            18369 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_TransitionTime),
            18370 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_EffectiveTransitionTime),
            18371 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_TrueState),
            18372 => Ok(VariableId::InstrumentDiagnosticAlarmType_EnabledState_FalseState),
            18373 => Ok(VariableId::InstrumentDiagnosticAlarmType_Quality),
            18374 => Ok(VariableId::InstrumentDiagnosticAlarmType_Quality_SourceTimestamp),
            18375 => Ok(VariableId::InstrumentDiagnosticAlarmType_LastSeverity),
            18376 => Ok(VariableId::InstrumentDiagnosticAlarmType_LastSeverity_SourceTimestamp),
            18377 => Ok(VariableId::InstrumentDiagnosticAlarmType_Comment),
            18378 => Ok(VariableId::InstrumentDiagnosticAlarmType_Comment_SourceTimestamp),
            18379 => Ok(VariableId::InstrumentDiagnosticAlarmType_ClientUserId),
            18383 => Ok(VariableId::InstrumentDiagnosticAlarmType_AddComment_InputArguments),
            18385 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionRefresh_InputArguments),
            18387 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConditionRefresh2_InputArguments),
            18388 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState),
            18389 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_Id),
            18390 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_Name),
            18391 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_Number),
            18392 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_EffectiveDisplayName),
            18393 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_TransitionTime),
            18394 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_EffectiveTransitionTime),
            18395 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_TrueState),
            18396 => Ok(VariableId::InstrumentDiagnosticAlarmType_AckedState_FalseState),
            18397 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState),
            18398 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_Id),
            18399 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_Name),
            18400 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_Number),
            18401 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_EffectiveDisplayName),
            18402 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_TransitionTime),
            18403 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_EffectiveTransitionTime),
            18404 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_TrueState),
            18405 => Ok(VariableId::InstrumentDiagnosticAlarmType_ConfirmedState_FalseState),
            18407 => Ok(VariableId::InstrumentDiagnosticAlarmType_Acknowledge_InputArguments),
            18409 => Ok(VariableId::InstrumentDiagnosticAlarmType_Confirm_InputArguments),
            18410 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState),
            18411 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_Id),
            18412 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_Name),
            18413 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_Number),
            18414 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_EffectiveDisplayName),
            18415 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_TransitionTime),
            18416 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_EffectiveTransitionTime),
            18417 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_TrueState),
            18418 => Ok(VariableId::InstrumentDiagnosticAlarmType_ActiveState_FalseState),
            18419 => Ok(VariableId::InstrumentDiagnosticAlarmType_InputNode),
            18420 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState),
            18421 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_Id),
            18422 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_Name),
            18423 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_Number),
            18424 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_EffectiveDisplayName),
            18425 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_TransitionTime),
            18426 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_EffectiveTransitionTime),
            18427 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_TrueState),
            18428 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedState_FalseState),
            18429 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState),
            18430 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_Id),
            18431 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_Name),
            18432 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_Number),
            18433 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_EffectiveDisplayName),
            18434 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_TransitionTime),
            18435 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_EffectiveTransitionTime),
            18436 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_TrueState),
            18437 => Ok(VariableId::InstrumentDiagnosticAlarmType_OutOfServiceState_FalseState),
            18439 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_CurrentState),
            18440 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Id),
            18441 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Name),
            18442 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_Number),
            18443 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            18444 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition),
            18445 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Id),
            18446 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Name),
            18447 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_Number),
            18448 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_TransitionTime),
            18449 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            18450 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_AvailableStates),
            18451 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_AvailableTransitions),
            18452 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_UnshelveTime),
            18454 => Ok(VariableId::InstrumentDiagnosticAlarmType_ShelvingState_TimedShelve_InputArguments),
            18457 => Ok(VariableId::InstrumentDiagnosticAlarmType_SuppressedOrShelved),
            18458 => Ok(VariableId::InstrumentDiagnosticAlarmType_MaxTimeShelved),
            18459 => Ok(VariableId::InstrumentDiagnosticAlarmType_AudibleEnabled),
            18460 => Ok(VariableId::InstrumentDiagnosticAlarmType_AudibleSound),
            18461 => Ok(VariableId::InstrumentDiagnosticAlarmType_AudibleSound_ListId),
            18462 => Ok(VariableId::InstrumentDiagnosticAlarmType_AudibleSound_AgencyId),
            18463 => Ok(VariableId::InstrumentDiagnosticAlarmType_AudibleSound_VersionId),
            18464 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState),
            18465 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_Id),
            18466 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_Name),
            18467 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_Number),
            18468 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_EffectiveDisplayName),
            18469 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_TransitionTime),
            18470 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_EffectiveTransitionTime),
            18471 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_TrueState),
            18472 => Ok(VariableId::InstrumentDiagnosticAlarmType_SilenceState_FalseState),
            18473 => Ok(VariableId::InstrumentDiagnosticAlarmType_OnDelay),
            18474 => Ok(VariableId::InstrumentDiagnosticAlarmType_OffDelay),
            18475 => Ok(VariableId::InstrumentDiagnosticAlarmType_FirstInGroupFlag),
            18477 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState),
            18478 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_Id),
            18479 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_Name),
            18480 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_Number),
            18481 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_EffectiveDisplayName),
            18482 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_TransitionTime),
            18483 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_EffectiveTransitionTime),
            18484 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_TrueState),
            18485 => Ok(VariableId::InstrumentDiagnosticAlarmType_LatchedState_FalseState),
            18487 => Ok(VariableId::InstrumentDiagnosticAlarmType_ReAlarmTime),
            18488 => Ok(VariableId::InstrumentDiagnosticAlarmType_ReAlarmRepeatCount),
            18495 => Ok(VariableId::InstrumentDiagnosticAlarmType_NormalState),
            18497 => Ok(VariableId::SystemDiagnosticAlarmType_EventId),
            18498 => Ok(VariableId::SystemDiagnosticAlarmType_EventType),
            18499 => Ok(VariableId::SystemDiagnosticAlarmType_SourceNode),
            18500 => Ok(VariableId::SystemDiagnosticAlarmType_SourceName),
            18501 => Ok(VariableId::SystemDiagnosticAlarmType_Time),
            18502 => Ok(VariableId::SystemDiagnosticAlarmType_ReceiveTime),
            18503 => Ok(VariableId::SystemDiagnosticAlarmType_LocalTime),
            18504 => Ok(VariableId::SystemDiagnosticAlarmType_Message),
            18505 => Ok(VariableId::SystemDiagnosticAlarmType_Severity),
            18506 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionClassId),
            18507 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionClassName),
            18508 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionSubClassId),
            18509 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionSubClassName),
            18510 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionName),
            18511 => Ok(VariableId::SystemDiagnosticAlarmType_BranchId),
            18512 => Ok(VariableId::SystemDiagnosticAlarmType_Retain),
            18513 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState),
            18514 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_Id),
            18515 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_Name),
            18516 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_Number),
            18517 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_EffectiveDisplayName),
            18518 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_TransitionTime),
            18519 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_EffectiveTransitionTime),
            18520 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_TrueState),
            18521 => Ok(VariableId::SystemDiagnosticAlarmType_EnabledState_FalseState),
            18522 => Ok(VariableId::SystemDiagnosticAlarmType_Quality),
            18523 => Ok(VariableId::SystemDiagnosticAlarmType_Quality_SourceTimestamp),
            18524 => Ok(VariableId::SystemDiagnosticAlarmType_LastSeverity),
            18525 => Ok(VariableId::SystemDiagnosticAlarmType_LastSeverity_SourceTimestamp),
            18526 => Ok(VariableId::SystemDiagnosticAlarmType_Comment),
            18527 => Ok(VariableId::SystemDiagnosticAlarmType_Comment_SourceTimestamp),
            18528 => Ok(VariableId::SystemDiagnosticAlarmType_ClientUserId),
            18532 => Ok(VariableId::SystemDiagnosticAlarmType_AddComment_InputArguments),
            18534 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionRefresh_InputArguments),
            18536 => Ok(VariableId::SystemDiagnosticAlarmType_ConditionRefresh2_InputArguments),
            18537 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState),
            18538 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_Id),
            18539 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_Name),
            18540 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_Number),
            18541 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_EffectiveDisplayName),
            18542 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_TransitionTime),
            18543 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_EffectiveTransitionTime),
            18544 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_TrueState),
            18545 => Ok(VariableId::SystemDiagnosticAlarmType_AckedState_FalseState),
            18546 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState),
            18547 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_Id),
            18548 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_Name),
            18549 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_Number),
            18550 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_EffectiveDisplayName),
            18551 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_TransitionTime),
            18552 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_EffectiveTransitionTime),
            18553 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_TrueState),
            18554 => Ok(VariableId::SystemDiagnosticAlarmType_ConfirmedState_FalseState),
            18556 => Ok(VariableId::SystemDiagnosticAlarmType_Acknowledge_InputArguments),
            18558 => Ok(VariableId::SystemDiagnosticAlarmType_Confirm_InputArguments),
            18559 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState),
            18560 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_Id),
            18561 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_Name),
            18562 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_Number),
            18563 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_EffectiveDisplayName),
            18564 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_TransitionTime),
            18565 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_EffectiveTransitionTime),
            18566 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_TrueState),
            18567 => Ok(VariableId::SystemDiagnosticAlarmType_ActiveState_FalseState),
            18568 => Ok(VariableId::SystemDiagnosticAlarmType_InputNode),
            18569 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState),
            18570 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_Id),
            18571 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_Name),
            18572 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_Number),
            18573 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_EffectiveDisplayName),
            18574 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_TransitionTime),
            18575 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_EffectiveTransitionTime),
            18576 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_TrueState),
            18577 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedState_FalseState),
            18578 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState),
            18579 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_Id),
            18580 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_Name),
            18581 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_Number),
            18582 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_EffectiveDisplayName),
            18583 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_TransitionTime),
            18584 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_EffectiveTransitionTime),
            18585 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_TrueState),
            18586 => Ok(VariableId::SystemDiagnosticAlarmType_OutOfServiceState_FalseState),
            18588 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_CurrentState),
            18589 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_CurrentState_Id),
            18590 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_CurrentState_Name),
            18591 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_CurrentState_Number),
            18592 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            18593 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition),
            18594 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition_Id),
            18595 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition_Name),
            18596 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition_Number),
            18597 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition_TransitionTime),
            18598 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            18599 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_AvailableStates),
            18600 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_AvailableTransitions),
            18601 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_UnshelveTime),
            18603 => Ok(VariableId::SystemDiagnosticAlarmType_ShelvingState_TimedShelve_InputArguments),
            18606 => Ok(VariableId::SystemDiagnosticAlarmType_SuppressedOrShelved),
            18607 => Ok(VariableId::SystemDiagnosticAlarmType_MaxTimeShelved),
            18608 => Ok(VariableId::SystemDiagnosticAlarmType_AudibleEnabled),
            18609 => Ok(VariableId::SystemDiagnosticAlarmType_AudibleSound),
            18610 => Ok(VariableId::SystemDiagnosticAlarmType_AudibleSound_ListId),
            18611 => Ok(VariableId::SystemDiagnosticAlarmType_AudibleSound_AgencyId),
            18612 => Ok(VariableId::SystemDiagnosticAlarmType_AudibleSound_VersionId),
            18613 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState),
            18614 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_Id),
            18615 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_Name),
            18616 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_Number),
            18617 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_EffectiveDisplayName),
            18618 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_TransitionTime),
            18619 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_EffectiveTransitionTime),
            18620 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_TrueState),
            18621 => Ok(VariableId::SystemDiagnosticAlarmType_SilenceState_FalseState),
            18622 => Ok(VariableId::SystemDiagnosticAlarmType_OnDelay),
            18623 => Ok(VariableId::SystemDiagnosticAlarmType_OffDelay),
            18624 => Ok(VariableId::SystemDiagnosticAlarmType_FirstInGroupFlag),
            18626 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState),
            18627 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_Id),
            18628 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_Name),
            18629 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_Number),
            18630 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_EffectiveDisplayName),
            18631 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_TransitionTime),
            18632 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_EffectiveTransitionTime),
            18633 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_TrueState),
            18634 => Ok(VariableId::SystemDiagnosticAlarmType_LatchedState_FalseState),
            18636 => Ok(VariableId::SystemDiagnosticAlarmType_ReAlarmTime),
            18637 => Ok(VariableId::SystemDiagnosticAlarmType_ReAlarmRepeatCount),
            18644 => Ok(VariableId::SystemDiagnosticAlarmType_NormalState),
            18645 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState),
            18646 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_Id),
            18647 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_Name),
            18648 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_Number),
            18649 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_EffectiveDisplayName),
            18650 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_TransitionTime),
            18651 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_EffectiveTransitionTime),
            18652 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_TrueState),
            18653 => Ok(VariableId::CertificateExpirationAlarmType_LatchedState_FalseState),
            18655 => Ok(VariableId::DiscrepancyAlarmType_LatchedState),
            18656 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_Id),
            18657 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_Name),
            18658 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_Number),
            18659 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_EffectiveDisplayName),
            18660 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_TransitionTime),
            18661 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_EffectiveTransitionTime),
            18662 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_TrueState),
            18663 => Ok(VariableId::DiscrepancyAlarmType_LatchedState_FalseState),
            18668 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_DiagnosticsLevel),
            18669 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation),
            18670 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_Active),
            18671 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_Classification),
            18672 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            18673 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            18674 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError),
            18675 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_Active),
            18676 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_Classification),
            18677 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            18678 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            18680 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_SubError),
            18682 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError),
            18683 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Active),
            18684 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_Classification),
            18685 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            18686 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            18687 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            18688 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            18689 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            18690 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            18691 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            18692 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            18693 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            18694 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            18695 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            18696 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            18697 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            18698 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            18699 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            18700 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            18701 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            18702 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            18703 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            18704 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            18705 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            18706 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            18707 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            18708 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            18709 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            18710 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            18711 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            18713 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress),
            18714 => Ok(VariableId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel),
            18716 => Ok(VariableId::PublishSubscribeType_Diagnostics_DiagnosticsLevel),
            18717 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalInformation),
            18718 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalInformation_Active),
            18719 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalInformation_Classification),
            18720 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalInformation_DiagnosticsLevel),
            18721 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalInformation_TimeFirstChange),
            18722 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalError),
            18723 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalError_Active),
            18724 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalError_Classification),
            18725 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalError_DiagnosticsLevel),
            18726 => Ok(VariableId::PublishSubscribeType_Diagnostics_TotalError_TimeFirstChange),
            18728 => Ok(VariableId::PublishSubscribeType_Diagnostics_SubError),
            18730 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateError),
            18731 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateError_Active),
            18732 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateError_Classification),
            18733 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            18734 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateError_TimeFirstChange),
            18735 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod),
            18736 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_Active),
            18737 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            18738 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            18739 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            18740 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent),
            18741 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_Active),
            18742 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_Classification),
            18743 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            18744 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            18745 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError),
            18746 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_Active),
            18747 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_Classification),
            18748 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            18749 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            18750 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StatePausedByParent),
            18751 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_Active),
            18752 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_Classification),
            18753 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            18754 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            18755 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod),
            18756 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_Active),
            18757 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            18758 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            18759 => Ok(VariableId::PublishSubscribeType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            18761 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetWriters),
            18762 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            18763 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetReaders),
            18764 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            18765 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetWriters),
            18766 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            18767 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetReaders),
            18768 => Ok(VariableId::PublishSubscribeType_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            18769 => Ok(VariableId::ThreeDVectorType_X),
            18770 => Ok(VariableId::ThreeDVectorType_Y),
            18771 => Ok(VariableId::ThreeDVectorType_Z),
            18773 => Ok(VariableId::CartesianCoordinatesType_LengthUnit),
            18775 => Ok(VariableId::ThreeDCartesianCoordinatesType_LengthUnit),
            18776 => Ok(VariableId::ThreeDCartesianCoordinatesType_X),
            18777 => Ok(VariableId::ThreeDCartesianCoordinatesType_Y),
            18778 => Ok(VariableId::ThreeDCartesianCoordinatesType_Z),
            18780 => Ok(VariableId::OrientationType_AngleUnit),
            18782 => Ok(VariableId::ThreeDOrientationType_AngleUnit),
            18783 => Ok(VariableId::ThreeDOrientationType_A),
            18784 => Ok(VariableId::ThreeDOrientationType_B),
            18785 => Ok(VariableId::ThreeDOrientationType_C),
            18787 => Ok(VariableId::FrameType_Orientation),
            18788 => Ok(VariableId::FrameType_Constant),
            18789 => Ok(VariableId::FrameType_BaseFrame),
            18790 => Ok(VariableId::FrameType_FixedBase),
            18792 => Ok(VariableId::ThreeDFrameType_Orientation),
            18793 => Ok(VariableId::ThreeDFrameType_Constant),
            18794 => Ok(VariableId::ThreeDFrameType_BaseFrame),
            18795 => Ok(VariableId::ThreeDFrameType_FixedBase),
            18796 => Ok(VariableId::ThreeDFrameType_CartesianCoordinates),
            18797 => Ok(VariableId::ThreeDFrameType_CartesianCoordinates_LengthUnit),
            18798 => Ok(VariableId::ThreeDFrameType_CartesianCoordinates_X),
            18799 => Ok(VariableId::ThreeDFrameType_CartesianCoordinates_Y),
            18800 => Ok(VariableId::ThreeDFrameType_CartesianCoordinates_Z),
            18801 => Ok(VariableId::FrameType_CartesianCoordinates),
            18802 => Ok(VariableId::FrameType_CartesianCoordinates_LengthUnit),
            18803 => Ok(VariableId::FrameType_Orientation_AngleUnit),
            18824 => Ok(VariableId::OpcUa_BinarySchema_RationalNumber),
            18825 => Ok(VariableId::OpcUa_BinarySchema_RationalNumber_DataTypeVersion),
            18826 => Ok(VariableId::OpcUa_BinarySchema_RationalNumber_DictionaryFragment),
            18827 => Ok(VariableId::OpcUa_BinarySchema_Vector),
            18828 => Ok(VariableId::OpcUa_BinarySchema_Vector_DataTypeVersion),
            18829 => Ok(VariableId::OpcUa_BinarySchema_Vector_DictionaryFragment),
            18830 => Ok(VariableId::OpcUa_BinarySchema_ThreeDVector),
            18831 => Ok(VariableId::OpcUa_BinarySchema_ThreeDVector_DataTypeVersion),
            18832 => Ok(VariableId::OpcUa_BinarySchema_ThreeDVector_DictionaryFragment),
            18833 => Ok(VariableId::OpcUa_BinarySchema_CartesianCoordinates),
            18834 => Ok(VariableId::OpcUa_BinarySchema_CartesianCoordinates_DataTypeVersion),
            18835 => Ok(VariableId::OpcUa_BinarySchema_CartesianCoordinates_DictionaryFragment),
            18836 => Ok(VariableId::OpcUa_BinarySchema_ThreeDCartesianCoordinates),
            18837 => Ok(VariableId::OpcUa_BinarySchema_ThreeDCartesianCoordinates_DataTypeVersion),
            18838 => Ok(VariableId::OpcUa_BinarySchema_ThreeDCartesianCoordinates_DictionaryFragment),
            18839 => Ok(VariableId::OpcUa_BinarySchema_Orientation),
            18840 => Ok(VariableId::OpcUa_BinarySchema_Orientation_DataTypeVersion),
            18841 => Ok(VariableId::OpcUa_BinarySchema_Orientation_DictionaryFragment),
            18842 => Ok(VariableId::OpcUa_BinarySchema_ThreeDOrientation),
            18843 => Ok(VariableId::OpcUa_BinarySchema_ThreeDOrientation_DataTypeVersion),
            18844 => Ok(VariableId::OpcUa_BinarySchema_ThreeDOrientation_DictionaryFragment),
            18845 => Ok(VariableId::OpcUa_BinarySchema_Frame),
            18846 => Ok(VariableId::OpcUa_BinarySchema_Frame_DataTypeVersion),
            18847 => Ok(VariableId::OpcUa_BinarySchema_Frame_DictionaryFragment),
            18848 => Ok(VariableId::OpcUa_BinarySchema_ThreeDFrame),
            18849 => Ok(VariableId::OpcUa_BinarySchema_ThreeDFrame_DataTypeVersion),
            18850 => Ok(VariableId::OpcUa_BinarySchema_ThreeDFrame_DictionaryFragment),
            18872 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel),
            18873 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation),
            18874 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active),
            18875 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification),
            18876 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            18877 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            18878 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError),
            18879 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active),
            18880 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification),
            18881 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            18882 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            18884 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_SubError),
            18886 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError),
            18887 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active),
            18888 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification),
            18889 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            18890 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            18891 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            18892 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            18893 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            18894 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            18895 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            18896 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            18897 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            18898 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            18899 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            18900 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            18901 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            18902 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            18903 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            18904 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            18905 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            18906 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            18907 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            18908 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            18909 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            18910 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            18911 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            18912 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            18913 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            18914 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            18915 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            18917 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages),
            18918 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active),
            18919 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification),
            18920 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            18921 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            18922 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber),
            18923 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            18924 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode),
            18925 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            18926 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion),
            18927 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            18928 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion),
            18929 => Ok(VariableId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            18931 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel),
            18932 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation),
            18933 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active),
            18934 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification),
            18935 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            18936 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            18937 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError),
            18938 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active),
            18939 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification),
            18940 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            18941 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            18943 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_SubError),
            18945 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError),
            18946 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active),
            18947 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification),
            18948 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            18949 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            18950 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            18951 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            18952 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            18953 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            18954 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            18955 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            18956 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            18957 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            18958 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            18959 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            18960 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            18961 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            18962 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            18963 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            18964 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            18965 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            18966 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            18967 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            18968 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            18969 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            18970 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            18971 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            18972 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            18973 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            18974 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            18976 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages),
            18977 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active),
            18978 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification),
            18979 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            18980 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            18981 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber),
            18982 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            18983 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode),
            18984 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            18985 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion),
            18986 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            18987 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion),
            18988 => Ok(VariableId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            18990 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_DiagnosticsLevel),
            18991 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation),
            18992 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Active),
            18993 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_Classification),
            18994 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            18995 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            18996 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError),
            18997 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Active),
            18998 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_Classification),
            18999 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            19000 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            19002 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_SubError),
            19004 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError),
            19005 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Active),
            19006 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_Classification),
            19007 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19008 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            19009 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            19010 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            19011 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19012 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19013 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19014 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            19015 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            19016 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            19017 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19018 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19019 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            19020 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            19021 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            19022 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19023 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19024 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            19025 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            19026 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            19027 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19028 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19029 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            19030 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            19031 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19032 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19033 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19035 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages),
            19036 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Active),
            19037 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_Classification),
            19038 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            19039 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            19040 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber),
            19041 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            19042 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode),
            19043 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            19044 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion),
            19045 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            19046 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion),
            19047 => Ok(VariableId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            19073 => Ok(VariableId::ThreeDFrameType_Orientation_AngleUnit),
            19074 => Ok(VariableId::ThreeDFrameType_Orientation_A),
            19075 => Ok(VariableId::ThreeDFrameType_Orientation_B),
            19076 => Ok(VariableId::ThreeDFrameType_Orientation_C),
            19078 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_Definition),
            19079 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_ValuePrecision),
            19080 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_EnumValues),
            19081 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_ValueAsText),
            19082 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_EnumDictionaryEntries),
            19083 => Ok(VariableId::MultiStateDictionaryEntryDiscreteBaseType_ValueAsDictionaryEntries),
            19085 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_Definition),
            19086 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_ValuePrecision),
            19087 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_EnumValues),
            19088 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_ValueAsText),
            19089 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_EnumDictionaryEntries),
            19090 => Ok(VariableId::MultiStateDictionaryEntryDiscreteType_ValueAsDictionaryEntries),
            19091 => Ok(VariableId::HistoryServerCapabilities_ServerTimestampSupported),
            19092 => Ok(VariableId::HistoricalDataConfigurationType_ServerTimestampSupported),
            19093 => Ok(VariableId::HAConfiguration_ServerTimestampSupported),
            19094 => Ok(VariableId::HistoryServerCapabilitiesType_ServerTimestampSupported),
            19096 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_EventId),
            19097 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_EventType),
            19098 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_SourceNode),
            19099 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_SourceName),
            19100 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_Time),
            19101 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ReceiveTime),
            19102 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_LocalTime),
            19103 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_Message),
            19104 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_Severity),
            19105 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ActionTimeStamp),
            19106 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_Status),
            19108 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_DiagnosticsLevel),
            19109 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation),
            19110 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_Active),
            19111 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_Classification),
            19112 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            19113 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            19114 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError),
            19115 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_Active),
            19116 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_Classification),
            19117 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            19118 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            19120 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_SubError),
            19122 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError),
            19123 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_Active),
            19124 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_Classification),
            19125 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19126 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            19127 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            19128 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            19129 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19130 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19131 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19132 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            19133 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            19134 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            19135 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19136 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19137 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            19138 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            19139 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            19140 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19141 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19142 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            19143 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            19144 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            19145 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19146 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19147 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            19148 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            19149 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19150 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19151 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19153 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages),
            19154 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_Active),
            19155 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_Classification),
            19156 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_DiagnosticsLevel),
            19157 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_SentNetworkMessages_TimeFirstChange),
            19158 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions),
            19159 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_Active),
            19160 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_Classification),
            19161 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_DiagnosticsLevel),
            19162 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_FailedTransmissions_TimeFirstChange),
            19163 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors),
            19164 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_Active),
            19165 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_Classification),
            19166 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_DiagnosticsLevel),
            19167 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Counters_EncryptionErrors_TimeFirstChange),
            19168 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetWriters),
            19169 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            19170 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetWriters),
            19171 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            19172 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_SecurityTokenID),
            19173 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel),
            19174 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID),
            19175 => Ok(VariableId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            19177 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_DiagnosticsLevel),
            19178 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation),
            19179 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_Active),
            19180 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_Classification),
            19181 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_DiagnosticsLevel),
            19182 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalInformation_TimeFirstChange),
            19183 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError),
            19184 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_Active),
            19185 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_Classification),
            19186 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_DiagnosticsLevel),
            19187 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_TotalError_TimeFirstChange),
            19189 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_SubError),
            19191 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError),
            19192 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_Active),
            19193 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_Classification),
            19194 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19195 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateError_TimeFirstChange),
            19196 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod),
            19197 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Active),
            19198 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19199 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19200 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19201 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent),
            19202 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Active),
            19203 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_Classification),
            19204 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19205 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19206 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError),
            19207 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Active),
            19208 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_Classification),
            19209 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19210 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19211 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent),
            19212 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Active),
            19213 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_Classification),
            19214 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19215 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19216 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod),
            19217 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Active),
            19218 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19219 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19220 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19222 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages),
            19223 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_Active),
            19224 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_Classification),
            19225 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_DiagnosticsLevel),
            19226 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedNetworkMessages_TimeFirstChange),
            19227 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages),
            19228 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Active),
            19229 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Classification),
            19230 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel),
            19231 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange),
            19232 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors),
            19233 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_Active),
            19234 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_Classification),
            19235 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel),
            19236 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Counters_DecryptionErrors_TimeFirstChange),
            19237 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetReaders),
            19238 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            19239 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetReaders),
            19240 => Ok(VariableId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            19242 => Ok(VariableId::PubSubConnectionType_Diagnostics_DiagnosticsLevel),
            19243 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalInformation),
            19244 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalInformation_Active),
            19245 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalInformation_Classification),
            19246 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalInformation_DiagnosticsLevel),
            19247 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalInformation_TimeFirstChange),
            19248 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalError),
            19249 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalError_Active),
            19250 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalError_Classification),
            19251 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalError_DiagnosticsLevel),
            19252 => Ok(VariableId::PubSubConnectionType_Diagnostics_TotalError_TimeFirstChange),
            19254 => Ok(VariableId::PubSubConnectionType_Diagnostics_SubError),
            19256 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateError),
            19257 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateError_Active),
            19258 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateError_Classification),
            19259 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19260 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateError_TimeFirstChange),
            19261 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod),
            19262 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_Active),
            19263 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19264 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19265 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19266 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent),
            19267 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_Active),
            19268 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_Classification),
            19269 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19270 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19271 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError),
            19272 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_Active),
            19273 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_Classification),
            19274 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19275 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19276 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StatePausedByParent),
            19277 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_Active),
            19278 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_Classification),
            19279 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19280 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19281 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod),
            19282 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_Active),
            19283 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19284 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19285 => Ok(VariableId::PubSubConnectionType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19287 => Ok(VariableId::PubSubConnectionType_Diagnostics_LiveValues_ResolvedAddress),
            19288 => Ok(VariableId::PubSubConnectionType_Diagnostics_LiveValues_ResolvedAddress_DiagnosticsLevel),
            19289 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ServerId),
            19290 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ClientAuditEntryId),
            19291 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ClientUserId),
            19292 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_ParameterDataTypeId),
            19293 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_PerformInsertReplace),
            19294 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_NewValues),
            19295 => Ok(VariableId::AuditHistoryAnnotationUpdateEventType_OldValues),
            19296 => Ok(VariableId::TrustListType_UpdateFrequency),
            19298 => Ok(VariableId::TrustListOutOfDateAlarmType_EventId),
            19299 => Ok(VariableId::TrustListOutOfDateAlarmType_EventType),
            19300 => Ok(VariableId::TrustListOutOfDateAlarmType_SourceNode),
            19301 => Ok(VariableId::TrustListOutOfDateAlarmType_SourceName),
            19302 => Ok(VariableId::TrustListOutOfDateAlarmType_Time),
            19303 => Ok(VariableId::TrustListOutOfDateAlarmType_ReceiveTime),
            19304 => Ok(VariableId::TrustListOutOfDateAlarmType_LocalTime),
            19305 => Ok(VariableId::TrustListOutOfDateAlarmType_Message),
            19306 => Ok(VariableId::TrustListOutOfDateAlarmType_Severity),
            19307 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionClassId),
            19308 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionClassName),
            19309 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionSubClassId),
            19310 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionSubClassName),
            19311 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionName),
            19312 => Ok(VariableId::TrustListOutOfDateAlarmType_BranchId),
            19313 => Ok(VariableId::TrustListOutOfDateAlarmType_Retain),
            19314 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState),
            19315 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_Id),
            19316 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_Name),
            19317 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_Number),
            19318 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_EffectiveDisplayName),
            19319 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_TransitionTime),
            19320 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_EffectiveTransitionTime),
            19321 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_TrueState),
            19322 => Ok(VariableId::TrustListOutOfDateAlarmType_EnabledState_FalseState),
            19323 => Ok(VariableId::TrustListOutOfDateAlarmType_Quality),
            19324 => Ok(VariableId::TrustListOutOfDateAlarmType_Quality_SourceTimestamp),
            19325 => Ok(VariableId::TrustListOutOfDateAlarmType_LastSeverity),
            19326 => Ok(VariableId::TrustListOutOfDateAlarmType_LastSeverity_SourceTimestamp),
            19327 => Ok(VariableId::TrustListOutOfDateAlarmType_Comment),
            19328 => Ok(VariableId::TrustListOutOfDateAlarmType_Comment_SourceTimestamp),
            19329 => Ok(VariableId::TrustListOutOfDateAlarmType_ClientUserId),
            19333 => Ok(VariableId::TrustListOutOfDateAlarmType_AddComment_InputArguments),
            19335 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionRefresh_InputArguments),
            19337 => Ok(VariableId::TrustListOutOfDateAlarmType_ConditionRefresh2_InputArguments),
            19338 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState),
            19339 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_Id),
            19340 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_Name),
            19341 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_Number),
            19342 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_EffectiveDisplayName),
            19343 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_TransitionTime),
            19344 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_EffectiveTransitionTime),
            19345 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_TrueState),
            19346 => Ok(VariableId::TrustListOutOfDateAlarmType_AckedState_FalseState),
            19347 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState),
            19348 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_Id),
            19349 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_Name),
            19350 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_Number),
            19351 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_EffectiveDisplayName),
            19352 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_TransitionTime),
            19353 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_EffectiveTransitionTime),
            19354 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_TrueState),
            19355 => Ok(VariableId::TrustListOutOfDateAlarmType_ConfirmedState_FalseState),
            19357 => Ok(VariableId::TrustListOutOfDateAlarmType_Acknowledge_InputArguments),
            19359 => Ok(VariableId::TrustListOutOfDateAlarmType_Confirm_InputArguments),
            19360 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState),
            19361 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_Id),
            19362 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_Name),
            19363 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_Number),
            19364 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_EffectiveDisplayName),
            19365 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_TransitionTime),
            19366 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_EffectiveTransitionTime),
            19367 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_TrueState),
            19368 => Ok(VariableId::TrustListOutOfDateAlarmType_ActiveState_FalseState),
            19369 => Ok(VariableId::TrustListOutOfDateAlarmType_InputNode),
            19370 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState),
            19371 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_Id),
            19372 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_Name),
            19373 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_Number),
            19374 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_EffectiveDisplayName),
            19375 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_TransitionTime),
            19376 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_EffectiveTransitionTime),
            19377 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_TrueState),
            19378 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedState_FalseState),
            19379 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState),
            19380 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_Id),
            19381 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_Name),
            19382 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_Number),
            19383 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_EffectiveDisplayName),
            19384 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_TransitionTime),
            19385 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_EffectiveTransitionTime),
            19386 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_TrueState),
            19387 => Ok(VariableId::TrustListOutOfDateAlarmType_OutOfServiceState_FalseState),
            19389 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_CurrentState),
            19390 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Id),
            19391 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Name),
            19392 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_CurrentState_Number),
            19393 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_CurrentState_EffectiveDisplayName),
            19394 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition),
            19395 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Id),
            19396 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Name),
            19397 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition_Number),
            19398 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition_TransitionTime),
            19399 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime),
            19400 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_AvailableStates),
            19401 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_AvailableTransitions),
            19402 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_UnshelveTime),
            19404 => Ok(VariableId::TrustListOutOfDateAlarmType_ShelvingState_TimedShelve_InputArguments),
            19407 => Ok(VariableId::TrustListOutOfDateAlarmType_SuppressedOrShelved),
            19408 => Ok(VariableId::TrustListOutOfDateAlarmType_MaxTimeShelved),
            19409 => Ok(VariableId::TrustListOutOfDateAlarmType_AudibleEnabled),
            19410 => Ok(VariableId::TrustListOutOfDateAlarmType_AudibleSound),
            19411 => Ok(VariableId::TrustListOutOfDateAlarmType_AudibleSound_ListId),
            19412 => Ok(VariableId::TrustListOutOfDateAlarmType_AudibleSound_AgencyId),
            19413 => Ok(VariableId::TrustListOutOfDateAlarmType_AudibleSound_VersionId),
            19414 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState),
            19415 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_Id),
            19416 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_Name),
            19417 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_Number),
            19418 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_EffectiveDisplayName),
            19419 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_TransitionTime),
            19420 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_EffectiveTransitionTime),
            19421 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_TrueState),
            19422 => Ok(VariableId::TrustListOutOfDateAlarmType_SilenceState_FalseState),
            19423 => Ok(VariableId::TrustListOutOfDateAlarmType_OnDelay),
            19424 => Ok(VariableId::TrustListOutOfDateAlarmType_OffDelay),
            19425 => Ok(VariableId::TrustListOutOfDateAlarmType_FirstInGroupFlag),
            19427 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState),
            19428 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_Id),
            19429 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_Name),
            19430 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_Number),
            19431 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_EffectiveDisplayName),
            19432 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_TransitionTime),
            19433 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_EffectiveTransitionTime),
            19434 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_TrueState),
            19435 => Ok(VariableId::TrustListOutOfDateAlarmType_LatchedState_FalseState),
            19437 => Ok(VariableId::TrustListOutOfDateAlarmType_ReAlarmTime),
            19438 => Ok(VariableId::TrustListOutOfDateAlarmType_ReAlarmRepeatCount),
            19445 => Ok(VariableId::TrustListOutOfDateAlarmType_NormalState),
            19446 => Ok(VariableId::TrustListOutOfDateAlarmType_TrustListId),
            19447 => Ok(VariableId::TrustListOutOfDateAlarmType_LastUpdateTime),
            19448 => Ok(VariableId::TrustListOutOfDateAlarmType_UpdateFrequency),
            19449 => Ok(VariableId::CertificateGroupType_TrustList_UpdateFrequency),
            19451 => Ok(VariableId::CertificateGroupType_CertificateExpired_EventId),
            19452 => Ok(VariableId::CertificateGroupType_CertificateExpired_EventType),
            19453 => Ok(VariableId::CertificateGroupType_CertificateExpired_SourceNode),
            19454 => Ok(VariableId::CertificateGroupType_CertificateExpired_SourceName),
            19455 => Ok(VariableId::CertificateGroupType_CertificateExpired_Time),
            19456 => Ok(VariableId::CertificateGroupType_CertificateExpired_ReceiveTime),
            19457 => Ok(VariableId::CertificateGroupType_CertificateExpired_LocalTime),
            19458 => Ok(VariableId::CertificateGroupType_CertificateExpired_Message),
            19459 => Ok(VariableId::CertificateGroupType_CertificateExpired_Severity),
            19460 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConditionClassId),
            19461 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConditionClassName),
            19462 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConditionSubClassId),
            19463 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConditionSubClassName),
            19464 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConditionName),
            19465 => Ok(VariableId::CertificateGroupType_CertificateExpired_BranchId),
            19466 => Ok(VariableId::CertificateGroupType_CertificateExpired_Retain),
            19467 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState),
            19468 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_Id),
            19469 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_Name),
            19470 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_Number),
            19471 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_EffectiveDisplayName),
            19472 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_TransitionTime),
            19473 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_EffectiveTransitionTime),
            19474 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_TrueState),
            19475 => Ok(VariableId::CertificateGroupType_CertificateExpired_EnabledState_FalseState),
            19476 => Ok(VariableId::CertificateGroupType_CertificateExpired_Quality),
            19477 => Ok(VariableId::CertificateGroupType_CertificateExpired_Quality_SourceTimestamp),
            19478 => Ok(VariableId::CertificateGroupType_CertificateExpired_LastSeverity),
            19479 => Ok(VariableId::CertificateGroupType_CertificateExpired_LastSeverity_SourceTimestamp),
            19480 => Ok(VariableId::CertificateGroupType_CertificateExpired_Comment),
            19481 => Ok(VariableId::CertificateGroupType_CertificateExpired_Comment_SourceTimestamp),
            19482 => Ok(VariableId::CertificateGroupType_CertificateExpired_ClientUserId),
            19486 => Ok(VariableId::CertificateGroupType_CertificateExpired_AddComment_InputArguments),
            19487 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState),
            19488 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_Id),
            19489 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_Name),
            19490 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_Number),
            19491 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_EffectiveDisplayName),
            19492 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_TransitionTime),
            19493 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_EffectiveTransitionTime),
            19494 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_TrueState),
            19495 => Ok(VariableId::CertificateGroupType_CertificateExpired_AckedState_FalseState),
            19496 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState),
            19497 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_Id),
            19498 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_Name),
            19499 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_Number),
            19500 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            19501 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_TransitionTime),
            19502 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            19503 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_TrueState),
            19504 => Ok(VariableId::CertificateGroupType_CertificateExpired_ConfirmedState_FalseState),
            19506 => Ok(VariableId::CertificateGroupType_CertificateExpired_Acknowledge_InputArguments),
            19508 => Ok(VariableId::CertificateGroupType_CertificateExpired_Confirm_InputArguments),
            19509 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState),
            19510 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_Id),
            19511 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_Name),
            19512 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_Number),
            19513 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_EffectiveDisplayName),
            19514 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_TransitionTime),
            19515 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_EffectiveTransitionTime),
            19516 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_TrueState),
            19517 => Ok(VariableId::CertificateGroupType_CertificateExpired_ActiveState_FalseState),
            19518 => Ok(VariableId::CertificateGroupType_CertificateExpired_InputNode),
            19519 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState),
            19520 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_Id),
            19521 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_Name),
            19522 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_Number),
            19523 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_EffectiveDisplayName),
            19524 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_TransitionTime),
            19525 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            19526 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_TrueState),
            19527 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedState_FalseState),
            19528 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState),
            19529 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_Id),
            19530 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_Name),
            19531 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_Number),
            19532 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            19533 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_TransitionTime),
            19534 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            19535 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_TrueState),
            19536 => Ok(VariableId::CertificateGroupType_CertificateExpired_OutOfServiceState_FalseState),
            19538 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_CurrentState),
            19539 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Id),
            19540 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Name),
            19541 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_Number),
            19542 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            19543 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition),
            19544 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Id),
            19545 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Name),
            19546 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_Number),
            19547 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            19548 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            19549 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_AvailableStates),
            19551 => Ok(VariableId::DataSetWriterType_Diagnostics_DiagnosticsLevel),
            19552 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalInformation),
            19553 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalInformation_Active),
            19554 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalInformation_Classification),
            19555 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalInformation_DiagnosticsLevel),
            19556 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalInformation_TimeFirstChange),
            19557 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalError),
            19558 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalError_Active),
            19559 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalError_Classification),
            19560 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalError_DiagnosticsLevel),
            19561 => Ok(VariableId::DataSetWriterType_Diagnostics_TotalError_TimeFirstChange),
            19563 => Ok(VariableId::DataSetWriterType_Diagnostics_SubError),
            19565 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateError),
            19566 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateError_Active),
            19567 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateError_Classification),
            19568 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19569 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateError_TimeFirstChange),
            19570 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod),
            19571 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_Active),
            19572 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19573 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19574 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19575 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByParent),
            19576 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_Active),
            19577 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_Classification),
            19578 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19579 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19580 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalFromError),
            19581 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_Active),
            19582 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_Classification),
            19583 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19584 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19585 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StatePausedByParent),
            19586 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StatePausedByParent_Active),
            19587 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StatePausedByParent_Classification),
            19588 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19589 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19590 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod),
            19591 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_Active),
            19592 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19593 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19594 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19596 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages),
            19597 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_Active),
            19598 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_Classification),
            19599 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            19600 => Ok(VariableId::DataSetWriterType_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            19601 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MessageSequenceNumber),
            19602 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            19603 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_StatusCode),
            19604 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            19605 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MajorVersion),
            19606 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            19607 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MinorVersion),
            19608 => Ok(VariableId::DataSetWriterType_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            19610 => Ok(VariableId::DataSetReaderType_Diagnostics_DiagnosticsLevel),
            19611 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalInformation),
            19612 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalInformation_Active),
            19613 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalInformation_Classification),
            19614 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalInformation_DiagnosticsLevel),
            19615 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalInformation_TimeFirstChange),
            19616 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalError),
            19617 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalError_Active),
            19618 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalError_Classification),
            19619 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalError_DiagnosticsLevel),
            19620 => Ok(VariableId::DataSetReaderType_Diagnostics_TotalError_TimeFirstChange),
            19622 => Ok(VariableId::DataSetReaderType_Diagnostics_SubError),
            19624 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateError),
            19625 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateError_Active),
            19626 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateError_Classification),
            19627 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            19628 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateError_TimeFirstChange),
            19629 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod),
            19630 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_Active),
            19631 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            19632 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19633 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            19634 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByParent),
            19635 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_Active),
            19636 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_Classification),
            19637 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            19638 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            19639 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalFromError),
            19640 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_Active),
            19641 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_Classification),
            19642 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            19643 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            19644 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StatePausedByParent),
            19645 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StatePausedByParent_Active),
            19646 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StatePausedByParent_Classification),
            19647 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            19648 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            19649 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod),
            19650 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_Active),
            19651 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            19652 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19653 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            19655 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages),
            19656 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_Active),
            19657 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_Classification),
            19658 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_DiagnosticsLevel),
            19659 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_FailedDataSetMessages_TimeFirstChange),
            19660 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_DecryptionErrors),
            19661 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_DecryptionErrors_Active),
            19662 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_DecryptionErrors_Classification),
            19663 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel),
            19664 => Ok(VariableId::DataSetReaderType_Diagnostics_Counters_DecryptionErrors_TimeFirstChange),
            19665 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MessageSequenceNumber),
            19666 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            19667 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_StatusCode),
            19668 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_StatusCode_DiagnosticsLevel),
            19669 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MajorVersion),
            19670 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MajorVersion_DiagnosticsLevel),
            19671 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MinorVersion),
            19672 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_MinorVersion_DiagnosticsLevel),
            19673 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_SecurityTokenID),
            19674 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel),
            19675 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_TimeToNextTokenID),
            19676 => Ok(VariableId::DataSetReaderType_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            19678 => Ok(VariableId::PubSubDiagnosticsType_DiagnosticsLevel),
            19679 => Ok(VariableId::PubSubDiagnosticsType_TotalInformation),
            19680 => Ok(VariableId::PubSubDiagnosticsType_TotalInformation_Active),
            19681 => Ok(VariableId::PubSubDiagnosticsType_TotalInformation_Classification),
            19682 => Ok(VariableId::PubSubDiagnosticsType_TotalInformation_DiagnosticsLevel),
            19683 => Ok(VariableId::PubSubDiagnosticsType_TotalInformation_TimeFirstChange),
            19684 => Ok(VariableId::PubSubDiagnosticsType_TotalError),
            19685 => Ok(VariableId::PubSubDiagnosticsType_TotalError_Active),
            19686 => Ok(VariableId::PubSubDiagnosticsType_TotalError_Classification),
            19687 => Ok(VariableId::PubSubDiagnosticsType_TotalError_DiagnosticsLevel),
            19688 => Ok(VariableId::PubSubDiagnosticsType_TotalError_TimeFirstChange),
            19690 => Ok(VariableId::PubSubDiagnosticsType_SubError),
            19692 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateError),
            19693 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateError_Active),
            19694 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateError_Classification),
            19695 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateError_DiagnosticsLevel),
            19696 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateError_TimeFirstChange),
            19697 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByMethod),
            19698 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByMethod_Active),
            19699 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByMethod_Classification),
            19700 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19701 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByMethod_TimeFirstChange),
            19702 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByParent),
            19703 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByParent_Active),
            19704 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByParent_Classification),
            19705 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19706 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalByParent_TimeFirstChange),
            19707 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalFromError),
            19708 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalFromError_Active),
            19709 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalFromError_Classification),
            19710 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalFromError_DiagnosticsLevel),
            19711 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateOperationalFromError_TimeFirstChange),
            19712 => Ok(VariableId::PubSubDiagnosticsType_Counters_StatePausedByParent),
            19713 => Ok(VariableId::PubSubDiagnosticsType_Counters_StatePausedByParent_Active),
            19714 => Ok(VariableId::PubSubDiagnosticsType_Counters_StatePausedByParent_Classification),
            19715 => Ok(VariableId::PubSubDiagnosticsType_Counters_StatePausedByParent_DiagnosticsLevel),
            19716 => Ok(VariableId::PubSubDiagnosticsType_Counters_StatePausedByParent_TimeFirstChange),
            19717 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateDisabledByMethod),
            19718 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateDisabledByMethod_Active),
            19719 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateDisabledByMethod_Classification),
            19720 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19721 => Ok(VariableId::PubSubDiagnosticsType_Counters_StateDisabledByMethod_TimeFirstChange),
            19724 => Ok(VariableId::DiagnosticsLevel_EnumStrings),
            19726 => Ok(VariableId::PubSubDiagnosticsCounterType_Active),
            19727 => Ok(VariableId::PubSubDiagnosticsCounterType_Classification),
            19728 => Ok(VariableId::PubSubDiagnosticsCounterType_DiagnosticsLevel),
            19729 => Ok(VariableId::PubSubDiagnosticsCounterType_TimeFirstChange),
            19731 => Ok(VariableId::PubSubDiagnosticsCounterClassification_EnumStrings),
            19733 => Ok(VariableId::PubSubDiagnosticsRootType_DiagnosticsLevel),
            19734 => Ok(VariableId::PubSubDiagnosticsRootType_TotalInformation),
            19735 => Ok(VariableId::PubSubDiagnosticsRootType_TotalInformation_Active),
            19736 => Ok(VariableId::PubSubDiagnosticsRootType_TotalInformation_Classification),
            19737 => Ok(VariableId::PubSubDiagnosticsRootType_TotalInformation_DiagnosticsLevel),
            19738 => Ok(VariableId::PubSubDiagnosticsRootType_TotalInformation_TimeFirstChange),
            19739 => Ok(VariableId::PubSubDiagnosticsRootType_TotalError),
            19740 => Ok(VariableId::PubSubDiagnosticsRootType_TotalError_Active),
            19741 => Ok(VariableId::PubSubDiagnosticsRootType_TotalError_Classification),
            19742 => Ok(VariableId::PubSubDiagnosticsRootType_TotalError_DiagnosticsLevel),
            19743 => Ok(VariableId::PubSubDiagnosticsRootType_TotalError_TimeFirstChange),
            19745 => Ok(VariableId::PubSubDiagnosticsRootType_SubError),
            19747 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateError),
            19748 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateError_Active),
            19749 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateError_Classification),
            19750 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateError_DiagnosticsLevel),
            19751 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateError_TimeFirstChange),
            19752 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByMethod),
            19753 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_Active),
            19754 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_Classification),
            19755 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19756 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByMethod_TimeFirstChange),
            19757 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByParent),
            19758 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByParent_Active),
            19759 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByParent_Classification),
            19760 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19761 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalByParent_TimeFirstChange),
            19762 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalFromError),
            19763 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalFromError_Active),
            19764 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalFromError_Classification),
            19765 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalFromError_DiagnosticsLevel),
            19766 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateOperationalFromError_TimeFirstChange),
            19767 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StatePausedByParent),
            19768 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StatePausedByParent_Active),
            19769 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StatePausedByParent_Classification),
            19770 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StatePausedByParent_DiagnosticsLevel),
            19771 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StatePausedByParent_TimeFirstChange),
            19772 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateDisabledByMethod),
            19773 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_Active),
            19774 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_Classification),
            19775 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19776 => Ok(VariableId::PubSubDiagnosticsRootType_Counters_StateDisabledByMethod_TimeFirstChange),
            19778 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetWriters),
            19779 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            19780 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetReaders),
            19781 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            19782 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_OperationalDataSetWriters),
            19783 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            19784 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_OperationalDataSetReaders),
            19785 => Ok(VariableId::PubSubDiagnosticsRootType_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            19787 => Ok(VariableId::PubSubDiagnosticsConnectionType_DiagnosticsLevel),
            19788 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalInformation),
            19789 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalInformation_Active),
            19790 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalInformation_Classification),
            19791 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalInformation_DiagnosticsLevel),
            19792 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalInformation_TimeFirstChange),
            19793 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalError),
            19794 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalError_Active),
            19795 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalError_Classification),
            19796 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalError_DiagnosticsLevel),
            19797 => Ok(VariableId::PubSubDiagnosticsConnectionType_TotalError_TimeFirstChange),
            19799 => Ok(VariableId::PubSubDiagnosticsConnectionType_SubError),
            19801 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateError),
            19802 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateError_Active),
            19803 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateError_Classification),
            19804 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateError_DiagnosticsLevel),
            19805 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateError_TimeFirstChange),
            19806 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod),
            19807 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_Active),
            19808 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_Classification),
            19809 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19810 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByMethod_TimeFirstChange),
            19811 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent),
            19812 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_Active),
            19813 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_Classification),
            19814 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19815 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalByParent_TimeFirstChange),
            19816 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError),
            19817 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_Active),
            19818 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_Classification),
            19819 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_DiagnosticsLevel),
            19820 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateOperationalFromError_TimeFirstChange),
            19821 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StatePausedByParent),
            19822 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_Active),
            19823 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_Classification),
            19824 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_DiagnosticsLevel),
            19825 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StatePausedByParent_TimeFirstChange),
            19826 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod),
            19827 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_Active),
            19828 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_Classification),
            19829 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19830 => Ok(VariableId::PubSubDiagnosticsConnectionType_Counters_StateDisabledByMethod_TimeFirstChange),
            19832 => Ok(VariableId::PubSubDiagnosticsConnectionType_LiveValues_ResolvedAddress),
            19833 => Ok(VariableId::PubSubDiagnosticsConnectionType_LiveValues_ResolvedAddress_DiagnosticsLevel),
            19835 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_DiagnosticsLevel),
            19836 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalInformation),
            19837 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalInformation_Active),
            19838 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalInformation_Classification),
            19839 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalInformation_DiagnosticsLevel),
            19840 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalInformation_TimeFirstChange),
            19841 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalError),
            19842 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalError_Active),
            19843 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalError_Classification),
            19844 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalError_DiagnosticsLevel),
            19845 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_TotalError_TimeFirstChange),
            19847 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_SubError),
            19849 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateError),
            19850 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateError_Active),
            19851 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateError_Classification),
            19852 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateError_DiagnosticsLevel),
            19853 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateError_TimeFirstChange),
            19854 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod),
            19855 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_Active),
            19856 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_Classification),
            19857 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19858 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByMethod_TimeFirstChange),
            19859 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent),
            19860 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_Active),
            19861 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_Classification),
            19862 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19863 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalByParent_TimeFirstChange),
            19864 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError),
            19865 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_Active),
            19866 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_Classification),
            19867 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_DiagnosticsLevel),
            19868 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateOperationalFromError_TimeFirstChange),
            19869 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent),
            19870 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_Active),
            19871 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_Classification),
            19872 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_DiagnosticsLevel),
            19873 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StatePausedByParent_TimeFirstChange),
            19874 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod),
            19875 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_Active),
            19876 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_Classification),
            19877 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19878 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_StateDisabledByMethod_TimeFirstChange),
            19880 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages),
            19881 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_Active),
            19882 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_Classification),
            19883 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_DiagnosticsLevel),
            19884 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_SentNetworkMessages_TimeFirstChange),
            19885 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions),
            19886 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_Active),
            19887 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_Classification),
            19888 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_DiagnosticsLevel),
            19889 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_FailedTransmissions_TimeFirstChange),
            19890 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors),
            19891 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_Active),
            19892 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_Classification),
            19893 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_DiagnosticsLevel),
            19894 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_Counters_EncryptionErrors_TimeFirstChange),
            19895 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_ConfiguredDataSetWriters),
            19896 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_ConfiguredDataSetWriters_DiagnosticsLevel),
            19897 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_OperationalDataSetWriters),
            19898 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_OperationalDataSetWriters_DiagnosticsLevel),
            19899 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_SecurityTokenID),
            19900 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_SecurityTokenID_DiagnosticsLevel),
            19901 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_TimeToNextTokenID),
            19902 => Ok(VariableId::PubSubDiagnosticsWriterGroupType_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            19904 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_DiagnosticsLevel),
            19905 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalInformation),
            19906 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalInformation_Active),
            19907 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalInformation_Classification),
            19908 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalInformation_DiagnosticsLevel),
            19909 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalInformation_TimeFirstChange),
            19910 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalError),
            19911 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalError_Active),
            19912 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalError_Classification),
            19913 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalError_DiagnosticsLevel),
            19914 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_TotalError_TimeFirstChange),
            19916 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_SubError),
            19918 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateError),
            19919 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateError_Active),
            19920 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateError_Classification),
            19921 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateError_DiagnosticsLevel),
            19922 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateError_TimeFirstChange),
            19923 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod),
            19924 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_Active),
            19925 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_Classification),
            19926 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19927 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByMethod_TimeFirstChange),
            19928 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent),
            19929 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_Active),
            19930 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_Classification),
            19931 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19932 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalByParent_TimeFirstChange),
            19933 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError),
            19934 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_Active),
            19935 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_Classification),
            19936 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_DiagnosticsLevel),
            19937 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateOperationalFromError_TimeFirstChange),
            19938 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent),
            19939 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_Active),
            19940 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_Classification),
            19941 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_DiagnosticsLevel),
            19942 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StatePausedByParent_TimeFirstChange),
            19943 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod),
            19944 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_Active),
            19945 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_Classification),
            19946 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            19947 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_StateDisabledByMethod_TimeFirstChange),
            19949 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages),
            19950 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_Active),
            19951 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_Classification),
            19952 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_DiagnosticsLevel),
            19953 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedNetworkMessages_TimeFirstChange),
            19954 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages),
            19955 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_Active),
            19956 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_Classification),
            19957 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel),
            19958 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange),
            19959 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors),
            19960 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_Active),
            19961 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_Classification),
            19962 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_DiagnosticsLevel),
            19963 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_Counters_DecryptionErrors_TimeFirstChange),
            19964 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_LiveValues_ConfiguredDataSetReaders),
            19965 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            19966 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_LiveValues_OperationalDataSetReaders),
            19967 => Ok(VariableId::PubSubDiagnosticsReaderGroupType_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            19969 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_DiagnosticsLevel),
            19970 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalInformation),
            19971 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalInformation_Active),
            19972 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalInformation_Classification),
            19973 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalInformation_DiagnosticsLevel),
            19974 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalInformation_TimeFirstChange),
            19975 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalError),
            19976 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalError_Active),
            19977 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalError_Classification),
            19978 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalError_DiagnosticsLevel),
            19979 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_TotalError_TimeFirstChange),
            19981 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_SubError),
            19983 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateError),
            19984 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateError_Active),
            19985 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateError_Classification),
            19986 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateError_DiagnosticsLevel),
            19987 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateError_TimeFirstChange),
            19988 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod),
            19989 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_Active),
            19990 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_Classification),
            19991 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            19992 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByMethod_TimeFirstChange),
            19993 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent),
            19994 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_Active),
            19995 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_Classification),
            19996 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_DiagnosticsLevel),
            19997 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalByParent_TimeFirstChange),
            19998 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError),
            19999 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_Active),
            20000 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_Classification),
            20001 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_DiagnosticsLevel),
            20002 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateOperationalFromError_TimeFirstChange),
            20003 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent),
            20004 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_Active),
            20005 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_Classification),
            20006 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_DiagnosticsLevel),
            20007 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StatePausedByParent_TimeFirstChange),
            20008 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod),
            20009 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_Active),
            20010 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_Classification),
            20011 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            20012 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_StateDisabledByMethod_TimeFirstChange),
            20014 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages),
            20015 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_Active),
            20016 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_Classification),
            20017 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_DiagnosticsLevel),
            20018 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_Counters_FailedDataSetMessages_TimeFirstChange),
            20019 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MessageSequenceNumber),
            20020 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            20021 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_StatusCode),
            20022 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_StatusCode_DiagnosticsLevel),
            20023 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MajorVersion),
            20024 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MajorVersion_DiagnosticsLevel),
            20025 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MinorVersion),
            20026 => Ok(VariableId::PubSubDiagnosticsDataSetWriterType_LiveValues_MinorVersion_DiagnosticsLevel),
            20028 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_DiagnosticsLevel),
            20029 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalInformation),
            20030 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalInformation_Active),
            20031 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalInformation_Classification),
            20032 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalInformation_DiagnosticsLevel),
            20033 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalInformation_TimeFirstChange),
            20034 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalError),
            20035 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalError_Active),
            20036 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalError_Classification),
            20037 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalError_DiagnosticsLevel),
            20038 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_TotalError_TimeFirstChange),
            20040 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_SubError),
            20042 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateError),
            20043 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateError_Active),
            20044 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateError_Classification),
            20045 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateError_DiagnosticsLevel),
            20046 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateError_TimeFirstChange),
            20047 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod),
            20048 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_Active),
            20049 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_Classification),
            20050 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_DiagnosticsLevel),
            20051 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByMethod_TimeFirstChange),
            20052 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent),
            20053 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_Active),
            20054 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_Classification),
            20055 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_DiagnosticsLevel),
            20056 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalByParent_TimeFirstChange),
            20057 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError),
            20058 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_Active),
            20059 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_Classification),
            20060 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_DiagnosticsLevel),
            20061 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateOperationalFromError_TimeFirstChange),
            20062 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent),
            20063 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_Active),
            20064 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_Classification),
            20065 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_DiagnosticsLevel),
            20066 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StatePausedByParent_TimeFirstChange),
            20067 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod),
            20068 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_Active),
            20069 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_Classification),
            20070 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_DiagnosticsLevel),
            20071 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_StateDisabledByMethod_TimeFirstChange),
            20073 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages),
            20074 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_Active),
            20075 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_Classification),
            20076 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_DiagnosticsLevel),
            20077 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_FailedDataSetMessages_TimeFirstChange),
            20078 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors),
            20079 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_Active),
            20080 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_Classification),
            20081 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_DiagnosticsLevel),
            20082 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_Counters_DecryptionErrors_TimeFirstChange),
            20083 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MessageSequenceNumber),
            20084 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MessageSequenceNumber_DiagnosticsLevel),
            20085 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_StatusCode),
            20086 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_StatusCode_DiagnosticsLevel),
            20087 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MajorVersion),
            20088 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MajorVersion_DiagnosticsLevel),
            20089 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MinorVersion),
            20090 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_MinorVersion_DiagnosticsLevel),
            20091 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_SecurityTokenID),
            20092 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_SecurityTokenID_DiagnosticsLevel),
            20093 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_TimeToNextTokenID),
            20094 => Ok(VariableId::PubSubDiagnosticsDataSetReaderType_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            20095 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_AvailableTransitions),
            20096 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_UnshelveTime),
            20098 => Ok(VariableId::CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            20101 => Ok(VariableId::CertificateGroupType_CertificateExpired_SuppressedOrShelved),
            20102 => Ok(VariableId::CertificateGroupType_CertificateExpired_MaxTimeShelved),
            20103 => Ok(VariableId::CertificateGroupType_CertificateExpired_AudibleEnabled),
            20104 => Ok(VariableId::CertificateGroupType_CertificateExpired_AudibleSound),
            20105 => Ok(VariableId::CertificateGroupType_CertificateExpired_AudibleSound_ListId),
            20106 => Ok(VariableId::CertificateGroupType_CertificateExpired_AudibleSound_AgencyId),
            20107 => Ok(VariableId::CertificateGroupType_CertificateExpired_AudibleSound_VersionId),
            20108 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState),
            20109 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_Id),
            20110 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_Name),
            20111 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_Number),
            20112 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_EffectiveDisplayName),
            20113 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_TransitionTime),
            20114 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_EffectiveTransitionTime),
            20115 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_TrueState),
            20116 => Ok(VariableId::CertificateGroupType_CertificateExpired_SilenceState_FalseState),
            20117 => Ok(VariableId::CertificateGroupType_CertificateExpired_OnDelay),
            20118 => Ok(VariableId::CertificateGroupType_CertificateExpired_OffDelay),
            20119 => Ok(VariableId::CertificateGroupType_CertificateExpired_FirstInGroupFlag),
            20121 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState),
            20122 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_Id),
            20123 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_Name),
            20124 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_Number),
            20125 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_EffectiveDisplayName),
            20126 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_TransitionTime),
            20127 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_EffectiveTransitionTime),
            20128 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_TrueState),
            20129 => Ok(VariableId::CertificateGroupType_CertificateExpired_LatchedState_FalseState),
            20130 => Ok(VariableId::CertificateGroupType_CertificateExpired_ReAlarmTime),
            20131 => Ok(VariableId::CertificateGroupType_CertificateExpired_ReAlarmRepeatCount),
            20138 => Ok(VariableId::CertificateGroupType_CertificateExpired_NormalState),
            20139 => Ok(VariableId::CertificateGroupType_CertificateExpired_ExpirationDate),
            20140 => Ok(VariableId::CertificateGroupType_CertificateExpired_ExpirationLimit),
            20141 => Ok(VariableId::CertificateGroupType_CertificateExpired_CertificateType),
            20142 => Ok(VariableId::CertificateGroupType_CertificateExpired_Certificate),
            20144 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EventId),
            20145 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EventType),
            20146 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SourceNode),
            20147 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SourceName),
            20148 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Time),
            20149 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ReceiveTime),
            20150 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LocalTime),
            20151 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Message),
            20152 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Severity),
            20153 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConditionClassId),
            20154 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConditionClassName),
            20155 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConditionSubClassId),
            20156 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConditionSubClassName),
            20157 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConditionName),
            20158 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_BranchId),
            20159 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Retain),
            20160 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState),
            20161 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_Id),
            20162 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_Name),
            20163 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_Number),
            20164 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            20165 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_TransitionTime),
            20166 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            20167 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_TrueState),
            20168 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_EnabledState_FalseState),
            20169 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Quality),
            20170 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Quality_SourceTimestamp),
            20171 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LastSeverity),
            20172 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            20173 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Comment),
            20174 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Comment_SourceTimestamp),
            20175 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ClientUserId),
            20179 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AddComment_InputArguments),
            20180 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState),
            20181 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_Id),
            20182 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_Name),
            20183 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_Number),
            20184 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            20185 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_TransitionTime),
            20186 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            20187 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_TrueState),
            20188 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AckedState_FalseState),
            20189 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState),
            20190 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_Id),
            20191 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_Name),
            20192 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_Number),
            20193 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            20194 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_TransitionTime),
            20195 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            20196 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_TrueState),
            20197 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ConfirmedState_FalseState),
            20199 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Acknowledge_InputArguments),
            20201 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_Confirm_InputArguments),
            20202 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState),
            20203 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_Id),
            20204 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_Name),
            20205 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_Number),
            20206 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            20207 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_TransitionTime),
            20208 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            20209 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_TrueState),
            20210 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ActiveState_FalseState),
            20211 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_InputNode),
            20212 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState),
            20213 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_Id),
            20214 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_Name),
            20215 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_Number),
            20216 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            20217 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_TransitionTime),
            20218 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            20219 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_TrueState),
            20220 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedState_FalseState),
            20221 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState),
            20222 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Id),
            20223 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Name),
            20224 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_Number),
            20225 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            20226 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            20227 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            20228 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_TrueState),
            20229 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OutOfServiceState_FalseState),
            20231 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState),
            20232 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            20233 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            20234 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            20235 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            20236 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition),
            20237 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            20238 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            20239 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            20240 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            20241 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            20242 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_AvailableStates),
            20243 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            20244 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_UnshelveTime),
            20246 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            20249 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SuppressedOrShelved),
            20250 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_MaxTimeShelved),
            20251 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AudibleEnabled),
            20252 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AudibleSound),
            20253 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AudibleSound_ListId),
            20254 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AudibleSound_AgencyId),
            20255 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_AudibleSound_VersionId),
            20256 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState),
            20257 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_Id),
            20258 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_Name),
            20259 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_Number),
            20260 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            20261 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_TransitionTime),
            20262 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            20263 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_TrueState),
            20264 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_SilenceState_FalseState),
            20265 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OnDelay),
            20266 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_OffDelay),
            20267 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_FirstInGroupFlag),
            20269 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState),
            20270 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_Id),
            20271 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_Name),
            20272 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_Number),
            20273 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            20274 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_TransitionTime),
            20275 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            20276 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_TrueState),
            20277 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LatchedState_FalseState),
            20278 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ReAlarmTime),
            20279 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_ReAlarmRepeatCount),
            20286 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_NormalState),
            20287 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_TrustListId),
            20288 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_LastUpdateTime),
            20289 => Ok(VariableId::CertificateGroupType_TrustListOutOfDate_UpdateFrequency),
            20290 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_UpdateFrequency),
            20292 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EventId),
            20293 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EventType),
            20294 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SourceNode),
            20295 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SourceName),
            20296 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Time),
            20297 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReceiveTime),
            20298 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LocalTime),
            20299 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Message),
            20300 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Severity),
            20301 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionClassId),
            20302 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionClassName),
            20303 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId),
            20304 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName),
            20305 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConditionName),
            20306 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_BranchId),
            20307 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Retain),
            20308 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState),
            20309 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Id),
            20310 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Name),
            20311 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_Number),
            20312 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            20313 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime),
            20314 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            20315 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState),
            20316 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState),
            20317 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Quality),
            20318 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp),
            20319 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LastSeverity),
            20320 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            20321 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Comment),
            20322 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp),
            20323 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ClientUserId),
            20327 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments),
            20328 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState),
            20329 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Id),
            20330 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Name),
            20331 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_Number),
            20332 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            20333 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime),
            20334 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            20335 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState),
            20336 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState),
            20337 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState),
            20338 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id),
            20339 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name),
            20340 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number),
            20341 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            20342 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime),
            20343 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            20344 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState),
            20345 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState),
            20347 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments),
            20349 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments),
            20350 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState),
            20351 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Id),
            20352 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Name),
            20353 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_Number),
            20354 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            20355 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime),
            20356 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            20357 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState),
            20358 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState),
            20359 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_InputNode),
            20360 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState),
            20361 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id),
            20362 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name),
            20363 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number),
            20364 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            20365 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime),
            20366 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            20367 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState),
            20368 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState),
            20369 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState),
            20370 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id),
            20371 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name),
            20372 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number),
            20373 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            20374 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            20375 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            20376 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState),
            20377 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState),
            20379 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState),
            20380 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            20381 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            20382 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            20383 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            20384 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition),
            20385 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            20386 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            20387 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            20388 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            20389 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            20390 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates),
            20391 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            20392 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime),
            20394 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            20397 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved),
            20398 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved),
            20399 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleEnabled),
            20400 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound),
            20401 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId),
            20402 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId),
            20403 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId),
            20404 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState),
            20405 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Id),
            20406 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Name),
            20407 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_Number),
            20409 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_SecurityTokenID),
            20410 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            20411 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime),
            20412 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            20413 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState),
            20414 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState),
            20415 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OnDelay),
            20416 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_OffDelay),
            20417 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag),
            20419 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState),
            20420 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Id),
            20421 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Name),
            20422 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_Number),
            20423 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            20424 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime),
            20425 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            20426 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState),
            20427 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState),
            20428 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReAlarmTime),
            20429 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount),
            20436 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_NormalState),
            20437 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ExpirationDate),
            20438 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ExpirationLimit),
            20439 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_CertificateType),
            20440 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Certificate),
            20442 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EventId),
            20443 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EventType),
            20444 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SourceNode),
            20445 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SourceName),
            20446 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Time),
            20447 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime),
            20448 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LocalTime),
            20449 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Message),
            20450 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Severity),
            20451 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId),
            20452 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName),
            20453 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId),
            20454 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName),
            20455 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConditionName),
            20456 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_BranchId),
            20457 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Retain),
            20458 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState),
            20459 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id),
            20460 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name),
            20461 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number),
            20462 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            20463 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            20464 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            20465 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState),
            20466 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState),
            20467 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Quality),
            20468 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            20469 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity),
            20470 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            20471 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Comment),
            20472 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            20473 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId),
            20477 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments),
            20478 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState),
            20479 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id),
            20480 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name),
            20481 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number),
            20482 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            20483 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime),
            20484 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            20485 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState),
            20486 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState),
            20487 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState),
            20488 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id),
            20489 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name),
            20490 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number),
            20491 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            20492 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            20493 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            20494 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            20495 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            20497 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            20499 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments),
            20500 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState),
            20501 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id),
            20502 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name),
            20503 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number),
            20504 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            20505 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            20506 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            20507 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState),
            20508 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState),
            20509 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_InputNode),
            20510 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState),
            20511 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id),
            20512 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name),
            20513 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number),
            20514 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            20515 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            20516 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            20517 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState),
            20518 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState),
            20519 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState),
            20520 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id),
            20521 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name),
            20522 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number),
            20523 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            20524 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            20525 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            20526 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            20527 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            20529 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            20530 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            20531 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            20532 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            20533 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            20534 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            20535 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            20536 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            20537 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            20538 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            20539 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            20540 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            20541 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            20542 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            20544 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            20547 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved),
            20548 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved),
            20549 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled),
            20550 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound),
            20551 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId),
            20552 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            20553 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId),
            20554 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState),
            20555 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id),
            20556 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name),
            20557 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number),
            20558 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            20559 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            20560 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            20561 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState),
            20562 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState),
            20563 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OnDelay),
            20564 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_OffDelay),
            20565 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag),
            20567 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState),
            20568 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id),
            20569 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name),
            20570 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number),
            20571 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            20572 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            20573 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            20574 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState),
            20575 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState),
            20576 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime),
            20577 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            20584 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_NormalState),
            20585 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_TrustListId),
            20586 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime),
            20587 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency),
            20588 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_UpdateFrequency),
            20590 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EventId),
            20591 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EventType),
            20592 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SourceNode),
            20593 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SourceName),
            20594 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Time),
            20595 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReceiveTime),
            20596 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LocalTime),
            20597 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Message),
            20598 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Severity),
            20599 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionClassId),
            20600 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionClassName),
            20601 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId),
            20602 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName),
            20603 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConditionName),
            20604 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_BranchId),
            20605 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Retain),
            20606 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState),
            20607 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Id),
            20608 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Name),
            20609 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_Number),
            20610 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            20611 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime),
            20612 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            20613 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState),
            20614 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState),
            20615 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Quality),
            20616 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp),
            20617 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LastSeverity),
            20618 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            20619 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Comment),
            20620 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp),
            20621 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ClientUserId),
            20625 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments),
            20626 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState),
            20627 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Id),
            20628 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Name),
            20629 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_Number),
            20630 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            20631 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime),
            20632 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            20633 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState),
            20634 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState),
            20635 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState),
            20636 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id),
            20637 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name),
            20638 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number),
            20639 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            20640 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime),
            20641 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            20642 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState),
            20643 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState),
            20645 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments),
            20647 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments),
            20648 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState),
            20649 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Id),
            20650 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Name),
            20651 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_Number),
            20652 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            20653 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime),
            20654 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            20655 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState),
            20656 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState),
            20657 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_InputNode),
            20658 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState),
            20659 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id),
            20660 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name),
            20661 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number),
            20662 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            20663 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime),
            20664 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            20665 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState),
            20666 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState),
            20667 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState),
            20668 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id),
            20669 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name),
            20670 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number),
            20671 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            20672 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            20673 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            20674 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState),
            20675 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState),
            20677 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState),
            20678 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            20679 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            20680 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            20681 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            20682 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition),
            20683 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            20684 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            20685 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            20686 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            20687 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            20688 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates),
            20689 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            20690 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime),
            20692 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            20695 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved),
            20696 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved),
            20697 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleEnabled),
            20698 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound),
            20699 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId),
            20700 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId),
            20701 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId),
            20702 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState),
            20703 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Id),
            20704 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Name),
            20705 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_Number),
            20706 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            20707 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime),
            20708 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            20709 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState),
            20710 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState),
            20711 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OnDelay),
            20712 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_OffDelay),
            20713 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag),
            20715 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState),
            20716 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Id),
            20717 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Name),
            20718 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_Number),
            20719 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            20720 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime),
            20721 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            20722 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState),
            20723 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState),
            20724 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReAlarmTime),
            20725 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount),
            20732 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_NormalState),
            20733 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ExpirationDate),
            20734 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ExpirationLimit),
            20735 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_CertificateType),
            20736 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Certificate),
            20738 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EventId),
            20739 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EventType),
            20740 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SourceNode),
            20741 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SourceName),
            20742 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Time),
            20743 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime),
            20744 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LocalTime),
            20745 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Message),
            20746 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Severity),
            20747 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId),
            20748 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName),
            20749 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId),
            20750 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName),
            20751 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConditionName),
            20752 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_BranchId),
            20753 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Retain),
            20754 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState),
            20755 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id),
            20756 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name),
            20757 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number),
            20758 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            20759 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            20760 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            20761 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState),
            20762 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState),
            20763 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Quality),
            20764 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            20765 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity),
            20766 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            20767 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Comment),
            20768 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            20769 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId),
            20773 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments),
            20774 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState),
            20775 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id),
            20776 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name),
            20777 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number),
            20778 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            20779 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime),
            20780 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            20781 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState),
            20782 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState),
            20783 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState),
            20784 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id),
            20785 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name),
            20786 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number),
            20787 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            20788 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            20789 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            20790 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            20791 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            20793 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            20795 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments),
            20796 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState),
            20797 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id),
            20798 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name),
            20799 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number),
            20800 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            20801 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            20802 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            20803 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState),
            20804 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState),
            20805 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_InputNode),
            20806 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState),
            20807 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id),
            20808 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name),
            20809 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number),
            20810 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            20811 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            20812 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            20813 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState),
            20814 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState),
            20815 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState),
            20816 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id),
            20817 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name),
            20818 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number),
            20819 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            20820 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            20821 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            20822 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            20823 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            20825 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            20826 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            20827 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            20828 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            20829 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            20830 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            20831 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            20832 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            20833 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            20834 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            20835 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            20836 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            20837 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            20838 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            20840 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            20843 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved),
            20844 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved),
            20845 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled),
            20846 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound),
            20847 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId),
            20848 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            20849 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId),
            20850 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState),
            20851 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id),
            20852 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name),
            20853 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number),
            20854 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            20855 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            20856 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            20857 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState),
            20858 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState),
            20859 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OnDelay),
            20860 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_OffDelay),
            20861 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag),
            20863 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState),
            20864 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id),
            20865 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name),
            20866 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number),
            20867 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            20868 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            20869 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            20870 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState),
            20871 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState),
            20872 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime),
            20873 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            20880 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_NormalState),
            20881 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_TrustListId),
            20882 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime),
            20883 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency),
            20884 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_UpdateFrequency),
            20886 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EventId),
            20887 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EventType),
            20888 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SourceNode),
            20889 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SourceName),
            20890 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Time),
            20891 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReceiveTime),
            20892 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LocalTime),
            20893 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Message),
            20894 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Severity),
            20895 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionClassId),
            20896 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionClassName),
            20897 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId),
            20898 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName),
            20899 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConditionName),
            20900 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_BranchId),
            20901 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Retain),
            20902 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState),
            20903 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id),
            20904 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name),
            20905 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number),
            20906 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            20907 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime),
            20908 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            20909 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState),
            20910 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState),
            20911 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Quality),
            20912 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp),
            20913 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LastSeverity),
            20914 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            20915 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Comment),
            20916 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp),
            20917 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ClientUserId),
            20921 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments),
            20922 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState),
            20923 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Id),
            20924 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Name),
            20925 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_Number),
            20926 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            20927 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime),
            20928 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            20929 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState),
            20930 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState),
            20931 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState),
            20932 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id),
            20933 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name),
            20934 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number),
            20935 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            20936 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime),
            20937 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            20938 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState),
            20939 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState),
            20941 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments),
            20943 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments),
            20944 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState),
            20945 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id),
            20946 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name),
            20947 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number),
            20948 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            20949 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime),
            20950 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            20951 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState),
            20952 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState),
            20953 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_InputNode),
            20954 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState),
            20955 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id),
            20956 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name),
            20957 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number),
            20958 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            20959 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime),
            20960 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            20961 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState),
            20962 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState),
            20963 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState),
            20964 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id),
            20965 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name),
            20966 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number),
            20967 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            20968 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            20969 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            20970 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState),
            20971 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState),
            20973 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState),
            20974 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            20975 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            20976 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            20977 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            20978 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition),
            20979 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            20980 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            20981 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            20982 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            20983 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            20984 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates),
            20985 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            20986 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime),
            20988 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            20991 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved),
            20992 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved),
            20993 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled),
            20994 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound),
            20995 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId),
            20996 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId),
            20997 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId),
            21002 => Ok(VariableId::OpcUa_BinarySchema_FieldTargetDataType),
            21003 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_SecurityTokenID_DiagnosticsLevel),
            21004 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID),
            21005 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_LiveValues_TimeToNextTokenID_DiagnosticsLevel),
            21007 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState),
            21008 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id),
            21010 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables_InputArguments),
            21011 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables_OutputArguments),
            21013 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror_InputArguments),
            21014 => Ok(VariableId::ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror_OutputArguments),
            21016 => Ok(VariableId::ReaderGroupType_Diagnostics_DiagnosticsLevel),
            21017 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalInformation),
            21018 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalInformation_Active),
            21019 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalInformation_Classification),
            21020 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalInformation_DiagnosticsLevel),
            21021 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalInformation_TimeFirstChange),
            21022 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalError),
            21023 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalError_Active),
            21024 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalError_Classification),
            21025 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalError_DiagnosticsLevel),
            21026 => Ok(VariableId::ReaderGroupType_Diagnostics_TotalError_TimeFirstChange),
            21028 => Ok(VariableId::ReaderGroupType_Diagnostics_SubError),
            21030 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateError),
            21031 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateError_Active),
            21032 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateError_Classification),
            21033 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateError_DiagnosticsLevel),
            21034 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateError_TimeFirstChange),
            21035 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod),
            21036 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_Active),
            21037 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_Classification),
            21038 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_DiagnosticsLevel),
            21039 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByMethod_TimeFirstChange),
            21040 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByParent),
            21041 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_Active),
            21042 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_Classification),
            21043 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_DiagnosticsLevel),
            21044 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalByParent_TimeFirstChange),
            21045 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalFromError),
            21046 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_Active),
            21047 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_Classification),
            21048 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_DiagnosticsLevel),
            21049 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateOperationalFromError_TimeFirstChange),
            21050 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StatePausedByParent),
            21051 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StatePausedByParent_Active),
            21052 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StatePausedByParent_Classification),
            21053 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StatePausedByParent_DiagnosticsLevel),
            21054 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StatePausedByParent_TimeFirstChange),
            21055 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod),
            21056 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_Active),
            21057 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_Classification),
            21058 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_DiagnosticsLevel),
            21059 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_StateDisabledByMethod_TimeFirstChange),
            21061 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages),
            21062 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_Active),
            21063 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_Classification),
            21064 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_DiagnosticsLevel),
            21065 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedNetworkMessages_TimeFirstChange),
            21066 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages),
            21067 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Active),
            21068 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_Classification),
            21069 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_DiagnosticsLevel),
            21070 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_ReceivedInvalidNetworkMessages_TimeFirstChange),
            21071 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_DecryptionErrors),
            21072 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_DecryptionErrors_Active),
            21073 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_DecryptionErrors_Classification),
            21074 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_DecryptionErrors_DiagnosticsLevel),
            21075 => Ok(VariableId::ReaderGroupType_Diagnostics_Counters_DecryptionErrors_TimeFirstChange),
            21076 => Ok(VariableId::ReaderGroupType_Diagnostics_LiveValues_ConfiguredDataSetReaders),
            21077 => Ok(VariableId::ReaderGroupType_Diagnostics_LiveValues_ConfiguredDataSetReaders_DiagnosticsLevel),
            21078 => Ok(VariableId::ReaderGroupType_Diagnostics_LiveValues_OperationalDataSetReaders),
            21079 => Ok(VariableId::ReaderGroupType_Diagnostics_LiveValues_OperationalDataSetReaders_DiagnosticsLevel),
            21083 => Ok(VariableId::ReaderGroupType_AddDataSetReader_InputArguments),
            21084 => Ok(VariableId::ReaderGroupType_AddDataSetReader_OutputArguments),
            21086 => Ok(VariableId::ReaderGroupType_RemoveDataSetReader_InputArguments),
            21088 => Ok(VariableId::PubSubGroupTypeAddReaderMethodType_InputArguments),
            21089 => Ok(VariableId::PubSubGroupTypeAddReaderMethodType_OutputArguments),
            21092 => Ok(VariableId::DataSetWriterType_DataSetWriterId),
            21093 => Ok(VariableId::DataSetWriterType_DataSetFieldContentMask),
            21094 => Ok(VariableId::DataSetWriterType_KeyFrameCount),
            21097 => Ok(VariableId::DataSetReaderType_PublisherId),
            21098 => Ok(VariableId::DataSetReaderType_WriterGroupId),
            21099 => Ok(VariableId::DataSetReaderType_DataSetWriterId),
            21100 => Ok(VariableId::DataSetReaderType_DataSetMetaData),
            21101 => Ok(VariableId::DataSetReaderType_DataSetFieldContentMask),
            21102 => Ok(VariableId::DataSetReaderType_MessageReceiveTimeout),
            21106 => Ok(VariableId::UadpWriterGroupMessageType_GroupVersion),
            21107 => Ok(VariableId::UadpWriterGroupMessageType_DataSetOrdering),
            21108 => Ok(VariableId::UadpWriterGroupMessageType_NetworkMessageContentMask),
            21109 => Ok(VariableId::UadpWriterGroupMessageType_SamplingOffset),
            21110 => Ok(VariableId::UadpWriterGroupMessageType_PublishingOffset),
            21112 => Ok(VariableId::UadpDataSetWriterMessageType_DataSetMessageContentMask),
            21113 => Ok(VariableId::UadpDataSetWriterMessageType_ConfiguredSize),
            21114 => Ok(VariableId::UadpDataSetWriterMessageType_NetworkMessageNumber),
            21115 => Ok(VariableId::UadpDataSetWriterMessageType_DataSetOffset),
            21117 => Ok(VariableId::UadpDataSetReaderMessageType_GroupVersion),
            21118 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name),
            21119 => Ok(VariableId::UadpDataSetReaderMessageType_NetworkMessageNumber),
            21120 => Ok(VariableId::UadpDataSetReaderMessageType_DataSetClassId),
            21121 => Ok(VariableId::UadpDataSetReaderMessageType_NetworkMessageContentMask),
            21122 => Ok(VariableId::UadpDataSetReaderMessageType_DataSetMessageContentMask),
            21123 => Ok(VariableId::UadpDataSetReaderMessageType_PublishingInterval),
            21124 => Ok(VariableId::UadpDataSetReaderMessageType_ProcessingOffset),
            21125 => Ok(VariableId::UadpDataSetReaderMessageType_ReceiveOffset),
            21127 => Ok(VariableId::JsonWriterGroupMessageType_NetworkMessageContentMask),
            21129 => Ok(VariableId::JsonDataSetWriterMessageType_DataSetMessageContentMask),
            21131 => Ok(VariableId::JsonDataSetReaderMessageType_NetworkMessageContentMask),
            21132 => Ok(VariableId::JsonDataSetReaderMessageType_DataSetMessageContentMask),
            21134 => Ok(VariableId::DatagramWriterGroupTransportType_MessageRepeatCount),
            21135 => Ok(VariableId::DatagramWriterGroupTransportType_MessageRepeatDelay),
            21137 => Ok(VariableId::BrokerWriterGroupTransportType_QueueName),
            21139 => Ok(VariableId::BrokerDataSetWriterTransportType_QueueName),
            21140 => Ok(VariableId::BrokerDataSetWriterTransportType_MetaDataQueueName),
            21141 => Ok(VariableId::BrokerDataSetWriterTransportType_MetaDataUpdateTime),
            21143 => Ok(VariableId::BrokerDataSetReaderTransportType_QueueName),
            21144 => Ok(VariableId::BrokerDataSetReaderTransportType_MetaDataQueueName),
            21146 => Ok(VariableId::NetworkAddressType_NetworkInterface),
            21148 => Ok(VariableId::NetworkAddressUrlType_NetworkInterface),
            21149 => Ok(VariableId::NetworkAddressUrlType_Url),
            21156 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupDataType),
            21157 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupDataType_DataTypeVersion),
            21158 => Ok(VariableId::OpcUa_BinarySchema_WriterGroupDataType_DictionaryFragment),
            21159 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressDataType),
            21160 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressDataType_DataTypeVersion),
            21161 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressDataType_DictionaryFragment),
            21162 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressUrlDataType),
            21163 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressUrlDataType_DataTypeVersion),
            21164 => Ok(VariableId::OpcUa_BinarySchema_NetworkAddressUrlDataType_DictionaryFragment),
            21165 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupDataType),
            21166 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupDataType_DataTypeVersion),
            21167 => Ok(VariableId::OpcUa_BinarySchema_ReaderGroupDataType_DictionaryFragment),
            21168 => Ok(VariableId::OpcUa_BinarySchema_PubSubConfigurationDataType),
            21169 => Ok(VariableId::OpcUa_BinarySchema_PubSubConfigurationDataType_DataTypeVersion),
            21170 => Ok(VariableId::OpcUa_BinarySchema_PubSubConfigurationDataType_DictionaryFragment),
            21171 => Ok(VariableId::OpcUa_BinarySchema_DatagramWriterGroupTransportDataType),
            21172 => Ok(VariableId::OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DataTypeVersion),
            21173 => Ok(VariableId::OpcUa_BinarySchema_DatagramWriterGroupTransportDataType_DictionaryFragment),
            21204 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number),
            21205 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            21206 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime),
            21207 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            21208 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState),
            21209 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState),
            21210 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OnDelay),
            21211 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_OffDelay),
            21212 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag),
            21214 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState),
            21215 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id),
            21216 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name),
            21217 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number),
            21218 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            21219 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime),
            21220 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            21221 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState),
            21222 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState),
            21223 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime),
            21224 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount),
            21231 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_NormalState),
            21232 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ExpirationDate),
            21233 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit),
            21234 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_CertificateType),
            21235 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Certificate),
            21237 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EventId),
            21238 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EventType),
            21239 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode),
            21240 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SourceName),
            21241 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Time),
            21242 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime),
            21243 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime),
            21244 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Message),
            21245 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Severity),
            21246 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId),
            21247 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName),
            21248 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId),
            21249 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName),
            21250 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName),
            21251 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_BranchId),
            21252 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Retain),
            21253 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState),
            21254 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id),
            21255 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name),
            21256 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number),
            21257 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            21258 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            21259 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            21260 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState),
            21261 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState),
            21262 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Quality),
            21263 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            21264 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity),
            21265 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            21266 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Comment),
            21267 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            21268 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId),
            21272 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments),
            21273 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState),
            21274 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id),
            21275 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name),
            21276 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number),
            21277 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            21278 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime),
            21279 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            21280 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState),
            21281 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState),
            21282 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState),
            21283 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id),
            21284 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name),
            21285 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number),
            21286 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            21287 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            21288 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            21289 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            21290 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            21292 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            21294 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments),
            21295 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState),
            21296 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id),
            21297 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name),
            21298 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number),
            21299 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            21300 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            21301 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            21302 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState),
            21303 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState),
            21304 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_InputNode),
            21305 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState),
            21306 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id),
            21307 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name),
            21308 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number),
            21309 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            21310 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            21311 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            21312 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState),
            21313 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState),
            21314 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState),
            21315 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id),
            21316 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name),
            21317 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number),
            21318 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            21319 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            21320 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            21321 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            21322 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            21324 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            21325 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            21326 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            21327 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            21328 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            21329 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            21330 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            21331 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            21332 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            21333 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            21334 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            21335 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            21336 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            21337 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            21339 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            21342 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved),
            21343 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved),
            21344 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled),
            21345 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound),
            21346 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId),
            21347 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            21348 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId),
            21349 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState),
            21350 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id),
            21351 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name),
            21352 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number),
            21353 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            21354 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            21355 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            21356 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState),
            21357 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState),
            21358 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay),
            21359 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay),
            21360 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag),
            21362 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState),
            21363 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id),
            21364 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name),
            21365 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number),
            21366 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            21367 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            21368 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            21369 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState),
            21370 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState),
            21371 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime),
            21372 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            21379 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_NormalState),
            21380 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId),
            21381 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime),
            21382 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency),
            21383 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_UpdateFrequency),
            21385 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EventId),
            21386 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EventType),
            21387 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SourceNode),
            21388 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SourceName),
            21389 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Time),
            21390 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReceiveTime),
            21391 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LocalTime),
            21392 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Message),
            21393 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Severity),
            21394 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionClassId),
            21395 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionClassName),
            21396 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionSubClassId),
            21397 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionSubClassName),
            21398 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConditionName),
            21399 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_BranchId),
            21400 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Retain),
            21401 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState),
            21402 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Id),
            21403 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Name),
            21404 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_Number),
            21405 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_EffectiveDisplayName),
            21406 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_TransitionTime),
            21407 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_EffectiveTransitionTime),
            21408 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_TrueState),
            21409 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_EnabledState_FalseState),
            21410 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Quality),
            21411 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Quality_SourceTimestamp),
            21412 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LastSeverity),
            21413 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LastSeverity_SourceTimestamp),
            21414 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Comment),
            21415 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Comment_SourceTimestamp),
            21416 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ClientUserId),
            21420 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AddComment_InputArguments),
            21421 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState),
            21422 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Id),
            21423 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Name),
            21424 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_Number),
            21425 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_EffectiveDisplayName),
            21426 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_TransitionTime),
            21427 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_EffectiveTransitionTime),
            21428 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_TrueState),
            21429 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AckedState_FalseState),
            21430 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState),
            21431 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Id),
            21432 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Name),
            21433 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_Number),
            21434 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            21435 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_TransitionTime),
            21436 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            21437 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_TrueState),
            21438 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ConfirmedState_FalseState),
            21440 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Acknowledge_InputArguments),
            21442 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Confirm_InputArguments),
            21443 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState),
            21444 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Id),
            21445 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Name),
            21446 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_Number),
            21447 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_EffectiveDisplayName),
            21448 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_TransitionTime),
            21449 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_EffectiveTransitionTime),
            21450 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_TrueState),
            21451 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ActiveState_FalseState),
            21452 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_InputNode),
            21453 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState),
            21454 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Id),
            21455 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Name),
            21456 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_Number),
            21457 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_EffectiveDisplayName),
            21458 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_TransitionTime),
            21459 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            21460 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_TrueState),
            21461 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedState_FalseState),
            21462 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState),
            21463 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Id),
            21464 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Name),
            21465 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_Number),
            21466 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            21467 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_TransitionTime),
            21468 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            21469 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_TrueState),
            21470 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OutOfServiceState_FalseState),
            21472 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState),
            21473 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Id),
            21474 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Name),
            21475 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_Number),
            21476 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            21477 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition),
            21478 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Id),
            21479 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Name),
            21480 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_Number),
            21481 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            21482 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            21483 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_AvailableStates),
            21484 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_AvailableTransitions),
            21485 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_UnshelveTime),
            21487 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            21490 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SuppressedOrShelved),
            21491 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_MaxTimeShelved),
            21492 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleEnabled),
            21493 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound),
            21494 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_ListId),
            21495 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_AgencyId),
            21496 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AudibleSound_VersionId),
            21497 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState),
            21498 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Id),
            21499 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Name),
            21500 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_Number),
            21501 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_EffectiveDisplayName),
            21502 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_TransitionTime),
            21503 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_EffectiveTransitionTime),
            21504 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_TrueState),
            21505 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_SilenceState_FalseState),
            21506 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OnDelay),
            21507 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_OffDelay),
            21508 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_FirstInGroupFlag),
            21510 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState),
            21511 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Id),
            21512 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Name),
            21513 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_Number),
            21514 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_EffectiveDisplayName),
            21515 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_TransitionTime),
            21516 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_EffectiveTransitionTime),
            21517 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_TrueState),
            21518 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_LatchedState_FalseState),
            21519 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReAlarmTime),
            21520 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ReAlarmRepeatCount),
            21527 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_NormalState),
            21528 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ExpirationDate),
            21529 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ExpirationLimit),
            21530 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_CertificateType),
            21531 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Certificate),
            21533 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EventId),
            21534 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EventType),
            21535 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SourceNode),
            21536 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SourceName),
            21537 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Time),
            21538 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReceiveTime),
            21539 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LocalTime),
            21540 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Message),
            21541 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Severity),
            21542 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionClassId),
            21543 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionClassName),
            21544 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionSubClassId),
            21545 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionSubClassName),
            21546 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConditionName),
            21547 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_BranchId),
            21548 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Retain),
            21549 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState),
            21550 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Id),
            21551 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Name),
            21552 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_Number),
            21553 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            21554 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_TransitionTime),
            21555 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            21556 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_TrueState),
            21557 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_EnabledState_FalseState),
            21558 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Quality),
            21559 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Quality_SourceTimestamp),
            21560 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastSeverity),
            21561 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            21562 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Comment),
            21563 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Comment_SourceTimestamp),
            21564 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ClientUserId),
            21568 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AddComment_InputArguments),
            21569 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState),
            21570 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Id),
            21571 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Name),
            21572 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_Number),
            21573 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            21574 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_TransitionTime),
            21575 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            21576 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_TrueState),
            21577 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AckedState_FalseState),
            21578 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState),
            21579 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Id),
            21580 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Name),
            21581 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_Number),
            21582 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            21583 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_TransitionTime),
            21584 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            21585 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_TrueState),
            21586 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ConfirmedState_FalseState),
            21588 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Acknowledge_InputArguments),
            21590 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Confirm_InputArguments),
            21591 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState),
            21592 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Id),
            21593 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Name),
            21594 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_Number),
            21595 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            21596 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_TransitionTime),
            21597 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            21598 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_TrueState),
            21599 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ActiveState_FalseState),
            21600 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_InputNode),
            21601 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState),
            21602 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Id),
            21603 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Name),
            21604 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_Number),
            21605 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            21606 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_TransitionTime),
            21607 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            21608 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_TrueState),
            21609 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedState_FalseState),
            21610 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState),
            21611 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Id),
            21612 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Name),
            21613 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_Number),
            21614 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            21615 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            21616 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            21617 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_TrueState),
            21618 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OutOfServiceState_FalseState),
            21620 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState),
            21621 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            21622 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            21623 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            21624 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            21625 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition),
            21626 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            21627 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            21628 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            21629 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            21630 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            21631 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_AvailableStates),
            21632 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            21633 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_UnshelveTime),
            21635 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            21638 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SuppressedOrShelved),
            21639 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_MaxTimeShelved),
            21640 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleEnabled),
            21641 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound),
            21642 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_ListId),
            21643 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_AgencyId),
            21644 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AudibleSound_VersionId),
            21645 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState),
            21646 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Id),
            21647 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Name),
            21648 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_Number),
            21649 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            21650 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_TransitionTime),
            21651 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            21652 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_TrueState),
            21653 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_SilenceState_FalseState),
            21654 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OnDelay),
            21655 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_OffDelay),
            21656 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_FirstInGroupFlag),
            21658 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState),
            21659 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Id),
            21660 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Name),
            21661 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_Number),
            21662 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            21663 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_TransitionTime),
            21664 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            21665 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_TrueState),
            21666 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LatchedState_FalseState),
            21667 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReAlarmTime),
            21668 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ReAlarmRepeatCount),
            21675 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_NormalState),
            21676 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_TrustListId),
            21677 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_LastUpdateTime),
            21678 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_UpdateFrequency),
            21679 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency),
            21681 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId),
            21682 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType),
            21683 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode),
            21684 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName),
            21685 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time),
            21686 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime),
            21687 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime),
            21688 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message),
            21689 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity),
            21690 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId),
            21691 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName),
            21692 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId),
            21693 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName),
            21694 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName),
            21695 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId),
            21696 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain),
            21697 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState),
            21698 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id),
            21699 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name),
            21700 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number),
            21701 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            21702 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime),
            21703 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            21704 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState),
            21705 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState),
            21706 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality),
            21707 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp),
            21708 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity),
            21709 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            21710 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment),
            21711 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp),
            21712 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId),
            21716 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments),
            21717 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState),
            21718 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id),
            21719 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name),
            21720 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number),
            21721 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            21722 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime),
            21723 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            21724 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState),
            21725 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState),
            21726 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState),
            21727 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id),
            21728 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name),
            21729 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number),
            21730 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            21731 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime),
            21732 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            21733 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState),
            21734 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState),
            21736 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments),
            21738 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments),
            21739 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState),
            21740 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id),
            21741 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name),
            21742 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number),
            21743 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            21744 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime),
            21745 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            21746 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState),
            21747 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState),
            21748 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode),
            21749 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState),
            21750 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id),
            21751 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name),
            21752 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number),
            21753 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            21754 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime),
            21755 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            21756 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState),
            21757 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState),
            21758 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState),
            21759 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id),
            21760 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name),
            21761 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number),
            21762 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            21763 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            21764 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            21765 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState),
            21766 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState),
            21768 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState),
            21769 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            21770 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            21771 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            21772 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            21773 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition),
            21774 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            21775 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            21776 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            21777 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            21778 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            21779 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates),
            21780 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            21781 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime),
            21783 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            21786 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved),
            21787 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved),
            21788 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled),
            21789 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound),
            21790 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId),
            21791 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId),
            21792 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId),
            21793 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState),
            21794 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id),
            21795 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name),
            21796 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number),
            21797 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            21798 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime),
            21799 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            21800 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState),
            21801 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState),
            21802 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay),
            21803 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay),
            21804 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag),
            21806 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState),
            21807 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id),
            21808 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name),
            21809 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number),
            21810 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            21811 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime),
            21812 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            21813 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState),
            21814 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState),
            21815 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime),
            21816 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount),
            21823 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState),
            21824 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate),
            21825 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit),
            21826 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType),
            21827 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate),
            21829 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId),
            21830 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType),
            21831 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode),
            21832 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName),
            21833 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time),
            21834 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime),
            21835 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime),
            21836 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message),
            21837 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity),
            21838 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId),
            21839 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName),
            21840 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId),
            21841 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName),
            21842 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName),
            21843 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId),
            21844 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain),
            21845 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState),
            21846 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id),
            21847 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name),
            21848 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number),
            21849 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            21850 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            21851 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            21852 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState),
            21853 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState),
            21854 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality),
            21855 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            21856 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity),
            21857 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            21858 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment),
            21859 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            21860 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId),
            21864 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments),
            21865 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState),
            21866 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id),
            21867 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name),
            21868 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number),
            21869 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            21870 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime),
            21871 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            21872 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState),
            21873 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState),
            21874 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState),
            21875 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id),
            21876 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name),
            21877 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number),
            21878 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            21879 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            21880 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            21881 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            21882 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            21884 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            21886 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments),
            21887 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState),
            21888 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id),
            21889 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name),
            21890 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number),
            21891 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            21892 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            21893 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            21894 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState),
            21895 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState),
            21896 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode),
            21897 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState),
            21898 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id),
            21899 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name),
            21900 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number),
            21901 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            21902 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            21903 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            21904 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState),
            21905 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState),
            21906 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState),
            21907 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id),
            21908 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name),
            21909 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number),
            21910 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            21911 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            21912 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            21913 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            21914 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            21916 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            21917 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            21918 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            21919 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            21920 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            21921 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            21922 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            21923 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            21924 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            21925 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            21926 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            21927 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            21928 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            21929 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            21931 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            21934 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved),
            21935 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved),
            21936 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled),
            21937 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound),
            21938 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId),
            21939 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            21940 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId),
            21941 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState),
            21942 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id),
            21943 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name),
            21944 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number),
            21945 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            21946 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            21947 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            21948 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState),
            21949 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState),
            21950 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay),
            21951 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay),
            21952 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag),
            21954 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState),
            21955 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id),
            21956 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name),
            21957 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number),
            21958 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            21959 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            21960 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            21961 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState),
            21962 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState),
            21963 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime),
            21964 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            21971 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState),
            21972 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId),
            21973 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime),
            21974 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency),
            21975 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency),
            21977 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId),
            21978 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType),
            21979 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode),
            21980 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName),
            21981 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time),
            21982 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime),
            21983 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime),
            21984 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message),
            21985 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity),
            21986 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId),
            21987 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName),
            21988 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId),
            21989 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName),
            21990 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName),
            21991 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId),
            21992 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain),
            21993 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState),
            21994 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id),
            21995 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name),
            21996 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number),
            21997 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            21998 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime),
            21999 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            22000 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState),
            22001 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState),
            22002 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality),
            22003 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp),
            22004 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity),
            22005 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            22006 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment),
            22007 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp),
            22008 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId),
            22012 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments),
            22013 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState),
            22014 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id),
            22015 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name),
            22016 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number),
            22017 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            22018 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime),
            22019 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            22020 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState),
            22021 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState),
            22022 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState),
            22023 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id),
            22024 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name),
            22025 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number),
            22026 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            22027 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime),
            22028 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            22029 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState),
            22030 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState),
            22032 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments),
            22034 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments),
            22035 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState),
            22036 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id),
            22037 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name),
            22038 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number),
            22039 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            22040 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime),
            22041 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            22042 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState),
            22043 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState),
            22044 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode),
            22045 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState),
            22046 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id),
            22047 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name),
            22048 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number),
            22049 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            22050 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime),
            22051 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            22052 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState),
            22053 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState),
            22054 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState),
            22055 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id),
            22056 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name),
            22057 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number),
            22058 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            22059 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            22060 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            22061 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState),
            22062 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState),
            22064 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState),
            22065 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            22066 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            22067 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            22068 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            22069 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition),
            22070 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            22071 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            22072 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            22073 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            22074 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            22075 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates),
            22076 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            22077 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime),
            22079 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            22082 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved),
            22083 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved),
            22084 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled),
            22085 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound),
            22086 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId),
            22087 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId),
            22088 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId),
            22089 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState),
            22090 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id),
            22091 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name),
            22092 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number),
            22093 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            22094 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime),
            22095 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            22096 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState),
            22097 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState),
            22098 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay),
            22099 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay),
            22100 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag),
            22102 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState),
            22103 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id),
            22104 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name),
            22105 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number),
            22106 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            22107 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime),
            22108 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            22109 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState),
            22110 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState),
            22111 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime),
            22112 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount),
            22119 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState),
            22120 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate),
            22121 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit),
            22122 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType),
            22123 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate),
            22125 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId),
            22126 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType),
            22127 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode),
            22128 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName),
            22129 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time),
            22130 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime),
            22131 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime),
            22132 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message),
            22133 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity),
            22134 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId),
            22135 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName),
            22136 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId),
            22137 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName),
            22138 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName),
            22139 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId),
            22140 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain),
            22141 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState),
            22142 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id),
            22143 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name),
            22144 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number),
            22145 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            22146 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            22147 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            22148 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState),
            22149 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState),
            22150 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality),
            22151 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            22152 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity),
            22153 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            22154 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment),
            22155 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            22156 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId),
            22160 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments),
            22161 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState),
            22162 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id),
            22163 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name),
            22164 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number),
            22165 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            22166 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime),
            22167 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            22168 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState),
            22169 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState),
            22170 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState),
            22171 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id),
            22172 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name),
            22173 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number),
            22174 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            22175 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            22176 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            22177 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            22178 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            22180 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            22182 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments),
            22183 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState),
            22184 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id),
            22185 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name),
            22186 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number),
            22187 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            22188 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            22189 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            22190 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState),
            22191 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState),
            22192 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode),
            22193 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState),
            22194 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id),
            22195 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name),
            22196 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number),
            22197 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            22198 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            22199 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            22200 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState),
            22201 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState),
            22202 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState),
            22203 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id),
            22204 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name),
            22205 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number),
            22206 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            22207 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            22208 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            22209 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            22210 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            22212 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            22213 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            22214 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            22215 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            22216 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            22217 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            22218 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            22219 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            22220 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            22221 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            22222 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            22223 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            22224 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            22225 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            22227 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            22230 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved),
            22231 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved),
            22232 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled),
            22233 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound),
            22234 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId),
            22235 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            22236 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId),
            22237 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState),
            22238 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id),
            22239 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name),
            22240 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number),
            22241 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            22242 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            22243 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            22244 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState),
            22245 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState),
            22246 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay),
            22247 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay),
            22248 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag),
            22250 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState),
            22251 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id),
            22252 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name),
            22253 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number),
            22254 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            22255 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            22256 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            22257 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState),
            22258 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState),
            22259 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime),
            22260 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            22267 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState),
            22268 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId),
            22269 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime),
            22270 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency),
            22271 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency),
            22273 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId),
            22274 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType),
            22275 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode),
            22276 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName),
            22277 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time),
            22278 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime),
            22279 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime),
            22280 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message),
            22281 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity),
            22282 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId),
            22283 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName),
            22284 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId),
            22285 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName),
            22286 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName),
            22287 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId),
            22288 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain),
            22289 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState),
            22290 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id),
            22291 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name),
            22292 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number),
            22293 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            22294 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime),
            22295 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            22296 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState),
            22297 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState),
            22298 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality),
            22299 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp),
            22300 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity),
            22301 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            22302 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment),
            22303 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp),
            22304 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId),
            22308 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments),
            22309 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState),
            22310 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id),
            22311 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name),
            22312 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number),
            22313 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            22314 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime),
            22315 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            22316 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState),
            22317 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState),
            22318 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState),
            22319 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id),
            22320 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name),
            22321 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number),
            22322 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            22323 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime),
            22324 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            22325 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState),
            22326 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState),
            22328 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments),
            22330 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments),
            22331 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState),
            22332 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id),
            22333 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name),
            22334 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number),
            22335 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            22336 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime),
            22337 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            22338 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState),
            22339 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState),
            22340 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode),
            22341 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState),
            22342 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id),
            22343 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name),
            22344 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number),
            22345 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            22346 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime),
            22347 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            22348 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState),
            22349 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState),
            22350 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState),
            22351 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id),
            22352 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name),
            22353 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number),
            22354 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            22355 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            22356 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            22357 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState),
            22358 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState),
            22360 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState),
            22361 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            22362 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            22363 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            22364 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            22365 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition),
            22366 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            22367 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            22368 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            22369 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            22370 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            22371 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates),
            22372 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            22373 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime),
            22375 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            22378 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved),
            22379 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved),
            22380 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled),
            22381 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound),
            22382 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId),
            22383 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId),
            22384 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId),
            22385 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState),
            22386 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id),
            22387 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name),
            22388 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number),
            22389 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            22390 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime),
            22391 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            22392 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState),
            22393 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState),
            22394 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay),
            22395 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay),
            22396 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag),
            22398 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState),
            22399 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id),
            22400 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name),
            22401 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number),
            22402 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            22403 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime),
            22404 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            22405 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState),
            22406 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState),
            22407 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime),
            22408 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount),
            22415 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState),
            22416 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate),
            22417 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit),
            22418 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType),
            22419 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate),
            22421 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId),
            22422 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType),
            22423 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode),
            22424 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName),
            22425 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time),
            22426 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime),
            22427 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime),
            22428 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message),
            22429 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity),
            22430 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId),
            22431 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName),
            22432 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId),
            22433 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName),
            22434 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName),
            22435 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId),
            22436 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain),
            22437 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState),
            22438 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id),
            22439 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name),
            22440 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number),
            22441 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            22442 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            22443 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            22444 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState),
            22445 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState),
            22446 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality),
            22447 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            22448 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity),
            22449 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            22450 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment),
            22451 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            22452 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId),
            22456 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments),
            22457 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState),
            22458 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id),
            22459 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name),
            22460 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number),
            22461 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            22462 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime),
            22463 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            22464 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState),
            22465 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState),
            22466 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState),
            22467 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id),
            22468 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name),
            22469 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number),
            22470 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            22471 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            22472 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            22473 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            22474 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            22476 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            22478 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments),
            22479 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState),
            22480 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id),
            22481 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name),
            22482 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number),
            22483 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            22484 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            22485 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            22486 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState),
            22487 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState),
            22488 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode),
            22489 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState),
            22490 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id),
            22491 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name),
            22492 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number),
            22493 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            22494 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            22495 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            22496 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState),
            22497 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState),
            22498 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState),
            22499 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id),
            22500 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name),
            22501 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number),
            22502 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            22503 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            22504 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            22505 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            22506 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            22508 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            22509 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            22510 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            22511 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            22512 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            22513 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            22514 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            22515 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            22516 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            22517 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            22518 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            22519 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            22520 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            22521 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            22523 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            22526 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved),
            22527 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved),
            22528 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled),
            22529 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound),
            22530 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId),
            22531 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            22532 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId),
            22533 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState),
            22534 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id),
            22535 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name),
            22536 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number),
            22537 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            22538 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            22539 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            22540 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState),
            22541 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState),
            22542 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay),
            22543 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay),
            22544 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag),
            22546 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState),
            22547 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id),
            22548 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name),
            22549 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number),
            22550 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            22551 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            22552 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            22553 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState),
            22554 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState),
            22555 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime),
            22556 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            22563 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState),
            22564 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId),
            22565 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime),
            22566 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency),
            22567 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_UpdateFrequency),
            22569 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventId),
            22570 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EventType),
            22571 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceNode),
            22572 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SourceName),
            22573 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Time),
            22574 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReceiveTime),
            22575 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LocalTime),
            22576 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Message),
            22577 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Severity),
            22578 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassId),
            22579 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionClassName),
            22580 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassId),
            22581 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionSubClassName),
            22582 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConditionName),
            22583 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_BranchId),
            22584 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Retain),
            22585 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState),
            22586 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Id),
            22587 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Name),
            22588 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_Number),
            22589 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            22590 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TransitionTime),
            22591 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            22592 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_TrueState),
            22593 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_EnabledState_FalseState),
            22594 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality),
            22595 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Quality_SourceTimestamp),
            22596 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity),
            22597 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            22598 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment),
            22599 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Comment_SourceTimestamp),
            22600 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ClientUserId),
            22604 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment_InputArguments),
            22605 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState),
            22606 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Id),
            22607 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Name),
            22608 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_Number),
            22609 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            22610 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TransitionTime),
            22611 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            22612 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_TrueState),
            22613 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AckedState_FalseState),
            22614 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState),
            22615 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Id),
            22616 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Name),
            22617 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_Number),
            22618 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            22619 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TransitionTime),
            22620 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            22621 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_TrueState),
            22622 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ConfirmedState_FalseState),
            22624 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge_InputArguments),
            22626 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm_InputArguments),
            22627 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState),
            22628 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Id),
            22629 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Name),
            22630 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_Number),
            22631 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            22632 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TransitionTime),
            22633 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            22634 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_TrueState),
            22635 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ActiveState_FalseState),
            22636 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_InputNode),
            22637 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState),
            22638 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Id),
            22639 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Name),
            22640 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_Number),
            22641 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            22642 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TransitionTime),
            22643 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            22644 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_TrueState),
            22645 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedState_FalseState),
            22646 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState),
            22647 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Id),
            22648 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Name),
            22649 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_Number),
            22650 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            22651 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            22652 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            22653 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_TrueState),
            22654 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OutOfServiceState_FalseState),
            22656 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState),
            22657 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            22658 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            22659 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            22660 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            22661 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition),
            22662 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            22663 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            22664 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            22665 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            22666 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            22667 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableStates),
            22668 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            22669 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_UnshelveTime),
            22671 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            22674 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SuppressedOrShelved),
            22675 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_MaxTimeShelved),
            22676 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleEnabled),
            22677 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound),
            22678 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_ListId),
            22679 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_AgencyId),
            22680 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AudibleSound_VersionId),
            22681 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState),
            22682 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Id),
            22683 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Name),
            22684 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_Number),
            22685 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            22686 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TransitionTime),
            22687 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            22688 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_TrueState),
            22689 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_SilenceState_FalseState),
            22690 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OnDelay),
            22691 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_OffDelay),
            22692 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_FirstInGroupFlag),
            22694 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState),
            22695 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Id),
            22696 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Name),
            22697 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_Number),
            22698 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            22699 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TransitionTime),
            22700 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            22701 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_TrueState),
            22702 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_LatchedState_FalseState),
            22703 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmTime),
            22704 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ReAlarmRepeatCount),
            22711 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_NormalState),
            22712 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationDate),
            22713 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ExpirationLimit),
            22714 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_CertificateType),
            22715 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Certificate),
            22717 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventId),
            22718 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EventType),
            22719 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceNode),
            22720 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SourceName),
            22721 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Time),
            22722 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReceiveTime),
            22723 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LocalTime),
            22724 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Message),
            22725 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Severity),
            22726 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassId),
            22727 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionClassName),
            22728 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassId),
            22729 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionSubClassName),
            22730 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConditionName),
            22731 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_BranchId),
            22732 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Retain),
            22733 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState),
            22734 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Id),
            22735 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Name),
            22736 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_Number),
            22737 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            22738 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            22739 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            22740 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_TrueState),
            22741 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_EnabledState_FalseState),
            22742 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality),
            22743 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            22744 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity),
            22745 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            22746 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment),
            22747 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            22748 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ClientUserId),
            22752 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment_InputArguments),
            22753 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState),
            22754 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Id),
            22755 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Name),
            22756 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_Number),
            22757 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            22758 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TransitionTime),
            22759 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            22760 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_TrueState),
            22761 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AckedState_FalseState),
            22762 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState),
            22763 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Id),
            22764 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Name),
            22765 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_Number),
            22766 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            22767 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            22768 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            22769 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            22770 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            22772 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            22774 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm_InputArguments),
            22775 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState),
            22776 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Id),
            22777 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Name),
            22778 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_Number),
            22779 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            22780 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            22781 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            22782 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_TrueState),
            22783 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ActiveState_FalseState),
            22784 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_InputNode),
            22785 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState),
            22786 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Id),
            22787 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Name),
            22788 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_Number),
            22789 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            22790 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            22791 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            22792 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_TrueState),
            22793 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedState_FalseState),
            22794 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState),
            22795 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Id),
            22796 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Name),
            22797 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_Number),
            22798 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            22799 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            22800 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            22801 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            22802 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            22804 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            22805 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            22806 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            22807 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            22808 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            22809 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            22810 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            22811 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            22812 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            22813 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            22814 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            22815 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            22816 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            22817 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            22819 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            22822 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SuppressedOrShelved),
            22823 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_MaxTimeShelved),
            22824 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleEnabled),
            22825 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound),
            22826 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_ListId),
            22827 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            22828 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AudibleSound_VersionId),
            22829 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState),
            22830 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Id),
            22831 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Name),
            22832 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_Number),
            22833 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            22834 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            22835 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            22836 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_TrueState),
            22837 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_SilenceState_FalseState),
            22838 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OnDelay),
            22839 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_OffDelay),
            22840 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_FirstInGroupFlag),
            22842 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState),
            22843 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Id),
            22844 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Name),
            22845 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_Number),
            22846 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            22847 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            22848 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            22849 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_TrueState),
            22850 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LatchedState_FalseState),
            22851 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmTime),
            22852 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            22859 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_NormalState),
            22860 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_TrustListId),
            22861 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_LastUpdateTime),
            22862 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_UpdateFrequency),
            22863 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_UpdateFrequency),
            22865 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventId),
            22866 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EventType),
            22867 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceNode),
            22868 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SourceName),
            22869 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Time),
            22870 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReceiveTime),
            22871 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LocalTime),
            22872 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Message),
            22873 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Severity),
            22874 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassId),
            22875 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionClassName),
            22876 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassId),
            22877 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionSubClassName),
            22878 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConditionName),
            22879 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_BranchId),
            22880 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Retain),
            22881 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState),
            22882 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Id),
            22883 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Name),
            22884 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_Number),
            22885 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            22886 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TransitionTime),
            22887 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            22888 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_TrueState),
            22889 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_EnabledState_FalseState),
            22890 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality),
            22891 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Quality_SourceTimestamp),
            22892 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity),
            22893 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            22894 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment),
            22895 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Comment_SourceTimestamp),
            22896 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ClientUserId),
            22900 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment_InputArguments),
            22901 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState),
            22902 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Id),
            22903 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Name),
            22904 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_Number),
            22905 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            22906 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TransitionTime),
            22907 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            22908 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_TrueState),
            22909 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AckedState_FalseState),
            22910 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState),
            22911 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Id),
            22912 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Name),
            22913 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_Number),
            22914 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            22915 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TransitionTime),
            22916 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            22917 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_TrueState),
            22918 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ConfirmedState_FalseState),
            22920 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge_InputArguments),
            22922 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm_InputArguments),
            22923 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState),
            22924 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Id),
            22925 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Name),
            22926 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_Number),
            22927 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            22928 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TransitionTime),
            22929 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            22930 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_TrueState),
            22931 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ActiveState_FalseState),
            22932 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_InputNode),
            22933 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState),
            22934 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Id),
            22935 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Name),
            22936 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_Number),
            22937 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            22938 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TransitionTime),
            22939 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            22940 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_TrueState),
            22941 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedState_FalseState),
            22942 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState),
            22943 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Id),
            22944 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Name),
            22945 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_Number),
            22946 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            22947 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            22948 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            22949 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_TrueState),
            22950 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OutOfServiceState_FalseState),
            22952 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState),
            22953 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            22954 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            22955 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            22956 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            22957 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition),
            22958 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            22959 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            22960 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            22961 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            22962 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            22963 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableStates),
            22964 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            22965 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_UnshelveTime),
            22967 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            22970 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SuppressedOrShelved),
            22971 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_MaxTimeShelved),
            22972 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleEnabled),
            22973 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound),
            22974 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_ListId),
            22975 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_AgencyId),
            22976 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AudibleSound_VersionId),
            22977 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState),
            22978 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Id),
            22979 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Name),
            22980 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_Number),
            22981 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            22982 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TransitionTime),
            22983 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            22984 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_TrueState),
            22985 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_SilenceState_FalseState),
            22986 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OnDelay),
            22987 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_OffDelay),
            22988 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_FirstInGroupFlag),
            22990 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState),
            22991 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Id),
            22992 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Name),
            22993 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_Number),
            22994 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            22995 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TransitionTime),
            22996 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            22997 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_TrueState),
            22998 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_LatchedState_FalseState),
            22999 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmTime),
            23000 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ReAlarmRepeatCount),
            23007 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_NormalState),
            23008 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationDate),
            23009 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ExpirationLimit),
            23010 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_CertificateType),
            23011 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Certificate),
            23013 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventId),
            23014 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EventType),
            23015 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceNode),
            23016 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SourceName),
            23017 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Time),
            23018 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReceiveTime),
            23019 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LocalTime),
            23020 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Message),
            23021 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Severity),
            23022 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassId),
            23023 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionClassName),
            23024 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassId),
            23025 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionSubClassName),
            23026 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConditionName),
            23027 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_BranchId),
            23028 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Retain),
            23029 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState),
            23030 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Id),
            23031 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Name),
            23032 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_Number),
            23033 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            23034 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            23035 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            23036 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_TrueState),
            23037 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_EnabledState_FalseState),
            23038 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality),
            23039 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            23040 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity),
            23041 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            23042 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment),
            23043 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            23044 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ClientUserId),
            23048 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment_InputArguments),
            23049 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState),
            23050 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Id),
            23051 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Name),
            23052 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_Number),
            23053 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            23054 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TransitionTime),
            23055 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            23056 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_TrueState),
            23057 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AckedState_FalseState),
            23058 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState),
            23059 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Id),
            23060 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Name),
            23061 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_Number),
            23062 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            23063 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            23064 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            23065 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            23066 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            23068 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            23070 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm_InputArguments),
            23071 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState),
            23072 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Id),
            23073 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Name),
            23074 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_Number),
            23075 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            23076 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            23077 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            23078 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_TrueState),
            23079 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ActiveState_FalseState),
            23080 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_InputNode),
            23081 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState),
            23082 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Id),
            23083 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Name),
            23084 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_Number),
            23085 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            23086 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            23087 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            23088 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_TrueState),
            23089 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedState_FalseState),
            23090 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState),
            23091 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Id),
            23092 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Name),
            23093 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_Number),
            23094 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            23095 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            23096 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            23097 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            23098 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            23100 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            23101 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            23102 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            23103 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            23104 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            23105 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            23106 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            23107 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            23108 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            23109 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            23110 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            23111 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            23112 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            23113 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            23115 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            23118 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SuppressedOrShelved),
            23119 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_MaxTimeShelved),
            23120 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleEnabled),
            23121 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound),
            23122 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_ListId),
            23123 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            23124 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AudibleSound_VersionId),
            23125 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState),
            23126 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Id),
            23127 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Name),
            23128 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_Number),
            23129 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            23130 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            23131 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            23132 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_TrueState),
            23133 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_SilenceState_FalseState),
            23134 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OnDelay),
            23135 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_OffDelay),
            23136 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_FirstInGroupFlag),
            23138 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState),
            23139 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Id),
            23140 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Name),
            23141 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_Number),
            23142 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            23143 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            23144 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            23145 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_TrueState),
            23146 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LatchedState_FalseState),
            23147 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmTime),
            23148 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            23155 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_NormalState),
            23156 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_TrustListId),
            23157 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_LastUpdateTime),
            23158 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_UpdateFrequency),
            23159 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_UpdateFrequency),
            23161 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventId),
            23162 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EventType),
            23163 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceNode),
            23164 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SourceName),
            23165 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Time),
            23166 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReceiveTime),
            23167 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LocalTime),
            23168 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Message),
            23169 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Severity),
            23170 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassId),
            23171 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionClassName),
            23172 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassId),
            23173 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionSubClassName),
            23174 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConditionName),
            23175 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_BranchId),
            23176 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Retain),
            23177 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState),
            23178 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Id),
            23179 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Name),
            23180 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_Number),
            23181 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveDisplayName),
            23182 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TransitionTime),
            23183 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_EffectiveTransitionTime),
            23184 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_TrueState),
            23185 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_EnabledState_FalseState),
            23186 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality),
            23187 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Quality_SourceTimestamp),
            23188 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity),
            23189 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LastSeverity_SourceTimestamp),
            23190 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment),
            23191 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Comment_SourceTimestamp),
            23192 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ClientUserId),
            23196 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment_InputArguments),
            23197 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState),
            23198 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Id),
            23199 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Name),
            23200 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_Number),
            23201 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveDisplayName),
            23202 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TransitionTime),
            23203 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_EffectiveTransitionTime),
            23204 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_TrueState),
            23205 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AckedState_FalseState),
            23206 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState),
            23207 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Id),
            23208 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Name),
            23209 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_Number),
            23210 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveDisplayName),
            23211 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TransitionTime),
            23212 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_EffectiveTransitionTime),
            23213 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_TrueState),
            23214 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ConfirmedState_FalseState),
            23216 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge_InputArguments),
            23218 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm_InputArguments),
            23219 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState),
            23220 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Id),
            23221 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Name),
            23222 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_Number),
            23223 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveDisplayName),
            23224 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TransitionTime),
            23225 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_EffectiveTransitionTime),
            23226 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_TrueState),
            23227 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ActiveState_FalseState),
            23228 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_InputNode),
            23229 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState),
            23230 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Id),
            23231 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Name),
            23232 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_Number),
            23233 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveDisplayName),
            23234 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TransitionTime),
            23235 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_EffectiveTransitionTime),
            23236 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_TrueState),
            23237 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedState_FalseState),
            23238 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState),
            23239 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Id),
            23240 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Name),
            23241 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_Number),
            23242 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveDisplayName),
            23243 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TransitionTime),
            23244 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_EffectiveTransitionTime),
            23245 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_TrueState),
            23246 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OutOfServiceState_FalseState),
            23248 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState),
            23249 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Id),
            23250 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Name),
            23251 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_Number),
            23252 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_CurrentState_EffectiveDisplayName),
            23253 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition),
            23254 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Id),
            23255 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Name),
            23256 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_Number),
            23257 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_TransitionTime),
            23258 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_LastTransition_EffectiveTransitionTime),
            23259 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableStates),
            23260 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_AvailableTransitions),
            23261 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_UnshelveTime),
            23263 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve_InputArguments),
            23266 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SuppressedOrShelved),
            23267 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_MaxTimeShelved),
            23268 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleEnabled),
            23269 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound),
            23270 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_ListId),
            23271 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_AgencyId),
            23272 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AudibleSound_VersionId),
            23273 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState),
            23274 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Id),
            23275 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Name),
            23276 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_Number),
            23277 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveDisplayName),
            23278 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TransitionTime),
            23279 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_EffectiveTransitionTime),
            23280 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_TrueState),
            23281 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_SilenceState_FalseState),
            23282 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OnDelay),
            23283 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_OffDelay),
            23284 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_FirstInGroupFlag),
            23286 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState),
            23287 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Id),
            23288 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Name),
            23289 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_Number),
            23290 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveDisplayName),
            23291 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TransitionTime),
            23292 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_EffectiveTransitionTime),
            23293 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_TrueState),
            23294 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_LatchedState_FalseState),
            23295 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmTime),
            23296 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ReAlarmRepeatCount),
            23303 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_NormalState),
            23304 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationDate),
            23305 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ExpirationLimit),
            23306 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_CertificateType),
            23307 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Certificate),
            23309 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventId),
            23310 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EventType),
            23311 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceNode),
            23312 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SourceName),
            23313 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Time),
            23314 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReceiveTime),
            23315 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LocalTime),
            23316 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Message),
            23317 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Severity),
            23318 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassId),
            23319 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionClassName),
            23320 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassId),
            23321 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionSubClassName),
            23322 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConditionName),
            23323 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_BranchId),
            23324 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Retain),
            23325 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState),
            23326 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Id),
            23327 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Name),
            23328 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_Number),
            23329 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveDisplayName),
            23330 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TransitionTime),
            23331 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_EffectiveTransitionTime),
            23332 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_TrueState),
            23333 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_EnabledState_FalseState),
            23334 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality),
            23335 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Quality_SourceTimestamp),
            23336 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity),
            23337 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastSeverity_SourceTimestamp),
            23338 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment),
            23339 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Comment_SourceTimestamp),
            23340 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ClientUserId),
            23344 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment_InputArguments),
            23345 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState),
            23346 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Id),
            23347 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Name),
            23348 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_Number),
            23349 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveDisplayName),
            23350 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TransitionTime),
            23351 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_EffectiveTransitionTime),
            23352 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_TrueState),
            23353 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AckedState_FalseState),
            23354 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState),
            23355 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Id),
            23356 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Name),
            23357 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_Number),
            23358 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveDisplayName),
            23359 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TransitionTime),
            23360 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_EffectiveTransitionTime),
            23361 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_TrueState),
            23362 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ConfirmedState_FalseState),
            23364 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge_InputArguments),
            23366 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm_InputArguments),
            23367 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState),
            23368 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Id),
            23369 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Name),
            23370 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_Number),
            23371 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveDisplayName),
            23372 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TransitionTime),
            23373 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_EffectiveTransitionTime),
            23374 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_TrueState),
            23375 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ActiveState_FalseState),
            23376 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_InputNode),
            23377 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState),
            23378 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Id),
            23379 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Name),
            23380 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_Number),
            23381 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveDisplayName),
            23382 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TransitionTime),
            23383 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_EffectiveTransitionTime),
            23384 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_TrueState),
            23385 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedState_FalseState),
            23386 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState),
            23387 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Id),
            23388 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Name),
            23389 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_Number),
            23390 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveDisplayName),
            23391 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TransitionTime),
            23392 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_EffectiveTransitionTime),
            23393 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_TrueState),
            23394 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OutOfServiceState_FalseState),
            23396 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState),
            23397 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Id),
            23398 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Name),
            23399 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_Number),
            23400 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_CurrentState_EffectiveDisplayName),
            23401 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition),
            23402 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Id),
            23403 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Name),
            23404 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_Number),
            23405 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_TransitionTime),
            23406 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_LastTransition_EffectiveTransitionTime),
            23407 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableStates),
            23408 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_AvailableTransitions),
            23409 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_UnshelveTime),
            23411 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve_InputArguments),
            23414 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SuppressedOrShelved),
            23415 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_MaxTimeShelved),
            23416 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleEnabled),
            23417 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound),
            23418 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_ListId),
            23419 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_AgencyId),
            23420 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AudibleSound_VersionId),
            23421 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState),
            23422 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Id),
            23423 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Name),
            23424 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_Number),
            23425 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveDisplayName),
            23426 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TransitionTime),
            23427 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_EffectiveTransitionTime),
            23428 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_TrueState),
            23429 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_SilenceState_FalseState),
            23430 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OnDelay),
            23431 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_OffDelay),
            23432 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_FirstInGroupFlag),
            23434 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState),
            23435 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Id),
            23436 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Name),
            23437 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_Number),
            23438 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveDisplayName),
            23439 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TransitionTime),
            23440 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_EffectiveTransitionTime),
            23441 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_TrueState),
            23442 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LatchedState_FalseState),
            23443 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmTime),
            23444 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ReAlarmRepeatCount),
            23451 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_NormalState),
            23452 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_TrustListId),
            23453 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_LastUpdateTime),
            23454 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_UpdateFrequency),
            23460 => Ok(VariableId::AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias_InputArguments),
            23461 => Ok(VariableId::AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments),
            23463 => Ok(VariableId::AliasNameCategoryType_FindAlias_InputArguments),
            23464 => Ok(VariableId::AliasNameCategoryType_FindAlias_OutputArguments),
            23466 => Ok(VariableId::FindAliasMethodType_InputArguments),
            23467 => Ok(VariableId::FindAliasMethodType_OutputArguments),
            23474 => Ok(VariableId::Aliases_SubAliasNameCategories_Placeholder_FindAlias_InputArguments),
            23475 => Ok(VariableId::Aliases_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments),
            23477 => Ok(VariableId::Aliases_FindAlias_InputArguments),
            23478 => Ok(VariableId::Aliases_FindAlias_OutputArguments),
            23483 => Ok(VariableId::TagVariables_SubAliasNameCategories_Placeholder_FindAlias_InputArguments),
            23484 => Ok(VariableId::TagVariables_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments),
            23486 => Ok(VariableId::TagVariables_FindAlias_InputArguments),
            23487 => Ok(VariableId::TagVariables_FindAlias_OutputArguments),
            23492 => Ok(VariableId::Topics_SubAliasNameCategories_Placeholder_FindAlias_InputArguments),
            23493 => Ok(VariableId::Topics_SubAliasNameCategories_Placeholder_FindAlias_OutputArguments),
            23495 => Ok(VariableId::Topics_FindAlias_InputArguments),
            23496 => Ok(VariableId::Topics_FindAlias_OutputArguments),
            23501 => Ok(VariableId::CurrencyUnit),
            23502 => Ok(VariableId::OpcUa_BinarySchema_AliasNameDataType),
            23503 => Ok(VariableId::OpcUa_BinarySchema_AliasNameDataType_DataTypeVersion),
            23504 => Ok(VariableId::OpcUa_BinarySchema_AliasNameDataType_DictionaryFragment),
            23514 => Ok(VariableId::OpcUa_BinarySchema_CurrencyUnitType),
            23515 => Ok(VariableId::OpcUa_BinarySchema_CurrencyUnitType_DataTypeVersion),
            23516 => Ok(VariableId::OpcUa_BinarySchema_CurrencyUnitType_DictionaryFragment),
            23517 => Ok(VariableId::IOrderedObjectType_NumberInList),
            23521 => Ok(VariableId::OrderedListType_OrderedObject_Placeholder_NumberInList),
            23525 => Ok(VariableId::OrderedListType_NodeVersion),
            23527 => Ok(VariableId::CertificateGroupType_GetRejectedList_OutputArguments),
            23530 => Ok(VariableId::CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList_OutputArguments),
            23532 => Ok(VariableId::CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList_OutputArguments),
            23534 => Ok(VariableId::CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList_OutputArguments),
            23536 => Ok(VariableId::CertificateGroupFolderType_AdditionalGroup_Placeholder_GetRejectedList_OutputArguments),
            23545 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments),
            23547 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments),
            23549 => Ok(VariableId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments),
            23551 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList_OutputArguments),
            23553 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList_OutputArguments),
            23555 => Ok(VariableId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList_OutputArguments),
            23558 => Ok(VariableId::AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_ServiceUri),
            23559 => Ok(VariableId::AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_ServiceCertificate),
            23560 => Ok(VariableId::AuthorizationServicesConfigurationFolderType_ServiceName_Placeholder_IssuerEndpointUrl),
            _ => Err(())
        }
    }
}

#[allow(non_camel_case_types)]
#[derive(Debug, PartialEq, Eq, Copy, Clone, Hash)]
pub enum MethodId {
    ProgramStateMachineType_Start = 2426,
    ProgramStateMachineType_Suspend = 2427,
    ProgramStateMachineType_Resume = 2428,
    ProgramStateMachineType_Halt = 2429,
    ProgramStateMachineType_Reset = 2430,
    ShelvedStateMachineType_Unshelve = 2947,
    ShelvedStateMachineType_OneShotShelve = 2948,
    ShelvedStateMachineType_TimedShelve = 2949,
    AddCommentMethodType = 3863,
    ConditionType_ConditionRefresh = 3875,
    DialogConditionType_ConditionRefresh = 4198,
    AcknowledgeableConditionType_ConditionRefresh = 5123,
    AlarmConditionType_ConditionRefresh = 5550,
    TimedShelveMethodType = 6102,
    LimitAlarmType_ConditionRefresh = 6126,
    ConditionRefreshMethodType = 9007,
    ConditionType_Enable = 9027,
    ConditionType_Disable = 9028,
    ConditionType_AddComment = 9029,
    DialogResponseMethodType = 9031,
    DialogConditionType_Enable = 9051,
    DialogConditionType_Disable = 9052,
    DialogConditionType_AddComment = 9053,
    DialogConditionType_Respond = 9069,
    AcknowledgeableConditionType_Enable = 9089,
    AcknowledgeableConditionType_Disable = 9090,
    AcknowledgeableConditionType_AddComment = 9091,
    AcknowledgeableConditionType_Acknowledge = 9111,
    AcknowledgeableConditionType_Confirm = 9113,
    AlarmConditionType_Enable = 9134,
    AlarmConditionType_Disable = 9135,
    AlarmConditionType_AddComment = 9136,
    AlarmConditionType_Acknowledge = 9156,
    AlarmConditionType_Confirm = 9158,
    AlarmConditionType_ShelvingState_Unshelve = 9211,
    AlarmConditionType_ShelvingState_OneShotShelve = 9212,
    AlarmConditionType_ShelvingState_TimedShelve = 9213,
    LimitAlarmType_Enable = 9235,
    LimitAlarmType_Disable = 9236,
    LimitAlarmType_AddComment = 9237,
    LimitAlarmType_Acknowledge = 9257,
    LimitAlarmType_Confirm = 9259,
    LimitAlarmType_ShelvingState_Unshelve = 9312,
    LimitAlarmType_ShelvingState_OneShotShelve = 9313,
    LimitAlarmType_ShelvingState_TimedShelve = 9314,
    ExclusiveLimitAlarmType_Enable = 9370,
    ExclusiveLimitAlarmType_Disable = 9371,
    ExclusiveLimitAlarmType_AddComment = 9372,
    ExclusiveLimitAlarmType_ConditionRefresh = 9374,
    ExclusiveLimitAlarmType_Acknowledge = 9394,
    ExclusiveLimitAlarmType_Confirm = 9396,
    ExclusiveLimitAlarmType_ShelvingState_Unshelve = 9449,
    ExclusiveLimitAlarmType_ShelvingState_OneShotShelve = 9450,
    ExclusiveLimitAlarmType_ShelvingState_TimedShelve = 9451,
    ExclusiveLevelAlarmType_Enable = 9511,
    ExclusiveLevelAlarmType_Disable = 9512,
    ExclusiveLevelAlarmType_AddComment = 9513,
    ExclusiveLevelAlarmType_ConditionRefresh = 9515,
    ExclusiveLevelAlarmType_Acknowledge = 9535,
    ExclusiveLevelAlarmType_Confirm = 9537,
    ExclusiveLevelAlarmType_ShelvingState_Unshelve = 9590,
    ExclusiveLevelAlarmType_ShelvingState_OneShotShelve = 9591,
    ExclusiveLevelAlarmType_ShelvingState_TimedShelve = 9592,
    ExclusiveRateOfChangeAlarmType_Enable = 9652,
    ExclusiveRateOfChangeAlarmType_Disable = 9653,
    ExclusiveRateOfChangeAlarmType_AddComment = 9654,
    ExclusiveRateOfChangeAlarmType_ConditionRefresh = 9656,
    ExclusiveRateOfChangeAlarmType_Acknowledge = 9676,
    ExclusiveRateOfChangeAlarmType_Confirm = 9678,
    ExclusiveRateOfChangeAlarmType_ShelvingState_Unshelve = 9731,
    ExclusiveRateOfChangeAlarmType_ShelvingState_OneShotShelve = 9732,
    ExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve = 9733,
    ExclusiveDeviationAlarmType_Enable = 9793,
    ExclusiveDeviationAlarmType_Disable = 9794,
    ExclusiveDeviationAlarmType_AddComment = 9795,
    ExclusiveDeviationAlarmType_ConditionRefresh = 9797,
    ExclusiveDeviationAlarmType_Acknowledge = 9817,
    ExclusiveDeviationAlarmType_Confirm = 9819,
    ExclusiveDeviationAlarmType_ShelvingState_Unshelve = 9872,
    ExclusiveDeviationAlarmType_ShelvingState_OneShotShelve = 9873,
    ExclusiveDeviationAlarmType_ShelvingState_TimedShelve = 9874,
    NonExclusiveLimitAlarmType_Enable = 9935,
    NonExclusiveLimitAlarmType_Disable = 9936,
    NonExclusiveLimitAlarmType_AddComment = 9937,
    NonExclusiveLimitAlarmType_ConditionRefresh = 9939,
    NonExclusiveLimitAlarmType_Acknowledge = 9959,
    NonExclusiveLimitAlarmType_Confirm = 9961,
    NonExclusiveLimitAlarmType_ShelvingState_Unshelve = 10014,
    NonExclusiveLimitAlarmType_ShelvingState_OneShotShelve = 10015,
    NonExclusiveLimitAlarmType_ShelvingState_TimedShelve = 10016,
    NonExclusiveLevelAlarmType_Enable = 10089,
    NonExclusiveLevelAlarmType_Disable = 10090,
    NonExclusiveLevelAlarmType_AddComment = 10091,
    NonExclusiveLevelAlarmType_ConditionRefresh = 10093,
    NonExclusiveLevelAlarmType_Acknowledge = 10113,
    NonExclusiveLevelAlarmType_Confirm = 10115,
    NonExclusiveLevelAlarmType_ShelvingState_Unshelve = 10168,
    NonExclusiveLevelAlarmType_ShelvingState_OneShotShelve = 10169,
    NonExclusiveLevelAlarmType_ShelvingState_TimedShelve = 10170,
    NonExclusiveRateOfChangeAlarmType_Enable = 10243,
    NonExclusiveRateOfChangeAlarmType_Disable = 10244,
    NonExclusiveRateOfChangeAlarmType_AddComment = 10245,
    NonExclusiveRateOfChangeAlarmType_ConditionRefresh = 10247,
    NonExclusiveRateOfChangeAlarmType_Acknowledge = 10267,
    NonExclusiveRateOfChangeAlarmType_Confirm = 10269,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_Unshelve = 10322,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_OneShotShelve = 10323,
    NonExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve = 10324,
    NonExclusiveDeviationAlarmType_Enable = 10397,
    NonExclusiveDeviationAlarmType_Disable = 10398,
    NonExclusiveDeviationAlarmType_AddComment = 10399,
    NonExclusiveDeviationAlarmType_ConditionRefresh = 10401,
    NonExclusiveDeviationAlarmType_Acknowledge = 10421,
    NonExclusiveDeviationAlarmType_Confirm = 10423,
    NonExclusiveDeviationAlarmType_ShelvingState_Unshelve = 10476,
    NonExclusiveDeviationAlarmType_ShelvingState_OneShotShelve = 10477,
    NonExclusiveDeviationAlarmType_ShelvingState_TimedShelve = 10478,
    DiscreteAlarmType_Enable = 10552,
    DiscreteAlarmType_Disable = 10553,
    DiscreteAlarmType_AddComment = 10554,
    DiscreteAlarmType_ConditionRefresh = 10556,
    DiscreteAlarmType_Acknowledge = 10576,
    DiscreteAlarmType_Confirm = 10578,
    DiscreteAlarmType_ShelvingState_Unshelve = 10631,
    DiscreteAlarmType_ShelvingState_OneShotShelve = 10632,
    DiscreteAlarmType_ShelvingState_TimedShelve = 10633,
    OffNormalAlarmType_Enable = 10666,
    OffNormalAlarmType_Disable = 10667,
    OffNormalAlarmType_AddComment = 10668,
    OffNormalAlarmType_ConditionRefresh = 10670,
    OffNormalAlarmType_Acknowledge = 10690,
    OffNormalAlarmType_Confirm = 10692,
    OffNormalAlarmType_ShelvingState_Unshelve = 10745,
    OffNormalAlarmType_ShelvingState_OneShotShelve = 10746,
    OffNormalAlarmType_ShelvingState_TimedShelve = 10747,
    TripAlarmType_Enable = 10780,
    TripAlarmType_Disable = 10781,
    TripAlarmType_AddComment = 10782,
    TripAlarmType_ConditionRefresh = 10784,
    TripAlarmType_Acknowledge = 10804,
    TripAlarmType_Confirm = 10806,
    TripAlarmType_ShelvingState_Unshelve = 10859,
    TripAlarmType_ShelvingState_OneShotShelve = 10860,
    TripAlarmType_ShelvingState_TimedShelve = 10861,
    ServerType_GetMonitoredItems = 11489,
    Server_GetMonitoredItems = 11492,
    GetMonitoredItemsMethodType = 11495,
    FileType_Open = 11580,
    FileType_Close = 11583,
    FileType_Read = 11585,
    FileType_Write = 11588,
    FileType_GetPosition = 11590,
    FileType_SetPosition = 11593,
    AddressSpaceFileType_Open = 11600,
    AddressSpaceFileType_Close = 11603,
    AddressSpaceFileType_Read = 11605,
    AddressSpaceFileType_Write = 11608,
    AddressSpaceFileType_GetPosition = 11610,
    AddressSpaceFileType_SetPosition = 11613,
    AddressSpaceFileType_ExportNamespace = 11615,
    NamespaceMetadataType_NamespaceFile_Open = 11629,
    NamespaceMetadataType_NamespaceFile_Close = 11632,
    NamespaceMetadataType_NamespaceFile_Read = 11634,
    NamespaceMetadataType_NamespaceFile_Write = 11637,
    NamespaceMetadataType_NamespaceFile_GetPosition = 11639,
    NamespaceMetadataType_NamespaceFile_SetPosition = 11642,
    NamespaceMetadataType_NamespaceFile_ExportNamespace = 11644,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open = 11659,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Close = 11662,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read = 11664,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Write = 11667,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition = 11669,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_SetPosition = 11672,
    NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_ExportNamespace = 11674,
    OpenMethodType = 11738,
    CloseMethodType = 11741,
    ReadMethodType = 11743,
    WriteMethodType = 11746,
    GetPositionMethodType = 11748,
    SetPositionMethodType = 11751,
    SystemOffNormalAlarmType_Disable = 11784,
    SystemOffNormalAlarmType_Enable = 11785,
    SystemOffNormalAlarmType_AddComment = 11786,
    SystemOffNormalAlarmType_ConditionRefresh = 11788,
    SystemOffNormalAlarmType_Acknowledge = 11808,
    SystemOffNormalAlarmType_Confirm = 11810,
    SystemOffNormalAlarmType_ShelvingState_Unshelve = 11844,
    SystemOffNormalAlarmType_ShelvingState_OneShotShelve = 11845,
    SystemOffNormalAlarmType_ShelvingState_TimedShelve = 11846,
    OpenWithMasksMethodType = 12513,
    CloseAndUpdateMethodType = 12516,
    AddCertificateMethodType = 12518,
    RemoveCertificateMethodType = 12520,
    TrustListType_Open = 12527,
    TrustListType_Close = 12530,
    TrustListType_Read = 12532,
    TrustListType_Write = 12535,
    TrustListType_GetPosition = 12537,
    TrustListType_SetPosition = 12540,
    TrustListType_OpenWithMasks = 12543,
    TrustListType_CloseAndUpdate = 12546,
    TrustListType_AddCertificate = 12548,
    TrustListType_RemoveCertificate = 12550,
    UpdateCertificateMethodType = 12578,
    ServerConfigurationType_UpdateCertificate = 12616,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open = 12647,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close = 12650,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read = 12652,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write = 12655,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition = 12657,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition = 12660,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks = 12663,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate = 12666,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate = 12668,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate =
        12670,
    ServerConfigurationType_CreateSigningRequest = 12731,
    ServerConfigurationType_ApplyChanges = 12734,
    ServerConfiguration_CreateSigningRequest = 12737,
    ServerConfiguration_ApplyChanges = 12740,
    CreateSigningRequestMethodType = 12741,
    ServerType_SetSubscriptionDurable = 12746,
    Server_SetSubscriptionDurable = 12749,
    SetSubscriptionDurableMethodType = 12752,
    GetRejectedListMethodType = 12773,
    ServerConfigurationType_GetRejectedList = 12775,
    ServerConfiguration_GetRejectedList = 12777,
    ServerType_ResendData = 12871,
    Server_ResendData = 12873,
    ResendDataMethodType = 12875,
    ServerType_RequestServerStateChange = 12883,
    Server_RequestServerStateChange = 12886,
    RequestServerStateChangeMethodType = 12888,
    ConditionType_ConditionRefresh2 = 12912,
    ConditionRefresh2MethodType = 12914,
    DialogConditionType_ConditionRefresh2 = 12916,
    AcknowledgeableConditionType_ConditionRefresh2 = 12918,
    AlarmConditionType_ConditionRefresh2 = 12984,
    LimitAlarmType_ConditionRefresh2 = 12986,
    ExclusiveLimitAlarmType_ConditionRefresh2 = 12988,
    NonExclusiveLimitAlarmType_ConditionRefresh2 = 12990,
    NonExclusiveLevelAlarmType_ConditionRefresh2 = 12992,
    ExclusiveLevelAlarmType_ConditionRefresh2 = 12994,
    NonExclusiveDeviationAlarmType_ConditionRefresh2 = 12996,
    ExclusiveDeviationAlarmType_ConditionRefresh2 = 12998,
    NonExclusiveRateOfChangeAlarmType_ConditionRefresh2 = 13000,
    ExclusiveRateOfChangeAlarmType_ConditionRefresh2 = 13002,
    DiscreteAlarmType_ConditionRefresh2 = 13004,
    OffNormalAlarmType_ConditionRefresh2 = 13006,
    SystemOffNormalAlarmType_ConditionRefresh2 = 13008,
    TripAlarmType_ConditionRefresh2 = 13010,
    CertificateExpirationAlarmType_Disable = 13256,
    CertificateExpirationAlarmType_Enable = 13257,
    CertificateExpirationAlarmType_AddComment = 13258,
    CertificateExpirationAlarmType_ConditionRefresh = 13260,
    CertificateExpirationAlarmType_ConditionRefresh2 = 13262,
    CertificateExpirationAlarmType_Acknowledge = 13282,
    CertificateExpirationAlarmType_Confirm = 13284,
    CertificateExpirationAlarmType_ShelvingState_Unshelve = 13318,
    CertificateExpirationAlarmType_ShelvingState_OneShotShelve = 13319,
    CertificateExpirationAlarmType_ShelvingState_TimedShelve = 13320,
    CreateDirectoryMethodType = 13342,
    CreateFileMethodType = 13345,
    DeleteFileMethodType = 13348,
    MoveOrCopyMethodType = 13350,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory = 13355,
    FileDirectoryType_FileDirectoryName_Placeholder_CreateFile = 13358,
    FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy = 13363,
    FileDirectoryType_FileName_Placeholder_Open = 13372,
    FileDirectoryType_FileName_Placeholder_Close = 13375,
    FileDirectoryType_FileName_Placeholder_Read = 13377,
    FileDirectoryType_FileName_Placeholder_Write = 13380,
    FileDirectoryType_FileName_Placeholder_GetPosition = 13382,
    FileDirectoryType_FileName_Placeholder_SetPosition = 13385,
    FileDirectoryType_CreateDirectory = 13387,
    FileDirectoryType_CreateFile = 13390,
    FileDirectoryType_DeleteFileSystemObject = 13393,
    FileDirectoryType_MoveOrCopy = 13395,
    CertificateGroupType_TrustList_Open = 13605,
    CertificateGroupType_TrustList_Close = 13608,
    CertificateGroupType_TrustList_Read = 13610,
    CertificateGroupType_TrustList_Write = 13613,
    CertificateGroupType_TrustList_GetPosition = 13615,
    CertificateGroupType_TrustList_SetPosition = 13618,
    CertificateGroupType_TrustList_OpenWithMasks = 13621,
    CertificateGroupType_TrustList_CloseAndUpdate = 13624,
    CertificateGroupType_TrustList_AddCertificate = 13627,
    CertificateGroupType_TrustList_RemoveCertificate = 13629,
    ServerConfiguration_UpdateCertificate = 13737,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open = 13821,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close = 13824,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read = 13826,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write = 13829,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition = 13831,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition = 13834,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks = 13837,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate = 13840,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate = 13843,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate = 13845,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open = 13855,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close = 13858,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read = 13860,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write = 13863,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition = 13865,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition = 13868,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks = 13871,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate = 13874,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate = 13877,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate = 13879,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open = 13889,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close = 13892,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read = 13894,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write = 13897,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition = 13899,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition = 13902,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks = 13905,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate = 13908,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate = 13911,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate = 13913,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open = 13923,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Close = 13926,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read = 13928,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Write = 13931,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition = 13933,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_SetPosition = 13936,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks = 13939,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate = 13942,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_AddCertificate = 13945,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_RemoveCertificate = 13947,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open = 13958,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close = 13961,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read = 13963,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write = 13966,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition = 13968,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition = 13971,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks =
        13974,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate =
        13977,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate =
        13980,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate =
        13982,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open = 13992,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close = 13995,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read = 13997,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write = 14000,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition = 14002,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition = 14005,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks = 14008,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate = 14011,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate = 14014,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate = 14016,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open = 14026,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close = 14029,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read = 14031,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write = 14034,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition = 14036,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition = 14039,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks = 14042,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate =
        14045,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate =
        14048,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate =
        14050,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open = 14095,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close = 14098,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read = 14100,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write = 14103,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition = 14105,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition = 14108,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks = 14111,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate = 14114,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate = 14117,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate = 14119,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open = 14129,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close = 14132,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read = 14134,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write = 14137,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition = 14139,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition = 14142,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks = 14145,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate = 14148,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate = 14151,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate = 14153,
    RemoveConnectionMethodType = 14183,
    PubSubConnectionType_RemoveGroup = 14225,
    PublishSubscribeType_ConnectionName_Placeholder_Status_Enable = 14421,
    PublishSubscribeType_ConnectionName_Placeholder_Status_Disable = 14422,
    PublishSubscribeType_ConnectionName_Placeholder_RemoveGroup = 14424,
    PublishSubscribeType_RemoveConnection = 14432,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItems = 14435,
    PublishSubscribeType_PublishedDataSets_AddPublishedEvents = 14438,
    PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet = 14441,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems = 14479,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents = 14482,
    DataSetFolderType_DataSetFolderName_Placeholder_RemovePublishedDataSet = 14485,
    DataSetFolderType_AddPublishedDataItems = 14493,
    DataSetFolderType_AddPublishedEvents = 14496,
    DataSetFolderType_RemovePublishedDataSet = 14499,
    AddPublishedDataItemsMethodType = 14501,
    AddPublishedEventsMethodType = 14504,
    RemovePublishedDataSetMethodType = 14507,
    PublishedDataItemsType_AddVariables = 14555,
    PublishedDataItemsType_RemoveVariables = 14558,
    PublishedDataItemsAddVariablesMethodType = 14564,
    PublishedDataItemsRemoveVariablesMethodType = 14567,
    PubSubConnectionType_Status_Enable = 14602,
    PubSubConnectionType_Status_Disable = 14603,
    PubSubConnectionTypeRemoveGroupMethodType = 14604,
    PubSubGroupTypeRemoveWriterMethodType = 14623,
    PubSubGroupTypeRemoveReaderMethodType = 14625,
    PubSubStatusType_Enable = 14645,
    PubSubStatusType_Disable = 14646,
    PublishedEventsType_ModifyFieldSelection = 15052,
    PublishedEventsTypeModifyFieldSelectionMethodType = 15054,
    TargetVariablesType_AddTargetVariables = 15115,
    TargetVariablesType_RemoveTargetVariables = 15118,
    TargetVariablesTypeAddTargetVariablesMethodType = 15121,
    TargetVariablesTypeRemoveTargetVariablesMethodType = 15124,
    PublishSubscribeType_GetSecurityKeys = 15212,
    PublishSubscribe_GetSecurityKeys = 15215,
    GetSecurityKeysMethodType = 15218,
    PublishedDataSetType_DataSetWriterName_Placeholder_Status_Enable = 15225,
    PublishedDataSetType_DataSetWriterName_Placeholder_Status_Disable = 15226,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Status_Enable = 15233,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Status_Disable = 15234,
    PublishedEventsType_DataSetWriterName_Placeholder_Status_Enable = 15241,
    PublishedEventsType_DataSetWriterName_Placeholder_Status_Disable = 15242,
    CreateCredentialMethodType = 15248,
    PubSubGroupType_Status_Enable = 15267,
    PubSubGroupType_Status_Disable = 15268,
    DataSetWriterType_Status_Enable = 15301,
    DataSetWriterType_Status_Disable = 15302,
    DataSetReaderType_Status_Enable = 15309,
    DataSetReaderType_Status_Disable = 15310,
    PublishSubscribeType_GetSecurityGroup = 15431,
    PublishSubscribeType_SecurityGroups_AddSecurityGroup = 15435,
    PublishSubscribeType_SecurityGroups_RemoveSecurityGroup = 15438,
    PublishSubscribe_GetSecurityGroup = 15440,
    PublishSubscribe_SecurityGroups_AddSecurityGroup = 15444,
    PublishSubscribe_SecurityGroups_RemoveSecurityGroup = 15447,
    GetSecurityGroupMethodType = 15449,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup = 15454,
    SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_RemoveSecurityGroup = 15457,
    SecurityGroupFolderType_AddSecurityGroup = 15461,
    SecurityGroupFolderType_RemoveSecurityGroup = 15464,
    AddSecurityGroupMethodType = 15466,
    RemoveSecurityGroupMethodType = 15469,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField = 15474,
    DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_RemoveExtensionField = 15477,
    PublishedDataSetType_ExtensionFields_AddExtensionField = 15482,
    PublishedDataSetType_ExtensionFields_RemoveExtensionField = 15485,
    ExtensionFieldsType_AddExtensionField = 15491,
    ExtensionFieldsType_RemoveExtensionField = 15494,
    AddExtensionFieldMethodType = 15496,
    RemoveExtensionFieldMethodType = 15499,
    PublishedDataItemsType_ExtensionFields_AddExtensionField = 15504,
    PublishedDataItemsType_ExtensionFields_RemoveExtensionField = 15507,
    PublishedEventsType_ExtensionFields_AddExtensionField = 15512,
    PublishedEventsType_ExtensionFields_RemoveExtensionField = 15515,
    RoleSetType_RoleName_Placeholder_AddIdentity = 15612,
    RoleSetType_RoleName_Placeholder_RemoveIdentity = 15614,
    RoleType_AddIdentity = 15624,
    RoleType_RemoveIdentity = 15626,
    AddIdentityMethodType = 15636,
    RemoveIdentityMethodType = 15638,
    WellKnownRole_Anonymous_AddIdentity = 15648,
    WellKnownRole_Anonymous_RemoveIdentity = 15650,
    WellKnownRole_AuthenticatedUser_AddIdentity = 15660,
    WellKnownRole_AuthenticatedUser_RemoveIdentity = 15662,
    WellKnownRole_Observer_AddIdentity = 15672,
    WellKnownRole_Observer_RemoveIdentity = 15674,
    WellKnownRole_Operator_AddIdentity = 15684,
    WellKnownRole_Operator_RemoveIdentity = 15686,
    WellKnownRole_Supervisor_AddIdentity = 15696,
    WellKnownRole_Supervisor_RemoveIdentity = 15698,
    WellKnownRole_SecurityAdmin_AddIdentity = 15708,
    WellKnownRole_SecurityAdmin_RemoveIdentity = 15710,
    WellKnownRole_ConfigureAdmin_AddIdentity = 15720,
    WellKnownRole_ConfigureAdmin_RemoveIdentity = 15722,
    TemporaryFileTransferType_GenerateFileForRead = 15746,
    TemporaryFileTransferType_GenerateFileForWrite = 15749,
    TemporaryFileTransferType_CloseAndCommit = 15751,
    TemporaryFileTransferType_TransferState_Placeholder_Reset = 15794,
    GenerateFileForReadMethodType = 15795,
    GenerateFileForWriteMethodType = 15798,
    CloseAndCommitMethodType = 15800,
    FileTransferStateMachineType_Reset = 15843,
    PublishSubscribeType_Status_Enable = 15846,
    PublishSubscribeType_Status_Disable = 15847,
    PublishSubscribe_ConnectionName_Placeholder_Status_Enable = 15893,
    PublishSubscribe_ConnectionName_Placeholder_Status_Disable = 15894,
    PubSubKeyServiceType_GetSecurityKeys = 15907,
    PubSubKeyServiceType_GetSecurityGroup = 15910,
    PubSubKeyServiceType_SecurityGroups_AddSecurityGroup = 15914,
    PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup = 15917,
    OPCUANamespaceMetadata_NamespaceFile_Open = 15971,
    OPCUANamespaceMetadata_NamespaceFile_Close = 15974,
    OPCUANamespaceMetadata_NamespaceFile_Read = 15976,
    OPCUANamespaceMetadata_NamespaceFile_Write = 15979,
    OPCUANamespaceMetadata_NamespaceFile_GetPosition = 15981,
    OPCUANamespaceMetadata_NamespaceFile_SetPosition = 15984,
    OPCUANamespaceMetadata_NamespaceFile_ExportNamespace = 15986,
    RoleSetType_AddRole = 15997,
    RoleSetType_RemoveRole = 16000,
    AddRoleMethodType = 16002,
    RemoveRoleMethodType = 16005,
    WellKnownRole_Engineer_AddIdentity = 16041,
    WellKnownRole_Engineer_RemoveIdentity = 16043,
    PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Reset = 16076,
    RoleSetType_RoleName_Placeholder_AddApplication = 16165,
    RoleSetType_RoleName_Placeholder_RemoveApplication = 16167,
    RoleSetType_RoleName_Placeholder_AddEndpoint = 16169,
    RoleSetType_RoleName_Placeholder_RemoveEndpoint = 16171,
    RoleType_AddApplication = 16176,
    RoleType_RemoveApplication = 16178,
    RoleType_AddEndpoint = 16180,
    RoleType_RemoveEndpoint = 16182,
    AddApplicationMethodType = 16184,
    RemoveApplicationMethodType = 16186,
    AddEndpointMethodType = 16188,
    RemoveEndpointMethodType = 16190,
    WellKnownRole_Anonymous_AddApplication = 16195,
    WellKnownRole_Anonymous_RemoveApplication = 16197,
    WellKnownRole_Anonymous_AddEndpoint = 16199,
    WellKnownRole_Anonymous_RemoveEndpoint = 16201,
    WellKnownRole_AuthenticatedUser_AddApplication = 16206,
    WellKnownRole_AuthenticatedUser_RemoveApplication = 16208,
    WellKnownRole_AuthenticatedUser_AddEndpoint = 16210,
    WellKnownRole_AuthenticatedUser_RemoveEndpoint = 16212,
    WellKnownRole_Observer_AddApplication = 16217,
    WellKnownRole_Observer_RemoveApplication = 16219,
    WellKnownRole_Observer_AddEndpoint = 16221,
    WellKnownRole_Observer_RemoveEndpoint = 16223,
    WellKnownRole_Operator_AddApplication = 16228,
    WellKnownRole_Operator_RemoveApplication = 16230,
    WellKnownRole_Operator_AddEndpoint = 16232,
    WellKnownRole_Operator_RemoveEndpoint = 16234,
    WellKnownRole_Engineer_AddApplication = 16239,
    WellKnownRole_Engineer_RemoveApplication = 16241,
    WellKnownRole_Engineer_AddEndpoint = 16243,
    WellKnownRole_Engineer_RemoveEndpoint = 16245,
    WellKnownRole_Supervisor_AddApplication = 16250,
    WellKnownRole_Supervisor_RemoveApplication = 16252,
    WellKnownRole_Supervisor_AddEndpoint = 16254,
    WellKnownRole_Supervisor_RemoveEndpoint = 16256,
    WellKnownRole_SecurityAdmin_AddApplication = 16261,
    WellKnownRole_SecurityAdmin_RemoveApplication = 16263,
    WellKnownRole_SecurityAdmin_AddEndpoint = 16265,
    WellKnownRole_SecurityAdmin_RemoveEndpoint = 16267,
    WellKnownRole_ConfigureAdmin_AddApplication = 16272,
    WellKnownRole_ConfigureAdmin_RemoveApplication = 16274,
    WellKnownRole_ConfigureAdmin_AddEndpoint = 16276,
    WellKnownRole_ConfigureAdmin_RemoveEndpoint = 16278,
    ServerType_ServerCapabilities_RoleSet_AddRole = 16290,
    ServerType_ServerCapabilities_RoleSet_RemoveRole = 16293,
    ServerCapabilitiesType_RoleSet_AddRole = 16296,
    ServerCapabilitiesType_RoleSet_RemoveRole = 16299,
    Server_ServerCapabilities_RoleSet_AddRole = 16301,
    Server_ServerCapabilities_RoleSet_RemoveRole = 16304,
    FileSystem_FileDirectoryName_Placeholder_CreateDirectory = 16316,
    FileSystem_FileDirectoryName_Placeholder_CreateFile = 16319,
    FileSystem_FileDirectoryName_Placeholder_MoveOrCopy = 16324,
    FileSystem_FileName_Placeholder_Open = 16333,
    FileSystem_FileName_Placeholder_Close = 16336,
    FileSystem_FileName_Placeholder_Read = 16338,
    FileSystem_FileName_Placeholder_Write = 16341,
    FileSystem_FileName_Placeholder_GetPosition = 16343,
    FileSystem_FileName_Placeholder_SetPosition = 16346,
    FileSystem_CreateDirectory = 16348,
    FileSystem_CreateFile = 16351,
    FileSystem_DeleteFileSystemObject = 16354,
    FileSystem_MoveOrCopy = 16356,
    AlarmConditionType_Silence = 16402,
    AlarmConditionType_Suppress = 16403,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Disable = 16439,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Enable = 16440,
    AlarmGroupType_AlarmConditionInstance_Placeholder_AddComment = 16441,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Acknowledge = 16461,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Confirm = 16463,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_Unshelve = 16515,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_OneShotShelve = 16516,
    AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_TimedShelve = 16517,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Silence = 16533,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Suppress = 16534,
    PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup = 16535,
    PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup = 16560,
    LimitAlarmType_Silence = 16569,
    LimitAlarmType_Suppress = 16570,
    PublishSubscribeType_AddConnection = 16598,
    PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate = 16601,
    ExclusiveLimitAlarmType_Silence = 16609,
    ExclusiveLimitAlarmType_Suppress = 16610,
    PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate = 16639,
    NonExclusiveLimitAlarmType_Silence = 16649,
    NonExclusiveLimitAlarmType_Suppress = 16650,
    PublishSubscribeType_PublishedDataSets_AddDataSetFolder = 16651,
    PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder = 16680,
    NonExclusiveLevelAlarmType_Silence = 16689,
    NonExclusiveLevelAlarmType_Suppress = 16690,
    AddConnectionMethodType = 16691,
    ExclusiveLevelAlarmType_Silence = 16729,
    ExclusiveLevelAlarmType_Suppress = 16730,
    NonExclusiveDeviationAlarmType_Silence = 16769,
    NonExclusiveDeviationAlarmType_Suppress = 16770,
    ExclusiveDeviationAlarmType_Silence = 16810,
    ExclusiveDeviationAlarmType_Suppress = 16811,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate = 16842,
    NonExclusiveRateOfChangeAlarmType_Silence = 16851,
    NonExclusiveRateOfChangeAlarmType_Suppress = 16852,
    DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate = 16881,
    DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder = 16884,
    ExclusiveRateOfChangeAlarmType_Silence = 16892,
    ExclusiveRateOfChangeAlarmType_Suppress = 16893,
    DataSetFolderType_DataSetFolderName_Placeholder_RemoveDataSetFolder = 16923,
    DiscreteAlarmType_Silence = 16933,
    DiscreteAlarmType_Suppress = 16934,
    DataSetFolderType_AddPublishedDataItemsTemplate = 16935,
    DataSetFolderType_AddPublishedEventsTemplate = 16960,
    OffNormalAlarmType_Silence = 16969,
    OffNormalAlarmType_Suppress = 16970,
    DataSetFolderType_AddDataSetFolder = 16994,
    DataSetFolderType_RemoveDataSetFolder = 16997,
    SystemOffNormalAlarmType_Silence = 17005,
    SystemOffNormalAlarmType_Suppress = 17006,
    AddPublishedDataItemsTemplateMethodType = 17030,
    AddPublishedEventsTemplateMethodType = 17033,
    TripAlarmType_Silence = 17041,
    TripAlarmType_Suppress = 17042,
    AddDataSetFolderMethodType = 17067,
    CertificateExpirationAlarmType_Silence = 17077,
    CertificateExpirationAlarmType_Suppress = 17078,
    RemoveDataSetFolderMethodType = 17079,
    DiscrepancyAlarmType_Disable = 17113,
    DiscrepancyAlarmType_Enable = 17114,
    DiscrepancyAlarmType_AddComment = 17115,
    DiscrepancyAlarmType_ConditionRefresh = 17117,
    DiscrepancyAlarmType_ConditionRefresh2 = 17119,
    DiscrepancyAlarmType_Acknowledge = 17139,
    DiscrepancyAlarmType_Confirm = 17141,
    DiscrepancyAlarmType_ShelvingState_Unshelve = 17193,
    DiscrepancyAlarmType_ShelvingState_OneShotShelve = 17194,
    DiscrepancyAlarmType_ShelvingState_TimedShelve = 17195,
    DiscrepancyAlarmType_Silence = 17212,
    DiscrepancyAlarmType_Suppress = 17213,
    PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter = 17293,
    PublishSubscribeType_SetSecurityKeys = 17296,
    SetSecurityKeysMethodType = 17298,
    PubSubConnectionType_WriterGroupName_Placeholder_Status_Enable = 17316,
    PubSubConnectionType_WriterGroupName_Placeholder_Status_Disable = 17317,
    PubSubConnectionType_WriterGroupName_Placeholder_RemoveDataSetWriter = 17323,
    PubSubConnectionType_ReaderGroupName_Placeholder_Status_Enable = 17331,
    PubSubConnectionType_ReaderGroupName_Placeholder_Status_Disable = 17332,
    PubSubConnectionType_ReaderGroupName_Placeholder_RemoveDataSetReader = 17333,
    PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader = 17355,
    PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup = 17356,
    PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup = 17359,
    PublishSubscribe_ConnectionName_Placeholder_RemoveGroup = 17362,
    PublishSubscribe_SetSecurityKeys = 17364,
    PublishSubscribe_AddConnection = 17366,
    PublishSubscribe_RemoveConnection = 17369,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItems = 17372,
    PublishSubscribe_PublishedDataSets_AddPublishedEvents = 17375,
    PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate = 17378,
    PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate = 17381,
    PublishSubscribe_PublishedDataSets_RemovePublishedDataSet = 17384,
    DataSetReaderType_CreateTargetVariables = 17386,
    DataSetReaderType_CreateDataSetMirror = 17389,
    DataSetReaderTypeCreateTargetVariablesMethodType = 17392,
    DataSetReaderTypeCreateDataSetMirrorMethodType = 17395,
    PublishSubscribe_PublishedDataSets_AddDataSetFolder = 17398,
    PublishSubscribe_PublishedDataSets_RemoveDataSetFolder = 17403,
    PublishSubscribe_Status_Enable = 17407,
    PublishSubscribe_Status_Disable = 17408,
    PublishSubscribe_Diagnostics_Reset = 17421,
    PubSubConnectionType_AddWriterGroup = 17427,
    PubSubConnectionType_AddReaderGroup = 17465,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey = 17516,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_UpdateCredential = 17519,
    KeyCredentialConfigurationFolderType_ServiceName_Placeholder_DeleteCredential = 17521,
    KeyCredentialConfigurationFolderType_CreateCredential = 17522,
    KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey = 17525,
    KeyCredentialConfiguration_CreateCredential = 17528,
    GetEncryptingKeyMethodType = 17531,
    KeyCredentialConfigurationType_GetEncryptingKey = 17534,
    PubSubConnectionTypeAddWriterGroupMethodType = 17561,
    PubSubConnectionAddReaderGroupGroupMethodType = 17630,
    FileDirectoryType_FileDirectoryName_Placeholder_DeleteFileSystemObject = 17718,
    FileSystem_FileDirectoryName_Placeholder_DeleteFileSystemObject = 17722,
    WriterGroupType_Status_Enable = 17734,
    WriterGroupType_Status_Disable = 17735,
    WriterGroupType_DataSetWriterName_Placeholder_Status_Enable = 17751,
    WriterGroupType_DataSetWriterName_Placeholder_Status_Disable = 17752,
    WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Reset = 17765,
    WriterGroupType_Diagnostics_Reset = 17824,
    AlarmConditionType_Unsuppress = 17868,
    AlarmConditionType_RemoveFromService = 17869,
    AlarmConditionType_PlaceInService = 17870,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Unsuppress = 17875,
    AlarmGroupType_AlarmConditionInstance_Placeholder_RemoveFromService = 17876,
    AlarmGroupType_AlarmConditionInstance_Placeholder_PlaceInService = 17877,
    LimitAlarmType_Unsuppress = 17882,
    LimitAlarmType_RemoveFromService = 17883,
    LimitAlarmType_PlaceInService = 17884,
    ExclusiveLimitAlarmType_Unsuppress = 17889,
    ExclusiveLimitAlarmType_RemoveFromService = 17890,
    ExclusiveLimitAlarmType_PlaceInService = 17891,
    NonExclusiveLimitAlarmType_Unsuppress = 17896,
    NonExclusiveLimitAlarmType_RemoveFromService = 17897,
    NonExclusiveLimitAlarmType_PlaceInService = 17898,
    NonExclusiveLevelAlarmType_RemoveFromService = 17904,
    NonExclusiveLevelAlarmType_PlaceInService = 17905,
    ExclusiveLevelAlarmType_Unsuppress = 17910,
    ExclusiveLevelAlarmType_RemoveFromService = 17911,
    ExclusiveLevelAlarmType_PlaceInService = 17912,
    NonExclusiveDeviationAlarmType_Unsuppress = 17917,
    NonExclusiveDeviationAlarmType_RemoveFromService = 17918,
    NonExclusiveDeviationAlarmType_PlaceInService = 17919,
    NonExclusiveRateOfChangeAlarmType_Unsuppress = 17924,
    NonExclusiveRateOfChangeAlarmType_RemoveFromService = 17925,
    NonExclusiveRateOfChangeAlarmType_PlaceInService = 17926,
    ExclusiveDeviationAlarmType_Unsuppress = 17931,
    ExclusiveDeviationAlarmType_RemoveFromService = 17932,
    ExclusiveDeviationAlarmType_PlaceInService = 17933,
    ExclusiveRateOfChangeAlarmType_Unsuppress = 17938,
    ExclusiveRateOfChangeAlarmType_RemoveFromService = 17939,
    ExclusiveRateOfChangeAlarmType_PlaceInService = 17940,
    DiscreteAlarmType_Unsuppress = 17945,
    DiscreteAlarmType_RemoveFromService = 17946,
    DiscreteAlarmType_PlaceInService = 17947,
    OffNormalAlarmType_Unsuppress = 17952,
    OffNormalAlarmType_RemoveFromService = 17953,
    OffNormalAlarmType_PlaceInService = 17954,
    SystemOffNormalAlarmType_Unsuppress = 17959,
    SystemOffNormalAlarmType_RemoveFromService = 17960,
    SystemOffNormalAlarmType_PlaceInService = 17961,
    TripAlarmType_Unsuppress = 17966,
    TripAlarmType_RemoveFromService = 17967,
    TripAlarmType_PlaceInService = 17968,
    WriterGroupType_AddDataSetWriter = 17969,
    CertificateExpirationAlarmType_Unsuppress = 17973,
    CertificateExpirationAlarmType_RemoveFromService = 17974,
    CertificateExpirationAlarmType_PlaceInService = 17975,
    DiscrepancyAlarmType_Unsuppress = 17980,
    DiscrepancyAlarmType_RemoveFromService = 17981,
    DiscrepancyAlarmType_PlaceInService = 17982,
    WriterGroupType_RemoveDataSetWriter = 17992,
    PubSubGroupTypeAddWriterrMethodType = 17994,
    KeyCredentialConfigurationType_UpdateCredential = 18006,
    KeyCredentialConfigurationType_DeleteCredential = 18008,
    KeyCredentialUpdateMethodType = 18009,
    ReaderGroupType_Status_Enable = 18074,
    ReaderGroupType_Status_Disable = 18075,
    ReaderGroupType_DataSetReaderName_Placeholder_Status_Enable = 18090,
    ReaderGroupType_DataSetReaderName_Placeholder_Status_Disable = 18091,
    ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Reset = 18104,
    KeyCredentialConfiguration_ServiceName_Placeholder_UpdateCredential = 18161,
    KeyCredentialConfiguration_ServiceName_Placeholder_DeleteCredential = 18163,
    AlarmConditionType_Reset = 18199,
    AlarmGroupType_AlarmConditionInstance_Placeholder_Reset = 18212,
    LimitAlarmType_Reset = 18222,
    ExclusiveLimitAlarmType_Reset = 18232,
    NonExclusiveLimitAlarmType_Reset = 18242,
    NonExclusiveLevelAlarmType_Unsuppress = 18255,
    NonExclusiveLevelAlarmType_Reset = 18256,
    ExclusiveLevelAlarmType_Reset = 18266,
    NonExclusiveDeviationAlarmType_Reset = 18276,
    NonExclusiveRateOfChangeAlarmType_Reset = 18286,
    ExclusiveDeviationAlarmType_Reset = 18296,
    ExclusiveRateOfChangeAlarmType_Reset = 18306,
    DiscreteAlarmType_Reset = 18316,
    OffNormalAlarmType_Reset = 18326,
    SystemOffNormalAlarmType_Reset = 18336,
    TripAlarmType_Reset = 18346,
    InstrumentDiagnosticAlarmType_Disable = 18380,
    InstrumentDiagnosticAlarmType_Enable = 18381,
    InstrumentDiagnosticAlarmType_AddComment = 18382,
    InstrumentDiagnosticAlarmType_ConditionRefresh = 18384,
    InstrumentDiagnosticAlarmType_ConditionRefresh2 = 18386,
    InstrumentDiagnosticAlarmType_Acknowledge = 18406,
    InstrumentDiagnosticAlarmType_Confirm = 18408,
    InstrumentDiagnosticAlarmType_ShelvingState_TimedShelve = 18453,
    InstrumentDiagnosticAlarmType_ShelvingState_Unshelve = 18455,
    InstrumentDiagnosticAlarmType_ShelvingState_OneShotShelve = 18456,
    InstrumentDiagnosticAlarmType_Silence = 18489,
    InstrumentDiagnosticAlarmType_Suppress = 18490,
    InstrumentDiagnosticAlarmType_Unsuppress = 18491,
    InstrumentDiagnosticAlarmType_RemoveFromService = 18492,
    InstrumentDiagnosticAlarmType_PlaceInService = 18493,
    InstrumentDiagnosticAlarmType_Reset = 18494,
    SystemDiagnosticAlarmType_Disable = 18529,
    SystemDiagnosticAlarmType_Enable = 18530,
    SystemDiagnosticAlarmType_AddComment = 18531,
    SystemDiagnosticAlarmType_ConditionRefresh = 18533,
    SystemDiagnosticAlarmType_ConditionRefresh2 = 18535,
    SystemDiagnosticAlarmType_Acknowledge = 18555,
    SystemDiagnosticAlarmType_Confirm = 18557,
    SystemDiagnosticAlarmType_ShelvingState_TimedShelve = 18602,
    SystemDiagnosticAlarmType_ShelvingState_Unshelve = 18604,
    SystemDiagnosticAlarmType_ShelvingState_OneShotShelve = 18605,
    SystemDiagnosticAlarmType_Silence = 18638,
    SystemDiagnosticAlarmType_Suppress = 18639,
    SystemDiagnosticAlarmType_Unsuppress = 18640,
    SystemDiagnosticAlarmType_RemoveFromService = 18641,
    SystemDiagnosticAlarmType_PlaceInService = 18642,
    SystemDiagnosticAlarmType_Reset = 18643,
    CertificateExpirationAlarmType_Reset = 18654,
    DiscrepancyAlarmType_Reset = 18664,
    AlarmMetricsType_Reset = 18666,
    PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Reset = 18679,
    PublishSubscribeType_Diagnostics_Reset = 18727,
    PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Reset = 18883,
    PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Reset = 18942,
    PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Reset = 19001,
    PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Reset = 19119,
    PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Reset = 19188,
    PubSubConnectionType_Diagnostics_Reset = 19253,
    TrustListOutOfDateAlarmType_Disable = 19330,
    TrustListOutOfDateAlarmType_Enable = 19331,
    TrustListOutOfDateAlarmType_AddComment = 19332,
    TrustListOutOfDateAlarmType_ConditionRefresh = 19334,
    TrustListOutOfDateAlarmType_ConditionRefresh2 = 19336,
    TrustListOutOfDateAlarmType_Acknowledge = 19356,
    TrustListOutOfDateAlarmType_Confirm = 19358,
    TrustListOutOfDateAlarmType_ShelvingState_TimedShelve = 19403,
    TrustListOutOfDateAlarmType_ShelvingState_Unshelve = 19405,
    TrustListOutOfDateAlarmType_ShelvingState_OneShotShelve = 19406,
    TrustListOutOfDateAlarmType_Silence = 19439,
    TrustListOutOfDateAlarmType_Suppress = 19440,
    TrustListOutOfDateAlarmType_Unsuppress = 19441,
    TrustListOutOfDateAlarmType_RemoveFromService = 19442,
    TrustListOutOfDateAlarmType_PlaceInService = 19443,
    TrustListOutOfDateAlarmType_Reset = 19444,
    CertificateGroupType_CertificateExpired_Disable = 19483,
    CertificateGroupType_CertificateExpired_Enable = 19484,
    CertificateGroupType_CertificateExpired_AddComment = 19485,
    CertificateGroupType_CertificateExpired_Acknowledge = 19505,
    CertificateGroupType_CertificateExpired_Confirm = 19507,
    DataSetWriterType_Diagnostics_Reset = 19562,
    DataSetReaderType_Diagnostics_Reset = 19621,
    PubSubDiagnosticsType_Reset = 19689,
    PubSubDiagnosticsRootType_Reset = 19744,
    PubSubDiagnosticsConnectionType_Reset = 19798,
    PubSubDiagnosticsWriterGroupType_Reset = 19846,
    PubSubDiagnosticsReaderGroupType_Reset = 19915,
    PubSubDiagnosticsDataSetWriterType_Reset = 19980,
    PubSubDiagnosticsDataSetReaderType_Reset = 20039,
    CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve = 20097,
    CertificateGroupType_CertificateExpired_ShelvingState_Unshelve = 20099,
    CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve = 20100,
    CertificateGroupType_CertificateExpired_Silence = 20132,
    CertificateGroupType_CertificateExpired_Suppress = 20133,
    CertificateGroupType_CertificateExpired_Unsuppress = 20134,
    CertificateGroupType_CertificateExpired_RemoveFromService = 20135,
    CertificateGroupType_CertificateExpired_PlaceInService = 20136,
    CertificateGroupType_CertificateExpired_Reset = 20137,
    CertificateGroupType_TrustListOutOfDate_Disable = 20176,
    CertificateGroupType_TrustListOutOfDate_Enable = 20177,
    CertificateGroupType_TrustListOutOfDate_AddComment = 20178,
    CertificateGroupType_TrustListOutOfDate_Acknowledge = 20198,
    CertificateGroupType_TrustListOutOfDate_Confirm = 20200,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve = 20245,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve = 20247,
    CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve = 20248,
    CertificateGroupType_TrustListOutOfDate_Silence = 20280,
    CertificateGroupType_TrustListOutOfDate_Suppress = 20281,
    CertificateGroupType_TrustListOutOfDate_Unsuppress = 20282,
    CertificateGroupType_TrustListOutOfDate_RemoveFromService = 20283,
    CertificateGroupType_TrustListOutOfDate_PlaceInService = 20284,
    CertificateGroupType_TrustListOutOfDate_Reset = 20285,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Disable = 20324,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Enable = 20325,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment = 20326,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge = 20346,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm = 20348,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve =
        20393,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve =
        20395,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve =
        20396,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Silence = 20430,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress = 20431,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress = 20432,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService = 20433,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService = 20434,
    CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset = 20435,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Disable = 20474,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Enable = 20475,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment = 20476,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge = 20496,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm = 20498,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        20543,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        20545,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        20546,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Silence = 20578,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress = 20579,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress = 20580,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService = 20581,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService = 20582,
    CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset = 20583,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Disable = 20622,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Enable = 20623,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment = 20624,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge = 20644,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm = 20646,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve =
        20691,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve = 20693,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve =
        20694,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Silence = 20726,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress = 20727,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress = 20728,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService = 20729,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService = 20730,
    CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset = 20731,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Disable = 20770,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Enable = 20771,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment = 20772,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge = 20792,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm = 20794,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        20839,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve = 20841,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        20842,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Silence = 20874,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress = 20875,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress = 20876,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService = 20877,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService = 20878,
    CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset = 20879,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Disable = 20918,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Enable = 20919,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment = 20920,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge = 20940,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm = 20942,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve =
        20987,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve =
        20989,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve =
        20990,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables = 21009,
    ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror = 21012,
    ReaderGroupType_Diagnostics_Reset = 21027,
    ReaderGroupType_AddDataSetReader = 21082,
    ReaderGroupType_RemoveDataSetReader = 21085,
    PubSubGroupTypeAddReaderMethodType = 21087,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Silence = 21225,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress = 21226,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress = 21227,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService = 21228,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService = 21229,
    CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset = 21230,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Disable = 21269,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Enable = 21270,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment = 21271,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge = 21291,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm = 21293,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        21338,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        21340,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        21341,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Silence = 21373,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress = 21374,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress = 21375,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService = 21376,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService = 21377,
    CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset = 21378,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Disable = 21417,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Enable = 21418,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AddComment = 21419,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Acknowledge = 21439,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Confirm = 21441,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_TimedShelve =
        21486,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_Unshelve =
        21488,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_OneShotShelve =
        21489,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Silence = 21521,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Suppress = 21522,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Unsuppress = 21523,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_RemoveFromService =
        21524,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_PlaceInService =
        21525,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Reset = 21526,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Disable = 21565,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Enable = 21566,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AddComment = 21567,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Acknowledge = 21587,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Confirm = 21589,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_TimedShelve =
        21634,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_Unshelve =
        21636,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_OneShotShelve =
        21637,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Silence = 21669,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Suppress = 21670,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Unsuppress = 21671,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_RemoveFromService =
        21672,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_PlaceInService =
        21673,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Reset = 21674,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable =
        21713,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable =
        21714,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment =
        21715,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge =
        21735,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm =
        21737,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve =
        21782,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve =
        21784,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve =
        21785,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence =
        21817,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress =
        21818,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress =
        21819,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService =
        21820,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService =
        21821,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset =
        21822,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable =
        21861,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable =
        21862,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment =
        21863,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge =
        21883,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm =
        21885,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        21930,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        21932,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        21933,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence =
        21965,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress =
        21966,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress =
        21967,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService =
        21968,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService =
        21969,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset =
        21970,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable = 22009,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable = 22010,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment =
        22011,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge =
        22031,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm = 22033,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve =
        22078,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve =
        22080,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve =
        22081,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence = 22113,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress = 22114,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress =
        22115,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService =
        22116,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService =
        22117,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset = 22118,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable = 22157,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable = 22158,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment =
        22159,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge =
        22179,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm = 22181,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        22226,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        22228,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        22229,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence = 22261,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress = 22262,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress =
        22263,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService =
        22264,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService =
        22265,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset = 22266,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable =
        22305,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable =
        22306,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment =
        22307,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge =
        22327,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm =
        22329,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve =
        22374,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve =
        22376,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve =
        22377,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence =
        22409,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress =
        22410,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress =
        22411,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService =
        22412,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService =
        22413,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset =
        22414,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable =
        22453,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable =
        22454,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment =
        22455,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge =
        22475,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm =
        22477,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        22522,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        22524,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        22525,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence =
        22557,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress =
        22558,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress =
        22559,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService =
        22560,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService =
        22561,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset =
        22562,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable =
        22601,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable = 22602,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment =
        22603,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge =
        22623,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm =
        22625,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve =
        22670,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve =
        22672,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve =
        22673,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence =
        22705,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress =
        22706,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress =
        22707,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService =
        22708,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService =
        22709,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset = 22710,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable =
        22749,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable = 22750,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment =
        22751,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge =
        22771,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm =
        22773,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        22818,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        22820,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        22821,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence =
        22853,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress =
        22854,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress =
        22855,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService =
        22856,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService =
        22857,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset = 22858,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable = 22897,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable = 22898,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment = 22899,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge = 22919,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm = 22921,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve =
        22966,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve =
        22968,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve =
        22969,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence = 23001,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress = 23002,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress = 23003,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService =
        23004,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService =
        23005,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset = 23006,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable = 23045,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable = 23046,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment = 23047,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge = 23067,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm = 23069,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        23114,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        23116,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        23117,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence = 23149,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress = 23150,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress = 23151,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService =
        23152,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService =
        23153,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset = 23154,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable = 23193,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable = 23194,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment =
        23195,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge =
        23215,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm = 23217,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve =
        23262,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve =
        23264,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve =
        23265,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence = 23297,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress = 23298,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress =
        23299,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService =
        23300,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService =
        23301,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset = 23302,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable = 23341,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable = 23342,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment =
        23343,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge =
        23363,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm = 23365,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve =
        23410,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve =
        23412,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve =
        23413,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence = 23445,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress = 23446,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress =
        23447,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService =
        23448,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService =
        23449,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset = 23450,
    AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias = 23459,
    AliasNameCategoryType_FindAlias = 23462,
    FindAliasMethodType = 23465,
    Aliases_SubAliasNameCategories_Placeholder_FindAlias = 23473,
    Aliases_FindAlias = 23476,
    TagVariables_SubAliasNameCategories_Placeholder_FindAlias = 23482,
    TagVariables_FindAlias = 23485,
    Topics_SubAliasNameCategories_Placeholder_FindAlias = 23491,
    Topics_FindAlias = 23494,
    CertificateGroupType_GetRejectedList = 23526,
    CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList = 23529,
    CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList = 23531,
    CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList = 23533,
    CertificateGroupFolderType_AdditionalGroup_Placeholder_GetRejectedList = 23535,
    ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList = 23544,
    ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList = 23546,
    ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList = 23548,
    ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList = 23550,
    ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList = 23552,
    ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList = 23554,
}

impl<'a> From<&'a MethodId> for NodeId {
    fn from(r: &'a MethodId) -> Self {
        NodeId::new(0, *r as u32)
    }
}

impl Into<NodeId> for MethodId {
    fn into(self) -> NodeId {
        NodeId::new(0, self as u32)
    }
}

impl Into<ExpandedNodeId> for MethodId {
    fn into(self) -> ExpandedNodeId {
        ExpandedNodeId {
            node_id: NodeId::new(0, self as u32),
            namespace_uri: UAString::null(),
            server_index: 0,
        }
    }
}

impl TryFrom<u32> for MethodId {
    type Error = ();

    fn try_from(value: u32) -> Result<Self, Self::Error> {
        match value {
            2426 => Ok(MethodId::ProgramStateMachineType_Start),
            2427 => Ok(MethodId::ProgramStateMachineType_Suspend),
            2428 => Ok(MethodId::ProgramStateMachineType_Resume),
            2429 => Ok(MethodId::ProgramStateMachineType_Halt),
            2430 => Ok(MethodId::ProgramStateMachineType_Reset),
            2947 => Ok(MethodId::ShelvedStateMachineType_Unshelve),
            2948 => Ok(MethodId::ShelvedStateMachineType_OneShotShelve),
            2949 => Ok(MethodId::ShelvedStateMachineType_TimedShelve),
            3863 => Ok(MethodId::AddCommentMethodType),
            3875 => Ok(MethodId::ConditionType_ConditionRefresh),
            4198 => Ok(MethodId::DialogConditionType_ConditionRefresh),
            5123 => Ok(MethodId::AcknowledgeableConditionType_ConditionRefresh),
            5550 => Ok(MethodId::AlarmConditionType_ConditionRefresh),
            6102 => Ok(MethodId::TimedShelveMethodType),
            6126 => Ok(MethodId::LimitAlarmType_ConditionRefresh),
            9007 => Ok(MethodId::ConditionRefreshMethodType),
            9027 => Ok(MethodId::ConditionType_Enable),
            9028 => Ok(MethodId::ConditionType_Disable),
            9029 => Ok(MethodId::ConditionType_AddComment),
            9031 => Ok(MethodId::DialogResponseMethodType),
            9051 => Ok(MethodId::DialogConditionType_Enable),
            9052 => Ok(MethodId::DialogConditionType_Disable),
            9053 => Ok(MethodId::DialogConditionType_AddComment),
            9069 => Ok(MethodId::DialogConditionType_Respond),
            9089 => Ok(MethodId::AcknowledgeableConditionType_Enable),
            9090 => Ok(MethodId::AcknowledgeableConditionType_Disable),
            9091 => Ok(MethodId::AcknowledgeableConditionType_AddComment),
            9111 => Ok(MethodId::AcknowledgeableConditionType_Acknowledge),
            9113 => Ok(MethodId::AcknowledgeableConditionType_Confirm),
            9134 => Ok(MethodId::AlarmConditionType_Enable),
            9135 => Ok(MethodId::AlarmConditionType_Disable),
            9136 => Ok(MethodId::AlarmConditionType_AddComment),
            9156 => Ok(MethodId::AlarmConditionType_Acknowledge),
            9158 => Ok(MethodId::AlarmConditionType_Confirm),
            9211 => Ok(MethodId::AlarmConditionType_ShelvingState_Unshelve),
            9212 => Ok(MethodId::AlarmConditionType_ShelvingState_OneShotShelve),
            9213 => Ok(MethodId::AlarmConditionType_ShelvingState_TimedShelve),
            9235 => Ok(MethodId::LimitAlarmType_Enable),
            9236 => Ok(MethodId::LimitAlarmType_Disable),
            9237 => Ok(MethodId::LimitAlarmType_AddComment),
            9257 => Ok(MethodId::LimitAlarmType_Acknowledge),
            9259 => Ok(MethodId::LimitAlarmType_Confirm),
            9312 => Ok(MethodId::LimitAlarmType_ShelvingState_Unshelve),
            9313 => Ok(MethodId::LimitAlarmType_ShelvingState_OneShotShelve),
            9314 => Ok(MethodId::LimitAlarmType_ShelvingState_TimedShelve),
            9370 => Ok(MethodId::ExclusiveLimitAlarmType_Enable),
            9371 => Ok(MethodId::ExclusiveLimitAlarmType_Disable),
            9372 => Ok(MethodId::ExclusiveLimitAlarmType_AddComment),
            9374 => Ok(MethodId::ExclusiveLimitAlarmType_ConditionRefresh),
            9394 => Ok(MethodId::ExclusiveLimitAlarmType_Acknowledge),
            9396 => Ok(MethodId::ExclusiveLimitAlarmType_Confirm),
            9449 => Ok(MethodId::ExclusiveLimitAlarmType_ShelvingState_Unshelve),
            9450 => Ok(MethodId::ExclusiveLimitAlarmType_ShelvingState_OneShotShelve),
            9451 => Ok(MethodId::ExclusiveLimitAlarmType_ShelvingState_TimedShelve),
            9511 => Ok(MethodId::ExclusiveLevelAlarmType_Enable),
            9512 => Ok(MethodId::ExclusiveLevelAlarmType_Disable),
            9513 => Ok(MethodId::ExclusiveLevelAlarmType_AddComment),
            9515 => Ok(MethodId::ExclusiveLevelAlarmType_ConditionRefresh),
            9535 => Ok(MethodId::ExclusiveLevelAlarmType_Acknowledge),
            9537 => Ok(MethodId::ExclusiveLevelAlarmType_Confirm),
            9590 => Ok(MethodId::ExclusiveLevelAlarmType_ShelvingState_Unshelve),
            9591 => Ok(MethodId::ExclusiveLevelAlarmType_ShelvingState_OneShotShelve),
            9592 => Ok(MethodId::ExclusiveLevelAlarmType_ShelvingState_TimedShelve),
            9652 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Enable),
            9653 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Disable),
            9654 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_AddComment),
            9656 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_ConditionRefresh),
            9676 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Acknowledge),
            9678 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Confirm),
            9731 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_ShelvingState_Unshelve),
            9732 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_ShelvingState_OneShotShelve),
            9733 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve),
            9793 => Ok(MethodId::ExclusiveDeviationAlarmType_Enable),
            9794 => Ok(MethodId::ExclusiveDeviationAlarmType_Disable),
            9795 => Ok(MethodId::ExclusiveDeviationAlarmType_AddComment),
            9797 => Ok(MethodId::ExclusiveDeviationAlarmType_ConditionRefresh),
            9817 => Ok(MethodId::ExclusiveDeviationAlarmType_Acknowledge),
            9819 => Ok(MethodId::ExclusiveDeviationAlarmType_Confirm),
            9872 => Ok(MethodId::ExclusiveDeviationAlarmType_ShelvingState_Unshelve),
            9873 => Ok(MethodId::ExclusiveDeviationAlarmType_ShelvingState_OneShotShelve),
            9874 => Ok(MethodId::ExclusiveDeviationAlarmType_ShelvingState_TimedShelve),
            9935 => Ok(MethodId::NonExclusiveLimitAlarmType_Enable),
            9936 => Ok(MethodId::NonExclusiveLimitAlarmType_Disable),
            9937 => Ok(MethodId::NonExclusiveLimitAlarmType_AddComment),
            9939 => Ok(MethodId::NonExclusiveLimitAlarmType_ConditionRefresh),
            9959 => Ok(MethodId::NonExclusiveLimitAlarmType_Acknowledge),
            9961 => Ok(MethodId::NonExclusiveLimitAlarmType_Confirm),
            10014 => Ok(MethodId::NonExclusiveLimitAlarmType_ShelvingState_Unshelve),
            10015 => Ok(MethodId::NonExclusiveLimitAlarmType_ShelvingState_OneShotShelve),
            10016 => Ok(MethodId::NonExclusiveLimitAlarmType_ShelvingState_TimedShelve),
            10089 => Ok(MethodId::NonExclusiveLevelAlarmType_Enable),
            10090 => Ok(MethodId::NonExclusiveLevelAlarmType_Disable),
            10091 => Ok(MethodId::NonExclusiveLevelAlarmType_AddComment),
            10093 => Ok(MethodId::NonExclusiveLevelAlarmType_ConditionRefresh),
            10113 => Ok(MethodId::NonExclusiveLevelAlarmType_Acknowledge),
            10115 => Ok(MethodId::NonExclusiveLevelAlarmType_Confirm),
            10168 => Ok(MethodId::NonExclusiveLevelAlarmType_ShelvingState_Unshelve),
            10169 => Ok(MethodId::NonExclusiveLevelAlarmType_ShelvingState_OneShotShelve),
            10170 => Ok(MethodId::NonExclusiveLevelAlarmType_ShelvingState_TimedShelve),
            10243 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Enable),
            10244 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Disable),
            10245 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_AddComment),
            10247 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_ConditionRefresh),
            10267 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Acknowledge),
            10269 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Confirm),
            10322 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_ShelvingState_Unshelve),
            10323 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_ShelvingState_OneShotShelve),
            10324 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_ShelvingState_TimedShelve),
            10397 => Ok(MethodId::NonExclusiveDeviationAlarmType_Enable),
            10398 => Ok(MethodId::NonExclusiveDeviationAlarmType_Disable),
            10399 => Ok(MethodId::NonExclusiveDeviationAlarmType_AddComment),
            10401 => Ok(MethodId::NonExclusiveDeviationAlarmType_ConditionRefresh),
            10421 => Ok(MethodId::NonExclusiveDeviationAlarmType_Acknowledge),
            10423 => Ok(MethodId::NonExclusiveDeviationAlarmType_Confirm),
            10476 => Ok(MethodId::NonExclusiveDeviationAlarmType_ShelvingState_Unshelve),
            10477 => Ok(MethodId::NonExclusiveDeviationAlarmType_ShelvingState_OneShotShelve),
            10478 => Ok(MethodId::NonExclusiveDeviationAlarmType_ShelvingState_TimedShelve),
            10552 => Ok(MethodId::DiscreteAlarmType_Enable),
            10553 => Ok(MethodId::DiscreteAlarmType_Disable),
            10554 => Ok(MethodId::DiscreteAlarmType_AddComment),
            10556 => Ok(MethodId::DiscreteAlarmType_ConditionRefresh),
            10576 => Ok(MethodId::DiscreteAlarmType_Acknowledge),
            10578 => Ok(MethodId::DiscreteAlarmType_Confirm),
            10631 => Ok(MethodId::DiscreteAlarmType_ShelvingState_Unshelve),
            10632 => Ok(MethodId::DiscreteAlarmType_ShelvingState_OneShotShelve),
            10633 => Ok(MethodId::DiscreteAlarmType_ShelvingState_TimedShelve),
            10666 => Ok(MethodId::OffNormalAlarmType_Enable),
            10667 => Ok(MethodId::OffNormalAlarmType_Disable),
            10668 => Ok(MethodId::OffNormalAlarmType_AddComment),
            10670 => Ok(MethodId::OffNormalAlarmType_ConditionRefresh),
            10690 => Ok(MethodId::OffNormalAlarmType_Acknowledge),
            10692 => Ok(MethodId::OffNormalAlarmType_Confirm),
            10745 => Ok(MethodId::OffNormalAlarmType_ShelvingState_Unshelve),
            10746 => Ok(MethodId::OffNormalAlarmType_ShelvingState_OneShotShelve),
            10747 => Ok(MethodId::OffNormalAlarmType_ShelvingState_TimedShelve),
            10780 => Ok(MethodId::TripAlarmType_Enable),
            10781 => Ok(MethodId::TripAlarmType_Disable),
            10782 => Ok(MethodId::TripAlarmType_AddComment),
            10784 => Ok(MethodId::TripAlarmType_ConditionRefresh),
            10804 => Ok(MethodId::TripAlarmType_Acknowledge),
            10806 => Ok(MethodId::TripAlarmType_Confirm),
            10859 => Ok(MethodId::TripAlarmType_ShelvingState_Unshelve),
            10860 => Ok(MethodId::TripAlarmType_ShelvingState_OneShotShelve),
            10861 => Ok(MethodId::TripAlarmType_ShelvingState_TimedShelve),
            11489 => Ok(MethodId::ServerType_GetMonitoredItems),
            11492 => Ok(MethodId::Server_GetMonitoredItems),
            11495 => Ok(MethodId::GetMonitoredItemsMethodType),
            11580 => Ok(MethodId::FileType_Open),
            11583 => Ok(MethodId::FileType_Close),
            11585 => Ok(MethodId::FileType_Read),
            11588 => Ok(MethodId::FileType_Write),
            11590 => Ok(MethodId::FileType_GetPosition),
            11593 => Ok(MethodId::FileType_SetPosition),
            11600 => Ok(MethodId::AddressSpaceFileType_Open),
            11603 => Ok(MethodId::AddressSpaceFileType_Close),
            11605 => Ok(MethodId::AddressSpaceFileType_Read),
            11608 => Ok(MethodId::AddressSpaceFileType_Write),
            11610 => Ok(MethodId::AddressSpaceFileType_GetPosition),
            11613 => Ok(MethodId::AddressSpaceFileType_SetPosition),
            11615 => Ok(MethodId::AddressSpaceFileType_ExportNamespace),
            11629 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_Open),
            11632 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_Close),
            11634 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_Read),
            11637 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_Write),
            11639 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_GetPosition),
            11642 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_SetPosition),
            11644 => Ok(MethodId::NamespaceMetadataType_NamespaceFile_ExportNamespace),
            11659 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Open),
            11662 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Close),
            11664 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Read),
            11667 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_Write),
            11669 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_GetPosition),
            11672 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_SetPosition),
            11674 => Ok(MethodId::NamespacesType_NamespaceIdentifier_Placeholder_NamespaceFile_ExportNamespace),
            11738 => Ok(MethodId::OpenMethodType),
            11741 => Ok(MethodId::CloseMethodType),
            11743 => Ok(MethodId::ReadMethodType),
            11746 => Ok(MethodId::WriteMethodType),
            11748 => Ok(MethodId::GetPositionMethodType),
            11751 => Ok(MethodId::SetPositionMethodType),
            11784 => Ok(MethodId::SystemOffNormalAlarmType_Disable),
            11785 => Ok(MethodId::SystemOffNormalAlarmType_Enable),
            11786 => Ok(MethodId::SystemOffNormalAlarmType_AddComment),
            11788 => Ok(MethodId::SystemOffNormalAlarmType_ConditionRefresh),
            11808 => Ok(MethodId::SystemOffNormalAlarmType_Acknowledge),
            11810 => Ok(MethodId::SystemOffNormalAlarmType_Confirm),
            11844 => Ok(MethodId::SystemOffNormalAlarmType_ShelvingState_Unshelve),
            11845 => Ok(MethodId::SystemOffNormalAlarmType_ShelvingState_OneShotShelve),
            11846 => Ok(MethodId::SystemOffNormalAlarmType_ShelvingState_TimedShelve),
            12513 => Ok(MethodId::OpenWithMasksMethodType),
            12516 => Ok(MethodId::CloseAndUpdateMethodType),
            12518 => Ok(MethodId::AddCertificateMethodType),
            12520 => Ok(MethodId::RemoveCertificateMethodType),
            12527 => Ok(MethodId::TrustListType_Open),
            12530 => Ok(MethodId::TrustListType_Close),
            12532 => Ok(MethodId::TrustListType_Read),
            12535 => Ok(MethodId::TrustListType_Write),
            12537 => Ok(MethodId::TrustListType_GetPosition),
            12540 => Ok(MethodId::TrustListType_SetPosition),
            12543 => Ok(MethodId::TrustListType_OpenWithMasks),
            12546 => Ok(MethodId::TrustListType_CloseAndUpdate),
            12548 => Ok(MethodId::TrustListType_AddCertificate),
            12550 => Ok(MethodId::TrustListType_RemoveCertificate),
            12578 => Ok(MethodId::UpdateCertificateMethodType),
            12616 => Ok(MethodId::ServerConfigurationType_UpdateCertificate),
            12647 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Open),
            12650 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Close),
            12652 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Read),
            12655 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_Write),
            12657 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition),
            12660 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition),
            12663 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks),
            12666 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate),
            12668 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate),
            12670 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate),
            12731 => Ok(MethodId::ServerConfigurationType_CreateSigningRequest),
            12734 => Ok(MethodId::ServerConfigurationType_ApplyChanges),
            12737 => Ok(MethodId::ServerConfiguration_CreateSigningRequest),
            12740 => Ok(MethodId::ServerConfiguration_ApplyChanges),
            12741 => Ok(MethodId::CreateSigningRequestMethodType),
            12746 => Ok(MethodId::ServerType_SetSubscriptionDurable),
            12749 => Ok(MethodId::Server_SetSubscriptionDurable),
            12752 => Ok(MethodId::SetSubscriptionDurableMethodType),
            12773 => Ok(MethodId::GetRejectedListMethodType),
            12775 => Ok(MethodId::ServerConfigurationType_GetRejectedList),
            12777 => Ok(MethodId::ServerConfiguration_GetRejectedList),
            12871 => Ok(MethodId::ServerType_ResendData),
            12873 => Ok(MethodId::Server_ResendData),
            12875 => Ok(MethodId::ResendDataMethodType),
            12883 => Ok(MethodId::ServerType_RequestServerStateChange),
            12886 => Ok(MethodId::Server_RequestServerStateChange),
            12888 => Ok(MethodId::RequestServerStateChangeMethodType),
            12912 => Ok(MethodId::ConditionType_ConditionRefresh2),
            12914 => Ok(MethodId::ConditionRefresh2MethodType),
            12916 => Ok(MethodId::DialogConditionType_ConditionRefresh2),
            12918 => Ok(MethodId::AcknowledgeableConditionType_ConditionRefresh2),
            12984 => Ok(MethodId::AlarmConditionType_ConditionRefresh2),
            12986 => Ok(MethodId::LimitAlarmType_ConditionRefresh2),
            12988 => Ok(MethodId::ExclusiveLimitAlarmType_ConditionRefresh2),
            12990 => Ok(MethodId::NonExclusiveLimitAlarmType_ConditionRefresh2),
            12992 => Ok(MethodId::NonExclusiveLevelAlarmType_ConditionRefresh2),
            12994 => Ok(MethodId::ExclusiveLevelAlarmType_ConditionRefresh2),
            12996 => Ok(MethodId::NonExclusiveDeviationAlarmType_ConditionRefresh2),
            12998 => Ok(MethodId::ExclusiveDeviationAlarmType_ConditionRefresh2),
            13000 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_ConditionRefresh2),
            13002 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_ConditionRefresh2),
            13004 => Ok(MethodId::DiscreteAlarmType_ConditionRefresh2),
            13006 => Ok(MethodId::OffNormalAlarmType_ConditionRefresh2),
            13008 => Ok(MethodId::SystemOffNormalAlarmType_ConditionRefresh2),
            13010 => Ok(MethodId::TripAlarmType_ConditionRefresh2),
            13256 => Ok(MethodId::CertificateExpirationAlarmType_Disable),
            13257 => Ok(MethodId::CertificateExpirationAlarmType_Enable),
            13258 => Ok(MethodId::CertificateExpirationAlarmType_AddComment),
            13260 => Ok(MethodId::CertificateExpirationAlarmType_ConditionRefresh),
            13262 => Ok(MethodId::CertificateExpirationAlarmType_ConditionRefresh2),
            13282 => Ok(MethodId::CertificateExpirationAlarmType_Acknowledge),
            13284 => Ok(MethodId::CertificateExpirationAlarmType_Confirm),
            13318 => Ok(MethodId::CertificateExpirationAlarmType_ShelvingState_Unshelve),
            13319 => Ok(MethodId::CertificateExpirationAlarmType_ShelvingState_OneShotShelve),
            13320 => Ok(MethodId::CertificateExpirationAlarmType_ShelvingState_TimedShelve),
            13342 => Ok(MethodId::CreateDirectoryMethodType),
            13345 => Ok(MethodId::CreateFileMethodType),
            13348 => Ok(MethodId::DeleteFileMethodType),
            13350 => Ok(MethodId::MoveOrCopyMethodType),
            13355 => Ok(MethodId::FileDirectoryType_FileDirectoryName_Placeholder_CreateDirectory),
            13358 => Ok(MethodId::FileDirectoryType_FileDirectoryName_Placeholder_CreateFile),
            13363 => Ok(MethodId::FileDirectoryType_FileDirectoryName_Placeholder_MoveOrCopy),
            13372 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_Open),
            13375 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_Close),
            13377 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_Read),
            13380 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_Write),
            13382 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_GetPosition),
            13385 => Ok(MethodId::FileDirectoryType_FileName_Placeholder_SetPosition),
            13387 => Ok(MethodId::FileDirectoryType_CreateDirectory),
            13390 => Ok(MethodId::FileDirectoryType_CreateFile),
            13393 => Ok(MethodId::FileDirectoryType_DeleteFileSystemObject),
            13395 => Ok(MethodId::FileDirectoryType_MoveOrCopy),
            13605 => Ok(MethodId::CertificateGroupType_TrustList_Open),
            13608 => Ok(MethodId::CertificateGroupType_TrustList_Close),
            13610 => Ok(MethodId::CertificateGroupType_TrustList_Read),
            13613 => Ok(MethodId::CertificateGroupType_TrustList_Write),
            13615 => Ok(MethodId::CertificateGroupType_TrustList_GetPosition),
            13618 => Ok(MethodId::CertificateGroupType_TrustList_SetPosition),
            13621 => Ok(MethodId::CertificateGroupType_TrustList_OpenWithMasks),
            13624 => Ok(MethodId::CertificateGroupType_TrustList_CloseAndUpdate),
            13627 => Ok(MethodId::CertificateGroupType_TrustList_AddCertificate),
            13629 => Ok(MethodId::CertificateGroupType_TrustList_RemoveCertificate),
            13737 => Ok(MethodId::ServerConfiguration_UpdateCertificate),
            13821 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Open),
            13824 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Close),
            13826 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Read),
            13829 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_Write),
            13831 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_GetPosition),
            13834 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_SetPosition),
            13837 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_OpenWithMasks),
            13840 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_CloseAndUpdate),
            13843 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_AddCertificate),
            13845 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustList_RemoveCertificate),
            13855 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Open),
            13858 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Close),
            13860 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Read),
            13863 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_Write),
            13865 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_GetPosition),
            13868 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_SetPosition),
            13871 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_OpenWithMasks),
            13874 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_CloseAndUpdate),
            13877 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_AddCertificate),
            13879 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustList_RemoveCertificate),
            13889 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Open),
            13892 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Close),
            13894 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Read),
            13897 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_Write),
            13899 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_GetPosition),
            13902 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_SetPosition),
            13905 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_OpenWithMasks),
            13908 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_CloseAndUpdate),
            13911 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_AddCertificate),
            13913 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustList_RemoveCertificate),
            13923 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Open),
            13926 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Close),
            13928 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Read),
            13931 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_Write),
            13933 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_GetPosition),
            13936 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_SetPosition),
            13939 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_OpenWithMasks),
            13942 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_CloseAndUpdate),
            13945 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_AddCertificate),
            13947 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustList_RemoveCertificate),
            13958 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Open),
            13961 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Close),
            13963 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Read),
            13966 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_Write),
            13968 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_GetPosition),
            13971 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_SetPosition),
            13974 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_OpenWithMasks),
            13977 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_CloseAndUpdate),
            13980 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_AddCertificate),
            13982 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustList_RemoveCertificate),
            13992 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Open),
            13995 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Close),
            13997 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Read),
            14000 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_Write),
            14002 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition),
            14005 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition),
            14008 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks),
            14011 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate),
            14014 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate),
            14016 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate),
            14026 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Open),
            14029 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Close),
            14031 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Read),
            14034 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_Write),
            14036 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition),
            14039 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition),
            14042 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks),
            14045 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate),
            14048 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate),
            14050 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate),
            14095 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Open),
            14098 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Close),
            14100 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Read),
            14103 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_Write),
            14105 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_GetPosition),
            14108 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_SetPosition),
            14111 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_OpenWithMasks),
            14114 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_CloseAndUpdate),
            14117 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_AddCertificate),
            14119 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustList_RemoveCertificate),
            14129 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Open),
            14132 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Close),
            14134 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Read),
            14137 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_Write),
            14139 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_GetPosition),
            14142 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_SetPosition),
            14145 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_OpenWithMasks),
            14148 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_CloseAndUpdate),
            14151 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_AddCertificate),
            14153 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustList_RemoveCertificate),
            14183 => Ok(MethodId::RemoveConnectionMethodType),
            14225 => Ok(MethodId::PubSubConnectionType_RemoveGroup),
            14421 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_Status_Enable),
            14422 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_Status_Disable),
            14424 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_RemoveGroup),
            14432 => Ok(MethodId::PublishSubscribeType_RemoveConnection),
            14435 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItems),
            14438 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_AddPublishedEvents),
            14441 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_RemovePublishedDataSet),
            14479 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItems),
            14482 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEvents),
            14485 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_RemovePublishedDataSet),
            14493 => Ok(MethodId::DataSetFolderType_AddPublishedDataItems),
            14496 => Ok(MethodId::DataSetFolderType_AddPublishedEvents),
            14499 => Ok(MethodId::DataSetFolderType_RemovePublishedDataSet),
            14501 => Ok(MethodId::AddPublishedDataItemsMethodType),
            14504 => Ok(MethodId::AddPublishedEventsMethodType),
            14507 => Ok(MethodId::RemovePublishedDataSetMethodType),
            14555 => Ok(MethodId::PublishedDataItemsType_AddVariables),
            14558 => Ok(MethodId::PublishedDataItemsType_RemoveVariables),
            14564 => Ok(MethodId::PublishedDataItemsAddVariablesMethodType),
            14567 => Ok(MethodId::PublishedDataItemsRemoveVariablesMethodType),
            14602 => Ok(MethodId::PubSubConnectionType_Status_Enable),
            14603 => Ok(MethodId::PubSubConnectionType_Status_Disable),
            14604 => Ok(MethodId::PubSubConnectionTypeRemoveGroupMethodType),
            14623 => Ok(MethodId::PubSubGroupTypeRemoveWriterMethodType),
            14625 => Ok(MethodId::PubSubGroupTypeRemoveReaderMethodType),
            14645 => Ok(MethodId::PubSubStatusType_Enable),
            14646 => Ok(MethodId::PubSubStatusType_Disable),
            15052 => Ok(MethodId::PublishedEventsType_ModifyFieldSelection),
            15054 => Ok(MethodId::PublishedEventsTypeModifyFieldSelectionMethodType),
            15115 => Ok(MethodId::TargetVariablesType_AddTargetVariables),
            15118 => Ok(MethodId::TargetVariablesType_RemoveTargetVariables),
            15121 => Ok(MethodId::TargetVariablesTypeAddTargetVariablesMethodType),
            15124 => Ok(MethodId::TargetVariablesTypeRemoveTargetVariablesMethodType),
            15212 => Ok(MethodId::PublishSubscribeType_GetSecurityKeys),
            15215 => Ok(MethodId::PublishSubscribe_GetSecurityKeys),
            15218 => Ok(MethodId::GetSecurityKeysMethodType),
            15225 => Ok(MethodId::PublishedDataSetType_DataSetWriterName_Placeholder_Status_Enable),
            15226 => Ok(MethodId::PublishedDataSetType_DataSetWriterName_Placeholder_Status_Disable),
            15233 => Ok(MethodId::PublishedDataItemsType_DataSetWriterName_Placeholder_Status_Enable),
            15234 => Ok(MethodId::PublishedDataItemsType_DataSetWriterName_Placeholder_Status_Disable),
            15241 => Ok(MethodId::PublishedEventsType_DataSetWriterName_Placeholder_Status_Enable),
            15242 => Ok(MethodId::PublishedEventsType_DataSetWriterName_Placeholder_Status_Disable),
            15248 => Ok(MethodId::CreateCredentialMethodType),
            15267 => Ok(MethodId::PubSubGroupType_Status_Enable),
            15268 => Ok(MethodId::PubSubGroupType_Status_Disable),
            15301 => Ok(MethodId::DataSetWriterType_Status_Enable),
            15302 => Ok(MethodId::DataSetWriterType_Status_Disable),
            15309 => Ok(MethodId::DataSetReaderType_Status_Enable),
            15310 => Ok(MethodId::DataSetReaderType_Status_Disable),
            15431 => Ok(MethodId::PublishSubscribeType_GetSecurityGroup),
            15435 => Ok(MethodId::PublishSubscribeType_SecurityGroups_AddSecurityGroup),
            15438 => Ok(MethodId::PublishSubscribeType_SecurityGroups_RemoveSecurityGroup),
            15440 => Ok(MethodId::PublishSubscribe_GetSecurityGroup),
            15444 => Ok(MethodId::PublishSubscribe_SecurityGroups_AddSecurityGroup),
            15447 => Ok(MethodId::PublishSubscribe_SecurityGroups_RemoveSecurityGroup),
            15449 => Ok(MethodId::GetSecurityGroupMethodType),
            15454 => Ok(MethodId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_AddSecurityGroup),
            15457 => Ok(MethodId::SecurityGroupFolderType_SecurityGroupFolderName_Placeholder_RemoveSecurityGroup),
            15461 => Ok(MethodId::SecurityGroupFolderType_AddSecurityGroup),
            15464 => Ok(MethodId::SecurityGroupFolderType_RemoveSecurityGroup),
            15466 => Ok(MethodId::AddSecurityGroupMethodType),
            15469 => Ok(MethodId::RemoveSecurityGroupMethodType),
            15474 => Ok(MethodId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_AddExtensionField),
            15477 => Ok(MethodId::DataSetFolderType_PublishedDataSetName_Placeholder_ExtensionFields_RemoveExtensionField),
            15482 => Ok(MethodId::PublishedDataSetType_ExtensionFields_AddExtensionField),
            15485 => Ok(MethodId::PublishedDataSetType_ExtensionFields_RemoveExtensionField),
            15491 => Ok(MethodId::ExtensionFieldsType_AddExtensionField),
            15494 => Ok(MethodId::ExtensionFieldsType_RemoveExtensionField),
            15496 => Ok(MethodId::AddExtensionFieldMethodType),
            15499 => Ok(MethodId::RemoveExtensionFieldMethodType),
            15504 => Ok(MethodId::PublishedDataItemsType_ExtensionFields_AddExtensionField),
            15507 => Ok(MethodId::PublishedDataItemsType_ExtensionFields_RemoveExtensionField),
            15512 => Ok(MethodId::PublishedEventsType_ExtensionFields_AddExtensionField),
            15515 => Ok(MethodId::PublishedEventsType_ExtensionFields_RemoveExtensionField),
            15612 => Ok(MethodId::RoleSetType_RoleName_Placeholder_AddIdentity),
            15614 => Ok(MethodId::RoleSetType_RoleName_Placeholder_RemoveIdentity),
            15624 => Ok(MethodId::RoleType_AddIdentity),
            15626 => Ok(MethodId::RoleType_RemoveIdentity),
            15636 => Ok(MethodId::AddIdentityMethodType),
            15638 => Ok(MethodId::RemoveIdentityMethodType),
            15648 => Ok(MethodId::WellKnownRole_Anonymous_AddIdentity),
            15650 => Ok(MethodId::WellKnownRole_Anonymous_RemoveIdentity),
            15660 => Ok(MethodId::WellKnownRole_AuthenticatedUser_AddIdentity),
            15662 => Ok(MethodId::WellKnownRole_AuthenticatedUser_RemoveIdentity),
            15672 => Ok(MethodId::WellKnownRole_Observer_AddIdentity),
            15674 => Ok(MethodId::WellKnownRole_Observer_RemoveIdentity),
            15684 => Ok(MethodId::WellKnownRole_Operator_AddIdentity),
            15686 => Ok(MethodId::WellKnownRole_Operator_RemoveIdentity),
            15696 => Ok(MethodId::WellKnownRole_Supervisor_AddIdentity),
            15698 => Ok(MethodId::WellKnownRole_Supervisor_RemoveIdentity),
            15708 => Ok(MethodId::WellKnownRole_SecurityAdmin_AddIdentity),
            15710 => Ok(MethodId::WellKnownRole_SecurityAdmin_RemoveIdentity),
            15720 => Ok(MethodId::WellKnownRole_ConfigureAdmin_AddIdentity),
            15722 => Ok(MethodId::WellKnownRole_ConfigureAdmin_RemoveIdentity),
            15746 => Ok(MethodId::TemporaryFileTransferType_GenerateFileForRead),
            15749 => Ok(MethodId::TemporaryFileTransferType_GenerateFileForWrite),
            15751 => Ok(MethodId::TemporaryFileTransferType_CloseAndCommit),
            15794 => Ok(MethodId::TemporaryFileTransferType_TransferState_Placeholder_Reset),
            15795 => Ok(MethodId::GenerateFileForReadMethodType),
            15798 => Ok(MethodId::GenerateFileForWriteMethodType),
            15800 => Ok(MethodId::CloseAndCommitMethodType),
            15843 => Ok(MethodId::FileTransferStateMachineType_Reset),
            15846 => Ok(MethodId::PublishSubscribeType_Status_Enable),
            15847 => Ok(MethodId::PublishSubscribeType_Status_Disable),
            15893 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_Status_Enable),
            15894 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_Status_Disable),
            15907 => Ok(MethodId::PubSubKeyServiceType_GetSecurityKeys),
            15910 => Ok(MethodId::PubSubKeyServiceType_GetSecurityGroup),
            15914 => Ok(MethodId::PubSubKeyServiceType_SecurityGroups_AddSecurityGroup),
            15917 => Ok(MethodId::PubSubKeyServiceType_SecurityGroups_RemoveSecurityGroup),
            15971 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_Open),
            15974 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_Close),
            15976 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_Read),
            15979 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_Write),
            15981 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_GetPosition),
            15984 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_SetPosition),
            15986 => Ok(MethodId::OPCUANamespaceMetadata_NamespaceFile_ExportNamespace),
            15997 => Ok(MethodId::RoleSetType_AddRole),
            16000 => Ok(MethodId::RoleSetType_RemoveRole),
            16002 => Ok(MethodId::AddRoleMethodType),
            16005 => Ok(MethodId::RemoveRoleMethodType),
            16041 => Ok(MethodId::WellKnownRole_Engineer_AddIdentity),
            16043 => Ok(MethodId::WellKnownRole_Engineer_RemoveIdentity),
            16076 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_Diagnostics_Reset),
            16165 => Ok(MethodId::RoleSetType_RoleName_Placeholder_AddApplication),
            16167 => Ok(MethodId::RoleSetType_RoleName_Placeholder_RemoveApplication),
            16169 => Ok(MethodId::RoleSetType_RoleName_Placeholder_AddEndpoint),
            16171 => Ok(MethodId::RoleSetType_RoleName_Placeholder_RemoveEndpoint),
            16176 => Ok(MethodId::RoleType_AddApplication),
            16178 => Ok(MethodId::RoleType_RemoveApplication),
            16180 => Ok(MethodId::RoleType_AddEndpoint),
            16182 => Ok(MethodId::RoleType_RemoveEndpoint),
            16184 => Ok(MethodId::AddApplicationMethodType),
            16186 => Ok(MethodId::RemoveApplicationMethodType),
            16188 => Ok(MethodId::AddEndpointMethodType),
            16190 => Ok(MethodId::RemoveEndpointMethodType),
            16195 => Ok(MethodId::WellKnownRole_Anonymous_AddApplication),
            16197 => Ok(MethodId::WellKnownRole_Anonymous_RemoveApplication),
            16199 => Ok(MethodId::WellKnownRole_Anonymous_AddEndpoint),
            16201 => Ok(MethodId::WellKnownRole_Anonymous_RemoveEndpoint),
            16206 => Ok(MethodId::WellKnownRole_AuthenticatedUser_AddApplication),
            16208 => Ok(MethodId::WellKnownRole_AuthenticatedUser_RemoveApplication),
            16210 => Ok(MethodId::WellKnownRole_AuthenticatedUser_AddEndpoint),
            16212 => Ok(MethodId::WellKnownRole_AuthenticatedUser_RemoveEndpoint),
            16217 => Ok(MethodId::WellKnownRole_Observer_AddApplication),
            16219 => Ok(MethodId::WellKnownRole_Observer_RemoveApplication),
            16221 => Ok(MethodId::WellKnownRole_Observer_AddEndpoint),
            16223 => Ok(MethodId::WellKnownRole_Observer_RemoveEndpoint),
            16228 => Ok(MethodId::WellKnownRole_Operator_AddApplication),
            16230 => Ok(MethodId::WellKnownRole_Operator_RemoveApplication),
            16232 => Ok(MethodId::WellKnownRole_Operator_AddEndpoint),
            16234 => Ok(MethodId::WellKnownRole_Operator_RemoveEndpoint),
            16239 => Ok(MethodId::WellKnownRole_Engineer_AddApplication),
            16241 => Ok(MethodId::WellKnownRole_Engineer_RemoveApplication),
            16243 => Ok(MethodId::WellKnownRole_Engineer_AddEndpoint),
            16245 => Ok(MethodId::WellKnownRole_Engineer_RemoveEndpoint),
            16250 => Ok(MethodId::WellKnownRole_Supervisor_AddApplication),
            16252 => Ok(MethodId::WellKnownRole_Supervisor_RemoveApplication),
            16254 => Ok(MethodId::WellKnownRole_Supervisor_AddEndpoint),
            16256 => Ok(MethodId::WellKnownRole_Supervisor_RemoveEndpoint),
            16261 => Ok(MethodId::WellKnownRole_SecurityAdmin_AddApplication),
            16263 => Ok(MethodId::WellKnownRole_SecurityAdmin_RemoveApplication),
            16265 => Ok(MethodId::WellKnownRole_SecurityAdmin_AddEndpoint),
            16267 => Ok(MethodId::WellKnownRole_SecurityAdmin_RemoveEndpoint),
            16272 => Ok(MethodId::WellKnownRole_ConfigureAdmin_AddApplication),
            16274 => Ok(MethodId::WellKnownRole_ConfigureAdmin_RemoveApplication),
            16276 => Ok(MethodId::WellKnownRole_ConfigureAdmin_AddEndpoint),
            16278 => Ok(MethodId::WellKnownRole_ConfigureAdmin_RemoveEndpoint),
            16290 => Ok(MethodId::ServerType_ServerCapabilities_RoleSet_AddRole),
            16293 => Ok(MethodId::ServerType_ServerCapabilities_RoleSet_RemoveRole),
            16296 => Ok(MethodId::ServerCapabilitiesType_RoleSet_AddRole),
            16299 => Ok(MethodId::ServerCapabilitiesType_RoleSet_RemoveRole),
            16301 => Ok(MethodId::Server_ServerCapabilities_RoleSet_AddRole),
            16304 => Ok(MethodId::Server_ServerCapabilities_RoleSet_RemoveRole),
            16316 => Ok(MethodId::FileSystem_FileDirectoryName_Placeholder_CreateDirectory),
            16319 => Ok(MethodId::FileSystem_FileDirectoryName_Placeholder_CreateFile),
            16324 => Ok(MethodId::FileSystem_FileDirectoryName_Placeholder_MoveOrCopy),
            16333 => Ok(MethodId::FileSystem_FileName_Placeholder_Open),
            16336 => Ok(MethodId::FileSystem_FileName_Placeholder_Close),
            16338 => Ok(MethodId::FileSystem_FileName_Placeholder_Read),
            16341 => Ok(MethodId::FileSystem_FileName_Placeholder_Write),
            16343 => Ok(MethodId::FileSystem_FileName_Placeholder_GetPosition),
            16346 => Ok(MethodId::FileSystem_FileName_Placeholder_SetPosition),
            16348 => Ok(MethodId::FileSystem_CreateDirectory),
            16351 => Ok(MethodId::FileSystem_CreateFile),
            16354 => Ok(MethodId::FileSystem_DeleteFileSystemObject),
            16356 => Ok(MethodId::FileSystem_MoveOrCopy),
            16402 => Ok(MethodId::AlarmConditionType_Silence),
            16403 => Ok(MethodId::AlarmConditionType_Suppress),
            16439 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Disable),
            16440 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Enable),
            16441 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_AddComment),
            16461 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Acknowledge),
            16463 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Confirm),
            16515 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_Unshelve),
            16516 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_OneShotShelve),
            16517 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_ShelvingState_TimedShelve),
            16533 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Silence),
            16534 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Suppress),
            16535 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_AddWriterGroup),
            16560 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_AddReaderGroup),
            16569 => Ok(MethodId::LimitAlarmType_Silence),
            16570 => Ok(MethodId::LimitAlarmType_Suppress),
            16598 => Ok(MethodId::PublishSubscribeType_AddConnection),
            16601 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_AddPublishedDataItemsTemplate),
            16609 => Ok(MethodId::ExclusiveLimitAlarmType_Silence),
            16610 => Ok(MethodId::ExclusiveLimitAlarmType_Suppress),
            16639 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_AddPublishedEventsTemplate),
            16649 => Ok(MethodId::NonExclusiveLimitAlarmType_Silence),
            16650 => Ok(MethodId::NonExclusiveLimitAlarmType_Suppress),
            16651 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_AddDataSetFolder),
            16680 => Ok(MethodId::PublishSubscribeType_PublishedDataSets_RemoveDataSetFolder),
            16689 => Ok(MethodId::NonExclusiveLevelAlarmType_Silence),
            16690 => Ok(MethodId::NonExclusiveLevelAlarmType_Suppress),
            16691 => Ok(MethodId::AddConnectionMethodType),
            16729 => Ok(MethodId::ExclusiveLevelAlarmType_Silence),
            16730 => Ok(MethodId::ExclusiveLevelAlarmType_Suppress),
            16769 => Ok(MethodId::NonExclusiveDeviationAlarmType_Silence),
            16770 => Ok(MethodId::NonExclusiveDeviationAlarmType_Suppress),
            16810 => Ok(MethodId::ExclusiveDeviationAlarmType_Silence),
            16811 => Ok(MethodId::ExclusiveDeviationAlarmType_Suppress),
            16842 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedDataItemsTemplate),
            16851 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Silence),
            16852 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Suppress),
            16881 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_AddPublishedEventsTemplate),
            16884 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_AddDataSetFolder),
            16892 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Silence),
            16893 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Suppress),
            16923 => Ok(MethodId::DataSetFolderType_DataSetFolderName_Placeholder_RemoveDataSetFolder),
            16933 => Ok(MethodId::DiscreteAlarmType_Silence),
            16934 => Ok(MethodId::DiscreteAlarmType_Suppress),
            16935 => Ok(MethodId::DataSetFolderType_AddPublishedDataItemsTemplate),
            16960 => Ok(MethodId::DataSetFolderType_AddPublishedEventsTemplate),
            16969 => Ok(MethodId::OffNormalAlarmType_Silence),
            16970 => Ok(MethodId::OffNormalAlarmType_Suppress),
            16994 => Ok(MethodId::DataSetFolderType_AddDataSetFolder),
            16997 => Ok(MethodId::DataSetFolderType_RemoveDataSetFolder),
            17005 => Ok(MethodId::SystemOffNormalAlarmType_Silence),
            17006 => Ok(MethodId::SystemOffNormalAlarmType_Suppress),
            17030 => Ok(MethodId::AddPublishedDataItemsTemplateMethodType),
            17033 => Ok(MethodId::AddPublishedEventsTemplateMethodType),
            17041 => Ok(MethodId::TripAlarmType_Silence),
            17042 => Ok(MethodId::TripAlarmType_Suppress),
            17067 => Ok(MethodId::AddDataSetFolderMethodType),
            17077 => Ok(MethodId::CertificateExpirationAlarmType_Silence),
            17078 => Ok(MethodId::CertificateExpirationAlarmType_Suppress),
            17079 => Ok(MethodId::RemoveDataSetFolderMethodType),
            17113 => Ok(MethodId::DiscrepancyAlarmType_Disable),
            17114 => Ok(MethodId::DiscrepancyAlarmType_Enable),
            17115 => Ok(MethodId::DiscrepancyAlarmType_AddComment),
            17117 => Ok(MethodId::DiscrepancyAlarmType_ConditionRefresh),
            17119 => Ok(MethodId::DiscrepancyAlarmType_ConditionRefresh2),
            17139 => Ok(MethodId::DiscrepancyAlarmType_Acknowledge),
            17141 => Ok(MethodId::DiscrepancyAlarmType_Confirm),
            17193 => Ok(MethodId::DiscrepancyAlarmType_ShelvingState_Unshelve),
            17194 => Ok(MethodId::DiscrepancyAlarmType_ShelvingState_OneShotShelve),
            17195 => Ok(MethodId::DiscrepancyAlarmType_ShelvingState_TimedShelve),
            17212 => Ok(MethodId::DiscrepancyAlarmType_Silence),
            17213 => Ok(MethodId::DiscrepancyAlarmType_Suppress),
            17293 => Ok(MethodId::PubSubConnectionType_WriterGroupName_Placeholder_AddDataSetWriter),
            17296 => Ok(MethodId::PublishSubscribeType_SetSecurityKeys),
            17298 => Ok(MethodId::SetSecurityKeysMethodType),
            17316 => Ok(MethodId::PubSubConnectionType_WriterGroupName_Placeholder_Status_Enable),
            17317 => Ok(MethodId::PubSubConnectionType_WriterGroupName_Placeholder_Status_Disable),
            17323 => Ok(MethodId::PubSubConnectionType_WriterGroupName_Placeholder_RemoveDataSetWriter),
            17331 => Ok(MethodId::PubSubConnectionType_ReaderGroupName_Placeholder_Status_Enable),
            17332 => Ok(MethodId::PubSubConnectionType_ReaderGroupName_Placeholder_Status_Disable),
            17333 => Ok(MethodId::PubSubConnectionType_ReaderGroupName_Placeholder_RemoveDataSetReader),
            17355 => Ok(MethodId::PubSubConnectionType_ReaderGroupName_Placeholder_AddDataSetReader),
            17356 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_AddWriterGroup),
            17359 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_AddReaderGroup),
            17362 => Ok(MethodId::PublishSubscribe_ConnectionName_Placeholder_RemoveGroup),
            17364 => Ok(MethodId::PublishSubscribe_SetSecurityKeys),
            17366 => Ok(MethodId::PublishSubscribe_AddConnection),
            17369 => Ok(MethodId::PublishSubscribe_RemoveConnection),
            17372 => Ok(MethodId::PublishSubscribe_PublishedDataSets_AddPublishedDataItems),
            17375 => Ok(MethodId::PublishSubscribe_PublishedDataSets_AddPublishedEvents),
            17378 => Ok(MethodId::PublishSubscribe_PublishedDataSets_AddPublishedDataItemsTemplate),
            17381 => Ok(MethodId::PublishSubscribe_PublishedDataSets_AddPublishedEventsTemplate),
            17384 => Ok(MethodId::PublishSubscribe_PublishedDataSets_RemovePublishedDataSet),
            17386 => Ok(MethodId::DataSetReaderType_CreateTargetVariables),
            17389 => Ok(MethodId::DataSetReaderType_CreateDataSetMirror),
            17392 => Ok(MethodId::DataSetReaderTypeCreateTargetVariablesMethodType),
            17395 => Ok(MethodId::DataSetReaderTypeCreateDataSetMirrorMethodType),
            17398 => Ok(MethodId::PublishSubscribe_PublishedDataSets_AddDataSetFolder),
            17403 => Ok(MethodId::PublishSubscribe_PublishedDataSets_RemoveDataSetFolder),
            17407 => Ok(MethodId::PublishSubscribe_Status_Enable),
            17408 => Ok(MethodId::PublishSubscribe_Status_Disable),
            17421 => Ok(MethodId::PublishSubscribe_Diagnostics_Reset),
            17427 => Ok(MethodId::PubSubConnectionType_AddWriterGroup),
            17465 => Ok(MethodId::PubSubConnectionType_AddReaderGroup),
            17516 => Ok(MethodId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_GetEncryptingKey),
            17519 => Ok(MethodId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_UpdateCredential),
            17521 => Ok(MethodId::KeyCredentialConfigurationFolderType_ServiceName_Placeholder_DeleteCredential),
            17522 => Ok(MethodId::KeyCredentialConfigurationFolderType_CreateCredential),
            17525 => Ok(MethodId::KeyCredentialConfiguration_ServiceName_Placeholder_GetEncryptingKey),
            17528 => Ok(MethodId::KeyCredentialConfiguration_CreateCredential),
            17531 => Ok(MethodId::GetEncryptingKeyMethodType),
            17534 => Ok(MethodId::KeyCredentialConfigurationType_GetEncryptingKey),
            17561 => Ok(MethodId::PubSubConnectionTypeAddWriterGroupMethodType),
            17630 => Ok(MethodId::PubSubConnectionAddReaderGroupGroupMethodType),
            17718 => Ok(MethodId::FileDirectoryType_FileDirectoryName_Placeholder_DeleteFileSystemObject),
            17722 => Ok(MethodId::FileSystem_FileDirectoryName_Placeholder_DeleteFileSystemObject),
            17734 => Ok(MethodId::WriterGroupType_Status_Enable),
            17735 => Ok(MethodId::WriterGroupType_Status_Disable),
            17751 => Ok(MethodId::WriterGroupType_DataSetWriterName_Placeholder_Status_Enable),
            17752 => Ok(MethodId::WriterGroupType_DataSetWriterName_Placeholder_Status_Disable),
            17765 => Ok(MethodId::WriterGroupType_DataSetWriterName_Placeholder_Diagnostics_Reset),
            17824 => Ok(MethodId::WriterGroupType_Diagnostics_Reset),
            17868 => Ok(MethodId::AlarmConditionType_Unsuppress),
            17869 => Ok(MethodId::AlarmConditionType_RemoveFromService),
            17870 => Ok(MethodId::AlarmConditionType_PlaceInService),
            17875 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Unsuppress),
            17876 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_RemoveFromService),
            17877 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_PlaceInService),
            17882 => Ok(MethodId::LimitAlarmType_Unsuppress),
            17883 => Ok(MethodId::LimitAlarmType_RemoveFromService),
            17884 => Ok(MethodId::LimitAlarmType_PlaceInService),
            17889 => Ok(MethodId::ExclusiveLimitAlarmType_Unsuppress),
            17890 => Ok(MethodId::ExclusiveLimitAlarmType_RemoveFromService),
            17891 => Ok(MethodId::ExclusiveLimitAlarmType_PlaceInService),
            17896 => Ok(MethodId::NonExclusiveLimitAlarmType_Unsuppress),
            17897 => Ok(MethodId::NonExclusiveLimitAlarmType_RemoveFromService),
            17898 => Ok(MethodId::NonExclusiveLimitAlarmType_PlaceInService),
            17904 => Ok(MethodId::NonExclusiveLevelAlarmType_RemoveFromService),
            17905 => Ok(MethodId::NonExclusiveLevelAlarmType_PlaceInService),
            17910 => Ok(MethodId::ExclusiveLevelAlarmType_Unsuppress),
            17911 => Ok(MethodId::ExclusiveLevelAlarmType_RemoveFromService),
            17912 => Ok(MethodId::ExclusiveLevelAlarmType_PlaceInService),
            17917 => Ok(MethodId::NonExclusiveDeviationAlarmType_Unsuppress),
            17918 => Ok(MethodId::NonExclusiveDeviationAlarmType_RemoveFromService),
            17919 => Ok(MethodId::NonExclusiveDeviationAlarmType_PlaceInService),
            17924 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Unsuppress),
            17925 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_RemoveFromService),
            17926 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_PlaceInService),
            17931 => Ok(MethodId::ExclusiveDeviationAlarmType_Unsuppress),
            17932 => Ok(MethodId::ExclusiveDeviationAlarmType_RemoveFromService),
            17933 => Ok(MethodId::ExclusiveDeviationAlarmType_PlaceInService),
            17938 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Unsuppress),
            17939 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_RemoveFromService),
            17940 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_PlaceInService),
            17945 => Ok(MethodId::DiscreteAlarmType_Unsuppress),
            17946 => Ok(MethodId::DiscreteAlarmType_RemoveFromService),
            17947 => Ok(MethodId::DiscreteAlarmType_PlaceInService),
            17952 => Ok(MethodId::OffNormalAlarmType_Unsuppress),
            17953 => Ok(MethodId::OffNormalAlarmType_RemoveFromService),
            17954 => Ok(MethodId::OffNormalAlarmType_PlaceInService),
            17959 => Ok(MethodId::SystemOffNormalAlarmType_Unsuppress),
            17960 => Ok(MethodId::SystemOffNormalAlarmType_RemoveFromService),
            17961 => Ok(MethodId::SystemOffNormalAlarmType_PlaceInService),
            17966 => Ok(MethodId::TripAlarmType_Unsuppress),
            17967 => Ok(MethodId::TripAlarmType_RemoveFromService),
            17968 => Ok(MethodId::TripAlarmType_PlaceInService),
            17969 => Ok(MethodId::WriterGroupType_AddDataSetWriter),
            17973 => Ok(MethodId::CertificateExpirationAlarmType_Unsuppress),
            17974 => Ok(MethodId::CertificateExpirationAlarmType_RemoveFromService),
            17975 => Ok(MethodId::CertificateExpirationAlarmType_PlaceInService),
            17980 => Ok(MethodId::DiscrepancyAlarmType_Unsuppress),
            17981 => Ok(MethodId::DiscrepancyAlarmType_RemoveFromService),
            17982 => Ok(MethodId::DiscrepancyAlarmType_PlaceInService),
            17992 => Ok(MethodId::WriterGroupType_RemoveDataSetWriter),
            17994 => Ok(MethodId::PubSubGroupTypeAddWriterrMethodType),
            18006 => Ok(MethodId::KeyCredentialConfigurationType_UpdateCredential),
            18008 => Ok(MethodId::KeyCredentialConfigurationType_DeleteCredential),
            18009 => Ok(MethodId::KeyCredentialUpdateMethodType),
            18074 => Ok(MethodId::ReaderGroupType_Status_Enable),
            18075 => Ok(MethodId::ReaderGroupType_Status_Disable),
            18090 => Ok(MethodId::ReaderGroupType_DataSetReaderName_Placeholder_Status_Enable),
            18091 => Ok(MethodId::ReaderGroupType_DataSetReaderName_Placeholder_Status_Disable),
            18104 => Ok(MethodId::ReaderGroupType_DataSetReaderName_Placeholder_Diagnostics_Reset),
            18161 => Ok(MethodId::KeyCredentialConfiguration_ServiceName_Placeholder_UpdateCredential),
            18163 => Ok(MethodId::KeyCredentialConfiguration_ServiceName_Placeholder_DeleteCredential),
            18199 => Ok(MethodId::AlarmConditionType_Reset),
            18212 => Ok(MethodId::AlarmGroupType_AlarmConditionInstance_Placeholder_Reset),
            18222 => Ok(MethodId::LimitAlarmType_Reset),
            18232 => Ok(MethodId::ExclusiveLimitAlarmType_Reset),
            18242 => Ok(MethodId::NonExclusiveLimitAlarmType_Reset),
            18255 => Ok(MethodId::NonExclusiveLevelAlarmType_Unsuppress),
            18256 => Ok(MethodId::NonExclusiveLevelAlarmType_Reset),
            18266 => Ok(MethodId::ExclusiveLevelAlarmType_Reset),
            18276 => Ok(MethodId::NonExclusiveDeviationAlarmType_Reset),
            18286 => Ok(MethodId::NonExclusiveRateOfChangeAlarmType_Reset),
            18296 => Ok(MethodId::ExclusiveDeviationAlarmType_Reset),
            18306 => Ok(MethodId::ExclusiveRateOfChangeAlarmType_Reset),
            18316 => Ok(MethodId::DiscreteAlarmType_Reset),
            18326 => Ok(MethodId::OffNormalAlarmType_Reset),
            18336 => Ok(MethodId::SystemOffNormalAlarmType_Reset),
            18346 => Ok(MethodId::TripAlarmType_Reset),
            18380 => Ok(MethodId::InstrumentDiagnosticAlarmType_Disable),
            18381 => Ok(MethodId::InstrumentDiagnosticAlarmType_Enable),
            18382 => Ok(MethodId::InstrumentDiagnosticAlarmType_AddComment),
            18384 => Ok(MethodId::InstrumentDiagnosticAlarmType_ConditionRefresh),
            18386 => Ok(MethodId::InstrumentDiagnosticAlarmType_ConditionRefresh2),
            18406 => Ok(MethodId::InstrumentDiagnosticAlarmType_Acknowledge),
            18408 => Ok(MethodId::InstrumentDiagnosticAlarmType_Confirm),
            18453 => Ok(MethodId::InstrumentDiagnosticAlarmType_ShelvingState_TimedShelve),
            18455 => Ok(MethodId::InstrumentDiagnosticAlarmType_ShelvingState_Unshelve),
            18456 => Ok(MethodId::InstrumentDiagnosticAlarmType_ShelvingState_OneShotShelve),
            18489 => Ok(MethodId::InstrumentDiagnosticAlarmType_Silence),
            18490 => Ok(MethodId::InstrumentDiagnosticAlarmType_Suppress),
            18491 => Ok(MethodId::InstrumentDiagnosticAlarmType_Unsuppress),
            18492 => Ok(MethodId::InstrumentDiagnosticAlarmType_RemoveFromService),
            18493 => Ok(MethodId::InstrumentDiagnosticAlarmType_PlaceInService),
            18494 => Ok(MethodId::InstrumentDiagnosticAlarmType_Reset),
            18529 => Ok(MethodId::SystemDiagnosticAlarmType_Disable),
            18530 => Ok(MethodId::SystemDiagnosticAlarmType_Enable),
            18531 => Ok(MethodId::SystemDiagnosticAlarmType_AddComment),
            18533 => Ok(MethodId::SystemDiagnosticAlarmType_ConditionRefresh),
            18535 => Ok(MethodId::SystemDiagnosticAlarmType_ConditionRefresh2),
            18555 => Ok(MethodId::SystemDiagnosticAlarmType_Acknowledge),
            18557 => Ok(MethodId::SystemDiagnosticAlarmType_Confirm),
            18602 => Ok(MethodId::SystemDiagnosticAlarmType_ShelvingState_TimedShelve),
            18604 => Ok(MethodId::SystemDiagnosticAlarmType_ShelvingState_Unshelve),
            18605 => Ok(MethodId::SystemDiagnosticAlarmType_ShelvingState_OneShotShelve),
            18638 => Ok(MethodId::SystemDiagnosticAlarmType_Silence),
            18639 => Ok(MethodId::SystemDiagnosticAlarmType_Suppress),
            18640 => Ok(MethodId::SystemDiagnosticAlarmType_Unsuppress),
            18641 => Ok(MethodId::SystemDiagnosticAlarmType_RemoveFromService),
            18642 => Ok(MethodId::SystemDiagnosticAlarmType_PlaceInService),
            18643 => Ok(MethodId::SystemDiagnosticAlarmType_Reset),
            18654 => Ok(MethodId::CertificateExpirationAlarmType_Reset),
            18664 => Ok(MethodId::DiscrepancyAlarmType_Reset),
            18666 => Ok(MethodId::AlarmMetricsType_Reset),
            18679 => Ok(MethodId::PublishSubscribeType_ConnectionName_Placeholder_Diagnostics_Reset),
            18727 => Ok(MethodId::PublishSubscribeType_Diagnostics_Reset),
            18883 => Ok(MethodId::PublishedDataSetType_DataSetWriterName_Placeholder_Diagnostics_Reset),
            18942 => Ok(MethodId::PublishedDataItemsType_DataSetWriterName_Placeholder_Diagnostics_Reset),
            19001 => Ok(MethodId::PublishedEventsType_DataSetWriterName_Placeholder_Diagnostics_Reset),
            19119 => Ok(MethodId::PubSubConnectionType_WriterGroupName_Placeholder_Diagnostics_Reset),
            19188 => Ok(MethodId::PubSubConnectionType_ReaderGroupName_Placeholder_Diagnostics_Reset),
            19253 => Ok(MethodId::PubSubConnectionType_Diagnostics_Reset),
            19330 => Ok(MethodId::TrustListOutOfDateAlarmType_Disable),
            19331 => Ok(MethodId::TrustListOutOfDateAlarmType_Enable),
            19332 => Ok(MethodId::TrustListOutOfDateAlarmType_AddComment),
            19334 => Ok(MethodId::TrustListOutOfDateAlarmType_ConditionRefresh),
            19336 => Ok(MethodId::TrustListOutOfDateAlarmType_ConditionRefresh2),
            19356 => Ok(MethodId::TrustListOutOfDateAlarmType_Acknowledge),
            19358 => Ok(MethodId::TrustListOutOfDateAlarmType_Confirm),
            19403 => Ok(MethodId::TrustListOutOfDateAlarmType_ShelvingState_TimedShelve),
            19405 => Ok(MethodId::TrustListOutOfDateAlarmType_ShelvingState_Unshelve),
            19406 => Ok(MethodId::TrustListOutOfDateAlarmType_ShelvingState_OneShotShelve),
            19439 => Ok(MethodId::TrustListOutOfDateAlarmType_Silence),
            19440 => Ok(MethodId::TrustListOutOfDateAlarmType_Suppress),
            19441 => Ok(MethodId::TrustListOutOfDateAlarmType_Unsuppress),
            19442 => Ok(MethodId::TrustListOutOfDateAlarmType_RemoveFromService),
            19443 => Ok(MethodId::TrustListOutOfDateAlarmType_PlaceInService),
            19444 => Ok(MethodId::TrustListOutOfDateAlarmType_Reset),
            19483 => Ok(MethodId::CertificateGroupType_CertificateExpired_Disable),
            19484 => Ok(MethodId::CertificateGroupType_CertificateExpired_Enable),
            19485 => Ok(MethodId::CertificateGroupType_CertificateExpired_AddComment),
            19505 => Ok(MethodId::CertificateGroupType_CertificateExpired_Acknowledge),
            19507 => Ok(MethodId::CertificateGroupType_CertificateExpired_Confirm),
            19562 => Ok(MethodId::DataSetWriterType_Diagnostics_Reset),
            19621 => Ok(MethodId::DataSetReaderType_Diagnostics_Reset),
            19689 => Ok(MethodId::PubSubDiagnosticsType_Reset),
            19744 => Ok(MethodId::PubSubDiagnosticsRootType_Reset),
            19798 => Ok(MethodId::PubSubDiagnosticsConnectionType_Reset),
            19846 => Ok(MethodId::PubSubDiagnosticsWriterGroupType_Reset),
            19915 => Ok(MethodId::PubSubDiagnosticsReaderGroupType_Reset),
            19980 => Ok(MethodId::PubSubDiagnosticsDataSetWriterType_Reset),
            20039 => Ok(MethodId::PubSubDiagnosticsDataSetReaderType_Reset),
            20097 => Ok(MethodId::CertificateGroupType_CertificateExpired_ShelvingState_TimedShelve),
            20099 => Ok(MethodId::CertificateGroupType_CertificateExpired_ShelvingState_Unshelve),
            20100 => Ok(MethodId::CertificateGroupType_CertificateExpired_ShelvingState_OneShotShelve),
            20132 => Ok(MethodId::CertificateGroupType_CertificateExpired_Silence),
            20133 => Ok(MethodId::CertificateGroupType_CertificateExpired_Suppress),
            20134 => Ok(MethodId::CertificateGroupType_CertificateExpired_Unsuppress),
            20135 => Ok(MethodId::CertificateGroupType_CertificateExpired_RemoveFromService),
            20136 => Ok(MethodId::CertificateGroupType_CertificateExpired_PlaceInService),
            20137 => Ok(MethodId::CertificateGroupType_CertificateExpired_Reset),
            20176 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Disable),
            20177 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Enable),
            20178 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_AddComment),
            20198 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Acknowledge),
            20200 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Confirm),
            20245 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_ShelvingState_TimedShelve),
            20247 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_ShelvingState_Unshelve),
            20248 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_ShelvingState_OneShotShelve),
            20280 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Silence),
            20281 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Suppress),
            20282 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Unsuppress),
            20283 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_RemoveFromService),
            20284 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_PlaceInService),
            20285 => Ok(MethodId::CertificateGroupType_TrustListOutOfDate_Reset),
            20324 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Disable),
            20325 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Enable),
            20326 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_AddComment),
            20346 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Acknowledge),
            20348 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Confirm),
            20393 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve),
            20395 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve),
            20396 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve),
            20430 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Silence),
            20431 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Suppress),
            20432 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Unsuppress),
            20433 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_RemoveFromService),
            20434 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_PlaceInService),
            20435 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_CertificateExpired_Reset),
            20474 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Disable),
            20475 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Enable),
            20476 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_AddComment),
            20496 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge),
            20498 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Confirm),
            20543 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            20545 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            20546 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            20578 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Silence),
            20579 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Suppress),
            20580 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress),
            20581 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService),
            20582 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService),
            20583 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_TrustListOutOfDate_Reset),
            20622 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Disable),
            20623 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Enable),
            20624 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_AddComment),
            20644 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Acknowledge),
            20646 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Confirm),
            20691 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve),
            20693 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve),
            20694 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve),
            20726 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Silence),
            20727 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Suppress),
            20728 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Unsuppress),
            20729 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_RemoveFromService),
            20730 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_PlaceInService),
            20731 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_CertificateExpired_Reset),
            20770 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Disable),
            20771 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Enable),
            20772 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_AddComment),
            20792 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge),
            20794 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Confirm),
            20839 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            20841 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            20842 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            20874 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Silence),
            20875 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Suppress),
            20876 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress),
            20877 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService),
            20878 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService),
            20879 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_TrustListOutOfDate_Reset),
            20918 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Disable),
            20919 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Enable),
            20920 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_AddComment),
            20940 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Acknowledge),
            20942 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Confirm),
            20987 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve),
            20989 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve),
            20990 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve),
            21009 => Ok(MethodId::ReaderGroupType_DataSetReaderName_Placeholder_CreateTargetVariables),
            21012 => Ok(MethodId::ReaderGroupType_DataSetReaderName_Placeholder_CreateDataSetMirror),
            21027 => Ok(MethodId::ReaderGroupType_Diagnostics_Reset),
            21082 => Ok(MethodId::ReaderGroupType_AddDataSetReader),
            21085 => Ok(MethodId::ReaderGroupType_RemoveDataSetReader),
            21087 => Ok(MethodId::PubSubGroupTypeAddReaderMethodType),
            21225 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Silence),
            21226 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Suppress),
            21227 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Unsuppress),
            21228 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_RemoveFromService),
            21229 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_PlaceInService),
            21230 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_CertificateExpired_Reset),
            21269 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Disable),
            21270 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Enable),
            21271 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_AddComment),
            21291 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge),
            21293 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Confirm),
            21338 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            21340 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            21341 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            21373 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Silence),
            21374 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Suppress),
            21375 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress),
            21376 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService),
            21377 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService),
            21378 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_TrustListOutOfDate_Reset),
            21417 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Disable),
            21418 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Enable),
            21419 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_AddComment),
            21439 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Acknowledge),
            21441 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Confirm),
            21486 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_TimedShelve),
            21488 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_Unshelve),
            21489 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_ShelvingState_OneShotShelve),
            21521 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Silence),
            21522 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Suppress),
            21523 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Unsuppress),
            21524 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_RemoveFromService),
            21525 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_PlaceInService),
            21526 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_CertificateExpired_Reset),
            21565 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Disable),
            21566 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Enable),
            21567 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_AddComment),
            21587 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Acknowledge),
            21589 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Confirm),
            21634 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_TimedShelve),
            21636 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_Unshelve),
            21637 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_ShelvingState_OneShotShelve),
            21669 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Silence),
            21670 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Suppress),
            21671 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Unsuppress),
            21672 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_RemoveFromService),
            21673 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_PlaceInService),
            21674 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_TrustListOutOfDate_Reset),
            21713 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable),
            21714 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable),
            21715 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment),
            21735 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge),
            21737 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm),
            21782 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve),
            21784 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve),
            21785 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve),
            21817 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence),
            21818 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress),
            21819 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress),
            21820 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService),
            21821 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService),
            21822 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset),
            21861 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable),
            21862 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable),
            21863 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment),
            21883 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge),
            21885 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm),
            21930 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            21932 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            21933 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            21965 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence),
            21966 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress),
            21967 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress),
            21968 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService),
            21969 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService),
            21970 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset),
            22009 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable),
            22010 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable),
            22011 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment),
            22031 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge),
            22033 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm),
            22078 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve),
            22080 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve),
            22081 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve),
            22113 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence),
            22114 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress),
            22115 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress),
            22116 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService),
            22117 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService),
            22118 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset),
            22157 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable),
            22158 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable),
            22159 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment),
            22179 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge),
            22181 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm),
            22226 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            22228 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            22229 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            22261 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence),
            22262 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress),
            22263 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress),
            22264 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService),
            22265 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService),
            22266 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset),
            22305 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable),
            22306 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable),
            22307 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment),
            22327 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge),
            22329 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm),
            22374 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve),
            22376 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve),
            22377 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve),
            22409 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence),
            22410 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress),
            22411 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress),
            22412 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService),
            22413 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService),
            22414 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset),
            22453 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable),
            22454 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable),
            22455 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment),
            22475 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge),
            22477 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm),
            22522 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            22524 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            22525 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            22557 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence),
            22558 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress),
            22559 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress),
            22560 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService),
            22561 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService),
            22562 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset),
            22601 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Disable),
            22602 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Enable),
            22603 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_AddComment),
            22623 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Acknowledge),
            22625 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Confirm),
            22670 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_TimedShelve),
            22672 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_Unshelve),
            22673 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_ShelvingState_OneShotShelve),
            22705 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Silence),
            22706 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Suppress),
            22707 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Unsuppress),
            22708 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_RemoveFromService),
            22709 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_PlaceInService),
            22710 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_CertificateExpired_Reset),
            22749 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Disable),
            22750 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Enable),
            22751 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_AddComment),
            22771 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Acknowledge),
            22773 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Confirm),
            22818 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            22820 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            22821 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            22853 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Silence),
            22854 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Suppress),
            22855 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Unsuppress),
            22856 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_RemoveFromService),
            22857 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_PlaceInService),
            22858 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_TrustListOutOfDate_Reset),
            22897 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Disable),
            22898 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Enable),
            22899 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_AddComment),
            22919 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Acknowledge),
            22921 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Confirm),
            22966 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_TimedShelve),
            22968 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_Unshelve),
            22969 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_ShelvingState_OneShotShelve),
            23001 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Silence),
            23002 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Suppress),
            23003 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Unsuppress),
            23004 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_RemoveFromService),
            23005 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_PlaceInService),
            23006 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_CertificateExpired_Reset),
            23045 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Disable),
            23046 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Enable),
            23047 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_AddComment),
            23067 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Acknowledge),
            23069 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Confirm),
            23114 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            23116 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            23117 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            23149 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Silence),
            23150 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Suppress),
            23151 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Unsuppress),
            23152 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_RemoveFromService),
            23153 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_PlaceInService),
            23154 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_TrustListOutOfDate_Reset),
            23193 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Disable),
            23194 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Enable),
            23195 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_AddComment),
            23215 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Acknowledge),
            23217 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Confirm),
            23262 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_TimedShelve),
            23264 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_Unshelve),
            23265 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_ShelvingState_OneShotShelve),
            23297 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Silence),
            23298 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Suppress),
            23299 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Unsuppress),
            23300 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_RemoveFromService),
            23301 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_PlaceInService),
            23302 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_CertificateExpired_Reset),
            23341 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Disable),
            23342 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Enable),
            23343 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_AddComment),
            23363 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Acknowledge),
            23365 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Confirm),
            23410 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_TimedShelve),
            23412 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_Unshelve),
            23413 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_ShelvingState_OneShotShelve),
            23445 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Silence),
            23446 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Suppress),
            23447 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Unsuppress),
            23448 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_RemoveFromService),
            23449 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_PlaceInService),
            23450 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_TrustListOutOfDate_Reset),
            23459 => Ok(MethodId::AliasNameCategoryType_SubAliasNameCategories_Placeholder_FindAlias),
            23462 => Ok(MethodId::AliasNameCategoryType_FindAlias),
            23465 => Ok(MethodId::FindAliasMethodType),
            23473 => Ok(MethodId::Aliases_SubAliasNameCategories_Placeholder_FindAlias),
            23476 => Ok(MethodId::Aliases_FindAlias),
            23482 => Ok(MethodId::TagVariables_SubAliasNameCategories_Placeholder_FindAlias),
            23485 => Ok(MethodId::TagVariables_FindAlias),
            23491 => Ok(MethodId::Topics_SubAliasNameCategories_Placeholder_FindAlias),
            23494 => Ok(MethodId::Topics_FindAlias),
            23526 => Ok(MethodId::CertificateGroupType_GetRejectedList),
            23529 => Ok(MethodId::CertificateGroupFolderType_DefaultApplicationGroup_GetRejectedList),
            23531 => Ok(MethodId::CertificateGroupFolderType_DefaultHttpsGroup_GetRejectedList),
            23533 => Ok(MethodId::CertificateGroupFolderType_DefaultUserTokenGroup_GetRejectedList),
            23535 => Ok(MethodId::CertificateGroupFolderType_AdditionalGroup_Placeholder_GetRejectedList),
            23544 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultApplicationGroup_GetRejectedList),
            23546 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultHttpsGroup_GetRejectedList),
            23548 => Ok(MethodId::ServerConfigurationType_CertificateGroups_DefaultUserTokenGroup_GetRejectedList),
            23550 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultApplicationGroup_GetRejectedList),
            23552 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultHttpsGroup_GetRejectedList),
            23554 => Ok(MethodId::ServerConfiguration_CertificateGroups_DefaultUserTokenGroup_GetRejectedList),
            _ => Err(())
        }
    }
}
